#ifdef _MSC_VER
#pragma warning ( push )
#pragma warning ( disable:4005 ) // '_WIN32_WINNT' : macro redefinition
#define _WIN32_WINNT 0x0500
#pragma warning ( pop )
#endif




#include "rpc.h"
#include "rpcndr.h"

#ifndef __RPCNDR_H_VERSION__
#error this stub requires an updated version of <rpcndr.h>
#endif // __RPCNDR_H_VERSION__


#ifndef __vl_cr2d_h__
#define __vl_cr2d_h__

#if defined(_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif

/* Forward Declarations */ 

/* header files for imported files */
#include "vl_base.h"
#include "vl_display.h"

#ifdef __cplusplus
extern "C"{
#endif 

void * __RPC_USER MIDL_user_allocate(size_t);
void __RPC_USER MIDL_user_free( void * ); 

/* interface __MIDL_itf_vl_cr2d_0000 */
/* [local] */ 

//=--------------------------------------------------------------------------=
// (C) Copyright 2002-2010 MATRIX Vision GmbH.  All Rights Reserved.
// (C) Copyright 2002-2010 Impuls computergesttzte Bildanalyse GmbH.
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
// PARTICULAR PURPOSE.
//=--------------------------------------------------------------------------=

#if defined(__BORLANDC__)
#pragma option -b
#endif
#if !defined(NO_VL_CR2D_AUTOLINK)
#if defined(__BORLANDC__)
#pragma comment(lib,"vlb_cr2d.lib")
#pragma message ("Automatically linking with vlb_cr2d.lib")
#else
#if defined(_M_X64)
#if _MSC_VER >= 1500
#pragma comment(lib,"vl_cr2d.lib")
#pragma message ("Automatically linking with vl_cr2d.lib")
#else
#pragma comment(lib,"vl_cr2d64.lib")
#pragma message ("Automatically linking with vl_cr2d64.lib")
#endif
#else
#pragma comment(lib,"vl_cr2d.lib")
#pragma message ("Automatically linking with vl_cr2d.lib")
#endif
#endif
#endif


#ifdef MVIMPACT_H_ // include guard of the main C++ header
namespace mvIMPACT {
	namespace mvIMPACT_C {
#endif // #ifdef MVIMPACT_H_

#ifdef VL_CR2D_COMPILING
// when compiling the dll
#define VL_CR2D_DLLEXPORT	__declspec(dllexport)
#undef __MIDL_DECLSPEC_DLLEXPORT
#define __MIDL_DECLSPEC_DLLEXPORT	__declspec(dllexport)
#undef __MIDL_DECLSPEC_DLLIMPORT
#define __MIDL_DECLSPEC_DLLIMPORT	__declspec(dllexport)
#else
// when using the dll
#define VL_CR2D_DLLEXPORT	__declspec(dllimport)
#undef __MIDL_DECLSPEC_DLLEXPORT
#define __MIDL_DECLSPEC_DLLEXPORT	__declspec(dllimport)
#undef __MIDL_DECLSPEC_DLLIMPORT
#define __MIDL_DECLSPEC_DLLIMPORT	__declspec(dllimport)
#endif
#define	_max_dm_rows	( 144 )

#define	_max_dm_cols	( 144 )



extern RPC_IF_HANDLE __MIDL_itf_vl_cr2d_0000_v0_0_c_ifspec;
extern RPC_IF_HANDLE __MIDL_itf_vl_cr2d_0000_v0_0_s_ifspec;


#ifndef __vl_cr2d_LIBRARY_DEFINED__
#define __vl_cr2d_LIBRARY_DEFINED__

/* library vl_cr2d */
/* [helpstring][version][uuid] */ 

typedef _CR2D_BUFHANDLE CR2D_BUFHANDLE;

/* [helpstring] */ 
enum CR2D_ERROR
    {	CR2D_E_UNKNOWN_PARAMETER	= -1900,
	CR2D_E_WRONG_IMAGE_TYPE	= -1901,
	CR2D_E_HANDLE_ERROR	= -1902,
	CR2D_E_BAD_PTR	= -1903,
	CR2D_E_WRONG_PARAMETER_VALUE	= -1904,
	CR2D_E_INVALID_DECODER	= -1905,
	CR2D_E_COULD_NOT_LOAD	= -1906,
	CR2D_E_PRINT_QUALITY_DATA_NA	= -1907
    } ;
typedef /* [hidden] */ enum CR2D_ERROR CR2D_ERROR;

/* [helpstring] */ 
enum CR2D_TRIMMING_STRATEGY
    {	CR2D_TRIM_3_ADJ_PLUS	= 3,
	CR2D_TRIM_4_PLUS	= 4,
	CR2D_TRIM_4_ADJ_PLUS	= 5
    } ;
typedef /* [hidden] */ enum CR2D_TRIMMING_STRATEGY CR2D_TRIMMING_STRATEGY;

/* [helpstring] */ 
enum CR2D_CONFIG_INQUIRE
    {	CR2D_CFG_SPACING	= 1,
	CR2D_CFG_CONTRAST	= 2,
	CR2D_CFG_MODE_BLACK_ON_WHITE	= 7,
	CR2D_CFG_TRIMMING_STRATEGY	= 8,
	CR2D_CFG_CHECK_PRINT_QUALITY	= 9,
	CR2D_GET_NUMBER_OF_CANDIDATES	= -1,
	CR2D_GET_NUMBER_OF_CODES	= -2,
	CR2D_GET_CODETYPE_LENGTH	= -3,
	CR2D_GET_CODETYPE	= -4,
	CR2D_GET_CODEDATA_LENGTH	= -5,
	CR2D_GET_CODEDATA	= -6,
	CR2D_GET_LOCATION	= -7,
	CR2D_GET_DM_COLUMNS	= -8,
	CR2D_GET_DM_ROWS	= -9,
	CR2D_GET_DM_ERRORS	= -10,
	CR2D_GET_READABILITY_SCORE	= -11,
	CR2D_IS_BLACK_ON_WHITE	= -12,
	CR2D_GET_TOTAL_DECODING_TIME	= -13,
	CR2D_GET_DECODING_TIME	= -14,
	CR2D_GET_DM_BITMAP	= -15,
	CR2D_GET_TOTAL_DECODING_TIME_AS_DOUBLE	= -16,
	CR2D_GET_DECODING_TIME_AS_DOUBLE	= -17,
	CR2D_GET_DM_MIRROR	= -18,
	CR2D_GET_REFLECTANCE_MINIMUM	= -19,
	CR2D_GET_REFLECTANCE_DARK	= -20,
	CR2D_GET_REFLECTANCE_MAXIMUM	= -21,
	CR2D_GET_REFLECTANCE_BRIGHT	= -22,
	CR2D_GET_SYMBOL_CONTRAST	= -23,
	CR2D_GET_MODULATION	= -24,
	CR2D_GET_FIXED_PATTERN_DAMAGE	= -25,
	CR2D_GET_AXIAL_NONUNIFORMITY	= -26,
	CR2D_GET_GRID_NONUNIFORMITY	= -27,
	CR2D_GET_UNUSED_ERROR_CORRECTION	= -28,
	CR2D_GET_DECODABILITY_GRADE	= -29,
	CR2D_GET_SYMBOL_CONTRAST_GRADE	= -30,
	CR2D_GET_MODULATION_GRADE	= -31,
	CR2D_GET_FIXED_PATTERN_DAMAGE_GRADE	= -32,
	CR2D_GET_AXIAL_NONUNIFORMITY_GRADE	= -33,
	CR2D_GET_GRID_NONUNIFORMITY_GRADE	= -34,
	CR2D_GET_UNUSED_ERROR_CORRECTION_GRADE	= -35,
	CR2D_GET_SCAN_GRADE	= -36
    } ;
typedef /* [hidden] */ enum CR2D_CONFIG_INQUIRE CR2D_CONFIG_INQUIRE;

/* [helpstring] */ 
enum CR2D_DECODERFLAGS
    {	CR2D_DECODER_COUNT	= 0,
	CR2D_DECODER_NAME	= 1,
	CR2D_DECODER_FILENAME	= 2,
	CR2D_DECODER_NAME_LENGTH	= 3,
	CR2D_DECODER_FILENAME_LENGTH	= 4,
	CR2D_DECODER_DM_SIZE	= 5
    } ;
typedef /* [hidden] */ enum CR2D_DECODERFLAGS CR2D_DECODERFLAGS;


EXTERN_C const IID LIBID_vl_cr2d;


#ifndef __vl_cr2d_MODULE_DEFINED__
#define __vl_cr2d_MODULE_DEFINED__


/* module vl_cr2d */
/* [dllname][uuid] */ 

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CR2D_IsValidBuffer( 
    /* [in] */ CR2D_BUFHANDLE Buffer,
    /* [full][out] */ IPL_BOOL *Valid);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CR2D_Control( 
    /* [in] */ CR2D_BUFHANDLE Buffer,
    /* [in] */ CR2D_CONFIG_INQUIRE Parameter,
    /* [in] */ IPL_ULONG Value);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CR2D_BufAlloc( 
    /* [full][out][in] */ CR2D_BUFHANDLE *Buffer);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CR2D_BufFree( 
    /* [in] */ CR2D_BUFHANDLE Buffer);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CR2D_Locate( 
    /* [in] */ IPL_BUFHANDLE Image,
    /* [full][out][in] */ CR2D_BUFHANDLE *Config,
    /* [full][out][in] */ CR2D_BUFHANDLE *Result);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CR2D_LocateAndVisualizeRuns( 
    /* [in] */ IPL_BUFHANDLE Image,
    /* [full][out][in] */ CR2D_BUFHANDLE *Config,
    /* [full][out][in] */ CR2D_BUFHANDLE *Result,
    /* [in] */ DISP_OOISETHANDLE OoiSet,
    /* [full][out] */ DISP_OOIHANDLE *BusyRunsOoi,
    /* [full][out] */ DISP_OOIHANDLE *QuiteGridOoi,
    /* [full][in] */ IPL_CONST_VOID_PTR UserPtr);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CR2D_Decode( 
    /* [in] */ IPL_BUFHANDLE Image,
    /* [full][out][in] */ CR2D_BUFHANDLE *Config,
    /* [full][out][in] */ CR2D_BUFHANDLE *Result);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CR2D_DecodeAndVisualizeRuns( 
    /* [in] */ IPL_BUFHANDLE Image,
    /* [full][out][in] */ CR2D_BUFHANDLE *Config,
    /* [full][out][in] */ CR2D_BUFHANDLE *Result,
    /* [in] */ DISP_OOISETHANDLE OoiSet,
    /* [full][out] */ DISP_OOIHANDLE *BusyRunsOoi,
    /* [full][out] */ DISP_OOIHANDLE *QuiteGridOoi,
    /* [full][in] */ IPL_CONST_VOID_PTR UserPtr);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CR2D_DecodeAtLocation( 
    /* [in] */ IPL_BUFHANDLE Image,
    /* [full][in] */ IPL_POINT *Location,
    /* [full][out][in] */ CR2D_BUFHANDLE *Config,
    /* [full][out][in] */ CR2D_BUFHANDLE *Result);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CR2D_DecodeBitmap( 
    /* [in] */ IPL_BUFHANDLE Cells,
    /* [full][out][in] */ CR2D_BUFHANDLE *Config,
    /* [full][out][in] */ CR2D_BUFHANDLE *Result);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CR2D_Inquire( 
    /* [in] */ CR2D_BUFHANDLE Buffer,
    /* [in] */ CR2D_CONFIG_INQUIRE Item,
    /* [in] */ IPL_ULONG CandidateIndex,
    /* [in] */ IPL_ULONG DecoderIndex,
    /* [full][out] */ IPL_VOID_PTR Value);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CR2D_EdgeMap( 
    /* [in] */ IPL_BUFHANDLE Image,
    /* [full][out][in] */ CR2D_BUFHANDLE *Config,
    /* [full][out][in] */ IPL_BUFHANDLE *EdgeMap);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CR2D_AddDecoder( 
    /* [string][full][in] */ const IPL_CHAR *Decoder,
    /* [in] */ IPL_LONG Index);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CR2D_RemoveDecoder( 
    /* [string][full][in] */ const IPL_CHAR *Decoder);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CR2D_ControlDecoder( 
    /* [in] */ IPL_ULONG Decoder,
    /* [in] */ CR2D_DECODERFLAGS Item,
    /* [full][in] */ IPL_CONST_VOID_PTR Value);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CR2D_InquireDecoder( 
    /* [in] */ IPL_ULONG Decoder,
    /* [in] */ CR2D_DECODERFLAGS Item,
    /* [full][out] */ IPL_VOID_PTR Value);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CR2D_CheckLic( void);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CR2D_GetVersion( 
    /* [full][in] */ const IPL_CHAR *Buffer,
    /* [in] */ IPL_INT Bytes);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CR2D_GetVersionDecoder( 
    /* [full][in] */ const IPL_CHAR *Decoder,
    /* [full][in] */ const IPL_CHAR *Buffer,
    /* [in] */ IPL_INT Bytes);

#endif /* __vl_cr2d_MODULE_DEFINED__ */
#endif /* __vl_cr2d_LIBRARY_DEFINED__ */

/* interface __MIDL_itf_vl_cr2d_0122 */
/* [local] */ 


#ifdef MVIMPACT_H_ // include guard of the main C++ header
	} // namespace mvIMPACT_C
} // namespace mvIMPACT
#endif // #ifdef MVIMPACT_H_



extern RPC_IF_HANDLE __MIDL_itf_vl_cr2d_0122_v0_0_c_ifspec;
extern RPC_IF_HANDLE __MIDL_itf_vl_cr2d_0122_v0_0_s_ifspec;

/* Additional Prototypes for ALL interfaces */

/* end of Additional Prototypes */

#ifdef __cplusplus
}
#endif

#endif


