#ifdef _MSC_VER
#pragma warning ( push )
#pragma warning ( disable:4005 ) // '_WIN32_WINNT' : macro redefinition
#define _WIN32_WINNT 0x0500
#pragma warning ( pop )
#endif




#include "rpc.h"
#include "rpcndr.h"

#ifndef __RPCNDR_H_VERSION__
#error this stub requires an updated version of <rpcndr.h>
#endif // __RPCNDR_H_VERSION__


#ifndef __vl_device_h__
#define __vl_device_h__

#if defined(_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif

/* Forward Declarations */ 

/* header files for imported files */
#include "vl_base.h"
#include "vl_driver.h"

#ifdef __cplusplus
extern "C"{
#endif 

void * __RPC_USER MIDL_user_allocate(size_t);
void __RPC_USER MIDL_user_free( void * ); 

/* interface __MIDL_itf_vl_device_0000 */
/* [local] */ 

//=--------------------------------------------------------------------------=
// (C) Copyright 2002-2010 MATRIX VISION GmbH.  All Rights Reserved.
// (C) Copyright 1997-2010 Impuls computergesttzte Bildanalyse GmbH.
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
// PARTICULAR PURPOSE.
//=--------------------------------------------------------------------------=

#if defined(__BORLANDC__)
#pragma option -b
#endif
#if !defined(NO_VL_DEVICE_AUTOLINK)
#if defined(__BORLANDC__)
#pragma comment(lib,"vlb_device.lib")
#pragma message ("Automatically linking with vlb_device.lib")
#else
#if defined(_M_X64)
#if _MSC_VER >= 1500
#pragma comment(lib,"vl_device.lib")
#pragma message ("Automatically linking with vl_device.lib")
#else
#pragma comment(lib,"vl_device64.lib")
#pragma message ("Automatically linking with vl_device64.lib")
#endif
#else
#pragma comment(lib,"vl_device.lib")
#pragma message ("Automatically linking with vl_device.lib")
#endif
#endif
#endif


#ifdef MVIMPACT_H_ // include guard of the main C++ header
namespace mvIMPACT {
	namespace mvIMPACT_C {
#endif // #ifdef MVIMPACT_H_


// Calling method for C Functions and C++ global and class methods.
// With other words: everything without a this-pointer
#define IPL_C_CALLTYPE __stdcall
#define IPL_C_CALLTYPEVAR __cdecl

// Calling method for the C++ methods with a this pointer.
// C++ static methods or C++ functions use IPL_C_CALLTYPE[VAR]
#define IPL_CPP_CALLTYPE // nothing == 'C++-call'
#define IPL_CPP_CALLTYPEVAR __cdecl

#ifdef VL_DEVICE_COMPILING
// when compiling the dll
#define VL_DEVICE_DLLEXPORT	__declspec(dllexport)
#undef __MIDL_DECLSPEC_DLLEXPORT
#define __MIDL_DECLSPEC_DLLEXPORT	__declspec(dllexport)
#undef __MIDL_DECLSPEC_DLLIMPORT
#define __MIDL_DECLSPEC_DLLIMPORT	__declspec(dllexport)
#else
// when using the dll
#define VL_DEVICE_DLLEXPORT	__declspec(dllimport)
#undef __MIDL_DECLSPEC_DLLEXPORT
#define __MIDL_DECLSPEC_DLLEXPORT	__declspec(dllimport)
#undef __MIDL_DECLSPEC_DLLIMPORT
#define __MIDL_DECLSPEC_DLLIMPORT	__declspec(dllimport)
#endif
#define	DEV_DONT_CARE	( -1 )



extern RPC_IF_HANDLE __MIDL_itf_vl_device_0000_v0_0_c_ifspec;
extern RPC_IF_HANDLE __MIDL_itf_vl_device_0000_v0_0_s_ifspec;


#ifndef __vl_device_LIBRARY_DEFINED__
#define __vl_device_LIBRARY_DEFINED__

/* library vl_device */
/* [helpstring][version][uuid] */ 

typedef /* [helpstring] */ _DEV_HANDLE DEV_HANDLE;

typedef /* [helpstring][hidden] */ enum DCTL_RANGETYPE DEV_RANGETYPE;

typedef /* [helpstring][hidden] */ enum DCTL_CAPSTYPE DEV_CAPSTYPE;

/* [helpstring] */ 
enum DEV_ERROR
    {	DEV_ACCESS_ERROR	= -600,
	DEV_DLL_ERROR	= -601,
	DEV_FEATURE_ERROR	= -602,
	DEV_DDC_FILE_ERROR	= -603,
	DEV_BUFFER_ERROR	= -604,
	DEV_HANDLE_ERROR	= -605,
	DEV_NULL	= -606,
	DEV_WRONG_PARAM	= -607,
	DEV_THREAD_ERROR	= -608,
	DEV_SIZE_MISMATCH_ERROR	= -609,
	DEV_DATATYPE_ERROR	= -610,
	DEV_HWND_ERROR	= -611,
	DEV_NO_GRAB_DEVICE_ERROR	= -612,
	DEV_GRAB_ERROR	= -613,
	DEV_GRAB_FUNC_ERROR	= -614,
	DEV_DLL_LOAD_ERROR	= -615,
	DEV_DHC_FILE_ERROR	= -616,
	DEV_PROPERTY_LIST_ERROR	= -617,
	DEV_INVALID_PTR_ERROR	= -618,
	DEV_MEMORY_ERROR	= -619
    } ;
typedef /* [hidden] */ enum DEV_ERROR DEV_ERROR;

/* [helpstring] */ 
enum DEV_TYPE
    {	DEV_UNKNOWN_DEVICE	= 0,
	DEV_DEVICE	= 1,
	DEV_TWAIN_DEVICE	= 2,
	DEV_MCI_DEVICE	= 3,
	DEV_OVERLAY_DEVICE	= 4,
	DEV_SPECIAL_DEVICE	= 5,
	DEV_STORAGE_DEVICE	= 6
    } ;
typedef /* [hidden] */ enum DEV_TYPE DEV_TYPE;

/* [helpstring] */ 
enum DEV_GRABMODE
    {	DEV_SINGLE_MODE	= 1,
	DEV_LIVE_MODE	= -1
    } ;
typedef /* [hidden] */ enum DEV_GRABMODE DEV_GRABMODE;

/* [helpstring] */ 
enum DEV_CONTROLTYPE
    {	DEV_SINGLE	= 0,
	DEV_STARTLIVE	= 1,
	DEV_NUMBER_FRAMES	= 3,
	DEV_GET_DBB_HANDLE	= 7,
	DEV_NORMALIZATION_FACTOR	= 8,
	DEV_STOPLIVE	= 31,
	DEV_USE_THREAD_SINGLE	= 9,
	DEV_ENABLE_OVERLAY	= 10,
	DEV_OVERLAY_BITCOUNT	= 11,
	DEV_MAPPING_PRESET	= 12,
	DEV_GRAB_INTO_AOI	= 13,
	DEV_SMART_LIVE_MODE	= 14,
	DEV_GRAB_MODE	= 126,
	DEV_DEVICE_TYPE	= 127,
	DEV_CURRENT_GRAB_DEVICE	= 134,
	DEV_NB_DEVICES	= 135,
	DEV_MAPPING_PALETTE_HANDLE	= 136,
	DEV_DISPLAY_PALETTE_HANDLE	= 137,
	DEV_DDC_PATH_LENGTH	= 138,
	DEV_DDC_PATH	= 139,
	DEV_MAN_NAME_LENGTH	= 140,
	DEV_MAN_NAME	= 141,
	DEV_DEVICE_HANDLES	= 142,
	DEV_FPS	= 143,
	DEV_DHC_PATH_LENGTH	= 144,
	DEV_DHC_PATH	= 145,
	DEV_DHC_SECTION_LENGTH	= 146,
	DEV_DHC_SECTION	= 147,
	DEV_THREAD_HANDLE	= 148,
	DEV_THREAD_SAFE	= 149,
	DEV_SEQUENTIAL_MODE	= 150,
	DEV_GRAB_WITH_WHITE_BALANCE	= 151
    } ;
typedef /* [hidden] */ enum DEV_CONTROLTYPE DEV_CONTROLTYPE;

/* [helpstring] */ 
enum DEV_EVENT
    {	DEV_EVENT_PREOPEN_DRIVER	= 0,
	DEV_EVENT_GRAB_END	= 1,
	DEV_EVENT_FRAME_END	= 2,
	DEV_EVENT_FIELD_END	= 3,
	DEV_EVENT_NEVER_USED	= 3,
	DEV_EVENT_POSTOPEN_DRIVER	= 4,
	DEV_EVENT_PRECLOSE_DRIVER	= 5,
	DEV_EVENT_POSTCLOSE_DRIVER	= 6,
	DEV_EVENT_DRAW_OVERLAY	= 7,
	DEV_EVENT_GRAB_START	= 8,
	DEV_EVENT_CFG_CHANGED	= 10,
	DEV_EVENT_GRAB_DIALOG	= 11,
	DEV_EVENT_MAXNUMBER	= DEV_EVENT_GRAB_DIALOG
    } ;
typedef /* [hidden] */ enum DEV_EVENT DEV_EVENT;

/* [helpstring] */ 
enum DEV_EVENT_SUB
    {	DEV_DO_SNAPSHOT	= 200,
	DEV_DO_GRAB	= 201,
	DEV_DO_GRAB_HALT	= 202
    } ;
typedef /* [hidden] */ enum DEV_EVENT_SUB DEV_EVENT_SUB;

/* [helpstring] */ 
enum DEV_EVENT_METHOD
    {	DEV_USE_MESSAGE_LOOP	= 0,
	DEV_USE_HOOK_FUNCTION	= 1,
	DEV_CLEAR_EVENT	= 4,
	DEV_CLEAR_EVENT_MESSAGE	= 5,
	DEV_CLEAR_EVENT_FUNCTION	= 6,
	DEV_FREE_DATAPTR_ON_CLEAR	= 256
    } ;
typedef /* [hidden] */ enum DEV_EVENT_METHOD DEV_EVENT_METHOD;

/* [helpstring] */ 
enum DEV_DIALOG
    {	DEV_OPEN_CONFIG_DLGBOX	= 51,
	DEV_OPEN_ABOUT_DLGBOX	= 53
    } ;
typedef /* [hidden] */ enum DEV_DIALOG DEV_DIALOG;

/* [helpstring] */ 
enum DEV_ACCUMULATE
    {	DEV_RUNNING_AVERAGE	= 2,
	DEV_WEIGHTED_AVERAGE	= 3
    } ;
typedef /* [hidden] */ enum DEV_ACCUMULATE DEV_ACCUMULATE;

/* [helpstring] */ 
enum DEV_SUBTRACT
    {	DEV_CLIP	= 0,
	DEV_CLIP_CST	= 1,
	DEV_ABS	= 2,
	DEV_ABS_CST	= 3
    } ;
typedef /* [hidden] */ enum DEV_SUBTRACT DEV_SUBTRACT;

/* [helpstring] */ 
enum DEV_SHADING
    {	DEV_MUL	= 1,
	DEV_MUL_BLACK_CST	= 2,
	DEV_ADD	= 3,
	DEV_ADD_BLACK_CST	= 4
    } ;
typedef /* [hidden] */ enum DEV_SHADING DEV_SHADING;

/* [helpstring] */ 
enum DEV_PALETTE
    {	DEV_INPUT_PALETTE	= 1,
	DEV_MAPPING_PALETTE	= 2,
	DEV_DISPLAY_PALETTE	= 3
    } ;
typedef /* [hidden] */ enum DEV_PALETTE DEV_PALETTE;

/* [helpstring] */ 
enum DEV_INQUIRE_ID_TYPE
    {	DEV_INDEX	= 1,
	DEV_STD_PROP	= 2,
	DEV_CUSTOM_PROP	= 3,
	DEV_NUMBER_PROP	= 4
    } ;
typedef /* [hidden] */ enum DEV_INQUIRE_ID_TYPE DEV_INQUIRE_ID_TYPE;

typedef struct DSTR_PROPERTY_LIST DEV_PROPERTY_LIST;

typedef struct DSTR_LNG_RANGE DEV_LNG_RANGE;

typedef struct DSTR_ULNG_RANGE DEV_ULNG_RANGE;

typedef struct DSTR_DBL_RANGE DEV_DBL_RANGE;

typedef struct DSTR_NL_LNG_RANGE DEV_NL_LNG_RANGE;

typedef struct DSTR_NL_ULNG_RANGE DEV_NL_ULNG_RANGE;

typedef struct DSTR_NL_DBL_RANGE DEV_NL_DBL_RANGE;

typedef struct DSTR_LNG_ENUM DEV_LNG_ENUM;

typedef struct DSTR_DBL_ENUM DEV_DBL_ENUM;

typedef struct DSTR_STR_VALUE DEV_STR_VALUE;

struct DEV_MSG
    {
    DEV_HANDLE DevId;
    IPL_LONG CtlValue;
    IPL_BUFHANDLE BufId;
    } ;
typedef struct DEV_MSG DEV_MSG;

struct DEV_MSGOVL
    {
    DEV_HANDLE DevId;
    IPL_LONG CtlValue;
    IPL_BUFHANDLE BufId;
    IPL_HDC Hdc;
    IPL_HWND Hwnd;
    } ;
typedef struct DEV_MSGOVL DEV_MSGOVL;

typedef IPL_FRESULT ( __stdcall *DEV_EVENT_PTR )( 
    IPL_LONG EventType,
    IPL_VOID_PTR DataPtr);

typedef BOOL ( __stdcall *IPL_PROC_PTR )( 
    IPL_LONG __MIDL_0042,
    void *__MIDL_0043);


EXTERN_C const IID LIBID_vl_device;


#ifndef __vl_device_MODULE_DEFINED__
#define __vl_device_MODULE_DEFINED__


/* module vl_device */
/* [dllname][uuid] */ 

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DEV_Open( 
    /* [full][out] */ DEV_HANDLE *Device,
    /* [string][full][in] */ const IPL_CHAR *Ddc);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DEV_IOControl( 
    /* [in] */ DEV_HANDLE Device,
    /* [in] */ DCTL_CONTROLCODES ControlCode,
    /* [full][in] */ IPL_CONST_VOID_PTR InputParam,
    /* [full][out] */ IPL_VOID_PTR OutputParam,
    /* [full][out][in] */ IPL_VOID_PTR AsyncParam);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DEV_Close( 
    /* [in] */ DEV_HANDLE Device);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DEV_RegWndMessage( 
    /* [in] */ IPL_HWND hWnd,
    /* [string][full][in] */ const IPL_CHAR *MessageName,
    /* [full][out] */ IPL_ULONG *MessageId);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DEV_LiveDispScroll( 
    /* [in] */ DEV_HANDLE Device,
    /* [in] */ IPL_ULONG X,
    /* [in] */ IPL_ULONG Y);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DEV_LiveDispZoom( 
    /* [in] */ DEV_HANDLE Device,
    /* [in] */ IPL_DOUBLE X,
    /* [in] */ IPL_DOUBLE Y);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DEV_ControlCaps( 
    /* [in] */ DEV_HANDLE Device,
    /* [in] */ DEV_CAPSTYPE CapsType,
    /* [full][in] */ IPL_CONST_VOID_PTR Control);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DEV_InquireCaps( 
    /* [in] */ DEV_HANDLE Device,
    /* [in] */ DEV_CAPSTYPE CapsType,
    /* [full][out] */ IPL_VOID_PTR Inquire);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DEV_GetInfoString( 
    /* [size_is][full][out] */ IPL_CHAR *Info,
    /* [string][full][in] */ const IPL_CHAR *Ddc,
    /* [in] */ IPL_ULONG n);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DEV_HookEvent( 
    /* [in] */ DEV_HANDLE Device,
    /* [in] */ DEV_EVENT DeviceEvent,
    /* [full][in] */ IPL_CONST_VOID_PTR DeviceHandler,
    /* [full][in] */ IPL_CONST_VOID_PTR Data,
    /* [in] */ DEV_EVENT_METHOD Method);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DEV_Inquire( 
    /* [in] */ DEV_HANDLE Device,
    /* [in] */ DEV_CONTROLTYPE Control,
    /* [full][out] */ IPL_VOID_PTR Data);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DEV_OpenDlgBox( 
    /* [in] */ DEV_HANDLE Device,
    /* [in] */ DEV_DIALOG DialogType);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DEV_Grab( 
    /* [in] */ DEV_HANDLE Device,
    /* [full][out][in] */ IPL_BUFHANDLE *Image);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DEV_GrabAccumulate( 
    /* [in] */ DEV_HANDLE Device,
    /* [full][out][in] */ IPL_BUFHANDLE *Image,
    /* [in] */ DEV_ACCUMULATE Method,
    /* [in] */ IPL_DOUBLE Weight);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DEV_GrabSubtract( 
    /* [in] */ DEV_HANDLE Device,
    /* [in] */ IPL_BUFHANDLE Subtract,
    /* [full][out][in] */ IPL_BUFHANDLE *Image,
    /* [in] */ DEV_SUBTRACT Method);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DEV_GrabShadingCorrection( 
    /* [in] */ DEV_HANDLE Device,
    /* [in] */ IPL_BUFHANDLE White,
    /* [in] */ IPL_BUFHANDLE Black,
    /* [full][out][in] */ IPL_BUFHANDLE *Image,
    /* [in] */ DEV_SHADING Method);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DEV_GrabTimed( 
    /* [in] */ DEV_HANDLE Device,
    /* [full][out][in] */ IPL_BUFHANDLE *Image,
    /* [size_is][full][in] */ const IPL_DWORD *Timing,
    /* [in] */ IPL_ULONG n);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DEV_AttachPalette( 
    /* [in] */ DEV_HANDLE Device,
    /* [in] */ DEV_PALETTE PaletteType,
    /* [in] */ IPL_BUFHANDLE Palette);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DEV_Control( 
    /* [in] */ DEV_HANDLE Device,
    /* [in] */ DEV_CONTROLTYPE Control,
    /* [full][in] */ IPL_CONST_VOID_PTR Data);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DEV_EnterNativeMode( 
    /* [in] */ DEV_HANDLE Device,
    /* [full][out] */ IPL_VOID_PTR *NativePtr);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DEV_LeaveNativeMode( 
    /* [in] */ DEV_HANDLE Device,
    /* [full][in] */ IPL_CONST_VOID_PTR NativePtr);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DEV_GetCapsList( 
    /* [in] */ DEV_HANDLE Device);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DEV_InquireCapsList( 
    /* [in] */ DEV_HANDLE Device,
    /* [in] */ IPL_LONG InquireId,
    /* [in] */ DEV_INQUIRE_ID_TYPE InquireIdType,
    /* [out] */ IPL_LONG *IdentifierPtr,
    /* [out] */ IPL_CHAR **NamePtr,
    /* [out] */ IPL_CHAR **UnitPtr,
    /* [out] */ DEV_RANGETYPE *RangeTypePtr,
    /* [full][out] */ IPL_VOID_PTR *DataPtr);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DEV_CheckLic( void);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DEV_GetVersion( 
    /* [full][in] */ const IPL_CHAR *Buffer,
    /* [in] */ IPL_INT Bytes);

#endif /* __vl_device_MODULE_DEFINED__ */
#endif /* __vl_device_LIBRARY_DEFINED__ */

/* interface __MIDL_itf_vl_device_0122 */
/* [local] */ 


#ifdef MVIMPACT_H_ // include guard of the main C++ header
	} // namespace mvIMPACT_C
} // namespace mvIMPACT
#endif // #ifdef MVIMPACT_H_



extern RPC_IF_HANDLE __MIDL_itf_vl_device_0122_v0_0_c_ifspec;
extern RPC_IF_HANDLE __MIDL_itf_vl_device_0122_v0_0_s_ifspec;

/* Additional Prototypes for ALL interfaces */

/* end of Additional Prototypes */

#ifdef __cplusplus
}
#endif

#endif


