//----------------------------------------------------------------------
//----------------------------------------------------------------------
// MATRIX VISION GmbH
// mvIMPACT - sample >>rank<<
// Don Feb 17 16:02:48 CET 2005
//----------------------------------------------------------------------
#include <vl_base.h>
#include <vl_file.h>
#include <vl_display.h>
#include <vl_ipl.h>
#include <samples.h>

//----------------------------------------------------------------------
int main(int /*argc*/, char** /*argv[]*/)
{
	// load any supported file format, into image
	IPL_BUFHANDLE image = IPL_DONT_CARE;
	CHECKSDKCALL(IPL_FlImport(&image, NULL, FL_DONT_CARE, "screw.bmp"));

	const int dx = 5;
	const int dy = 5;

	IPL_BUFHANDLE structel = IPL_DONT_CARE;
	CHECKSDKCALL(IPL_BufAlloc(&structel, dx, dy, 1, 1, 1, IPL_DTLONG, IPL_STRUCTBUF, 0));

	IPL_LONG structel_data[dx*dy] =
		{ 1, 0, 0, 0, 1,
		  0, 1, 0, 1, 0,
		  0, 0, 1, 0, 0,
		  0, 1, 0, 1, 0,
		  1, 0, 0, 0, 1, };

	CHECKSDKCALL(IPL_PutBufData(structel, 0, 0, 0, 0, 0, dx, dy, structel_data));

	CHECKSDKCALL(IPL_Rank(image, &image, structel, 5, IPL_GRAYSCALE));

	// open window to display image
	IPL_HWND hwnd = 0;
	CHECKSDKCALL(DISP_OpenWindow(image, &hwnd, 0, NULL));

	// keep sample alive until console window is closed or space bar is pressed
	CHECKSDKCALL(DISP_KeepRunning("Click the space bar to end program.\n"));

	// free allocated buffers
	CHECKSDKCALL(IPL_BufFreeAll());

	return 0;
}

//----------------------------------------------------------------------
//----------------------------------------------------------------------
