// sizefilter.cpp : Defines the entry point for the console application.
//

#include <vl_base.h>
#include <vl_file.h>
#include <vl_ipl.h>
#include <vl_display.h>
#include <samples.h>

int main(int /*argc*/, char** /*argv[]*/)
{
	IPL_BUFHANDLE lhSrc = IPL_DONT_CARE;

	//load sample file
	CHECKSDKCALL(IPL_FlImport(&lhSrc, NULL, FL_DONT_CARE, "gef.bmp"));

	//inquire about source buffer
	IPL_ULONG lXSize=0, lYSize=0, lDataType=0;
	CHECKSDKCALL(IPL_BufInquire(lhSrc, IPL_XSIZE, &lXSize));
	CHECKSDKCALL(IPL_BufInquire(lhSrc, IPL_YSIZE, &lYSize));
	CHECKSDKCALL(IPL_BufInquire(lhSrc, IPL_DATATYPE, &lDataType));

	//create a new destination image 
	IPL_BUFHANDLE lhDest=IPL_DONT_CARE;
	CHECKSDKCALL(IPL_BufAlloc2D(&lhDest, lXSize, lYSize, (IPL_BUFFER_DATATYPE)lDataType, IPL_IMAGEBUF, NULL));

	//create a binary image at threshold 110
	CHECKSDKCALL(IPL_PtToPoint(lhSrc, 110, &lhSrc, IPL_GREATER_CST));

	//apply size filter; remove objects with an area smaller than 300
	CHECKSDKCALL(IPL_MoSizeFilter(lhSrc, &lhDest, IPL_SIZE_SMALLER, 300, 0, IPL_SIZE_WHITE, IPL_RECT_3x3, NULL));

	//open window and draw binary image
	IPL_HWND hWnd = 0;
	CHECKSDKCALL(DISP_OpenWindow(lhSrc, &hWnd, 0, 0));

	//open window and draw filtered binary image
	hWnd = 0;
	CHECKSDKCALL(DISP_OpenWindow(lhDest, &hWnd, 0, 0));

	//wait until space bar is pressed
	DISP_KeepRunning("Press space bar to continue.\n");

	//free buffers
	CHECKSDKCALL(IPL_BufFree(lhSrc));
	CHECKSDKCALL(IPL_BufFree(lhDest));

	return 0;
}

