//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

#include "vl_base.h"
#include "vl_ipl.h"
#include "vl_device.h"
#include "vl_display.h"

#include <assert.h>
#include <samples.h>

//---------------------------------------------------------------------------
int main( int argc, char *argv[] )
{
	int conv_flag = 0;

	if( argc > 1 )
	{
		_skiparg( );
		_intarg( conv_flag );
	}

	printf(" \n usage: contsnap [conv flag]\n\n");

	DEV_HANDLE device = IPL_DONT_CARE;
	assert( DEV_Open(&device, "mvblue.ddc"));
    assert( DEV_Control( device, DEV_SINGLE, 0 ));

	IPL_HWND hwnd = 0;
	IPL_BUFHANDLE image = IPL_DONT_CARE;
	assert( DEV_Grab( device, &image ));
	assert( DISP_OpenWindow(image, &hwnd, 0, NULL ));
	assert( DISP_UpdateWindow( hwnd, DISP_INVALIDATE ));

	printf(" Press <ENTER> to stop the demo!!\n");
	while( !_kbhit( ))
	{
		assert( DEV_Grab( device, &image ));

		if( conv_flag )
			assert( IPL_Convolve( image, &image, IPL_SOBEL ));

		assert( DISP_UpdateWindow( hwnd, DISP_INVALIDATE ));
	}

    DEV_Close( device );
	IPL_BufFree( image );

	return 0;
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
