//----------------------------------------------------------------------
//----------------------------------------------------------------------
// MATRIX VISION GmbH
// mvIMPACT - mvBlueLYNX demo >>blob-afs<<
// Mit Aug 13 11:31:13 CEST 2003
//----------------------------------------------------------------------
#ifndef __afsapi_h__
#define __afsapi_h__

//----------------------------------------------------------------------
//----------------------------------------------------------------------
#include <stdio.h>

#include <vl_base.h>
#include <vl_device.h>
#include <vl_display.h>

#include <pgutils.h>
#include <samples.h>

//----------------------------------------------------------------------
//----------------------------------------------------------------------
#define START_LIVE_STR							"live"
#define STOP_LIVE_STR							"stopped live"

#define NO_ANALYSE_STR							"No analyse"
#define CLASSIFY_STR							"classify"
#define TEACH_STR								"teach"
#define DELETE_STR								"delete"

#define STOP_AFTER_STR( a )						"Stopped after " #a " objects!!"

//----------------------------------------------------------------------
//----------------------------------------------------------------------
struct SStatusInfo
{
	pghandle wBox;
	pghandle wText;
	char *msg;
	int msg_len;
	pghandle msg_col;
};

typedef struct SStatusInfo STATUS_INFO;

struct SSpinEdit
{
	pghandle wBox;
	SStatusInfo si;
	pghandle wBtnUp;
	pghandle wBtnDown;
	pghandle wLabel;
};

typedef struct SSpinEdit SPIN_EDIT;

//----------------------------------------------------------------------
//----------------------------------------------------------------------
pghandle init_pg( int argc, char *argv[], char *msg );
pghandle mk_buttons( pghandle parent );
void get_img4displ( BYTE **shm_buffer, long width, long height );
void mk_disp( pghandle widget, int pos );
void displ_img( );
void draw_aoi( pgcontext gc, int x, int y, int w, int h, pgcolor color );
void draw_txt( pgcontext gc, int x, int y, char *text, pgcolor color );
void display_bounding_box( char *text, unsigned long left, unsigned long top,
					unsigned long right, unsigned long bottom, int pos );

void mk_blb_initdlg( );
void rm_blb_initdlg( );

void exit_demo( const char *s, long err_code );
void note_or_err_msg( const char *msg_type, const char *s, long err_code );

void cp_img( BYTE *src, BYTE *dst, int width, int height, int spitch, int dpitch );
void cp_chimg( BYTE *src, BYTE *dst, int sx, int sy, int width, int height, int spitch, int dpitch );

void widget_delete( pghandle *widget );
pghandle mk_ctrl_btn( pghandle parent, char *txt, int pos, pgevthandler btn_cb, pghandle color, int fsize );
void set_w_color( pghandle widget, pghandle color );

pghandle mk_statline( pghandle parent, int pos, int size );
void mk_statLineLabel( pghandle parent );
void mk_stll_si( pghandle parent, int pos, STATUS_INFO *si );
void repl_txt_si( STATUS_INFO si );
void si_iupdate( STATUS_INFO *si, char *msg_prefix, char *msg_sufix, int value, int color_mode, int msg_len );
void si_fupdate( STATUS_INFO *si, char *msg_prefix, char *msg_sufix, double value, int color_mode, int msg_len );
void si_cupdate( STATUS_INFO *si, char *msg_prefix, char *msg_sufix, char *data, int color_mode, int msg_len );
void update_status_line( int flag );

SPIN_EDIT mk_spin_edit( pghandle parent, long value, char *label );
void set_val_from_se( struct pgEvent *evt, int val );
SPIN_EDIT get_se( struct pgEvent *evt, long *se_cnt, unsigned int *step );
void set_se_val( SPIN_EDIT *se, int val );

int get_x_size( char *s );
int get_y_size( char *s );
void get_s_size( char *s, int *x, int *y );

int get_class_name( BYTE *img_buffer, int width, int height, char *class_name,
					char class_list[MAX_CLASS_NB][MAX_BUF_SIZE], int list_size, int gui_type );
void redraw_img( );

pghandle mk_chb( pghandle parent, char *txt, pgevthandler chbox_cb, int pos, int status );

int evtLiveON( struct pgEvent *evt );
int evtClassify( struct pgEvent *evt );
void init_gui( );
void init_blb_globals2fl( );

//----------------------------------------------------------------------
//----------------------------------------------------------------------
#endif //	__afsapi_h__
