//----------------------------------------------------------------------
//----------------------------------------------------------------------
// MATRIX VISION GmbH
// mvIMPACT - mvBlueLYNX demo >>blob-afs<<
// Mit Aug 13 11:31:13 CEST 2003
//----------------------------------------------------------------------
#include <time.h>

#include <vl_base.h>
#include <vl_file.h>
#include <vl_device.h>
#include <vl_display.h>
#include <vl_ipl.h>
#include <vl_blob.h>

#include <pgutils.h>
#include <samples.h>

#include "blob-afs.h"
#include "afsapi.h"
#include "blbproc.h"
#include "afstools.h"

//----------------------------------------------------------------------
//----------------------------------------------------------------------
void quicksort_iv( INTERVAL *a, int start, int size )
{
	dprintf((" ++ " TOOL_PREFIX ": quicksort_iv (start: %d, stop: %d)\n", start, size ));

	double v; //, t;
	INTERVAL t;
	int i, j;

	if( size > start )
	{
		i = start - 1;
		j = size;
		v = a[j].x1;
		dprintf((" == " TOOL_PREFIX ": quicksort_iv v: %f, i: %d, j: %d\n", v, i, j ));

		for(;;)
		{
			while( a[++i].x1 < v );
			while( a[--j].x1 > v );
			if( i >= j )	break;

			t = a[i];
			a[i] = a[j];
			a[j] = t;
		}

		t = a[i];
		a[i] = a[size];
		a[size] = t;
		quicksort_iv( a, start, i - 1 );
		quicksort_iv( a, i + 1, size );
	}

	dprintf((" -- " TOOL_PREFIX ": quicksort_iv\n"));
}

//----------------------------------------------------------------------
void quicksort_f( double *a, int start, int size )
{
	dprintf((" ++ " TOOL_PREFIX ": quicksort_f (start: %d, stop: %d)\n", start, size ));

	double v, t;
	int i, j;

	if( size > start )
	{
		i = start - 1;
		j = size;
		v = a[j];
		dprintf((" == " TOOL_PREFIX ": quicksort_f v: %f, i: %d, j: %d\n", v, i, j ));

		for(;;)
		{
			while( a[++i] < v );
			while( a[--j] > v );
			if( i >= j )	break;

			t = a[i];
			a[i] = a[j];
			a[j] = t;
		}

		t = a[i];
		a[i] = a[size];
		a[size] = t;
		quicksort_f( a, start, i - 1 );
		quicksort_f( a, i + 1, size );
	}

	dprintf((" -- " TOOL_PREFIX ": quicksort_f\n"));
}

//----------------------------------------------------------------------
//----------------------------------------------------------------------
