//----------------------------------------------------------------------
//----------------------------------------------------------------------
// MATRIX VISION GmbH
// mvIMPACT - mvBlueLYNX demo >>crtool<<
// Don Apr 29 14:28:38 CEST 2004
//----------------------------------------------------------------------
#ifndef __ftools_h__
#define __ftools_h__

//----------------------------------------------------------------------
#include <stdio.h>

#include "crtool.h"
#include "prop.h"
#include "gui.h"
#include "preproc.h"

//----------------------------------------------------------------------
#define CR_FILL_PROP( s, d, min, max )		{ #s, CR_##s, d, min, max }

#define set_print( a, x )														\
			dprintf((" == "  TOOL_PREFIX ": set_config_val - " #a ": %d \n", x ));

#ifdef LINE_DEBUG
	#ifdef DEBUG
		#undef DEBUG
	#endif

	#define __stmt( stmt )													\
			do { stmt; printf(" --> %s line %d\n", __FILE__, __LINE__ ); }	\
			while( 0 )

	#define DPRINTF( p )	__stmt( printf p; )
#elif DEBUG
	#define DPRINTF( p )	dprintf( p ); printf("\n")
#else
	#define DPRINTF( p )
#endif //LINE_DEBUG

//----------------------------------------------------------------------
#define CRASSERT( _c, _err )										\
	{																\
		if( !(_c))													\
		{															\
			dprintf(("*** %s (%s: %d) - >>%s<< failed!!\n", 		\
						__FUNCTION__, __FILE__, __LINE__, #_c));	\
			return _err;											\
		}															\
	}

//----------------------------------------------------------------------
int  pt_in_rect( const IPL_RECT rc, const IPL_POINT pt );
long ch_tv2ms( const struct timeval tv );
int  mk_pgm( BYTE *sbuf, BYTE **dbuf, const unsigned int width,
					const unsigned int height, const unsigned int pitch, const unsigned int bpp );

int read_ini_file( );
int save_ini_file( FILE *f );
int check_pt( const IPL_POINT pt, const unsigned int x, const unsigned int y );

//----------------------------------------------------------------------
//----------------------------------------------------------------------
#endif	// __ftools_h__
