//----------------------------------------------------------------------
//----------------------------------------------------------------------
#ifndef __pgtools_h__
#define __pgtools_h__

//----------------------------------------------------------------------
#include <stdio.h>
#include <picogui.h>

//----------------------------------------------------------------------
//----------------------------------------------------------------------
#define CRPGASSERT( _c, _err )										\
	{																\
		if( !(_c))													\
		{															\
			dprintf(("*** %s (%s: %d) - >>%s<< failed!!\n", 		\
						__FUNCTION__, __FILE__, __LINE__, #_c));	\
			err_msg( #_c, _err );									\
			return _err;											\
		}															\
	}

//----------------------------------------------------------------------
#define CRPGASSERT_IPL( _c )															\
	{																					\
		if( !(_c))																		\
		{																				\
			dprintf(("*** %s (%s: %d) - >>%s<< - %s\n", 								\
						__FUNCTION__, __FILE__, __LINE__, #_c,							\
						IPL_GetErrorString( IPL_GetErrorCode2())));						\
			err_msg( IPL_GetErrorString( IPL_GetErrorCode2()), IPL_GetErrorCode2());	\
			return -1;																	\
		}																				\
	}

//----------------------------------------------------------------------
//----------------------------------------------------------------------
struct SStatusInfo
{
	pghandle wBox;
	pghandle wText;
	char *msg;
	int msg_len;
	pghandle msg_col;
};
typedef struct SStatusInfo STATUS_INFO;

//----------------------------------------------------------------------
//----------------------------------------------------------------------
#ifdef __cplusplus
extern "C"{
#endif	//__cplusplus

void widget_delete( pghandle *widget );
void cp_img( const unsigned char *src, unsigned char *dst, const int width, const int height, const int spitch, const int dpitch );

void draw_aoi( const pgcontext gc, const int x, const int y, const int w, const int h, const pgcolor color );
void draw_txt( const pgcontext gc, const int x, const int y, const char *text, const pgcolor color );
void draw_line( const pgcontext gc, const int x1, const int y1, const int x2, const int y2, const pgcolor color );

void exit_demo( const char *s, const long err_code );
void err_msg( const char *s, const long err_code );
void note_or_err_msg( const char *msg_type, const char *s, const long err_code );

void get_str_size( int *x, int *y, const pghandle font, const char *str );
void set_w_color( pghandle widget, const pghandle color );

int get_x_size( const char *s );
int get_y_size( const char *s );
void get_s_size( const char *s, int *x, int *y );
int mk_popup_menu( char *menu_entrys, const unsigned int entrys_cnt );

void repl_txt( pghandle widget, const char *text );

pghandle mk_chb( const pghandle parent, const char *txt, pgevthandler evtChBox, const int pos, const int status );
pghandle mk_btn( const pghandle parent, const char *txt, const int pos, const int size, pgevthandler evtBtn );
pghandle mk_ctrl_btn( const pghandle parent, const char *txt, const int pos, pgevthandler evtBtn, const pghandle color, const int fsize );
pghandle mk_label( const pghandle parent, const char *txt, const int pos );
pghandle mk_scroller( const pghandle parent, const int pos, const int max_s, const int def_s, pgevthandler evtScroll );
pghandle mk_wBox( const pghandle parent, const int pat_pos, const int side, const int size );
pghandle mk_scroller_lable( const pghandle parent, const int pos, char *txt );
pghandle mk_statline( const pghandle parent, const int pos, const int size );
pghandle mk_stll( const pghandle parent, const int pos, pghandle *wText, const char *str, const int size );
pghandle get_stat_color( const int col_stat_mode );

void repl_txt_si( STATUS_INFO si );
void mk_stll_si( const pghandle parent, const int pos, STATUS_INFO *si );

void ni( );
void note4max_limit( const char *type, const int val );
void note4min_limit( const char *type, const int val );
void si_iupdate( STATUS_INFO *si, const char *msg_prefix, const char *msg_sufix, const int value, const int color_mode, const int msg_len );
void si_cupdate( STATUS_INFO *si, const char *msg_prefix, const char *msg_sufix, const char *data, const int color_mode, const int msg_len );

int check_if_file_exist( const char *fname );
int save_file( const unsigned char *data_buf, const char *fname, const char *ftype, const int fsize );

#ifdef __cplusplus
}
#endif	//__cplusplus

//----------------------------------------------------------------------
//----------------------------------------------------------------------
#endif	// __pgtools_h__
