//----------------------------------------------------------------------
//----------------------------------------------------------------------
// MATRIX VISION GmbH
// mvIMPACT - mvBlueLYNX demo >>gmmtool<<
// Don Nov 13 11:40:07 CET 2003
//----------------------------------------------------------------------

#ifndef __gmmtool_h__
#define __gmmtool_h__

//----------------------------------------------------------------------
//----------------------------------------------------------------------
#include <stdio.h>

#include <vl_base.h>
#include <vl_device.h>
#include <vl_display.h>

#include <mvslib.h>
#include <mvsensor.h>

#include <pgutils.h>
#include <samples.h>

//----------------------------------------------------------------------
//----------------------------------------------------------------------
#define TOOL_PREFIX							"gmmtool"
#define KB_ERROR							"KEYBOARD ERROR"

#define NO_MODE_STR							"NO GMM MODE SELECTED"
#define START_LIVE_STR						"live mode"
#define STOP_LIVE_STR						"live mode stopped"

#define INIT_STR_PROC						"PROCESS"
#define INIT_STR_RDISP						"RESDISP"
#define INIT_STR_TH							"THRESHOLD"
#define INIT_STR_DISPQ						"QUALITY"
#define INIT_STR_QMIN						"QMIN"
#define INIT_STR_MAXFEAT					"MAX_FEAT"
#define INIT_STR_MAXOBJ						"MAX_OBJ"

#define MVCOLOR_WHITE						PALETTERGB( 255, 255, 255 )
#define MVCOLOR_GREY						PALETTERGB( 127, 127, 127 )
#define MVCOLOR_BLACK						PALETTERGB( 0, 0, 0 )
#define MVCOLOR_RED							PALETTERGB( 255, 0, 0 )
#define MVCOLOR_GREEN						PALETTERGB( 0, 255, 0 )
#define MVCOLOR_BLUE						PALETTERGB( 0, 0, 255 )
#define MVCOLOR_YELLOW						PALETTERGB( 255, 255, 0 )
#define MVCOLOR_MAGENTA						PALETTERGB( 255, 0, 255 )
#define MVCOLOR_L_BLUE						PALETTERGB( 0, 255, 255 )

#define MAX_CHAR_SIZE						256
#define MSG_SIZE							80

#define MAX_OBJ_NB							10
#define MAX_FEAT_NB							10

#define MAX_QUALITY							100
#define DEFAULT_QUALITY						80

#define MAX_THRESHOLD						50
#define DEFAULT_THRESHOLD					30

#define RET_SUCCESS							0
#define RET_ERROR							-1

#define GMM_NO_MODE							0
#define GMM_FIND_MODE						1
#define GMM_TEACH_MODE						2
#define GMM_LABEL_MODE						3

#define GMM_DISPL_MATCH_TABLE				0
#define GMM_DISPL_TRIGS						1

//----------------------------------------------------------------------
//----------------------------------------------------------------------
typedef unsigned char				BYTE;

struct SStatusInfo
{
	pghandle wBox;
	pghandle wText;
	char *msg;
	int msg_len;
};

typedef struct SStatusInfo STATUS_INFO;

struct SSpinEdit
{
	pghandle wBox;
	SStatusInfo si;
	pghandle wBtnUp;
	pghandle wBtnDown;
	pghandle wLabel;
};

typedef struct SSpinEdit SPIN_EDIT;


//----------------------------------------------------------------------
//----------------------------------------------------------------------
void get_str_size( int *x, int *y, pghandle font, char *str );
int write2file( );

//----------------------------------------------------------------------
// tools.cpp
//----------------------------------------------------------------------
int gmm_get_ival( char *pname, FILE *fp, int min, int max, int defaultval );

//----------------------------------------------------------------------
// pgtools.cpp
//----------------------------------------------------------------------
void exit_demo( const char *s, long err_code );
pghandle mk_ctrl_btn( pghandle parent, char *txt, int pos, pgevthandler btn_cb, pghandle color );
pghandle mk_wBox( pghandle parent, int pat_pos, int side, int size );
pghandle mk_scroller( pghandle parent, int pos, int max_s, int def_s, pgevthandler scroll_cb );
pghandle mk_scroller_label( pghandle parent, int pos, char *txt );
pghandle mk_statline( pghandle parent, int pos, int size );
pghandle mk_btn( pghandle parent, char *txt, int pos, int size, pgevthandler btn_cb );
void widget_delete( pghandle *widget );
void mk_stll_si( pghandle parent, int pos, STATUS_INFO *si );
void cp_img( unsigned char *src, unsigned char *dst, int width, int height, int spitch, int dpitch );
void repl_txt_si( STATUS_INFO si );
void repl_txt( pghandle widget, char *text );
void set_w_color( pghandle widget, pghandle color );
void get_s_size( char *s, int *x, int *y );
int get_x_size( char *s );
int get_y_size( char *s );
pghandle mk_chb( pghandle parent, char *txt, pgevthandler chbox_cb );


SPIN_EDIT mk_spin_edit( pghandle parent, long value, char *label );
void set_se_val( SPIN_EDIT *se, int val );

void draw_circle( pgcontext gc, int x_cent, int y_cent, int r, pgcolor color );
void draw_line( pgcontext gc, int x1, int y1, int x2, int y2, pgcolor color );
void draw_txt( pgcontext gc, int x, int y, char *text, pgcolor color );
void draw_aoi( pgcontext gc, int x, int y, int w, int h, pgcolor color );
void draw_point( pgcontext gc, int x, int y, pgcolor color );

int mk_popup_menu( pghandle wMainCanvas, char *menu_entrys, unsigned int entry_cnt );

//----------------------------------------------------------------------
//----------------------------------------------------------------------
#endif	// __gmmtool_h__
