//----------------------------------------------------------------------
//----------------------------------------------------------------------
// MATRIX VISION GmbH
// mvIMPACT - mvBlueLYNX demo >>gmmtool<<
// Tue May 20 14:35:47 CEST 2003
//----------------------------------------------------------------------
//----------------------------------------------------------------------
#include <stdio.h>

#include "gmmtool.h"

//----------------------------------------------------------------------
//----------------------------------------------------------------------
int gmm_read_init( FILE *fp, char *key_name )
{
	dprintf((" ++ " TOOL_PREFIX ": gmm_read_init\n" ));

	int ret = -1;
	char buf[MAX_CHAR_SIZE];
	memset( buf, 0, MAX_CHAR_SIZE );

	if( fp != NULL )
	{
		dprintf((" == " TOOL_PREFIX ": gmm_read_init: >>%s\n", key_name ));

		rewind( fp );
		for(  ; fgets( buf, MAX_CHAR_SIZE, fp ) != NULL;  )

		{
			dprintf((" == " TOOL_PREFIX ": gmm_read_init: %s", buf ));
			if( strncmp( buf, key_name, strlen ( key_name )) == 0 )
			{
				ret = atoi( buf + strlen ( key_name ) + 1 );
				break;
			}
		}
	}
	else
		fprintf( stderr, "*** " TOOL_PREFIX ": gmm_read_init - no file opened!!\n");

	dprintf((" -- " TOOL_PREFIX ": gmm_read_init (%d)\n", ret ));
	return ret;
}

// -------------------------------------------------------------------------------------
int gmm_get_ival( char *pname, FILE *fp, int min, int max, int defaultval )
{
	dprintf((" ++ " TOOL_PREFIX ": gmm_get_ival\n" ));
	int ret = gmm_read_init( fp, pname );

	if( ret < min || ret > max )
	{
		fprintf( stderr, "*** " TOOL_PREFIX ": gmm_get_ival - wrong %s in init file! Set to %d from %d!!\n",
								pname, defaultval, ret );
		ret = defaultval;
	}

	dprintf((" -- " TOOL_PREFIX ": gmm_get_ival (%d)\n", ret ));
	return ret;
}

// -------------------------------------------------------------------------------------
int gmm_get_sval( char *pname, FILE *fp, char *dbuf )
{
	dprintf((" ++ " TOOL_PREFIX ": gmm_get_sval\n" ));
	int ret = -1;
	char buf[MAX_CHAR_SIZE];
	memset( buf, 0, MAX_CHAR_SIZE );

	if( fp != NULL )
	{
		dprintf((" == " TOOL_PREFIX ": gmm_get_sval - >%s<\n", pname ));

		rewind( fp );
		for(  ; fgets( buf, MAX_CHAR_SIZE, fp ) != NULL;  )
		{
			dprintf((" == " TOOL_PREFIX ": gmm_get_sval - %s", buf ));
			if( strncmp( buf, pname, strlen ( pname )) == 0 )
			{
				strncpy( dbuf, buf + strlen ( pname ) + 1, strlen( buf ) - strlen ( pname ) - 2 );
				dprintf((" == " TOOL_PREFIX ": gmm_get_sval - def_str: >%s<\n", dbuf ));
				ret = 0;
				break;
			}
		}
	}
	else
		fprintf( stderr, "*** " TOOL_PREFIX ": gmm_get_sval - no file opened!!\n");

	dprintf((" -- " TOOL_PREFIX ": gmm_get_sval (%d)\n", ret ));
	return ret;
}

//----------------------------------------------------------------------
//----------------------------------------------------------------------
