//-----------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------
/*! \file mk_msg.h
 *  \brief MATRIX VISION GmbH
 *
 * $Id: mk_msg.h,v 1.1 2004/10/20 08:18:19 td Exp $
 *
 *
 */

//-----------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------
#ifndef __mk_msg__
#define __mk_msg__

//-----------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------
#include <stdio.h>

//-----------------------------------------------------------------------------------
#define MK_PRINT_MSG_FLAG						0x01
#define MK_SYSLOG_MSG_FLAG						0x02

//-----------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------
#define ERROR_MSG( __prefix, __fmt )																\
	{																								\
		memset( db_args, 0, 200 );																	\
		if( __prefix )																				\
			sprintf( db_args, "%s: %s - (%s [%d])", __prefix, __FUNCTION__, __FILE__, __LINE__ );	\
		else																						\
			sprintf( db_args, "%s - (%s [%d])", __FUNCTION__, __FILE__, __LINE__ );					\
		make_error_msg __fmt;																		\
	}

//-------------------------------------------------------------
#define DEBUG_MSG( __flags, __prefix, __fmt )															\
	{																									\
		if( __flags )																					\
		{																								\
			memset( db_args, 0, 200 );																	\
			if( __prefix )																				\
				sprintf( db_args, "%s: %s - (%s [%d])", __prefix, __FUNCTION__, __FILE__, __LINE__ );	\
			else																						\
				sprintf( db_args, "%s - (%s [%d])", __FUNCTION__, __FILE__, __LINE__ );					\
			make_dbg_msg __fmt;																			\
		}																								\
	}

//-----------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------
#ifdef __cplusplus
extern "C"{
#endif

extern char db_args[200];

int make_message( int flag, const char *fmt, ... );
int make_dbg_msg( const char *fmt, ... );
int make_error_msg( const char *fmt, ... );

#ifdef __cplusplus
}
#endif

//-----------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------
#endif	// __mk_msg__
