#ifndef MVIMPACT_H_
#define MVIMPACT_H_

/// \file
///

#ifdef _MSC_VER	// is Microsoft compiler?
#	if _MSC_VER < 1300	// is 'old' VC 6 compiler?
#		pragma warning( disable : 4786 ) // 'identifier was truncated to '255' characters in the debug information'
#		define __FUNCTION__ "No function name information as the __FUNCTION__ macro is not supported by this(VC 6) compiler"
#	endif // _MSC_VER < 1300
#   if _MSC_VER >= 1400 // shut down VS security warnings
#		ifndef _CRT_SECURE_NO_WARNINGS
#			define _CRT_SECURE_NO_WARNINGS
#		endif
#   endif // _MSC_VER >= 1400
#endif // _MSC_VER
#ifdef _WIN32
#	if defined(__BORLANDC__)
#		pragma option push -b // force enums to the size of integer
#		define __FUNCTION__ "No function name information as the __FUNCTION__ macro is not supported by this(Borland) compiler"
#	endif
#endif // _WIN32

#ifdef SWIG
#	ifdef SWIGPYTHON
#		define WRAP_PYTHON
#	endif
#	ifdef SWIGJAVA
#		define WRAP_JAVA
#	endif
#endif

#ifdef WRAP_PYTHON
#	define PYTHON_ONLY(X) X
#	define PYTHON_CPP_SWITCH(PYTHON_WRAPPER_CODE,CPP_WRAPPER_CODE) PYTHON_WRAPPER_CODE
#	ifndef WRAP_ANY
#		define WRAP_ANY
#	endif // #	ifndef WRAP_ANY
#else // #ifdef WRAP_PYTHON
#	define PYTHON_ONLY(X)
#	define PYTHON_CPP_SWITCH(PYTHON_WRAPPER_CODE,CPP_WRAPPER_CODE) CPP_WRAPPER_CODE
#endif // #ifdef WRAP_PYTHON

#ifdef WRAP_DOTNET
#	define DOTNET_ONLY(X) X
#	define DOTNET_CPP_SWITCH(DOTNET_WRAPPER_CODE,CPP_WRAPPER_CODE) DOTNET_WRAPPER_CODE
#	ifndef WRAP_ANY
#		define WRAP_ANY
#	endif // #	ifndef WRAP_ANY
#else // #ifdef WRAP_DOTNET
#	define DOTNET_ONLY(X)
#	define DOTNET_CPP_SWITCH(DOTNET_WRAPPER_CODE,CPP_WRAPPER_CODE) CPP_WRAPPER_CODE
#endif // #ifdef WRAP_DOTNET

#if defined(__GNUC__) || (defined(SWIG) && !defined(PLATFORM_WIN32))
# define LINUX_ONLY(X) X
# define WINDOWS_ONLY(X)
# if !(defined(SWIG) || defined(PLATFORM_MVBL) || defined(PLATFORM_LINUX))
#  include <endian.h>
#  if __BYTE_ORDER == __BIG_ENDIAN
#   define PLATFORM_MVBL
#  endif
# endif
# ifdef PLATFORM_MVBL
#  define I386_LINUX_ONLY(X)
#  define PPC603E_LINUX_ONLY(X) X
# else
#  define I386_LINUX
#  define I386_LINUX_ONLY(X) X
#  define PPC603E_LINUX_ONLY(X)
# endif
#else
# define LINUX_ONLY(X)
# define I386_LINUX_ONLY(X)
# define PPC603E_LINUX_ONLY(X)
# define WINDOWS_ONLY(X) X
#endif

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_PYTHON


#include <memory>
#include <stdexcept>
#include <vector>
#include <string>
#include <iostream>
#include <sstream>
#include <iomanip>
#include <algorithm>
#include <math.h>
#include <assert.h>
#include <map>
#include <list>
#include <utility>
#include <cmath>

#ifndef M_PI
#	define M_PI       3.14159265358979323846
#endif // #ifndef M_PI


#endif // #ifndef WRAP_PYTHON
#endif // DOXYGEN_SHOULD_SKIP_THIS



#ifndef DOXYGEN_SHOULD_SKIP_THIS

#ifdef DEBUG_ON

#ifdef WRAP_PYTHON
// #ifndef WRAP_PYTHON does not understand this MSVC extension, so define
// it as empty:
#define __declspec(ARG1)
#endif // #ifdef WRAP_PYTHON

#include <UsageCounter.h>

#else // #ifdef DEBUG_ON

#define DECLARE_USAGE_COUNTER
#define DEFINE_USAGE_COUNTER(CLASS)
#define DEFINE_USAGE_COUNTER_EX(CLASS, CREATOR)
#define INC_USAGE_COUNTER
#define DEC_USAGE_COUNTER

#endif // #ifdef DEBUG_ON

#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS


#ifndef  DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_PYTHON


#include <vl_base.h>
#include <vl_ipl.h>
#include <vl_file.h>
#include <vl_slice.h>
#ifndef I386_LINUX
# include <vl_display.h>
#endif
#include <vl_autotrace.h>
#include <vl_device.h>


#endif // #ifndef WRAP_PYTHON
#endif // DOXYGEN_SHOULD_SKIP_THIS

//
// Expand proxy classes for reference properties
//

#define PROXY_CLASS_SIMPLE_DECL(name, type, base) \
class name##Proxy \
{ \
private: \
	base & base__; \
\
public: \
	name##Proxy(base & base_); \
	name##Proxy& operator=(type v); \
	operator type() const; \
};

#define PROXY_CLASS_SIMPLE_IMPL(name, type, base) \
\
inline base::name##Proxy::name##Proxy(base & base_) \
	: base__(base_) \
{ } \
\
inline base::name##Proxy& base::name##Proxy::operator=(type v) \
{ \
	base__.set##name(v); \
	return *this; \
} \
\
inline base::name##Proxy::operator type() const \
{ \
	return const_cast<const base &>(base__).get##name(); \
}


#define PROXY_CLASS_RGBCOLOR_DECL(name, type, base) \
class name##Proxy \
{ \
private: \
	base & base__; \
\
public: \
	name##Proxy(base & base_); \
	name##Proxy& operator=(const type & v); \
	unsigned char getRed() const; \
	name##Proxy& setRed(unsigned char red); \
	unsigned char getGreen() const; \
	name##Proxy& setGreen(unsigned char red); \
	unsigned char getBlue() const; \
	name##Proxy& setBlue(unsigned char red); \
	unsigned char getAlpha() const; \
	name##Proxy& setAlpha(unsigned char red); \
	operator type() const; \
};

#define PROXY_CLASS_RGBCOLOR_IMPL(name, type, base) \
\
inline base::name##Proxy::name##Proxy(base & base_) \
	: base__(base_) \
{ } \
\
inline base::name##Proxy& base::name##Proxy::operator=(const type & v) \
{ \
	base__.set##name(v); \
	return *this; \
} \
\
inline unsigned char base::name##Proxy::getRed() const \
{ \
	return const_cast<const base &>(base__).get##name().getRed(); \
} \
\
inline base::name##Proxy& base::name##Proxy::setRed(unsigned char red) \
{ \
	base__.set##name(const_cast<const base &>(base__).get##name().setRed(red)); \
	return *this; \
} \
\
inline unsigned char base::name##Proxy::getGreen() const \
{ \
	return const_cast<const base &>(base__).get##name().getGreen(); \
} \
\
inline base::name##Proxy& base::name##Proxy::setGreen(unsigned char green) \
{ \
	base__.set##name(const_cast<const base &>(base__).get##name().setGreen(green)); \
	return *this; \
} \
\
inline unsigned char base::name##Proxy::getBlue() const \
{ \
	return const_cast<const base &>(base__).get##name().getBlue(); \
} \
\
inline base::name##Proxy& base::name##Proxy::setBlue(unsigned char blue) \
{ \
	base__.set##name(const_cast<const base &>(base__).get##name().setBlue(blue)); \
	return *this; \
} \
\
inline unsigned char base::name##Proxy::getAlpha() const \
{ \
	return const_cast<const base &>(base__).get##name().getAlpha(); \
} \
\
inline base::name##Proxy& base::name##Proxy::setAlpha(unsigned char alpha) \
{ \
	base__.set##name(const_cast<const base &>(base__).get##name().setAlpha(alpha)); \
	return *this; \
} \
\
inline base::name##Proxy::operator type() const \
{ \
	return const_cast<const base &>(base__).get##name(); \
}


#define PROXY_CLASS_RECTANGLE_DECL(name, type, base) \
class name##Proxy \
{ \
private: \
	base & base__; \
\
public: \
	name##Proxy(base & base_); \
	name##Proxy& operator=(const type & v); \
	int getLeft() const; \
	name##Proxy& setLeft(int left); \
	int getRight() const; \
	name##Proxy& setRight(int right); \
	int getTop() const; \
	name##Proxy& setTop(int top); \
	int getBottom() const; \
	name##Proxy& setBottom(int bottom); \
	int getWidth() const; \
	int getHeight() const; \
	operator type() const; \
};

#define PROXY_CLASS_RECTANGLE_IMPL(name, type, base) \
\
inline base::name##Proxy::name##Proxy(base & base_) \
	: base__(base_) \
{ } \
\
inline base::name##Proxy& base::name##Proxy::operator=(const type & v) \
{ \
	base__.set##name(v); \
	return *this; \
} \
\
inline int base::name##Proxy::getLeft() const \
{ \
	return const_cast<const base &>(base__).get##name().getLeft(); \
} \
\
inline base::name##Proxy& base::name##Proxy::setLeft(int left) \
{ \
	base__.set##name(const_cast<const base &>(base__).get##name().setLeft(left)); \
	return *this; \
} \
\
inline int base::name##Proxy::getRight() const \
{ \
	return const_cast<const base &>(base__).get##name().getRight(); \
} \
\
inline base::name##Proxy& base::name##Proxy::setRight(int right) \
{ \
	base__.set##name(const_cast<const base &>(base__).get##name().setRight(right)); \
	return *this; \
} \
\
inline int base::name##Proxy::getTop() const \
{ \
	return const_cast<const base &>(base__).get##name().getTop(); \
} \
\
inline base::name##Proxy& base::name##Proxy::setTop(int top) \
{ \
	base__.set##name(const_cast<const base &>(base__).get##name().setTop(top)); \
	return *this; \
} \
\
inline int base::name##Proxy::getBottom() const \
{ \
	return const_cast<const base &>(base__).get##name().getBottom(); \
} \
\
inline base::name##Proxy& base::name##Proxy::setBottom(int bottom) \
{ \
	base__.set##name(const_cast<const base &>(base__).get##name().setBottom(bottom)); \
	return *this; \
} \
\
inline int base::name##Proxy::getWidth() const \
{ \
	return const_cast<const base &>(base__).get##name().getWidth(); \
} \
\
inline int base::name##Proxy::getHeight() const \
{ \
	return const_cast<const base &>(base__).get##name().getHeight(); \
} \
\
inline base::name##Proxy::operator type() const \
{ \
	return const_cast<const base &>(base__).get##name(); \
}


#define PROXY_CLASS_LINE_DECL(name, type, base) \
class name##Proxy \
{ \
private: \
	base & base__; \
\
public: \
	name##Proxy(base & base_); \
	name##Proxy& operator=(const type & v); \
	Point getP0() const; \
	name##Proxy& setP0(const Point & p0); \
	Point getP1() const; \
	name##Proxy& setP1(const Point & p1); \
	operator type() const; \
};

#define PROXY_CLASS_LINE_IMPL(name, type, base) \
\
inline base::name##Proxy::name##Proxy(base & base_) \
	: base__(base_) \
{ } \
\
inline base::name##Proxy& base::name##Proxy::operator=(const type & v) \
{ \
	base__.set##name(v); \
	return *this; \
} \
\
inline Point base::name##Proxy::getP0() const \
{ \
	return const_cast<const base &>(base__).get##name().getP0(); \
} \
\
inline base::name##Proxy& base::name##Proxy::setP0(const Point & p0) \
{ \
	base__.set##name(const_cast<const base &>(base__).get##name().setP0(p0)); \
	return *this; \
} \
\
inline Point base::name##Proxy::getP1() const \
{ \
	return const_cast<const base &>(base__).get##name().getP1(); \
} \
\
inline base::name##Proxy& base::name##Proxy::setP1(const Point & p1) \
{ \
	base__.set##name(const_cast<const base &>(base__).get##name().setP1(p1)); \
	return *this; \
} \
\
inline base::name##Proxy::operator type() const \
{ \
	return const_cast<const base &>(base__).get##name(); \
}


#define PROXY_CLASS_POINT_DECL(name, type, base) \
class name##Proxy \
{ \
private: \
	base & base__; \
\
public: \
	name##Proxy(base & base_); \
	name##Proxy& operator=(const type & v); \
	int getX() const; \
	name##Proxy& setX(int x); \
	int getY() const; \
	name##Proxy& setY(int y); \
	operator type() const; \
};

#define PROXY_CLASS_POINT_IMPL(name, type, base) \
\
inline base::name##Proxy::name##Proxy(base & base_) \
	: base__(base_) \
{ } \
\
inline base::name##Proxy& base::name##Proxy::operator=(const type & v) \
{ \
	base__.set##name(v); \
	return *this; \
} \
\
inline int base::name##Proxy::getX() const \
{ \
	return const_cast<const base &>(base__).get##name().getX(); \
} \
\
inline base::name##Proxy& base::name##Proxy::setX(int x) \
{ \
	base__.set##name(const_cast<const base &>(base__).get##name().setX(x)); \
	return *this; \
} \
\
inline int base::name##Proxy::getY() const \
{ \
	return const_cast<const base &>(base__).get##name().getY(); \
} \
\
inline base::name##Proxy& base::name##Proxy::setY(int y) \
{ \
	base__.set##name(const_cast<const base &>(base__).get##name().setY(y)); \
	return *this; \
} \
\
inline base::name##Proxy::operator type() const \
{ \
	return const_cast<const base &>(base__).get##name(); \
}


#define PROXY_CLASS_CALIBRATOR_DECL(name, type, base) \
class name##Proxy \
{ \
private: \
	base & base__; \
	\
public: \
	name##Proxy(base & base_); \
	name##Proxy& operator=(const type & v); \
	std::string getUnit() const; \
	name##Proxy& setUnit(const std::string& unit); \
	int getPower() const; \
	name##Proxy& setPower(int power); \
	double getOffset() const; \
	name##Proxy& setOffset(double offset); \
	operator type() const; \
};

#define PROXY_CLASS_CALIBRATOR_IMPL(name, type, base) \
\
inline base::name##Proxy::name##Proxy(base & base_) \
	: base__(base_) \
{ } \
\
inline base::name##Proxy& base::name##Proxy::operator=(const type & v) \
{ \
	base__.set##name(v); \
	return *this; \
} \
\
inline std::string base::name##Proxy::getUnit() const \
{ \
	return const_cast<const base &>(base__).get##name().getUnit(); \
} \
\
inline base::name##Proxy& base::name##Proxy::setUnit(const std::string& unit) \
{ \
	base__.set##name(const_cast<const base &>(base__).get##name().setUnit(unit)); \
	return *this; \
} \
\
inline int base::name##Proxy::getPower() const \
{ \
	return const_cast<const base &>(base__).get##name().getPower(); \
} \
	\
inline base::name##Proxy& base::name##Proxy::setPower(int power) \
{ \
	base__.set##name(const_cast<const base &>(base__).get##name().setPower(power)); \
	return *this; \
} \
\
inline double base::name##Proxy::getOffset() const \
{ \
	return const_cast<const base &>(base__).get##name().getOffset(); \
} \
\
inline base::name##Proxy& base::name##Proxy::setOffset(double offset) \
{ \
	base__.set##name(const_cast<const base &>(base__).get##name().setOffset(offset)); \
	return *this; \
} \
\
inline base::name##Proxy::operator type() const \
{ \
	return const_cast<const base &>(base__).get##name(); \
}


/// \namespace mvIMPACT This is the main namespace that contains all functions and classes from mvIMPACT Base as well as other namespaces for the standard and extended modules.
namespace mvIMPACT {


/// \brief The datatype enumeration.

/// Buffers may have different datatypes. This enumeration lists the possible datatypes.
/// \note Not all functions support all datatypes. A function will generate an error if a
/// \note datatype is not supported.
enum BufferDatatype
{
	/// No valid datatype.
	bdNone = mvIMPACT_C::IPL_DTNONE,
	/// Signed 8 bit datatype.
	bdChar = mvIMPACT_C::IPL_DTCHAR,
	/// Unsigned 8 bit datatype.
	bdUChar = mvIMPACT_C::IPL_DTUCHAR,
	/// Signed 16 bit datatpye.
	bdShort = mvIMPACT_C::IPL_DTSHORT,
	/// Unsigned 16 bit datatype.
	bdUShort = mvIMPACT_C::IPL_DTUSHORT,
	/// Signed 32 bit datatype.
	bdLong = mvIMPACT_C::IPL_DTLONG,
	/// Unsigned 32 bit datatype.
	bdULong = mvIMPACT_C::IPL_DTULONG,
	/// 32 bit float.
	bdFloat = mvIMPACT_C::IPL_DTFLOAT,
	/// 64 bit double.
	bdDouble = mvIMPACT_C::IPL_DTDOUBLE,
};



/// \brief The BufferAttribute enumeration. This specifies buffer types.

/// Buffers may have different attributes. This enumeration lists the possible attributes.
/// The different attributes reflect the different buffer types in mvIMPACT Base.
/// \note Not all functions support all attributes. A function will generate an error if an
/// \note attribute is not supported.
/// \see mvIMPACT::BufferBase::getAttribute
enum BufferAttribute
{
	/// Not allocated.
	baNone = mvIMPACT_C::IPL_NOTALLOCATED,
	/// Image buffer.
	baImage = mvIMPACT_C::IPL_IMAGEBUF,
	/// Lut (Palette) buffer.
	baLut = mvIMPACT_C::IPL_LUTBUF,
	/// Histogram buffer.
	baHistogram = mvIMPACT_C::IPL_HISTBUF,
	/// Profile buffer.
	baProfile = mvIMPACT_C::IPL_PROFBUF,
	/// Kernel buffer.
	baKernel = mvIMPACT_C::IPL_KERNELBUF,
	/// Structuring element buffer.
	baStructuringElement = mvIMPACT_C::IPL_STRUCTBUF,
	/// Result buffer.
	baResult = mvIMPACT_C::IPL_RESULTBUF,
	/// Point buffer.
	baPoint = mvIMPACT_C::IPL_POINTBUF,
	/// Line buffer.
	baLine = mvIMPACT_C::IPL_LINEBUF,
	/// Polygon buffer.
	baPolygon = mvIMPACT_C::IPL_POLYGONBUF,
	/// Run length encoded buffer.
	baRle = mvIMPACT_C::IPL_RLEBUF,
	/// Bayer mosaic buffer.
	baBayerMosaic = mvIMPACT_C::IPL_BAYERMOSAICBUF,
};



/// \brief The DimensionSpec enumeration. Specifies the dimensions a buffer can have.

/// Some functions affect a single dimension of a multidimensional buffer. These
/// flags allow you to specify this dimension.
enum DimensionSpec
{
	/// Specifies the x dimension.
	dsDimX = mvIMPACT_C::IPL_DIM_X,
	/// Specifies the y dimension.
	dsDimY = mvIMPACT_C::IPL_DIM_Y,
	/// Specifies the band dimension.
	dsDimB = mvIMPACT_C::IPL_DIM_BANDS,
	/// Specifies the z dimension (slices).
	dsDimZ = mvIMPACT_C::IPL_DIM_Z,
	/// Specifies the time dimension (frames).
	dsDimTime = mvIMPACT_C::IPL_DIM_TIME
};



/// \brief Location specifier.Specifies the location of temporary data.

/// The mvIMPACT::BufferBase::freeDim function may need a lot of temporary memory.
/// These flags specify whether to keep the temporary data in main memory or on disk.
/// \see mvIMPACT::BufferBase::freeDim
enum LocationSpec
{
	/// Specifies main memory (RAM).
	lsMemory = mvIMPACT_C::IPL_LOC_MEMORY,
	/// Specifies memory on disk.
	lsDisk = mvIMPACT_C::IPL_LOC_DISK,
};




/// \brief Geometric interpolation mode.

/// Geometric transformation functions support different interpolation methods
/// for increased accuracy.
/// \see mvIMPACT::matrix
/// \see mvIMPACT::scale
enum GeometricInterpolation
{
	/// Specifies nearest neighbor interpolation.
	giNearestNeighbor = mvIMPACT_C::IPL_NEAREST_NEIGHBOR,
	/// Specifies bilinear interpolation.
	giBilinear = mvIMPACT_C::IPL_BILINEAR,
//	/// Specifies bicubic interpolation.
//	giBicubic = mvIMPACT_C::IPL_BICUBIC
};


/// \brief Preset structururing element.

enum KernelClippingMode {
    /// clipping will be disabled. Any overflow will be truncated
    kcmClipDisable = mvIMPACT_C::IPL_CLIP_DISABLE,

    /// the absolute value of the result is taken
    kcmAbsolute = mvIMPACT_C::IPL_ABSOLUTE,

    /// a saturation is performed on the result. A result that
    /// overflows or underflows
    /// will be set to the maximum or minimum that can be
    /// represented in the
    /// destination buffer
    kcmSaturate = mvIMPACT_C::IPL_SATURATE,

    /// first takes the absolute value (first operation) and after
    /// this the result will be saturated. A result that overflows
    /// or underflows will be set to the maximum or minimum that can
    /// be represented in the destination buffer
    kcmAbsoluteSaturate = mvIMPACT_C::IPL_ABSOLUTE_SATURATE
};

/// \brief Mode for handling image border for operations using mvIMPACT::Kernel and mvIMPACT::StructuringElement.
enum OverscanMode {
	/// No overscan processing takes place which leads to unprocessed rows and
	/// columns at the image border. Depending on the kernel size the number of
	/// unprocessed rows and columns varies.
	omOverscanDisable = mvIMPACT_C::IPL_OVERSCAN_DISABLE,

	/// Enables overscan processing at the image border. A mirror type
	/// conversion of the source buffer border pixels will be performed and the
	/// subsequent operation takes these values for processing. If the source buffer
	/// of the subsequent operation is a child buffer, the function tries to get the
	/// overscan pixels from its parent buffer. If this is not possible, a mirror
	/// type conversion will be performed.
	omOverscanTransparent = mvIMPACT_C::IPL_OVERSCAN_TRANS,

	/// Enables overscan processing at the image border.
	/// The source buffer border pixels are set to a constant value.
	/// This value can be set with Kernel::setOverscanConstValue() or
	/// StructuringElement::setOverscanConstValue() respectively.
	omOverscanReplace = mvIMPACT_C::IPL_CTLID_OVERSCAN_REPLACE
};


/// \brief Color spaces
enum ColorSpace {
		/// Unknown color space.
		csUnknown = mvIMPACT_C::COL_UNKNOWN,
		/// Cyan, Magenta, Yellow color space.
		csCMY = mvIMPACT_C::COL_CMY,
		/// Monochrome color space.
		csGray = mvIMPACT_C::COL_GRAY,
		/// Hue, Luminance, Saturation color space.
		csHLS = mvIMPACT_C::COL_HLS,
		/// Hue, Saturation, Value color space.
		csHSV = mvIMPACT_C::COL_HSV,
		/// Red, Green Blue color space.
		csRGB = mvIMPACT_C::COL_RGB,
		/// XYZ 601 color space.
		csXYZ601 = mvIMPACT_C::COL_XYZ601,
		/// XYZ 709 color space.
		csXYZ709 = mvIMPACT_C::COL_XYZ709,
		/// XYZ ITU color space.
		csXYZITU = mvIMPACT_C::COL_XYZITU,
		/// YCC 601 color space.
		csYCC601 = mvIMPACT_C::COL_YCC601,
		/// YIQ color space.
		csYIQ = mvIMPACT_C::COL_YIQ,
		/// YUV color space.
		csYUV = mvIMPACT_C::COL_YUV,
		/// BAYER MOSAIC color space
		csBayerMosaic = mvIMPACT_C::COL_BAYER_MOSAIC,
};

/// \brief Neighborhood mode used for searching

///  When searching for adjacent contour pixels the tracer can work in a
/// 4- or 8-neighborhood mode.
/// \see mvIMPACT::Tracer::setNeighborhoodMode
enum NeighborhoodMode
{
  /// The left, right, up and down neighbors are used.
  nm4Connected = ATR_4_CONNECTED,
  /// All eight neighbors of a contour pixel are used.
  nm8Connected = ATR_8_CONNECTED
};

#ifndef I386_LINUX

/// \brief The drawing style of a point of interest.
enum PointDrawingStyle
{
	/// The point is drawn as a small cross of a specific size.
	pdsSmallCross = mvIMPACT_C::DISP_POI_CROSS,
	/// The point is drawn as a large cross.
	pdsLargeCross = mvIMPACT_C::DISP_POI_RUBBER_CROSS,
};


/// \brief The drawing style of a dragging handle.
enum HandleDrawingStyle
{
	/// The handle is not drawn at all.
	hdsNone = mvIMPACT_C::DISP_NO_HANDLE,
	/// The handle is drawn as a sqare.
	hdsSquare = mvIMPACT_C::DISP_SQUARE_HANDLE,
	/// The handle is drawn as a circle.
	hdsCircle = mvIMPACT_C::DISP_CIRCULAR_HANDLE,
};
#endif	// I386_LINUX



#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY

/// "ONLY USED INTERNALLY"
/// utility class to provide automatic memory management for
/// an dynamic allocated array
template< class T, class O = T>
class DynArray
{
public:
	/// create a non-allocated object
	DynArray();

	/// copy data from a std::vector of type O
	DynArray(const std::vector<O> &os);

	/// copy data from an array \a o of size \a size of type O
	DynArray(const O* o, size_t size);

	/// depending on \a doCopy: copy data of array \a t of type T, if \a doCopy is true
	/// or "take over" array and free it on destruction.
	DynArray(T* t, size_t size, bool doCopy);

	/// create uninitialized array of size \a size
	DynArray(size_t size);

	/// create initialized array of size \a size
	DynArray(size_t size, T t);

	/// return pointer to the encapsulated array
	T* getPointer()  const;

	/// return pointer to the encapsulated array
	T* getPointer();

	operator const T*() const;

	operator T*();

	/// destruct the object
	~DynArray();

	/// copy construct the array: a deep copy is done
	DynArray(const DynArray& src);

	/// assign another array. The buffer is destroyed and the
	/// new buffer is copied
	DynArray& operator=(const DynArray& src);

	/// create a vector of same size as the array and type O, copy the
	/// array data into it and return the resulting vector
	std::vector<O> asVector();

	/// return the size of the array
	size_t getSize() const;

	/// copy data from a std::vector of type O
	void allocate(const std::vector<O> &os);

	/// copy data from an array \a o of size \a size of type O
	void allocate(const O* o, size_t size);

	/// depending on \a doCopy: copy data of array \a t of type T, if \a doCopy is true
	/// or "take over" array and free it on destruction.
	void allocate(T* t, size_t size, bool doCopy);

	/// create uninitialized array of size \a size
	void allocate(size_t size);

	/// create initialized array of size \a size
	void allocate(size_t size, T t);

private:
	/// free memory and turn object back in non-allocated state
	void dispose();

	/// dumb copy
	void copy(const DynArray& src);

	T* m_array;
	size_t m_size;
};

/// "ONLY USED INTERNALLY"
class MyBufferAccess
{
public:
	MyBufferAccess();

	void init(mvIMPACT_C::IPL_BUFHANDLE handle, int band, int slice, int frame, int width, int height, int bands, int slices, int frames, BufferDatatype datatype, bool hasWriteAccess);

	void dispose();

	~MyBufferAccess();

	bool getHasAnyPointer() const;

	bool getHasPointer(int band, int frame, int slice) const;
	bool getHasPointer() const;

	unsigned char* getPointer(int band, int frame, int slice) const;
	unsigned char* getPointer() const;

	void releasePointer(int band, int frame, int slice);
	void releaseAllPointers();

	int getPitch() const;

	int getCurrentBand() const;
	int getCurrentSlice() const;
	int getCurrentFrame() const;

	int getPixel(int x, int y, int band, int slice, int frame) const;
	void setPixel(int x, int y, int band, int slice, int frame, int value);

	int getHasWriteAccess() const;

	bool getIsValid() const;
private:
	typedef  int (*GetPixelFunc)(const MyBufferAccess*, int, int, int, int, int);
	static int getPixelChar(const MyBufferAccess* t, int x, int y, int band, int slice, int frame);
	static int getPixelUChar(const MyBufferAccess* t, int x, int y, int band, int slice, int frame);
	static int getPixelShort(const MyBufferAccess* t, int x, int y, int band, int slice, int frame);
	static int getPixelUShort(const MyBufferAccess* t, int x, int y, int band, int slice, int frame);
	static int getPixelLong(const MyBufferAccess* t, int x, int y, int band, int slice, int frame);
	static int getPixelULong(const MyBufferAccess* t, int x, int y, int band, int slice, int frame);
	static int getPixelFloat(const MyBufferAccess* t, int x, int y, int band, int slice, int frame);
	static int getPixelDouble(const MyBufferAccess* t, int x, int y, int band, int slice, int frame);
	static int getPixelNone(const MyBufferAccess* t, int x, int y, int band, int slice, int frame);

	typedef void (*SetPixelFunc)(MyBufferAccess*, int, int, int, int, int, int);
	static void setPixelChar(MyBufferAccess* t, int x, int y, int band, int slice, int frame, int value);
	static void setPixelUChar(MyBufferAccess* t, int x, int y, int band, int slice, int frame, int value);
	static void setPixelShort(MyBufferAccess* t, int x, int y, int band, int slice, int frame, int value);
	static void setPixelUShort(MyBufferAccess* t, int x, int y, int band, int slice, int frame, int value);
	static void setPixelLong(MyBufferAccess* t, int x, int y, int band, int slice, int frame, int value);
	static void setPixelULong(MyBufferAccess* t, int x, int y, int band, int slice, int frame, int value);
	static void setPixelFloat(MyBufferAccess* t, int x, int y, int band, int slice, int frame, int value);
	static void setPixelDouble(MyBufferAccess* t, int x, int y, int band, int slice, int frame, int value);
	static void setPixelNone(MyBufferAccess* t, int x, int y, int band, int slice, int frame, int value);

private:
	// never need to copy an object of this class, so make copy constructor and
	// assignment operator private and not implemented.
	MyBufferAccess(const MyBufferAccess & src);
	MyBufferAccess& operator=(const MyBufferAccess& src);

	int m_width;
	int m_height;
	int m_bands;
	int m_slices;
	int m_frames;

	int m_currentBand;
	int m_currentSlice;
	int m_currentFrame;

	bool m_isValid;


	bool m_hasWriteAccess;

	std::vector<mvIMPACT_C::IPL_UCHAR*> m_pointers;
	std::vector<int> m_planeIndexStack;
	mvIMPACT_C::IPL_LONG m_pitch;

	GetPixelFunc m_getPixelFunc;
	SetPixelFunc m_setPixelFunc;

	mvIMPACT_C::IPL_BUFHANDLE m_handle;
};

#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

#ifndef WRAP_ANY

/// \brief The base class for all mvIMPACT-SDK exceptions.
///
/// All exceptions thrown by the mvIMPACT-SDK are objects of this class.
///
/// You can get the error string by calling \c getErrorString(),
/// the spot where the error occurred by calling \c getErrorOrigin(),
/// and the error code by calling \c getErrorCode().
///
/// \htmlinclude cpp_doc_start.html
/// \note Since the ImpactException is derived from the C++ standard exception class
/// \note std::runtime_error, you can also use its what() method to retrieve
/// \note the error string.
/// \htmlinclude specific_doc_end.html
/// \htmlinclude code_fragment_start_cpp.html
/// For example, code like this:
/// \code
/// 	try {
/// 	   ... // lots of cool mvIMPACT functions
/// 	}
/// 	catch(ImpactException& e) {
/// 	   std::cerr <<  e.getErrorOrigin() << " : " << e.getErrorString() << std::endl;
/// 	}
/// \endcode
/// could print something like:<br/>
/// 	<i> Module 'Color' : Invalid number of bands </i>
/// \htmlinclude code_fragment_end.html
/// \xmlonly
/// <mvWrapperDoc>
/// <htmlinclude ref="code_fragment_start_python.html"/>
/// In Python, you can also just 'print' the exception.
/// For example, this code:
/// \code
/// 	from mvIMPACT.base import *
/// 	from mvIMPACT.ocr import *
///
/// 	segmentList = SegmentList(16)
/// 	try:
/// 	    segmentList.setSize(-2)
/// 	except ImpactException, e:
/// 	    print e
/// \endcode
/// would print:<br/>
/// 	<i> Size &lt; 0 </i>
/// <htmlinclude ref="code_fragment_end.html"/>
/// </mvWrapperDoc>
/// \endxmlonly
//-----------------------------------------------------------------------------
class ImpactException : public std::runtime_error
//-----------------------------------------------------------------------------
{
public:
	/// \brief Construct an ImpactException.
	explicit ImpactException(
		/// The error number from the mvIMPACT C Layer.
		int errorCode);

	/// \brief Construct an ImpactException. Deprecated: member \c m_origin will be empty.
	explicit ImpactException(
		/// The error string.
		const std::string& errorString,
		/// The error number from the mvIMPACT C Layer, if any.
		int errorCode = 0 );

	/// \brief Construct an ImpactException.
	explicit ImpactException(
		/// The error string.
		const std::string& errorString,
		/// The error origin.
		const std::string& errorOrigin,
		/// The error number from the mvIMPACT C Layer, if any.
		int errorCode = 0 );

	// must define a dtor to prevent the error:
	//  'looser throw specifier for ?virtual mvIMPACT::ImpactException::~ImpactException()?
	//  overriding ?virtual std::runtime_error::~runtime_error() throw ()?'
	~ImpactException() throw () {}

	/// \brief Get the error string of the exception.
	std::string getErrorString() const;

	/// \brief Get the origin of the exception, i.e. the class and/or function from where it was thrown.
	std::string getErrorOrigin() const;

	/// \brief Get the error code of the exception.
	int getErrorCode() const;
	int getError() const; // to be backwards compatible

	/// \brief Get the error code of the exception as the original enum string.
	///
	/// Where \c getErrorCode() would return, for instance, -1707,
	/// \c getErrorCodeAsString() would return "GMM_IMAGE_TOO_SMALL".
	virtual std::string getErrorCodeAsString() const;

private:
	/// The spot where the error occurred.
	/// This string preferably contains the namespace/module, class and function.
	const std::string m_origin;
	/// The error id (0 if not applicable (error is not in vl_base\\errorstrings.cpp)).
	const int m_error;
};
#endif // #ifndef WRAP_ANY

#define throwImpactException(errorString) throw ImpactException(errorString, __FUNCTION__)

/// \brief Matrix with variable dimensions.

/// If the data is accessed linearly (i.e. via an array or a vector),
/// row major order is used, i.e. the first elements of the linear data structure
/// are the elements of the first row.
//----------------------------------------------------------------------------
class MatrixDouble
//----------------------------------------------------------------------------
{
public:
#ifndef WRAP_PYTHON // The wrapper code needs a default constructor. The user not.
        /// \brief Default constructor.
	MatrixDouble();
#endif

	/// \brief Construct a new matrix with width \a w and height \a h.
	MatrixDouble(
			/// width of the matrix
   			/// \xmlonly
			/// <mvParamRange>
   			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
   			/// </mvParamRange>
   			/// \endxmlonly
			int width,
		    /// height of the matrix
   			/// \xmlonly
			/// <mvParamRange>
   			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
   			/// </mvParamRange>
   			/// \endxmlonly
			int height);



	/// \brief Construct a new matrix from a vector, which must have \a w * \a h elements:

	/// The order in the vector is row major, i.e. the first elements in the vector are the
	/// elements of the first row.
	MatrixDouble(
			/// width of the matrix
   			/// \xmlonly
			/// <mvParamRange>
   			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
   			/// </mvParamRange>
   			/// \endxmlonly
			int width,
		    /// height of the matrix
   			/// \xmlonly
			/// <mvParamRange>
   			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
   			/// </mvParamRange>
   			/// \endxmlonly
			int height,
		    /// the data of the matrix (row major order)
		    const std::vector<double> & PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, data));

#ifndef WRAP_PYTHON

	/// \brief Construct a new matrix from a C-Array (by copying)

	/// The order in the array is row major, i.e. the first elements in the array are the
	/// elements of the first row.
	MatrixDouble(
			/// width of the matrix
   			/// \xmlonly
			/// <mvParamRange>
   			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
   			/// </mvParamRange>
   			/// \endxmlonly
			int width,
		    /// height of the matrix
   			/// \xmlonly
			/// <mvParamRange>
   			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
   			/// </mvParamRange>
   			/// \endxmlonly
			int height,
		    /// the data of the matrix (row major order)
		    const double* data);
#endif

	/// \brief Destructor.
	~MatrixDouble();

#ifndef WRAP_ANY
	/// \brief Access the matrix elements linearly.

	/// E.g. a 3x3 matrix has 9 elements.Thus \a index has a valid range from 0 to
	/// (mvIMPACT::MatrixDouble::getHeight * mvIMPACT::MatrixDouble::getWidth) -1.
	/// \exception On boundary violation an exception is thrown.
	/// \see mvIMPACT::MatrixDouble::getWidth
	/// \see mvIMPACT::MatrixDouble::getHeight
	double& operator [] (/// the index of the element
			     int index ) const;
#endif

	/// \brief Set a cell in the matrix.

	/// \exception On boundary violation an exception is thrown.
	/// \see mvIMPACT::MatrixDouble::getWidth
	/// \see mvIMPACT::MatrixDouble::getHeight
	MatrixDouble& set (
				/// the row of the cell (range: 0 to mvIMPACT::MatrixDouble::getHeight -1)
				/// \xmlonly
	   			/// <mvParamRange>
	   			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
				/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
	   			/// </mvParamRange>
 	   			/// \endxmlonly
			   int row,
			   	/// the column of the cell (range: 0 to mvIMPACT::MatrixDouble::getWidth -1)
				/// \xmlonly
	   			/// <mvParamRange>
	   			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
				/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
	   			/// </mvParamRange>
 	   			/// \endxmlonly
			   int col,
			   /// the value to be set
			   double val);



	/// \brief Get a cell in the matrix.

	/// Returns the value of the cell.
	/// \exception On boundary violation an exception is thrown.
	/// \see mvIMPACT::MatrixDouble::getWidth
	/// \see mvIMPACT::MatrixDouble::getHeight
	double get(
			/// the row of the cell (range: 0 to mvIMPACT::MatrixDouble::getHeight -1)
			/// \xmlonly
	   		/// <mvParamRange>
	   		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	   		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
	   		/// </mvParamRange>
 	   		/// \endxmlonly
		   int row,
		   	/// the column of the cell (range: 0 to mvIMPACT::MatrixDouble::getWidth -1)
	   		/// \xmlonly
	   		/// <mvParamRange>
	   		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	   		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
	   		/// </mvParamRange>
 	   		/// \endxmlonly
		   int col) const;




	/// \brief Get a pointer to the internal representation of the matrix.

	/// The matrix is stored as a linear memory block containing
	/// row*column elements.
	/// The order in the array is row major, i.e. the first elements in the array are the
	/// elements of the first row.
	double* data();

#ifndef WRAP_ANY
	/// \brief Get a pointer to the internal representation of the matrix.

	/// The matrix is stored as a linear memory block containing
	/// row*column elements.
	/// The order in the array is row major, i.e. the first elements in the array are the
	/// elements of the first row.
	const double* data() const;
#endif // #ifndef WRAP_ANY

	/// \brief Return the width of the matrix.
	int getWidth() const;

	/// \brief Return the height of the matrix.
	int getHeight() const;

	/// \brief Return a textual representation of the matrix.

	/// Returns the values stored in the matrix. Each row is seperated with a newline.
	char* toString() const;


	/// \brief Construct a DoubleMatrix from \a src.
	MatrixDouble(/// the other matrix
		     const MatrixDouble& src);

#ifndef WRAP_ANY
	/// \brief Overwrite current object with \a src.
	MatrixDouble& operator=(/// the other matrix
				const MatrixDouble& src);
#endif // #ifndef WRAP_ANY

private:
	void dispose();
	void copy(const MatrixDouble& m);

	double*  m_pData;
	int m_iWidth;
	int m_iHeight;
};


/// \brief Class for window handles.

/// This window handle can also refer to a window handle under
/// other supported operating systems (mvBlueLYNX for example)
class WindowHandle
{
private:
	mvIMPACT_C::IPL_HWND m_handle;

public:

#ifndef DOXYGEN_SHOULD_SKIP_THIS
	/// Constructor needed by the DOTNET wrapper, initializes
	/// m_handle to NULL.
	WindowHandle();
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

	/// Construct a WindowHandle from an int.
	WindowHandle(int handle);

#ifndef WRAP_ANY
	/// Construct a WindowHandle from a portable window handle.
	WindowHandle(mvIMPACT_C::IPL_HWND handle);

	/// Convert the handle to a portable window handle.
	operator mvIMPACT_C::IPL_HWND() const;

	/// Convert the handle into an int.
	operator int() const;

	/// Convert to a portable window handle.
	mvIMPACT_C::IPL_HWND ConvertToWindowHandle() const;

	// 64bit support makes sense for 64bit capable compilers only
#ifdef _M_X64
	/// Convert to an integer (64 bit).
	long long ConvertToInteger64() const;
#endif // #ifdef _M_X64

#endif // #ifndef WRAP_ANY

	/// Convert to an integer.
	int ConvertToInteger() const;
};

/// \brief Represents a RGB color

/// RGB is the standard subtractive color space, where each pixel is coded with a red,
/// green and blue value. This class also supports the alpha channel, which is used to
/// encode opacity information.
//-----------------------------------------------------------------------------
class RGBColor
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a black color.
    RGBColor ();

    /// \brief Constructs a color from a 32bit value.
	///
    /// The RGB color parts are coded into this value like this: 0xAABBGGRR.
    RGBColor (
		/// the 32bit value with the encoded color information
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamConst value="4294967295"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int color);

	/// \brief Constructs a color with the RGB value \a red, \a green, \a blue, and optionally an alpha part \a alpha.
	///
	/// The default value for the alpha value \a alpha is 0.
	///
	// \internal
	// If you change the default initializations, you have to
	// change them in base.i as well in the tuple to class conversion !
	RGBColor (
		/// the red value
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamConst value="255"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		unsigned char red,
		/// the green value
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamConst value="255"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		unsigned char green,
		/// the blue value
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamConst value="255"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		unsigned char blue,
		/// the alpha value
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamConst value="255"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		unsigned char alpha = 0);


	/// \brief Return the red part of the color.
	///
	/// \see mvIMPACT::RGBColor::setRed
	/// \see mvIMPACT::RGBColor::getGreen
	/// \see mvIMPACT::RGBColor::getBlue
	/// \see mvIMPACT::RGBColor::getAlpha
	unsigned char getRed() const;

#ifndef WRAP_ANY
	/// \brief Return the red part of the color.
	///
	/// \see mvIMPACT::RGBColor::setRed
	/// \see mvIMPACT::RGBColor::getGreen
	/// \see mvIMPACT::RGBColor::getBlue
	/// \see mvIMPACT::RGBColor::getAlpha
	unsigned char & getRed();
#endif // #ifndef WRAP_ANY

    /// \brief Set the red part of the color.
    ///
    /// \see mvIMPACT::RGBColor::getRed
    /// \see mvIMPACT::RGBColor::setGreen
    /// \see mvIMPACT::RGBColor::setBlue
    /// \see mvIMPACT::RGBColor::setRGB
    RGBColor& setRed(
		/// the new value for the red channel
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamConst value="255"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		unsigned char red);


	/// \brief Return the green part of the color.
	///
	/// \see mvIMPACT::RGBColor::setGreen
	/// \see mvIMPACT::RGBColor::getRed
	/// \see mvIMPACT::RGBColor::getBlue
	/// \see mvIMPACT::RGBColor::getAlpha
	unsigned char getGreen() const;

#ifndef WRAP_ANY
	/// \brief Return the green part of the color.
	///
	/// \see mvIMPACT::RGBColor::setGreen
	/// \see mvIMPACT::RGBColor::getRed
	/// \see mvIMPACT::RGBColor::getBlue
	/// \see mvIMPACT::RGBColor::getAlpha
	unsigned char & getGreen();
#endif // #ifndef WRAP_ANY

	/// \brief Set the green part of the color.
	///
	/// \see mvIMPACT::RGBColor::getGreen
	/// \see mvIMPACT::RGBColor::setRed
	/// \see mvIMPACT::RGBColor::setBlue
	/// \see mvIMPACT::RGBColor::setRGB
	RGBColor& setGreen(
		/// the new value for the green channel
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamConst value="255"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		unsigned char green);


    /// \brief Return the blue part of the color.
    ///
    /// \see mvIMPACT::RGBColor::setBlue
    /// \see mvIMPACT::RGBColor::getGreen
    /// \see mvIMPACT::RGBColor::getRed
    /// \see mvIMPACT::RGBColor::getAlpha
    unsigned char getBlue() const;

#ifndef WRAP_ANY
	/// \brief Return the blue part of the color.
	///
	/// \see mvIMPACT::RGBColor::setBlue
	/// \see mvIMPACT::RGBColor::getGreen
	/// \see mvIMPACT::RGBColor::getRed
	/// \see mvIMPACT::RGBColor::getAlpha
	unsigned char & getBlue();
#endif // #ifndef WRAP_ANY

    /// \brief Set the blue part of the color.
    ///
    /// \see mvIMPACT::RGBColor::getBlue
    /// \see mvIMPACT::RGBColor::setRed
    /// \see mvIMPACT::RGBColor::setGreen
    /// \see mvIMPACT::RGBColor::setRGB
    RGBColor& setBlue(
		/// the new value  for the blue channel
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamConst value="255"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		unsigned char blue);


	/// \brief Return the alpha part of the color.
	///
	/// \see mvIMPACT::RGBColor::setAlpha
	/// \see mvIMPACT::RGBColor::getGreen
	/// \see mvIMPACT::RGBColor::getBlue
	/// \see mvIMPACT::RGBColor::getRed
	unsigned char getAlpha() const;

#ifndef WRAP_ANY
	/// \brief Return the alpha part of the color.
	///
	/// \see mvIMPACT::RGBColor::setAlpha
	/// \see mvIMPACT::RGBColor::getGreen
	/// \see mvIMPACT::RGBColor::getBlue
	/// \see mvIMPACT::RGBColor::getRed
	unsigned char & getAlpha();
#endif // #ifndef WRAP_ANY

    /// \brief Set the alpha part of the color.
    ///
    /// \see mvIMPACT::RGBColor::getAlpha
    /// \see mvIMPACT::RGBColor::setRed
    /// \see mvIMPACT::RGBColor::setGreen
    /// \see mvIMPACT::RGBColor::setBlue
    /// \see mvIMPACT::RGBColor::setRGB
    RGBColor& setAlpha(
		/// the new value for the alpha channel
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamConst value="255"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		unsigned char alpha);


#ifndef WRAP_DOTNET // this cannot be wrapped because of the set prefix
    /// \brief Set the RGB color
	/// 
    /// The default value for the alpha channel \a alpha is 0.
    /// \see mvIMPACT::RGBColor::setRed
    /// \see mvIMPACT::RGBColor::setGreen
    /// \see mvIMPACT::RGBColor::setBlue
    /// \see mvIMPACT::RGBColor::setAlpha
    RGBColor& setRGB (
		/// the red value
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamConst value="255"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
  		unsigned char red,
		/// the green value
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamConst value="255"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		unsigned char green,
		/// the blue value
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamConst value="255"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		unsigned char blue,
		/// the alpha value
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamConst value="255"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		unsigned char alpha = 0);
#endif


    /// \brief Return a 32bit value that represents the color.
	///
    /// The value has the following
    /// structure:
    /// windows (little endian) : 0xAABBGGRR.
    /// mvBL (big endian) : 0xAARRGGBB
    ///
    /// \see mvIMPACT::RGBColor::fromDWord
    int asDWord () const;

    /// \brief Sets the color from a 32bit value that represents the color.
	///
    /// The value has the following
    /// structure:
    /// windows (little endian) : 0xAABBGGRR.
    /// mvBL (big endian) : 0xAARRGGBB
    ///
    /// \see mvIMPACT::RGBColor::asDWord
    /// \see mvIMPACT::RGBColor::setRGB
    void fromDWord (
    		/// the color information coded in a 32bit value
			/// \xmlonly
			/// <mvParamRange>
	   		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	   		/// <mvParamMax><mvParamConst value="4294967295"/></mvParamMax>
	   		/// </mvParamRange>
 	   		/// \endxmlonly
		    int color);


#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
	 operator mvIMPACT_C::IPL_COLOR() const;
#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
    unsigned char m_r;
    unsigned char m_g;
    unsigned char m_b;
    unsigned char m_a;
};

/// \brief A point object in the euclidean plane that stores it's x/y coordinates as double values.
///
/// Since the x and y coordinates are floating point, the position of the PointDouble
/// is unlimited and can be anywhere in the euclidean plane (in all four quadrants).
//-----------------------------------------------------------------------------
class PointDouble
//-----------------------------------------------------------------------------
{
public:
  /// \brief Construct a PointDouble.
  /// The default coordinates are (0/0)
   // \internal
   // If you change the default initializations, you have to
   // change them in base.i as well in the tuple to class conversion !
  PointDouble(/// the desired x-coordinate
	      double x=0.0,
	      /// the desired y-coordinate
	      double y=0.0 );

  /// \brief Compare if two PointDouble contain the same data
  bool operator== (/// the second point
		   const PointDouble& second) const;

  /// \brief Compare is two PointDouble contain different data
  bool operator!=(/// the second point
		  const PointDouble& second) const;

  /// \brief Get the x-coordinate of a PointDouble object
  ///
  /// \see mvIMPACT::PointDouble::setX
  /// \see mvIMPACT::PointDouble::getY
  double getX() const;

#ifndef WRAP_ANY
  /// \brief Get the x-coordinate of a PointDouble object
  ///
  /// \see mvIMPACT::PointDouble::setX
  /// \see mvIMPACT::PointDouble::getY
  double & getX();
#endif // #ifndef WRAP_ANY

  /// \brief Set the x-coordinate of a PointDouble object
  ///
  /// \see mvIMPACT::PointDouble::setY
  /// \see mvIMPACT::PointDouble::getX
  PointDouble&  setX(/// the new x-coordinate
		     double x);


  /// \brief Get the y-coordinate of a PointDouble object
  ///
  /// \see mvIMPACT::PointDouble::setY
  /// \see mvIMPACT::PointDouble::getX
  double getY() const;

#ifndef WRAP_ANY
  /// \brief Get the y-coordinate of a PointDouble object
  ///
  /// \see mvIMPACT::PointDouble::setY
  /// \see mvIMPACT::PointDouble::getX
  double & getY();
#endif // #ifndef WRAP_ANY

  /// \brief Set the y-coordinate of a PointDouble object
  ///
  /// \see mvIMPACT::PointDouble::setX
  /// \see mvIMPACT::PointDouble::getY
  PointDouble& setY(/// the new y-coordinate
		    double y);


#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
	operator const mvIMPACT_C::IPL_POINT_DOUBLE() const;
	PointDouble(const mvIMPACT_C::IPL_POINT_DOUBLE &p);
#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
	/// The point's x coordinate (horizontal cartesian coordinate).
	double m_x;
	/// The point's y coordinate (vertical cartesian coordinate).
	double m_y;
};


/// \brief A point object in the 3D euclidean space that stores it's x/y/z coordinates as double values.

/// Since the x, y and z coordinates are floating point, the position of the Point3DDouble
/// is unlimited and can be anywhere in the euclidean space.
class Point3DDouble
{
public:
/// \brief Construct a Point3DDouble.
///
/// The default coordinates are (0,0,0)
 // \internal
 // If you change the default initializations, you have to
 // change them in base.i as well in the tuple to class conversion !
Point3DDouble(double x=0.0, double y=0.0, double z=0.0);

/// \brief Get the x-coordinate of a Point3DDouble object
///
/// \see mvIMPACT::Point3DDouble::setX
/// \see mvIMPACT::Point3DDouble::getY
/// \see mvIMPACT::Point3DDouble::getZ
double getX() const;

#ifndef WRAP_ANY
/// \brief Get the x-coordinate of a Point3DDouble object
///
/// \see mvIMPACT::Point3DDouble::setX
/// \see mvIMPACT::Point3DDouble::getY
/// \see mvIMPACT::Point3DDouble::getZ
double & getX();
#endif // #ifndef WRAP_ANY

/// \brief Set the x-coordinate of a Point3DDouble object
///
/// \see mvIMPACT::Point3DDouble::setY
/// \see mvIMPACT::Point3DDouble::setZ
/// \see mvIMPACT::Point3DDouble::getX
Point3DDouble& setX(double x);


/// \brief Get the y-coordinate of a Point3DDouble object
///
/// \see mvIMPACT::Point3DDouble::setY
/// \see mvIMPACT::Point3DDouble::getX
/// \see mvIMPACT::Point3DDouble::getZ
double getY() const;

#ifndef WRAP_ANY
/// \brief Get the y-coordinate of a Point3DDouble object
///
/// \see mvIMPACT::Point3DDouble::setY
/// \see mvIMPACT::Point3DDouble::getX
/// \see mvIMPACT::Point3DDouble::getZ
double & getY();
#endif // #ifndef WRAP_ANY

/// \brief Set the x-coordinate of a Point3DDouble object
///
/// \see mvIMPACT::Point3DDouble::setX
/// \see mvIMPACT::Point3DDouble::setZ
/// \see mvIMPACT::Point3DDouble::getY
Point3DDouble& setY(double y);

/// \brief Get the z-coordinate of a Point3DDouble object
///
/// \see mvIMPACT::Point3DDouble::setZ
/// \see mvIMPACT::Point3DDouble::getX
/// \see mvIMPACT::Point3DDouble::getY
double getZ() const;

#ifndef WRAP_ANY
/// \brief Get the z-coordinate of a Point3DDouble object
///
/// \see mvIMPACT::Point3DDouble::setZ
/// \see mvIMPACT::Point3DDouble::getX
/// \see mvIMPACT::Point3DDouble::getY
double & getZ();
#endif // #ifndef WRAP_ANY

/// \brief Set the x-coordinate of a Point3DDouble object
///
/// \see mvIMPACT::Point3DDouble::setX
/// \see mvIMPACT::Point3DDouble::setY
/// \see mvIMPACT::Point3DDouble::getZ
Point3DDouble& setZ(double z);

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
	operator const mvIMPACT_C::IPL_POINT3D_DOUBLE() const;
	Point3DDouble(const mvIMPACT_C::IPL_POINT3D_DOUBLE &p);
#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
	double m_x;
	double m_y;
	double m_z;
};

/// \brief A line object in the euclidean plane that stores it's x/y coordinates as
/// \brief double values.
///
/// \see mvIMPACT::PointDouble
//-----------------------------------------------------------------------------
class LineDouble
//-----------------------------------------------------------------------------
{
 public:


  /// \brief Construct an empty LineDouble object.
  LineDouble();


  /// \brief Construct a LineDouble object between two points

  /// The two points are given with their coordinates
  LineDouble (/// x-coordinate of the first point
	      double x0,
	      /// y-coordinate of the first point
	      double y0,
	      /// x-coordinate of the second point
	      double x1,
	      /// y-coordinate of the second point
	      double y1);



  /// \brief Construct a LineDouble object between two points

  /// The two points are specified by the two mvIMPACT::PointDouble objects
  LineDouble (/// the first point
	      PointDouble p0,
	      /// the second point
	      PointDouble p1);


  /// \brief Retrieve the first point of the line.
  ///
  /// Returns a mvIMPACT::PointDouble object, that represents the first point of the line
  /// \see mvIMPACT::LineDouble::setP0
  /// \see mvIMPACT::LineDouble::getP1
  PointDouble getP0() const;

#ifndef WRAP_ANY
  /// \brief Retrieve the first point of the line.
  ///
  /// Returns a mvIMPACT::PointDouble object, that represents the first point of the line
  /// \see mvIMPACT::LineDouble::setP0
  /// \see mvIMPACT::LineDouble::getP1
  PointDouble & getP0();
#endif // #ifndef WRAP_ANY

  /// \brief Set the first point of the line
  ///
  /// \see mvIMPACT::LineDouble::getP0
  /// \see mvIMPACT::LineDouble::setP1
  LineDouble& setP0(/// the mvIMPACT::PointDouble object, that represents the first point of the line
		    PointDouble p0);


  /// \brief Retrieve the second point of the line
  ///
  /// Returns a mvIMPACT::PointDouble object, that represents the second point of the line
  /// \see mvIMPACT::LineDouble::setP1
  /// \see mvIMPACT::LineDouble::getP0
  PointDouble getP1() const;

#ifndef WRAP_ANY
  /// \brief Retrieve the second point of the line
  ///
  /// Returns a mvIMPACT::PointDouble object, that represents the second point of the line
  /// \see mvIMPACT::LineDouble::setP1
  /// \see mvIMPACT::LineDouble::getP0
  PointDouble & getP1();
#endif // #ifndef WRAP_ANY

  /// \brief Set the second point of the line
  ///
  /// \see mvIMPACT::LineDouble::setP0
  /// \see mvIMPACT::LineDouble::getP1
  LineDouble& setP1(/// the mvIMPACT::PointDouble object, that represents the second point of the line
		    PointDouble p1);

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
  operator mvIMPACT_C::IPL_LINE_DOUBLE() const;
  LineDouble(const mvIMPACT_C::IPL_LINE_DOUBLE & l);
#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  PointDouble m_p0;
  PointDouble m_p1;
};

/// \brief A point object in the euclidean plane that stores it's x/y coordinates as
/// \brief integer values.

/// A mvIMPACT::Point object is used to create for example mvIMPACT:Line
/// \see mvIMPACT::Line
//-----------------------------------------------------------------------------
class Point
//-----------------------------------------------------------------------------
{
 public:

  /// \brief Construct a zero-initialized Point.

  /// The default coordinates are (0/0)
   // \internal
   // If you change the default initializations, you have to
   // change them in base.i as well in the tuple to class conversion !
  Point(/// the x-coordinate of the the point
	int x=0,
	/// the y-coordinate of the point
	int y=0 );



  /// \brief Compare if two points contain the same data
  bool operator== (/// the second mvIMPACT::Point  object
		   const Point& second) const;



  /// \brief Compare if two points contain different data
  bool operator!=(/// the other mvIMPACT::Point object
		  const Point second) const;


  /// \brief Retrieve the x-coordinate of the point
  ///
  /// \see mvIMPACT::Point::setX
  /// \see mvIMPACT::Point::getY
  int getX() const;

#ifndef WRAP_ANY
  /// \brief Retrieve the x-coordinate of the point
  ///
  /// \see mvIMPACT::Point::setX
  /// \see mvIMPACT::Point::getY
  int & getX();
#endif // #ifndef WRAP_ANY

  /// \brief Set the x-coordinate of the point
  ///
  /// \see mvIMPACT::Point::getX
  /// \see mvIMPACT::Point::setY
  Point& setX(/// the new x-coordinate of the point
	      int x);


  /// \brief Retrieve the y-coordinate of the point
  ///
  /// \see mvIMPACT::Point::setY
  /// \see mvIMPACT::Point::getX
  int getY() const;

#ifndef WRAP_ANY
  /// \brief Retrieve the y-coordinate of the point
  ///
  /// \see mvIMPACT::Point::setY
  /// \see mvIMPACT::Point::getX
  int & getY();
#endif // #ifndef WRAP_ANY

  /// \brief Set the y-coordinate of the point
  ///
  /// \see mvIMPACT::Point::getY
  /// \see mvIMPACT::Point::setX
  Point& setY(/// the new y-coordinate of the point
	      int y);


#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
	operator const mvIMPACT_C::IPL_POINT() const;

	Point(const mvIMPACT_C::IPL_POINT &p);
#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
	/// The point's x coordinate (horizontal cartesian coordinate).
	int m_x;
	/// The point's y coordinate (vertical cartesian coordinate).
	int m_y;
};


/// \brief A Size object in the euclidean plane that stores it's width and height
/// \brief coordinates as integer values.

/// This class is used to represent dimension sizes.
/// \see mvIMPACT::datamatrix::DatamatrixResults
//-----------------------------------------------------------------------------
class Size
//-----------------------------------------------------------------------------
{
 public:


  /// \brief Construct a Size with a given width and height.
   // \internal
   // If you change the default initializations, you have to
   // change them in base.i as well in the tuple to class conversion !
  Size
    (
     /// Width.
     int width=0,
     /// Height.
     int height=0
     );


  /// \brief Retrieve the width of the mvIMPACT::Size object
  int getWidth() const;

#ifndef WRAP_ANY
  /// \brief Retrieve the width of the mvIMPACT::Size object
  int & getWidth();
#endif // #ifndef WRAP_ANY

  /// \brief Set the width of the mvIMPACT::Size object
  Size& setWidth(
	  /// the new width
	  int width);


  /// \brief Retrieve the height of the mvIMPACT::Size object
  int getHeight() const;

#ifndef WRAP_ANY
  /// \brief Retrieve the height of the mvIMPACT::Size object
  int & getHeight();
#endif // #ifndef WRAP_ANY

  /// \brief Set the height of the mvIMPACT::Size object
  Size& setHeight(
	  /// the new height
	  int height);


 private:
  /// Width.
  int m_width;
  /// Height.
  int m_height;
};



/// \brief A Line object in the euclidean plane that stores it's x/y coordinates as int values.

/// \see mvIMPACT::Point
//-----------------------------------------------------------------------------
class Line
//-----------------------------------------------------------------------------
{
public:
	/// \brief Construct a line from (0,0) to (0,0).
	Line();


	/// \brief Construct a line from (\c x1,\c y1) to (\c x2,\c y2).
	Line
	(
		/// x coordinate of start point.
		int x0,
		/// y coordinate of start point.
		int y0,
		/// x coordinate of end point.
		int x1,
		/// y coordinate of end point.
		int y1
		);

	/// \brief Construct a line from \c p0 to \c p1.
	Line
	(
		/// Start point of the line.
		const Point& p0,
		/// End point of the line.
		const Point& p1
		);


	/// \brief Check if two lines are equal.
	bool operator== (/// the second line
			 const Line& l) const;


	/// \brief Check if two lines are not equal.
	bool operator!= (/// the other line
			 const Line& l) const;



	/// \brief Retrieve the first point of the line
	///
	/// Returns a mvIMPACT::Point object that represents the first point of the line.
	/// \see mvIMPACT::Line::setP0
	/// \see mvIMPACT::Line::getP1
	Point getP0() const;

#ifndef WRAP_ANY
	/// \brief Retrieve the first point of the line
	///
	/// Returns a mvIMPACT::Point object that represents the first point of the line.
	/// \see mvIMPACT::Line::setP0
	/// \see mvIMPACT::Line::getP1
	Point & getP0();
#endif // #ifndef WRAP_ANY

	/// \brief Set the first point of the line
	///
	/// \see mvIMPACT::Line::getP0
	/// \see mvIMPACT::Line::setP1
	Line& setP0(
		/// a mvIMPACT::Point object that represents the first point of the line
		const Point &p0);


	/// \brief Retrieve the second point of the line
	///
	/// Returns a mvIMPACT::Point object that represents the second point of the line.
	/// \see mvIMPACT::Line::setP1
	/// \see mvIMPACT::Line::getP0
	Point getP1() const;

#ifndef WRAP_ANY
	/// \brief Retrieve the second point of the line
	///
	/// Returns a mvIMPACT::Point object that represents the second point of the line.
	/// \see mvIMPACT::Line::setP1
	/// \see mvIMPACT::Line::getP0
	Point & getP1();
#endif // #ifndef WRAP_ANY

	/// \brief Set the secondd point of the line
	///
	/// \see mvIMPACT::Line::setP0
	/// \see mvIMPACT::Line::getP1
	Line& setP1(
		/// a mvIMPACT::Point object that represents the second point of the line
		const Point &p1);

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
	operator mvIMPACT_C::IPL_LINE() const;
	Line(const mvIMPACT_C::IPL_LINE & r);
#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
	/// Start point of the line.
	Point m_p0;
	/// End point of the line.
	Point m_p1;
};


/// \brief A Rectangle object in the euclidean plane that stores it's x/y coordinates
/// as int values.
///
/// This class is used whenever an operation is performed on a rectangular area.
/// A mvIMPACT::Rectangle is defined by two mvIMPACT::Point objects. These points represent
/// the top-left corner and the bottom-right corner.
//-----------------------------------------------------------------------------
class Rectangle
//-----------------------------------------------------------------------------
{
public:

	/// \brief Retrieve the x-coordinate of the rectangles's top-left corner
	///
	/// A mvIMPACT::Rectangle is defined by two mvIMPACT::Point objects. These points represent
	/// the top-left corner and the bottom-right corner.
	/// \see mvIMPACT::Rectangle::setLeft
	/// \see mvIMPACT::Rectangle::getTop
	/// \see mvIMPACT::Rectangle::getRight
	/// \see mvIMPACT::Rectangle::getBottom
	int getLeft() const;

#ifndef WRAP_ANY
	/// \brief Retrieve the x-coordinate of the rectangles's top-left corner
	///
	/// A mvIMPACT::Rectangle is defined by two mvIMPACT::Point objects. These points represent
	/// the top-left corner and the bottom-right corner.
	/// \see mvIMPACT::Rectangle::setLeft
	/// \see mvIMPACT::Rectangle::getTop
	/// \see mvIMPACT::Rectangle::getRight
	/// \see mvIMPACT::Rectangle::getBottom
	int & getLeft();
#endif // #ifndef WRAP_ANY

	/// \brief Set the x-coordinate of the top-left corner
	///
	/// A mvIMPACT::Rectangle is defined by two mvIMPACT::Point objects. These points represent
	/// the top-left corner and the bottom-right corner.
	/// \see mvIMPACT::Rectangle::getLeft
	/// \see mvIMPACT::Rectangle::setTop
	/// \see mvIMPACT::Rectangle::setRight
	/// \see mvIMPACT::Rectangle::setBottom
	Rectangle& setLeft(
		/// the new x-coordinate of the rectangle's top-left corner
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.right"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int left);


	/// \brief Retrieve the x-coordinate of the rectangles's bottom-right corner
	///
	/// A mvIMPACT::Rectangle is defined by two mvIMPACT::Point objects. These points represent
	/// the top-left corner and the bottom-right corner.
	/// \see mvIMPACT::Rectangle::setRight
	/// \see mvIMPACT::Rectangle::getTop
	/// \see mvIMPACT::Rectangle::getLeft
	/// \see mvIMPACT::Rectangle::getBottom
	int getRight() const;

#ifndef WRAP_ANY
	/// \brief Retrieve the x-coordinate of the rectangles's bottom-right corner
	///
	/// A mvIMPACT::Rectangle is defined by two mvIMPACT::Point objects. These points represent
	/// the top-left corner and the bottom-right corner.
	/// \see mvIMPACT::Rectangle::setRight
	/// \see mvIMPACT::Rectangle::getTop
	/// \see mvIMPACT::Rectangle::getLeft
	/// \see mvIMPACT::Rectangle::getBottom
	int & getRight();
#endif // #ifndef WRAP_ANY

	/// \brief Set the x-coordinate of the rectangle's bottom-right corner
	///
	/// A mvIMPACT::Rectangle is defined by two mvIMPACT::Point objects. These points represent
	/// the top-left corner and the bottom-right corner.
	/// \see mvIMPACT::Rectangle::getRight
	/// \see mvIMPACT::Rectangle::setTop
	/// \see mvIMPACT::Rectangle::setLeft
	/// \see mvIMPACT::Rectangle::setBottom
	Rectangle& setRight(
		/// the new x-coordinate of the rectangle's bottom-right corner
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="%(instance)s.left"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int right);


	/// \brief Retrieve the y-coordinate of the rectangles's top-left corner
	///
	/// A mvIMPACT::Rectangle is defined by two mvIMPACT::Point objects. These points represent
	/// the top-left corner and the bottom-right corner.
	/// \see mvIMPACT::Rectangle::setTop
	/// \see mvIMPACT::Rectangle::getRight
	/// \see mvIMPACT::Rectangle::getLeft
	/// \see mvIMPACT::Rectangle::getBottom
	int getTop() const;

#ifndef WRAP_ANY
	/// \brief Retrieve the y-coordinate of the rectangles's top-left corner
	///
	/// A mvIMPACT::Rectangle is defined by two mvIMPACT::Point objects. These points represent
	/// the top-left corner and the bottom-right corner.
	/// \see mvIMPACT::Rectangle::setTop
	/// \see mvIMPACT::Rectangle::getRight
	/// \see mvIMPACT::Rectangle::getLeft
	/// \see mvIMPACT::Rectangle::getBottom
	int & getTop();
#endif // #ifndef WRAP_ANY

	/// \brief Set the y-coordinate of the top-left corner
	///
	/// A mvIMPACT::Rectangle is defined by two mvIMPACT::Point objects. These points represent
	/// the top-left corner and the bottom-right corner.
	/// \see mvIMPACT::Rectangle::getTop
	/// \see mvIMPACT::Rectangle::setRight
	/// \see mvIMPACT::Rectangle::setLeft
	/// \see mvIMPACT::Rectangle::setBottom
	Rectangle& setTop(
		/// the new y-coordinate of the rectangle's top-left corner
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bottom"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int top);


	/// \brief Retrieve the y-coordinate of the rectangles's bottom-right corner
	///
	/// A mvIMPACT::Rectangle is defined by two mvIMPACT::Point objects. These points represent
	/// the top-left corner and the bottom-right corner.
	/// \see mvIMPACT::Rectangle::setBottom
	/// \see mvIMPACT::Rectangle::getTop
	/// \see mvIMPACT::Rectangle::getRight
	/// \see mvIMPACT::Rectangle::getLeft
	int getBottom() const;

#ifndef WRAP_ANY
	/// \brief Retrieve the y-coordinate of the rectangles's bottom-right corner
	///
	/// A mvIMPACT::Rectangle is defined by two mvIMPACT::Point objects. These points represent
	/// the top-left corner and the bottom-right corner.
	/// \see mvIMPACT::Rectangle::setBottom
	/// \see mvIMPACT::Rectangle::getTop
	/// \see mvIMPACT::Rectangle::getRight
	/// \see mvIMPACT::Rectangle::getLeft
	int & getBottom();
#endif // #ifndef WRAP_ANY

	/// \brief Set the y-coordinate of the rectangles's bottom-right corner
	///
	/// A mvIMPACT::Rectangle is defined by two mvIMPACT::Point objects. These points represent
	/// the top-left corner and the bottom-right corner.
	/// \see mvIMPACT::Rectangle::getBottom
	/// \see mvIMPACT::Rectangle::setTop
	/// \see mvIMPACT::Rectangle::setRight
	/// \see mvIMPACT::Rectangle::setLeft
	Rectangle& setBottom(
		/// the new y-coordinate of the rectangle's bottom-right corner
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="%(instance)s.top"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int bottom);


	/// \brief Construct an undefined rectangle. All coordinates are set to zero.
	Rectangle();

	/// \brief Construct a Rectangle from four coordinates.
	///
	/// The coordinates \a left and \a top specifiy the top-left corner of the rectangle.
	/// The parameters \a right and \a bottom specify bottom-right corner of the rectangle.
	/// \see mvIMPACT::Rectangle::setBottom
	/// \see mvIMPACT::Rectangle::setTop
	/// \see mvIMPACT::Rectangle::setRight
	/// \see mvIMPACT::Rectangle::setLeft
	Rectangle(
		/// the x-coordinate of the rectangle's top-left corner
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMax><mvParamComplex Python="%(right)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int left,
		/// the y-coordinate of the rectangle's top-left corner
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMax><mvParamComplex Python="%(bottom)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int top,
		/// the x-coordinate of the rectangle's bottom-right corner
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="%(left)s"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int right,
		/// the y-coordinate of the rectangle's bottom-right corner
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="%(top)s"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int bottom );

	/// \brief Construct a mvIPACT::Rectangle from two mvIMPACT::Point objects.
	///
	/// Parameters \a p0 specifies the top-left corner of the rectangle, parameter \a p1
	/// specifies the bottom-right corner.
	/// \see mvIMPACT::Rectangle::setBottom
	/// \see mvIMPACT::Rectangle::setTop
	/// \see mvIMPACT::Rectangle::setRight
	/// \see mvIMPACT::Rectangle::setLeft
	Rectangle(
  		/// mvIMPACT::Point object that specifies the rectangle's  top-left corner
	    const Point& p0,
	    /// mvIMPACT::Point object that  specifies the rectangle's bottom-right corner
	    const Point& p1 );


	/// \brief Return the width of this rectangle.
	///
	/// Returns mvIMPACT::Rectangle::getRight - mvIMPACT::Rectangle::getLeft + 1
	int getWidth() const;


	/// \brief Return the height of this rectangle.
	///
	/// Returns mvIMPACT::Rectangle::getBottom - mvIMPACT::Rectangle::getTop + 1
	int getHeight() const;


	/// \brief Check if two mvIMPACT::Rectangle objects are equal.
	bool operator== (
		/// the second rectangle
		const Rectangle& second) const;


	/// \brief Check if two mvIMPACT::Rectangles are not equal.
	bool operator!= (
		/// the second rectangle
		const Rectangle& second) const;

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
	  operator mvIMPACT_C::IPL_RECT() const;
	  Rectangle(const mvIMPACT_C::IPL_RECT & r);
#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
	/// Left x coordinate.
	int m_left;

	/// Right x coordinate.
	int m_right;

	/// Top y coordinate.
	int m_top;

	/// Bottom y coordinate.
	int m_bottom;
};

/// \brief A Calibrator object contains Calibrator information for one dimension
/// \brief of a BufferBase.

/// This class keeps calibration information as used with the calibration properties. It
/// contains fields for the unit, the power,the offset and the number of values.
//-----------------------------------------------------------------------------
class Calibrator
//-----------------------------------------------------------------------------
{
	DECLARE_USAGE_COUNTER

	PROXY_CLASS_SIMPLE_DECL(Unit, std::string, Calibrator)
	PROXY_CLASS_SIMPLE_DECL(Power, int, Calibrator)

	friend class BufferBase;

private:
	/// The contained IPL_CALIBRATE structure.
	mvIMPACT_C::IPL_CALIBRATE* m_;

public:


	/// \brief Get the unit string.
	///
	/// Returns the string specifying a SI-unit, can be an arbitrary string.
	/// \see mvIMPACT::Calibrator::setUnit
	std::string getUnit() const;

#ifndef WRAP_ANY
	/// \brief Get the unit string.
	///
	/// Returns the string specifying a SI-unit, can be an arbitrary string.
	/// \see mvIMPACT::Calibrator::setUnit
	UnitProxy getUnit();
#endif // #ifndef WRAP_ANY

	/// \brief Set the unit string.
	///
	/// This specifies the unit that is used. An arbitrary string can be set.
	/// \see mvIMPACT::Calibrator::getUnit
	Calibrator& setUnit(
		/// the new unit string
		const std::string& unit);


	/// \brief Get the exponent of the unit.
	///
	/// Returns the exponent of the unit. 3 would mean kilo, -3 would mean milli, etc.
	/// \see mvIMPACT::Calibrator::setPower
	int getPower() const;

#ifndef WRAP_ANY
	/// \brief Get the exponent of the unit.
	///
	/// Returns the exponent of the unit. 3 would mean kilo, -3 would mean milli, etc.
	/// \see mvIMPACT::Calibrator::setPower
	PowerProxy getPower();
#endif // #ifndef WRAP_ANY

	/// \brief Set a new exponent for the unit.
	///
	/// 3 would mean kilo, -3 would mean milli, etc.
	/// \see mvIMPACT::Calibrator::getPower
	Calibrator& setPower(
		/// the new exponent
		int power);


	/// \brief Returns the offset.
	double getOffset() const;

#ifndef WRAP_ANY
	/// \brief Returns the offset.
	double & getOffset();
#endif // #ifndef WRAP_ANY

	/// \brief Set the offset.
	Calibrator& setOffset(
		/// the new offset value
		double offset);


	/// \brief Access the size of the calibration buffer (read only).
	int getSize() const;

	/// \brief Retrieve a calibration value
	///
	/// Retrieve a calibration value at a spcific index.
	double getValue(
			/// index of the calibration value
			/// \xmlonly
			/// <mvParamRange>
	   		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	   		/// <mvParamMax><mvParamComplex Python="%(instance)s.size-1"/></mvParamMax>
	   		/// </mvParamRange>
 	   		/// \endxmlonly
			int index) const;

	/// \brief Set a calibration value
	///
	/// Set \c value as calibration value at index \c index .
	Calibrator& setValue(
				/// the index of the calibration value to set
				/// \xmlonly
				/// <mvParamRange>
	   			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	   			/// <mvParamMax><mvParamComplex Python="%(instance)s.size-1"/></mvParamMax>
		   		/// </mvParamRange>
 		   		/// \endxmlonly
			    int index,
			    /// the new calibration value
			    double value);

#ifndef WRAP_ANY
	/// \brief Access the calibration value at a certain index.

	/// Returns a reference to a calibration value at a certain index. You can
	/// assign to the return value to set a new offset.
	double& operator[](/// index of the calibration value
			   int index);

	/// \brief Access the calibration value at a certain index.

	/// Returns a calibration value at a certain index.
	double operator[](/// index of the calibration value
			  int index) const;
#endif // #ifndef WRAP_ANY


public:
	/// \brief Construct a default Calibrator object of a specified size.
	Calibrator
	(
	 /// The size of the calibration buffer
	 int size=0
	 );


#ifndef WRAP_ANY
	/// \brief Construct a Calibrator object from values.

	///
	/// \note Not available in Python.
	template<class InIt>
	  Calibrator(/// Iterator specifying the begin of the value sequence
		    InIt begin,
		    /// Iterator specifying the end of the value sequence (one element past the sequence).
		    InIt end,
		    /// The unit string (max 32 characters).
		    std::string unit="",
		    /// The power of 10.
		    int power=0,
		    /// The offset of the calibration values.
		    double offset=0.0);

#endif // #ifndef WRAP_ANY

	/// \brief Destruct a Calibrator object.
	virtual ~Calibrator();


	/// \brief Construct a mvIMPACT::Calibrator object from \a src.
	Calibrator(/// the other mvIMPACT::Calibrator object
		    const Calibrator& src);

#ifndef WRAP_ANY
	/// \brief Overwrite current object with \a src.
	Calibrator& operator=(/// the other mvIMPACT::Calibrator object
			       const Calibrator& src);

	/// \brief Test for equality.

	/// Calibrator objects are considered equal if unit, power, offset and data are
	/// equal.
	/// Returns \c true if the Calibrator objects are equal, \c false otherwise.
	bool operator==(/// the second mvIMPACT::Calibrator object
			const Calibrator& second) const;

	/// \brief Test for inequality.

	/// Calibrator objects are considered not equal if unit, power, offset or data are
	/// not equal.
	/// Returns \c true if the Calibrator objects are not equal, \c false otherwise.
	bool operator!=(/// the second mvIMPACT::Calibrator object
			const Calibrator& second) const;
#endif // #ifndef WRAP_ANY

	// \internal
        // We chose to embed the underlying IPL structure instead of deriving
	// from it. The reason was that we wanted to change the spelling of some members.
private:
	void copy(const Calibrator& src);
	void dispose();
};




/// \brief Represents a coordinate in a 5 dimensional buffer like it is used for mvIMPACT::Images etc.
///
/// This class provides easy access to a specific coordinate.
/// This helps to select locations in different bands,slices and frames.
/// A buffer can have the following five dimensions:
/// - X
/// - Y
/// - slice (Z)
/// - band (color band)
/// - frame (time)
class Coord
{
 public:


  /// \brief Get the currently specified x-coordinate
  ///
  /// \see mvIMPACT::Coord::setX
  /// \see mvIMPACT::Coord::getY
  int getX() const;

#ifndef WRAP_ANY
  /// \brief Get the currently specified x-coordinate
  ///
  /// \see mvIMPACT::Coord::setX
  /// \see mvIMPACT::Coord::getY
  int & getX();
#endif // #ifndef WRAP_ANY

  /// \brief Set the x-coordinate
  ///
  /// \see mvIMPACT::Coord::getX
  /// \see mvIMPACT::Coord::setY
  Coord& setX(
		/// the new x-coordinate
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
  		/// </mvParamRange>
   		/// \endxmlonly
		int x);


  /// \brief Get the currently specified y-coordinate
  ///
  /// \see mvIMPACT::Coord::setY
  /// \see mvIMPACT::Coord::getX
  int getY() const;

#ifndef WRAP_ANY
  /// \brief Get the currently specified y-coordinate
  ///
  /// \see mvIMPACT::Coord::setY
  /// \see mvIMPACT::Coord::getX
  int & getY();
#endif // #ifndef WRAP_ANY

  /// \brief Set the y-coordinate
  ///
  /// \see mvIMPACT::Coord::getY
  /// \see mvIMPACT::Coord::setX
  Coord& setY(
			/// the new y-coordinate
			/// \xmlonly
			/// <mvParamRange>
   			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	   		/// </mvParamRange>
	   		/// \endxmlonly
			int y);


  /// \brief Get the currently selected band.
  ///
  /// \see mvIMPACT::Coord::setBand
  int getBand() const;

#ifndef WRAP_ANY
  /// \brief Get the currently selected band.
  ///
  /// \see mvIMPACT::Coord::setBand
  int & getBand();
#endif // #ifndef WRAP_ANY

  /// \brief Set the desired band
  ///
  /// \see mvIMPACT::Coord::getBand
  Coord& setBand(
			/// the new band
			/// \xmlonly
			/// <mvParamRange>
   			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	   		/// </mvParamRange>
	   		/// \endxmlonly
			int band);


  /// \brief Get the currently selected slice.
  ///
  /// \see mvIMPACT::Coord::setSlice
  int getSlice() const;

#ifndef WRAP_ANY
  /// \brief Get the currently selected slice.
  ///
  /// \see mvIMPACT::Coord::setSlice
  int & getSlice();
#endif // #ifndef WRAP_ANY

  /// \brief Set the desired slice
  ///
  /// \see mvIMPACT::Coord::getSlice
  Coord& setSlice(
			/// the new slice
			/// \xmlonly
			/// <mvParamRange>
   			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	   		/// </mvParamRange>
	   		/// \endxmlonly
			int slice);


  /// \brief Get the currently selected frame.
  ///
  /// \see mvIMPACT::Coord::setFrame
  int getFrame() const;

#ifndef WRAP_ANY
  /// \brief Get the currently selected frame.
  ///
  /// \see mvIMPACT::Coord::setFrame
  int & getFrame();
#endif // #ifndef WRAP_ANY

  /// \brief Set the desired frame
  ///
  /// \see mvIMPACT::Coord::getFrame
  Coord& setFrame(
			/// the new frame
			/// \xmlonly
			/// <mvParamRange>
   			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	   		/// </mvParamRange>
	   		/// \endxmlonly
			int frame);


  /// \brief Construct a mvIMPACT::Coord object with all members set to 0.
  Coord();


  /// \brief Construct a mvIMPACT::Coord object for the specified location.

  /// The default value for \a band, \a slice and \a frame is 0.
  ///
   // \internal
   // If you change the default initializations, you have to
   // change them in base.i as well in the tuple to class conversion !
  Coord(
			/// the x-coordinate
			/// \xmlonly
			/// <mvParamRange>
   			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	   		/// </mvParamRange>
	   		/// \endxmlonly
			int x,
			/// the y-coordinate
			/// \xmlonly
			/// <mvParamRange>
   			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	   		/// </mvParamRange>
	   		/// \endxmlonly
			int y,
			/// the desired band
			/// \xmlonly
			/// <mvParamRange>
   			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	   		/// </mvParamRange>
	   		/// \endxmlonly
			int band = 0,
			/// the desired slice
			/// \xmlonly
			/// <mvParamRange>
   			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	   		/// </mvParamRange>
	   		/// \endxmlonly
			int slice = 0,
			/// the desired frame
			/// \xmlonly
			/// <mvParamRange>
   			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	   		/// </mvParamRange>
	   		/// \endxmlonly
			int frame = 0);

 private:
  int m_x;
  int m_y;
  int m_band;
  int m_slice;
  int m_frame;
};


/// \brief This class represents a linear transformation
///
/// The transformation is specified by the offset (\a x, \a y), the
/// scaling factors \a scaleX and \a scaleY and the rotation angle \a angle.
class Position {
 public:

  /// \brief Retrieve the x-offset
  ///
  /// \see mvIMPACT::Position::setX
  /// \see mvIMPACT::Position::getY
  double getX() const;

#ifndef WRAP_ANY
  /// \brief Retrieve the x-offset
  ///
  /// \see mvIMPACT::Position::setX
  /// \see mvIMPACT::Position::getY
  double & getX();
#endif // #ifndef WRAP_ANY

  /// \brief Set the x-offset
  ///
  /// \see mvIMPACT::Position::getX
  /// \see mvIMPACT::Position::setY
  Position& setX(/// the new x-offset
		 double x);


  /// \brief Retrieve the y-offset
  ///
  /// \see mvIMPACT::Position::getX
  /// \see mvIMPACT::Position::setY
  double getY() const;

#ifndef WRAP_ANY
  /// \brief Retrieve the y-offset
  ///
  /// \see mvIMPACT::Position::getX
  /// \see mvIMPACT::Position::setY
  double & getY();
#endif // #ifndef WRAP_ANY

  /// \brief Set the y-offset
  ///
  /// \see mvIMPACT::Position::setX
  /// \see mvIMPACT::Position::getY
  Position& setY(/// the new y-offset
		 double y);


  /// \brief Retrieve the horizontal scale factor
  ///
  /// \see mvIMPACT::Position::setScaleX
  /// \see mvIMPACT::Position::getScaleY
  double getScaleX() const;

#ifndef WRAP_ANY
  /// \brief Retrieve the horizontal scale factor
  ///
  /// \see mvIMPACT::Position::setScaleX
  /// \see mvIMPACT::Position::getScaleY
  double & getScaleX();
#endif // #ifndef WRAP_ANY

  /// \brief Set the horizontal scale factor
  ///
  /// \see mvIMPACT::Position::getScaleX
  /// \see mvIMPACT::Position::setScaleY
  Position& setScaleX(/// the new horizontal scale factor
		      double scaleX);


  /// \brief Retrieve the vertical scale factor
  ///
  /// \see mvIMPACT::Position::setScaleY
  /// \see mvIMPACT::Position::getScaleX
  double getScaleY() const;

#ifndef WRAP_ANY
  /// \brief Retrieve the vertical scale factor
  ///
  /// \see mvIMPACT::Position::setScaleY
  /// \see mvIMPACT::Position::getScaleX
  double & getScaleY();
#endif // #ifndef WRAP_ANY

  /// \brief Set the vertical scale factor
  ///
  /// \see mvIMPACT::Position::getScaleY
  /// \see mvIMPACT::Position::setScaleX
  Position& setScaleY(/// the new vertical scale factor
		      double scaleY);


  /// \brief Retrieve the rotation angle of the transformation
  ///
  /// \see mvIMPACT::Position::setAngle
  double getAngle() const;

#ifndef WRAP_ANY
  /// \brief Retrieve the rotation angle of the transformation
  ///
  /// \see mvIMPACT::Position::setAngle
  double & getAngle();
#endif // #ifndef WRAP_ANY

  /// \brief Set the rotation angle of the transformation
  ///
  /// \see mvIMPACT::Position::getAngle
  Position& setAngle(
			/// the new rotation angle in degrees
			/// \xmlonly
			/// <mvParamRange>
   			/// <mvParamMin><mvParamConst value="-360.0"/></mvParamMin>
   			/// <mvParamMax><mvParamConst value="360.0"/></mvParamMax>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
	   		/// \endxmlonly
			double angle);



  /// \brief Construct a mvIMPACT::Position object with default values.
  /// Initializes the object with
  /// - x = 0
  /// - y = 0
  /// - scaleX = 1
  /// - scaleY = 1
  /// - angle = 0
  Position();


  /// \brief Construct a mvIMPACT::Position object.
  ///
  /// The object is initialized with the values passed in this constructor.
  ///
   // \internal
   // If you change the default initializations, you have to
   // change them in base.i as well in the tuple to class conversion !
  Position(/// the x-offset
		double x,
		/// the y-offset
		double y,
		/// the horizontal scale factor
		double scaleX=1.0,
		/// the vertical scale factor
		double scaleY=1.0,
		/// the rotation angle in degrees
		/// \xmlonly
		/// <mvParamRange>
   		/// <mvParamMin><mvParamConst value="-360.0"/></mvParamMin>
   		/// <mvParamMax><mvParamConst value="360.0"/></mvParamMax>
		/// <mvParamStep>0.1</mvParamStep>
		/// </mvParamRange>
	   	/// \endxmlonly
		double angle=0.0);

 private:
  double m_x;
  double m_y;
  double m_scaleX;
  double m_scaleY;
  double m_angle;
};



/// \brief The buffer lock.
///
/// The buffer lock is acquired with the mvIMPACT::BufferBase::readLock or mvIMPACT::BufferBase::readWriteLock
/// functions and released when the BufferLock object is destroyed. Using
/// mvIMPACT::BufferBase::readLock or mvIMPACT::BufferBase::readWriteLock you can lock a buffer for read or
/// read/write access of other threads. This class is intended to be used
/// in multithreaded applications to prevent possible deadlock situations.
///
/// Objects of this class are reference counted and
/// can be safely used within STL containers. When they are copied or assigned
/// the reference count is incremented and the contents is shared. When they are
/// destroyed, the reference count is decremented. If the reference count drops
/// to zero, the handle is freed. In addition the buffer lock increments and
/// decrements the reference count of the BufferBase object it locks.
class BufferLock
{
	DECLARE_USAGE_COUNTER

	friend class BufferBase;

public:
	/// \brief Locking mode.
	enum LockMode
	{
		/// Specifies the read locking mode.
		lmRead = mvIMPACT_C::IPL_LOCK_READ,
		/// Specifies the write locking mode.
		lmReadWrite = mvIMPACT_C::IPL_LOCK_WRITE,
	};

	/// \brief Get the number of shallow copies of this object.

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
	/// This is the contents of the
	/// shared reference counter.
	int getUseCount() const;
#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

	/// \brief  The class invariant.
	bool getIsValid() const;

	/// \brief Construct an unassigned buffer lock.
	BufferLock();

	/// \brief Copy construct a BufferLock object.
	///
	/// A BufferLock object is reference counted, so this creates a shallow copy.
	BufferLock(
		/// The BufferLock object to be copied.
		const BufferLock& src);

#ifndef WRAP_ANY
	/// \brief Copy assign a BufferLock object.

	///
	/// A BufferLock object is reference counted, so this creates a shallow copy.
	BufferLock& operator=(
		/// The BufferLock object to be copied.
		const BufferLock& src);
#endif // #ifndef WRAP_ANY

	/// \brief Destructor.

	///
	/// When the BufferLock object is destructed, the lock is removed from the buffer.
	~BufferLock();

private:
	/// Stored pointer to the BufferBase.
	/// This reference is
	class BufferBase* buffer_;

	/// Pointer to the reference counter.
	int* counter_;

	/// Stored locking mode.
	LockMode lock_;

	/// Construct the buffer lock.
	BufferLock(
		/// Pointer to the BufferBase.
		const BufferBase* buffer,
		/// The locking mode.
		LockMode mode);

	/// Decrease the reference count. When it drops to zero the object is destroyed.
	void dispose();

	void copy(const BufferLock& src);
};



/// \brief The base class for buffers.
///
/// Objects of this class are reference counted and
/// can be safely used within STL containers. When they are copied or assigned
/// the reference count is incremented and the handle is shared. When they are
/// destroyed, the reference count is decremented. If the reference count drops
/// to zero, the handle is freed.
///
/// BufferBase is an abstract class that cannot be instantiated directly. Rather,
/// it serves as an indirect base class for derived classes, like Image, Palette, etc.
///
/// A mvIMPACT::BufferBase object  can have
/// up to five dimensions:
/// - width (x-dimension)
/// - height (y-dimension)
/// - bands
/// - z-slices
/// - time-slices
/// Each band consists of a x/y surface, each z-slice consists of a specified number of bands and
/// each time-slice consists of a specified number of z-slices. The following figure shows
/// a buffer that consists of two time-slices, each time-slice consists of two z-slices and each
/// z-slice consists of three bands:
/// \image html images/mvi_base/Buffer_Architecture.png
///
/// Multiple bands are typically used to represent color images. A color image consists of three
/// bands: one for red, one for green and one for blue. To represent an image in depth (or 3D),
/// you could use multiple z-slices (i.e. if you have a series of CT slices). Additionally, you can
/// use time-slices to describe an object at different moments in time. If you use a
/// multidimensional buffer for processing, the following order will be used:
/// - processing each band (x/y surface)
/// - processing each z-slice
/// - processing each time-slice
///
/// \note This is an abstract class!

//-----------------------------------------------------------------------------
class BufferBase
//-----------------------------------------------------------------------------
{
private:
	PROXY_CLASS_SIMPLE_DECL(Bands, int, BufferBase)
	PROXY_CLASS_SIMPLE_DECL(Slices, int, BufferBase)
	PROXY_CLASS_SIMPLE_DECL(Frames, int, BufferBase)
	PROXY_CLASS_POINT_DECL(XYOffset, Point, BufferBase)
	PROXY_CLASS_SIMPLE_DECL(XOffset, int, BufferBase)
	PROXY_CLASS_SIMPLE_DECL(YOffset, int, BufferBase)
	PROXY_CLASS_SIMPLE_DECL(BandsOffset, int, BufferBase)
	PROXY_CLASS_SIMPLE_DECL(SlicesOffset, int, BufferBase)
	PROXY_CLASS_SIMPLE_DECL(FramesOffset, int, BufferBase)
	PROXY_CLASS_SIMPLE_DECL(ColorSpace, ColorSpace, BufferBase)
	PROXY_CLASS_SIMPLE_DECL(BayerMosaicRedGain, double, BufferBase)
	PROXY_CLASS_SIMPLE_DECL(BayerMosaicRedOffset, double, BufferBase)
	PROXY_CLASS_SIMPLE_DECL(BayerMosaicGreenGain, double, BufferBase)
	PROXY_CLASS_SIMPLE_DECL(BayerMosaicGreenOffset, double, BufferBase)
	PROXY_CLASS_SIMPLE_DECL(BayerMosaicBlueGain, double, BufferBase)
	PROXY_CLASS_SIMPLE_DECL(BayerMosaicBlueOffset, double, BufferBase)
	PROXY_CLASS_SIMPLE_DECL(BayerMosaicDigitalGain, double, BufferBase)
	PROXY_CLASS_SIMPLE_DECL(BayerMosaicParity, int, BufferBase)
	PROXY_CLASS_SIMPLE_DECL(IsThreadSafe, bool, BufferBase)
	PROXY_CLASS_SIMPLE_DECL(Datatype, BufferDatatype, BufferBase)
	PROXY_CLASS_SIMPLE_DECL(BitsPerSample, int, BufferBase)
	PROXY_CLASS_CALIBRATOR_DECL(XCalibrator, Calibrator, BufferBase)
	PROXY_CLASS_CALIBRATOR_DECL(YCalibrator, Calibrator, BufferBase)
	PROXY_CLASS_CALIBRATOR_DECL(SlicesCalibrator, Calibrator, BufferBase)
	PROXY_CLASS_CALIBRATOR_DECL(FramesCalibrator, Calibrator, BufferBase)


	/// Unassigned buffer constant.
	enum { unassigned = -1 };

	/// The buffer handle.
	mvIMPACT_C::IPL_BUFHANDLE handle_;

	/// Pointer to the reference counter.
	mutable int* counter_;

	/// Pointer to parent buffer or NULL if current buffer is not a child buffer.
	/// If non-NULL, lifetime is the same as counter_.
	BufferBase const * parent_;

	/// Stored pointer to MyBufferAccess object.
	/// The MyBufferAccess object can change. It sematically belongs to the buffer
	/// handle, so it is shared between copies of one BufferBase object.
	/// Lifetime is the same as counter_.
	mutable MyBufferAccess *access_;

	/// only used internally to check if this buffer must be freed
	bool mustCleanup_;

protected:
  /// \brief Get a pixel's value.

  ///
  /// Note that this operation is quite slow. If you
  /// do a bunch of calls of mvIMPACT::BufferBase::getPixel(int, int, int, int, int)
  /// with constant \a band, \a slice and \a frame,
  /// call mvIMPACT::BufferBase::prepareReadAccess() before and mvIMPACT::BufferBase::releaseAccess() afterwards.
  /// This speeds up operation of mvIMPACT::BufferBase::getPixel() considerably.
  /// If you also want to call mvIMPACT::BufferBase::setPixel(int, int, int, int, int, int),
  /// you need to call mvIMPACT::BufferBase::prepareReadWriteAccess instead.
  /// Furthermore you can then call mvIMPACT::BufferBase::getPixel(int,int), i.e. without the paramters
  /// \a band, \a slice and frame, which are redundant in this case.
  ///
  /// If one of the parameters \a band, \a slice and \a frame doesn't match
  /// the call of the last mvIMPACT::BufferBase::prepareReadAccess or mvIMPACT::BufferBase::prepareReadWriteAccess function, the slow
  /// version of the function is called automatically.
  int getPixel(
  			/// the x coordinate of the point to be accessed
			/// \xmlonly
			/// <mvParamRange>
   			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
   			/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
   			/// </mvParamRange>
   			/// \endxmlonly
	       	int x,
	       	/// the y coordinate of the point to be accessed
			/// \xmlonly
			/// <mvParamRange>
   			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
   			/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
   			/// </mvParamRange>
   			/// \endxmlonly
	       	int y,
	       	/// the band of the point to be accessed
			/// \xmlonly
			/// <mvParamRange>
   			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
   			/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
   			/// </mvParamRange>
   			/// \endxmlonly
	       	int band,
	       	/// the slice of the point to be accessed
			/// \xmlonly
			/// <mvParamRange>
   			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
   			/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
   			/// </mvParamRange>
   			/// \endxmlonly
	       	int slice,
	       	/// the frame of the point to be accessed
			/// \xmlonly
			/// <mvParamRange>
   			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
   			/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
   			/// </mvParamRange>
   			/// \endxmlonly
	       	int frame) const;



  /// \brief Get a pixel's value.

  /// This function can only be called after a call to
  /// mvIMPACT::BufferBase::prepareReadAccess or mvIMPACT::BufferBase::prepareReadWriteAccess.
  /// However, it is quite fast.
  /// The plane where the pixel is accessed (band,slice,frame) is specified with mvIMPACT::BufferBase::prepareReadAccess
  /// or mvIMPACT::BufferBase::prepareReadWriteAccess.
  /// \see mvIMPACT::BufferBase::prepareReadAccess
  /// \see mvIMPACT::BufferBase::prepareReadWriteAccess
  ///
  int getPixel(
  			/// the x coordinate of the point to be accessed
			/// \xmlonly
			/// <mvParamRange>
   			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
   			/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
   			/// </mvParamRange>
   			/// \endxmlonly
	       	int x,
	       	/// the y coordinate of the point to be accessed
			/// \xmlonly
			/// <mvParamRange>
   			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
   			/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
   			/// </mvParamRange>
   			/// \endxmlonly
	       	int y) const;



  /// \brief Set a pixel's value.

  /// Note that this operation is quite slow. If you
  /// do a bunch of calls of mvIMPACT::BufferBase::setPixel() with constant \a band, \a slice and \a frame,
  /// call mvIMPACT::BufferBase::prepareReadWriteAccess() before and mvIMPACT::BufferBase::releaseAccess() afterwards.
  /// first. This speeds up operation of mvIMPACT::BufferBase::setPixel() considerably.
  ///
  /// If one of the parameters \a band, \a slice and \a frame doesn't match
  /// the call of the last mvIMPACT::BufferBase::prepareReadWriteAccess() function, the slow
  /// version of the function is called.
  ///
   // \internal
   // if the return value is BufferBase& here (i.e. *this) then the Python
   // function gets considerably slower, so we use void here
  void setPixel(
  		/// x coordinate of the pixel to be set
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x,
		/// y coordinate of the pixel to be set
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y,
		/// band of the pixel to be set
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band,
		/// slice of the pixel to be set
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice,
		/// frame of the pixel to be set
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame,
		/// new value of the pixel to be set
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(instance)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(instance)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int value);

  /// \brief Set a pixel's value.

  /// This function can only be called after a call to
  /// mvIMPACT::BufferBase::prepareReadAccess() or mvIMPACT::BufferBase::prepareReadWriteAccess(). However, it is quite fast.
  ///
  /// \see mvIMPACT::BufferBase::prepareReadAccess
  /// \see mvIMPACT::BufferBase::prepareReadWriteAccess
   // \internal
   // if the return value is BufferBase& here (i.e. *this) then the Python
   // function gets considerably slower, so we use void here
  void setPixel(
	  	/// x coordinate of the pixel to be set
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x,
		/// y coordinate of the pixel to be set
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y,
		/// the new value to be set
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(instance)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(instance)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int value);


public:
#ifndef WRAP_ANY
	// The .NET garbage collector needs a rough idea of how much memory is involved to provide better
	// memory management. We should not return zero here, since this would correspond to no pressure.
	int getMemoryPressure() const
	{
		if (unassigned != handle_)
		{
			// since we cannot do sizeof(MAINARRAY) here, we do an educated guess and assume it it is
			// 256 bytes (which it was when I counted).
			return 
				sizeof(BufferBase) +	// the size of this unmanaged C++ object
				256 +					// the size of the unmanaged C object
				getIsParent() ?			// the size of the buffer data
					getWidth() * getHeight() * getBands() * getSlices() * getFrames() * getDatatypeSize() :
					0;
		}
		else
		{
			return sizeof(BufferBase);	// the size of this unmanaged C++ object
		}
	}
#endif // #ifndef WRAP_ANY


  /// \brief Acquire a direct access lock for reading.

  /// This speeds up subsequent calls to
  /// mvIMPACT::BufferBase::getPixel(int, int, int, int, int) considerably if the values for \a band, \a slice \a frame
  /// match those of a previous call to mvIMPACT::BufferBase::prepareReadAccess().
  ///
  /// Note that after calling mvIMPACT::BufferBase::prepareReadAccess() you can also use the mvIMPACT::BufferBase::getPixel(int, int) for
  /// reading.
  ///
  /// The acquired lock can be released again with a call to mvIMPACT::BufferBase::releaseAccess().
  ///
  /// If another direct access lock has been acquired, i.e.
  /// mvIMPACT::BufferBase::prepareReadAccess() or mvIMPACT::BufferBase::prepareReadAccess()
  /// has been called with other values for \a band, \a slice and  \a frame as before, the locks accumulate.
  ///
  /// If another direct access lock of a different type (reading vs. reading and writing, i.e mvIMPACT::BufferBase::prepareReadWriteAccess()) is acquired, all the
  /// "old" read locks are released first.
  ///
  /// \see mvIMPACT::BufferBase::prepareReadWriteAccess
  /// \see mvIMPACT::BufferBase::releaseAccess
  void prepareReadAccess(
	/// The specific band to be accessed.
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
	/// </mvParamRange>
	/// \endxmlonly
	int band=0,
	/// The specific slice to be accessed.
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
	/// </mvParamRange>
	/// \endxmlonly
	int slice=0,
	/// The specific frame to be accessed.
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
	/// </mvParamRange>
	/// \endxmlonly
	int frame=0) const;




  /// \brief Acquire a direct access lock for reading and writing.

  /// This speeds up subsequent calls to
  /// mvIMPACT::BufferBase::getPixel(int, int, int, int, int) and mvIMPACT::BufferBase::setPixel(int, int, int, int, int) considerably
  /// if the values for \a band, \a slice \a frame match those of a previous call to mvIMPACT::BufferBase::prepareReadAccess().
  ///
  /// Note that after calling mvIMPACT::BufferBase::prepareReadWriteAccess() you can also use the mvIMPACT::BufferBase::getPixel(int, int) for
  /// reading and mvIMPACT::BufferBase::setPixel(int, int, int) for writing.
  ///
  /// The acquired lock can be released again with a call to mvIMPACT::BufferBase::releaseAccess().
  ///
  /// If another direct access lock has been acquired, i.e. mvIMPACT::BufferBase::prepareReadWriteAccess()
  /// has been called with other values for \a band, \a slice and  \a frame as before, the locks accumulate.
  ///
  /// If another direct access lock of a different type (reading vs. reading and writing, i.e mvIMPACT::BufferBase::prepareReadAccess()) is acquired, all the
  /// "old" read-write locks are released first.
  ///
  /// \see mvIMPACT::BufferBase::prepareReadAccess
  /// \see mvIMPACT::BufferBase::releaseAccess
  void prepareReadWriteAccess(
	/// The specific band to be accessed.
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
	/// </mvParamRange>
	/// \endxmlonly
	int band=0,
	/// The specific slice to be accessed.
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
	/// </mvParamRange>
	/// \endxmlonly
	int slice=0,
	/// The specific frame to be accessed.
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
	/// </mvParamRange>
	/// \endxmlonly
	int frame=0);



  /**
   \brief Returns a pointer for direct access to the buffer's data.

   This operation is only allowed if
   the buffer is directly accessible, i.e. after calling mvIMPACT::BufferBase::prepareReadAccess() or
   mvIMPACT::BufferBase::prepareReadWriteAccess() and before calling mvIMPACT::BufferBase::releaseAccess().
   If this method is called and multiple planes have been locked using mvIMPACT::prepareReadAccess()
   or mvIMPACT::prepareReadWriteAccess() a pointer to the plane with the most recent lock is returned.

   Note that the returned pointer is of type unsigned char, because
   then you can easily make "bytewise" pointer arithmetic. For access
   of the values, you have to convert the pointer to the correct datatype
   of the buffer yourself (!).

   With such a pointer, you can access the buffer data directly.

   \xmlonly
   <mvWrapperDoc><htmlinclude ref="code_fragment_start_cpp.html"/></mvWrapperDoc>
   \endxmlonly
   \htmlinclude code_fragment_start_cpp.html
   For example invert pixels from band 2
   \code
  	img.prepareReadWriteAccess(1,0,0);
   	long *ptr = (long *)img.getPointer();
   	int itemPitch = img.getPitch()/sizeof(long);
  	// pitch in items as opposed to bytes
   	int width = img.getWidth();

   	for(int x = 0; x < width; x++) {
   		ptr[100*itemPitch+x] = -ptr[100*itemPitch+x];
   	}

   	img.releaseAccess();
   \endcode
   \htmlinclude code_fragment_end.html
   \xmlonly
   <mvWrapperDoc><htmlinclude ref="code_fragment_end.html"/></mvWrapperDoc>
   \endxmlonly
   \xmlonly
   <mvWrapperDoc>
   <htmlinclude ref="cs_doc_start.html"/>
   \note C#: The method that is calling mvIMPACT::BufferBase::getPointer must be declared "unsafe" and the code has to be compiled
   \note with "/unsafe". See the notes on the c# wrapper for further information.

   <htmlinclude ref="specific_doc_end.html"/>
   <htmlinclude ref="vb_net_doc_start.html"/>
   \note VB.NET: This method/property is NOT available in Visual Base.NET, since VB.NET cannot deal with pointers! See the notes on the VB.NET wrapper
   \note for further information.

   <htmlinclude ref="specific_doc_end.html"/>
   </mvWrapperDoc>
   \endxmlonly

   \see mvIMPACT::BufferBase::prepareReadAccess
   \see mvIMPACT::BufferBase::prepareReadWriteAccess
   \see mvIMPACT::BufferBase::releaseAccess
  */
  unsigned char* getPointer() const;

  /**
   \brief Returns a pointer for direct access to a specific plane of the buffer's data.

   This operation is only allowed if the plane
   is directly accessible, i.e. after calling mvIMPACT::BufferBase::prepareReadAccess() or
   mvIMPACT::BufferBase::prepareReadWriteAccess() and before calling mvIMPACT::BufferBase::releaseAccess().

   Note that the returned pointer is of type unsigned char, because
   then you can easily make "bytewise" pointer arithmetic. For access
   of the values, you have to convert the pointer to the correct datatype
   of the buffer yourself (!).

   With such a pointer, you can access the buffer data directly.
   \xmlonly
   <mvWrapperDoc><htmlinclude ref="code_fragment_start_cpp.html"/></mvWrapperDoc>
   \endxmlonly
   \htmlinclude code_fragment_start_cpp.html
   For example copy pixels from band 3 to band 2
   \code
  	img.prepareReadWriteAccess(1,0,0);
  	img.prepareReadWriteAccess(2,0,0);
   	long *ptr1 = (long *)img.getPointer(1,0,0);
        long *ptr2 = (long *)img.getPointer(2,0,0);
   	int itemPitch = img.getPitch(1,0,0)/sizeof(long);
  	// pitch in items as opposed to bytes
   	int width = img.getWidth();

   	for(int x = 0; x < width; x++) {
   		ptr1[100*itemPitch+x] = ptr2[100*itemPitch+x];
   	}


   	img.releaseAccess(1,0,0);
   	img.releaseAccess(2,0,0);
   \endcode
   \htmlinclude code_fragment_end.html
   \xmlonly
   <mvWrapperDoc><htmlinclude ref="code_fragment_end.html"/></mvWrapperDoc>
   \endxmlonly
   \xmlonly
   <mvWrapperDoc>
   <htmlinclude ref="cs_doc_start.html"/>
   \note C#: The method that is calling mvIMPACT::BufferBase::getPointer must be declared "unsafe" and the code has to be compiled
   \note with "/unsafe". See the notes on the c# wrapper for further information.
   <htmlinclude ref="specific_doc_end.html"/>
   <htmlinclude ref="vb_net_doc_start.html"/>
   \note VB.NET: This method/property is NOT available in Visual Base.NET, since VB.NET cannot deal with pointers! See the notes on the VB.NET wrapper
   \note for further information.
   <htmlinclude ref="specific_doc_end.html"/>
   </mvWrapperDoc>
   \endxmlonly
   \see mvIMPACT::BufferBase::prepareReadAccess
   \see mvIMPACT::BufferBase::prepareReadWriteAccess
   \see mvIMPACT::BufferBase::releaseAccess
  */
  unsigned char* getPointer(
	/// The specific band to be accessed.
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
	/// </mvParamRange>
	/// \endxmlonly
	int band,
	/// The specific slice to be accessed.
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
	/// </mvParamRange>
	/// \endxmlonly
	int slice,
	/// The specific frame to be accessed.
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
	/// </mvParamRange>
	/// \endxmlonly
	int frame) const;


#ifndef WRAP_ANY
  /**
   \brief Returns a pointer for direct access to the buffer's data.

   This operation is only allowed if
   the buffer is directly accessible, i.e. after calling mvIMPACT::BufferBase::prepareReadAccess() or
   mvIMPACT::BufferBase::prepareReadWriteAccess() and before calling mvIMPACT::BufferBase::releaseAccess().
   If this method is called and multiple planes have been locked using mvIMPACT::prepareReadAccess()
   or mvIMPACT::prepareReadWriteAccess() a pointer to the plane with the most recent lock is returned.


   Note that the returned pointer is of type unsigned char, because
   then you can easily make "bytewise" pointer arithmetic. For access
   of the values, you have to convert the pointer to the correct datatype
   of the buffer yourself (!).

   With such a pointer, you can access the buffer data directly.
   \xmlonly
   <mvWrapperDoc><htmlinclude ref="code_fragment_start_cpp.html"/></mvWrapperDoc>
   \endxmlonly
   \htmlinclude code_fragment_start_cpp.html
   For example invert pixels of band 2
   \code
  	img.prepareReadWriteAccess(1,0,0);
   	long *ptr = (long *)img.getPointer();
   	int pitch = img.getPitch();
   	int width = img.getWidth();

   	for(int x = 0; x < width; x++) {
   		*(long*)(ptr+100*pitch+x) = -*(long*)(ptr+100*pitch+x);
   	}

   	img.releaseAccess();
   \endcode
   \htmlinclude code_fragment_end.html
   \xmlonly
   <mvWrapperDoc><htmlinclude ref="code_fragment_end.html"/></mvWrapperDoc>
   \endxmlonly
   \xmlonly
   <mvWrapperDoc>
   <htmlinclude ref="cs_doc_start.html"/>
   \note C#: The method that is calling mvIMPACT::BufferBase::getPointer must be declared "unsafe" and the code has to be compiled
   \note with "/unsafe". See \ref cs_notes_unsafe_code for further information.
   <htmlinclude ref="specific_doc_end.html"/>
   <htmlinclude ref="vb_net_doc_start.html"/>
   \note VB.NET:This method/property is NOT available in Visual Base.NET, since VB.NET cannot deal with pointers! See \ref vbnet_notes_buffer_access
   \note for further information.
   <htmlinclude ref="specific_doc_end.html"/>
   </mvWrapperDoc>
   \endxmlonly

   This function is also callable for constant objects, i.e. when only read access
   is allowed.
   \see mvIMPACT::BufferBase::prepareReadAccess
   \see mvIMPACT::BufferBase::prepareReadWriteAccess
   \see mvIMPACT::BufferBase::releaseAccess
  */
  unsigned char* getPointer();

  /**
   \brief Returns a pointer for direct access to a specific plane of the buffer's data.

   This operation is only allowed if the plane
   is directly accessible, i.e. after calling mvIMPACT::BufferBase::prepareReadAccess() or
   mvIMPACT::BufferBase::prepareReadWriteAccess() and before calling mvIMPACT::BufferBase::releaseAccess().

   Note that the returned pointer is of type unsigned char, because
   then you can easily make "bytewise" pointer arithmetic. For access
   of the values, you have to convert the pointer to the correct datatype
   of the buffer yourself (!).

   With such a pointer, you can access the buffer data directly.
   \xmlonly
   <mvWrapperDoc><htmlinclude ref="code_fragment_start_cpp.html"/></mvWrapperDoc>
   \endxmlonly
   \htmlinclude code_fragment_start_cpp.html
   For example copy pixels from band 3 to band 2
   \code
  	img.prepareReadWriteAccess(1,0,0);
  	img.prepareReadWriteAccess(2,0,0);
   	long *ptr1 = (long *)img.getPointer(1,0,0);
        long *ptr2 = (long *)img.getPointer(2,0,0);
   	int itemPitch = img.getPitch(1,0,0)/sizeof(long);
        // pitch in items as opposed to bytes
   	int width = img.getWidth();

   	for(int x = 0; x < width; x++) {
   		ptr1[100*itemPitch+x] = ptr2[100*itemPitch+x];
   	}


   	img.releaseAccess(1,0,0);
   	img.releaseAccess(2,0,0);
   \endcode
   \htmlinclude code_fragment_end.html
   \xmlonly
   <mvWrapperDoc><htmlinclude ref="code_fragment_end.html"/></mvWrapperDoc>
   \endxmlonly
   \xmlonly
   <mvWrapperDoc>
   <htmlinclude ref="cs_doc_start.html"/>
   \note C#: The method that is calling mvIMPACT::BufferBase::getPointer must be declared "unsafe" and the code has to be compiled
   \note with "/unsafe". See the notes on the c# wrapper for further information.
   <htmlinclude ref="specific_doc_end.html"/>
   <htmlinclude ref="vb_net_doc_start.html"/>
   \note VB.NET: This method/property is NOT available in Visual Base.NET, since VB.NET cannot deal with pointers! See the notes on the VB.NET wrapper
   \note for further information.
   <htmlinclude ref="specific_doc_end.html"/>
   </mvWrapperDoc>
   \endxmlonly
   \see mvIMPACT::BufferBase::prepareReadAccess
   \see mvIMPACT::BufferBase::prepareReadWriteAccess
   \see mvIMPACT::BufferBase::releaseAccess
  */
  unsigned char* getPointer(int band, int slice, int frame);
#endif // #ifndef WRAP_ANY


  /// \brief Returns the pitch for the buffer in bytes.
  ///
  /// The pitch is the distance in memory between two items
  /// which have the same x coordinate. This operation is only allowed if
  /// the buffer is directly accessible, i.e. after calling mvIMPACT::BufferBase::prepareReadAccess() or
  /// mvIMPACT::BufferBase::prepareReadWriteAccess() and before calling mvIMPACT::BufferBase::releaseAccess().
  /// Otherwise, an exception is thrown.
  /// \see mvIMPACT::BufferBase::prepareReadAccess
  /// \see mvIMPACT::BufferBase::prepareReadWriteAccess
  /// \see mvIMPACT::BufferBase::releaseAccess
  ///
  int getPitch() const;


  /// \brief Release a specific direct access lock acquired with mvIMPACT::BufferBase::prepareReadAccess() or
  /// mvIMPACT::BufferBase::prepareReadWriteAccess().
  ///
  /// It is not an error to call mvIMPACT::BufferBase::releaseAccess() without having a direct
  /// access lock, i.e. nothing is done in this case.
  ///
  /// \see mvIMPACT::BufferBase::prepareReadAccess
  /// \see mvIMPACT::BufferBase::prepareReadWriteAccess
  void releaseAccess(
	/// The specific band to be accessed.
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
	/// </mvParamRange>
	/// \endxmlonly
	int band,
	/// The specific slice to be accessed.
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
	/// </mvParamRange>
	/// \endxmlonly
	int slice,
	/// The specific frame to be accessed.
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
	/// </mvParamRange>
	/// \endxmlonly
	int frame) const;

  /// \brief Release all direct access lock acquired with mvIMPACT::BufferBase::prepareReadAccess() or
  /// mvIMPACT::BufferBase::prepareReadWriteAccess().
  ///
  /// It is not an error to call mvIMPACT::BufferBase::releaseAccess() without having a direct
  /// access lock, i.e. nothing is done in this case.
  ///
  /// \see mvIMPACT::BufferBase::prepareReadAccess
  /// \see mvIMPACT::BufferBase::prepareReadWriteAccess
  void releaseAccess() const;

  /// \brief Check if the buffer has a read lock.
  ///
  /// Indicates, if mvIMPACT::BufferBase::prepareReadAccess() or mvIMPACT::BufferBase::prepareReadWriteAccess() has
  /// been called and the access has not been released yet by calling
  /// mvIMPACT::BufferBase::releaseAccess().
  /// \see mvIMPACT::BufferBase::prepareReadAccess
  /// \see mvIMPACT::BufferBase::prepareReadWriteAccess
  /// \see mvIMPACT::BufferBase::releaseAccess
  bool getHasReadAccess() const;


  /// \brief Check if the buffer has a write lock.
  ///
  /// Indicates, if mvIMPACT::BufferBase::prepareReadWriteAccess() has been called and the
  /// access has not been released yet by calling mvIMPACT::BufferBase::releaseAccess().
  ///
  /// Note the invariant
  /// <code>!getHasReadWriteAccess() || getHasReadAccess()</code>
  /// \see mvIMPACT::BufferBase::prepareReadAccess
  /// \see mvIMPACT::BufferBase::prepareReadWriteAccess
  /// \see mvIMPACT::BufferBase::releaseAccess
  bool getHasReadWriteAccess() const;

  /// \brief Read a single floating point value from a buffer.
  ///
  /// This function allows you to get a single value from a buffer without a need to call
  /// prepareReadAccess before and releaseReadAccess after.
  ///
  /// If the buffer has a datatype different from bdDouble, the value will be converted
  /// to double.
  ///
  /// \return The value at the specified location.
  ///
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::getValue32
  /// \see mvIMPACT::BufferBase::getValue32s
  /// \see mvIMPACT::BufferBase::getValue16
  /// \see mvIMPACT::BufferBase::getValue16s
  /// \see mvIMPACT::BufferBase::getValue8
  /// \see mvIMPACT::BufferBase::getValue8s
  /// \see mvIMPACT::BufferBase::setValue
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::setValues
  double getValue(
  		/// The horizontal position within the buffer.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	  	int x,
	  	/// The vertical position within the buffer.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	  	int y,
	  	/// The band of the buffer.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	  	int band=0,
	  	/// The z slice of the buffer.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	  	int slice=0,
	  	/// The frame of the buffer.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	  	int frame=0) const;

  /// \brief Read a single signed 32 bit value from a buffer.
  ///
  /// This function allows you to get a single value from a buffer without a need to call
  /// prepareReadAccess before and releaseReadAccess after.
  ///
  /// If the buffer has a datatype different from bdLong, the value will be converted
  /// to int.
  ///
  /// If the destination data depth is greater than the source data depth, a zero
  /// or sign extension will be performed. If the source data depth is greater
  /// than the destination data depth, the most significant bits are truncated.
  ///
  /// \return The value at the specified location.
  ///
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::getValue32
  /// \see mvIMPACT::BufferBase::getValue32s
  /// \see mvIMPACT::BufferBase::getValue16
  /// \see mvIMPACT::BufferBase::getValue16s
  /// \see mvIMPACT::BufferBase::getValue8
  /// \see mvIMPACT::BufferBase::getValue8s
  /// \see mvIMPACT::BufferBase::setValue
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::setValues
  unsigned int getValue32(
		/// The horizontal position within the buffer.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	  	int x,
	  	/// The vertical position within the buffer.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	  	int y,
	  	/// The band of the buffer.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	  	int band=0,
	  	/// The z slice of the buffer.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	  	int slice=0,
	  	/// The frame of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	  	int frame=0) const;

  /// \brief Read a single unsigned 32bit value from a buffer.
  ///
  /// This function allows you to get a single value from a buffer without a need to call
  /// prepareReadAccess before and releaseReadAccess after.
  ///
  /// If the buffer has a datatype different from bdULong, the value will be converted
  /// to unsigned int.
  ///
  /// If the destination data depth is greater than the source data depth, a zero
  /// or sign extension will be performed. If the source data depth is greater
  /// than the destination data depth, the most significant bits are truncated.
  ///
  /// \return The value at the specified location.
  ///
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::getValue32
  /// \see mvIMPACT::BufferBase::getValue32s
  /// \see mvIMPACT::BufferBase::getValue16
  /// \see mvIMPACT::BufferBase::getValue16s
  /// \see mvIMPACT::BufferBase::getValue8
  /// \see mvIMPACT::BufferBase::getValue8s
  /// \see mvIMPACT::BufferBase::setValue
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::setValues
  int getValue32s(
		/// The horizontal position within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x,
		/// The vertical position within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y,
		/// The band of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The z slice of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;

  /// \brief Read a single unsigned 16bit value from a buffer.
  ///
  /// This function allows you to get a single value from a buffer without a need to call
  /// prepareReadAccess before and releaseReadAccess after.
  ///
  /// If the buffer has a datatype different from bdUShort, the value will be converted
  /// to unsigned short.
  ///
  /// If the destination data depth is greater than the source data depth, a zero
  /// or sign extension will be performed. If the source data depth is greater
  /// than the destination data depth, the most significant bits are truncated.
  ///
  /// \return The value at the specified location.
  ///
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::getValue32
  /// \see mvIMPACT::BufferBase::getValue32s
  /// \see mvIMPACT::BufferBase::getValue16
  /// \see mvIMPACT::BufferBase::getValue16s
  /// \see mvIMPACT::BufferBase::getValue8
  /// \see mvIMPACT::BufferBase::getValue8s
  /// \see mvIMPACT::BufferBase::setValue
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::setValues
  unsigned short getValue16(
		/// The horizontal position within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x,
		/// The vertical position within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y,
		/// The band of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The z slice of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;

  /// \brief Read a single signed 16bit value from a buffer.
  ///
  /// This function allows you to get a single value from a buffer without a need to call
  /// prepareReadAccess before and releaseReadAccess after.
  ///
  /// If the buffer has a datatype different from bdShort, the value will be converted
  /// to short.
  ///
  /// If the destination data depth is greater than the source data depth, a zero
  /// or sign extension will be performed. If the source data depth is greater
  /// than the destination data depth, the most significant bits are truncated.
  ///
  /// \return The value at the specified location.
  ///
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::getValue32
  /// \see mvIMPACT::BufferBase::getValue32s
  /// \see mvIMPACT::BufferBase::getValue16
  /// \see mvIMPACT::BufferBase::getValue16s
  /// \see mvIMPACT::BufferBase::getValue8
  /// \see mvIMPACT::BufferBase::getValue8s
  /// \see mvIMPACT::BufferBase::setValue
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::setValues
  short getValue16s(
		/// The horizontal position within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x,
		/// The vertical position within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y,
		/// The band of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The z slice of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;

  /// \brief Read a single unsigned char value from a buffer.
  ///
  /// This function allows you to get a single value from a buffer without a need to call
  /// prepareReadAccess before and releaseReadAccess after.
  ///
  /// If the buffer has a datatype different from bdUchar, the value will be converted
  /// to unsigned char.
  ///
  /// If the destination data depth is greater than the source data depth, a zero
  /// or sign extension will be performed. If the source data depth is greater
  /// than the destination data depth, the most significant bits are truncated.
  ///
  /// \return The value at the specified location.
  ///
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::getValue32
  /// \see mvIMPACT::BufferBase::getValue32s
  /// \see mvIMPACT::BufferBase::getValue16
  /// \see mvIMPACT::BufferBase::getValue16s
  /// \see mvIMPACT::BufferBase::getValue8
  /// \see mvIMPACT::BufferBase::getValue8s
  /// \see mvIMPACT::BufferBase::setValue
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::setValues
  unsigned char getValue8(
		/// The horizontal position within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x,
		/// The vertical position within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y,
		/// The band of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The z slice of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;

  /// \brief Fead a single signed 8bit value from a buffer.
  ///
  /// This function allows you to get a single value from a buffer without a need to call
  /// prepareReadAccess before and releaseReadAccess after.
  ///
  /// If the buffer has a datatype different from bdChar, the value will be converted
  /// to char.
  ///
  /// If the destination data depth is greater than the source data depth, a zero
  /// or sign extension will be performed. If the source data depth is greater
  /// than the destination data depth, the most significant bits are truncated.
  ///
  /// \return The value at the specified location.
  ///
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::getValue32
  /// \see mvIMPACT::BufferBase::getValue32s
  /// \see mvIMPACT::BufferBase::getValue16
  /// \see mvIMPACT::BufferBase::getValue16s
  /// \see mvIMPACT::BufferBase::getValue8
  /// \see mvIMPACT::BufferBase::getValue8s
  /// \see mvIMPACT::BufferBase::setValue
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::setValues
  char getValue8s(
		/// The horizontal position within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x,
		/// The vertical position within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y,
		/// The band of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The z slice of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;

  /// \brief Write a single floating point value to a buffer.
  ///
  /// This function allows you to set a single value in a buffer without a need to call
  /// prepareReadAccess before and releaseReadAccess after.
  ///
  /// If the buffer has a datatype different from bdDouble, the value will be converted
  /// to the buffer type.
  ///
  /// \return A reference to this BufferBase object.
  ///
  /// \see mvIMPACT::BufferBase::setValue
  /// \see mvIMPACT::BufferBase::setValue32
  /// \see mvIMPACT::BufferBase::setValue32s
  /// \see mvIMPACT::BufferBase::setValue16
  /// \see mvIMPACT::BufferBase::setValue16s
  /// \see mvIMPACT::BufferBase::setValue8
  /// \see mvIMPACT::BufferBase::setValue8s
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::setValues
  BufferBase& setValue(
		/// The value to write into the buffer.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="%(instance)s.datatypeMinValue"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.datatypeMaxValue"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		double value,
		/// The horizontal position within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x,
		/// The vertical position within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y,
		/// The band of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The z slice of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0);

  /// \brief Write a single unsigned 32bit point value to a buffer.
  ///
  /// This function allows you to set a single value in a buffer without a need to call
  /// prepareReadAccess before and releaseReadAccess after.
  ///
  /// If the buffer has a datatype different from bdULong, the value will be converted
  /// to the buffer type.
  ///
  /// If the destination data depth is greater than the source data depth, a zero
  /// or sign extension will be performed. If the source data depth is greater
  /// than the destination data depth, the most significant bits are truncated.
  ///
  /// \return A reference to this BufferBase object.
  ///
  /// \see mvIMPACT::BufferBase::setValue
  /// \see mvIMPACT::BufferBase::setValue32
  /// \see mvIMPACT::BufferBase::setValue32s
  /// \see mvIMPACT::BufferBase::setValue16
  /// \see mvIMPACT::BufferBase::setValue16s
  /// \see mvIMPACT::BufferBase::setValue8
  /// \see mvIMPACT::BufferBase::setValue8s
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::setValues
  BufferBase& setValue32(
		/// The value to write into the buffer.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(instance)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(instance)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		unsigned int value,
		/// The horizontal position within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x,
		/// The vertical position within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y,
		/// The band of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The z slice of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0);

  /// \brief Write a single signed 32bit point value to a buffer.
  ///
  /// This function allows you to set a single value in a buffer without a need to call
  /// prepareReadAccess before and releaseReadAccess after.
  ///
  /// If the buffer has a datatype different from bdLong, the value will be converted
  /// to the buffer type.
  ///
  /// If the destination data depth is greater than the source data depth, a zero
  /// or sign extension will be performed. If the source data depth is greater
  /// than the destination data depth, the most significant bits are truncated.
  ///
  /// \return A reference to this BufferBase object.
  ///
  /// \see mvIMPACT::BufferBase::setValue
  /// \see mvIMPACT::BufferBase::setValue32
  /// \see mvIMPACT::BufferBase::setValue32s
  /// \see mvIMPACT::BufferBase::setValue16
  /// \see mvIMPACT::BufferBase::setValue16s
  /// \see mvIMPACT::BufferBase::setValue8
  /// \see mvIMPACT::BufferBase::setValue8s
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::setValues
  BufferBase& setValue32s(
		/// The value to write into the buffer.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(instance)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(instance)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int value,
		/// The horizontal position within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x,
		/// The vertical position within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y,
		/// The band of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The z slice of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0);

  /// \brief Write a single unsigned 16bit point value to a buffer.
  ///
  /// This function allows you to set a single value in a buffer without a need to call
  /// prepareReadAccess before and releaseReadAccess after.
  ///
  /// If the buffer has a datatype different from bdUShort, the value will be converted
  /// to the buffer type.
  ///
  /// If the destination data depth is greater than the source data depth, a zero
  /// or sign extension will be performed. If the source data depth is greater
  /// than the destination data depth, the most significant bits are truncated.
  ///
  /// \return A reference to this BufferBase object.
  ///
  /// \see mvIMPACT::BufferBase::setValue
  /// \see mvIMPACT::BufferBase::setValue32
  /// \see mvIMPACT::BufferBase::setValue32s
  /// \see mvIMPACT::BufferBase::setValue16
  /// \see mvIMPACT::BufferBase::setValue16s
  /// \see mvIMPACT::BufferBase::setValue8
  /// \see mvIMPACT::BufferBase::setValue8s
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::setValues
  BufferBase& setValue16(
		/// The value to write into the buffer.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(instance)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(instance)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		unsigned short value,
		/// The horizontal position within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x,
		/// The vertical position within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y,
		/// The band of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The z slice of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0);

  /// \brief Write a single signed 16bit point value to a buffer.
  ///
  /// This function allows you to set a single value in a buffer without a need to call
  /// prepareReadAccess before and releaseReadAccess after.
  ///
  /// If the buffer has a datatype different from bdShort, the value will be converted
  /// to the buffer type.
  ///
  /// If the destination data depth is greater than the source data depth, a zero
  /// or sign extension will be performed. If the source data depth is greater
  /// than the destination data depth, the most significant bits are truncated.
  ///
  /// \return A reference to this BufferBase object.
  ///
  /// \see mvIMPACT::BufferBase::setValue
  /// \see mvIMPACT::BufferBase::setValue32
  /// \see mvIMPACT::BufferBase::setValue32s
  /// \see mvIMPACT::BufferBase::setValue16
  /// \see mvIMPACT::BufferBase::setValue16s
  /// \see mvIMPACT::BufferBase::setValue8
  /// \see mvIMPACT::BufferBase::setValue8s
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::setValues
  BufferBase& setValue16s(
		/// The value to write into the buffer.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(instance)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(instance)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		short value,
		/// The horizontal position within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x,
		/// The vertical position within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y,
		/// The band of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The z slice of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0);

  /// \brief Write a single unsigned 8bit point value to a buffer.
  ///
  /// This function allows you to set a single value in a buffer without a need to call
  /// prepareReadAccess before and releaseReadAccess after.
  ///
  /// If the buffer has a datatype different from bdUChar, the value will be converted
  /// to the buffer type.
  ///
  /// If the destination data depth is greater than the source data depth, a zero
  /// or sign extension will be performed. If the source data depth is greater
  /// than the destination data depth, the most significant bits are truncated.
  ///
  /// \return A reference to this BufferBase object.
  ///
  /// \see mvIMPACT::BufferBase::setValue
  /// \see mvIMPACT::BufferBase::setValue32
  /// \see mvIMPACT::BufferBase::setValue32s
  /// \see mvIMPACT::BufferBase::setValue16
  /// \see mvIMPACT::BufferBase::setValue16s
  /// \see mvIMPACT::BufferBase::setValue8
  /// \see mvIMPACT::BufferBase::setValue8s
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::setValues
  BufferBase& setValue8(
		/// The value to write into the buffer.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(instance)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(instance)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		unsigned char value,
		/// The horizontal position within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x,
		/// The vertical position within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y,
		/// The band of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The z slice of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0);

  /// \brief Write a single signed 8bit point value to a buffer.
  ///
  /// This function allows you to set a single value in a buffer without a need to call
  /// prepareReadAccess before and releaseReadAccess after.
  ///
  /// If the buffer has a datatype different from bdChar, the value will be converted
  /// to the buffer type.
  ///
  /// If the destination data depth is greater than the source data depth, a zero
  /// or sign extension will be performed. If the source data depth is greater
  /// than the destination data depth, the most significant bits are truncated.
  ///
  /// \return A reference to this BufferBase object.
  ///
  /// \see mvIMPACT::BufferBase::setValue
  /// \see mvIMPACT::BufferBase::setValue32
  /// \see mvIMPACT::BufferBase::setValue32s
  /// \see mvIMPACT::BufferBase::setValue16
  /// \see mvIMPACT::BufferBase::setValue16s
  /// \see mvIMPACT::BufferBase::setValue8
  /// \see mvIMPACT::BufferBase::setValue8s
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::setValues
  BufferBase& setValue8s(
		/// The value to write into the buffer.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(instance)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(instance)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		char value,
		/// The horizontal position within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x,
		/// The vertical position within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y,
		/// The band of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The z slice of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0);

  /// \brief Read a rectangular subset of floating point values from a buffer.
  ///
  /// This function allows you to get a rectangular subset of values from a buffer.
  ///
  /// If the buffer has a datatype different from bdDouble, the value will be converted
  /// to double.
  ///
  /// \return The values of the rectangular subset in the form of a one-dimensional vector.
  ///
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::getValues32
  /// \see mvIMPACT::BufferBase::getValues32s
  /// \see mvIMPACT::BufferBase::getValues16
  /// \see mvIMPACT::BufferBase::getValues16s
  /// \see mvIMPACT::BufferBase::getValues8
  /// \see mvIMPACT::BufferBase::getValues8s
  /// \see mvIMPACT::BufferBase::setValues
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::setValue
  std::vector<double> getValues(
		/// The horizontal position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(width)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x=0,
		/// The vertical position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(height)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y=0,
		/// The width of the rectangular subset within the buffer. If you pass 0 here, the width of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(x)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int width=0,
		/// The height of the rectangular subset within the buffer. If you pass 0 here, the height of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(y)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int height=0,
		/// The band of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The z slice of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;

  /// \brief Read a rectangular subset of 32bit values from a buffer.
  ///
  /// This function allows you to get a rectangular subset of values from a buffer.
  ///
  /// If the buffer has a datatype different from bdULong, the value will be converted
  /// to unsigned int.
  ///
  /// If the destination data depth is greater than the source data depth, a zero
  /// or sign extension will be performed. If the source data depth is greater
  /// than the destination data depth, the most significant bits are truncated.
  ///
  /// \return The values of the rectangular subset in the form of a one-dimensional vector.
  ///
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::getValues32
  /// \see mvIMPACT::BufferBase::getValues32s
  /// \see mvIMPACT::BufferBase::getValues16
  /// \see mvIMPACT::BufferBase::getValues16s
  /// \see mvIMPACT::BufferBase::getValues8
  /// \see mvIMPACT::BufferBase::getValues8s
  /// \see mvIMPACT::BufferBase::setValues
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::setValue
  std::vector<unsigned int> getValues32(
		/// The horizontal position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(width)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x=0,
		/// The vertical position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(height)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y=0,
		/// The width of the rectangular subset within the buffer. If you pass 0 here, the width of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(x)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int width=0,
		/// The height of the rectangular subset within the buffer. If you pass 0 here, the height of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(y)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int height=0,
		/// The band of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The z slice of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;

  /// \brief Read a rectangular subset of signed 32bit values from a buffer.
  ///
  /// This function allows you to get a rectangular subset of values from a buffer.
  ///
  /// If the buffer has a datatype different from bdLong, the value will be converted
  /// to int.
  ///
  /// If the destination data depth is greater than the source data depth, a zero
  /// or sign extension will be performed. If the source data depth is greater
  /// than the destination data depth, the most significant bits are truncated.
  ///
  /// \return The values of the rectangular subset in the form of a one-dimensional vector.
  ///
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::getValues32
  /// \see mvIMPACT::BufferBase::getValues32s
  /// \see mvIMPACT::BufferBase::getValues16
  /// \see mvIMPACT::BufferBase::getValues16s
  /// \see mvIMPACT::BufferBase::getValues8
  /// \see mvIMPACT::BufferBase::getValues8s
  /// \see mvIMPACT::BufferBase::setValues
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::setValue
  std::vector<int> getValues32s(
		/// The horizontal position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(width)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x=0,
		/// The vertical position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(height)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y=0,
		/// The width of the rectangular subset within the buffer. If you pass 0 here, the width of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(x)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int width=0,
		/// The height of the rectangular subset within the buffer. If you pass 0 here, the height of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(y)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int height=0,
		/// The band of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The z slice of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;

  /// \brief Read a rectangular subset of 16bit values from a buffer.
  ///
  /// This function allows you to get a rectangular subset of values from a buffer.
  ///
  /// If the buffer has a datatype different from bdUShort, the value will be converted
  /// to unsigned short.
  ///
  /// If the destination data depth is greater than the source data depth, a zero
  /// or sign extension will be performed. If the source data depth is greater
  /// than the destination data depth, the most significant bits are truncated.
  ///
  /// \return The values of the rectangular subset in the form of a one-dimensional vector.
  ///
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::getValues32
  /// \see mvIMPACT::BufferBase::getValues32s
  /// \see mvIMPACT::BufferBase::getValues16
  /// \see mvIMPACT::BufferBase::getValues16s
  /// \see mvIMPACT::BufferBase::getValues8
  /// \see mvIMPACT::BufferBase::getValues8s
  /// \see mvIMPACT::BufferBase::setValues
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::setValue
  std::vector<unsigned short> getValues16(
		/// The horizontal position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(width)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x=0,
		/// The vertical position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(height)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y=0,
		/// The width of the rectangular subset within the buffer. If you pass 0 here, the width of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(x)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int width=0,
		/// The height of the rectangular subset within the buffer. If you pass 0 here, the height of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(y)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int height=0,
		/// The band of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The z slice of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;

  /// \brief Read a rectangular subset of signed 16bit values from a buffer.
  ///
  /// This function allows you to get a rectangular subset of values from a buffer.
  ///
  /// If the buffer has a datatype different from bdShort, the value will be converted
  /// to short.
  ///
  /// If the destination data depth is greater than the source data depth, a zero
  /// or sign extension will be performed. If the source data depth is greater
  /// than the destination data depth, the most significant bits are truncated.
  ///
  /// \return The values of the rectangular subset in the form of a one-dimensional vector.
  ///
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::getValues32
  /// \see mvIMPACT::BufferBase::getValues32s
  /// \see mvIMPACT::BufferBase::getValues16
  /// \see mvIMPACT::BufferBase::getValues16s
  /// \see mvIMPACT::BufferBase::getValues8
  /// \see mvIMPACT::BufferBase::getValues8s
  /// \see mvIMPACT::BufferBase::setValues
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::setValue
  std::vector<short> getValues16s(
		/// The horizontal position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(width)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x=0,
		/// The vertical position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(height)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y=0,
		/// The width of the rectangular subset within the buffer. If you pass 0 here, the width of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(x)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int width=0,
		/// The height of the rectangular subset within the buffer. If you pass 0 here, the height of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(y)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int height=0,
		/// The band of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The z slice of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;

  /// \brief Read a rectangular subset of 8bit values from a buffer.
  ///
  /// This function allows you to get a rectangular subset of values from a buffer.
  ///
  /// If the buffer has a datatype different from bdUChar, the value will be converted
  /// to unsigned char.
  ///
  /// If the destination data depth is greater than the source data depth, a zero
  /// or sign extension will be performed. If the source data depth is greater
  /// than the destination data depth, the most significant bits are truncated.
  ///
  /// \return The values of the rectangular subset in the form of a one-dimensional vector.
  ///
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::getValues32
  /// \see mvIMPACT::BufferBase::getValues32s
  /// \see mvIMPACT::BufferBase::getValues16
  /// \see mvIMPACT::BufferBase::getValues16s
  /// \see mvIMPACT::BufferBase::getValues8
  /// \see mvIMPACT::BufferBase::getValues8s
  /// \see mvIMPACT::BufferBase::setValues
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::setValue
  std::vector<unsigned char> getValues8(
		/// The horizontal position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(width)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x=0,
		/// The vertical position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(height)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y=0,
		/// The width of the rectangular subset within the buffer. If you pass 0 here, the width of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(x)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int width=0,
		/// The height of the rectangular subset within the buffer. If you pass 0 here, the height of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(y)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int height=0,
		/// The band of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The z slice of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;

  /// \brief Read a rectangular subset of signed 8bit values from a buffer.
  ///
  /// This function allows you to get a rectangular subset of values from a buffer.
  ///
  /// If the buffer has a datatype different from bdChar, the value will be converted
  /// to char.
  ///
  /// If the destination data depth is greater than the source data depth, a zero
  /// or sign extension will be performed. If the source data depth is greater
  /// than the destination data depth, the most significant bits are truncated.
  ///
  /// \return The values of the rectangular subset in the form of a one-dimensional vector.
  ///
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::getValues32
  /// \see mvIMPACT::BufferBase::getValues32s
  /// \see mvIMPACT::BufferBase::getValues16
  /// \see mvIMPACT::BufferBase::getValues16s
  /// \see mvIMPACT::BufferBase::getValues8
  /// \see mvIMPACT::BufferBase::getValues8s
  /// \see mvIMPACT::BufferBase::setValues
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::setValue
   std::vector<char> getValues8s(
		/// The horizontal position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(width)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x=0,
		/// The vertical position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(height)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y=0,
		/// The width of the rectangular subset within the buffer. If you pass 0 here, the width of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(x)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int width=0,
		/// The height of the rectangular subset within the buffer. If you pass 0 here, the height of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(y)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int height=0,
		/// The band of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The z slice of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;

  /// \brief Write a rectangular subset of floating point values  to a buffer.
  ///
  /// This function allows you to set a rectangular subset of values in a buffer.
  ///
  /// If the buffer has a datatype different from bdDouble, the value will be converted
  /// to the buffer type.
  ///
  /// \return A reference to this BufferBase object.
  ///
  /// \see mvIMPACT::BufferBase::setValues
  /// \see mvIMPACT::BufferBase::setValues32
  /// \see mvIMPACT::BufferBase::setValues32s
  /// \see mvIMPACT::BufferBase::setValues16
  /// \see mvIMPACT::BufferBase::setValues16s
  /// \see mvIMPACT::BufferBase::setValues8
  /// \see mvIMPACT::BufferBase::setValues8s
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::setValue
  BufferBase& setValues(
		/// The new values of the rectangular subset in the form of a one-dimensional vector.
		const std::vector<double>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, values),
		/// The horizontal position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(width)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x=0,
		/// The vertical position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(height)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y=0,
		/// The width of the rectangular subset within the buffer. If you pass 0 here, the width of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(x)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int width=0,
		/// The height of the rectangular subset within the buffer. If you pass 0 here, the height of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(y)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int height=0,
		/// The band of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The z slice of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0);

  /// \brief Write a rectangular subset of unsigned 32bit values to a buffer.
  ///
  /// This function allows you to set a rectangular subset of values in a buffer.
  ///
  /// If the buffer has a datatype different from bdULong, the values will be converted
  /// to the buffer type.
  ///
  /// If the destination data depth is greater than the source data depth, a zero
  /// or sign extension will be performed. If the source data depth is greater
  /// than the destination data depth, the most significant bits are truncated.
  ///
  /// \return A reference to this BufferBase object.
  ///
  /// \see mvIMPACT::BufferBase::setValues
  /// \see mvIMPACT::BufferBase::setValues32
  /// \see mvIMPACT::BufferBase::setValues32s
  /// \see mvIMPACT::BufferBase::setValues16
  /// \see mvIMPACT::BufferBase::setValues16s
  /// \see mvIMPACT::BufferBase::setValues8
  /// \see mvIMPACT::BufferBase::setValues8s
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::setValue
  BufferBase& setValues32(
		/// The new values of the rectangular subset in the form of a one-dimensional vector.
		const std::vector<unsigned int>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, values),
		/// The horizontal position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(width)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x=0,
		/// The vertical position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(height)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y=0,
		/// The width of the rectangular subset within the buffer. If you pass 0 here, the width of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(x)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int width=0,
		/// The height of the rectangular subset within the buffer. If you pass 0 here, the height of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(y)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int height=0,
		/// The band of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The z slice of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0);

  /// \brief Write a rectangular subset of 32bit values to a buffer.
  ///
  /// This function allows you to set a rectangular subset of values in a buffer.
  ///
  /// If the buffer has a datatype different from bdLong, the values will be converted
  /// to the buffer type.
  ///
  /// If the destination data depth is greater than the source data depth, a zero
  /// or sign extension will be performed. If the source data depth is greater
  /// than the destination data depth, the most significant bits are truncated.
  ///
  /// \return A reference to this BufferBase object.
  ///
  /// \see mvIMPACT::BufferBase::setValues
  /// \see mvIMPACT::BufferBase::setValues32
  /// \see mvIMPACT::BufferBase::setValues32s
  /// \see mvIMPACT::BufferBase::setValues16
  /// \see mvIMPACT::BufferBase::setValues16s
  /// \see mvIMPACT::BufferBase::setValues8
  /// \see mvIMPACT::BufferBase::setValues8s
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::setValue
  BufferBase& setValues32s(
		/// The new values of the rectangular subset in the form of a one-dimensional vector.
		const std::vector<int>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, values),
		/// The horizontal position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(width)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x=0,
		/// The vertical position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(height)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y=0,
		/// The width of the rectangular subset within the buffer. If you pass 0 here, the width of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(x)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int width=0,
		/// The height of the rectangular subset within the buffer. If you pass 0 here, the height of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(y)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int height=0,
		/// The band of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The z slice of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0);

  /// \brief Write a rectangular subset of unsigned 16bit values to a buffer.
  ///
  /// This function allows you to set a rectangular subset of values in a buffer.
  ///
  /// If the buffer has a datatype different from bdUShort, the values will be converted
  /// to the buffer type.
  ///
  /// If the destination data depth is greater than the source data depth, a zero
  /// or sign extension will be performed. If the source data depth is greater
  /// than the destination data depth, the most significant bits are truncated.
  ///
  /// \return A reference to this BufferBase object.
  ///
  /// \see mvIMPACT::BufferBase::setValues
  /// \see mvIMPACT::BufferBase::setValues32
  /// \see mvIMPACT::BufferBase::setValues32s
  /// \see mvIMPACT::BufferBase::setValues16
  /// \see mvIMPACT::BufferBase::setValues16s
  /// \see mvIMPACT::BufferBase::setValues8
  /// \see mvIMPACT::BufferBase::setValues8s
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::setValue
  BufferBase& setValues16(
		/// The new values of the rectangular subset in the form of a one-dimensional vector.
		const std::vector<unsigned short>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, values),
		/// The horizontal position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(width)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x=0,
		/// The vertical position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(height)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y=0,
		/// The width of the rectangular subset within the buffer. If you pass 0 here, the width of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(x)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int width=0,
		/// The height of the rectangular subset within the buffer. If you pass 0 here, the height of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(y)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int height=0,
		/// The band of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The z slice of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0);

  /// \brief Write a rectangular subset of 16bit values to a buffer.
  ///
  /// This function allows you to set a rectangular subset of values in a buffer.
  ///
  /// If the buffer has a datatype different from bdShort, the values will be converted
  /// to the buffer type.
  ///
  /// If the destination data depth is greater than the source data depth, a zero
  /// or sign extension will be performed. If the source data depth is greater
  /// than the destination data depth, the most significant bits are truncated.
  ///
  /// \return A reference to this BufferBase object.
  ///
  /// \see mvIMPACT::BufferBase::setValues
  /// \see mvIMPACT::BufferBase::setValues32
  /// \see mvIMPACT::BufferBase::setValues32s
  /// \see mvIMPACT::BufferBase::setValues16
  /// \see mvIMPACT::BufferBase::setValues16s
  /// \see mvIMPACT::BufferBase::setValues8
  /// \see mvIMPACT::BufferBase::setValues8s
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::setValue
  BufferBase& setValues16s(
		/// The new values of the rectangular subset in the form of a one-dimensional vector.
		const std::vector<short>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, values),
		/// The horizontal position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(width)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x=0,
		/// The vertical position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(height)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y=0,
		/// The width of the rectangular subset within the buffer. If you pass 0 here, the width of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(x)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int width=0,
		/// The height of the rectangular subset within the buffer. If you pass 0 here, the height of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(y)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int height=0,
		/// The band of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The z slice of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0);

  /// \brief Write a rectangular subset of unsigned 8bit values  to a buffer.
  ///
  /// This function allows you to set a rectangular subset of values in a buffer.
  ///
  /// If the buffer has a datatype different from bdUChar, the values will be converted
  /// to the buffer type.
  ///
  /// If the destination data depth is greater than the source data depth, a zero
  /// or sign extension will be performed. If the source data depth is greater
  /// than the destination data depth, the most significant bits are truncated.
  ///
  /// \return A reference to this BufferBase object.
  ///
  /// \see mvIMPACT::BufferBase::setValues
  /// \see mvIMPACT::BufferBase::setValues32
  /// \see mvIMPACT::BufferBase::setValues32s
  /// \see mvIMPACT::BufferBase::setValues16
  /// \see mvIMPACT::BufferBase::setValues16s
  /// \see mvIMPACT::BufferBase::setValues8
  /// \see mvIMPACT::BufferBase::setValues8s
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::setValue
  BufferBase& setValues8(
		/// The new values of the rectangular subset in the form of a one-dimensional vector.
		const std::vector<unsigned char>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, values),
		/// The horizontal position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(width)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x=0,
		/// The vertical position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(height)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y=0,
		/// The width of the rectangular subset within the buffer. If you pass 0 here, the width of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(x)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int width=0,
		/// The height of the rectangular subset within the buffer. If you pass 0 here, the height of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(y)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int height=0,
		/// The band of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The z slice of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0);

  /// \brief Write a rectangular subset of 8bit values to a buffer.
  ///
  /// This function allows you to set a rectangular subset of values in a buffer.
  ///
  /// If the buffer has a datatype different from bdChar, the values will be converted
  /// to the buffer type.
  ///
  /// If the destination data depth is greater than the source data depth, a zero
  /// or sign extension will be performed. If the source data depth is greater
  /// than the destination data depth, the most significant bits are truncated.
  ///
  /// \return A reference to this BufferBase object.
  ///
  /// \see mvIMPACT::BufferBase::setValues
  /// \see mvIMPACT::BufferBase::setValues32
  /// \see mvIMPACT::BufferBase::setValues32s
  /// \see mvIMPACT::BufferBase::setValues16
  /// \see mvIMPACT::BufferBase::setValues16s
  /// \see mvIMPACT::BufferBase::setValues8
  /// \see mvIMPACT::BufferBase::setValues8s
  /// \see mvIMPACT::BufferBase::getValues
  /// \see mvIMPACT::BufferBase::getValue
  /// \see mvIMPACT::BufferBase::setValue
  BufferBase& setValues8s(
		/// The new values of the rectangular subset in the form of a one-dimensional vector.
		const std::vector<char>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, values),
		/// The horizontal position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(width)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x=0,
		/// The vertical position of the rectangular subset within the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(height)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int y=0,
		/// The width of the rectangular subset within the buffer. If you pass 0 here, the width of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-%(x)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int width=0,
		/// The height of the rectangular subset within the buffer. If you pass 0 here, the height of the buffer will be used.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.height-%(y)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int height=0,
		/// The band of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The z slice of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame of the buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0);

public:

  /// \brief Get the buffer size.

  ///
  /// Every buffer has at least width 1 and height 1.
  /// \see mvIMPACT::BufferBase::getWidth
  /// \see mvIMPACT::BufferBase::getHeight
  Size getSize() const;


  /// \brief Get the buffer width.

  ///
  /// Every buffer has at least width 1.
  /// \see mvIMPACT::BufferBase::getHeight
  int getWidth() const;


  /// \brief Get the buffer height.

  ///
  /// Every buffer has at least height 1.
  /// \see mvIMPACT::BufferBase::getWidth
  int getHeight() const;


  /// \brief Get the minimum value represented by a buffer's datatype.

  ///
  /// Get the minimum value which can be represented by the buffers datatype. If, for example, the datatype of a buffer is bdChar,
  /// the minimum value is -128.
  double getDatatypeMinValue() const;

  /// \brief Get the maximum value represented by a buffer's datatype.

  ///
  /// Get the maximum value which can be represented by the buffers datatype. If, for example, the datatype of a buffer is bdChar,
  /// the maximum value is 127.
  double getDatatypeMaxValue() const;


  /// \brief Get the number of bands.
  ///
  /// This is 1 for a monochrome
  /// buffer and 3 for a color buffer.
  /// Every buffer has at least 1 band.
  /// \see mvIMPACT::BufferBase::setBands
  int getBands() const;

#ifndef WRAP_ANY
  /// \brief Get the number of bands.
  ///
  /// This is 1 for a monochrome
  /// buffer and 3 for a color buffer.
  /// Every buffer has at least 1 band.
  /// \see mvIMPACT::BufferBase::setBands
  BufferBase::BandsProxy getBands();
#endif // #ifndef WRAP_PYTHON

  /// \brief Set the number of bands.
  ///
  /// Set 1 for a monochrome
  /// buffer and 3 for a color buffer
  /// You must set this parameter to at least 1.
  /// \see mvIMPACT::BufferBase::getBands
  BufferBase& setBands(
			/// the number of bands.
		  	/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int bands);


  /// \brief Get the number of slices.

  /// Returns the number of z-slices the buffer has.
  /// This is at least 1 for every buffer.
  /// \see mvIMPACT::BufferBase::setSlices
  int getSlices() const;

#ifndef WRAP_ANY
  /// \brief Get the number of slices.

  /// Returns the number of z-slices the buffer has.
  /// This is at least 1 for every buffer.
  /// \see mvIMPACT::BufferBase::setSlices
  SlicesProxy getSlices();
#endif // #ifndef WRAP_PYTHON

  /// \brief Set the number of slices.
  /// 	
  /// Specifies the number of z-slices the buffer should have.
  /// You must set this parameter
  /// at least to 1.
  /// \see mvIMPACT::BufferBase::getSlices
  BufferBase& setSlices(
			/// number of slices.
		  	/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int slices);


  /// \brief Get the number of frames.

  /// Returns the number of time-slices the buffer has.
  /// every buffer has at least 1 time-slice
  /// \see mvIMPACT::BufferBase::setFrames
  int getFrames() const;

#ifndef WRAP_ANY
  /// \brief Get the number of frames.

  /// Returns the number of time-slices the buffer has.
  /// every buffer has at least 1 time-slice
  /// \see mvIMPACT::BufferBase::setFrames
  FramesProxy getFrames();
#endif // #ifndef WRAP_PYTHON

  /// \brief Set the number of frames.

  /// Specifies the number of time-slices the buffer should have. You must set this
  /// parameter at least to 1.
  /// \see mvIMPACT::BufferBase::getFrames
  BufferBase& setFrames(
			/// number of frames.
		  	/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int frames);


  /// \brief Get the x- and y-offset.
  ///
  /// \see mvIMPACT::BufferBase::setXYOffset
  Point getXYOffset() const;

#ifndef WRAP_ANY
  /// \brief Get the x- and y-offset.
  ///
  /// \see mvIMPACT::BufferBase::setXYOffset
  XYOffsetProxy getXYOffset();
#endif // #ifndef WRAP_PYTHON

  /// \brief Set the x- and y-offset.
  ///
  /// \see mvIMPACT::BufferBase::getXYOffset
  BufferBase& setXYOffset(/// the x- and y-offset
			 const Point& xyOffset);


  /// \brief Get the x-offset of a child buffer.
  ///
  /// \see mvIMPACT::BufferBase::setXOffset
  int getXOffset() const;

#ifndef WRAP_ANY
  /// \brief Get the x-offset of a child buffer.
  ///
  /// \see mvIMPACT::BufferBase::setXOffset
  XOffsetProxy getXOffset();
#endif // #ifndef WRAP_PYTHON

  /// \brief Set the x-offset of a child buffer.
  ///
  /// \see mvIMPACT::BufferBase::getXOffset
  BufferBase& setXOffset(
			/// the x offset
		  	/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.parentBuffer.width-%(instance)s.width"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int xOffset);


  /// \brief Get the y-offset of a child buffer.
  ///
  /// \see mvIMPACT::BufferBase::setYOffset
  int getYOffset() const;

#ifndef WRAP_ANY
  /// \brief Get the y-offset of a child buffer.
  ///
  /// \see mvIMPACT::BufferBase::setYOffset
  YOffsetProxy getYOffset();
#endif // #ifndef WRAP_PYTHON

  /// \brief Set the y-offset of a child buffer.
  ///
  /// \see mvIMPACT::BufferBase::getYOffset
  BufferBase& setYOffset(
			/// the y offset
		  	/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.parentBuffer.height-%(instance)s.height"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int yOffset);


  /// \brief Get the band offset of a child buffer.
  ///
  /// \see mvIMPACT::BufferBase::setBandsOffset.
  int getBandsOffset() const;

#ifndef WRAP_ANY
  /// \brief Get the band offset of a child buffer.
  ///
  /// \see mvIMPACT::BufferBase::setBandsOffset.
  BandsOffsetProxy getBandsOffset();
#endif // #ifndef WRAP_PYTHON

  /// \brief Set the band offset of a child buffer.
  ///
  /// \see mvIMPACT::BufferBase::getBandsOffset
  BufferBase& setBandsOffset(
			    /// band offset.
			  	/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
				/// <mvParamMax><mvParamComplex Python="%(instance)s.parentBuffer.bands-1"/></mvParamMax>
				/// </mvParamRange>
				/// \endxmlonly
			    int bandsOffset
			    );


  /// \brief Get slices offset of a child buffer.
  ///
  /// \see mvIMPACT::BufferBase::setSlicesOffset
  int getSlicesOffset() const;

#ifndef WRAP_ANY
  /// \brief Get slices offset of a child buffer.
  ///
  /// \see mvIMPACT::BufferBase::setSlicesOffset
  SlicesOffsetProxy getSlicesOffset();
#endif // #ifndef WRAP_PYTHON

  /// \brief Set slices offset of a child buffer
  ///
  /// \see mvIMPACT::BufferBase::getSlicesOffset
  BufferBase& setSlicesOffset(
				/// slices offset
			  	/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
				/// <mvParamMax><mvParamComplex Python="%(instance)s.parentBuffer.slices-1"/></mvParamMax>
				/// </mvParamRange>
				/// \endxmlonly
			    int slicesOffset);


  /// \brief Get frames offset of a child buffer
  ///
  /// \see mvIMPACT::BufferBase::setFramesOffset
  int getFramesOffset() const;

#ifndef WRAP_ANY
  /// \brief Get frames offset of a child buffer
  ///
  /// \see mvIMPACT::BufferBase::setFramesOffset
  FramesOffsetProxy getFramesOffset();
#endif // #ifndef WRAP_PYTHON

  /// \brief Set frames offset of a child buffer.
  ///
  /// \see mvIMPACT::BufferBase::getFramesOffset
  BufferBase& setFramesOffset(
				/// frame offset
			  	/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
				/// <mvParamMax><mvParamComplex Python="%(instance)s.parentBuffer.frames-1"/></mvParamMax>
				/// </mvParamRange>
				/// \endxmlonly
			    int framesOffset);


  /// \brief Get color space.
  ///
  /// Returns the colorspace of the buffer
  /// \see #ColorSpace
  /// \see mvIMPACT::BufferBase::setColorSpace
  ColorSpace getColorSpace() const;

#ifndef WRAP_ANY
  /// \brief Get color space.
  ///
  /// Returns the colorspace of the buffer
  /// \see #ColorSpace
  /// \see mvIMPACT::BufferBase::setColorSpace
  ColorSpaceProxy getColorSpace();
#endif // #ifndef WRAP_PYTHON

  /// \brief Set color space.
  ///
  /// Sets the new colorspace for the buffer
  /// \see #ColorSpace
  /// \see mvIMPACT::BufferBase::getColorSpace
  BufferBase& setColorSpace(/// the new colorspace
			    ColorSpace colorSpace);


  /// \brief Computes the white balance data for the image.
  ///
  /// This method expects the image to be a bayer mosaic image or a color
  /// image with three bands. The image should have been acquired from a
  /// white target. The method will then compute the respective red, green and
  /// blue offsets and gains in order to acquire white-balanced images.
  void whiteBalance();


  /// \brief Set the Bayer Mosaic red gain for the white balance.
  double getBayerMosaicRedGain() const;

#ifndef WRAP_ANY
  /// \brief Set the Bayer Mosaic red gain for the white balance.
  BayerMosaicRedGainProxy getBayerMosaicRedGain();
#endif // #ifndef WRAP_PYTHON

  /// \brief Get the Bayer Mosaic red gain for the white balance.
  BufferBase& setBayerMosaicRedGain(double v);


  /// \brief Set the Bayer Mosaic red offset for the white balance.
  double getBayerMosaicRedOffset() const;

#ifndef WRAP_ANY
  /// \brief Set the Bayer Mosaic red offset for the white balance.
  BayerMosaicRedOffsetProxy getBayerMosaicRedOffset();
#endif // #ifndef WRAP_PYTHON

  /// \brief Get the Bayer Mosaic red offset for the white balance.
  BufferBase& setBayerMosaicRedOffset(double v);


  /// \brief Set the Bayer Mosaic green gain for the white balance.
  double getBayerMosaicGreenGain() const;

#ifndef WRAP_ANY
  /// \brief Set the Bayer Mosaic green gain for the white balance.
  BayerMosaicGreenGainProxy getBayerMosaicGreenGain();
#endif // #ifndef WRAP_PYTHON

  /// \brief Get the Bayer Mosaic green gain for the white balance.
  BufferBase& setBayerMosaicGreenGain(double v);


  /// \brief Set the Bayer Mosaic green offset for the white balance.
  double getBayerMosaicGreenOffset() const;

#ifndef WRAP_ANY
  /// \brief Set the Bayer Mosaic green offset for the white balance.
  BayerMosaicGreenOffsetProxy getBayerMosaicGreenOffset();
#endif // #ifndef WRAP_PYTHON

  /// \brief Get the Bayer Mosaic green offset for the white balance.
  BufferBase& setBayerMosaicGreenOffset(double v);


  /// \brief Get the Bayer Mosaic blue gain for the white balance.
  double getBayerMosaicBlueGain() const;

#ifndef WRAP_ANY
  /// \brief Get the Bayer Mosaic blue gain for the white balance.
  BayerMosaicBlueGainProxy getBayerMosaicBlueGain();
#endif // #ifndef WRAP_PYTHON

  /// \brief Set the Bayer Mosaic blue gain for the white balance.
  BufferBase& setBayerMosaicBlueGain(double v);


  /// \brief Get the Bayer Mosaic blue offset for the white balance.
  double getBayerMosaicBlueOffset() const;

#ifndef WRAP_ANY
  /// \brief Get the Bayer Mosaic blue offset for the white balance.
  BayerMosaicBlueOffsetProxy getBayerMosaicBlueOffset();
#endif // #ifndef WRAP_PYTHON

  /// \brief Set the Bayer Mosaic blue offset for the white balance.
  BufferBase& setBayerMosaicBlueOffset(double v);


  /// \brief Get the Bayer Mosaic digital gain for the white balance.
  ///
  /// This value will be multiplied to the color gain values.
  double getBayerMosaicDigitalGain() const;

#ifndef WRAP_ANY
  /// \brief Get the Bayer Mosaic digital gain for the white balance.
  ///
  /// This value will be multiplied to the color gain values.
  BayerMosaicDigitalGainProxy getBayerMosaicDigitalGain();
#endif // #ifndef WRAP_PYTHON

  /// \brief Set the Bayer Mosaic digital gain for the white balance.
  ///
  /// This value will be multiplied to the color gain values.
  BufferBase& setBayerMosaicDigitalGain(double v);


  /// \brief Get the Bayer Mosaic parity.
  ///
  /// The parity can be: GR=0, RG=1, BG=2 or GB=3.
  int getBayerMosaicParity() const;

#ifndef WRAP_ANY
  /// \brief Get the Bayer Mosaic parity.
  ///
  /// The parity can be: GR=0, RG=1, BG=2 or GB=3.
  BayerMosaicParityProxy getBayerMosaicParity();
#endif // #ifndef WRAP_PYTHON

  /// \brief Set the Bayer Mosaic parity.
  ///
  /// The parity can be: GR=0, RG=1, BG=2 or GB=3.
  BufferBase& setBayerMosaicParity(int v);


  /// \brief Check if the buffer is in thread safe state
  ///
  /// Returns \c true if the buffer is in thread safe state, or \c false if not.
  /// \see mvIMPACT::BufferBase::setIsThreadSafe
  bool getIsThreadSafe() const;

#ifndef WRAP_ANY
  /// \brief Check if the buffer is in thread safe state
  ///
  /// Returns \c true if the buffer is in thread safe state, or \c false if not.
  /// \see mvIMPACT::BufferBase::setIsThreadSafe
  IsThreadSafeProxy getIsThreadSafe();
#endif // #ifndef WRAP_PYTHON

  /// \brief Switch thread safe state on/off
  ///
  /// Set this to \c true to set the buffer in thread safe state, or set it to \c false if you don't want that.
  /// \see mvIMPACT::BufferBase::getIsThreadSafe
  BufferBase& setIsThreadSafe(/// flag that specifies if the buffer should be threadsafe or not
			    bool isThreadSafe);


  /// \brief Return the datatype of the buffer
  ///
  /// \see #BufferDatatype
  /// \see mvIMPACT::BufferBase::setDatatype
  BufferDatatype getDatatype() const;

#ifndef WRAP_ANY
  /// \brief Return the datatype of the buffer
  ///
  /// \see #BufferDatatype
  /// \see mvIMPACT::BufferBase::setDatatype
  DatatypeProxy getDatatype();
#endif // #ifndef WRAP_PYTHON

  /// \brief Set the datatype of the buffer
  ///
  /// A buffer can have different datatypes. Use this method to set the desired type.
  /// \see #BufferDatatype
  /// \see mvIMPACT::BufferBase::getDatatype
  BufferBase& setDatatype(/// the datatype of the buffer
			  BufferDatatype datatype);


  /// \brief Get number of bits per sample
  ///
  /// Normally this should be 8 or 16 depending on the datatype you are using
  /// \see mvIMPACT::BufferBase::setBitsPerSample
  int getBitsPerSample() const;

#ifndef WRAP_ANY
  /// \brief Get number of bits per sample
  ///
  /// Normally this should be 8 or 16 depending on the datatype you are using
  /// \see mvIMPACT::BufferBase::setBitsPerSample
  BitsPerSampleProxy getBitsPerSample();
#endif // #ifndef WRAP_PYTHON

  /// \brief Set number of bits per sample
  ///
  /// Normally this should be set to 8 or 16 depending on the datatype you are using
  /// \see mvIMPACT::BufferBase::getBitsPerSample
  BufferBase& setBitsPerSample(
					/// number of bits per sample
				  	/// \xmlonly
					/// <mvParamRange>
					/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
					/// <mvParamMax><mvParamConst value="16"/></mvParamMax>
					/// </mvParamRange>
					/// \endxmlonly
			       int bitsPerSample);


  /// \brief Get the calibration values for the x dimension
  ///
  /// \see mvIMPACT::Calibrator
  /// \see mvIMPACT::BufferBase::setXCalibrator
  Calibrator getXCalibrator() const;

#ifndef WRAP_ANY
  /// \brief Get the calibration values for the x dimension
  ///
  /// \see mvIMPACT::Calibrator
  /// \see mvIMPACT::BufferBase::setXCalibrator
  XCalibratorProxy getXCalibrator();
#endif // #ifndef WRAP_PYTHON

  /// \brief Set the calibration values for the x dimension
  ///
  /// \see mvIMPACT::Calibrator
  /// \see mvIMPACT::BufferBase::getXCalibrator
  BufferBase& setXCalibrator(/// the calibration object
			      const Calibrator& xCalibrator );


  /// \brief Get the calibration values for the y dimension
  ///
  /// \see mvIMPACT::Calibrator
  /// \see mvIMPACT::BufferBase::setYCalibrator
  Calibrator getYCalibrator() const;

#ifndef WRAP_ANY
  /// \brief Get the calibration values for the y dimension
  ///
  /// \see mvIMPACT::Calibrator
  /// \see mvIMPACT::BufferBase::setYCalibrator
  YCalibratorProxy getYCalibrator();
#endif // #ifndef WRAP_PYTHON

  /// \brief Set the calibration values for the y dimension
  ///
  /// \see mvIMPACT::Calibrator
  /// \see mvIMPACT::BufferBase::getYCalibrator
  BufferBase& setYCalibrator( /// the calibration object
			      const Calibrator& yCalibrator );


  /// \brief Get the calibration values for the slice dimension
  ///
  /// \see mvIMPACT::Calibrator
  /// \see mvIMPACT::BufferBase::setSlicesCalibrator
  Calibrator getSlicesCalibrator() const;

#ifndef WRAP_ANY
  /// \brief Get the calibration values for the slice dimension
  ///
  /// \see mvIMPACT::Calibrator
  /// \see mvIMPACT::BufferBase::setSlicesCalibrator
  SlicesCalibratorProxy getSlicesCalibrator();
#endif // #ifndef WRAP_PYTHON

  /// \brief Set the calibration values for the slice dimension
  ///
  /// \see mvIMPACT::Calibrator
  /// \see mvIMPACT::BufferBase::getSlicesCalibrator
  BufferBase& setSlicesCalibrator(/// the calibration object
				   const Calibrator& slicesCalibrator );


  /// \brief Get the calibration values for the frame dimension
  ///
  /// \see mvIMPACT::Calibrator
  /// \see mvIMPACT::BufferBase::setFramesCalibrator
  Calibrator getFramesCalibrator() const;

#ifndef WRAP_ANY
  /// \brief Get the calibration values for the frame dimension
  ///
  /// \see mvIMPACT::Calibrator
  /// \see mvIMPACT::BufferBase::setFramesCalibrator
  FramesCalibratorProxy getFramesCalibrator();
#endif // #ifndef WRAP_PYTHON

  /// \brief Set the calibration values for the frame dimension
  ///
  /// \see mvIMPACT::Calibrator
  /// \see mvIMPACT::BufferBase::getFramesCalibrator
  BufferBase& setFramesCalibrator(/// the calibration object
				   const Calibrator& framesCalibrator );


#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
  mvIMPACT_C::IPL_BUFHANDLE getHandle  () const;
  int getUseCount() const;
  bool getIsUnique   () const;
#endif // #ifndef WRAP_PYTHON
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS


  /// \brief Retrieve if the buffer is assigned.
  ///
  /// Buffers created with the standard constructor of BufferBase and its subclasses
  /// are unassigned buffer i.e. they are not associated with a buffer of the
  /// underlying C-API.
  bool getIsAssigned() const;


  /// \brief Access the parent buffer.
  ///
  /// For allocated child buffers a pointer to the parent buffer
  /// is returned. Otherwise, NULL is returned.
  const BufferBase* getParentBuffer() const;


  /// \brief Check if the buffer is a child
  ///
  /// Returns \c true for a child buffer. Returns \c false for a topmost parent buffer.
  /// \see mvIMPACT::BufferBase::getIsParent
  bool getIsChild() const;


  /// \brief Check if the buffer is a parent.
  ///
  /// Returns \c true for a topmost parent buffer. For child buffers this function returns \c false.
  /// \see mvIMPACT::BufferBase::getIsChild
  bool getIsParent() const;


  /// \brief Lock a buffer against write accesses of other threads.
  ///
  /// When the BufferLock object goes
  /// out of scope, the lock is removed.
  /// \see mvIMPACT::BufferLock
  /// \see mvIMPACT::BufferBase::readWriteLock
  BufferLock readLock() const;

  /// \brief Lock a buffer against read/write accesses of other threads.
  ///
  /// When the BufferLock object goes
  /// out of scope, the lock is removed.
  /// \see mvIMPACT::BufferLock
  /// \see mvIMPACT::BufferBase::readLock
  BufferLock readWriteLock();


  /// \brief Get the buffer type.
  ///
  /// A BufferBase object can be of type Image,Palette etc. Use this function to get the type.
  /// \see #BufferAttribute
  BufferAttribute getAttribute() const;


  /// \brief Get size of the buffer's datatype in bytes
  ///
  /// \see #BufferDatatype
  int getDatatypeSize() const;


  /// \brief Get the horizontal calibration state.
  ///
  /// Returns \c true if the buffer is horizontally calibrated or \c false if not
  /// \see mvIMPACT::BufferBase::setXCalibrator
  bool getIsHorizontalCalibrated() const;


  /// \brief Get the vertical calibration state.
  ///
  /// Returns \c true if the buffer is vertically calibrated or \c false if not
  /// \see mvIMPACT::BufferBase::setYCalibrator
  bool getIsVerticalCalibrated() const;


  /// \brief Get the slices calibration state.
  ///
  /// Returns \c true if the slice dimension is calibrated or \c false if not
  /// \see mvIMPACT::BufferBase::setSlicesCalibrator
  bool getIsSlicesCalibrated() const;


  /// \brief Get the frames calibration state.
  ///
  /// Returns \c true if the frame dimension is calibrated or \c false if not
  /// \see mvIMPACT::BufferBase::setFramesCalibrator
  bool getIsFramesCalibrated() const;


  /// \brief Returns the duration of a sequence.
  ///
  /// Returns the sequence duration in seconds.
  double getSequenceDuration() const;

public:
  /// \brief Construct a non-allocated buffer.
  BufferBase();

  /// \brief Construct an allocated buffer.
  ///
  ///
  BufferBase
    (
    /// The horizontal size of the buffer.
  	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
	/// </mvParamRange>
	/// \endxmlonly
	int width,
    /// The vertical size of the buffer.
  	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
	/// </mvParamRange>
	/// \endxmlonly
    int height,
    /// The band size of the buffer.
  	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
	/// </mvParamRange>
	/// \endxmlonly
    int bands,
    /// The slice size of the buffer.
  	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
	/// </mvParamRange>
	/// \endxmlonly
    int slices,
    /// The frame size of the buffer.
  	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
	/// </mvParamRange>
	/// \endxmlonly
    int frames,
    /// The datatype of the buffer.
    BufferDatatype dataType,
    /// The attribute of the buffer.
    BufferAttribute attribute
    );

  /// \brief Construct an allocated BufferBase buffer from data addressed by a pointer.
  ///
  /// The pointer must point to a block of data, and the size and layout of this
  /// block of data is defined by the width, height, bands, slices, frames and datatype parameters.
  ///
  /// The datatype parameters specifies the type of a single pixel. The width parameter
  /// specifies the number of pixels in a single row. The height parameter specifies the 
  /// number of rows. The bands parameter specifies the number of color bands. The slices
  /// parameter specifies the number of slices. The frame parameter specifies the number
  /// of slices.
  ///
  /// The pixels, rows, bands, slices and frames are packed as densely as possible, without any 
  /// extra padding between.
  /// 
  /// The size of the block of data addressed by ptr is 
  /// width * height * bands * slices * frames * sizeof(datatype).
  /// 
  /// The lifetime of the block of data must be managed by the user. In particular, the data block
  /// addressed by ptr must not be freed before the BufferBase buffer is destroyed.
  BufferBase(
	  /// The horizontal size of the buffer.
	  /// \xmlonly
	  /// <mvParamRange>
	  /// <mvParamMin><mvParamConst value="1"/></mvParamMin>
	  /// </mvParamRange>
	  /// \endxmlonly
	  int width,
	  /// The vertical size of the buffer.
	  /// \xmlonly
	  /// <mvParamRange>
	  /// <mvParamMin><mvParamConst value="1"/></mvParamMin>
	  /// </mvParamRange>
	  /// \endxmlonly
	  int height,
	  /// The band size of the buffer.
	  /// \xmlonly
	  /// <mvParamRange>
	  /// <mvParamMin><mvParamConst value="1"/></mvParamMin>
	  /// </mvParamRange>
	  /// \endxmlonly
	  int bands,
	  /// The slice size of the buffer.
	  /// \xmlonly
	  /// <mvParamRange>
	  /// <mvParamMin><mvParamConst value="1"/></mvParamMin>
	  /// </mvParamRange>
	  /// \endxmlonly
	  int slices,
	  /// The frame size of the buffer.
	  /// \xmlonly
	  /// <mvParamRange>
	  /// <mvParamMin><mvParamConst value="1"/></mvParamMin>
	  /// </mvParamRange>
	  /// \endxmlonly
	  int frames,
	  /// The datatype of the buffer.
	  BufferDatatype dataType,
	  /// The attribute of the buffer.
	  BufferAttribute attribute,
	  /// The pointer to address the buffer data.
	  void * ptr);


  /// \brief Construct an allocated BufferBase buffer from an xml string.
  explicit BufferBase(/// the xml string to construct the buffer.
		      const std::string& xmlString);


  /// \brief Construct an allocated child BufferBase buffer from an xml string
  BufferBase(/// Reference to parent
	     const BufferBase& parent,
	     /// The xml string to allocate from
	     const std::string& xmlString);


  /// \brief Construct an allocated child BufferBase buffer.
  BufferBase(
		/// Reference to parent
	    const BufferBase& parent,
	    /// specifies the x coordinate of the upper-left corner of the child buffer
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.width-%(width)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	    int xOffset,
	    /// specifies the y coordinate of the upper-left corner of the child buffer
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.height-%(height)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	    int yOffset,
	    /// specifies the band offset for the child buffer
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.bands-%(bands)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	    int bandsOffset,
	    /// specifies the slice offset for the child buffer
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.slices-%(slices)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	    int slicesOffset,
	    /// specifies the frame offset for the child buffer
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.frames-%(frames)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	    int framesOffset,
	    /// specifies the width of the child buffer
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.width-%(xOffset)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	    int width,
	    /// specifies the height of the child buffer
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.height-%(yOffset)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	    int height,
	    /// specifies the number of bands for the child buffer
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.ands-%(bandsOffset)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	    int bands,
	    /// specifies the number of slices for the child buffer
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.slices-%(slicesOffset)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	    int slices,
	    /// specifies the number of frames for the child buffer
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.frames-%(framesOffset)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	    int frames);


  /// \brief Construct an allocated child BufferBase buffer.
  ///
  /// This method uses a Coord object to pass the offset values.
  /// \see mvIMPACT::Coord
  BufferBase(
		/// Reference to parent
	    const BufferBase& parent,
	    /// object that specifies the different offsets of the child buffer
	    const Coord &offset,
	    /// specifies the width of the child buffer
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.width-%(offset)s.x"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	    int width,
	    /// specifies the height of the child buffer
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.height-%(offset)s.y"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	    int height,
	    /// specifies the number of bands for the child buffer
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.bands-%(offset)s.band"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	    int bands,
	    /// specifies the number of slices for the child buffer
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.slices-%(offset)s.slice"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	    int slices,
	    /// specifies the number of frames for the child buffer
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.frames-%(offset)s.frame"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	    int frames);


  /// \brief Construct a BufferBase object from \a src.
  BufferBase(/// the object to copy from
	     const BufferBase& src);


  /// \brief Destructor.
  virtual ~BufferBase() = 0;


  // Abstract class. The user must not instantiate it!

#ifndef WRAP_PYTHON
  /// \brief Create a copy on the heap.
  ///
  /// This is useful to make a copy of an unknown buffer.
  /// \code
  /// Image img;
  /// BufferBase* p    = &img;
  /// BufferBase* copy = p->makeShallowCopy(); // copy now holds a duplicate of img.
  /// \endcode
  /// \note This is an abstract function.
  virtual BufferBase* makeShallowCopy() const = 0;
#endif // WRAP_PYTHON

  /// \brief Change the position and size of a 2D child buffer.
  ///
  /// This function changes the position and size of a 2D child buffer. You can use it to move child
  /// buffers with respect to their parent buffer.
  ///
  void translate(
		/// Specifies the new horizontal offset relative to the parent buffer origin. The parent
		/// buffer origin is the top left corner. This value may not exceed the width of the
		/// parent buffer
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.parentBuffer.width-%(width)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int xOffset,
		/// Specifies the new vertical offset relative to the parent buffer origin. The parent
		/// buffer origin is the top left corner. This value may not exceed the height of the
		/// parent buffer.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.parentBuffer.height-%(height)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int yOffset,
		/// Specifies the new width of the child buffer starting from \a x. This value may not
		/// exceed the parent buffer width.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.parentBuffer.width-%(xOffset)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int width,
		/// Specifies the new height of the child buffer starting from \a y. This value may not
		/// exceed the parent buffer height.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.parentBuffer.height-%(yOffset)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int height);


  /// \brief Serialize the buffer into an xml string.
  ///
  /// Set \a asParent to \c true if you want the buffer to be serialized as a parent buffer.
  std::string asXml(/// flag that indicates whether the buffer should be saved as a parent or not.
		    bool asParent = false,
		    /// flag that indicates whether data should be compressed or not
		    bool compressed = false) const;


  /// \brief Free a dimension of a buffer.
  ///
  /// This function allows you to remove one or more planes from the band-, slice- or frame-dimension.
  /// The handle of the buffer might be changed by this function. You cannot remove all planes of the
  /// specified dimension, at least one must remain. Only parent type buffers can be processed.
  /// \see #DimensionSpec
  /// \see #LocationSpec
  void freeDim(
	       /// Specifies the dimension to be removed. It can be set to the following constants:
	       /// - dsDimB:  removes one or more bands from the band-dimension.
	       /// - dsDimZ:  removes one or more slices from the z-dimension.
	       /// - dimTime: removes one or more frames from the t-dimension.
	       DimensionSpec dimensionSpec,
	       /// A vector that contains the zero-based offsets of the planes to be removed within a dimension.
	       const std::vector<int>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR,offsets),
	       /// Specifies the storage location for temporary data. Temporary data can be kept in system memory
	       /// or on the hard disk. System memory is faster, disk is slower.
	       LocationSpec locationSpec = lsMemory);



#ifndef WRAP_ANY
  	/// \brief Overwrite current object with \a src.
  BufferBase& operator=(/// the other object
			const BufferBase& src);
#endif // #ifndef WRAP_ANY

protected:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  /// \brief Construct an allocated buffer from a handle
  explicit BufferBase(/// The buffer handle
		    mvIMPACT_C::IPL_BUFHANDLE bufhandle, bool mustCleanup=true);
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS


  /// \brief Check if buffer is a child buffer
  ///
  /// Returns \c true if the buffer is a child buffer or \c false if it is a parent buffer
  bool getChildID() const;


  /// \brief Get the minimal value of a single plane of the buffer.
  ///
  /// The meaning differs depending on the type of the buffer:
  /// - Image: the minimal value found in the image is returned
  /// - Histogram: the smallest grayscale value with a nonzero frequency in the histogram buffer will be returned.
  ///
  /// If the buffer has multiple bands, slices or frames, the respective band, slice or frame must be given.
  /// If no band, slice or frame is given, the function defaults to the first band, slice and frame, respectively.
  ///
  /// If you need the minimum values of multiple planes of the buffer, getAllMinValues might be more performant.
  ///
  /// \see mvIMPACT::BufferBase::getMax
  /// \see mvIMPACT::BufferBase::getMinMax
  /// \see mvIMPACT::BufferBase::getAllMinValues
  int getMin(
		/// The band to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The slice to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;


  /// \brief Get the minimal values of all planes of the buffer.
  ///
  /// The meaning differs depending on the type of the buffer:
  /// - Image: the minimal value found in the image is returned
  /// - Histogram: the smallest grayscale value with a nonzero frequency in the histogram buffer will be returned.
  ///
  /// The results are returned in a one-dimensional array and ordered in
  /// bands, slices, frames order.
  ///
  /// \see mvIMPACT::BufferBase::getAllMaxValues
  /// \see mvIMPACT::BufferBase::getAllMinMaxValues
  /// \see mvIMPACT::BufferBase::getMin
  std::vector<int> getAllMinValues() const;


  /// \brief Get the maximal values of a single plane of the buffer.
  ///
  /// The meaning differs depending on the type of the buffer:
  /// - Image: the maximal value found in the image is returned
  /// - Histogram: the largest grayscale value with a nonzero frequency in the histogram buffer will be returned.
  ///
  /// If the buffer has multiple bands, slices or frames, the respective band, slice or frame must be given.
  /// If no band, slice or frame is given, the function defaults to the first band, slice and frame, respectively.
  ///
  /// If you need the maximum values of multiple planes of the buffer, getAllMaxValues might be more performant.
  ///
  /// \see mvIMPACT::BufferBase::getMin
  /// \see mvIMPACT::BufferBase::getMinMax
  /// \see mvIMPACT::BufferBase::getAllMaxValues
  int getMax(
		/// The band to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The slice to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;


  /// \brief Get the maximal values of all planes of the buffer.
  ///
  /// The meaning differs depending on the type of the buffer:
  /// - Image: the maximal value found in the image is returned
  /// - Histogram: the largest grayscale value with a nonzero frequency in the histogram buffer will be returned.
  ///
  /// The results are returned in a one-dimensional array and ordered in
  /// bands, slices, frames order.
  ///
  /// \see mvIMPACT::BufferBase::getAllMinValues
  /// \see mvIMPACT::BufferBase::getAllMinMaxValues
  /// \see mvIMPACT::BufferBase::getMax
  std::vector<int> getAllMaxValues() const;


  /// \brief Get the minimal and maximal values of a single plane of the buffer.
  ///
  /// The meanings differ depending on the type of the buffer:
  /// - Image: the minimal and maximal values found in the image are returned
  /// - Histogram: the smallest  and largest grayscale values with a nonzero frequency in the histogram buffer will be returned.
  /// The first value is the minimal value, the second value is the maximal value.
  ///
  /// If the buffer has multiple bands, slices or frames, the respective band, slice or frame must be given.
  /// If no band, slice or frame is given, the function defaults to the first band, slice and frame, respectively.
  ///
  /// If you need the maximum and minimum values of multiple planes of the buffer, getAllMinMaxValues might be more performant.
  ///
  /// \see mvIMPACT::BufferBase::getMin
  /// \see mvIMPACT::BufferBase::getMax
  /// \see mvIMPACT::BufferBase::getAllMinMaxValues
  std::pair<int,int> getMinMax(
		/// The band to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The slice to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;


  /// \brief Get the minimal and maximal values of all planes of the buffer.
  ///
  /// The meanings differ depending on the type of the buffer:
  /// - Image: the minimal and maximal values found in the image are returned
  /// - Histogram: the smallest  and largest grayscale values with a nonzero frequency in the histogram buffer will be returned.
  /// The first value is the minimal value, the second value is the maximal value.
  ///
  /// The results are returned in a one-dimensional array and ordered in
  /// min-max, bands, slices, frames order.
  ///
  /// \see mvIMPACT::BufferBase::getAllMinValues
  /// \see mvIMPACT::BufferBase::getAllMaxValues
  /// \see mvIMPACT::BufferBase::getMinMax
  std::vector<int> getAllMinMaxValues() const;


  /// \brief Get the mean gray value of a single plane of the buffer.
  ///
  /// If the buffer has multiple bands, slices or frames, the respective band, slice or frame must be given.
  /// If no band, slice or frame is given, the function defaults to the first band, slice and frame, respectively.
  ///
  /// If you need the mean values of multiple planes of the buffer, getAllMeanValues might be more performant.
  ///
  /// \see mvIMPACT::BufferBase::getStdDev
  /// \see mvIMPACT::BufferBase::getAllMeanValues
  double getMean(
		/// The band to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The slice to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;


  /// \brief Get the mean gray values of all planes of the buffer.
  ///
  /// The results are returned in a one-dimensional array and ordered in
  /// bands, slices, frames order.
  ///
  /// \see mvIMPACT::BufferBase::getAllStdDevValues
  /// \see mvIMPACT::BufferBase::getMean
  std::vector<double> getAllMeanValues() const;


  /// \brief Get the standard deviation of a single plane of the buffer.
  ///
  /// If the buffer has multiple bands, slices or frames, the respective band, slice or frame must be given.
  /// If no band, slice or frame is given, the function defaults to the first band, slice and frame, respectively.
  ///
  /// If you need the standard deviation values of multiple planes of the buffer, getAllStdDevValues might be more performant.
  ///
  /// \see mvIMPACT::BufferBase::getMean
  /// \see mvIMPACT::BufferBase::getAllStdDevValues
  double getStdDev(
		/// The band to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The slice to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;


  /// \brief Get the standard deviation of all planes of the buffer.
  ///
  /// The results are returned in a one-dimensional array and ordered in
  /// bands, slices, frames order.
  ///
  /// \see mvIMPACT::BufferBase::getAllMeanValues
  /// \see mvIMPACT::BufferBase::getStdDev
  std::vector<double> getAllStdDevValues() const;

private:
   /// \brief Dispose the buffer.
  ///
  /// If the reference count drops to zero
  /// and the buffer was allocated it is freed.
  void dispose();

  /// copy the buffer
  void copy(const BufferBase& src);

};

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
/// "ONLY USED INTERNALLY"
class ResultBuf: public BufferBase
{
	DECLARE_USAGE_COUNTER

public:
	ResultBuf(int width, int bands, int slices, int frames, BufferDatatype dt);

	ResultBuf(const ResultBuf &resultBuf);

	virtual BufferBase* makeShallowCopy() const;

	virtual ~ResultBuf();

	double getDoubleValue(int x, int band, int slice, int frame) const;
	int getIntValue(int x, int band, int slice, int frame) const;
};

#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

class Palette;




/// \brief The base class for images
///
/// This class is derived from mvIMPACT::BufferBase
//-----------------------------------------------------------------------------
class Image : public BufferBase
//-----------------------------------------------------------------------------
{
	DECLARE_USAGE_COUNTER

public:
	/// \brief Construct a non-allocated image
	Image();

	/// \brief Copy constructor
	Image(/// the Image to copy from
	      const Image& src);


	/// \brief Construct an allocated image
	///
	/// You have to provide values for all 5 dimensions
	/// \see #BufferDatatype
	Image(
			/// Width of the image.
		  	/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int width,
			/// Height of the image.
		  	/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int height,
			/// Number of bands of the image.
		  	/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int bands,
			/// Number of slices of the image.
		  	/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int slices,
			/// Number of frames of the image.
		  	/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int frames,
			/// The desired datatype
			BufferDatatype datatype=bdUChar);


	/// \brief Construct an allocated Image buffer from data addressed by a pointer.
	///
	/// The pointer must point to a block of data, and the size and layout of this
	/// block of data is defined by the width, height, bands, slices, frames and datatype parameters.
	///
	/// The datatype parameters specifies the type of a single pixel. The width parameter
	/// specifies the number of pixels in a single row. The height parameter specifies the 
	/// number of rows. The bands parameter specifies the number of color bands. The slices
	/// parameter specifies the number of slices. The frame parameter specifies the number
	/// of slices.
	///
	/// The pixels, rows, bands, slices and frames are packed as densely as possible, without any 
	/// extra padding between.
	/// 
	/// The size of the block of data addressed by ptr is 
	/// width * height * bands * slices * frames * sizeof(datatype).
	/// 
	/// The lifetime of the block of data must be managed by the user. In particular, the data block
	/// addressed by ptr must not be freed before the Image buffer is destroyed.
	Image(
		/// Width of the image.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int width,
		/// Height of the image.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int height,
		/// Number of bands of the image.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int bands,
		/// Number of slices of the image.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int slices,
		/// Number of frames of the image.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int frames,
		/// The desired datatype.
		BufferDatatype datatype,
		/// The pointer to address the image data.
		void * ptr);


	/// \brief Construct an allocated image.
	///
	/// The Image is created with one slice and one frame.
	Image
	  (
		/// Width of the image.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int width,
		/// Height of the image.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int height,
		/// Number of bands of the image.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int bands=1,
		/// Datatype of the image.
		BufferDatatype datatype=bdUChar
		);

	/// \brief Construct an allocated child image
	///
	/// A child image is a specific part of an image that can be accessed like a normal image.
	Image(
		/// reference to the parent image
	    const Image& parent,
	    /// the x offset of the child image relative to the parent buffer
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.width-%(width)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int xOffset,
	    /// the y offset of the child image relative to the parent buffer
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.height-%(height)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int yOffset,
	    /// the band offset of the child image relative to the parent buffer
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.bands-%(bands)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	    int bandsOffset,
	    /// the slice offset of the child image relative to the parent buffer
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.slices-%(slices)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slicesOffset,
	    /// the frame offset of the child image relative to the parent buffer
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.frames-%(frames)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int framesOffset,
	    /// the width of the child image.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.width-%(xOffset)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	    int width,
	    /// the height of the child image.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.height-%(yOffset)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int height,
	    /// number of bands of the child image.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.bands-%(bandsOffset)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int bands,
	    /// number of slices of the child image.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.slices-%(slicesOffset)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slices,
	    /// number of frames of the child image.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.frames-%(framesOffset)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	    int frames);


	/// \brief Construct an allocated child image
	///
	/// A child image is a specific part of an image that can be accessed like a normal image.
	/// A Coord object is used to pass the offset values
	/// \see mvIMPACT::Coord
	Image(
		/// Reference to parent image.
		const Image& parent,
		/// The offset to the parent image
		const Coord &offset,
	    /// The width of the child image.
	    /// number of slices of the child image.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.width-%(offset)s.x"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	    int width,
	    /// The height of the child image.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.height-%(offset)s.y"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int height,
	    /// Number of bands of the child image.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.bands-%(offset)s.band"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	    int bands,
	    /// Number of slices of the child image.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.slices-%(offset)s.slice"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	    int slices,
	    /// Number of frames of the child image.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.frames-%(offset)s.frame"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
	    int frames);

	/// \brief Construct an allocated child image.
	///
	/// A child image is a specific part of an image that can be accessed like a normal image.
	/// The band, slice and frame offsets are set to 0.
	/// The band, slice and frame sizes are set to 1.
	Image
	  (
	   /// Reference to parent image.
	   const Image& parent,
	   /// The horizontal offset to the parent image.
	   /// \xmlonly
	   /// <mvParamRange>
	   /// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	   /// <mvParamMax><mvParamComplex Python="%(parent)s.width-%(width)s"/></mvParamMax>
	   /// </mvParamRange>
 	   /// \endxmlonly
	   int xOffset,

	   /// The vertical offset to the parent image.
	   /// \xmlonly
	   /// <mvParamRange>
	   /// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	   /// <mvParamMax><mvParamComplex Python="%(parent)s.height-%(height)s"/></mvParamMax>
	   /// </mvParamRange>
 	   /// \endxmlonly
	   int yOffset,

	   /// The width of the child image.
	   ///
	   /// \xmlonly
	   /// <mvParamRange>
	   /// <mvParamMin><mvParamConst value="1"/></mvParamMin>
	   /// <mvParamMax><mvParamComplex Python="%(parent)s.width-%(xOffset)s"/></mvParamMax>
	   /// </mvParamRange>
	   /// \endxmlonly
	   ///
	   int width,

	   /// The height of the child image.
	   /// \xmlonly
	   /// <mvParamRange>
	   /// <mvParamMin><mvParamConst value="1"/></mvParamMin>
	   /// <mvParamMax><mvParamComplex Python="%(parent)s.height-%(yOffset)s"/></mvParamMax>
	   /// </mvParamRange>
 	   /// \endxmlonly
	   int height
	   );

	/// \brief Construct an allocated child image.
	///
	/// A child image is a specific part of an image that can be accessed like a normal image.
	/// The slice and frame offsets are set to 0.
	/// The slice and frame sizes are set to 1.
	Image
	  (
		/// Reference to parent image.
		const Image& parent,
		/// The horizontal offset to the parent image.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.width-%(width)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int xOffset,
		/// The vertical offset to the parent image.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.height-%(height)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int yOffset,
		/// The band offset to the parent image.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.bands-%(bands)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int bandsOffset,
		/// The width of the child image.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.width-%(xOffset)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int width,
		/// The height of the child image.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.height-%(yOffset)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int height,
		/// Number of bands of the child image.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.bands-%(bandsOffset)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int bands
		);

	/// \brief Get the parent Image.
	///
	/// This function returns  pointer to the parent Image for allocated child Images or
	/// NULL for parent Images.
	const Image* getParentBuffer() const;


	/// \brief Destructor
	virtual ~Image();


#ifndef WRAP_PYTHON
	/// \brief Make a copy on the heap.
	virtual BufferBase* makeShallowCopy() const;
#endif // WRAP_PYTHON


	/// \brief Construct an allocated Image from an xml string
	///
	/// This constructor can be used to load serialized image buffers.
	/// \see mvIMPACT::BufferBase::asXml
	explicit Image(/// the xml string
		       const std::string& xmlString);


	/// \brief Construct an allocated child  image from an xml string
	///
	/// This constructor can be used to load serialized image buffers.
	/// \see mvIMPACT::BufferBase::asXml
	Image
	  (
	   /// Reference to parent.
	   const Image& parent,
	   /// The xml string to allocate from.
	   const std::string& xmlString
	   );




#ifndef WRAP_ANY
	/// \brief Overwrite current object with \a src.
	Image& operator=(/// the other object
			 const Image& src);
#endif // #ifndef WRAP_ANY

	/// \brief Clone an Image (deep copy).
	///
	/// For non-child images this function creates a new
	/// image and copies the data of the current image into it.
	///
	/// For child images, this function creates a new child image
	/// of the parent image of the current image. The new child
	/// image has the same properties as the current child image.
	///
	/// This returns a deep copy of the Image.
	Image clone() const;


	/// \brief Copy an Image (deep copy), a child image as new image.
	///
	/// For non-child images this does the same as clone().
	///
	/// For child images it creates a totally new image
	/// and copies the data of the current child image into it.
	///
	/// This returns a deep copy of the Image. Never a child image.
	Image copyAsImage() const;


	/// \brief Draw an outlined polygon into the image.
	///
	/// If a closed polygon should be drawn, the last point in the point buffer must
	/// be identical with the first point (otherwise, the polygon will not be closed).
	/// If the source buffer is a multidimensional buffer, the polygon will be drawn into all dimensions (bands, z-slices, and time-slices).
	/// \see mvIMPACT::Image::drawFilledPolygon
	void drawPolygon
	  (
		/// The polygon points.
		const std::vector<Point>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR,polygon),
		/// The outline color. Only the low-order bits that match the Image datatype are used.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(instance)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(instance)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int value
		);


	/// \brief Draw a filled polygon into the image.
	///
	/// If a closed polygon should be drawn, the last point in the point buffer must
	/// be identical with the first point (otherwise, the polygon will not be closed).
	/// The polygon will be filled with the given color.
	/// If the source buffer is a multidimensional buffer, the polygon will be drawn into all dimensions (bands, z-slices, and time-slices).
	/// \see mvIMPACT::Image::drawPolygon
	void drawFilledPolygon
	  (
		/// The polygon points.
		const std::vector<Point>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR,polygon),
		/// The fill color. Only the low-order bits
		/// that match the Image datatype are used.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(instance)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(instance)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int value
		);


	/// \brief Draw an outlined ellipse into the Image.
	/// If the source buffer is a multidimensional buffer, the ellipse will be drawn into all dimensions (bands, z-slices, and time-slices).
	///
	/// \see mvIMPACT::Image::drawFilledEllipse
	void drawEllipse
		(
		/// The ellipse center point.
		const Point& center,
		/// The major half axis size (x-axis).
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int major,
		/// The minor half axis size (y-axis).
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int minor,
		/// The outline color. Only the low-order bits
		/// that match the Image datatype are used.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(instance)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(instance)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int value
		);


	/// \brief Draw a filled ellipse into the Image.
	/// If the source buffer is a multidimensional buffer, the ellipse will be drawn into all dimensions (bands, z-slices, and time-slices).
	///
	/// \see mvIMPACT::Image::drawEllipse
	void drawFilledEllipse
		(
		/// The ellipse center point.
		const Point& center,
		/// The major half axis size (x-axis).
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int major,
		/// The minor half axis size (y-axis).
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int minor,
		/// The fill color. Only the low-order
		/// bits that match the Image datatype are used.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(instance)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(instance)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int value
		);


	/// \brief Draw an outlined rectangle into the image.
	/// If the source buffer is a multidimensional buffer, the rectangle will be drawn into all dimensions (bands, z-slices, and time-slices).
	///
	/// \see mvIMPACT::Point
	void drawRectangle
	  (
		/// The top left corner
		const Point& topleft,
		/// The bottom right corner
		const Point& bottomright,
		/// The outline color. Only the low-order
		/// bits that match the Image datatype are used.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(instance)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(instance)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int value
		);

	/// \brief Draw an outlined rectangle into the image.
	/// If the source buffer is a multidimensional buffer, the rectangle will be drawn into all dimensions (bands, z-slices, and time-slices).
	///
	/// \see mvIMPACT::Rectangle
	void drawRectangle
	  (
		/// the rectangle to draw
		const Rectangle& rectangle,
		/// The outline color. Only the low-order
		/// bits that match the Image datatype are used.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(instance)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(instance)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int value
		);


	/// \brief Draw a line into the image.
	/// If the source buffer is a multidimensional buffer, the line will be drawn into all dimensions (bands, z-slices, and time-slices).
	///
	/// \see mvIMPACT::Line
	void drawLine
		(
		/// the line to draw
		const Line& line,
		/// The outline color. Only the low-order
		/// bits that match the Image datatype are used.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(instance)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(instance)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int value
		);


	/// \brief Draw a line into the image.
	///
	/// The line is specified by passing to points.
	/// If the source buffer is a multidimensional buffer, the line will be drawn into all dimensions (bands, z-slices, and time-slices).
	/// \see mvIMPACT::Point
	void drawLine
		(
		/// The first point of the line
		const Point& first,
		/// The second point of the line
		const Point& second,
		/// The outline color. Only the low-order
		/// bits that match the Image datatype are used.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(instance)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(instance)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int value
		);


	/// \brief Draw a point into the image.
	/// If the source buffer is a multidimensional buffer, the point will be drawn into all dimensions (bands, z-slices, and time-slices).
	///
	/// \see mvIMPACT::Point
	void drawPoint
		(
		/// The point
		const Point& point,
		/// The outline color. Only the low-order
		/// bits that match the Image datatype are used.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(instance)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(instance)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int value
		);


	/// \brief Get the minimal value of a single plane of the image.
	///
	/// If the image has multiple bands, slices or frames, the respective band, slice or frame must be given.
	/// If no band, slice or frame is given, the function defaults to the first band, slice and frame, respectively.
	///
	/// If you need the minimum values of multiple planes of the image, getAllMinValues might be more performant.
	///
	/// \see mvIMPACT::Image::getMax
	/// \see mvIMPACT::Image::getMinMax
	/// \see mvIMPACT::Image::getAllMinValues
  int getMin(
		/// The band to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The slice to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;

	/// \brief Get the minimal values of all planes of the image.
	///
	/// The results are returned in a one-dimensional array and ordered in
	/// bands, slices, frames order.
	///
	/// \see mvIMPACT::Image::getAllMaxValues
	/// \see mvIMPACT::Image::getAllMinMaxValues
	/// \see mvIMPACT::Image::getMin
	std::vector<int> getAllMinValues() const;

	/// \brief Get the maximal value of a single plane of the image.
	///
	/// If the image has multiple bands, slices or frames, the respective band, slice or frame must be given.
	/// If no band, slice or frame is given, the function defaults to the first band, slice and frame, respectively.
	///
	/// If you need the maximum values of multiple planes of the image, getAllMaxValues might be more performant.
	///
	/// \see mvIMPACT::Image::getMin
	/// \see mvIMPACT::Image::getMinMax
	/// \see mvIMPACT::Image::getAllMaxValues
	int getMax(
		/// The band to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The slice to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;

	/// \brief Get the maximal values of all planes of the image.
	///
	/// The results are returned in a one-dimensional array and ordered in
	/// bands, slices, frames order.
	///
	/// \see mvIMPACT::Image::getAllMinValues
	/// \see mvIMPACT::Image::getAllMinMaxValues
	/// \see mvIMPACT::Image::getMax
	std::vector<int> getAllMaxValues() const;


  /// \brief Get the minimal and maximal values of a single plane of the image.
  ///
  /// The first value is the minimal value, the second value is the maximal value.
  ///
  /// If the image has multiple bands, slices or frames, the respective band, slice or frame must be given.
  /// If no band, slice or frame is given, the function defaults to the first band, slice and frame, respectively.
  ///
  /// If you need the maximum and minimum values of multiple planes of the image, getAllMinMaxValues might be more performant.
  ///
  /// \see mvIMPACT::Image::getMin
  /// \see mvIMPACT::Image::getMax
  /// \see mvIMPACT::Image::getAllMinMaxValues
  std::pair<int,int> getMinMax(
		/// The band to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The slice to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;

  /// \brief Get the minimal and maximal values of all planes of the image.
  ///
  /// The first value is the minimal value, the second value is the maximal value.
  ///
  /// The results are returned in a one-dimensional array and ordered in
  /// min-max, bands, slices, frames order.
  ///
  /// \see mvIMPACT::Image::getAllMinValues
  /// \see mvIMPACT::Image::getAllMaxValues
  /// \see mvIMPACT::Image::getMinMax
  std::vector<int> getAllMinMaxValues() const;


  /// \brief Get the mean gray value of a single plane of the image.
  ///
  /// If the image has multiple bands, slices or frames, the respective band, slice or frame must be given.
  /// If no band, slice or frame is given, the function defaults to the first band, slice and frame, respectively.
  ///
  /// If you need the mean values of multiple planes of the image, getAllMeanValues might be more performant.
  ///
  /// \see mvIMPACT::Image::getStdDev
  /// \see mvIMPACT::Image::getAllMeanValues
  double getMean(
		/// The band to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The slice to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;

  /// \brief Get the mean gray values of all planes of the image.
  ///
  /// The results are returned in a one-dimensional array and ordered in
  /// bands, slices, frames order.
  ///
  /// \see mvIMPACT::Image::getAllStdDevValues
  /// \see mvIMPACT::Image::getMean
  std::vector<double> getAllMeanValues() const;


  /// \brief Get the standard deviation of a single plane of the image.
  ///
  /// If the image has multiple bands, slices or frames, the respective band, slice or frame must be given.
  /// If no band, slice or frame is given, the function defaults to the first band, slice and frame, respectively.
  ///
  /// If you need the standard deviation values of multiple planes of the image, getAllStdDevValues might be more performant.
  ///
  /// \see mvIMPACT::Image::getMean
  /// \see mvIMPACT::Image::getAllStdDevValues
  double getStdDev(
		/// The band to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The slice to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame to be inspected.
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;

  /// \brief Get the standard deviation of all planes of the image.
  ///
  /// The results are returned in a one-dimensional array and ordered in
  /// bands, slices, frames order.
  ///
  /// \see mvIMPACT::Image::getAllMeanValues
  /// \see mvIMPACT::Image::getStdDev
  std::vector<double> getAllStdDevValues() const;


	/// \brief Get a pixel's value.

	///
	/// Note that this operation is quite slow. If you
	/// do a bunch of calls of mvIMPACT::Image::getPixel(int, int, int, int, int)
	/// with constant \a band, \a slice and \a frame,
	/// call mvIMPACT::BufferBase::prepareReadAccess() before and mvIMPACT::BufferBase::releaseAccess() afterwards.
	/// This speeds up operation of mvIMPACT::Image::getPixel() considerably.
	/// If you also want to call mvIMPACT::Image::setPixel(int, int, int, int, int, int),
	/// you need to call mvIMPACT::BufferBase::prepareReadWriteAccess instead.
	/// Furthermore you can then call mvIMPACT::Image::getPixel(int,int), i.e. without the paramters
	/// \a band, \a slice and \a frame, which are redundant in this case.
	///
	/// If one of the parameters \a band, \a slice and \a frame doesn't match
	/// the call of the last mvIMPACT::BufferBase::prepareReadAccess or mvIMPACT::BufferBase::prepareReadWriteAccess function, the slow
	/// version of the function is called automatically.
	int getPixel(
			/// the x coordinate of the pixel
	  		/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int x,
		    /// the y coordinate of the pixel
	  		/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int y,
		    /// the band of the pixel
	  		/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
		    int band,
		    /// the slice of the pixel
	  		/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
		    int slice,
		    /// the frame of the pixel
	  		/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
		    int frame) const;


	/// \brief Get a pixel's value.

	/// This function can only be called after a call to
	/// mvIMPACT::BufferBase::prepareReadAccess or mvIMPACT::BufferBase::prepareReadWriteAccess.
	/// However, it is quite fast.
	/// The plane where the pixel is accessed (band,slice,frame) is specified with mvIMPACT::BufferBase::prepareReadAccess
	/// or mvIMPACT::BufferBase::prepareReadWriteAccess.
	/// \see mvIMPACT::BufferBase::prepareReadAccess
	/// \see mvIMPACT::BufferBase::prepareReadWriteAccess
	///
	int getPixel(
			/// the x coordinate of the pixel
	  		/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int x,
		    /// the y coordinate of the pixel
	  		/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
		    int y) const;




	/// \brief Set a pixel's value.

	/// Note that this operation is quite slow. If you
	/// do a bunch of calls of mvIMPACT::Image::setPixel() with constant \a band, \a slice and \a frame,
	/// call mvIMPACT::BufferBase::prepareReadWriteAccess() before and mvIMPACT::BufferBase::releaseAccess() afterwards.
	/// first. This speeds up operation of mvIMPACT::Image::setPixel() considerably.
	///
	/// If one of the parameters \a band, \a slice and \a frame doesn't match
	/// the call of the last mvIMPACT::BufferBase::prepareReadWriteAccess() function, the slow
	/// version of the function is called.
	///
	 // \internal
	 // if the return value is BufferBase& here (i.e. *this) then the
	 // Python function gets considerably slower, so we use void here
	void setPixel(
			/// the x coordinate of the pixel to be set
	  		/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int x,
		    /// the y coordinate of the pixel to be set
	  		/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
		    int y,
		    /// the band of the pixel to be set
	  		/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
		    int band,
		    /// the slice of the pixel to be set
	  		/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
		    int slice,
		    /// the frame of the pixel to be set
	  		/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int frame,
		    /// the value to be set
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamComplex Python="int(%(instance)s.datatypeMinValue)"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="int(%(instance)s.datatypeMaxValue)"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int value);



  /// \brief Set a pixel's value.

  /// This function can only be called after a call to
  /// mvIMPACT::BufferBase::prepareReadAccess() or mvIMPACT::BufferBase::prepareReadWriteAccess(). However, it is quite fast.
  ///
  /// \see mvIMPACT::BufferBase::prepareReadAccess
  /// \see mvIMPACT::BufferBase::prepareReadWriteAccess
   // \internal
   // if the return value is BufferBase& here (i.e. *this) then the Python
   // function gets considerably slower, so we use void here
	void setPixel(
				/// the x coordinate of the pixel
	  			/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
				/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
				/// </mvParamRange>
				/// \endxmlonly
				int x,
				/// the y coordinate of the pixel
	  			/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
				/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
				/// </mvParamRange>
				/// \endxmlonly
				int y,
				/// the value to be set
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamComplex Python="int(%(instance)s.datatypeMinValue)"/></mvParamMin>
				/// <mvParamMax><mvParamComplex Python="int(%(instance)s.datatypeMaxValue)"/></mvParamMax>
				/// </mvParamRange>
				/// \endxmlonly
				int value);

#ifndef WRAP_ANY
	/// Convert this image to bitmap bits.
	///
	/// This function converts this image to bitmap bits. Bitmap bits are in packed format and are usually needed to provide
	/// image data for image drawing. The data copied to bitmap is always in 8 bit format, regardless of the format of this
	/// image.
	///
	/// If the image has exactly three bands, the data copied to bitmap is in RGB format. If the image has any other number
	/// of bands, the data of the first or only band is copied to bitmap in monochrome format.
	///
	/// For multi-slice or multi-frame images, this function always copies the first slice and frame. If this is not wanted,
	/// you should create a child image for the specific slice or frame. Likewise, if you want to copy only a portion of the
	/// x/y image plane, you should create a child image for the specific x/y image plane portion.
	///
	/// The function has an optional shift parameter that can be used to shift the displayed range when working with 16 bit
	/// images. There is also an overload of this function that takes a palette for the respective conversion. The palette
	/// version can also be used to convert 8 bit images, while the shift version is for 16 bit images only.
	void convertToBitmap(
		/// Pointer to a pre-allocated bitmap that has enough room to accept the
		/// data that this function will copy into it.
		void * bitmap,
		/// Specifies the number of bits to shift right before the data will be written to the buffer specified with bitmap.
		/// This parameter should be used only if the source buffer is a 16 bit type buffer, and it serves to shift the original
		/// range to some range suitable for display. For example, if you have a 10bit image, you would usually set the shift
		/// parameter to 2.
		/// If the source buffer is an 8 bit type source buffer, this parameter will be ignored.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		unsigned int shift=0) const;

	/// Convert this image to bitmap bits.
	///
	/// This function converts this image to bitmap bits. Bitmap bits are in packed format and are usually needed to provide
	/// image data for image drawing. The data copied to bitmap is always in 8 bit format, regardless of the format of this
	/// image.
	///
	/// If the image has exactly three bands, the data copied to bitmap is in RGB format. If the image has any other number
	/// of bands, the data of the first or only band is copied to bitmap in monochrome format.
	///
	/// For multi-slice or multi-frame images, this function always copies the first slice and frame. If this is not wanted,
	/// you should create a child image for the specific slice or frame. Likewise, if you want to copy only a portion of the
	/// x/y image plane, you should create a child image for the specific x/y image plane portion.
	///
	/// The function has a palette parameter that specifies a mapping to be applied before the data is written to bitmap.
	/// There is also an overload of this function that can take a shift parameter for simple conversion of 16 bit images.
	/// The shift version is for 16 bit images only.
	void convertToBitmap(
		/// Pointer to a pre-allocated bitmap that has enough room to accept the
		/// data that this function will copy into it.
		void * bitmap,
		/// Specifies the palette used to convert the image pixels before they are copied to bitmap.
		/// The passed palette must match the image in terms of the number of bands; i.e. if the image has three bands, the palette
		/// must have three bands as well. The passed palette must also match the image in terms of the datatype; i.e. if the image
		/// is 8 bit, the palette must have at least 256 entries, whereas if the image is 16 bit, the palette must have at least
		/// 65536 entries.
		const Palette& palette) const;
#endif // #ifndef WRAP_ANY


#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
	/// Factory function to return an Image from a handle.
	///
	/// only used internally
	static Image imageFactory(/// The buffer handle.
			mvIMPACT_C::IPL_BUFHANDLE handle);
#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

#ifndef WRAP_ANY
	/// \brief Factory function to return an Image from a handle.
	///
	/// If one has a buffer handle from the
	/// C-API of the vl_device module, one can
	/// use this function to construct an image
	/// object. For details on usage, see the C++ sample
	/// called device.
	static Image imageDeviceFactory(/// The buffer handle.
			mvIMPACT_C::IPL_BUFHANDLE handle);
#endif // #ifndef WRAP_ANY



private:
	/// \brief Construct an allocated Image from a handle
	explicit Image(/// The buffer handle
		       mvIMPACT_C::IPL_BUFHANDLE bufhandle,
		       /// cleanup flag
		       bool mustCleanup=true);


};


/// \brief The base class for palettes
///
/// This class is derived from mvIMPACT::BufferBase
//-----------------------------------------------------------------------------
class Palette : public BufferBase
//-----------------------------------------------------------------------------
{
	DECLARE_USAGE_COUNTER

public:
	/// \brief Construct a non-allocated palette
	Palette();

	/// \brief Construct an allocated palette.
	///
	/// The number of slices and the number of frames is set to 1.
	/// \see #BufferDatatype
	Palette(
		/// The width of the palette.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int width,
		/// The number of bands of the palette.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int bands=1,
		/// The datatype of the palette.
		BufferDatatype datatype=bdUChar);

	/// \brief Construct an allocated palette.
	///
	/// \see #BufferDatatype
	Palette(
		/// The width of the palette.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int width,
		/// The number of bands of the palette.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int bands,
		/// The number of slices of the palette.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int slices,
		/// The number of frames of the palette.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int frames,
		/// The datatype of the palette.
		BufferDatatype datatype=bdUChar);

	/// \brief Construct an allocated Palette buffer from data addressed by a pointer.
	///
	/// The pointer must point to a block of data, and the size and layout of this
	/// block of data is defined by the width, bands, slices, frames and datatype parameters.
	///
	/// The datatype parameters specifies the type of a single pixel. The width parameter
	/// specifies the number of pixels in a single row. The bands parameter specifies the 
	/// number of color bands. The slices parameter specifies the number of slices. The frame 
	/// parameter specifies the number of slices.
	///
	/// The pixels, bands, slices and frames are packed as densely as possible, without any 
	/// extra padding between.
	/// 
	/// The size of the block of data addressed by ptr is 
	/// width * bands * slices * frames * sizeof(datatype).
	/// 
	/// The lifetime of the block of data must be managed by the user. In particular, the data block
	/// addressed by ptr must not be freed before the Palette buffer is destroyed.
	Palette(
		/// The width of the palette.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int width,
		/// The number of bands of the palette.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int bands,
		/// The number of slices of the palette.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int slices,
		/// The number of frames of the palette.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int frames,
		/// The datatype of the palette.
		BufferDatatype datatype,
		/// The pointer to address the palette data.
		void * ptr);

	/// \brief Construct an allocated palette from an xml string.
	///
	/// This can be use to load a serialized Palette.
	/// \see mvIMPACT::BufferBase::asXml
	explicit Palette(
			 /// The xml string to construct the palette from.
			 const std::string& xmlString);

	/// \brief Access the parent palette.
	///
	/// This method returns a pointer to the parent palette for allocated child palettes or 0 for parent palettes.
	const Palette* getParentBuffer() const;


	/// \brief Copy-construct a palette object (shallow copy)
	Palette(
		/// The palette to copy.
		const Palette& src);


	/// \brief Clone a palette (deep copy).
	Palette clone() const;

	/// \brief Destruct a palette.
	virtual ~Palette();

#ifndef WRAP_PYTHON
	/// \brief Make a copy on the heap.
	virtual BufferBase* makeShallowCopy() const;
#endif // WRAP_PYTHON


	/// \brief Construct an allocated child palette.
	///
	/// The child palette is created with one frame and one slice.
	/// The offsets except the band offset are set to 0.
	Palette
	(
		/// Reference to parent buffer palette.
		const Palette& parent,
		/// The band offset with respect to the parent.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.bands-%(bands)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int bandsOffset,
		/// The number of bands.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.bands-%(bandsOffset)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int bands
		);


	/// \brief Construct an allocated child Palette.
	///
	/// You have to provide the offsets and the size of all four dimensions.
	Palette
	(
		/// Reference to parent buffer palette.
		const Palette& parent,
		/// The horizontal offset with respect to the parent.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.width-%(width)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int xOffset,
		/// The band offset with respect to the parent.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.bands-%(bands)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int bandsOffset,
		/// The slice offset with respect to the parent.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.slices-%(slices)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slicesOffset,
		/// The frame offset with respect to the parent.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.frames-%(frames)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frameOffset,
		/// The horizontal size.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.width-%(xOffset)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int width,
		/// The number of bands.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.bands-%(bandsOffset)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int bands,
		/// The number of slices.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.slices-%(slicesOffset)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slices,
		/// The number of frames.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.frames-%(framesOffset)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frames
		);

	/// \brief Construct an allocated child Palette.
	///
	/// The offset values of the child palette are passed with a Coord object.
	/// \see mvIMPACT::Coord
	Palette
	(
		/// Reference to parent buffer palette.
		const Palette& parent,
		/// Offset relative to the parent. The value offset.y is ignored.
		const Coord &offset,
		/// The horizontal size.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.width-%(offset)s.x"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int width,
		/// The number of bands.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.bands-%(offset)s.band"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int bands,
		/// The number of slices.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.slices-%(offset)s.slice"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slices,
		/// The number of frames.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.frames-%(offset)s.frame"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frames
		);

	/// \brief Copy a Palette (deep copy), a child palette as a new palette.
	///
	/// For non-child palettes this does the same as clone().
	///
	/// For child palettes it creates a totally new palette
	/// and copies the data of the current child palette into it.
	///
	/// \return A deep copy of the Image. Never a child image.
	Palette copyAsPalette() const;

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
	static Palette paletteFactory(mvIMPACT_C::IPL_BUFHANDLE handle);
#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

	/// \brief Construct an allocated Palette from an xml string.
	///
	/// This constructor can be used to load a serialized palette.
	Palette
	(
		/// Reference to parent.
		const Palette& parent,
		/// The xml string to allocate from.
		const std::string& xmlString
		);

#ifndef WRAP_ANY
	/// \brief Overwrite current object with \a src.
	Palette& operator=(/// the other palette object
			   const Palette& src);
#endif // #ifndef WRAP_ANY



	/// \brief Get an entry from the palette
	///
	/// Note that this operation is quite slow. If you
	/// do a bunch of calls of mvIMPACT::Palette::getEntry(int, int, int, int)
	/// with constant \a band, \a slice and \a frame,
	/// call mvIMPACT::BufferBase::prepareReadAccess() before and mvIMPACT::BufferBase::releaseAccess() afterwards.
	/// This speeds up operation of mvIMPACT::Palette::getEntry() considerably.
	/// If you also want to call mvIMPACT::Palette::setEntry(int, int, int, int, int),
	/// you need to call mvIMPACT::BufferBase::prepareReadWriteAccess instead.
	/// Furthermore you can then call mvIMPACT::Palette::getEntry(int,int), i.e. without the paramters
	/// \a band, \a slice and \a frame, which are redundant in this case.
	///
	/// If one of the parameters \a band, \a slice and \a frame doesn't match
	/// the call of the last mvIMPACT::BufferBase::prepareReadAccess or mvIMPACT::BufferBase::prepareReadWriteAccess function, the slow
	/// version of the function is called automatically.
	int getEntry(
		/// the index of the entry
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int index,
	    /// the band of the entry
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band,
		/// the slice of the entry
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice,
		/// the frame of the entry
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame) const;


	/// \brief Get a palette entry.

	/// This function can only be called after a call to
	/// mvIMPACT::BufferBase::prepareReadAccess or mvIMPACT::BufferBase::prepareReadWriteAccess.
	/// However, it is quite fast.
	/// The plane where the entry is accessed (band,slice,frame) is specified with mvIMPACT::BufferBase::prepareReadAccess
	/// or mvIMPACT::BufferBase::prepareReadWriteAccess.
	/// \see mvIMPACT::BufferBase::prepareReadAccess
	/// \see mvIMPACT::BufferBase::prepareReadWriteAccess
	///
	int getEntry(
		/// the index of the entry
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int index) const;


	/// \brief Set a palette entry

	/// Note that this operation is quite slow. If you
	/// do a bunch of calls of mvIMPACT::Palette::setEntry() with constant \a band, \a slice and \a frame,
	/// call mvIMPACT::BufferBase::prepareReadWriteAccess() before and mvIMPACT::BufferBase::releaseAccess() afterwards.
	/// first. This speeds up operation of mvIMPACT::Palette::setEntry() considerably.
	///
	/// If one of the parameters \a band, \a slice and \a frame doesn't match
	/// the call of the last mvIMPACT::BufferBase::prepareReadWriteAccess() function, the slow
	/// version of the function is called.
	///
	 // \internal
	 // if the return value is BufferBase& here (i.e. *this) then the
	 // Python function gets considerably slower, so we use void here
	void setEntry(
		/// the index of the entry
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int index,
		/// the band of the entry
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band,
		/// the slice of the entry
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice,
		/// the frame of the entry
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame,
		/// the new value
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(instance)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(instance)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int value);



	/// \brief Set a palette entry

	/// This function can only be called after a call to
	/// mvIMPACT::BufferBase::prepareReadAccess() or mvIMPACT::BufferBase::prepareReadWriteAccess(). However, it is quite fast.
	///
	/// \see mvIMPACT::BufferBase::prepareReadAccess
	/// \see mvIMPACT::BufferBase::prepareReadWriteAccess
	 // \internal
	 // if the return value is BufferBase& here (i.e. *this) then the
	 // Python function gets considerably slower, so we use void here
	void setEntry(
		/// index of the entry
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int index,
		/// the new value
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(instance)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(instance)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int value);

private:
	/// Construct an allocated Palette from a handle.
	/// \param bufhandle The buffer handle
	explicit Palette(mvIMPACT_C::IPL_BUFHANDLE bufhandle);

};


/// \brief The base class for profiles.
///
/// This class is derived from mvIMPACT::BufferBase
//-----------------------------------------------------------------------------
class Profile : public BufferBase
//-----------------------------------------------------------------------------
{
	DECLARE_USAGE_COUNTER

public:

	/// \brief Construct an allocated child profile from an xml string.
	///
	/// This constructor can be used to load a serialized Profile
	/// \see mvIMPACT::BufferBase::asXml
	Profile
	  (
	   /// Reference to parent profile.
	   const Profile& parent,
	   /// The xml string to allocate from.
	   const std::string& xmlString
	   );


	/// \brief Construct an allocated child profile.
	Profile(/// reference to the parent profile
		const Profile& parent,
		/// specifies the horizontal offset
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.width-%(width)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int xOffset,
		/// specifies the band offset
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.bands-%(bands)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int bandsOffset,
		/// specifies the slice offset
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.slices-%(slices)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slicesOffset,
		/// specifies the frame offset
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.frames-%(frames)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int framesOffset,
		/// specifies the width of the child profile
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.width-%(xOffset)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int width,
		/// specifies the number of bands of the child profile
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.bands-%(bandsOffset)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int bands,
		/// specifies the number of slices of the child profile
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.slices-%(slicesOffset)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slices,
		/// specifies the number of frames of the child profile
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.frames-%(framesOffset)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frames);



	/// \brief Construct an allocated child profile
	///
	/// The offset values are passed in a Coord object.
	/// \note The \c offset.y value is ignored
	/// \see mvIMPACT::Coord
	Profile(/// reference to the parent profile
		const Profile& parent,
		/// the offset values
		const Coord &offset,
		/// width of the child profile
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.width-%(offset)s.x"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int width,
		/// number of bands of the child profile
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.bands-%(offset)s.band"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int bands,
		/// number of slices of the child profile
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.slices-%(offset)s.slice"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slices,
		/// number of frames of the child profile
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.frames-%(offset)s.frame"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frames);


	/// \brief Construct a non-allocated profile.
	Profile();


	/// \brief Construct an allocated profile.
	///
	/// The profile is created with the datatype specified with parameter \a datatype
	/// \see #BufferDatatype
	Profile(
		/// the width of the profile
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int width,
		/// number of bands
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int bands=1,
		/// number of slices
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int slices=1,
		/// number of frames
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int frames=1,
		/// the datatype of the profile
		BufferDatatype datatype=bdUChar);


	/// \brief Construct an allocated Profile buffer from data addressed by a pointer.
	///
	/// The pointer must point to a block of data, and the size and layout of this
	/// block of data is defined by the width, bands, slices, frames and datatype parameters.
	///
	/// The datatype parameters specifies the type of a single pixel. The width parameter
	/// specifies the number of pixels in a single row. The bands parameter specifies the 
	/// number of color bands. The slices parameter specifies the number of slices. The 
	/// frame parameter specifies the number of slices.
	///
	/// The pixels, bands, slices and frames are packed as densely as possible, without any 
	/// extra padding between.
	/// 
	/// The size of the block of data addressed by ptr is 
	/// width * bands * slices * frames * sizeof(datatype).
	/// 
	/// The lifetime of the block of data must be managed by the user. In particular, the data block
	/// addressed by ptr must not be freed before the Profile buffer is destroyed.
	Profile(
		/// the width of the profile
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int width,
		/// number of bands
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int bands,
		/// number of slices
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int slices,
		/// number of frames
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int frames,
		/// the datatype of the profile
		BufferDatatype datatype,
		/// The pointer to address the profile data.
		void * ptr);


	/// \brief Copy-construct a profile
	Profile(/// the other profile
		const Profile &src);

	/// \brief Access the parent profile.
	///
	/// This returns a pointer to the parent Profile for allocated child profiles or 0 for parent profiles.
	const Profile* getParentBuffer() const;

	/// \brief Destruct a Profile
	virtual ~Profile();

	// Abstract class. The user must not instantiate it!

#ifndef WRAP_PYTHON
	/// \brief Make a copy on the heap.
	///
	/// \note Abstract function.
	virtual BufferBase* makeShallowCopy() const;
#endif // WRAP_PYTHON


public:
	/// \brief Construct an allocated Profile from an xml string.
	///
	/// This constructor can be used to load a serialized profile.
	/// \see mvIMPACT::BufferBase::asXml
	explicit Profile(/// the xml string
			 const std::string& xmlString);


	/// \brief Clone a profile (deep copy).
	Profile clone() const;

	/// \brief Copy a Profile (deep copy), a child profile as a new profile.
	///
	/// For non-child profiles this does the same as clone().
	///
	/// For child profiles it creates a totally new profile
	/// and copies the data of the current child profile into it.
	///
	/// This returns a deep copy of the Profile. Never a child profile.
	Profile copyAsProfile() const;

#ifndef WRAP_ANY
	/// \brief Overwrite current object with \a src.
	Profile& operator=(/// the other profile
			   const Profile& src);
#endif // #ifndef WRAP_ANY

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
	static Profile profileFactory(mvIMPACT_C::IPL_BUFHANDLE handle);
#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS


	/// \brief Get a pixel's value.
	///
	/// Note that this operation is quite slow. If you
	/// do a bunch of calls of mvIMPACT::Profile::getPixel(int, int, int, int)
	/// with constant \a band, \a slice and \a frame,
	/// call mvIMPACT::BufferBase::prepareReadAccess() before and mvIMPACT::BufferBase::releaseAccess() afterwards.
	/// This speeds up operation of mvIMPACT::Profile::getPixel() considerably.
	/// If you also want to call mvIMPACT::Profile::setPixel(int, int, int, int, int),
	/// you need to call mvIMPACT::BufferBase::prepareReadWriteAccess instead.
	/// Furthermore you can then call mvIMPACT::Profile::getPixel(int,int), i.e. without the paramters
	/// \a band, \a slice and frame, which are redundant in this case.
	///
	/// If one of the parameters \a band, \a slice and \a frame doesn't match
	/// the call of the last mvIMPACT::BufferBase::prepareReadAccess or mvIMPACT::BufferBase::prepareReadWriteAccess function, the slow
	/// version of the function is called automatically.
	int getPixel(
		/// x coordinate of the pixel
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int x,
		/// band of the pixel
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band,
		/// slice of the pixel
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice,
		/// frame of the pixel
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame) const;


	/// \brief Get a pixel's value.
	///
	/// This function can only be called after a call to
	/// mvIMPACT::BufferBase::prepareReadAccess or mvIMPACT::BufferBase::prepareReadWriteAccess.
	/// However, it is quite fast.
	/// The plane where the pixel is accessed (band,slice,frame) is specified with mvIMPACT::BufferBase::prepareReadAccess
	/// or mvIMPACT::BufferBase::prepareReadWriteAccess.
	/// \see mvIMPACT::BufferBase::prepareReadAccess
	/// \see mvIMPACT::BufferBase::prepareReadWriteAccess
	///
	int getPixel(
			/// the x coordinate of the pixel
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int x) const;


	/// \brief Set a pixel's value.

	/// Note that this operation is quite slow. If you
	/// do a bunch of calls of mvIMPACT::Profile::setPixel() with constant \a band, \a slice and \a frame,
	/// call mvIMPACT::BufferBase::prepareReadWriteAccess() before and mvIMPACT::BufferBase::releaseAccess() afterwards.
	/// first. This speeds up operation of mvIMPACT::Profile::setPixel() considerably.
	///
	/// If one of the parameters \a band, \a slice and \a frame doesn't match
	/// the call of the last mvIMPACT::BufferBase::prepareReadWriteAccess() function, the slow
	/// version of the function is called.
	///
	 // \internal
	 // if the return value is BufferBase& here (i.e. *this) then the
	 // Python function gets considerably slower, so we use void here
	void setPixel(
			/// the x coordinate of the pixel
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int x,
		    /// the band of the pixel
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int band,
		    /// the slice of the pixel
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
		    int slice,
		    /// the frame of the pixel
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
		    int frame,
		    /// the new value
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamComplex Python="int(%(instance)s.datatypeMinValue)"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="int(%(instance)s.datatypeMaxValue)"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int value);


	/// \brief Set a pixel's value.

	/// This function can only be called after a call to
	/// mvIMPACT::BufferBase::prepareReadAccess() or mvIMPACT::BufferBase::prepareReadWriteAccess(). However, it is quite fast.
	///
	/// \see mvIMPACT::BufferBase::prepareReadAccess
	/// \see mvIMPACT::BufferBase::prepareReadWriteAccess
	 // \internal
	 // if the return value is BufferBase& here (i.e. *this) then the
	 // Python function gets considerably slower, so we use void here
	void setPixel(
			/// the x coordinate of the pixel
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
		    int x,
		    /// the new value
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamComplex Python="int(%(instance)s.datatypeMinValue)"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="int(%(instance)s.datatypeMaxValue)"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int value);


  /// \brief Get the minimal value of a single plane of the profile.
  ///
  /// If the profile has multiple bands, slices or frames, the respective band, slice or frame must be given.
  /// If no band, slice or frame is given, the function defaults to the first band, slice and frame, respectively.
  ///
  /// If you need the minimum values of multiple planes of the profile, getAllMinValues might be more performant.
  ///
  /// \see mvIMPACT::Profile::getMax
  /// \see mvIMPACT::Profile::getMinMax
  /// \see mvIMPACT::Profile::getAllMinValues
  int getMin(
		/// The band to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The slice to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;

  /// \brief Get the minimal values of all planes of the profile.
  ///
  /// The results are returned in a one-dimensional array and ordered in
  /// bands, slices, frames order.
  ///
  /// \see mvIMPACT::Profile::getAllMaxValues
  /// \see mvIMPACT::Profile::getAllMinMaxValues
  /// \see mvIMPACT::Profile::getMin
  std::vector<int> getAllMinValues() const;


  /// \brief Get the maximal values of a single plane of the profile.
  ///
  /// If the profile has multiple bands, slices or frames, the respective band, slice or frame must be given.
  /// If no band, slice or frame is given, the function defaults to the first band, slice and frame, respectively.
  ///
  /// If you need the maximum values of multiple planes of the profile, getAllMaxValues might be more performant.
  ///
  /// \see mvIMPACT::Profile::getMin
  /// \see mvIMPACT::Profile::getMinMax
  /// \see mvIMPACT::Profile::getAllMaxValues
  int getMax(
		/// The band to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The slice to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;

  /// \brief Get the maximal values of all planes of the profile.
  ///
  /// The results are returned in a one-dimensional array and ordered in
  /// bands, slices, frames order.
  ///
  /// \see mvIMPACT::Profile::getAllMinValues
  /// \see mvIMPACT::Profile::getAllMinMaxValues
  /// \see mvIMPACT::Profile::getMax
  std::vector<int> getAllMaxValues() const;


  /// \brief Get the minimal and maximal values of a single plane of the profile.
  ///
  /// The first value is the minimal value, the second value is the maximal value.
  ///
  /// If the profile has multiple bands, slices or frames, the respective band, slice or frame must be given.
  /// If no band, slice or frame is given, the function defaults to the first band, slice and frame, respectively.
  ///
  /// If you need the maximum and minimum values of multiple planes of the profileprofile, getAllMinMaxValues might be more performant.
  ///
  /// \see mvIMPACT::Profile::getMin
  /// \see mvIMPACT::Profile::getMax
  /// \see mvIMPACT::Profile::getAllMinMaxValues
  std::pair<int,int> getMinMax(
		/// The band to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The slice to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;

  /// \brief Get the minimal and maximal values of all planes of the buffer.
  ///
  /// The first value is the minimal value, the second value is the maximal value.
  ///
  /// The results are returned in a one-dimensional array and ordered in
  /// min-max, bands, slices, frames order.
  ///
  /// \see mvIMPACT::Profile::getAllMinValues
  /// \see mvIMPACT::Profile::getAllMaxValues
  /// \see mvIMPACT::Profile::getMinMax
  std::vector<int> getAllMinMaxValues() const;

  /// \brief Get the mean gray value of a single plane of the profile.
  ///
  /// If the profile has multiple bands, slices or frames, the respective band, slice or frame must be given.
  /// If no band, slice or frame is given, the function defaults to the first band, slice and frame, respectively.
  ///
  /// If you need the mean values of multiple planes of the profile, getAllMeanValues might be more performant.
  ///
  /// \see mvIMPACT::Profile::getStdDev
  /// \see mvIMPACT::Profile::getAllMeanValues
  double getMean(
		/// The band to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The slice to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;

  /// \brief Get the mean gray values of all planes of the profile.
  ///
  /// The results are returned in a one-dimensional array and ordered in
  /// bands, slices, frames order.
  ///
  /// \see mvIMPACT::Profile::getAllStdDevValues
  /// \see mvIMPACT::Profile::getMean
  std::vector<double> getAllMeanValues() const;


  /// \brief Get the standard deviation of a single plane of the profile.
  ///
  /// If the profile has multiple bands, slices or frames, the respective band, slice or frame must be given.
  /// If no band, slice or frame is given, the function defaults to the first band, slice and frame, respectively.
  ///
  /// If you need the standard deviation values of multiple profile of the buffer, getAllStdDevValues might be more performant.
  ///
  /// \see mvIMPACT::Profile::getMean
  /// \see mvIMPACT::Profile::getAllStdDevValues
  double getStdDev(
		/// The band to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The slice to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;

  /// \brief Get the standard deviation of all planes of the profile.
  ///
  /// The results are returned in a one-dimensional array and ordered in
  /// bands, slices, frames order.
  ///
  /// \see mvIMPACT::Profile::getAllMeanValues
  /// \see mvIMPACT::Profile::getStdDev
  std::vector<double> getAllStdDevValues() const;


private:

	/// Construct an allocated Profile from a handle
	/// \param bufhandle The buffer handle
	explicit Profile(mvIMPACT_C::IPL_BUFHANDLE bufhandle);
};


/// The base class for histograms.
//-----------------------------------------------------------------------------
class Histogram : public BufferBase
//-----------------------------------------------------------------------------
{
	DECLARE_USAGE_COUNTER

public:
	/// \brief Construct a non-allocated histogram.
	Histogram();


	/// \brief Construct an allocated histogram.
	///
	/// You have to pass sizes for each dimension
	Histogram(
		/// width of the histogram
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int width,
		/// number of bands
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int bands,
		/// number of slices
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int slices,
		/// number of frames
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int frames);


	/// \brief Construct an allocated histogram with specific datatype.
	///
	///
	/// You have to pass sizes for each dimension
	/// The Histogram is created with the datatype specified in parameter \a datatype.
	/// \see #BufferDatatype
	Histogram(
		/// the width of the histogram
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int width,
		/// the number of bands
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int bands,
		/// the number of slices
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int slices,
		/// the number of frames
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int frames,
		/// the desired datatype
		BufferDatatype datatype);


	/// \brief Construct an allocated Histogram buffer from data addressed by a pointer.
	///
	/// The pointer must point to a block of data, and the size and layout of this
	/// block of data is defined by the width, bands, slices, frames and datatype parameters.
	///
	/// The datatype parameters specifies the type of a single pixel. The width parameter
	/// specifies the number of pixels in a single row. The bands parameter specifies the 
	/// number of color bands. The slices parameter specifies the number of slices. The frame 
	/// parameter specifies the number of slices.
	///
	/// The pixels, bands, slices and frames are packed as densely as possible, without any 
	/// extra padding between.
	/// 
	/// The size of the block of data addressed by ptr is 
	/// width * bands * slices * frames * sizeof(datatype).
	/// 
	/// The lifetime of the block of data must be managed by the user. In particular, the data block
	/// addressed by ptr must not be freed before the Histogram buffer is destroyed.
	Histogram(
		/// the width of the histogram
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int width,
		/// the number of bands
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int bands,
		/// the number of slices
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int slices,
		/// the number of frames
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int frames,
		/// the desired datatype
		BufferDatatype datatype,
		/// The pointer to address the histogram data.
		void * ptr);



	/// \brief Construct an allocated child histogram.
	///
	/// You have to specify the offsets and the sizes for each dimension
	Histogram(
		/// reference to the parent histogram
		const Histogram& parent,
		/// the horizontal offset of the child histogram
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.width-%(width)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int xOffset,
		/// the band offset of the child histogram
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.bands-%(bands)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int bandsOffset,
		/// the slice offset of the child histogram
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.slices-%(slices)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slicesOffset,
		/// the frame offset of the child histogram
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.frames-%(frames)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int framesOffset,
		/// the width of the child histogram
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.width-%(xOffset)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int width,
		/// the number of bands of the child histogram
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.bands-%(bands)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int bands,
		/// the number of slices of the child histogram
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.slices-%(slicesOffset)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slices,
		/// the number of frames of the child histogram
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.frames-%(framesOffset)s"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frames);



	/// \brief Construct an allocated child histogram
	///
	/// The offset values are passed in a Coord object.
	/// \note The value of the \c y property of \a offset is ignored.
	/// \see mvIMPACT::Coord
	Histogram(/// reference to the parent histogram
		const Histogram& parent,
		/// the offset values
		const Coord &offset,
		/// width of the child histogram
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.width-%(offset)s.x"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int width,
		/// number of bands of the child histogram
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.bands-%(offset)s.band"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int bands,
		/// number of slices of the child histogram
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.slices-%(offset)s.slice"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slices,
		/// number of frames of the child histogram
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(parent)s.frames-%(offset)s.frame"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frames);

	/// \brief Clone a histogram (deep copy).
	Histogram clone() const;

	/// \brief Copy construct a histogram:
	Histogram(/// the histogram to copy from
		  const Histogram &src);


	/// \brief Copy an Histogram (deep copy), a child histogram as new histogram.
	///
	/// For non-child histograms this does the same as clone().
	///
	/// For child histograms it creates a totally new histogram
	/// and copies the data of the current child histogram into it.
	///
	/// This returns a deep copy of the Histogram. Never a child histogram.
	Histogram copyAsHistogram() const;


	/// \brief Access the parent histogram.
	///
	/// This returns a pointer to the parent histogram for allocated child histograms
	/// or 0 for parent histograms.
	const Histogram* getParentBuffer() const;

	/// \brief Construct an allocated histogram from an xml string.
	///
	/// This constructor can be used to load a serialized histogram
	/// \see mvIMPACT::BufferBase::asXml
	explicit Histogram(/// the xml string
			   const std::string& xmlString);

	/// \brief Destruct a histogram.
	virtual ~Histogram();

#ifndef WRAP_PYTHON
	/// \brief Make a copy on the heap.
	virtual BufferBase* makeShallowCopy() const;
#endif // WRAP_PYTHON


public:
	/// \brief Construct an allocated child histogram from an xml string.
	///
	/// This constructor can be used to load a serialized histogram
	/// \see mvIMPACT::BufferBase::asXml
	Histogram
	  (
	   /// Reference to parent.
	   const Histogram& parent,
	   /// 	The xml string to allocate from.
	   const std::string& xmlString
	   );

#ifndef WRAP_ANY
	/// \brief Overwrite current object with \a src.
	Histogram& operator=(/// the other histogram
			     const Histogram& src);
#endif // #ifndef WRAP_ANY

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
	static Histogram histogramFactory(mvIMPACT_C::IPL_BUFHANDLE handle);
#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS



	/// \brief Get a frequency value.
	///
	/// Note that this operation is quite slow. If you
	/// do a bunch of calls of mvIMPACT::Histogram::getFrequency(int, int, int, int)
	/// with constant \a band, \a slice and \a frame,
	/// call mvIMPACT::BufferBase::prepareReadAccess() before and mvIMPACT::BufferBase::releaseAccess() afterwards.
	/// This speeds up operation of mvIMPACT::Histogram::getFrequency() considerably.
	/// If you also want to call mvIMPACT::Histogram::setFrequency(int, int, int, int, int),
	/// you need to call mvIMPACT::BufferBase::prepareReadWriteAccess instead.
	/// Furthermore you can then call mvIMPACT::Histogram::getFrequency(int,int), i.e. without the paramters
	/// \a band, \a slice and \a frame, which are redundant in this case.
	///
	/// If one of the parameters \a band, \a slice and \a frame doesn't match
	/// the call of the last mvIMPACT::BufferBase::prepareReadAccess or mvIMPACT::BufferBase::prepareReadWriteAccess function, the slow
	/// version of the function is called automatically.
	int getFrequency(
			/// index of the entry
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int index,
			/// band of the entry
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int band,
			/// slice of the entry
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int slice,
			/// frame of the entry
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int frame) const;



	/// \brief Get a frequency value
	///
	/// This function can only be called after a call to
	/// mvIMPACT::BufferBase::prepareReadAccess or mvIMPACT::BufferBase::prepareReadWriteAccess.
	/// However, it is quite fast.
	/// The plane where the entry is accessed (band,slice,frame) is specified with mvIMPACT::BufferBase::prepareReadAccess
	/// or mvIMPACT::BufferBase::prepareReadWriteAccess.
	/// \see mvIMPACT::BufferBase::prepareReadAccess
	/// \see mvIMPACT::BufferBase::prepareReadWriteAccess
	///
	int getFrequency(
			/// index of the entry
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int index) const;


	/// \brief Set a frequency value.
	///
	/// Note that this operation is quite slow. If you
	/// do a bunch of calls of mvIMPACT::Histogram::setFrequency() with constant \a band, \a slice and \a frame,
	/// call mvIMPACT::BufferBase::prepareReadWriteAccess() before and mvIMPACT::BufferBase::releaseAccess() afterwards.
	/// first. This speeds up operation of mvIMPACT::Histogram::setFrequency() considerably.
	///
	/// If one of the parameters \a band, \a slice and \a frame doesn't match
	/// the call of the last mvIMPACT::BufferBase::prepareReadWriteAccess() function, the slow
	/// version of the function is called.
	///
	 // \internal
	 // if the return value is BufferBase& here (i.e. *this) then the
	 // Python function gets considerably slower, so we use void here
	void setFrequency(
			/// index of the frequency entry
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int index,
			/// band of the frequency entry
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int band,
			/// slice of the frequency entry
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int slice,
			/// frame of the frequency entry
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int frame,
			/// the new value
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamComplex Python="int(%(instance)s.datatypeMinValue)"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="int(%(instance)s.datatypeMaxValue)"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int value);



	/// \brief Set a frequency value.
	///
	/// This function can only be called after a call to
	/// mvIMPACT::BufferBase::prepareReadAccess() or mvIMPACT::BufferBase::prepareReadWriteAccess(). However, it is quite fast.
	///
	/// \see mvIMPACT::BufferBase::prepareReadAccess
	/// \see mvIMPACT::BufferBase::prepareReadWriteAccess
	 // \internal
	 // if the return value is BufferBase& here (i.e. *this) then the
	 // Python function gets considerably slower, so we use void here
	void setFrequency(
			/// index of the frequency entry
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int index,
			/// the new value
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamComplex Python="int(%(instance)s.datatypeMinValue)"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="int(%(instance)s.datatypeMaxValue)"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int value);


  /// \brief Get the minimal value of a single plane of an image from its corresponding histogram.
  ///
  /// The smallest grayscale value with a nonzero frequency in the histogram buffer will be returned (this is the minimal pixel value of the source image).
  ///
  /// If the histogram has multiple bands, slices or frames, the respective band, slice or frame must be given.
  /// If no band, slice or frame is given, the function defaults to the first band, slice and frame, respectively.
  ///
  /// If you need the minimum values of multiple planes of the histogram, getAllMinValues might be more performant.
  ///
  /// \see mvIMPACT::Histogram::getMax
  /// \see mvIMPACT::Histogram::getMinMax
  /// \see mvIMPACT::Histogram::getAllMinValues
  int getMin(
		/// The band to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The slice to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;

  /// \brief Get the minimal values of all planes of an image from its corresponding histogram.
  ///
  /// The smallest grayscale value with a nonzero frequency in the histogram buffer will be returned (this is the minimal pixel value of the source image).
  ///
  /// The results are returned in a one-dimensional array and ordered in
  /// bands, slices, frames order.
  ///
  /// \see mvIMPACT::Histogram::getAllMaxValues
  /// \see mvIMPACT::Histogram::getAllMinMaxValues
  /// \see mvIMPACT::Histogram::getMin
  std::vector<int> getAllMinValues() const;


  /// \brief Get the maximal value of a single plane of an image from its corresponding histogram.
  ///
  /// The largest grayscale value with a nonzero frequency in the histogram buffer will be returned (this is the maximal pixel value of the source image).
  ///
  /// If the histogram has multiple bands, slices or frames, the respective band, slice or frame must be given.
  /// If no band, slice or frame is given, the function defaults to the first band, slice and frame, respectively.
  ///
  /// If you need the maximal values of multiple planes of the histogram, getAllMaxValues might be more performant.
  ///
  /// \see mvIMPACT::Histogram::getMin
  /// \see mvIMPACT::Histogram::getMinMax
  /// \see mvIMPACT::Histogram::getAllMaxValues
  int getMax(
		/// The band to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The slice to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;

  /// \brief Get the maximal values of all planes of an image from its corresponding histogram.
  ///
  /// The largest grayscale value with a nonzero frequency in the histogram buffer will be returned (this is the maximal pixel value of the source image).
  ///
  /// The results are returned in a one-dimensional array and ordered in
  /// bands, slices, frames order.
  ///
  /// \see mvIMPACT::Histogram::getAllMinValues
  /// \see mvIMPACT::Histogram::getAllMinMaxValues
  /// \see mvIMPACT::Histogram::getMax
  std::vector<int> getAllMaxValues() const;


  /// \brief Get the minimal and maximal values of a single plane of an image from its corresponding histogram.
  ///
  /// The smallest and largest grayscale values with a nonzero frequency in the histogram buffer will be returned (these are the minimal and maximal pixel values of the source image).
  /// The first value is the minimal value, the second value is the maximal value.
  ///
  /// If the histogram has multiple bands, slices or frames, the respective band, slice or frame must be given.
  /// If no band, slice or frame is given, the function defaults to the first band, slice and frame, respectively.
  ///
  /// If you need the minimum and maximum values of multiple planes of the histogram, getAllMinMaxValues might be more performant.
  ///
  /// \see mvIMPACT::Histogram::getMin
  /// \see mvIMPACT::Histogram::getMax
  /// \see mvIMPACT::Histogram::getAllMinMaxValues
  std::pair<int,int> getMinMax(
		/// The band to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The slice to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;

  /// \brief Get the minimal and maximal values of all planes of an image from its corresponding histogram.
  ///
  /// The smallest and largest grayscale values with a nonzero frequency in the histogram buffer will be returned (these are the minimal and maximal pixel values of the source image).
  /// The first value is the minimal value, the second value is the maximal value.
  ///
  /// The results are returned in a one-dimensional array and ordered in
  /// bands, slices, frames order.
  ///
  /// \see mvIMPACT::Histogram::getAllMinValues
  /// \see mvIMPACT::Histogram::getAllMaxValues
  /// \see mvIMPACT::Histogram::getMinMax
  std::vector<int> getAllMinMaxValues() const;

  /// \brief Get the mean gray value of a single plane of the histogram.
  ///
  /// If the histogram has multiple bands, slices or frames, the respective band, slice or frame must be given.
  /// If no band, slice or frame is given, the function defaults to the first band, slice and frame, respectively.
  ///
  /// If you need the mean values of multiple planes of the histogram, getAllMeanValues might be more performant.
  ///
  /// \see mvIMPACT::Histogram::getStdDev
  /// \see mvIMPACT::Histogram::getAllMeanValues
  double getMean(
		/// The band to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The slice to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;

  /// \brief Get the mean gray values of all planes of the histogram.
  ///
  /// The results are returned in a one-dimensional array and ordered in
  /// bands, slices, frames order.
  ///
  /// \see mvIMPACT::Histogram::getAllStdDevValues
  /// \see mvIMPACT::Histogram::getMean
  std::vector<double> getAllMeanValues() const;


  /// \brief Get the standard deviation of a single plane of the histogram.
  ///
  /// If the histogram has multiple bands, slices or frames, the respective band, slice or frame must be given.
  /// If no band, slice or frame is given, the function defaults to the first band, slice and frame, respectively.
  ///
  /// If you need the standard deviation values of multiple planes of the histogram, getAllStdDevValues might be more performant.
  ///
  /// \see mvIMPACT::Histogram::getMean
  /// \see mvIMPACT::Histogram::getAllStdDevValues
  double getStdDev(
		/// The band to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int band=0,
		/// The slice to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.slicess-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int slice=0,
		/// The frame to be inspected.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int frame=0) const;

  /// \brief Get the standard deviation of all planes of the histogram.
  ///
  /// The results are returned in a one-dimensional array and ordered in
  /// bands, slices, frames order.
  ///
  /// \see mvIMPACT::Histogram::getAllMeanValues
  /// \see mvIMPACT::Histogram::getStdDev
  std::vector<double> getAllStdDevValues() const;

private:

	/// Construct an allocated Histogram from a handle.
	/// \param bufhandle The buffer handle
	explicit Histogram(mvIMPACT_C::IPL_BUFHANDLE bufhandle);
};


/// \brief The stock kernels.
///
/// mvIMPACT provides a number of simple classical filters defined on a 3x3
/// neighborhood. These 3x3 kernels are used with mvIMPACT::convolve.
/// 
/// If you need to change properties of such a stock kernel, you need to create
/// a Kernel from the StockKernel first (using the Kernel constructor that takes a
/// StockKernel argument) and then change the properties of the created Kernel.
///
/// \see mvIMPACT::convolve
/// \see mvIMPACT::Kernel
enum StockKernel
{
	/// Horizontal edge detection kernel.
	/// \image html images/mvi_base/StockKernel_HorEdge.png
	skHorEdge=mvIMPACT_C::IPL_HOR_EDGE,
	/// Vertical edge detection kernel.
	/// \image html images/mvi_base/StockKernel_VertEdge.png
	skVerEdge=mvIMPACT_C::IPL_VER_EDGE,
	/// Sharpening Kernel.
	/// \image html images/mvi_base/StockKernel_Sharpen1.png
	skSharpen1=mvIMPACT_C::IPL_SHARPEN_1,
	/// Sharpening Kernel.
	/// \image html images/mvi_base/StockKernel_Sharpen2.png
	skSharpen2=mvIMPACT_C::IPL_SHARPEN_2,
	/// Smoothing Kernel.
	/// \image html images/mvi_base/StockKernel_Smooth1.png
	skSmooth1=mvIMPACT_C::IPL_SMOOTH_1,
	/// Smoothing Kernel.
	/// \image html images/mvi_base/StockKernel_Smooth2.png
	skSmooth2=mvIMPACT_C::IPL_SMOOTH_2,
	/// Sobel Kernel.
	/// \image html images/mvi_base/StockKernel_Sobel.png
	skSobel=mvIMPACT_C::IPL_SOBEL,
	/// Prewitt Kernel.
	/// \image html images/mvi_base/StockKernel_Prewitt.png
	skPrewitt=mvIMPACT_C::IPL_PREWITT,
	/// Morphological gradient Kernel.
	/// \image html images/mvi_base/StockKernel_MorphGradient.png
	skMorphGradient=mvIMPACT_C::IPL_MORPH_GRAD,
	/// Laplace Kernel.
	/// \image html images/mvi_base/StockKernel_Laplace1.png
	skLaplace1=mvIMPACT_C::IPL_LAPLACE_1,
	/// Laplace Kernel.
	/// \image html images/mvi_base/StockKernel_Laplace2.png
	skLaplace2=mvIMPACT_C::IPL_LAPLACE_2,
	/// Midrange Kernel.
	/// \image html images/mvi_base/StockKernel_Midrange1.png
	skMidrange1=mvIMPACT_C::IPL_MIDRANGE_1,
	/// Midrange Kernel.
	/// \image html images/mvi_base/StockKernel_Midrange2.png
	skMidrange2=mvIMPACT_C::IPL_MIDRANGE_2,
	/// Smoothing Kernel.
	/// \image html images/mvi_base/StockKernel_Smooth3.png
	skSmooth3=mvIMPACT_C::IPL_SMOOTH_3,
	/// Smoothing Kernel.
	/// \image html images/mvi_base/StockKernel_Smooth4.png
	skSmooth4=mvIMPACT_C::IPL_SMOOTH_4,
	/// Sharpening Kernel.
	/// \image html images/mvi_base/StockKernel_Sharpen3.png
	skSharpen3=mvIMPACT_C::IPL_SHARPEN_3,
	/// Sharpening Kernel.
	/// \image html images/mvi_base/StockKernel_Sharpen4.png
	skSharpen4=mvIMPACT_C::IPL_SHARPEN_4,
	/// Diagonal edges Kernel.
	/// \image html images/mvi_base/StockKernel_DiagEdge1.png
	skDiagEdge1=mvIMPACT_C::IPL_DIAG_EDGE_1,
	/// Diagonal edges Kernel.
	/// \image html images/mvi_base/StockKernel_DiagEdge2.png
	skDiagEdge2=mvIMPACT_C::IPL_DIAG_EDGE_2,
	/// Laplace Kernel.
	/// \image html images/mvi_base/StockKernel_Laplace3.png
	skLaplace3=mvIMPACT_C::IPL_LAPLACE_3,
	/// Laplace Kernel.
	/// \image html images/mvi_base/StockKernel_Laplace4.png
	skLaplace4=mvIMPACT_C::IPL_LAPLACE_4,
};


/// The base class for kernels.
///
/// A kernel is a small window which is used in neighborhood operations. This window
/// is moved across the image performing the neighborhood operation. The coefficients of the
/// kernel define it's shape. To prevent that an image is saturated after a neighborhood operation
/// each kernel has a normalization factor. This normalization factor must normally be set to the sum
/// of all coefficients.
/// To create a kernel for smoothing like the one that follows:
/// \image html images/mvi_base/StockKernel_Smooth2.png
/// you have to use method mvIMPACT::Kernel::setCoefficient to set the 9 coefficients and
/// mvIMPACT::Kernel::setNormalizationFactor() with parameter 16 to set the correct
/// normalization factor. There exist a set of predefined kernels which can be used in different
/// functions. See #StockKernel .
//-----------------------------------------------------------------------------
class Kernel : public BufferBase
//-----------------------------------------------------------------------------
{
	DECLARE_USAGE_COUNTER

public:
	/// \brief Get the center of the kernel.
	///
	/// \see mvIMPACT::Point
	Point getCenter() const;

#ifndef WRAP_ANY
	// PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the center of the kernel.
	///
	/// \see mvIMPACT::Point
	Kernel& setCenter(/// the new center point
			  const Point& center);


public:
	/// \brief Construct a non-allocated kernel.
	Kernel();


	/// \brief Construct an allocated kernel from a predefined one.
	/// 
	/// While you can use the predefined StockKernel directly in some
	/// functions, sometimes you need to change 
	/// the overscan behaviour. In this case you need to create a Kernel
	/// from the predefined kernel, so you can then change the
	/// respective properties.
	///
	/// \note The only methods you can call when creating a Kernel using this constructor are:
	/// \note Kernel::getOverscanMode , Kernel::setOverscanMode , 
	/// \note Kernel::getOverscanConstValue and Kernel::setOverscanConstValue .
	/// \note Calling any other method of class Kernel will result in an exception!

	Kernel(
		/// The predefined kernel.
		StockKernel sk);


	/// \brief Construct an allocated kernel of a specific size.
	///
	/// The Kernel is created with the specified dimensions.
	Kernel(
			/// width of the Kernel
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int width,
		    /// height of the Kernel
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int height,
			/// number of bands of the Kernel
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int bands=1,
			/// number of slices of the Kernel
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int slices=1,
			/// number of frames of the Kernel
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int frames=1);


	/// \brief Construct an allocated Kernel buffer from data addressed by a pointer.
	///
	/// The pointer must point to a block of data, and the size and layout of this
	/// block of data is defined by the width, height, bands, slices and frames parameters.
	///
	/// The type of a single pixel implicitly is a signed 8 bit value. The width parameter
	/// specifies the number of pixels in a single row. The height parameter specifies the 
	/// number of rows. The bands parameter specifies the number of color bands. The slices
	/// parameter specifies the number of slices. The frame parameter specifies the number
	/// of slices.
	///
	/// The pixels, rows, bands, slices and frames are packed as densely as possible, without any 
	/// extra padding between.
	/// 
	/// The size of the block of data addressed by ptr is 
	/// width * height * bands * slices * frames.
	/// 
	/// The lifetime of the block of data must be managed by the user. In particular, the data block
	/// addressed by ptr must not be freed before the Kernel buffer is destroyed.
	Kernel(
		/// width of the Kernel
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int width,
		/// height of the Kernel
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int height,
		/// number of bands of the Kernel
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int bands,
		/// number of slices of the Kernel
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int slices,
		/// number of frames of the Kernel
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int frames,
		/// The pointer to address the kernel data.
		void * ptr);


	/// \brief Construct an allocated child kernel.
	///
	/// You have to specify the offsets and sizes for all dimensions
	Kernel(/// reference to the parent Kernel
			const Kernel& parent,
			/// horizontal offset of the child Kernel
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.width-%(width)s"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int xOffset,
			/// vertical offset of the child Kernel
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.height-%(height)s"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int yOffset,
			/// band offset of the child Kernel
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.bands-%(bands)s"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int bandsOffset,
			/// slice offset of the child Kernel
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.slices-%(slices)s"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int slicesOffset,
			/// frame offset of the child Kernel
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.frames-%(frames)s"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int framesOffset,
			/// width of the child Kernel
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.width-%(xOffset)s"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int width,
			/// height of the child Kernel
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.height-%(yOffset)s"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int height,
			/// number of bands of the child Kernel
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.bands-%(bandsOffset)s"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int bands,
			/// number of slices of the child Kernel
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.slices-%(slicesOffset)s"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int slices,
			/// number of frames of the child Kernel
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.frames-%(framesOffset)s"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int frames);



	/// \brief Construct an allocated child kernel.
	///
	/// The offsets are passed using a Coord object
	/// \see mvIMPACT::Coord
	Kernel(/// referece to the parent Kernel
			const Kernel& parent,
			/// the offset values
			const Coord &offset,
			/// width of the child Kernel
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.width-%(offset)s.x"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int width,
			/// heigth of the child Kernel
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.height-%(offset)s.y"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int height,
			/// number of bands of the child Kernel
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.bands-%(offset)s.band"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int bands,
			/// number of slices of the child Kernel
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.slices-%(offset)s.slice"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int slices,
			/// number of frames of the child Kernel
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.frames-%(offset)s.frame"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int frames);



	/// \brief Copy an Kernel (deep copy), a child kernel as new kernel.
	///
	/// For non-child kernels this does the same as clone().
	///
	/// For child kernels it creates a totally new kernel
	/// and copies the data of the current child kernel into it.
	///
	/// This returns a  deep copy of the Kernel. Never a child kernel.
	Kernel copyAsKernel() const;

	/// \brief Clone a kernel (deep copy).
	Kernel clone() const;

	/// \brief Copy-construct a kernel:
	Kernel(/// the Kernel to copy from
	       const Kernel &src);

	/// \brief Access the parent kernel.
	///
	/// This returns a  pointer to the parent kernel for allocated child kernels or 0 for parent kernels.
	const Kernel* getParentBuffer() const;

	/// \brief Destruct a Kernel
	virtual ~Kernel();


#ifndef WRAP_PYTHON
	/// \brief Make a copy on the heap.
	virtual BufferBase* makeShallowCopy() const;
#endif // WRAP_PYTHON


public:
	/// \brief Construct an allocated kernel from an xml string.
	///
	/// This constructor can be used to load a serialized kernel.
	/// \see mvIMPACT::BufferBase::asXml
	explicit Kernel(/// the xml string
			const std::string& xmlString);


	/// \brief Construct an allocated child kernel from an xml string.
	///
	/// This constructor can be used to load a serialized kernel.
	/// \see mvIMPACT::BufferBase::asXml
	Kernel
	  (
	   /// Reference to parent.
	   const Kernel& parent,
	   /// The xml string to allocate from.
	   const std::string& xmlString
	   );

#ifndef WRAP_ANY
	/// \brief Overwrite current object with \a src.
	Kernel& operator=(/// the other kernel
			  const Kernel& src);
#endif // #ifndef WRAP_ANY

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
	static Kernel kernelFactory(mvIMPACT_C::IPL_BUFHANDLE handle);
#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS



	/// \brief Get a kernel coefficient.
	///
	/// Note that this operation is quite slow. If you
	/// do a bunch of calls of mvIMPACT::Kernel::getCoefficient(int, int, int, int, int)
	/// with constant \a band, \a slice and \a frame,
	/// call mvIMPACT::BufferBase::prepareReadAccess() before and mvIMPACT::BufferBase::releaseAccess() afterwards.
	/// This speeds up operation of mvIMPACT::Kernel::getCoefficient() considerably.
	/// If you also want to call mvIMPACT::Kernel::setCoefficient(int, int, int, int, int, int),
	/// you need to call mvIMPACT::BufferBase::prepareReadWriteAccess instead.
	/// Furthermore you can then call mvIMPACT::Kernel::getCoefficient(int,int), i.e. without the paramters
	/// \a band, \a slice and \a frame, which are redundant in this case.
	///
	/// If one of the parameters \a band, \a slice and \a frame doesn't match
	/// the call of the last mvIMPACT::BufferBase::prepareReadAccess or mvIMPACT::BufferBase::prepareReadWriteAccess function, the slow
	/// version of the function is called automatically.
	int getCoefficient(
			/// x coordinate of the coefficient value
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int x,
			/// y coordinate of the coefficient value
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int y,
			/// band of the coefficient value
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int band,
			/// slice of the coefficient value
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int slice,
			/// frame of the coefficient value
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int frame) const;


	/// \brief Get a kernel coefficient.
	///
	/// This function can only be called after a call to
	/// mvIMPACT::BufferBase::prepareReadAccess or mvIMPACT::BufferBase::prepareReadWriteAccess.
	/// However, it is quite fast.
	/// The plane where the pixel is accessed (band,slice,frame) is specified with mvIMPACT::BufferBase::prepareReadAccess
	/// or mvIMPACT::BufferBase::prepareReadWriteAccess.
	/// \see mvIMPACT::BufferBase::prepareReadAccess
	/// \see mvIMPACT::BufferBase::prepareReadWriteAccess
	///
	int getCoefficient(
			/// x coordinate of the coefficient value
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int x,
			/// y coordinate of the coefficient value
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int y) const;



	/// \brief Set a kernel coefficient value.
	///
	/// Note that this operation is quite slow. If you
	/// do a bunch of calls of mvIMPACT::Kernel::setCoefficient() with constant \a band, \a slice and \a frame,
	/// call mvIMPACT::BufferBase::prepareReadWriteAccess() before and mvIMPACT::BufferBase::releaseAccess() afterwards.
	/// first. This speeds up operation of mvIMPACT::Kernel::setCoefficient() considerably.
	///
	/// If one of the parameters \a band, \a slice and \a frame doesn't match
	/// the call of the last mvIMPACT::BufferBase::prepareReadWriteAccess() function, the slow
	/// version of the function is called.
	///
	 // \internal
	 // if the return value is BufferBase& here (i.e. *this) then the
	 // Python function gets considerably slower, so we use void here
	void setCoefficient(
			/// the x cooordinate of the coefficient entry
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int x,
			/// the y cooordinate of the coefficient entry
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int y,
			/// the band of the coefficient entry
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int band,
			/// the slice of the coefficient entry
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int slice,
			/// the frame of the coefficient entry
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int frame,
			/// the new coeffiient value
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamComplex Python="int(%(instance)s.datatypeMinValue)"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="int(%(instance)s.datatypeMaxValue)"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int value);

	/// \brief Set a kernel coefficient value
	///
	/// This function can only be called after a call to
	/// mvIMPACT::BufferBase::prepareReadAccess() or mvIMPACT::BufferBase::prepareReadWriteAccess(). However, it is quite fast.
	///
	/// \see mvIMPACT::BufferBase::prepareReadAccess
	/// \see mvIMPACT::BufferBase::prepareReadWriteAccess
	 // \internal
	 // if the return value is BufferBase& here (i.e. *this) then the
	 // Python function gets considerably slower, so we use void here
	void setCoefficient(
			/// the x cooordinate of the coefficient entry
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int x,
			/// the y cooordinate of the coefficient entry
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int y,
			/// the new coefficient value
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamComplex Python="int(%(instance)s.datatypeMinValue)"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="int(%(instance)s.datatypeMaxValue)"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int value);



	/// \brief Get the Kernel's current clipping mode.
	///
	/// \see KernelClippingMode
	KernelClippingMode getClippingMode() const;

#ifndef WRAP_ANY
	// PROP
#endif // #ifndef WRAP_ANY

	/// \brief Sets the Kernel's clipping mode.
	///
	/// \see KernelClippingMode
    Kernel& setClippingMode(/// the cliping mode to use
				KernelClippingMode clippingMode);


	/// \brief Get the Kernel's current overscan mode.
	///
	/// \see #OverscanMode
	OverscanMode getOverscanMode() const;

#ifndef WRAP_ANY
	// PROP
#endif // #ifndef WRAP_ANY

	/// \brief Sets the Kernel's overscan mode.
	///
	/// \see #OverscanMode
	Kernel& setOverscanMode(/// the overscan mode
				OverscanMode overscanMode);


	/// \brief Get the constant value for overscan processing at the image border.
	///
	/// If the OverscanMode property is set to omOverscanReplace,
	/// the returned value is used to set the border pixels.
	/// \see mvIMPACT::Kernel::setOverscanMode
	/// \see #OverscanMode
	int getOverscanConstValue() const;

#ifndef WRAP_ANY
	// PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the constant value for overscan processing at the image border.
	///
	/// If the OverscanMode property is set to omOverscanReplace,
	/// take \a val as the constant value to set the border pixels.
	/// \see mvIMPACT::Kernel::setOverscanMode
	/// \see #OverscanMode
	Kernel& setOverscanConstValue(/// the constant value to be used
				      int overscanValue);


	/// \brief Returns the Kernel's current normalization value.
	///
	int getNormalizationFactor() const;

#ifndef WRAP_ANY
	// PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the Kernel's normalization value.
	Kernel& setNormalizationFactor(
			/// the normalization value
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int normalizationFactor);


private:

	/// Construct an allocated kernel from a handle.
	/// \param bufhandle The buffer handle
	explicit Kernel(mvIMPACT_C::IPL_BUFHANDLE bufhandle);
};


/// There are two preset structuring elements. These are:
/// - \c sseSquare: a 3x3 square
/// \image html images/mvi_base/PresetStructuringElement_Square.png
/// - \c sseCross: a cross in a 3x3 square
/// \image html images/mvi_base/PresetStructuringElement_Cross.png
/// \note In the images the grey pixels make up the structuring element. The white pixels are the pixels
/// \note that are set to a "don't care" state.
/// 
/// If you need to change properties of such a stock structuring element, you need to create
/// a StructuringElement from the StockStructuringElement first (using the StructuringElement constructor that takes a
/// StockStructuringElement argument) and then change the properties of the created StructuringElement.
///
/// \see mvIMPACT::StructuringElement
enum StockStructuringElement
{
	/// Simple 3x3 square around the current pixel
	sseSquare=mvIMPACT_C::IPL_RECT_3x3,
	/// cross ("+", no "x") in a square with 3 pixels width and height
	sseCross=mvIMPACT_C::IPL_CROSS_3x3

};


/// \brief The base class for structuring elements.
///
/// This class is derived from mvIMPACT::BufferBase
//-----------------------------------------------------------------------------
class StructuringElement : public BufferBase
//-----------------------------------------------------------------------------
{
	DECLARE_USAGE_COUNTER

public:
	/// \brief Get the center of the structuring element.
	///
	/// This returns a point containing the center.
	/// \see mvIMPACT::Point
	Point getCenter() const;

#ifndef WRAP_ANY
	// PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the center of the structuring element.
	///
	/// \see mvIMPACT::Point
	StructuringElement& setCenter(/// a point containing the center.
				      const Point& center);


public:
	/// \brief Construct a non-allocated structuring element.
	StructuringElement();


	/// \brief Construct an allocated structuring element from a predefined one.
	/// 
	/// While you can use the predefined StockStructuringElement directly in some
	/// functions, sometimes you need to change the overscan behaviour. 
	/// In this case you need to create a StructuringElement
	/// from the predefined structuring element, so you can then change the
	/// respective properties.
	///
	/// \note The only methods you can call when creating a StructuringElement using this constructor are:
	/// \note StructuringElement::getOverscanMode , StructuringElement::setOverscanMode , 
	/// \note StructuringElement::getOverscanConstValue and StructuringElement::setOverscanConstValue .
	/// \note Calling any other method of class StructuringElement will result in an exception!
	StructuringElement(
		/// The predefined structuring element.
		StockStructuringElement sse);


	/// \brief Construct an allocated structuring element.
	///
	/// The structuring element is created with the specified dimensions and datatype.
	StructuringElement(
			/// width of the structuring element
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int width,
			/// height of the structuring element
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int height,
			/// number of bands of the structuring element
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int bands=1,
			/// number of slices of the structuring element
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int slices=1,
			/// number of frames of the structuring element
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int frames=1);

	/// \brief Construct an allocated StructuringElement buffer from data addressed by a pointer.
	///
	/// The pointer must point to a block of data, and the size and layout of this
	/// block of data is defined by the width, height, bands, slices and frames parameters.
	///
	/// The type of a single pixel implicitly is a signed 32 bit value. The width parameter
	/// specifies the number of pixels in a single row. The height parameter specifies the 
	/// number of rows. The bands parameter specifies the number of color bands. The slices
	/// parameter specifies the number of slices. The frame parameter specifies the number
	/// of slices.
	///
	/// The pixels, rows, bands, slices and frames are packed as densely as possible, without any 
	/// extra padding between.
	/// 
	/// The size of the block of data addressed by ptr is 
	/// width * height * bands * slices * frames * 4.
	/// 
	/// The lifetime of the block of data must be managed by the user. In particular, the data block
	/// addressed by ptr must not be freed before the StructuringElement buffer is destroyed.
	StructuringElement(
		/// width of the structuring element
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int width,
		/// height of the structuring element
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int height,
		/// number of bands of the structuring element
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int bands,
		/// number of slices of the structuring element
	  	/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int slices,
		/// number of frames of the structuring element
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int frames,
		/// The pointer to address the structuring element data.
		void * ptr);

	/// Construct an allocated child structuring element.
	///
	/// you have to specifiy offsets and sizes for each dimension
	StructuringElement(/// reference to the parent
			const StructuringElement& parent,
			/// horizontal offset of the child structuring element
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.width-%(width)s"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int xOffset,
			/// vertical offset of the child structuring element
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.height-%(height)s"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int yOffset,
			/// band offset of the child structuring element
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.bands-%(bands)s"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int bandsOffset,
			/// slice offset of the child structuring element
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.slices-%(slices)s"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int slicesOffset,
			/// frame offset of the child structuring element
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.frames-%(frames)s"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int framesOffset,
			/// width of the child structuring element
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.width-%(xOffset)s"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int width,
			/// height of the child structuring element
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.height-%(yOffset)s"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int height,
			/// number of bands of the child structuring element
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.bands-%(bandsOffset)s"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int bands,
			/// number of slices of the child structuring element
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.slices-%(slicesOffset)s"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int slices,
			/// number of frames of the child structuring element
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.frames-%(framesOffset)s"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int frames);


	/// \brief Construct an allocated child structuring element.
	///
	/// The offsets are passed in a Coor object.
	/// \see mvIMPACT::Coord
	StructuringElement(/// reference to the parent structuring element
			const StructuringElement& parent,
			/// Coord object that contains the offsets
			const Coord &offset,
			/// width of the structuring element
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.width-%(offset)s.x"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int width,
			/// height of the structuring element
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.height-%(offset)s.y"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int height,
			/// number of bands of the structuring element
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.bands-%(offset)s.band"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int bands,
			/// number of slices of the structuring element
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.slices-%(offset)s.slice"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int slices,
			/// number of frames of the structuring element
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(parent)s.frames-%(offset)s.frame"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int frames);

	/// \brief Clone a structuring element (deep copy).
	StructuringElement clone() const;

	/// \brief Copy an StructuringElement (deep copy), a child structuring element as new structuring element.
	///
	/// For non-child structuring elements this does the same as clone().
	///
	/// For child structuring elements it creates a totally new structuring element
	/// and copies the data of the current child structuring element into it.
	///
	/// This returns a deep copy of the StructuringElement. Never a child structuring element.
	StructuringElement copyAsStructuringElement() const;


	/// \brief Access the parent structuring element.
	///
	/// This returns a pointer to the parent StructuringElement for allocated child structuring elements
	///         or 0 for parent structuring element.
	const StructuringElement* getParentBuffer() const;


	/// \brief Destruct a structuring element.
	virtual ~StructuringElement();

#ifndef WRAP_PYTHON
	/// \brief Make a copy on the heap.
	virtual BufferBase* makeShallowCopy() const;
#endif // WRAP_PYTHON

public:

	/// \brief Construct an allocated structuring element from an xml string
	///
	/// This constructor can be used to load a serialized StructuringElement
	/// \see mvIMPACT::BufferBase::asXml
	explicit StructuringElement(/// the xml string
				    const std::string& xmlString);


	/// \brief Construct an allocated child structuring element from an xml string.
	///
	/// This constructor can be used to load a serialized StructuringElement
	/// \see mvIMPACT::BufferBase::asXml
	StructuringElement
	  (
	   /// Reference to parent.
	   const StructuringElement& parent,
	   /// The xml string to allocate from.
	   const std::string& xmlString
	   );

#ifndef WRAP_ANY
	/// \brief Overwrite current object with \a src.
	StructuringElement& operator=(/// the other StructuringElement
				      const StructuringElement& src);
#endif // #ifndef WRAP_ANY

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
	static StructuringElement structuringElementFactory(mvIMPACT_C::IPL_BUFHANDLE handle);
#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

	/// \brief Copy-construnct a structuring element
	StructuringElement(/// the StructuringElement to copy from
			   const StructuringElement &src);


	/// \brief Get a coefficient value.
	///
	/// Note that this operation is quite slow. If you
	/// do a bunch of calls of mvIMPACT::StructuringElement::getCoefficient(int, int, int, int, int)
	/// with constant \a band, \a slice and \a frame,
	/// call mvIMPACT::BufferBase::prepareReadAccess() before and mvIMPACT::BufferBase::releaseAccess() afterwards.
	/// This speeds up operation of mvIMPACT::StructuringElement::getCoefficient() considerably.
	/// If you also want to call mvIMPACT::StructuringElement::setCoefficient(int, int, int, int, int, int),
	/// you need to call mvIMPACT::BufferBase::prepareReadWriteAccess instead.
	/// Furthermore you can then call mvIMPACT::StructuringElement::getCoefficient(int,int), i.e. without the paramters
	/// \a band, \a slice and \a frame, which are redundant in this case.
	///
	/// If one of the parameters \a band, \a slice and \a frame doesn't match
	/// the call of the last mvIMPACT::BufferBase::prepareReadAccess or mvIMPACT::BufferBase::prepareReadWriteAccess function, the slow
	/// version of the function is called automatically.
	int getCoefficient(
			/// the x coordinate of the coefficient entry
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int x,
			/// the y coordinate of the coefficient entry
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int y,
			/// band of the coefficient entry
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int band,
			/// slice of the coefficient entry
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int slice,
			/// frame of the coefficient entry
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int frame) const;


	/// \brief Get a pixel's value.
	///
	/// This function can only be called after a call to
	/// mvIMPACT::BufferBase::prepareReadAccess or mvIMPACT::BufferBase::prepareReadWriteAccess.
	/// However, it is quite fast.
	/// The plane where the pixel is accessed (band,slice,frame) is specified with mvIMPACT::BufferBase::prepareReadAccess
	/// or mvIMPACT::BufferBase::prepareReadWriteAccess.
	/// \see mvIMPACT::BufferBase::prepareReadAccess
	/// \see mvIMPACT::BufferBase::prepareReadWriteAccess
	///
	int getCoefficient(
			/// the x coordinate of the coefficient entry
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int x,
			/// the y coordinate of the coefficient entry
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int y) const;



	/// \brief Set a coefficient value.
	///
	/// Note that this operation is quite slow. If you
	/// do a bunch of calls of mvIMPACT::StructuringElement::setCoefficient() with constant \a band, \a slice and \a frame,
	/// call mvIMPACT::BufferBase::prepareReadWriteAccess() before and mvIMPACT::BufferBase::releaseAccess() afterwards.
	/// first. This speeds up operation of mvIMPACT::StructuringElement::setCoefficient() considerably.
	///
	/// If one of the parameters \a band, \a slice and \a frame doesn't match
	/// the call of the last mvIMPACT::BufferBase::prepareReadWriteAccess() function, the slow
	/// version of the function is called.
	///
	 // \internal
	 // if the return value is BufferBase& here (i.e. *this) then the
	 // Python function gets considerably slower, so we use void here
	void setCoefficient(
			/// the x coordinate of the coefficient value
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int x,
			/// the y coordinate of the coefficient value
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int y,
			/// the band of the coefficient value
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.bands-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int band,
			/// the slice of the coefficient value
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.slices-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int slice,
			/// the frame of the coefficient value
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.frames-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int frame,
			/// the new coefficient value
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="-1"/></mvParamMin>
			/// <mvParamMax><mvParamConst value="1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int value);


	/// \brief Set a pixel's value.
	///
	/// This function can only be called after a call to
	/// mvIMPACT::BufferBase::prepareReadAccess() or mvIMPACT::BufferBase::prepareReadWriteAccess(). However, it is quite fast.
	///
	/// \see mvIMPACT::BufferBase::prepareReadAccess
	/// \see mvIMPACT::BufferBase::prepareReadWriteAccess
	 // \internal
	 // if the return value is BufferBase& here (i.e. *this) then the
	 // Python function gets considerably slower, so we use void here
	void setCoefficient(
			/// the x coordinate of the coefficient
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.width-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int x,
			/// the y coordinate of the coefficient
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.height-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int y,
			/// the new coefficient value
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="-1"/></mvParamMin>
			/// <mvParamMax><mvParamConst value="1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int value);



	/// \brief Get the StructuringElement's current overscan mode.
	///
	/// \see #OverscanMode
	OverscanMode getOverscanMode() const;

#ifndef WRAP_ANY
	// PROP
#endif // #ifndef WRAP_ANY

	/// \brief Sets the StructuringElement's overscan mode.
	///
	/// \see #OverscanMode
	StructuringElement& setOverscanMode(/// the overscan mode
					    OverscanMode overscanMode);


	/// \brief Get the constant value for overscan processing at the image border.
	///
	/// If the OverscanMode property is set to omOverscanReplace,
	/// the returned value is used to set the border pixels.
	/// \see mvIMPACT::StructuringElement::setOverscanMode
	/// \see #OverscanMode
	int getOverscanConstValue() const;

#ifndef WRAP_ANY
	// PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the constant value for overscan processing at the image border.
	///
	/// If the OverscanMode property is set to omOverscanReplace,
	/// take \a overscanConstValue as the constant value to set the border pixels.
	/// \see mvIMPACT::StructuringElement::setOverscanMode
	/// \see #OverscanMode
	StructuringElement& setOverscanConstValue(
			/// the constant value to be used
			int overscanConstValue);

private:

	/// Construct an allocated structuring element from a handle.
	/// \param bufhandle The buffer handle
	explicit StructuringElement(mvIMPACT_C::IPL_BUFHANDLE bufhandle);
};



PYTHON_ONLY(%feature("director") OnProgress);
/// \brief Base class to provide progress feedback.
///
/// To use this, you must derive a new class from Progress and
/// overload mvIMPACT::Progress::onUpdate(). In mvIMPACT::OnProgess::onUpdate() you should perform the task you
/// want to do when progress events are generated.
//-----------------------------------------------------------------------------
class OnProgress
//-----------------------------------------------------------------------------
{
public:
	/// \brief Constructor.
	OnProgress();

	/// \brief Destructor.
	virtual ~OnProgress() =0;

#ifndef WRAP_DOTNET		// this is injected
	/// \brief The callback that gets called when progress callbacks are delivered.
	///
	/// It is called at periodic intervals to give feedback about function progress.
	/// It indicates a ready percentage, telling how many of the function is complete,
	/// it gives stepwise feedback for functions where a percentage is not known and
	/// it indicates the end of processing.
	///
	/// You can calculate the percentage already done by this formula: total * 100 / done.
	///
	/// If both total and done are 0, this is an incremental step progress.
	///
	/// If total is -1 this is the end of processing.
	///
	/// \return True to continue processing, false to abort processing.
	virtual bool onUpdate(
		/// Specifies the number of total steps (this is the equivalent of 100%),
		/// or 0 to step, or -1 to indicate end of processing.
		int total,
		/// Specifies the number of steps complete (this is the equivalent of the
		/// actual done percentage), or 0 to step or any value to indicate end of
		/// processing.
		int done);
#endif // #ifndef WRAP_DOTNET

#ifndef WRAP_ANY
	// for backward compatibility reasons
	virtual bool update(int total, int done);
#endif // #ifndef WRAP_ANY

	/// \brief Enables progress callbacks.
	///
	/// \see mvIMPACT::onProgress::disable
	void enable();

	/// \brief Disables progress callbacks.
	///
	/// \see mvIMPACT::onProgress::enable
	void disable();

	/// \brief Indicates whether the callback is enabled.
	///
	/// Returns \c true if enabled or \c false if not.
	bool getIsEnabled() const;

private:

	bool enabled_;

#ifndef WRAP_ANY
	static mvIMPACT_C::IPL_BOOL IPL_C_CALLTYPE progress_function(mvIMPACT_C::IPL_LONG Total, mvIMPACT_C::IPL_LONG Done, mvIMPACT_C::IPL_VOID_PTR Cookie);
#endif // #ifndef WRAP_ANY
};

// Note: the combineBuffers come in versions for Images, Palettes, and the other buffer types. On the C++ side overloading is fine, since
// the compiler can disinguish the various overloads by the type of the first parameter. However, when mapping this to .NET a problem occurs:
// all the different first parameters are mapped to the same Array type, thus the distinction is lost. In order to fix this, we added
// function that can be distinguished by name, i.e. combineImages, combinePalettes, etc.


/// \brief Construct an allocated mvIMPACT::Image by combination of multiple images in different
/// dimensions.

/// This function allows you to combine two or more images in the
/// x-, y-, band-, slice- or frame-dimension. The images you want to combine must have
/// equal datatype and equal dimensions (except in the
/// dimension you want to combine). Child images cannot be combined.
/// Example how to use this:
/// \code
/// Image i1 = loadImage("img1.bmp"); // 256x256
/// Image i2 = loadImage("img2.bmp"); // 256x256
///
/// vector<Image> v;
/// v.push_back(i1);
/// v.push_back(i2);
///
/// Image i3 = combineBuffers(v,dsDimX,128,128);
/// \endcode
/// Both images in the vector are scaled to 128x128 before they are horizontally
/// combined to a resulting image with the dimension 256x128.
/// \see #DimensionSpec
/// \see #GeometricInterpolation
/// \see mvIMPACT::Image
//-----------------------------------------------------------------------------
Image combineImages
(
	/// The vector of mvIMPACT::Image objects to be combined.
	const std::vector<Image>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, buffers),
	/// The combination dimension specifier.
	DimensionSpec dimensionSpec,
	/// All images in \c buffers are scaled to this width
	/// before they are combined.
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
	/// </mvParamRange>
	/// \endxmlonly
	int width,
	/// All images in \c buffers are scaled to this height
	/// before they are combined.
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
	/// </mvParamRange>
	/// \endxmlonly
	int height,
	/// The geometric interpolation mode.
	GeometricInterpolation geometricInterpolation = giBilinear
	);


/// \brief Construct an allocated mvIMPACT::Image by combination of multiple images in different
/// dimensions.

/// This function allows you to combine two or more images in the
/// x-, y-, band-, slice- or frame-dimension. The images you want to combine must have
/// equal datatype and equal dimensions (except in the
/// dimension you want to combine). Child images cannot be combined.
/// Example how to use this:
/// \code
/// Image i1 = loadImage("img1.bmp"); // 256x256
/// Image i2 = loadImage("img2.bmp"); // 256x256
///
/// vector<Image> v;
/// v.push_back(i1);
/// v.push_back(i2);
///
/// Image i3 = combineBuffers(v,dsDimX,128,128);
/// \endcode
/// Both images in the vector are scaled to 128x128 before they are horizontally
/// combined to a resulting image with the dimension 256x128.
/// \see #DimensionSpec
/// \see #GeometricInterpolation
/// \see mvIMPACT::Image
//-----------------------------------------------------------------------------
Image combineBuffers
(
	/// The vector of mvIMPACT::Image objects to be combined.
	const std::vector<Image>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, buffers),
	/// The combination dimension specifier.
	DimensionSpec dimensionSpec,
	/// All images in \c buffers are scaled to this width
	/// before they are combined.
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
	/// </mvParamRange>
	/// \endxmlonly
	int width,
	/// All images in \c buffers are scaled to this height
	/// before they are combined.
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
	/// </mvParamRange>
	/// \endxmlonly
	int height,
	/// The geometric interpolation mode.
	GeometricInterpolation geometricInterpolation = giBilinear
	);



/// \brief Construct an allocated mvIMPACT::Palette by combination of multiple palettes in different
/// dimensions.

/// This function allows you to combine two or more palettes in the
/// x-, y-, band-, slice- or frame-dimension. The palettes you want to combine must have
/// equal datatype and equal dimensions (except in the
/// dimension you want to combine). Child buffers cannot be combined.
/// \see #DimensionSpec
/// \see mvIMPACT::Palette
Palette combinePalettes
(
	/// The vector of buffers to be combined.
	const std::vector<Palette>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, buffers),
	/// The combination dimension specifier.
	DimensionSpec dimensionSpec
	);

/// \brief Construct an allocated mvIMPACT::Palette by combination of multiple palettes in different
/// dimensions.

/// This function allows you to combine two or more palettes in the
/// x-, y-, band-, slice- or frame-dimension. The palettes you want to combine must have
/// equal datatype and equal dimensions (except in the
/// dimension you want to combine). Child buffers cannot be combined.
/// \see #DimensionSpec
/// \see mvIMPACT::Palette
Palette combineBuffers
(
	/// The vector of buffers to be combined.
	const std::vector<Palette>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, buffers),
	/// The combination dimension specifier.
	DimensionSpec dimensionSpec
	);



/// \brief Construct an allocated mvIMPACT::Profile by combination of multiple profiles in different
/// dimensions.

/// This function allows you to combine two or more profiles in the
/// x-, y-, band-, slice- or frame-dimension. The profiles you want to combine must have
/// equal datatype and equal dimensions (except in the
/// dimension you want to combine). Child buffers cannot be combined.
/// \see #DimensionSpec
/// \see #GeometricInterpolation
/// \see mvIMPACT::Profile
Profile combineProfiles
(
	/// The vector of mvIMPACT::Profile objects to be combined.
	const std::vector<Profile>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, buffers),
	/// The combination dimension specifier.
	DimensionSpec dimensionSpec,
	/// All profiles in \c buffers are scaled to this width
	/// before they are combined.
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
	/// </mvParamRange>
	/// \endxmlonly
	int width,
	/// The geometric interpolation mode.
	GeometricInterpolation geometricInterpolation = giBilinear
	);

/// \brief Construct an allocated mvIMPACT::Profile by combination of multiple profiles in different
/// dimensions.

/// This function allows you to combine two or more profiles in the
/// x-, y-, band-, slice- or frame-dimension. The profiles you want to combine must have
/// equal datatype and equal dimensions (except in the
/// dimension you want to combine). Child buffers cannot be combined.
/// \see #DimensionSpec
/// \see #GeometricInterpolation
/// \see mvIMPACT::Profile
Profile combineBuffers
(
	/// The vector of mvIMPACT::Profile objects to be combined.
	const std::vector<Profile>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, buffers),
	/// The combination dimension specifier.
	DimensionSpec dimensionSpec,
	/// All profiles in \c buffers are scaled to this width
	/// before they are combined.
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
	/// </mvParamRange>
	/// \endxmlonly
	int width,
	/// The geometric interpolation mode.
	GeometricInterpolation geometricInterpolation = giBilinear
	);



/// \brief Construct an allocated mvIMPACT::Histogram by combination of multiple histograms in different
/// dimensions.

/// This function allows you to combine two or more histograms in the
/// x-, y-, band-, slice- or frame-dimension. The histograms you want to combine must have
/// equal datatype and equal dimensions (except in the
/// dimension you want to combine). Child buffers cannot be combined.
/// \see #DimensionSpec
/// \see mvIMPACT::Histogram
Histogram combineHistograms
(
	/// The vector of buffers to be combined.
	const std::vector<Histogram>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, buffers),
	/// The combination dimension specifier.
	DimensionSpec dimensionSpec
	);

/// \brief Construct an allocated mvIMPACT::Histogram by combination of multiple histograms in different
/// dimensions.

/// This function allows you to combine two or more histograms in the
/// x-, y-, band-, slice- or frame-dimension. The histograms you want to combine must have
/// equal datatype and equal dimensions (except in the
/// dimension you want to combine). Child buffers cannot be combined.
/// \see #DimensionSpec
/// \see mvIMPACT::Histogram
Histogram combineBuffers
(
	/// The vector of buffers to be combined.
	const std::vector<Histogram>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, buffers),
	/// The combination dimension specifier.
	DimensionSpec dimensionSpec
	);



/// \brief Construct an allocated mvIMPACT::Kernel by combination of multiple kernels in different
/// dimensions.

/// This function allows you to combine two or more kernels in the
/// x-, y-, band-, slice- or frame-dimension. The kernels you want to combine must have
/// equal datatype and equal dimensions (except in the
/// dimension you want to combine). Child buffers cannot be combined.
/// \see #DimensionSpec
/// \see #GeometricInterpolation
/// \see mvIMPACT::Kernel
Kernel combineKernels
(
	/// The vector of mvIMPACT::Kernel objects to be combined.
	const std::vector<Kernel>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, buffers),
	/// The combination dimension specifier.
	DimensionSpec dimensionSpec
	);

/// \brief Construct an allocated mvIMPACT::Kernel by combination of multiple kernels in different
/// dimensions.

/// This function allows you to combine two or more kernels in the
/// x-, y-, band-, slice- or frame-dimension. The kernels you want to combine must have
/// equal datatype and equal dimensions (except in the
/// dimension you want to combine). Child buffers cannot be combined.
/// \see #DimensionSpec
/// \see #GeometricInterpolation
/// \see mvIMPACT::Kernel
Kernel combineBuffers
(
	/// The vector of mvIMPACT::Kernel objects to be combined.
	const std::vector<Kernel>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, buffers),
	/// The combination dimension specifier.
	DimensionSpec dimensionSpec
	);



/// \brief Construct an allocated mvIMPACT::StructuringElement by combination of multiple structuring elements in different
/// dimensions.

/// This function allows you to combine two or more structuring elements in the
/// x-, y-, band-, slice- or frame-dimension. The structuring elements you want to combine must have
/// equal datatype and equal dimensions (except in the
/// dimension you want to combine). Child buffers cannot be combined.
/// \see #DimensionSpec
/// \see #GeometricInterpolation
/// \see mvIMPACT::StructuringElement
StructuringElement combineStructuringElements
(
	/// The vector of mvIMPACT::StructuringElement objects to be combined.
	const std::vector<StructuringElement>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, buffers),
	/// The combination dimension specifier.
	DimensionSpec dimensionSpec
	);

/// \brief Construct an allocated mvIMPACT::StructuringElement by combination of multiple structuring elements in different
/// dimensions.

/// This function allows you to combine two or more structuring elements in the
/// x-, y-, band-, slice- or frame-dimension. The structuring elements you want to combine must have
/// equal datatype and equal dimensions (except in the
/// dimension you want to combine). Child buffers cannot be combined.
/// \see #DimensionSpec
/// \see #GeometricInterpolation
/// \see mvIMPACT::StructuringElement
StructuringElement combineBuffers
(
	/// The vector of mvIMPACT::StructuringElement objects to be combined.
	const std::vector<StructuringElement>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, buffers),
	/// The combination dimension specifier.
	DimensionSpec dimensionSpec
	);



/// \brief Copy a mvIMPACT::BufferBase.

/// This function performs a buffer copy operation between the specified source buffer and the
/// specified destination buffer.
/// The complete operation can be expressed as follows:
/// - <b> shift > 0: </b><br> \a dest(x, y) = ((source(x, y) AND \a sourceMask) << \a shift) AND \a destMask
/// - <b> shift < 0: </b><br> \a dest(x, y) = ((source(x, y) AND \a sourceMask) >> \a shift) AND \a destMask
///
/// The source and destination buffers must have the same properties concerning the number of
/// bands, slices and time-slices (frames).
/// \see mvIMPACT::BufferBase
//-----------------------------------------------------------------------------
void copy
(
	/// The destination buffer.
	BufferBase& dest,
	/// The source buffer to be copied.
	const BufferBase& source,
	/// Specifies a read mask applied to the source buffer data. The bits from the source
	/// buffer are logically ANDed with the read mask. Even though this parameter is of
	/// type \c int, only those bits are used that correspond with the largest data
	/// type of the source or the destination. The other bits are ignored.
	int souceMask=-1,
	/// Specifies a write mask applied to the destination buffer data. Only those bits of the
	/// destination are modified that have a non-zero corresponding bit in the destination
	/// mask. Even though this parameter is of type \c int, only those bits are used
	/// that correspond with the greatest data type of the source or destination. The other
	/// bits are ignored.
	int destMask=-1,
	/// Will be applied to the source data before they are written to the destination buffer.
	/// A positive value shifts bits to the left whereas a negative value shifts bits to the
	/// right
	int shift=0
	);





/// \brief Copy a mvIMPACT::Histogram.

/// This function copies the  specified source mvIMPACT::Histogram \a source.
/// The complete operation can be expressed as follows:
/// - <b> shift > 0: </b><br> dest(x, y) = ((source(x, y) AND \a sourceMask) << \a shift) AND \a destMask
/// - <b> shift < 0: </b><br> dest(x, y) = ((source(x, y) AND \a sourceMask) >> \a shift) AND \a destMask
/// \see mvIMPACT::Histogram
//-----------------------------------------------------------------------------
Histogram copy
(
	/// The source mvIMPACT::Histogram.
	const Histogram& source,
	/// Specifies a read mask applied to the source histogram data. The bits from the source
	/// histogram are logically ANDed with the read mask. Even though this parameter is of
	/// type \c int, only those bits are used that correspond with the data
	/// type of \a source. The other bits are ignored.
	int sourceMask=-1,
	/// Specifies a write mask applied to the destination histogram data. Only those bits of the
	/// destination are modified that have a non-zero corresponding bit in the destination
	/// mask. Even though this parameter is of type \c int, only those bits are used
	/// that correspond with the  data type of \a source. The other
	/// bits are ignored.
	int destMask=-1,
	/// Will be applied to the source data before they are written to the destination mvIMPACT::Histogram.
	/// A positive value shifts bits to the left whereas a negative value shifts bits to the
	/// right
	int shift=0
	);





/// \brief Copy an mvIMPACT::Image.

/// This function copies the  specified source mvIMPACT::Image \a source.
/// The complete operation can be expressed as follows:
/// - <b> shift > 0: </b><br> dest(x, y) = ((source(x, y) AND \a sourceMask) << \a shift) AND \a destMask
/// - <b> shift < 0: </b><br> dest(x, y) = ((source(x, y) AND \a sourceMask) >> \a shift) AND \a destMask
/// \see mvIMPACT::Image
//-----------------------------------------------------------------------------
Image copy
(
	/// The source mvIMPACT::Image.
	const Image& source,
	/// Specifies a read mask applied to the source image data. The bits from the source
	/// image are logically ANDed with the read mask. Even though this parameter is of
	/// type \c int, only those bits are used that correspond with the data
	/// type of \a source. The other bits are ignored.
	int sourceMask=-1,
	/// Specifies a write mask applied to the destination image data. Only those bits of the
	/// destination are modified that have a non-zero corresponding bit in the destination
	/// mask. Even though this parameter is of type \c int, only those bits are used
	/// that correspond with the  data type of \a source. The other
	/// bits are ignored.
	int destMask=-1,
	/// Will be applied to the source data before they are written to the destination mvIMPACT::Image.
	/// A positive value shifts bits to the left whereas a negative value shifts bits to the
	/// right
	int shift=0
	);





/// \brief Copy a mvIMPACT::Kernel.

/// This function copies the  specified source mvIMPACT::Kernel \a source.
/// The complete operation can be expressed as follows:
/// - <b> shift > 0: </b><br> dest(x, y) = ((source(x, y) AND \a sourceMask) << \a shift) AND \a destMask
/// - <b> shift < 0: </b><br> dest(x, y) = ((source(x, y) AND \a sourceMask) >> \a shift) AND \a destMask
/// \see mvIMPACT::Kernel
//-----------------------------------------------------------------------------
Kernel copy
(
	/// The source mvIMPACT::Kernel.
	const Kernel& source,
	/// Specifies a read mask applied to the source kernel data. The bits from the source
	/// kernel are logically ANDed with the read mask. Even though this parameter is of
	/// type \c int, only those bits are used that correspond with the data
	/// type of \a source. The other bits are ignored.
	int sourceMask=-1,
	/// Specifies a write mask applied to the destination kernel data. Only those bits of the
	/// destination are modified that have a non-zero corresponding bit in the destination
	/// mask. Even though this parameter is of type \c int, only those bits are used
	/// that correspond with the  data type of \a source. The other
	/// bits are ignored.
	int destMask=-1,
 	/// Will be applied to the source data before they are written to the destination mvIMPACT::Kernel.
	/// A positive value shifts bits to the left whereas a negative value shifts bits to the
	/// right
	int shift=0
	);





/// \brief Copy a mvIMPACT::Palette.

/// This function copies the  specified source mvIMPACT::Kernel \a source.
/// The complete operation can be expressed as follows:
/// - <b> shift > 0: </b><br> dest(x, y) = ((source(x, y) AND \a sourceMask) << \a shift) AND \a destMask
/// - <b> shift < 0: </b><br> dest(x, y) = ((source(x, y) AND \a sourceMask) >> \a shift) AND \a destMask
/// \see mvIMPACT::Palette
//-----------------------------------------------------------------------------
Palette copy
(
	/// The source mvIMPACT::Palette.
	const Palette& source,
	/// Specifies a read mask applied to the source palette data. The bits from the source
	/// palette are logically ANDed with the read mask. Even though this parameter is of
	/// type \c int, only those bits are used that correspond with the data
	/// type of \a source. The other bits are ignored.
	int sourceMask=-1,
	/// Specifies a write mask applied to the destination palette data. Only those bits of the
	/// destination are modified that have a non-zero corresponding bit in the destination
	/// mask. Even though this parameter is of type \c int, only those bits are used
	/// that correspond with the  data type of \a source. The other
	/// bits are ignored.
	int destMask=-1,
 	/// Will be applied to the source data before they are written to the destination mvIMPACT::Palette.
	/// A positive value shifts bits to the left whereas a negative value shifts bits to the
	/// right
	int shift=0
	);





/// \brief Copy a mvIMPACT::Profile.

/// This function copies the  specified source mvIMPACT::Profile \a source.
/// The complete operation can be expressed as follows:
/// - <b> shift > 0: </b><br> dest(x, y) = ((source(x, y) AND \a sourceMask) << \a shift) AND \a destMask
/// - <b> shift < 0: </b><br> dest(x, y) = ((source(x, y) AND \a sourceMask) >> \a shift) AND \a destMask
/// \see mvIMPACT::Profile
//-----------------------------------------------------------------------------
Profile copy
(
	/// The source mvIMPACT::Profile.
	const Profile& source,
	/// Specifies a read mask applied to the source profile data. The bits from the source
	/// profile are logically ANDed with the read mask. Even though this parameter is of
	/// type \c int, only those bits are used that correspond with the data
	/// type of \a source. The other bits are ignored.
	int sourceMask=-1,
	/// Specifies a write mask applied to the destination profile data. Only those bits of the
	/// destination are modified that have a non-zero corresponding bit in the destination
	/// mask. Even though this parameter is of type \c int, only those bits are used
	/// that correspond with the  data type of \a source. The other
	/// bits are ignored.
	int destMask=-1,
 	/// Will be applied to the source data before they are written to the destination mvIMPACT::Profile.
	/// A positive value shifts bits to the left whereas a negative value shifts bits to the
	/// right
	int shift=0
	);


/// \brief Copy a mvIMPACT::StructuringElement.

/// This function copies the  specified source mvIMPACT::StructuringElement \a source.
/// The complete operation can be expressed as follows:
/// - <b> shift > 0: </b><br> dest(x, y) = ((source(x, y) AND \a sourceMask) << \a shift) AND \a destMask
/// - <b> shift < 0: </b><br> dest(x, y) = ((source(x, y) AND \a sourceMask) >> \a shift) AND \a destMask
/// \see mvIMPACT::StructuringElement
//-----------------------------------------------------------------------------
StructuringElement copy
(
	/// The source mvIMPACT::StructuringElement.
	const StructuringElement& source,
	/// Specifies a read mask applied to the source structuring element data. The bits from the source
	/// structuring element are logically ANDed with the read mask. Even though this parameter is of
	/// type \c int, only those bits are used that correspond with the data
	/// type of \a source. The other bits are ignored.
	int sourceMask=-1,
	/// Specifies a write mask applied to the destination structuring element data. Only those bits of the
	/// destination are modified that have a non-zero corresponding bit in the destination
	/// mask. Even though this parameter is of type \c int, only those bits are used
	/// that correspond with the  data type of \a source. The other
	/// bits are ignored.
	int destMask=-1,
 	/// Will be applied to the source data before they are written to the destination mvIMPACT::StructuringElement.
	/// A positive value shifts bits to the left whereas a negative value shifts bits to the
	/// right
	int shift=0
	);



/// \brief Create a compatible mvIMPACT::Histogram.

/// The returned mvIMPACT::Histogram has the same number of width,height,band,slices,frames and
/// the same datatype as the source histogram.
/// \note The histogram data is not copied!
/// \see mvIMPACT::Histogram
/// \see mvIMPACT::copy
//-----------------------------------------------------------------------------
Histogram createCompatibleHistogram
(
	/// The source histogram.
	const Histogram& source
	);



/// \brief Create a compatible mvIMPACT::Image.

/// The returned image has the same number of width,height,band,slices,frames and
/// the same datatype as the source image.
/// \note The image data is not copied!
/// \see mvIMPACT::Image
/// \see mvIMPACT::copy
//-----------------------------------------------------------------------------
Image createCompatibleImage
(
	/// The source image.
	const Image& source
	);




/// \brief Create a compatible mvIMPACT::Kernel.

/// The returned kernel has the same number of width,height,band,slices,frames and
/// the same datatype as the source kernel.
/// \note The kernel data is not copied!
/// \see mvIMPACT::Kernel
/// \see mvIMPACT::copy
//-----------------------------------------------------------------------------
Kernel createCompatibleKernel
(
	/// The source kernel.
	const Kernel& source
	);





/// \brief Create a compatible mvIMPACT::Palette.

/// The returned palette has the same number of width,height,band,slices,frames and
/// the samedatatype as the source palette.
/// \note The palette data is not copied!
/// \see mvIMPACT::Palette
/// \see mvIMPACT::copy
//-----------------------------------------------------------------------------
Palette createCompatiblePalette
(
	/// The source palette.
	const Palette& source
	);




/// \brief Create a compatible mvIMPACT::Profile.

/// The returned profile has the same number of width,height,band,slices,frames and
/// the same datatype as the source profile.
/// \note The profile data is not copied!
/// \see mvIMPACT::Profile
/// \see mvIMPACT::copy
//-----------------------------------------------------------------------------
Profile createCompatibleProfile
(
	/// The source profile.
	const Profile& source
	);


/// \brief Create a compatible mvIMPACT::StructuringElement.

/// The returned structuring element has the same number of width,height,band,
/// slices,frames and the same datatype as the source structuring element.
/// \note The structuring element data is not copied!
/// \see mvIMPACT::StructuringElement
/// \see mvIMPACT::copy
//-----------------------------------------------------------------------------
StructuringElement createCompatibleStructuringElement
(
	/// The source structuring element.
	const StructuringElement& source
	);




/// \brief Sends a debugging trace message to the IPLTrace tracer application.

/// This function sends a message to the IPLTrace tracer application. The message string
/// is augmented with the Process ID, the Thread ID and the current time, before it is sent.
/// \note The IPLTrace application must be started before the application that sends the trace
/// \note information, otherwise the trace information won't be routed to the IPLTrace tracer
/// \note application.
///
//-----------------------------------------------------------------------------
void trace(/// String containing the message.
	   const std::string& message);


#ifndef DOXYGEN_SHOULD_SKIP_THIS
/// \brief Gets the license serial number.

/// This function returns the license serial number(s). The actual serial number is either stored in
/// a dongle, framegrabber card or network card.
/// The function can return multiple serial numbers, for example when multiple framegrabbers or
/// multiple network cards are installed.
/// Multiple serial numbers are returned in the form of a list of zero-terminated strings. The list is
/// terminated with another zero.
/// \see mvIMPACT::checkLicense
//-----------------------------------------------------------------------------
std::string serialNumber
(
	/// The authentificator dll used. Currently, the following authentificators are available:
	/// lic_dongle.dll, lic_dongle_all.dll, lic_matrix.dll, lic_matrix_all.dll,
	/// lic_vision.dll, lic_comet.dll, lic_pickup.dll and lic_demo.dll.
	const std::string& authentificator,
	/// The public key used to perform the decryption. The public key must match the key used
	/// in the authentificator.
	const std::string& publicKey
	);
#endif // DOXYGEN_SHOULD_SKIP_THIS

/// \brief Gets the time stamp.

/// This function returns a time stamp. This time stamp is the date of creation,
/// independent of the file creation or modification dates. The time stamp is returned in the
/// form of a string with the following format: mm/dd/yy, where mm is a two-digit code for the
/// month (00 - January ... 12 - December), dd is two-digit code for the day of the month and
/// yy is a two-digit code for the year.
//-----------------------------------------------------------------------------
std::string getTimeStamp();

/// \brief Checks if the base license is valid.
bool checkLicenseBase();

/// \brief Return version number from vl_base module.

/// This function returns a version string. The following format is used:
/// "major.minor.point.build" where "major" specifies the major version number, "minor" specifies
/// the minor version number, "point" specifies a point version number and "build" specifies the build number.
/// Example: 6.3.1.4529
//-----------------------------------------------------------------------------
std::string getVersionBase();

/// \brief Return version number from vl_file module.

/// This function returns a version string. The following format is used:
/// "major.minor.point.build" where "major" specifies the major version number, "minor" specifies
/// the minor version number, "point" specifies a point version number and "build" specifies the build number.
/// Example: 6.3.1.4529
//-----------------------------------------------------------------------------
std::string getVersionFile();

/// \brief Return version number from one of the file filter modules.

/// This function returns a version string. The following format is used:
/// "major.minor.point.build" where "major" specifies the major version number, "minor" specifies
/// the minor version number, "point" specifies a point version number and "build" specifies the build number.
/// Example: 6.3.1.4529
//-----------------------------------------------------------------------------
std::string getVersionFileFilter(
	/// Specifies the file filter modul.
	/// Under Windows, you can get the name of a filter module
	/// by having a look at the file file.fmt. Valid names for example are
	/// vif_tiff, vif_psd or vif_web.
	/// Currently, the file filter modules are not supported under Linux.
	const std::string& filter);


/// \brief Return version number from vl_ipl module.

/// This function returns a version string. The following format is used:
/// "major.minor.point.build" where "major" specifies the major version number, "minor" specifies
/// the minor version number, "point" specifies a point version number and "build" specifies the build number.
/// Example: 6.3.1.4529
//-----------------------------------------------------------------------------
std::string getVersionIPL();

/// \brief Return version number from vl_slice module.

/// This function returns a version string. The following format is used:
/// "major.minor.point.build" where "major" specifies the major version number, "minor" specifies
/// the minor version number, "point" specifies a point version number and "build" specifies the build number.
/// Example: 6.3.1.4529
//-----------------------------------------------------------------------------
std::string getVersionSlice();

#ifndef I386_LINUX
/// \brief Return version number from vl_display module.

/// This function returns a version string. The following format is used:
/// "major.minor.point.build" where "major" specifies the major version number, "minor" specifies
/// the minor version number, "point" specifies a point version number and "build" specifies the build number.
/// Example: 6.3.1.4529
//-----------------------------------------------------------------------------
std::string getVersionDisplay();
#endif // I386_LINUX

/// \brief Return version number from vl_autotrace module.

/// This function returns a version string. The following format is used:
/// "major.minor.point.build" where "major" specifies the major version number, "minor" specifies
/// the minor version number, "point" specifies a point version number and "build" specifies the build number.
/// Example: 6.3.1.4529
//-----------------------------------------------------------------------------
std::string getVersionAutotrace();



/// \brief Checks the license.
///
/// This function checks the license of one or multiple modules. The
/// function throws an exception if at least one license check fails. A
/// side-effect of the function is that the modules that have been
/// checked do not need to do license checking again (as long as they
/// remain loaded in-process).
///
/// The parameter module allows you to specify a single dll/so, a single
/// module consisting of one or more dll's/so's or of all modules found.
///
/// If you pass the string "All", all dll's/so's that are found in the
/// path are checked.
///
/// If you pass a module name, all dll's/so's that are part of the module are checked.
/// The following modules are available (note the first uppercase letter):
/// - Base: specifies the Base module, consisting of the base, display, file, ipl, device, slice and autotrace dll's/so's.
/// - Focus: specifies the Focus module, consisting of the focus dll/so.
/// - Match: specifies the Match module, consisting of the autoreg and pat dll's/so's.
/// - Blob: specifies the Blob module, consisting of the blobloc and blob dll's/so's.
/// - Calibration: specifies the Calibration modules, consisting of the blobloc and camcal dll's/so's.
/// - Color: specifies the Color module, consisting of the color dll/so.
/// - Measure: specifies the Measure module, consisting of the gauge dll/so.
/// - OCR: specifies the OCR module, consisting of the ocr dll/so.
/// - Barcode: specifies the Barcode module, consisting of the cr1d dll/so.
/// - Data Matrix: specifies the Data Matrix module, consisting of the cr2d dll/so.
/// - GMM: specifies the GMM module, consisting of the gmm dll/so.
/// - 3D Display: specifies the 3D Display module, consisting of the 3ddisp dll/so.
///
/// If you pass a dll/so name, the single dll/so is checked (you do not need to specify any prefix or suffix, just the abbreviations of the following list).
/// The following dll's/so's are available (note the first lowercase letter):
/// - base: specifies the vl_base.dll/libvl_base.so.
/// - display: specifies the vl_display.dll/libvl_display.so.
/// - 3ddisp: specifies the vl_3ddisp.dll/libvl_3ddisp.so.
/// - file: specifies the vl_file.dll/libvl_file.so.
/// - ipl: specifies the vl_ipl.dll/libvl_ipl.so.
/// - device: specifies the vl_device.dll/libvl_device.so.
/// - slice: specifies the vl_slice.dll/libvl_slice.so.
/// - autotrace: specifies the vl_autotrace.dll/libvl_autotrace.so.
/// - focus: specifies the vl_focus.dll/libvl_focus.so.
/// - autoreg: specifies the vl_autoreg.dll/libvl_autoreg.so.
/// - pat: specifies the vl_pat.dll/libvl_pat.so.
/// - blobloc: specifies the vl_blobloc.dll/libvl_blobloc.so.
/// - blob: specifies the vl_blob.dll/libvl_blob.so.
/// - camcal: specifies the vl_camcal.dll/libvl_camcal.so.
/// - color: specifies the vl_color.dll/libvl_color.so.
/// - gauge: specifies the vl_gauge.dll/libvl_gauge.so.
/// - ocr: specifies the vl_ocr.dll/libvl_ocr.so.
/// - cr1d: specifies the vl_cr1d.dll/libvl_cr1d.so.
/// - cr2d: specifies the vl_cr2d.dll/libvl_cr2d.so.
/// - gmm: specifies the vl_gmm.dll/libvl_gmm.so.
//-----------------------------------------------------------------------------
void checkModule
(
	/// The module to be checked. This can be the following:
	/// - "All": all dll's/so's that are found in the path are checked.
	/// - "Module": the specific module (may consist of multiple dll's/so's). A Module always begins with an uppercase letter, such as 'Base'.
	/// - "dll": the specific dll/so is checked. A dll/So name always begins with a lowercase letter, such as 'base'.
	const std::string& module = "All"
	);


#ifndef DOYXYGEN_SHOULD_SKIP_THIS
/// \brief Checks for a valid license.

/// This function checks a license, using the passed in authentificator dll and the module name.
/// If the license is valid, the function returns, otherwise an ImpactException is thrown, telling
/// you more why the license check failed.
/// \see mvIMPACT::serialNumber
//-----------------------------------------------------------------------------
void checkLicense
(
  /// The authentificator dll used. Currently, the following authentificators are available:
  /// lic_dongle.dll, lic_dongle_all.dll, lic_matrix.dll, lic_matrix_all.dll, lic_nic.dll,
  /// lic_vision.dll, lic_comet.dll, lic_pickup.dll and lic_demo.dll.
  const std::string& authentificator,
  /// The public key used to perform the decryption. The public key must match the key used
  /// in the authentificator.
  const std::vector<unsigned char>& publicKey,
  /// The module name. This is an arbitrary name used to secure a module. The name must match
  /// the module name used when generating the license with the cgenlic license generator.
  const std::string& module
  );
#endif // DOXYGEN_SHOULD_SKIP_THIS



/// \brief Non-blocking check for input from the keyboard.

/// This function returns \c true if a key was pressed and \c false otherwise.
/// \see mvIMPACT::keyHitBlock
/// \see mvIMPACT::getChar
//-----------------------------------------------------------------------------
bool keyHit();


// don't wrap getChar and keyHitBlock for Python since they are blocking functions which may cause a deadlock. See base.i for the replacement.
// #if defined(PLATFORM_MVBL) || !defined(WRAP_PYTHON)
// The above #if has been commented out to try changeset [7751]

/// \brief Blocking check for input from the keyboard.

/// This function blocks the thread, and unblocks it as soon as a key is pressed.
/// Unlike \c getChar, it does not return the key that was pressed (but may echo it to the console, depending on the optional \a echo parameter).
/// \see mvIMPACT::keyHit
/// \see mvIMPACT::getChar
//-----------------------------------------------------------------------------
void keyHitBlock
(
	/// Console echoing mode: if true, the key pressed is echoed to the console,
	/// if false, the key pressed is not echoed.
	bool echo=false
);

/// \brief Get character from the keyboard.

/// This function returns the character code of the key that was pressed.
/// \note This is a blocking call.
/// \see mvIMPACT::keyHit
/// \see mvIMPACT::keyHitBlock
//-----------------------------------------------------------------------------
std::string getChar
(
	/// Console echoing mode: if true, the key pressed is echoed to the console,
	/// if false, the key pressed is not echoed.
	bool echo=false
);
// #endif // WRAP_PYTHON


/// \brief Gets the timeout when waiting for a buffer lock.

/// This function returns the timeout when waiting for a buffer lock in milliseconds.
/// If the buffer lock cannot be granted within the specified time mvIMPACT throws an
/// exception. The standard value is 10000 ms.
/// \see mvIMPACT::setBufferLockTiemout
//-----------------------------------------------------------------------------
int getBufferLockTimeout();
//-----------------------------------------------------------------------------

/// \brief Sets the timeout when waiting for a buffer lock.

/// This function sets the timeout when waiting for a buffer lock in milliseconds.
/// If the buffer lock cannot be granted within the specified time mvIMPACT throws an
/// exception. The standard value is 10000 ms.
/// \see mvIMPACT::getBufferLockTiemout
//-----------------------------------------------------------------------------
void setBufferLockTimeout(int timeoutMs);


#ifndef DOXYGEN_SHOULD_SKIP_THIS

#ifndef WRAP_ANY

// Convenience function to convert a buffer (CPP) to a handle (C).
mvIMPACT_C::IPL_BUFHANDLE bufferToHandle(const BufferBase& buffer);

#endif // #ifndef WRAP_ANY



// Convenience function to save typing.
void throwImpactError();

// Convenience function. Additionally the compiler optimizer generates
// faster code if an exception is called in a sub-function.
void throwImpactError(const std::string& message);
#endif // DOXYGEN_SHOULD_SKIP_THIS


/////////////////////////////////////////////////////////////////
 // vl_ipl functions


/// Clipping/saturation mode for scaleLuminance().
enum SaturationMode {

	#ifndef DOXYGEN_SHOULD_SKIP_THIS
	// This is a misnomer, and is therefore now deprecated. The new entry
	// smWrapAround should be used.
	// Wrapping it inside this #ifdef causes it to be still there and be picked
	// up by the Python and .NET wrapping mechanisms, however since it's not
	// documenated any more, it also won't end up in mvRI.
	smClip = mvIMPACT_C::IPL_CLIP,
	#endif

	/// Values that exceed the range of the datatype wrap around, i.e.
	/// their higher bits are lost.
	smWrapAround = mvIMPACT_C::IPL_WRAP_AROUND,

	/// Values that exceed the range of the datatype are clamped to the
	/// respective minimum and maximum values of this datatype.
	//! Until version 6.2 this mode was named smClip, but this is deprecated now.
	smSaturate = mvIMPACT_C::IPL_SATURATE
};

/// \brief Specifies a transformation function.

///
/// \see mvIMPACT::generatePalette
enum Segment
{
	/// Builds a logarithmic curve between two points.
	sLn     = mvIMPACT_C::IPL_LN,
	/// Builds a square-root curve between two points.
	sSqrt   = mvIMPACT_C::IPL_SQRT,
	/// Builds a parabolic curve between two points.
	sSquare = mvIMPACT_C::IPL_SQUARE,
	/// Builds an exponential curve between two points.
	sExp    = mvIMPACT_C::IPL_EXP
};

/// \brief Morphological operation mode.

/// Defines if the output buffer of a morphological filter will contain gray or binary values.
/// \see mvIMPACT::closing
/// \see mvIMPACT::dilate
/// \see mvIMPACT::erode
enum MorphOpMode
{
  /// Grayscale mode.
  /// The destination buffer will contain gray values.
  momGrayscale = mvIMPACT_C::IPL_GRAYSCALE,
  /// Binary mode.
  /// The destination buffer will contain binary values.
  /// All non-zero pixels in the source buffer will be treated as object pixels and all zero pixels will
  /// be treated as background pixels. When using this operation mode on a binary image, the
  /// processing speed will be faster than when using the grayscale processing mode.
  momBinary    = mvIMPACT_C::IPL_BINARY
};






/// \brief Flip mode.

/// Defines how a mvIMPACT::Image is flipped.
/// \see mvIMPACT::flip
enum FlipMode
{
	/// Horizontal flipping
	fmHorizontal            = mvIMPACT_C::IPL_HOR,
	/// Vertical flipping
	fmVertical              = mvIMPACT_C::IPL_VER,
	/// Horizontal and vertical flipping
	fmHorizontalAndVertical = mvIMPACT_C::IPL_HOR_AND_VER,
	/// 90 degree flipping in clockwise direction
	fm90Clockwise = mvIMPACT_C::IPL_90_CLOCKWISE,
	/// 90 degree flipping in anti-clockwise direction
	fm90AntiClockwise = mvIMPACT_C::IPL_90_ANTI_CLOCKWISE
};




enum MorphDistance
{
  /// Performs a distance operation.
  /// The morphological distance transform tells how far a given pixel is from the nearest object.
  /// The source image of the operation must be a binary image. The destination image will be a
  /// gray level image, where every foreground pixel in the source image (for a 8 bit buffer this
  /// means 255) is given a gray level value equal to the shortest distance from the pixel to the
  /// object boundary. This value can be seen as the size of the smallest erosion, which will make
  /// this pixel disappear.
  /// By definition, pixels belonging to an object have a zero distance.
  /// \image html images/mvi_base/MorphDistance_Distance.png
  mdDistance   = mvIMPACT_C::IPL_DISTANCE,

  /// Performs a medial axis operation.
  /// The source image of the operation must be a binary image. The destination image will be a
  /// gray level image. The pixel of the medial axis will consist of gray level values. The gray level
  /// value for each point of the medial axis is obtained by a preceding distance operation. The
  /// skeleton obtained from this operation is usually not connected but is made up of small
  /// segments.
  /// \image html images/mvi_base/MorphDistance_MedialAxis.png
  mdMedialAxis = mvIMPACT_C::IPL_MEDIAL_AXIS
};



#ifndef DOXYGEN_SHOULD_SKIP_THIS

/// \brief This enumeration lists all available reconstruction operation modes.
enum ReconstructMode
  {
    /// If one pixel of the marker buffer has a corresponding pixel in an object of the source buffer,
    /// the object of the source buffer will be reconstructed and written into the destination buffer
    /// (similar to a conditional dilation).
    /// All non-zero pixels in the marker buffer are considered to be part of the marker.
    rmReconstructMarker = mvIMPACT_C::IPL_RECONSTRUCT_MARKER,

    /// All blobs touching the border of a buffer are removed from the image.
    /// This constant can be bitwise ORed with "rmTop", "rmBottom", "rmLeft", "rmRight"
    /// and "rmAll".
    /// \image html images/mvi_base/ReconstructMode_KillBorderBlobs.png
    rmKillBorderBlobs   = mvIMPACT_C::IPL_KILL_BORDER_BLOBS,

    /// Holes within an object will be filled. The source image must be a binary image. Holes cannot
    /// touch the image border.
    /// \image html images/mvi_base/ReconstructMode_FillHoleBlobs.png
    rmFillHolesBlobs    = mvIMPACT_C::IPL_FILL_HOLES_BLOBS,

    /// All holes within objects will be extracted. The source image must be a binary image. Holes
    /// cannot touch the image border.
    rmExtractHolesBlobs = mvIMPACT_C::IPL_EXTRACT_HOLES_BLOBS,

    /// Only the blobs touching the top border will be removed.
    rmTop               = mvIMPACT_C::IPL_TOP,

    /// Only the blobs touching the bottom border will be removed.
    rmBottom            = mvIMPACT_C::IPL_BOTTOM,

    /// Only the blobs touching the left border will be removed.
    rmLeft              = mvIMPACT_C::IPL_LEFT,

    /// Only the blobs touching the right border will be removed.
    rmRight             = mvIMPACT_C::IPL_RIGHT,

    /// A combination of "rmTop", "rmBottom", "rmLeft" and "rmRight".
    rmAll               = mvIMPACT_C::IPL_ALL
  };
#endif //#ifndef DOXYGEN_SHOULD_SKIP_THIS


/// \brief This enumeration lists all available rotation modes for structuring elements
/// \see mvIMPACT::thick
/// \see mvIMPACT::thin
enum RotationMode
  {

    /// Preserved.
    rmRotate = mvIMPACT_C::IPL_ROTATE_KERNEL,

    /// The kernel is not rotated after each iteration or after convergence.
    /// This parameter is only valid, if the structuring element is of size 3x3.
    rmDoNotRotate = mvIMPACT_C::IPL_DONOT_ROTATE_KERNEL,

    /// Rotate structuring element after each iteration.
    rmRotateIteration   = mvIMPACT_C::IPL_ROTATE_KERNEL_ITERATION,

    /// Rotate structuring element after reaching convergence.
    rmRotateConvergence = mvIMPACT_C::IPL_ROTATE_KERNEL_CONVERGENCE
  };



/// This enumeration specifies binary predicates.
/// The destination is D. The sources are \c S1 and \c S2.
/// \see mvIMPACT::Threshold
enum PointMode
{
	/// D = S1 AND S2.
	pmAnd               = mvIMPACT_C::IPL_AND,
	/// D = S1 OR S2.
	pmOr                = mvIMPACT_C::IPL_OR,
	/// D = ~(S1 AND S2).
	pmNAnd              = mvIMPACT_C::IPL_NAND,
	/// D = ~(S1 OR S2).
	pmNor               = mvIMPACT_C::IPL_NOR,
	/// D = S1 ^ S2.
	pmXor               = mvIMPACT_C::IPL_XOR,
	/// D = ~(S1 ^ S2).
	pmXNor              = mvIMPACT_C::IPL_XNOR,
	/// Same as pmXNor.
	pmNXor              = mvIMPACT_C::IPL_NXOR,
	/// D = (S1 == S2).
	pmEqual             = mvIMPACT_C::IPL_EQUAL,
	/// D = (S1 != S2).
	pmNotEqual          = mvIMPACT_C::IPL_NOT_EQUAL,
	/// D = (S1 > S2).
	pmGreater           = mvIMPACT_C::IPL_GREATER,
	/// D = (S1 >= S2).
	pmGreaterOrEqual    = mvIMPACT_C::IPL_GREATER_OR_EQUAL,
	/// D = (S1 < S2).
	pmLess              = mvIMPACT_C::IPL_LESS,
	/// D = (S1 <= S2).
	pmLessOrEqual       = mvIMPACT_C::IPL_LESS_OR_EQUAL,
	/// D = S1 AND ~S2.
	pmAndN              = mvIMPACT_C::IPL_ANDN,
	/// D = ~(S1 AND ~S2).
	pmNandN             = mvIMPACT_C::IPL_NANDN,
	/// D = S1 OR ~S2.
	pmOrN               = mvIMPACT_C::IPL_ORN,
	/// D = ~(S1 OR ~S2).
	pmNorN              = mvIMPACT_C::IPL_NORN,
};


/// This enumeration specifies a special value for the number of iterations
/// accepted by some functions.
/// \see mvIMPACT::thin
/// \see mvIMPACT::thick
enum IterationMode
{
	/// Run operation, until no more changes are detected.
	imConvergence=mvIMPACT_C::IPL_CONVERGENCE
};


/// This enumeration lists all available size filter modes.
/// These values are use in conjunction with mvIMPACT::sizeFilter.
/// \see mvIMPACT::sizeFilter
enum SizeMode
{
	/// All objects greater than the specified size will be removed.
	smGreater=mvIMPACT_C::IPL_SIZE_GREATER,
	/// All objects smaller than the specified size will be removed.
	smSmaller=mvIMPACT_C::IPL_SIZE_SMALLER,
	/// Only the object with the greatest size (area) will be left. The specified size will be ignored.
	smMaxOnly=mvIMPACT_C::IPL_SIZE_LEAVE_MAX
};


/// This enumeration lists all available object states.
/// These values are used in conjunction with mvIMPACT::sizeFilter
/// \see mvIMPACT::sizeFilter
enum ObjectState
{
  /// Objects must have the maximum value that can be represented (i.e. 0xFF for a 8-bit buffer
  /// and 0xFFFF for a 16-bit buffer).
  osWhite=mvIMPACT_C::IPL_SIZE_WHITE,
  /// The background must have the maximum value that can be represented (i.e. 0xFF for a 8-bit
  /// buffer and 0xFFFF for a 16-bit buffer). Objects must have a value of 0.
  osBlack=mvIMPACT_C::IPL_SIZE_BLACK,
  /// All objects, that are different from 0 will be included in the filter process.
  osNonZero=mvIMPACT_C::IPL_SIZE_NOT_EQUAL_ZERO
};



/// This enumeration lists all available histogram equalization modes.
/// These values are use in conjunction with mvIMPACT::equalize
/// \see mvIMPACT::equalize
enum EqualizeMode
  {
    /// The LUT will be set to produce the effect of a uniform distribution of pixels. The contrast of
    /// an image is increased.
    emUniform     = mvIMPACT_C::IPL_UNIFORM,

    /// The LUT will be set to a hyperbolic logarithmic function. Generally, the contrast of dark
    /// areas should be improved.
    emHyperLog    = mvIMPACT_C::IPL_HYPER_LOG,

    /// The LUT will be set to a hyperbolic cuberoot function. Generally, the contrast of bright areas
    /// should be improved.
    emHyperCube   = mvIMPACT_C::IPL_HYPER_CUBE,

    /// Not implemented yet.
    emExponential = mvIMPACT_C::IPL_EXPONENTIAL,

    /// Not implemented yet.
    emRayLeigh    = mvIMPACT_C::IPL_RAYLEIGH
  };


/// \brief Profile modes

/// This enumeration lists all available profile modes.
/// It is used in conjunction with mvIMPACT::calcLineProfile
/// \see mvIMPACT::calcLineProfile
enum ProfileMode
{
  /// Calculate a x-profile.
  pmXProfile = mvIMPACT_C::IPL_XPROF,
  /// Calculate a y-profile.
  pmYProfile = mvIMPACT_C::IPL_YPROF
};


/// \brief Tophat modes.
///
/// This enumeration lists all available modes used for a Tophat transformation.
/// It is used in conjunction with mvIMPACT::tophat
/// \see mvIMPACT::tophat
enum TopHatMode
{
  /// Detect light spots on a dark background.
  thmWhite = mvIMPACT_C::IPL_WHITE_OBJECTS,
  /// Detect dark spots on a light background.
  thmBlack = mvIMPACT_C::IPL_BLACK_OBJECTS
};



/// \brief Shading correction modes.

/// This enumeration lists all available modes used for a shading correction.
/// It is used in conjunction wih mvIMPACT::shadingCorrection
/// \see mvIMPACT::shadingCorrection
enum ShadingMode
  {
    /// Use multiplicative shading correction.
    smMultiplicative         = mvIMPACT_C::IPL_MULTIPLICATIVE,
    /// Use additive shading correction.
    smAdditive               = mvIMPACT_C::IPL_ADDITIVE,
  };



/// \brief The adaptive thresholding mode specifier.

/// This enumeration lists all available adaptive threshold modes.
/// It is used in conjunction with mvIMPACT::dynamicThreshold
/// \see mvIMPACT::dynamicThreshold
enum AdaptiveMode
{
	/// Calculates an adaptive threshold region-wise. For each rectangular region
	/// only one threshold is calculated. Thus, the threshold adapts to each region
	/// only. This is fast but not accurate.
	amRegion=mvIMPACT_C::IPL_REGION,
	/// Caclulates an adaptive threshold for each pixel. Thus, the threshold truely
	/// adapts to each pixel according to the pixel's neighborhood. This is slow but
	/// accurate.
	amNeighborhood=mvIMPACT_C::IPL_NEIGHBORHOOD
};

/// \brief Polarity mode.
///
/// The polarity defines which values are considered as foreground.
enum PolarityMode
{
	/// Light objects on dark background.
	pmWhiteOnBlack = mvIMPACT_C::IPL_WHITE_ON_BLACK,
	/// Dark objects on light background.
	pmBlackOnWhite = mvIMPACT_C::IPL_BLACK_ON_WHITE,
	/// Polarity mode is automatically determined.
	pmAuto = mvIMPACT_C::IPL_POLARITY_AUTO
};


/// \brief Watershed modes

/// This enumeration lists all available Watershed modes.
/// It is used in conjunction with mvIMPACT::watershed
/// \see mvIMPACT::watershed
enum WatershedMode
{
  /// Split touching particles.
  /// This method works fine, as long as the particles are convex and the center (which is actually
  /// the local maximum of the distance function) of each particle is outside of other particles.
  /// Pixel from the source image are merged with detected "watershed pixels".
  wmSplitObjectsMerge		= mvIMPACT_C::IPL_SPLIT_OBJECTS | mvIMPACT_C::IPL_MERGE,

  /// Split touching particles.
  /// This method works fine, as long as the particles are convex and the center (which is actually
  /// the local maximum of the distance function) of each particle is outside of other particles.
  /// Only the detected "watershed pixels" are written into the destination buffer.
  wmSplitObjectsSeparate		= mvIMPACT_C::IPL_SPLIT_OBJECTS | mvIMPACT_C::IPL_SEPARATE,

  /// This operation is similar to the computation of the "zone of influence" except that touching
  /// objects are split.
  /// The image is separated into zones whereas each zone surrounds an object.
  /// Pixel from the source image are merged with detected "watershed pixels".
  wmSplitBackgroundMerge	= mvIMPACT_C::IPL_SPLIT_BACKGROUND | mvIMPACT_C::IPL_MERGE,


  /// This operation is similar to the computation of the "zone of influence" except that touching
  /// objects are split.
  /// The image is separated into zones whereas each zone surrounds an object.
  /// Only the detected "watershed pixels" are written into the destination buffer.
  wmSplitBackgroundSeparate	= mvIMPACT_C::IPL_SPLIT_BACKGROUND | mvIMPACT_C::IPL_SEPARATE,
};




/// \brief Color dithering setting.

/// The dithering setting for the mvIMPACT::quantize function.
/// \see mvIMPACT::quantize
enum DitherMode
{
  /// No dithering.
  dmNoDither = mvIMPACT_C::IPL_NO_DITHER,
  /// 1-val error diffusion dithering.
  dmDither1  = mvIMPACT_C::IPL_DITHER_1,
  /// 2-val error diffusion dithering.
  dmDither2  = mvIMPACT_C::IPL_DITHER_2,
  /// 4-val error diffusion dithering (Floyd-Steinberg).
  dmDither4  = mvIMPACT_C::IPL_DITHER_4
};




/// Curve interpolation mode.
/// \see mvIMPACT::presetNoiseImage
/// \see mvIMPACT::presetRingImage
/// \see mvIMPACT::presetWedgeImage
enum PresetCurveType
{
  /// Use linear interpolation. This is the fastest mode.
  /// \image html images/mvi_base/Preset_Linear_Interpolation.png
  pctPresetLinear = mvIMPACT_C::IPL_PRESET_LINEAR,

  /// Use cosine interpolation.
  /// \image html images/mvi_base/Preset_Cosinus_Interpolation.png
  pctPresetCos    = mvIMPACT_C::IPL_PRESET_COS,


  /// Use cosine interpolation with doubled frequency.
  /// \image html images/mvi_base/Preset_Cosinus2_Interpolation.png
  pctPresetCos2   = mvIMPACT_C::IPL_PRESET_COS2,

  /// Use gaussian interpolation.
  /// \image html images/mvi_base/Preset_Gauss_Interpolation.png
  pctPresetGauss  = mvIMPACT_C::IPL_PRESET_GAUSS
};


/// \brief FFT modes.
///
/// This enumeration lists all available FFT transformation modes.
/// \see mvIMPACT::forwardFFT
/// \see mvIMPACT::inverseFFT
/// \see mvIMPACT::getSpectrum
enum FFTMode
{
  /// Specifies a 2D FFT.
  fftm2D = mvIMPACT_C::IPL_2D_FFT,
  /// Specifies a 1D FFT.
  fftm1D = mvIMPACT_C::IPL_1D_FFT
};



/// \brief Spectrum types.
///
/// This enumeration lists all available spectrum types.
/// It is used in conjunction with mvIMPACT::getSpectrum
/// \see mvIMPACT::getSpectrum
enum FFTSpectrum
{
  /// Specifies an amplitude spectrum.
  fftsAmplSpec  = mvIMPACT_C::IPL_AMPL_SPEC,
  /// Specifies a power spectrum.
  fftsPowerSpec = mvIMPACT_C::IPL_POWER_SPEC,
  /// Specifies a phase spectrum.
  fftsPhaseSpec = mvIMPACT_C::IPL_PHASE_SPEC
};


/// \brief FFT data types.
///
/// This enumeration lists all available FFT data types.
/// It is used in conjunction with mvIMPACT::dataWindow
/// \see mvIMPACT::dataWindow
enum FFTData
{
  /// Specifies 1D data.
  fftdData1D = mvIMPACT_C::IPL_1D_DATA,
  /// Specifies 2D data.
  fftdData2D = mvIMPACT_C::IPL_2D_DATA
};


/// \brief FFT function types.
///
/// This enumeration lists all available FFT function types.
/// It is used in conjunction with mvIMPACT::dataWindow
/// \see mvIMPACT::dataWindow
enum FFTFunction
{
	/// Using it in the frequency domain:<br>
	/// A low pass function will be applied.
	/// The data window must be centered with respect to the frequency origin (this is where
	/// frequency 0 is defined and is located at the center of the image). All data outside of the
	/// window will be set to 0.
	/// Using it in the time domain:<br>
	/// Due to the fact, that signal discontinuities are introduced at the image border, you can use this
	/// function type before the FFT is applied to minimize this problem.
	fftfLowPass    = mvIMPACT_C::IPL_LOW_PASS,
	/// Using it in the frequency domain:<br>
	/// A high pass function will be applied.
	/// The data window must be centered with respect to the frequency origin (this is where
	/// frequency 0 is defined and is located at the center of the image). All frequencies inside the
	/// window will be set to 0.
	/// Using it in the time domain:<br>
	/// The window can be set to any position.
	fftfHighPass   = mvIMPACT_C::IPL_HIGH_PASS,
	/// A spike cut function will be applied. The data window can be set at any position.
	/// Using it in the frequency domain:<br>
	/// Because the FFT data are point symmetrical to the frequency origin (this is where frequency 0
	/// is defined and is located at the center of the image) the data window should also be "mirrored"
	/// at the frequency origin. This means, that the function has to be called several times, with the
	/// appropriate coordinates for the data window.
	/// Using it in the time domain:<br>
	/// The window can be set to any position.
	fftfCutSpike   = mvIMPACT_C::IPL_CUT_SPIKE,
	/// A spike boost function will be applied. The data window can be set at any position.
	/// Using it in the frequency domain:<br>
	/// Because the FFT data are point symmetrical to the frequency origin (this is where frequency 0
	/// is defined and is located at the center of the image) the data window must also be "mirrored"
	/// at the frequency origin. This means, that the function has to be called several times, with the
	/// appropriate coordinates for the data window.
	/// Using it in the time domain:<br>
	/// The window can be set to any position.
	fftfBoostSpike = mvIMPACT_C::IPL_BOOST_SPIKE
};


/// \brief FFT data window function types.
///
/// This enumeration lists all available FFT data window function types.
/// It is used in conjunction with mvIMPACT::dataWindow
/// \see mvIMPACT::dataWindow
enum FFTWindow
{
	/// A "Square window" function will be applied to the input data.
	fftwSquareWindow  = mvIMPACT_C::IPL_SQUARE_WINDOW,
	/// A "Hanning window" function will be applied to the input data.
	fftwHanningWindow = mvIMPACT_C::IPL_HANNING_WINDOW,
	/// A "Parzen window" function will be applied to the input data.
	fftwParzenWindow  = mvIMPACT_C::IPL_PARZEN_WINDOW,
	/// A "Welch window" function will be applied to the input data.
	fftwWelchWindow   = mvIMPACT_C::IPL_WELCH_WINDOW
};


/// \brief Look-up-table preset types.
///
/// These values are used to generate a preset mvIMPACT::Palette of a specific type.
/// The gray modes (ranging from "pptGrayFirst" to "pptGrayLast" can be
/// applied to palettes with any datatype and 1 to n bands (if n bands, each band
/// is preset the same),
/// while the color modes (ranging from "pptColorFirst" to pptColorLast" can
/// be applied only to 8 bit palettes with exactly 3 bands.
/// \see mvIMPACT::presetPalette
enum PalettePresetType
{
	/// The first gray mode, synonym to pptGrayLinear.
	pptGrayFirst = mvIMPACT_C::IPL_LUT_GRAY_FIRST,
	/// A linear look-up-table from dark to bright.
	pptGrayLinear = mvIMPACT_C::IPL_LUT_GRAY_LINEAR,
	/// An inverse linear look-up-table from bright to dark.
	pptGrayInverse = mvIMPACT_C::IPL_LUT_GRAY_INVERSE,
	/// A square look-up-table.
	pptGraySquare = mvIMPACT_C::IPL_LUT_GRAY_SQUARE,
	/// A square-root look-up-table.
	pptGraySquareRoot = mvIMPACT_C::IPL_LUT_GRAY_SQARE_ROOT,
	/// An exponential look-up-table.
	pptGrayExponential = mvIMPACT_C::IPL_LUT_GRAY_EXP,
	/// A logarithmic look-up-table.
	pptGrayLogarithmic = mvIMPACT_C::IPL_LUT_GRAY_LOG,
	/// A gamma look-up-table.
	pptGrayGamma = mvIMPACT_C::IPL_LUT_GRAY_GAMMA,
	/// An inverse gamma look-up-table.
	pptGrayInverseGamma = mvIMPACT_C::IPL_LUT_GRAY_INVERSE_GAMMA,
	/// The last gray mode, synonym to pptGrayInverseGamma.
	pptGrayLast = mvIMPACT_C::IPL_LUT_GRAY_LAST,

	/// The first color mode, synonym to pptColorContour8.
	pptColorFirst = mvIMPACT_C::IPL_LUT_COL_FIRST,
	/// A gray look-up-table with 8 colored contours.
	pptColorContour8 = mvIMPACT_C::IPL_LUT_COL_CONTOUR_8,
	/// A gray look-up-table with 16 colored contours.
	pptColorContour16 = mvIMPACT_C::IPL_LUT_COL_CONTOUR_16,
	/// A look-up-table with distributed colors for label separation on labelled images.
	pptColorDistributed = mvIMPACT_C::IPL_LUT_COL_DISTRIBUTED,
	/// A rainbow type look-up-table
	pptColorRainbow = mvIMPACT_C::IPL_LUT_COL_RAINBOW,
	/// A reddish, fire-looking look-up-table.
	pptColorFire = mvIMPACT_C::IPL_LUT_COL_FIRE,
	/// A greenish, grass-looking look-up-table.
	pptColorGrass = mvIMPACT_C::IPL_LUT_COL_GRASS,
	/// A blueish, ice-looking look-up-table.
	pptColorIce = mvIMPACT_C::IPL_LUT_COL_ICE,
	/// The last color mode, synonym to pptColorIce.
	pptColorLast = mvIMPACT_C::IPL_LUT_COL_LAST,
};

/// \brief Represents a threshold operation
///
/// An object of this class holds thresholding information. These are
/// - the threshold value
/// - the threshold mode
/// \see mvIMPACT::generatePalette
class Threshold
{
public:

	/// \brief Construct a threshold object.
	///
	 // \internal
	 // If you change the default initializations, you have to
	 // change them in base.i as well in the tuple to class conversion !
	Threshold(
		/// Threshold value.
		int value=0,
		/// Threshold comparison point mode. The default (gmGreater) means that values
		/// greater than the threshold value are foreground pixels (and set to 255) and
		/// all other pixels are background pixels (and set to 0).
		PointMode type=pmGreater
		);

	/// \brief Retrieve the current threshold value
	int getValue() const;

#ifndef WRAP_ANY
	// PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the threshold value
	Threshold& setValue(/// the new threshold value
			    int value);

	/// \brief Retrieve the threshold comparison mode
	PointMode getType() const;

#ifndef WRAP_ANY
	// PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the threshold comparison mode
	Threshold& setType(/// the new comparison mode
			   PointMode type);

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY

	/// \brief Convert a mvIMPACT::Threshold object into a IPL_THRESHOLD
	operator mvIMPACT_C::IPL_THRESHOLD() const;

	/// \brief Construct a mvIMPACT::Threshold object from an IPL_THRESHOLD.
	Threshold(/// the other object
		  const mvIMPACT_C::IPL_THRESHOLD& src);

#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
	int m_value;
	PointMode m_type;
};


/// \brief Holds bitplane shuffle information.

/// This class is used to generate a bitplane shuffling palette.
/// \see mvIMPACT::generatePalette
class Shuffle
{
public:
	Shuffle(
		/// Specifies the source bitplane. The range is from 0 to 7 for an 8 bit datatype, and from 0 to 15
		/// for a 16 bit datatype buffer.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamConst value="15"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int fromIndex,
		/// Specifies the destination bitplane. The range is from 0 to 7 for an 8 bit datatype, and from 0 to
		/// 15 for a 16 bit datatype buffer.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamConst value="15"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int toIndex);

	/// \brief Standard constructor, does not do any initialization
	Shuffle();

	/// \brief Retrieve the source bitplane.
	int getFromIndex() const;

#ifndef WRAP_ANY
	// PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the source bitplane.
	Shuffle& setFromIndex(
		/// The source bitplane.Range is from 0 to 7 for an 8 bit datatype, and from 0 to 15 for a 16 bit datatype buffer.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamConst value="15"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int fromIndex);


	/// \brief Retrieve the destination bitplane
	int getToIndex() const;

#ifndef WRAP_ANY
	// PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the destination bitplane
	Shuffle& setToIndex(
		/// The range is from 0 to 7 for an 8 bit datatype, and from 0 to
		/// 15 for a 16 bit datatype buffer.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamConst value="15"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int toIndex);

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY

	/// \brief Convert a mvIMPACT::Shuffle object into a IPL_SHUFFLE
	operator mvIMPACT_C::IPL_SHUFFLE() const;

	/// \brief Construct a mvIMPACT::Shuffle object from IPL_SHUFFLE
	Shuffle(/// the other object
		const mvIMPACT_C::IPL_SHUFFLE& r);

#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS


private:
	int m_fromIndex;
	int m_toIndex;
};


/// \brief Transformation used for the preset image generation functions.

/// This class describes the transformation that is applied on
/// the preset pattern.
/// \see mvIMPACT::presetRingImage
/// \see mvIMPACT::presetWedgeImage
/// \see mvIMPACT::presetCheckerImage
class PresetTransformation
{
public:

  /// \brief Construct a geometric transformation for the preset functions.

  /// If no parameters are given, the object is initialized with a dummy transformation, that actually does nothing.
   // \internal
   // If you change the default initializations, you have to
   // change them in base.i as well in the tuple to class conversion !
  PresetTransformation(
				/// The horizontal scaling factor.
				double scaleX=1.0,
				/// The vertical scaling factor.
				double scaleY=1.0,
				/// The horizontal translation.
				double translationX=0.0,
				/// The vertical translation.
				double translationY=0.0,
				/// The rotation angle in radians.
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
				/// <mvParamMax><mvParamConst value="6.2831853071795862"/></mvParamMax>
				/// <mvParamStep>0.01</mvParamStep>
				/// </mvParamRange>
				/// \endxmlonly
				double rotationAngle=0.0);

  /// \brief Retrieve the horizontal scaling factor
  double getScaleX() const;

#ifndef WRAP_ANY
  // PROP
#endif // #ifndef WRAP_ANY

  /// \brief Set the horizontal scaling factor
  PresetTransformation& setScaleX(/// the new horizontal scaling factor
			      double scaleX);

  /// \brief Retrieve the vertical scaling factor
  double getScaleY() const;

#ifndef WRAP_ANY
  // PROP
#endif // #ifndef WRAP_ANY

  /// \brief set the vertical scaling factor
  PresetTransformation& setScaleY(/// the new vertical scaling factor
			      double scaleY);

  /// \brief Retrieve the horizontal translation
  double getTranslationX() const;

#ifndef WRAP_ANY
  // PROP
#endif // #ifndef WRAP_ANY

  /// \brief Set the horizontal translation
  PresetTransformation& setTranslationX(/// the new horizontal translation
			      double translationX);

  /// \brief Retrieve the vertical translation
  double getTranslationY() const;

#ifndef WRAP_ANY
  // PROP
#endif // #ifndef WRAP_ANY

  /// \brief Set the vertical translation
  PresetTransformation& setTranslationY(/// the new vertical translation
			      double translationY);

  /// \brief Retrieve the rotation angle

  /// The angle is returned in radians
  double getRotationAngle() const;

#ifndef WRAP_ANY
  // PROP
#endif // #ifndef WRAP_ANY

  /// \brief Set the rotation angle
  PresetTransformation& setRotationAngle(
				/// the new rotation angle in radians
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
				/// <mvParamMax><mvParamConst value="6.2831853071795862"/></mvParamMax>
				/// <mvParamStep>0.01</mvParamStep>
				/// </mvParamRange>
				/// \endxmlonly
				double rotationAngle);

#ifndef WRAP_ANY
	/// \brief Convert a mvIMPACT::PresetTransformation into a IPL_PRESET_GEOTRANS
	operator const mvIMPACT_C::IPL_PRESET_GEOTRANS() const;
#endif

private:

	/// The horizontal scaling factor.
	double m_sx;

	/// The vertical scaling factor.
	double m_sy;

	/// The horizontal translation.
	double m_tx;

	/// The vertical translation.
	double m_ty;

	/// The rotation angle in radians.
	double m_phi;
};


/// \brief Color indexes used in image generation functions.

/// This class is used in conjunction with the preset image generation functions.
/// This specifies the indexes for black and white.
/// \see mvIMPACT::presetCheckerImage
/// \see mvIMPACT::presetNoiseImage
/// \see mvIMPACT::presetRingImage
/// \see mvIMPACT::presetWedgeImage
class PresetColors
{
public:

	/// \brief Initialize an object of class PresetColors.
	///
        /// If no parameters are given, the indexes are set to 0 for black and 255 for white.
	 // \internal
         // If you change the default initializations, you have to
	 // change them in base.i as well in the tuple to class conversion !
        PresetColors(/// the index for black
		     double black=0.0,
		     /// the index for white
		     double white=255.0);

	/// \brief Retrieve the color index for black
	double getBlack() const;

#ifndef WRAP_ANY
	// PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the color index for black
	PresetColors& setBlack(/// the new index for black
			       double black);


	/// \brief Retrieve the color index for white
	double getWhite() const;

#ifndef WRAP_ANY
	// PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the color index for white
	PresetColors& setWhite(/// the new index for white
			       double white);

private:
	/// Color index for black.
	double m_black;

	/// Color index for white.
	double m_white;
};

/// \brief Computes a 1D- or 2D FFT.
///
/// This function performs a 1D- or 2D FFT transformation from spatial domain to
/// frequency domain. After a forward transformation (time to frequency domain),
/// the origin (frequency 0) of the real- and imaginary data is located at the center
/// of the destination image (XSize/2, YSize/2) as shown in the figure below.
/// \image html images/mvi_base/Forward_FFT.png
/// Returns a pair of mvIMPACT::Image objects containing the real and imaginary coefficients. The
/// datatype of the mvIMPACT::Image objects is \c bdFloat.
/// \note The size of the source image \a source must be a power of 2.
/// \see mvIMPACT::inverseFFT
//-----------------------------------------------------------------------------
std::pair<Image,Image> forwardFFT
(
	/// The source image. Its size must be a power of 2.
	const Image& source,
	/// Specifies if this is a 1D or 2D transformation.
	FFTMode          mode = fftm2D
	);



/// \brief Computes a 1D- or 2D FFT.

/// This function performs a 1D- or 2D FFT transformation from spatial domain to
/// frequency domain. After a forward transformation (time to frequency domain),
/// the origin (frequency 0) of the real- and imaginary data is located at the center
/// of the destination image (XSize/2, YSize/2) as shown in the figure below.
/// \image html images/mvi_base/Forward_FFT.png
/// \note All sizes of the source and destination images must be a power of 2. All buffers
/// \note must have the same properties (width, height, bands, slices, frames).
/// \see mvIMPACT::inverseFFT
//-----------------------------------------------------------------------------
 void forwardFFT
(
	/// Stores the real result of the FFT.
	Image&       destReal,
	/// Stores the imaginary result of the FFT.
	Image&       destImag,
	/// The source image. Its size must be a power of 2.
	const Image& source,
	/// Specifies if this is a 1D or 2D transformation.
	FFTMode          mode = fftm2D
	);


/// \brief Computes a 1D- or 2D FFT.

/// This function performs a 1D- or 2D FFT transformation from frequency
/// domain to spatial domain.
/// \note All sizes of the source images must be a power of 2. The images
/// \note must have the same properties (width, height, bands, slices, frames).
/// \see mvIMPACT::forwardFFT
//-----------------------------------------------------------------------------
 Image inverseFFT
(
	/// This image contains the real data part to be transformed. It must be of
	/// datatype \c bdFloat.
	const Image& sourceReal,
	/// This image contains the imaginary data part to be transformed. It must be of
	/// datatype \c bdFloat.
	const Image& sourceImag,
	/// Specifies if this is a 1D or 2D transformation.
	FFTMode          mode = fftm2D
	);





/// \brief Computes a 1D- or 2D FFT.

/// This function performs a 1D- or 2D FFT transformation from frequency
/// domain to spatial domain.
/// \note All sizes of the source images must be a power of 2. The images
/// \note must have the same properties (width, height, bands, slices, frames).
/// \see mvIMPACT::forwardFFT
//-----------------------------------------------------------------------------
 void inverseFFT
(
	/// The destination image.
	Image&       dest,
	/// This image contains the real data part to be transformed. It must be of
	/// datatype \c bdFloat.
	const Image& sourceReal,
	/// This image contains the imaginary data part to be transformed. It must be of
	/// datatype \c bdFloat.
	const Image& sourceImag,
	/// Specifies if this is a 1D or 2D transformation.
	FFTMode          mode  = fftm2D
	);



/// \brief Displays a frequency spectrum.
/// This function lets you visualize the data of a previously computed FFT. You
/// can display the phase, power and amplitude spectrum with different kinds of
/// intensity scaling. The output image is a point symmetric image with the center
/// located at the center of the image (XSize/2,YSize/2).
/// \image html images/mvi_base/Spectrum_FFT.png
/// \see mvIMPACT::forwardFFT
/// \see mvIMPACT::inverseFFT
//-----------------------------------------------------------------------------
 Image getSpectrum
(
	/// An image with datatype \c bdFloat containing the real part of the FFT.
	const Image& sourceReal,
	/// An image with datatype \c bdFloat containing the imaginary part of the FFT.
	const Image& sourceImag,
	/// Specifies the type of spectrum to visualize.
	FFTSpectrum      fFTSpectrum,
	/// Specifies a gamma-factor, which influences the intensity scaling of the displayed
	/// spectrum. This parameter can be given a value between [1..99]. Depending on the
	/// value you specify, you can emphasize different frequencies in the spectrum.
	///  - 1..9: high frequencies are emphasized (like an exponential function)
	///  - 10: no scaling (like a linear ramp function)
	///  - 11..99: low frequencies are emphasized (like a logarithmic function)
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="1.0"/></mvParamMin>
	/// <mvParamMax><mvParamConst value="99.0"/></mvParamMax>
	/// <mvParamStep>0.1</mvParamStep>
	/// </mvParamRange>
	/// \endxmlonly
	double           gamma = 10.0,
	/// Specifies the type of the input data.
	FFTMode          mode = fftm2D
	);



/// \brief Displays a frequency spectrum.

/// This function lets you visualize the data of a previously computed FFT. You
/// can display the phase, power and amplitude spectrum with different kinds of
/// intensity scaling. The output image is a point symmetric image with the center
/// located at the center of the image (XSize/2,YSize/2).
/// \image html images/mvi_base/Spectrum_FFT.png
/// \see mvIMPACT::forwardFFT
/// \see mvIMPACT::inverseFFT
//-----------------------------------------------------------------------------
void getSpectrum
(
 /// The destination image.
 /// If the \a mode  is set to "fftm2D", the data type of this
 /// buffer must be set to "dbUChar". If \a mode is set to
 /// "fftm1D", the data type of this buffer must be set to "bdULong".
 Image&       dest,
 /// An image with datatype \c bdFloat containing the real part of the FFT.
 const Image& sourceReal,
 /// An image with datatype \c bdFloat containing the imaginary part of the FFT.
 const Image& sourceImag,
 /// Specifies the type of spectrum to visualize.
 FFTSpectrum      fFTspectrum,
 /// Specifies a gamma-factor, which influences the intensity scaling of the displayed
 /// spectrum. This parameter can be given a value between [1..99]. Depending on the
 /// value you specify, you can emphasize different frequencies in the spectrum.
 ///  - 1..9: high frequencies are emphasized (like an exponential function)
 ///  - 10: no scaling (like a linear ramp function)
 ///  - 11..99: low frequencies are emphasized (like a logarithmic function)
 /// \xmlonly
 /// <mvParamRange>
 /// <mvParamMin><mvParamConst value="1.0"/></mvParamMin>
 /// <mvParamMax><mvParamConst value="99.0"/></mvParamMax>
 /// <mvParamStep>0.1</mvParamStep>
 /// </mvParamRange>
 /// \endxmlonly
 double           gamma = 10.0,
 /// Specifies the type of the input data.
 FFTMode          mode = fftm2D
 );



/// \brief This function multiplies the input data with a selectable window function.

/// Applied to the frequency domain, a kind of filtering can be achieved.
/// Applied to the time domain, this function is useful to eliminate discontinuance
/// at the border of a buffer before performing a FFT. In the case of the frequency
/// domain, the origin (frequency 0) of the data (real and imaginary part) in the
/// source buffers are located at the center of the image (this is how the data are
/// output from the FFT function). A few of the more common window functions are:
/// <ul>
/// <li>Hanning Window</li>
/// <li>Parzen Window</li>
/// <li>Welch Window</li>
/// </ul>
/// \note Only inplace processing is supported. The images \c srcReal, \c srcImag must
/// \note have the same properties (width, height, bands, slices, frames).
/// \note The width and height of these images must be a power of 2.
//-----------------------------------------------------------------------------
 void dataWindow
(
	/// An image with datatype \c bdFloat containing the real part of the FFT.
	Image&  sourceDestReal,
	/// An image with datatype \c bdFloat containing the imaginary part of the FFT.
	Image&  sourceDestImag,
	/// Specifies the x-coordinate of the top left window corner with respect to the buffer
	/// origin (top left corner).
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	/// <mvParamMax><mvParamComplex Python="%(sourceDestReal)s.width-%(xSizeWin)s"/></mvParamMax>
	/// </mvParamRange>
	/// \endxmlonly
	int        xPosWin,
	/// Specifies the y-coordinate of the top left window corner with respect to the buffer
	/// origin (top left corner).
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	/// <mvParamMax><mvParamComplex Python="%(sourceDestReal)s.height-%(ySizeWin)s"/></mvParamMax>
	/// </mvParamRange>
	/// \endxmlonly
	int        yPosWin,
	/// Specifies the width of the data window with respect to the data window's top left
	/// corner.
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
	/// <mvParamMax><mvParamComplex Python="%(sourceDestReal)s.width-%(xPosWin)s"/></mvParamMax>
	/// </mvParamRange>
	/// \endxmlonly
	int        xSizeWin,
	/// Specifies the height of the data window with respect to the data window's top left
	/// corner.
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
	/// <mvParamMax><mvParamComplex Python="%(sourceDestReal)s.height-%(ySizeWin)s"/></mvParamMax>
	/// </mvParamRange>
	/// \endxmlonly
	int        ySizeWin,
	/// Specifies the type of input data.
	FFTData     fFTData,
	/// Specifies the type of function to apply.
	FFTFunction fFTFunction,
	/// Specifies the type of data window function to apply.
	FFTWindow   fFTWindow,
	/// Specifies a scale factor which will be applied to every data window operation. This
	/// value should usually be set to 1. It is the user's responsibility to avoid overflows.
	/// The function does not perform any clipping.
	/// It is equal to:<br>
	/// w(j) = Scale * w(j)<br>
	/// where<br>
	/// w(j) is the function value of any window function at location j.
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="0.0"/></mvParamMin>
	/// <mvParamStep>0.1</mvParamStep>
	/// </mvParamRange>
	/// \endxmlonly
	double      scale
	);




/// \brief Close a mvIMPACT::Image.

/// This function performs a morphological (binary or grayscale) closing operation using the
/// specified source image  \a source and a predefined structuring element \a se.
/// A closing consists of one or more dilations followed by one or more
/// erosions. In the case of a multidimensional image, the structuring
/// element will be applied to every plane.
/// \note The morphological operations can be iterated, i.e. applied a given number of
/// \note times to itself. The resulting effect is equivalent to using a larger structuring element, with a
/// \note much better time performance.
/// \see mvIMPACT::dilate
/// \see mvIMPACT::erode
/// \see mvIMPACT::opening
/// \see #MorphOpMode
//-----------------------------------------------------------------------------
Image closing
(
	/// the source image
	const Image& source,
	/// the predefined structuring element to use for the operation
	StockStructuringElement se=sseSquare,
	/// Specifies the number of passes to run the operation.
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
	/// </mvParamRange>
	/// \endxmlonly
	int iterations=1,
	/// Specifies the operation mode for processing.
	MorphOpMode mode=momGrayscale
 );



/// \brief Close a mvIMPACT::Image.

/// This function performs a morphological (binary or grayscale) closing operation using the
/// specified source image  \a source  and the a predefined structuring element \a se.
/// The resulting image is stored in \a dest. The source and destination image must
/// have the same properties (width, height, bands, z-slices, time-slices, datatype).
/// A closing consists of one or more dilations followed by one or more
/// erosions. In the case of a multidimensional image, the structuring
/// element will be applied to every plane.
/// \note The morphological operations can be iterated, i.e. applied a given number of
/// \note times to itself. The resulting effect is equivalent to using a larger structuring element, with a
/// \note much better time performance.
/// \see mvIMPACT::dilate
/// \see mvIMPACT::erode
/// \see mvIMPACT::opening
/// \see #MorphOpMode
//-----------------------------------------------------------------------------
 void closing(
	    /// the destination image
	    Image& dest,
	    /// the source image
	    const Image& source,
	    /// the predefined structuring element to use for the operation
	    StockStructuringElement se,
	    /// Specifies the number of passes to run the operation
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int iterations=1,
	    /// Specifies the operation mode for processing.
	    MorphOpMode mode=momGrayscale);



/// \brief Close an mvIMPACT::Image

/// This function performs a morphological (binary or grayscale) closing operation using the
/// specified source image \a source and the custom structuring element \a se.
/// A closing consists of one or more dilations followed by one or more
/// erosions. In the case of a multidimensional image, the structuring
/// element will be applied to every plane.
/// - If a binary closing will be performed (\a mode = momBinary), the values of structuring element \a se can be set to -1,
/// 0 and 1. Neighborhood pixel specified with -1 in the structuring
/// element, are not considered during the operation.
/// - If a grayscale closing will be performed (\a mode=momGrayscale), the values of the structuring element \a se can
/// be any numerical value or can be set to -1 to ignore the value.
/// \note The morphological operations can be iterated, i.e. applied a given number of
/// \note times to itself. The resulting effect is equivalent to using a larger structuring element, with a
/// \note much better time performance.
/// \see mvIMPACT::dilate
/// \see mvIMPACT::erode
/// \see mvIMPACT::opening
/// \see #MorphOpMode
//-----------------------------------------------------------------------------
 Image closing(
	    /// the source image
	    const Image& source,
	    /// the structuring element to use for the operation
	    const StructuringElement& se,
	    /// Specifies the number of passes to run the operation
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int iterations=1,
	    /// Specifies the operation mode for processing.
	    MorphOpMode mode=momGrayscale);



/// \brief Close an mvIMPACT::Image

/// This function performs a morphological (binary or grayscale) closing operation using the
/// specified source image \a source  and the custom structuring element \a se.
/// A closing consists of one or more dilations followed by one or more
/// erosions. In the case of a multidimensional image, the structuring
/// element will be applied to every plane.
/// - If a binary closing will be performed (\a mode = momBinary), the values of structuring element \a se can be set to -1,
/// 0 and 1. Neighborhood pixel specified with -1 in the structuring
/// element, are not considered during the operation.
/// - If a grayscale closing will be performed (\a mode=momGrayscale), the values of the structuring element \a se can
/// be any numerical value or can be set to -1 to ignore the value.
/// The source and destination image must
/// have the same properties (width, height, bands, z-slices, time-slices, datatype).
/// \note The morphological operations can be iterated, i.e. applied a given number of
/// \note times to itself. The resulting effect is equivalent to using a larger structuring element, with a
/// \note much better time performance.
/// \see mvIMPACT::dilate
/// \see mvIMPACT::erode
/// \see mvIMPACT::opening
/// \see #MorphOpMode
//-----------------------------------------------------------------------------
 void closing(
	    /// the destination image
	    Image& dest,
	    /// the source image
	    const Image& source,
	    /// the structuring element to use for the closing operation
	    const StructuringElement& se,
	    /// Specifies the number of passes to run the operation
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
	    int iterations=1,
	    /// Specifies the operation mode for processing.
	    MorphOpMode mode=momGrayscale);



/// \brief Connectivity mapping on a mvIMPACT::Image.

/// This function performs a connectivity mapping operation on an image using the
/// specified source image \a source  and the mvIMPACT::Palette \a palette.
/// Connectivity mapping is a step in connected components analysis, i.e. looking at the way
/// pixels neighbor each other. This function assigns to each pixel a numerical encoding of the
/// neighbor presence, using the weighting scheme below:
/// \image html images/mvi_base/MorphConnectivity_Scheme.png
/// The resulting value is an integer between 0 and 511. It can be mapped to range 0..255 by
/// means of a suitable lookup-table, or the high order bit can just be ignored.
/// The directions of a 3x3 neighborhood are coded as follows:<br>
/// p3 p2 p1 <br>
/// p4 p8 p0 <br>
/// p5 p6 p7<br>
/// where the numbers represent the i'th bit in a 9 bit word (bit order of a 9 bit word : bit 8 7 6 5 4 3 2 1 0)
/// The connectivity code will be calculated as follows:
/// \image html images/mvi_base/MorphConnectivity_Formula.png
/// where
/// - p(i) is 1 if the pixel is set
/// - p(i) is 0 if the pixel is not set
/// In the case of a multidimensional mvIMPACT::Image \a source  the mvIMPACT::Palette \a palette must have the same
/// properties as the source image \a source  concerning the number of bands, z-slices and
/// time-slices.
//-----------------------------------------------------------------------------
Image connectivity(/// Specifies the source buffer handle. All non zero pixel of the source buffer will be
		   /// treated as object pixel.
		   const Image& source,
		   /// Specifies the mvIMPACT::Palette. Because the connectivity code is a 9 bit code, the
		   /// number of palette entries must be set at least to 512.
		   const Palette& palette);


/// \brief Connectivity mapping on a mvIMPACT::Image.

/// This function performs a connectivity mapping operation on an image using the
/// specified source image \a source  and the mvIMPACT::Palette \a palette.
/// Connectivity mapping is a step in connected components analysis, i.e. looking at the way
/// pixels neighbor each other. This function assigns to each pixel a numerical encoding of the
/// neighbor presence, using the weighting scheme below:
/// \image html images/mvi_base/MorphConnectivity_Scheme.png
/// The resulting value is an integer between 0 and 511. It can be mapped to range 0..255 by
/// means of a suitable lookup-table, or the high order bit can just be ignored. Another possibility
/// is to pass a destination image \a dest with a datatype which can hold more than 8 bits, i.e.
/// bdUShort for example.
/// The directions of a 3x3 neighborhood are coded as follows:<br>
/// p3 p2 p1 <br>
/// p4 p8 p0 <br>
/// p5 p6 p7<br>
/// where the numbers represent the i'th bit in a 9 bit word (bit order of a 9 bit word : bit 8 7 6 5 4 3 2 1 0)
/// The connectivity code will be calculated as follows:
/// \image html images/mvi_base/MorphConnectivity_Formula.png
/// where
/// - p(i) is 1 if the pixel is set
/// - p(i) is 0 if the pixel is not set
/// In the case of a multidimensional mvIMPACT::Image \a source  the mvIMPACT::Palette \a palette must have the same
/// properties as the source image \a source  and the destination image \a dest concerning the number of bands, z-slices and
/// time-slices.
//-----------------------------------------------------------------------------
void connectivity(/// the destination image
		  Image& dest,
		  /// Specifies the source buffer handle. All non zero pixel of the source buffer will be
		  /// treated as object pixel.
		  const Image& source,
		  /// Specifies the mvIMPACT::Palette. Because the connectivity code is a 9 bit code, the
		  /// number of palette entries must be set at least to 512.
		  /// The output data type of the palette
		  /// should have the same data type as the destination buffer. Otherwise data will be
		  /// lost.
		  const Palette& palette);


/// \brief Connectivity mapping on a mvIMPACT::Image.

/// This function performs a connectivity mapping operation on an image using the
/// specified source image \a source.
/// Connectivity mapping is a step in connected components analysis, i.e. looking at the way
/// pixels neighbor each other. This function assigns to each pixel a numerical encoding of the
/// neighbor presence, using the weighting scheme below:
/// \image html images/mvi_base/MorphConnectivity_Scheme.png
/// The resulting value is an integer between 0 and 511. It can be mapped to range 0..255 by
/// means of a suitable lookup-table, or the high order bit can just be ignored.
/// The directions of a 3x3 neighborhood are coded as follows:<br>
/// p3 p2 p1 <br>
/// p4 p8 p0 <br>
/// p5 p6 p7<br>
/// where the numbers represent the i'th bit in a 9 bit word (bit order of a 9 bit word : bit 8 7 6 5 4 3 2 1 0)
/// The connectivity code will be calculated as follows:
/// \image html images/mvi_base/MorphConnectivity_Formula.png
/// where
/// - p(i) is 1 if the pixel is set
/// - p(i) is 0 if the pixel is not set
/// In the case of a multidimensional mvIMPACT::Image \a source  the mvIMPACT::Palette \a palette must have the same
/// properties as the source image \a source  concerning the number of bands, z-slices and
/// time-slices.
//-----------------------------------------------------------------------------
Image connectivity(/// Specifies the source buffer handle. All non zero pixel of the source buffer will be
		   /// treated as object pixel.
		   const Image& source);


/// \brief Connectivity mapping on a mvIMPACT::Image.

/// This function performs a connectivity mapping operation on an image using the
/// specified source image \a source.
/// Connectivity mapping is a step in connected components analysis, i.e. looking at the way
/// pixels neighbor each other. This function assigns to each pixel a numerical encoding of the
/// neighbor presence, using the weighting scheme below:
/// \image html images/mvi_base/MorphConnectivity_Scheme.png
/// The resulting value is an integer between 0 and 511. Bit 8 will then be thrown away. Another possibility
/// is to pass a destination image \a dest with a datatype which can hold more than 8 bits, i.e.
/// bdUShort for example.
/// The directions of a 3x3 neighborhood are coded as follows:<br>
/// p3 p2 p1 <br>
/// p4 p8 p0 <br>
/// p5 p6 p7<br>
/// where the numbers represent the i'th bit in a 9 bit word (bit order of a 9 bit word : bit 8 7 6 5 4 3 2 1 0)
/// The connectivity code will be calculated as follows:
/// \image html images/mvi_base/MorphConnectivity_Formula.png
/// where
/// - p(i) is 1 if the pixel is set
/// - p(i) is 0 if the pixel is not set
//-----------------------------------------------------------------------------
void connectivity(/// the destination image
		  Image& dest,
		  /// Specifies the source buffer handle. All non zero pixel of the source buffer will be
		  /// treated as object pixel.
		  const Image& source);



/// \brief Dilate an mvIMPACT::Image.

/// This function performs a morphological (binary or grayscale) dilation operation using the
/// specified source image \a source  and a predefined structuring element \a se.
/// Generally speaking, a morphological
/// dilation lets objects grow and therefore changes the shape of objects. In the case of a
/// multidimensional image, the structuring element will be applied to every plane.
/// If a grayscale dilation will be performed, no structuring element will be subtracted
/// from the neighborhood pixels (empty structuring element) and if a binary dilation
/// will be performed, a full 3x3 rectangular structuring element is used.
/// \image html images/mvi_base/MorphDilate_Dilation.png
/// \note The morphological operations can be iterated, i.e. applied a given number of
/// \note times to itself. The resulting effect is equivalent to using a larger structuring element, with a
/// \note much better time performance.
/// \see #MorphOpMode
/// \see mvIMPACT::erode
//-----------------------------------------------------------------------------
Image dilate(/// the soure image
	    const Image& source,
   	    /// the predefined structuring element to use for the operation
   	    StockStructuringElement se=sseSquare,
	    /// Specifies the number of passes to run the operation
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int iterations=1,
	    /// Specifies the operation mode for processing.
	    MorphOpMode mode=momGrayscale
	    );



/// \brief Dilate an mvIMPACT::Image.

/// This function performs a morphological (binary or grayscale) dilation operation using the
/// specified source image \a source  and a predefined structuring element \a se.
/// Generally speaking, a morphological
/// dilation lets objects grow and therefore changes the shape of objects. In the case of a
/// multidimensional image, the structuring element will be applied to every plane.
/// If a grayscale dilation will be performed, no structuring element will be subtracted
/// from the neighborhood pixels (empty structuring element) and if a binary dilation
/// will be performed, a full 3x3 rectangular structuring element is used.
/// The source
/// and destination image must have the same properties (width, height, bands, z-slices,
/// time-slices, datatype).
/// \image html images/mvi_base/MorphDilate_Dilation.png
/// \note The morphological operations can be iterated, i.e. applied a given number of
/// \note times to itself. The resulting effect is equivalent to using a larger structuring element, with a
/// \note much better time performance.
/// \see #MorphOpMode
/// \see mvIMPACT::erode
//-----------------------------------------------------------------------------
void dilate(/// the destination image
	    Image& dest,
	    /// the soure image
	    const Image& source,
	    /// the predefined structuring element to use for the operation
   	    StockStructuringElement se=sseSquare,
	    /// Specifies the number of passes to run the operation
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int iterations=1,
	    /// Specifies the operation mode for processing.
	    MorphOpMode mode=momGrayscale
	    );





/// \brief Dilate an mvIMPACT::Image.

/// This function performs a morphological (binary or grayscale) dilation operation using the
/// specified source image \a source  and some custom structuring element \a se.
/// Generally speaking, a morphological
/// dilation lets objects grow and therefore changes the shape of objects. In the case of a
/// multidimensional image, the structuring element will be applied to every plane.
/// - If a binary dilation will be performed, the values can be set to -1
/// and 1. Neighborhood pixel specified with -1 in the structuring
/// element, are not considered during the operation. If any structuring element matches
/// the corresponding neighborhood pixel, the center pixel is set to the maximum of the
/// buffer, otherwise it remains unchanged.
/// - If a grayscale dilation will be performed, the values of the structuring element can
/// be any numerical value or can be set to  -1 to ignore the value. These values are added
/// to the corresponding neighborhood pixels of the source buffer. The maximum value
/// of the resulting operation will be written to the center pixel of the destination buffer.
/// When using a custom buffer handle, it must be a valid buffer handle returned from a
/// call to one of the buffer allocation functions.
/// \image html images/mvi_base/MorphDilate_Dilation.png
/// \note The morphological operations can be iterated, i.e. applied a given number of
/// \note times to itself. The resulting effect is equivalent to using a larger structuring element, with a
/// \note much better time performance.
/// \see mvIMPACT::erode
/// \see #MorphOpMode
//-----------------------------------------------------------------------------
Image dilate(/// the source image
		const Image& source,
	    /// the structuring element to use for the operation
	    const StructuringElement& se,
	    /// Specifies the number of passes to run the operation
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int iterations=1,
	    /// Specifies the operation mode for processing.
	    MorphOpMode mode=momGrayscale
	    );





/// \brief Dilate an mvIMPACT::Image.

/// This function performs a morphological (binary or grayscale) dilation operation using the
/// specified source image \a source  and some custom structuring element \a se.
/// Generally speaking, a morphological
/// dilation lets objects grow and therefore changes the shape of objects. In the case of a
/// multidimensional image, the structuring element will be applied to every plane.
/// - If a binary dilation will be performed, the values can be set to -1
/// or 1. Neighborhood pixel specified with -1 in the structuring
/// element are not considered during the operation. If any structuring element matches
/// the corresponding neighborhood pixel, the center pixel is set to the maximum of the
/// buffer, otherwise it remains unchanged.
/// - If a grayscale dilation will be performed, the values of the structuring element can
/// be any numerical value or can be set to  -1 to ignore the value. These values are added
/// to the corresponding neighborhood pixels of the source buffer. The maximum value
/// of the resulting operation will be written to the center pixel of the destination buffer.
/// When using a custom buffer handle, it must be a valid buffer handle returned from a
/// call to one of the buffer allocation functions.
/// The source
/// and destination image must have the same properties (width, height, bands, z-slices,
/// time-slices, datatype).
/// \image html images/mvi_base/MorphDilate_Dilation.png
/// \note The morphological operations can be iterated, i.e. applied a given number of
/// \note times to itself. The resulting effect is equivalent to using a larger structuring element, with a
/// \note much better time performance.
/// \see mvIMPACT::erode
/// \see #MorphOpMode
//-----------------------------------------------------------------------------
void dilate(/// the destination image
	    Image& dest,
	    /// the source image
	    const Image& source,
	    /// the structuring element to use for the operation
	    const StructuringElement& se,
	    /// Specifies the number of passes to run the operation
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int iterations=1,
	    /// Specifies the operation mode for processing.
	    MorphOpMode mode=momGrayscale
	    );





/// \brief Performs a morphological distance operation.

/// This function performs a morphological distance operation on a binary image using the
/// specified source image. Every pixel in
/// the destination image is given a gray level value, which is equal to the shortest distance from
/// the pixel to the object boundary. This value can be seen as the size of the smallest erosion,
/// which would make this pixel disappear. The function internally uses the predefined
/// structuring element "dkRect" and automatically enables overscanning with replace
/// mode (overscan pixels are set to 0).  In the case of a multidimensional buffer, the same operation will be
/// performed on every plane.
/// \image html images/mvi_base/MorphDistance_Distance.png
/// \note The data type of the destination image is dependent on the maximum possible distance, i.e.
/// \note the image size.
/// \see mvIMPACT::medialAxis
//-----------------------------------------------------------------------------
Image distance(/// the source image
	       const Image& source);





/// \brief Performs a morphological distance operation.

/// This function performs a morphological distance operation on a binary image using the
/// specified source image.The results are written to the destination image \a dest. Every pixel in
/// the destination image is given a gray level value, which is equal to the shortest distance from
/// the pixel to the object boundary. This value can be seen as the size of the smallest erosion,
/// which would make this pixel disappear. The function internally uses the predefined
/// structuring element "dkRect" and automatically enables overscanning with replace
/// mode (overscan pixels are set to 0).  In the case of a multidimensional buffer, the same operation will be
/// performed on every plane.
/// The source and destination image must have the same properties
/// concerning the number of bands, z-slices and time-slices.
/// \image html images/mvi_base/MorphDistance_Distance.png
/// \note The data type of the destination image is dependent on the maximum possible distance, i.e.
/// \note the image size.
/// \see mvIMPACT::medialAxis
//-----------------------------------------------------------------------------
void distance(/// the destination image
	      Image& dest,
	      /// the source image
	      const Image& source);





/// \brief Performs a morphological erosion operation.

/// This function performs a morphological (binary or grayscale) erosion operation using the
/// specified source image \a source  and a predefined structuring element \a se. Generally speaking, a morphological
/// erosion lets objects shrink and therefore changes the shape of objects. In the case of a
/// multidimensional buffer, the structuring element will be applied to every plane.
/// If a grayscale erosion will be performed, no structuring element will be subtracted
/// from the neighborhood pixels (empty structuring element) and if a binary erosion
/// will be performed, a full 3x3 rectangular structuring element is used.
/// \note The morphological operations can be iterated, i.e. applied a given number of
/// \note times to itself. The resulting effect is equivalent to using a larger structuring element, with a
/// \note much better time performance.
/// \see #MorphOpMode
/// \see mvIMPACT::dilate
//-----------------------------------------------------------------------------
Image erode(/// the source image
	    const Image& source,
	    /// the predefined structuring element to use for the operation
	    StockStructuringElement se=sseSquare,
	    /// Specifies the number of passes to run the operation.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int iterations=1,
	    /// Specifies the operation mode for processing.
	    MorphOpMode mode=momGrayscale
	    );


/// \brief Performs a morphological erosion operation.

/// This function performs a morphological (binary or grayscale) erosion operation using the
/// specified source image and a predefined structuring element \a se. The output is written in destination image \a dest.
/// Generally speaking, a morphological
/// erosion lets objects shrink and therefore changes the shape of objects. In the case of a
/// multidimensional buffer, the structuring element will be applied to every plane.
/// If a grayscale erosion will be performed, no structuring element will be subtracted
/// from the neighborhood pixels (empty structuring element) and if a binary erosion
/// will be performed, a full 3x3 rectangular structuring element is used.
/// The source
/// and destination buffer must have the same properties (width, height, bands, z-slices,
/// time-slices, datatype).
/// \note The morphological operations can be iterated, i.e. applied a given number of
/// \note times to itself. The resulting effect is equivalent to using a larger structuring element, with a
/// \note much better time performance.
/// \see #MorphOpMode
/// \see mvIMPACT::dilate
//-----------------------------------------------------------------------------
void erode(/// the destination image
		Image& dest,
		/// the source image
		const Image& source,
		/// the predefined structuring element to use for the operation
		StockStructuringElement se=sseSquare,
		/// Specifies the number of passes to run the operation.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int iterations=1,
		/// Specifies the operation mode for processing.
		MorphOpMode mode=momGrayscale
		);


/// \brief Performs a morphological erosion operation.

/// This function performs a morphological (binary or grayscale) erosion operation using the
/// specified source image and the structuring element \a se. Generally speaking, a morphological
/// erosion lets objects shrink and therefore changes the shape of objects. In the case of a
/// multidimensional buffer, the structuring element will be applied to every plane.
/// - If a binary erosion will be performed, the values can be set to -1
/// and 1. Neighborhood pixel specified with -1 in the structuring
/// element, are not considered during the operation. If the structuring element does not
/// match the corresponding neighborhood pixels exactly, the center pixel is set to 0,
/// otherwise it remains unchanged.
/// - If a grayscale erosion will be performed, the values of the structuring element can
/// be any numerical value or can be set to -1 to ignore the value. These values are
/// subtracted from the corresponding neighborhood pixels of the source buffer. The
/// minimum value of the resulting operation will be written to the center pixel of the
/// destination buffer. When using a custom buffer handle, it must be a valid buffer
/// handle returned from a call to one of the buffer allocation functions.
/// \note The morphological operations can be iterated, i.e. applied a given number of
/// \note times to itself. The resulting effect is equivalent to using a larger structuring element, with a
/// \note much better time performance.
/// \see mvIMPACT::dilate
/// \see #MorphOpMode
//-----------------------------------------------------------------------------
Image erode(/// the source image
	    const Image& source,
	    /// the structuring element to use for the operation
	    const StructuringElement& se,
	    /// Specifies the number of passes to run the operation.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int iterations=1,
	    /// Specifies the operation mode for processing.
	    MorphOpMode mode=momGrayscale
	    );





/// \brief Performs a morphological erosion operation.

/// This function performs a morphological (binary or grayscale) erosion operation using the
/// specified source image and the structuring element \a se. The output is written in destination image \a dest.
/// Generally speaking, a morphological
/// erosion lets objects shrink and therefore changes the shape of objects. In the case of a
/// multidimensional buffer, the structuring element will be applied to every plane.
/// - If a binary erosion will be performed, the values can be set to -1
/// and 1. Neighborhood pixel specified with -1 in the structuring
/// element, are not considered during the operation. If the structuring element does not
/// match the corresponding neighborhood pixels exactly, the center pixel is set to 0,
/// otherwise it remains unchanged.
/// - If a grayscale erosion will be performed, the values of the structuring element can
/// be any numerical value or can be set to -1 to ignore the value. These values are
/// subtracted from the corresponding neighborhood pixels of the source buffer. The
/// minimum value of the resulting operation will be written to the center pixel of the
/// destination buffer. When using a custom buffer handle, it must be a valid buffer
/// handle returned from a call to one of the buffer allocation functions.
/// The source
/// and destination buffer must have the same properties (width, height, bands, z-slices,
/// time-slices, datatype).
/// \note The morphological operations can be iterated, i.e. applied a given number of
/// \note times to itself. The resulting effect is equivalent to using a larger structuring element, with a
/// \note much better time performance.
/// \see mvIMPACT::dilate
/// \see #MorphOpMode
//-----------------------------------------------------------------------------
void erode(/// the destination image
		Image& dest,
		/// the source image
		const Image& source,
		/// the structuring element to use for the operation
		const StructuringElement& se,
		/// Specifies the number of passes to run the operation.
		/// \xmlonly
		/// 	<mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int iterations=1,
		/// Specifies the operation mode for processing.
		MorphOpMode mode=momGrayscale
		);




/// \brief Performs a morphological hit or miss operation.

/// This function performs a hit or miss transformation using the specified source buffer and
/// a predefined structuring element \a se.
/// \see #MorphOpMode
/// \image html images/mvi_base/MorphHitOrMiss_HitOrMiss.png
//-----------------------------------------------------------------------------
Image hitOrMiss(/// the source image
		const Image& source,
		/// the predefined structuring element to use for the operation
		StockStructuringElement se=sseSquare,
		/// Specifies the operation mode for processing.
		MorphOpMode mode=momGrayscale
		);




/// \brief Performs a morphological hit or miss operation.

/// This function performs a hit or miss transformation using the specified source buffer and
/// a predefined structuring element \a se.
/// In the case of a multidimensional buffer, the same structuring element will be applied to every
/// plane. The source and destination buffer must have the same properties (width, height,bands, z-slices,
/// time-slices, datatype).
/// \see #MorphOpMode
/// \image html images/mvi_base/MorphHitOrMiss_HitOrMiss.png
//-----------------------------------------------------------------------------
void hitOrMiss(/// the destination image
			Image& dest,
			/// the source image
			const Image& source,
			/// the predefined structuring element to use for the operation
			StockStructuringElement se=sseSquare,
			/// Specifies the operation mode for processing.
			MorphOpMode mode=momGrayscale);




/// \brief Performs a morphological hit or miss operation.

/// This function performs a hit or miss transformation using the specified source buffer and
/// the structuring element \a se.
/// - If a binary hit or miss transformation will be performed, the values can be set to
/// -1, 0 and 1. Neighborhood pixel specified with -1 in the structuring element
/// are not considered during the operation. If all structuring elements match with all
/// corresponding neighborhood pixels exactly, the center pixel is set to 1
/// (this means, that it is set to the maximum
/// value that can be represented in the buffer), otherwise it is set to 0.
/// - If a grayscale hit or miss transformation will be performed, the values of the
/// structuring element can be set to any numerical value or to -1. The
/// center pixel of the destination buffer will be set to the maximum pixel value that
/// can be represented (i.e. 0xFF for an 8 bit buffer), if all structuring elements match
/// with all corresponding neighborhood pixels exactly. Otherwise, the center pixel will
/// be set to the minimum that can be represented in the destination buffer (i.e. 0).
/// \image html images/mvi_base/MorphHitOrMiss_HitOrMiss.png
/// \note The function only works for unsigned buffer datatypes.
/// \see #MorphOpMode
//-----------------------------------------------------------------------------
Image hitOrMiss(/// the source image
		const Image& source,
		/// the structuring element to use for the operation
		const StructuringElement& se,
		/// Specifies the operation mode for processing.
		MorphOpMode mode=momGrayscale);



/// \brief Performs a morphological hit or miss operation.

/// This function performs a hit or miss transformation using the specified source buffer and
/// the structuring element \a se.
/// In the case of a multidimensional buffer, the same structuring element will be applied to every
/// plane. The source and destination buffer must have the same properties (width, height,bands, z-slices,
/// time-slices, datatype).
/// - If a binary hit or miss transformation will be performed, the values can be set to
/// -1, 0 and 1. Neighborhood pixel specified with
/// -1 in the structuring element are not considered during the
/// operation. If all structuring elements match with all corresponding neighborhood
/// pixels exactly, the center pixel is set to 1 (this means, that it is set to the maximum
/// value that can be represented in the buffer), otherwise it is set to 0.
/// - If a grayscale hit or miss transformation will be performed, the values of the
/// structuring element can be set to any numerical value or to  -1 to ignore the value. The
/// center pixel of the destination buffer will be set to the maximum pixel value that
/// can be represented (i.e. 0xFF for an 8 bit buffer), if all structuring elements match
/// with all corresponding neighborhood pixels exactly. Otherwise, the center pixel will
/// be set to the minimum that can be represented in the destination buffer (i.e. 0).
/// \image html images/mvi_base/MorphHitOrMiss_HitOrMiss.png
/// \see #MorphOpMode
//-----------------------------------------------------------------------------
void hitOrMiss(/// the destination image
	       Image& dest,
	       /// the source image
	       const Image& source,
	       /// the structuring element to use for the operation
	       const StructuringElement& se,
	       /// Specifies the operation mode for processing.
	       MorphOpMode mode=momGrayscale);


/// \brief Performs a labelling operation.

/// This function performs a labeling operation using the specified source image \a source.
/// Each pixel in a connected component is given the
/// same numerical value. The function starts with the label index 1 and assigns consecutive label
/// values to each following object. The gray level of each object depends on its position in the
/// source image (the function scans from left to right and from top to bottom). The buffer depth
/// of the destination buffer determines the number of objects that can be kept. For
/// example, a 8-bit buffer can be used for a maximum of 254 objects, whereas a 16-bit buffer
/// can be used for a maximum of 65534 objects.
/// The image that is returned has the same datatype as the source image!
/// \image html images/mvi_base/MorphLabel_Label.png
/// The soure image \a source  must have the following properties:
///  - 1 band
///  - 1 slice
///  - 1 frame
///
/// \xmlonly
/// <mvWrapperDoc>
/// <htmlinclude ref="python_doc_start.html"/>
/// In Python, this function is used differently, because Python does not support
/// call by reference directly. Here parameter 2 is a list. The object count
/// will be written to index 0 of this list. This is a pure output parameter.
/// The content of the list before the call is irrelevant. The list may even
/// be empty.
/// \verbatim
/// l = [None]
/// try:
///     resultImage = label(sourceImage, l, mode)
///     print '%d object(s) found' % l[0]
/// except ImpactException, e:
///     print e.errorString
/// \endverbatim
/// <htmlinclude ref="specific_doc_end.html"/>
/// </mvWrapperDoc>
/// \endxmlonly
///
/// \see #NeighborhoodMode
//-----------------------------------------------------------------------------
Image label(/// the source image
	    const Image& source,
	    /// Total number of objects found in the source buffer
	    int* PYTHON_CPP_SWITCH(OUTPUT,count=0),
	    /// Specifies how to treat touching objects:
	    /// - nm8Connected : diagonally touching objects are treated as one object
	    /// - nm4Connected: diagonally touching objects are not treated as one object
	    NeighborhoodMode mode=nm8Connected);




/// \brief Performs a labelling operation.

/// This function performs a labeling operation using the specified source buffer and writes the
/// results into the specified destination buffer. Each pixel in a connected component is given the
/// same numerical value. The function starts with the label index 1 and assigns consecutive label
/// values to each following object. The gray level of each object depends on its position in the
/// source image (the function scans from left to right and from top to bottom). The buffer depth
/// of the destination buffer determines the number of objects that can be kept. For
/// example, a 8-bit buffer can be used for a maximum of 254 objects, whereas a 16-bit buffer
/// can be used for a maximum of 65534 objects.
/// The source and destination image must have the same properties (width, height,bands, z-slices,
/// time-slices) except the datatype!
/// \image html images/mvi_base/MorphLabel_Label.png
/// The soure image \a source  must have the following properties:
///  - 1 band
///  - 1 slice
///  - 1 frame
///
/// \xmlonly
/// <mvWrapperDoc>
/// <htmlinclude ref="python_doc_start.html"/>
/// In Python, this function is used differently, because Python does not support
/// call by reference directly. Here parameter 3 is a list. The object count
/// will be written to index 0 of this list. This is a pure output parameter.
/// The content of the list before the call is irrelevant. The list may even
/// be empty.
/// \verbatim
/// l = []
/// try:
///     label(destImage, sourceImage, l, mode)
///     print '%d object(s) found' % l[0]
/// except ImpactException, e:
///     print e.errorString
/// \endverbatim
/// <htmlinclude ref="specific_doc_end.html"/>
/// </mvWrapperDoc>
/// \endxmlonly
///
/// \see #NeighborhoodMode
//-----------------------------------------------------------------------------
void label(/// the destination image
	   Image& dest,
	   /// the source image
	   const Image& source,
	   /// Total number of objects found in the source buffer
	   int* PYTHON_CPP_SWITCH(OUTPUT,count=0),
	   /// Specifies how to treat touching objects:
	   /// - nm8Connected: diagonally touching objects are treated as one object
	   /// - nm4Connected: diagonally touching objects are not treated as one object
	   NeighborhoodMode mode=nm8Connected);



/// \brief Performs a medial axis operation.

/// The source image of the operation must be a binary image. The destination image will be a
/// gray level image. The pixel of the medial axis will consist of gray level values. The gray level
/// value for each point of the medial axis is obtained by a preceding distance operation. The
/// skeleton obtained from this operation is usually not connected but is made up of small
/// segments.
/// The function internally uses the predefined
/// structuring element "dkRect" and automatically enables overscanning with replace
/// mode (overscan pixels are set to 0).  In the case of a multidimensional buffer, the same operation will be
/// performed on every plane.
/// \image html images/mvi_base/MorphDistance_MedialAxis.png
/// \note The data type of the destination image is dependent on the maximum possible distance, i.e.
/// \note the image size.
/// \see mvIMPACT::distance
//-----------------------------------------------------------------------------
Image medialAxis(/// the source image
		 const Image& source);



/// \brief Performs a medial axis operation.

/// The source image of the operation must be a binary image. The destination image will be a
/// gray level image. The pixel of the medial axis will consist of gray level values. The gray level
/// value for each point of the medial axis is obtained by a preceding distance operation. The
/// skeleton obtained from this operation is usually not connected but is made up of small
/// segments.
/// The function internally uses the predefined
/// structuring element "dkRect" and automatically enables overscanning with replace
/// mode (overscan pixels are set to 0).  In the case of a multidimensional buffer, the same operation will be
/// performed on every plane.
/// \image html images/mvi_base/MorphDistance_MedialAxis.png
/// \note The data type of the destination image is dependent on the maximum possible distance, i.e.
/// \note the image size.
/// \see mvIMPACT::distance
//-----------------------------------------------------------------------------
void medialAxis(/// the destination image
		Image& dest,
		/// the source image
		const Image& source);




/// \brief Performs a morphological open operation.

/// This function performs a morphological (binary or grayscale) open operation using the
/// specified source image and a predefined structuring element \a se.
/// An opening consists of one or more erosions followed by one or more
/// dilations. In the case of a multidimensional buffer, the
/// structuring element will be applied to every plane.
/// In case of a grayscale opening, no structuring element will be subtracted or added
/// from/to the neighborhood pixels (empty structuring element). If a binary opening
/// will be performed, a full 3x3 rectangular structuring element will be used.
/// \image html images/mvi_base/MorphOpen_Open.png
/// \note The morphological operations can be iterated, i.e. applied a given number of
/// \note times to itself. The resulting effect is equivalent to using a larger structuring element, with a
/// \note much better time performance.
/// \see mvIMPACT::closing
/// \see mvIMPACT::erode
/// \see mvIMPACT::dilate
/// \see #MorphOpMode
//-----------------------------------------------------------------------------
Image opening(/// the source image
		const Image& source,
   		/// the predefined structuring element to use for the operation
		StockStructuringElement se=sseSquare,
		/// Specifies the number of passes to run the operation.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int iterations=1,
		/// Specifies the operation mode for processing.
		MorphOpMode mode=momGrayscale);



/// \brief Performs a morphological open operation.

/// This function performs a morphological (binary or grayscale) open operation using the
/// specified source image and a predefined structuring element \a se. The result of the operation is written
/// into the destination image \a dest.
/// An opening consists of one or more erosions followed by one or more
/// dilations. In the case of a multidimensional buffer, the
/// structuring element will be applied to every plane.
/// In case of a grayscale opening, no structuring element will be subtracted or added
/// from/to the neighborhood pixels (empty structuring element). If a binary opening
/// will be performed, a full 3x3 rectangular structuring element will be used.
/// The source and destination buffer must
/// have the same properties (width, height, bands, z-slices, time-slices, datatype).
/// \image html images/mvi_base/MorphOpen_Open.png
/// \note The morphological operations can be iterated, i.e. applied a given number of
/// \note times to itself. The resulting effect is equivalent to using a larger structuring element, with a
/// \note much better time performance.
/// \see mvIMPACT::closing
/// \see mvIMPACT::erode
/// \see mvIMPACT::dilate
/// \see #MorphOpMode
//-----------------------------------------------------------------------------
void opening(/// the destination image
		Image& dest,
		/// the source image
		const Image& source,
   		/// the predefined structuring element to use for the operation
		StockStructuringElement se=sseSquare,
		/// Specifies the number of passes to run the operation.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int iterations=1,
		/// Specifies the operation mode for processing.
		MorphOpMode mode=momGrayscale);



/// \brief Performs a morphological open operation.

/// This function performs a morphological (binary or grayscale) open operation using the
/// specified source image and the structuring element \a se.
/// An opening consists of one or more erosions followed by one or more
/// dilations. In the case of a multidimensional buffer, the
/// structuring element will be applied to every plane.
/// - If a binary opening will be performed, the values can be set to -1,
/// 0 and 1. Neighborhood pixel specified with -1 in the structuring
/// element, are not considered during the operation.
/// - If a grayscale opening will be performed, the values of the structuring element can
/// be any numerical value or can be set to  -1 to ignore the value. When using a custom
/// buffer handle, it must be a valid buffer handle returned from a call to one of the
/// buffer allocation functions.
/// \image html images/mvi_base/MorphOpen_Open.png
/// \note The morphological operations can be iterated, i.e. applied a given number of
/// \note times to itself. The resulting effect is equivalent to using a larger structuring element, with a
/// \note much better time performance.
/// \see mvIMPACT::closing
/// \see mvIMPACT::erode
/// \see mvIMPACT::dilate
/// \see #MorphOpMode
//-----------------------------------------------------------------------------
Image opening(/// the source image
		const Image& source,
		/// the structuring element to be used for the operation
		const StructuringElement& se,
		/// Specifies the number of passes to run the operation.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int iterations=1,
		/// Specifies the operation mode for processing.
		MorphOpMode mode=momGrayscale);




/// \brief Performs a morphological open operation.

/// This function performs a morphological (binary or grayscale) open operation using the
/// specified source image and the structuring element \a se. The result of the operation is written
/// into the destination image \a dest.
/// An opening consists of one or more erosions followed by one or more
/// dilations. In the case of a multidimensional buffer, the
/// structuring element will be applied to every plane.
/// - If a binary opening will be performed, the values can be set to -1,
/// 0 and 1. Neighborhood pixel specified with -1 in the structuring
/// element, are not considered during the operation.
/// - If a grayscale opening will be performed, the values of the structuring element can
/// be any numerical value or can be set to -1 to ignore the value. When using a custom
/// buffer handle, it must be a valid buffer handle returned from a call to one of the
/// buffer allocation functions.
/// The source and destination buffer must
/// have the same properties (width, height, bands, z-slices, time-slices, datatype).
/// \image html images/mvi_base/MorphOpen_Open.png
/// \note The morphological operations can be iterated, i.e. applied a given number of
/// \note times to itself. The resulting effect is equivalent to using a larger structuring element, with a
/// \note much better time performance.
/// \see mvIMPACT::closing
/// \see mvIMPACT::erode
/// \see mvIMPACT::dilate
/// \see #MorphOpMode
//-----------------------------------------------------------------------------
void opening(/// the destination image
		Image& dest,
		/// the source image
		const Image& source,
		/// the structuring element to be used for the operation
		const StructuringElement& se,
		/// Specifies the number of passes to run the operation.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int iterations=1,
		/// Specifies the operation mode for processing.
		MorphOpMode mode=momGrayscale);



/// \brief Performs a size filter operation based on the area of objects.

/// This function allows you to remove objects based on their size (area). It applies a size filter to
/// the source image and returns the filtered image. The shape of the
/// objects left in the resulting image remains unchanged.
/// In the case of a multidimensional buffer, the size filter will be applied to every plane.
/// \image html images/mvi_base/MorphSize_Size.png
/// \see #SizeMode
/// \see #ObjectState
//-----------------------------------------------------------------------------
Image sizeFilter(/// the source image
		const Image& source,
		/// Specifies the size of the objects. The meaning also depends on parameter \a mode.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int size,
		/// Specifies which of the included objects should be filtered
		SizeMode mode=smSmaller,
		/// Specifies the objects that are included into the filtering process
		ObjectState objectState=osNonZero);




/// \brief Performs a size filter operation based on the area of objects.

/// This function allows you to remove objects based on their size (area). It applies a size filter to
/// the source images and writes the filtered image into the destination buffer \a dest. The shape of the
/// objects left in the resulting image remains unchanged.
/// In the case of a multidimensional buffer, the size filter will be applied to every plane.
/// The source and destination buffer must have the same properties (width, height, bands, z-slices, time-slices,
/// datatype)
/// \image html images/mvi_base/MorphSize_Size.png
/// \see #SizeMode
/// \see #ObjectState
//-----------------------------------------------------------------------------
void sizeFilter(/// the destination image
		Image& dest,
		/// the source image
		const Image& source,
		/// Specifies the size of the objects. The meaning also depends on parameter \a mode.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int size,
		/// Specifies which of the included objects should be filtered
		SizeMode mode=smSmaller,
		/// Specifies the objects that are included into the filtering process
		ObjectState objectState=osNonZero);



/// \brief Computes the ultimate eroded set of a mvIMPACT::Image

/// This function uses the specified source image and computes the ultimate eroded set.
/// The input image must be a binary image whereas the
/// output image is a grayscale image, where the gray value of each pixel represents the size of
/// the erosion which would make this pixel disappear. A typical application for this function
/// could be to count touching particles (as long as the particles are convex and the pseudo center
/// of one particle is outside of other particles).
/// The algorithm uses an iterative process. Operation time is roughly proportional to the size of
/// binary connected components. Objects to be treated by the algorithm, must have the
/// maximum value which can be represented in the source buffer (0xFF for a 8-bit buffer and
/// 0xFFFF for a 16-bit buffer). Background pixel must be 0.
//-----------------------------------------------------------------------------
Image ultimate(/// the source image
	       const Image& source);



/// \brief Computes the ultimate eroded set of a mvIMPACT::Image

/// This function uses the specified source image and computes the ultimate eroded set. The resulting image is written
/// into the destination buffer \a dest.
/// The input image must be a binary image whereas the
/// output image is a grayscale image, where the gray value of each pixel represents the size of
/// the erosion which would make this pixel disappear. A typical application for this function
/// could be to count touching particles (as long as the particles are convex and the pseudo center
/// of one particle is outside of other particles).
/// The algorithm uses an iterative process. Operation time is roughly proportional to the size of
/// binary connected components. Objects to be treated by the algorithm, must have the
/// maximum value which can be represented in the source buffer (0xFF for a 8-bit buffer and
/// 0xFFFF for a 16-bit buffer). Background pixel must be 0.
//-----------------------------------------------------------------------------
void ultimate(/// the destination image
	      Image& dest,
	      /// the source image
	      const Image& source);





/// \brief Performs a watershed operation.

/// This function performs a watershed operation using the specified source image \a source  and returns the
/// resulting image. The Watershed transformation is mainly used to separate
/// connected components.
/// The principle of the algorithm is to consider the grayvalues in the image 
/// as surface information. The algorithm then "floods" the surface beginning 
/// from the minima and takes care that water from different sources will not 
/// be mixed. The result of this operation are the watershed lines. 
/// The operation time is roughly proportional to the binary size of connected components.
/// \see #WatershedMode
//-----------------------------------------------------------------------------
Image watershed(/// the source image
		const Image& source,
		/// the watershed mode
		WatershedMode mode=wmSplitObjectsMerge,
		/// Specifies the color index of detected 'watershed pixel'. Each 'watershed pixel' is
		/// transfered into the destination buffer using this color index.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int color=0);


/// \brief Performs a watershed operation.

/// This function performs a watershed operation using the specified source image \a source  and writes the
/// resulting image into the destination buffer \a dest. The Watershed transformation is mainly used to separate
/// connected components.
/// The principle of the algorithm is to consider the grayvalues in the image 
/// as surface information. The algorithm then "floods" the surface beginning 
/// from the minima and takes care that water from different sources will not 
/// be mixed. The result of this operation are the watershed lines. 
/// The operation time is roughly proportional to the binary size of connected components.
/// \see #WatershedMode
//-----------------------------------------------------------------------------
void watershed(/// the destination image
	       Image& dest,
	       /// the source image
	       const Image& source,
	       /// the watershed mode
	       WatershedMode mode=wmSplitObjectsMerge,
	       /// Specifies the color index of detected 'watershed pixel'. Each 'watershed pixel' is
	       /// transfered into the destination buffer using this color index.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
		   int color=0);






/// \brief Performs a tophat operation.


/// This function performs a tophat operation and returns the resulting image.
/// - When detecting light objects on a dark background
/// the function is defined as the thresholded difference between the original source image and
/// the (morphologically) opened source image.<br>
/// <br>Destination (x, y) = Threshold[Source(x, y) - Open(x, y)]<br>
/// - When detecting dark objects on a light background the function is defined as the thresholded
/// difference between the (morphologically) closed source image and the original source image.<br>
/// <br>Destination (x, y) = Threshold[Close(x, y) - Source(x, y)]<br>
/// The resulting image will always be a gray scale image.
/// \image html images/mvi_base/MorphTopHat_TopHat.png
/// \see #PolarityMode
//-----------------------------------------------------------------------------
Image tophat(/// the source image
	    const Image& source,
	    /// Specifies the size of the morphological opening or closing operation. If, for
	    /// example, Size is set to 2, two successive erosions followed by two successive
	    /// dilations are performed (in the case of an opening).
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
	    int size=1,
	    /// Specifies the operation mode, i.e. specifies
	    /// if we detect light spots on dark background or vice versa
	    /// Note that pmAuto is not supported here.
	    PolarityMode mode=pmWhiteOnBlack,
		/// Specifies a threshold level, [0..255] for 8-bit images, [0..65535] for 16 bit images.
	    /// All gray values above this threshold will be set to the resulting values of the tophat
	    /// operation. All values below this threshold will be set to 0.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int threshold=127);




/// \brief Performs a tophat operation.


/// This function performs a tophat operation. The resulting image is stored in the
/// destination buffer \a dest.
/// - When detecting light objects on a dark background
/// the function is defined as the thresholded difference between the original source image and
/// the (morphologically) opened source image.<br>
/// <br>Destination (x, y) = Threshold[Source(x, y) - Open(x, y)]<br>
/// - When detecting dark objects on a light background the function is defined as the thresholded
/// difference between the (morphologically) closed source image and the original source image.<br>
/// <br>Destination (x, y) = Threshold[Close(x, y) - Source(x, y)]<br>
/// The destination image will always be a gray scale image.
/// \image html images/mvi_base/MorphTopHat_TopHat.png
/// \see #PolarityMode
//-----------------------------------------------------------------------------
void tophat(/// the destination image
	    Image& dest,
	    /// the source image
	    const Image& source,
	    /// Specifies the size of the morphological opening or closing operation. If, for
	    /// example, Size is set to 2, two successive erosions followed by two successive
	    /// dilations are performed (in the case of an opening).
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int size=1,
	    /// Specifies the operation mode, i.e. specifies
	    /// if we detect light spots on dark background or vice versa
		/// Note that pmAuto is not supported here.
	    PolarityMode mode=pmWhiteOnBlack,
	    /// Specifies a threshold level, [0..255] for 8-bit images, [0..65535} for 16 bit images.
	    /// All gray values above this threshold will be set to the resulting values of the tophat
	    /// operation. All values below this threshold will be set to 0.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int threshold=127);



/// \brief Performs a reconstruction of objects.

/// If one pixel of the marker buffer has a corresponding pixel in an object of the source buffer,
/// the object of the source buffer will be reconstructed and written into the destination buffer
/// (similar to a conditional dilation).
/// All non-zero pixels in the marker buffer are considered to be part of the marker.
/// Parameter \a mode can be given the following values:
/// - momBinary
/// The pixel values in the destination buffer will be set to the maximum that can be
/// represented in this buffer (i.e. 0xFFFF for an 16 bit buffer, 0xFF for a 8 bit buffer).
/// - momGrayscale
/// The pixel values in the destination buffer will be set to the corresponding pixel
/// value of the source buffer (i.e. reconstructing objects from a labeled image will
/// have the same gray values in the resulting buffer).
/// \see #MorphOpMode
//-----------------------------------------------------------------------------
Image reconstruct(/// The source image. All non-zero pixels in this image are
		  /// considered to be object pixels.
		  const Image& source,
		  /// Specifies the marker buffer handle.All non-zero pixels in the
		  /// marker buffer are considered to be part of the marker.
		  const Image& sourceMarker,
		  /// Specifies the operation mode for processing.
		  MorphOpMode mode=momGrayscale);






/// \brief Performs a reconstruction of objects.

/// If one pixel of the marker buffer has a corresponding pixel in an object of the source buffer,
/// the object of the source buffer will be reconstructed and written into the destination buffer \a dest
/// (similar to a conditional dilation).
/// All non-zero pixels in the marker buffer are considered to be part of the marker.
/// Parameter \a mode can be given the following values:
/// - momBinary
/// The pixel values in the destination buffer will be set to the maximum that can be
/// represented in this buffer (i.e. 0xFFFF for an 16 bit buffer, 0xFF for a 8 bit buffer).
/// - momGrayscale
/// The pixel values in the destination buffer will be set to the corresponding pixel
/// value of the source buffer (i.e. reconstructing objects from a labeled image will
/// have the same gray values in the resulting buffer).
/// \see #MorphOpMode
//-----------------------------------------------------------------------------
void reconstruct(/// the destination image
		 Image& dest,
		 /// The source image. All non-zero pixels in this image are
		 /// considered to be object pixels.
		 const Image& source,
		 /// Specifies the marker buffer handle.All non-zero pixels in the
		 /// marker buffer are considered to be part of the marker.
		 const Image& sourceMarker,
		 /// Specifies the operation mode for processing.
		 MorphOpMode mode=momGrayscale);






/// \brief Performs hole filling operation

/// Hole filling is the process of removing areas completely surrounded by other objects.
/// This can be used to clean object defects.
/// The source image must be a binary image.
/// \note Holes cannot touch the image border.
/// \image html images/mvi_base/MorphHoleFill_HoleFill.png
/// \see mvIMPACT::extractHoles
//-----------------------------------------------------------------------------
Image fillHoles(/// The source image. All non-zero pixels in this image are
		/// considered to be object pixels.
		const Image& source);




/// \brief Performs hole filling operation

/// Hole filling is the process of removing areas completely surrounded by other objects.
/// This can be used to clean object defects.
/// The source image must be a binary image. The resulting image is stored in \a dest.
/// \note Holes cannot touch the image border.
/// \image html images/mvi_base/MorphHoleFill_HoleFill.png
/// \see mvIMPACT::extractHoles
//-----------------------------------------------------------------------------
void fillHoles(/// the destination image
	       Image& dest,
	       /// The source image. All non-zero pixels in this image are
	       /// considered to be object pixels.
	       const Image& source);





/// \brief Performs hole extraction on the source image.

/// All holes within objects will be extracted.That means they still will be in the resulting image.
/// The source image must be a binary image.
/// \note Holes cannot touch the image border.
/// \see mvIMPACT::fillHoles
//-----------------------------------------------------------------------------
Image extractHoles(/// The source image. All non-zero pixels in this image are
		   /// considered to be object pixels.
		   const Image& source);


/// \brief Performs hole extraction on the source image.

/// All holes within objects will be extracted.That means they still will be in the resulting image.
/// The source image must be a binary image. The resulting image is stored int the destination buffer \a dest.
/// \note Holes cannot touch the image border.
/// \see mvIMPACT::fillHoles
//-----------------------------------------------------------------------------
void extractHoles(/// the destination image
		  Image& dest,
		  /// The source image. All non-zero pixels in this image are
		  /// considered to be object pixels.
		  const Image& source);




/// \brief Remove areas that reach a specific edge.

/// Border killing is the process of removing areas that reach the edges of the image, i.e. those
/// that are only partially visible.
/// If parameters \a top, \a left, \a bottom and \a right are omitted, all objects that reach any border will be removed.
/// \image html images/mvi_base/MorphBorderKill_BorderKill.png
//-----------------------------------------------------------------------------
Image killBorderObjects(/// The source image. All non-zero pixels in this image are
			/// considered to be object pixels.
			const Image& source,
			/// specifies whether or not to remove objects at the top border
			bool top=true,
			/// specifies whether or not to remove objects at the left border
			bool left=true,
			/// specifies whether or not to remove objects at the bottom border
			bool bottom=true,
			/// specifies whether or not to remove objects at the right border
			bool right=true);



/// \brief Remove areas that reach a specific edge.

/// Border killing is the process of removing areas that reach the edges of the image, i.e. those
/// that are only partially visible.
/// The resulting image will be stored in the destination buffer \a dest.
/// If parameters \a top, \a left, \a bottom and \a right are omitted, all objects that reach any border will be removed.
/// \image html images/mvi_base/MorphBorderKill_BorderKill.png
//-----------------------------------------------------------------------------
void killBorderObjects(/// the destination image
		       Image& dest,
		       /// The source image. All non-zero pixels in this image are
		       /// considered to be object pixels.
		       const Image& source,
			/// specifies whether or not to remove objects at the top border
		       bool top=true,
			/// specifies whether or not to remove objects at the left border
		       bool left=true,
			/// specifies whether or not to remove objects at the bottom border
		       bool bottom=true,
			/// specifies whether or not to remove objects at the right border
		       bool right=true);





/// \brief Perform a rank filter operation

/// A rank filter sorts the pixel values in increasing order and assigns the center pixel the value of
/// a given index. Three ranks are of particular interest:
/// -  the first index corresponds to the minimum value, i.e. the darkest pixel. This choice
/// corresponds to the erosion operation, as described below.
/// -  the last index corresponds to the maximum value, i.e. the lightest pixel. This choices
/// corresponds to dilation, the dual of erosion.
/// -  the middle index corresponds to the "most central" value, i.e. the closer to normal. This
/// form of processing, known as the median filtering, is well known for its capability to
/// remove impulse noise while preserving edges.
///
/// Typically, a rank filter
/// is used to remove noise (sometimes called 'salt and pepper' noise) from an image.
/// image html images/mvi_base/RankMedian.png
///
/// This function performs a rank filter operation using the specified source image \a source  and structuring
/// element \a se and returns the resulting image.
/// In the case of a multidimensional buffer, the same
/// structuring element will be applied to every plane.
///
/// If you want to use a default kernel with median filtering, see
/// rankFilter(const Image&,StockStructuringElement,MorphOpMode)
Image rankFilter(/// the source image
		const Image& source,
		/// The structuring element used for the operation.
		const StructuringElement &se,
		/// Defines which pixel to select after the rank operation (the pixels are sorted in
		/// increasing order). It can be given a value between 1 and the number of
		/// neighborhood pixels considered in the operation (i.e. the  number of "1"s in the structuring element \a se).
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="getCountElementsOfOne(%(se)s)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int rankIndex,
		/// Determines the processing mode of the function.
		MorphOpMode mode=momGrayscale
		);



/// \brief Perform a rank filter operation

/// A rank filter sorts the pixel values in increasing order and assigns the center pixel the value of
/// a given index. Three ranks are of particular interest:
/// -  the first index corresponds to the minimum value, i.e. the darkest pixel. This choice
/// corresponds to the erosion operation, as described below.
/// -  the last index corresponds to the maximum value, i.e. the lightest pixel. This choices
/// corresponds to dilation, the dual of erosion.
/// -  the middle index corresponds to the "most central" value, i.e. the closer to normal. This
/// form of processing, known as the median filtering, is well known for its capability to
/// remove impulse noise while preserving edges.
///
/// Typically, a rank filter
/// is used to remove noise (sometimes called 'salt and pepper' noise) from an image.
/// image html images/mvi_base/RankMedian.png
///
/// This function performs a rank filter operation using the specified source image \a source  and structuring
/// element \a se and stores the resulting image in the destination buffer \a dest. The source and destination image must
/// have the same properties (bands, z-slices, time-slices).
/// In the case of a multidimensional buffer, the same
/// structuring element will be applied to every plane.
///
/// If you want to use a default kernel with median filtering, see
/// rankFilter(Image&,const Image&,StockStructuringElement,MorphOpMode)
void rankFilter(
		/// the destination image
		Image& dest,
		/// the source image
		const Image& source,
		/// The structuring element used for the operation.
		const StructuringElement &se,
		/// Defines which pixel to select after the rank operation (the pixels are sorted in
		/// increasing order). It can be given a value between 1 and the number of
		/// neighborhood pixels considered in the operation (i.e. the  number of "1"s in the structuring element \a se).
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="getCountElementsOfOne(%(se)s)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int rankIndex,
		/// Determines the processing mode of the function.
		MorphOpMode mode=momGrayscale
		);



/// \brief Perform a rank filter operation with a predefined structuring element

/// A rank filter sorts the pixel values in increasing order and assigns the center pixel the value of
/// a given index. Three ranks are of particular interest:
/// -  the first index corresponds to the minimum value, i.e. the darkest pixel. This choice
/// corresponds to the erosion operation, as described below.
/// -  the last index corresponds to the maximum value, i.e. the lightest pixel. This choices
/// corresponds to dilation, the dual of erosion.
/// -  the middle index corresponds to the "most central" value, i.e. the closer to normal. This
/// form of processing, known as the median filtering, is well known for its capability to
/// remove impulse noise while preserving edges.
///
/// Typically, a rank filter
/// is used to remove noise (sometimes called 'salt and pepper' noise) from an image.
/// image html images/mvi_base/RankMedian.png
///
/// This function performs a rank filter operation using the specified source image \a source  and predefined structuring
/// element \a se and stores the resulting image in the destination buffer \a dest. The source and destination image must
/// have the same properties (bands, z-slices, time-slices).
/// In the case of a multidimensional buffer, the same
/// structuring element will be applied to every plane.
///
/// Parameter \a se can be set to one of the
/// following predefined structuring elements:
/// - sseSquare
/// - sseCross
///
/// With Predefined structuring elements the median is always used as the abovementioned index.
/// \see #StockStructuringElement
/// \see #MorphOpMode
void rankFilter(
		/// the destination image
		Image& dest,
		/// the source image
		const Image& source,
		/// The predefined structuring element used for the operation.
		StockStructuringElement se,
		/// Determines the processing mode of the function.
		MorphOpMode mode=momGrayscale
		);


/// \brief Perform a rank filter operation with a predefined structuring element

/// A rank filter sorts the pixel values in increasing order and assigns the center pixel the value of
/// a given index. Three ranks are of particular interest:
/// -  the first index corresponds to the minimum value, i.e. the darkest pixel. This choice
/// corresponds to the erosion operation, as described below.
/// -  the last index corresponds to the maximum value, i.e. the lightest pixel. This choices
/// corresponds to dilation, the dual of erosion.
/// -  the middle index corresponds to the "most central" value, i.e. the closer to normal. This
/// form of processing, known as the median filtering, is well known for its capability to
/// remove impulse noise while preserving edges.
///
/// Typically, a rank filter
/// is used to remove noise (sometimes called 'salt and pepper' noise) from an image.
/// image html images/mvi_base/RankMedian.png
///
/// This function performs a rank filter operation using the specified source image \a source  and predefined structuring
/// element \a se and returns the resulting image.
/// In the case of a multidimensional buffer, the same
/// structuring element will be applied to every plane.
///
/// Parameter \a se can be set to one of the
/// following predefined structuring elements:
/// - sseSquare
/// - sseCross
///
/// With predefined structuring elements the median is always used as the abovementioned index.
/// \see #StockStructuringElement
/// \see #MorphOpMode
Image rankFilter(
		/// the source image
		const Image& source,
		/// The predefined structuring element used for the operation.
		StockStructuringElement se,
		/// Determines the processing mode of the function.
		MorphOpMode mode=momGrayscale
		);



/// \brief Perform a thickening operation
///
/// This function performs a binary or grayscale thickening operation using the specified source
/// buffer and structuring element buffer and writes the results into the specified destination
/// buffer.
/// If a binary thickening is performed, the values can be set to \c -1, \c 0 and \c 1.
/// Neighborhood pixel specified with -1 in the structuring element are not
/// considered during the operation. If the structuring element matches with the corresponding
/// neighborhood pixels exactly, the center pixel is set to \c 1, otherwise it remains unchanged.
/// If a grayscale thickening is performed, the values of the structuring element can be set to
/// \c -1, \c 0 and \c 1. The center pixel is set if the following condition is true:
/// \verbatim
/// if MAX(0) <= center pixel < MIN(1)
/// center pixel = MIN(1)
/// else
/// center pixel is left unchanged.
/// \endverbatim
/// This means, that the value of the center pixel will change, if its value lies between the largest
/// value of points corresponding to 0 in the structuring element (MAX(0)) and the smallest value
/// of points corresponding to 1 in the structuring element (MIN(1)).
/// Here are some useful structuring elements:
///
/// <b>Getting the skeleton by zone of influence (background thinning)</b>
///
/// \verbatim
/// 0 0 0
/// x 0 x
/// 1 1 1
/// \endverbatim
/// followed by
/// \verbatim
/// 0 x 0
/// x 0 x
/// 1 1 1
/// \endverbatim
/// Required function call for first structuring element:
/// \code
/// thick(SrcId, DestId, StrELId1, imConvergence, momBinary, rmRotateIteration)
/// \endcode
/// Required function call for second structuring element:
/// \code
/// thick(SrcId, DestId, StrELId2, imConvergence, momBinary, rmRotateIteration)
/// \endcode
/// The thickening is performed with the first configuration and all its rotations until convergence
/// and then with the second configuration and all its rotations until convergence. The structuring
/// element must consist of multiple time-slices. Each time-slice of StrElIdx must contain a
/// structuring element rotated by 45 degrees (requires 8 time-slices).
///
/// <b>Removing prunes from a skeleton by zone of influence</b>
///
/// \verbatim
/// 1 1 1
/// 1 0 1
/// 1 x x
/// \endverbatim
/// followed by
/// \verbatim
/// 1 1 1
/// 1 0 1
/// x 1 x
/// \endverbatim
/// Required function call for first structuring element:
/// \code
/// thick(SrcId, DestId, StrELId1, imConvergence, momBinary, rmRotateIteration)
/// \endcode
/// Required function call for second structuring element:
/// \code
/// thick(SrcId, DestId, StrELId2, imConvergence, momBinary, rmRotateIteration)
/// \endcode
/// This structuring element is useful to eliminate artifacts (also called prunes) after a skeleton
/// thickening operation. The skeleton is very sensitive to small distortions on the edges of the
/// object. The only problem that can occur, is to find the number of iterations for pruning.
/// Thinning until convergence will remove all the skeletons except loops and branches. It is
/// sometimes better to do the pruning with a finite number of iterations. The structuring element
/// must consist of multiple time-slices. Each time-slice of StrElIdx must contain a structuring
/// element rotated by 45 degrees (requires 8 time-slices).
///
/// <b>Getting the quasi convex hull</b>
///
/// \verbatim
/// 1 x x
/// 1 0 0
/// 1 1 x
/// \endverbatim
/// followed by
/// \verbatim
/// x 1 x
/// 1 0 0
/// x 1 x
/// \endverbatim
/// Required function call for first structuring element:
/// \code
/// thick(SrcId, DestId, StrELId1, imConvergence, momBinary, rmRotateIteration)
/// \endcode
/// Required function call for second structuring element:
/// \code
/// thick(SrcId, DestId, StrELId2, imConvergence, momBinray, rmRotateIteration)
/// \endcode
/// The structuring element must consist of multiple time-slices. Each time-slice of StrElIdx must
/// contain a structuring element rotated by 45 degrees (requires 8 time-slices).
///
/// <b>Getting the quasi convex hull (faster then the above method) </b>
///
/// \verbatim
/// 1 x x
/// 1 0 x
/// 1 x x
/// \endverbatim
/// Required function call:
/// \code
/// thick(SrcId, DestId, StrELId, imConvergence, momBinary, rmRotateIteration)
/// \endcode
/// The structuring element must consist of multiple time-slices. Each time-slice of StrElIdx must
/// contain a structuring element rotated by 90 degrees (requires 4 time-slices).
/// In the case of a multidimensional buffer, the same structuring element will be applied to every
/// plane. The source and destination buffer must have the same properties (bands, z-slices,
/// time-slices aso...).
///
/// The parameter rotateMode only applies for structuring elements of
/// size 3x3. Otherwise no rotation is done and the value of rotation mode
/// is ignored.
Image thick(
	    /// the source image
	    const Image& source,
	    /// the structuring element used for thickening
	    const StructuringElement& K,
	    /// number of iterations or imConvergence to iterate until no change
	    /// occurs any more
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int iterations=1,
	    /// Determines the processing mode of the function.
        MorphOpMode morphOpMode=momGrayscale,
	    /// Determines if and when to rotate the structuring element given with K.
	    /// Only applies for structuring elements of size 3x3.
	    RotationMode rotateMode=rmRotateIteration   );


/// \brief Perform a thickening operation
///
/// This function performs a binary or grayscale thickening operation using the specified source
/// buffer and structuring element buffer and writes the results into the specified destination
/// buffer.
/// If a binary thickening is performed, the values can be set to -1, 0 and 1.
/// Neighborhood pixel specified with -1 in the structuring element are not
/// considered during the operation. If the structuring element matches with the corresponding
/// neighborhood pixels exactly, the center pixel is set to 1, otherwise it remains unchanged.
/// If a grayscale thickening is performed, the values of the structuring element can be set to
/// -1, 0 and 1. The center pixel is set if the following condition is true:
/// \verbatim
/// if MAX(0) <= center pixel < MIN(1)
/// center pixel = MIN(1)
/// else
/// center pixel is left unchanged.
/// \endverbatim
/// This means, that the value of the center pixel will change, if its value lies between the largest
/// value of points corresponding to 0 in the structuring element (MAX(0)) and the smallest value
/// of points corresponding to 1 in the structuring element (MIN(1)).
/// Here are some useful structuring elements:
///
/// <b>Getting the skeleton by zone of influence (background thinning)</b>
///
/// \verbatim
/// 0 0 0
/// x 0 x
/// 1 1 1
/// \endverbatim
/// followed by
/// \verbatim
/// 0 x 0
/// x 0 x
/// 1 1 1
/// \endverbatim
/// Required function call for first structuring element:
/// \code
/// thick(SrcId, DestId, StrELId1, imConvergence, momBinary, rmRotateIteration)
/// \endcode
/// Required function call for second structuring element:
/// \code
/// thick(SrcId, DestId, StrELId2, imConvergence, momBinary, rmRotateIteration)
/// \endcode
/// The thickening is performed with the first configuration and all its rotations until convergence
/// and then with the second configuration and all its rotations until convergence. The structuring
/// element must consist of multiple time-slices. Each time-slice of StrElIdx must contain a
/// structuring element rotated by 45 degrees (requires 8 time-slices).
///
/// <b>Removing prunes from a skeleton by zone of influence</b>
///
/// \verbatim
/// 1 1 1
/// 1 0 1
/// 1 x x
/// \endverbatim
/// followed by
/// \verbatim
/// 1 1 1
/// 1 0 1
/// x 1 x
/// \endverbatim
/// Required function call for first structuring element:
/// \code
/// thick(SrcId, DestId, StrELId1, imConvergence, momBinary, rmRotateIteration)
/// \endcode
/// Required function call for second structuring element:
/// \code
/// thick(SrcId, DestId, StrELId2, imConvergence, momBinary, rmRotateIteration)
/// \endcode
/// This structuring element is useful to eliminate artifacts (also called prunes) after a skeleton
/// thickening operation. The skeleton is very sensitive to small distortions on the edges of the
/// object. The only problem that can occur, is to find the number of iterations for pruning.
/// Thinning until convergence will remove all the skeletons except loops and branches. It is
/// sometimes better to do the pruning with a finite number of iterations. The structuring element
/// must consist of multiple time-slices. Each time-slice of StrElIdx must contain a structuring
/// element rotated by 45 degrees (requires 8 time-slices).
///
/// <b>Getting the quasi convex hull</b>
///
/// \verbatim
/// 1 x x
/// 1 0 0
/// 1 1 x
/// \endverbatim
/// followed by
/// \verbatim
/// x 1 x
/// 1 0 0
/// x 1 x
/// \endverbatim
/// Required function call for first structuring element:
/// \code
/// thick(SrcId, DestId, StrELId1, imConvergence, momBinary, rmRotateIteration)
/// \endcode
/// Required function call for second structuring element:
/// \code
/// thick(SrcId, DestId, StrELId2, imConvergence, momBinray, rmRotateIteration)
/// \endcode
/// The structuring element must consist of multiple time-slices. Each time-slice of StrElIdx must
/// contain a structuring element rotated by 45 degrees (requires 8 time-slices).
///
/// <b>Getting the quasi convex hull (faster then the above method) </b>
///
/// \verbatim
/// 1 x x
/// 1 0 x
/// 1 x x
/// \endverbatim
/// Required function call:
/// \code
/// thick(SrcId, DestId, StrELId, imConvergence, momBinary, rmRotateIteration)
/// \endcode
/// The structuring element must consist of multiple time-slices. Each time-slice of StrElIdx must
/// contain a structuring element rotated by 90 degrees (requires 4 time-slices).
/// In the case of a multidimensional buffer, the same structuring element will be applied to every
/// plane. The source and destination buffer must have the same properties (bands, z-slices,
/// time-slices aso...).
///
/// The parameter rotateMode only applies for structuring elements of
/// size 3x3. Otherwise no rotation is done and the value of rotation mode
/// is ignored.
void thick(
            /// the destination image
	    Image& dest,
	    /// the source image
	    const Image& source,
	    /// the structuring element used for thickening
	    const StructuringElement& K,
	    /// number of iterations or imConvergence to iterate until no change
	    /// occurs any more
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int iterations=1,
	    /// Determines the processing mode of the function.
        MorphOpMode morphOpMode=momGrayscale,
	    /// Determines if and when to rotate the structuring element given with K
	    RotationMode rotateMode=rmRotateIteration   );




/// \brief Perform a thinning operation
///
/// This function performs a binary or grayscale thinning operation using the specified source
/// buffer and structuring element buffer and writes the results in the specified destination buffer.
/// If a binary thinning will be performed, the values of the structuring element can be set to
/// -1, 0 and 1. Neighborhood pixels specified with -1 in the
/// structuring element are not considered during the operation.
/// If all structuring elements match with all corresponding neighborhood pixels exactly, the
/// center pixel is set to 0, otherwise it remains unchanged.
/// If a grayscale thinning will be performed, the values of the structuring element can be set to
/// -1, 0 and 1. The center pixel will be set if the following condition is true:
/// \verbatim
/// if MAX(0) < center pixel <= MIN(1)
/// center pixel = MAX(0)
/// else
/// center pixel is left unchanged.
/// \endverbatim
/// This means, that the value of the center pixel will change, if its value lies between the largest
/// value of points corresponding to 0 in the structuring element (MAX(0)) and the smallest value
/// of points corresponding to 1 in the structuring element (MIN(1)).
/// Here are some useful structuring elements:
///
/// <b>Getting the object border</b>
///
/// \verbatim
/// 1 1 1
/// 1 1 1
/// 1 1 1
/// \endverbatim
/// Required function call:
/// \code
/// thin (SrcId, DestId, StrELId, 1, momBinary, rmDoNotRotate)
/// \endcode
///
/// <b>Getting the skeleton of an object</b>
///
/// \verbatim
/// 1 1 1
/// x 1 x
/// 0 0 0
/// \endverbatim
/// followed by
/// \verbatim
/// 1 x 1
/// x 1 x
/// 0 0 0
/// \endverbatim
/// Required function call for first structuring element:
/// \code
/// thin (SrcId, DestId, StrELId1, imConvergence, momBinary, rmRotateIteration)
/// \endcode
/// Required function call for second structuring element:
/// \code
/// thin (SrcId, DestId, StrELId2, imConvergence, momBinary, rmRotateIteration)
/// \endcode
/// Thinning is performed with the first configuration and all its rotations until convergence and
/// then with the second configuration and all its rotations until convergence. The structuring
/// element buffer must consist of multiple time-slices. Each time-slice of StrElIdx must contain
/// a structuring element rotated by 45 degrees (requires 8 time-slices).
///
/// <b>Removing prunes from a skeleton</b>
///
/// \verbatim
/// 0 0 0
/// 0 1 0
/// 0 x x
/// \endverbatim
/// followed by
/// \verbatim
/// 0 0 0
/// 0 1 0
/// x 0 x
/// \endverbatim
/// Required function call for first structuring element:
/// \code
/// thin (SrcId, DestId, StrELId1, imConvergence, momBinary, rmRotateIteration)
/// \endcode
/// Required function call for second structuring element:
/// \code
/// thin (SrcId, DestId, StrELId2,imConvergence, momBinary, rmRotateIteration)
/// \endcode
/// This structuring element is useful to eliminate artifacts also called "prunes" after a skeleton
/// thinning operation. The skeleton is very sensitive to small distortions on the edges of the
/// object. The only problem that can occur, is to find the number of iterations for the pruning.
/// Thinning until convergence will remove all the skeletons except loops and branches. It is
/// sometimes better to do the pruning (rotating the E-type structuring element) with a finite
/// number of iterations. The structuring element buffer must consist of multiple time-slices.
/// Each time-slice of StrElIdx must contain a structuring element rotated by 45 degrees (requires 8
/// time-slices).
/// In the case of a multidimensional buffer, the same structuring element will be applied to every
/// plane. The source and destination buffer must have the same properties (bands, z-slices,
/// time-slices aso...).
///
/// The parameter rotateMode only applies for structuring elements of
/// size 3x3. Otherwise no rotation is done and the value of rotation mode
/// is ignored.
Image thin(
	    /// the source image
	    const Image& source,
	    /// the structuring element used for thinning
	    const StructuringElement& K,
	    /// number of iterations or imConvergence to iterate until no change
	    /// occurs any more
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int iterations=1,
	    /// Determines the processing mode of the function.
        MorphOpMode morphOpMode=momGrayscale,
	    /// Determines if and when to rotate the structuring element given with K
	    RotationMode rotateMode=rmRotateIteration   );


/// \brief Perform a thinning operation
///
/// This function performs a binary or grayscale thinning operation using the specified source
/// buffer and structuring element buffer and writes the results in the specified destination buffer.
/// If a binary thinning will be performed, the values of the structuring element can be set to
/// -1, 0 and 1. Neighborhood pixels specified with -1 in the
/// structuring element are not considered during the operation.
/// If all structuring elements match with all corresponding neighborhood pixels exactly, the
/// center pixel is set to 0, otherwise it remains unchanged.
/// If a grayscale thinning will be performed, the values of the structuring element can be set to
/// -1, 0 and 1. The center pixel will be set if the following condition is true:
/// \verbatim
/// if MAX(0) < center pixel <= MIN(1)
/// center pixel = MAX(0)
/// else
/// center pixel is left unchanged.
/// \endverbatim
/// This means, that the value of the center pixel will change, if its value lies between the largest
/// value of points corresponding to 0 in the structuring element (MAX(0)) and the smallest value
/// of points corresponding to 1 in the structuring element (MIN(1)).
/// Here are some useful structuring elements:
///
/// <b>Getting the object border</b>
///
/// \verbatim
/// 1 1 1
/// 1 1 1
/// 1 1 1
/// \endverbatim
/// Required function call:
/// \code
/// thin (SrcId, DestId, StrELId, 1, momBinary, rmDoNotRotate)
/// \endcode
///
/// <b>Getting the skeleton of an object</b>
///
/// \verbatim
/// 1 1 1
/// x 1 x
/// 0 0 0
/// \endverbatim
/// followed by
/// \verbatim
/// 1 x 1
/// x 1 x
/// 0 0 0
/// \endverbatim
/// Required function call for first structuring element:
/// \code
/// thin (SrcId, DestId, StrELId1, imConvergence, momBinary, rmRotateIteration)
/// \endcode
/// Required function call for second structuring element:
/// \code
/// thin (SrcId, DestId, StrELId2, imConvergence, momBinary, rmRotateIteration)
/// \endcode
/// Thinning is performed with the first configuration and all its rotations until convergence and
/// then with the second configuration and all its rotations until convergence. The structuring
/// element buffer must consist of multiple time-slices. Each time-slice of StrElIdx must contain
/// a structuring element rotated by 45 degrees (requires 8 time-slices).
///
/// <b>Removing prunes from a skeleton</b>
///
/// \verbatim
/// 0 0 0
/// 0 1 0
/// 0 x x
/// \endverbatim
/// followed by
/// \verbatim
/// 0 0 0
/// 0 1 0
/// x 0 x
/// \endverbatim
/// Required function call for first structuring element:
/// \code
/// thin (SrcId, DestId, StrELId1, imConvergence, momBinary, rmRotateIteration)
/// \endcode
/// Required function call for second structuring element:
/// \code
/// thin (SrcId, DestId, StrELId2,imConvergence, momBinary, rmRotateIteration)
/// \endcode
/// This structuring element is useful to eliminate artifacts also called "prunes" after a skeleton
/// thinning operation. The skeleton is very sensitive to small distortions on the edges of the
/// object. The only problem that can occur, is to find the number of iterations for the pruning.
/// Thinning until convergence will remove all the skeletons except loops and branches. It is
/// sometimes better to do the pruning (rotating the E-type structuring element) with a finite
/// number of iterations. The structuring element buffer must consist of multiple time-slices.
/// Each time-slice of StrElIdx must contain a structuring element rotated by 45 degrees (requires 8
/// time-slices).
/// In the case of a multidimensional buffer, the same structuring element will be applied to every
/// plane. The source and destination buffer must have the same properties (bands, z-slices,
/// time-slices aso...).
///
/// The parameter rotateMode only applies for structuring elements of
/// size 3x3. Otherwise no rotation is done and the value of rotation mode
/// is ignored.
void thin(
            /// the destination image
	    Image& dest,
	    /// the source image
	    const Image& source,
	    /// the structuring element used for thinning
	    const StructuringElement& K,
	    /// number of iterations or imConvergence to iterate until no change
	    /// occurs any more
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int iterations=1,
	    /// Determines the processing mode of the function.
        MorphOpMode morphOpMode=momGrayscale,
	    /// Determines if and when to rotate the structuring element given with K
	    RotationMode rotateMode=rmRotateIteration);


/// \brief Counts number of 1's in a stock structuring element.
///
/// Counts the number of 1's in a stock structuring element.
int getCountElementsOfOne(
			/// The stock structuring element to use.
			StockStructuringElement se);

/// \brief Counts number of 1's in a custom structuring element.
///
/// Counts the number of 1's in a custom structuring element.
int getCountElementsOfOne(const StructuringElement& se);


/// \brief Perform a luminance scaling of an image
///
/// This function converts the source image \c S to the destination image, adding
/// the offset to the pixel values and then multiplying with the gain.
/// If you pass smClip in the \c mode parameter, the results will be saturated, results higher than
/// the maximal value allowed for the datatype will be clipped to the maximal value, results
/// lower than the minimal value allowed for the datatype will be clipped to the minimal value.
/// Any other value passed within the \c mode parameter will cause higher bits of the results to be
/// discarded.
Image scaleLuminance(
	/// The source image
	const Image& source,
	/// The offset added to each pixel before multiplying with gain
	double offset,
	/// The gain each pixel is multiplied with after adding offset
	double gain,
	/// The clipping mode used
	SaturationMode mode=smSaturate);


/// \brief Perform a luminance scaling of an image
///
/// This function converts the source image \c S to the destination image \c D, adding
/// the offset to the pixel values and then multiplying with the gain.
/// If you pass smClip in the \c mode parameter, the results will be saturated, results higher than
/// the maximal value allowed for the datatype will be clipped to the maximal value, results
/// lower than the minimal value allowed for the datatype will be clipped to the minimal value.
/// Any other value passed within the \c mode parameter will cause higher bits of the results to be
/// discarded.
void scaleLuminance(
	/// The destinamtion image image
	Image& dest,
	/// The source image
	const Image& source,
	/// The offset added to each pixel before multiplying with gain
	double offset,
	/// The gain each pixel is multiplied with after adding offset
	double gain,
	/// The clipping mode used
	SaturationMode mode=smSaturate);



/// \brief Generate a mvIMPACT::Palette.

/// This function generates a linear palette between two points. The coordinates of the
/// two points specify the end points of the ramp (inclusive).All results are truncated to unsigned
/// integer before they are written into the palette buffer.
/// The function will allocate a destination mvIMPACT::Palette with 256
/// entries and datatype "dbUChar".
///
///
/// Example:
/// <pre>
/// Palette p = generateRampPalette(Point(0,255),Point(255,0));
/// </pre>
/// This creates a palette that can be used to invert grayscale images.
/// \see mvIMPACT::Point
/// \see mvIMPACT::Palette
/// \see mvIMPACT::generatePalette
/// \see mvIMPACT::generateShufflePalette
/// \see mvIMPACT::generateThresholdPalette
//-----------------------------------------------------------------------------
Palette generateRampPalette(
			    /// The start point of the ramp. The x-coordinate specifies the start index.
			    /// The y-coordinate specifies the start intensity.
			    const Point& from,
			    /// The end point of the ramp. The x-coordinate specifies the end index.
			    /// The y-coordinate specifies the end intensity.
			    const Point& to);





/// \brief Generate a mvIMPACT::Palette.

/// This function generates a linear palette between two points. The coordinates of the
/// two points specify the end points of the ramp (inclusive).All results are truncated to unsigned
/// integer before they are written into the palette buffer.
///
/// \see mvIMPACT::Point
/// \see mvIMPACT::Palette
/// \see mvIMPACT::generatePalette
/// \see mvIMPACT::generateShufflePalette
/// \see mvIMPACT::generateThresholdPalette
//-----------------------------------------------------------------------------
void generateRampPalette(
			 /// The destination palette.
			 Palette& D,
			 /// The start point of the ramp. The x-coordinate specifies the start index.
			 /// The y-coordinate specifies the start intensity.
			 const Point& from,
			 /// The end point of the ramp. The x-coordinate specifies the end index.
			 /// The y-coordinate specifies the end intensity.
			 const Point& to);





/// \brief Generate a mvIMPACT::Palette.

/// This function generates a non-linear palette between two points.
/// The coordinates of the two points specify the end points of the ramp (inclusive).
/// The intensity values are transformed using a predefined function.
/// All results are
/// truncated to unsigned integer before they are written into the resulting mvIMPACT::Palette. The palette data will
/// always be treated as unsigned.
/// \see mvIMPACT::Point
/// \see mvIMPACT::Palette
/// \see #Segment
/// \see mvIMPACT::generatePalette
/// \see mvIMPACT::generateShufflePalette
/// \see mvIMPACT::generateThresholdPalette
//-----------------------------------------------------------------------------
Palette generateRampPalette(
			    /// The type of function used to calculate palette entries.
			    Segment function,
			    /// The start point of the ramp. The x-coordinate specifies the start index.
			    /// The y-coordinate specifies the start intensity.
			    const Point& from,
			    /// The end point of the ramp. The x-coordinate specifies the end index.
			    /// The y-coordinate specifies the end intensity.
			    const Point& to);





/// \brief Generate a mvIMPACT::Palette.

/// This function generates a non-linear palette between two points and stores it into teh destination palette \a dest.
/// The coordinates of the two points specify the end points of the ramp (inclusive).
/// The intensity values are transformed using a predefined function.
/// All results are
/// truncated to unsigned integer before they are written into the resulting mvIMPACT::Palette. The palette data will
/// always be treated as unsigned.
/// \see mvIMPACT::Point
/// \see mvIMPACT::Palette
/// \see #Segment
/// \see mvIMPACT::generatePalette
/// \see mvIMPACT::generateShufflePalette
/// \see mvIMPACT::generateThresholdPalette
//-----------------------------------------------------------------------------
void generateRampPalette(
			 /// The destination palette.
			 Palette& D,
			 /// The type of function used to calculate palette entries.
			 Segment function,
			 /// The start point of the ramp. The x-coordinate specifies the start index.
			 /// The y-coordinate specifies the start intensity.
			 const Point& from,
			 /// The end point of the ramp. The x-coordinate specifies the end index.
			 /// The y-coordinate specifies the end intensity.
			 const Point& to);





/// \brief Generate a Palette.

/// This function uses luminance, gamma and contrast to generate palette entries. All results are
/// truncated to unsigned integer before they are written into the palette buffer. The palette data
/// will always be treated as unsigned.The palette will be calculated as follows:<br>
/// \image html images/mvi_base/GeneratePalette.png
/// where
/// <pre>
/// Y(x) is the palette entry at position x
/// W is the number of palette entries that will be set as sepcified with parameter \a width (256 for a 8-bit palette)
/// H is the maximal value a palette entry can have as specified with parameter \a height (256 for a 8-bit palette)
/// Contrast is tan((\a contrast*Pi)/200)
/// Luminance is (\a luminance*(((\a width-1)*2)/100) - (\a width-1)
/// </pre>
/// You can generate a linear ramp with the following values: contrast=50, luminance=50,
/// gamma=1.0.
///
/// \see mvIMPACT::generateRampPalette
/// \see mvIMPACT::generateShufflePalette
/// \see mvIMPACT::generateThresholdPalette
//-----------------------------------------------------------------------------
 Palette generatePalette(
	/// Specifies the number of palette entries that will be set (i.e. a 8-bit buffer has a width of
	/// 256. If a value > 256 is given here a palette with 65535 entries will be generated).
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
	/// </mvParamRange>
	/// \endxmlonly
	int width,
	/// Specifies the maximal value a palette entry can have (i.e. a 8-bit buffer has a height
	/// of 256).
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
	/// </mvParamRange>
	/// \endxmlonly
	int height,
	/// Specifies the luminance. Value range [0..100].
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	/// <mvParamMax><mvParamConst value="100"/></mvParamMax>
	/// <mvParamStep>0.1</mvParamStep>
	/// </mvParamRange>
	/// \endxmlonly
	double luminance,
	/// Specifies the contrast. Value range [0..100].
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	/// <mvParamMax><mvParamConst value="100"/></mvParamMax>
	/// <mvParamStep>0.1</mvParamStep>
	/// </mvParamRange>
	/// \endxmlonly
	double contrast,
	/// Specifies the gamma-factor. Value range [0.01..100.0].
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="0.01"/></mvParamMin>
	/// <mvParamMax><mvParamConst value="100.0"/></mvParamMax>
	/// <mvParamStep>0.01</mvParamStep>
	/// </mvParamRange>
	/// \endxmlonly
	double gamma = 1.0);






/// \brief Generate a Palette.

/// This function uses luminance, gamma and contrast to generate palette entries. All results are
/// truncated to unsigned integer before they are written into the palette buffer. The palette data
/// will always be treated as unsigned.The palette will be calculated as follows:<br>
/// \image html images/mvi_base/GeneratePalette.png
/// where
/// <pre>
/// Y(x) is the palette entry at position x
/// W is the number of palette entries that will be set as sepcified with parameter \a width (256 for a 8-bit palette)
/// H is the maximal value a palette entry can have as specified with parameter \a height (256 for a 8-bit palette)
/// Contrast is tan((\a contrast*Pi)/200)
/// Luminance is (\a luminance*(((\a width-1)*2)/100) - (\a width-1)
/// </pre>
/// The resulting palette will be stored in the destination palette \a dest.
/// You can generate a linear ramp with the following values: contrast=50, luminance=50,
/// gamma=1.0.
///
/// \see mvIMPACT::generateRampPalette
/// \see mvIMPACT::generateShufflePalette
/// \see mvIMPACT::generateThresholdPalette
//-----------------------------------------------------------------------------
 void generatePalette(
	/// Specifies the destination palette.
	Palette& D,
	/// Specifies the number of palette entries that will be set (i.e. a 8-bit buffer has a width of
	/// 256. If a value > 256 is given here a palette with 65535 entries will be generated).
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
	/// </mvParamRange>
	/// \endxmlonly
	int width,
	/// Specifies the maximal value a palette entry can have (i.e. a 8-bit buffer has a height
	/// of 256).
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
	/// </mvParamRange>
	/// \endxmlonly
	int height,
	/// Specifies the luminance. Value range [0..100].
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	/// <mvParamMax><mvParamConst value="100"/></mvParamMax>
	/// <mvParamStep>0.1</mvParamStep>
	/// </mvParamRange>
	/// \endxmlonly
	double luminance,
	/// Specifies the contrast. Value range [0..100].
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
	/// <mvParamMax><mvParamConst value="100"/></mvParamMax>
	/// <mvParamStep>0.1</mvParamStep>
	/// </mvParamRange>
	/// \endxmlonly
	double contrast,
	/// Specifies the gamma-factor. Value range [0.01..100.0].
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="0.01"/></mvParamMin>
	/// <mvParamMax><mvParamConst value="100.0"/></mvParamMax>
	/// <mvParamStep>0.01</mvParamStep>
	/// </mvParamRange>
	/// \endxmlonly
	double gamma = 1.0);





/// \brief Generate a palette for bitplane shuffling.

/// This function calculates a palette that can be applied to images with the mapLut()
/// function for the purpose of shuffling bitplanes around.<br>
/// A drawing should explain this further:
/// \image html images/mvi_base/GenerateShufflePalette1.png
/// In this example, the bitplanes 0 and 1 of the source image are copied to bitplanes 6 and 7 of
/// the destination image. The function calculates and presets the shuffle palette in a way that this
/// transformation can be executed.<br>
/// The \a shuffle parameter specifies how bitplanes are moved around. The table should
/// illustrate this:
/// \image html images/mvi_base/GenerateShufflePalette2.png
/// This table specifies that bitplane 0 of the source is moved to bitplane 6 of the destination.
/// Likewise, bitplane 1 of the source is moved to bitplane 7 of the destination. The \a shuffle
/// parameter is a std::vector of mvIMPACT::Shuffle objects with at least one and at most 16 entries.
/// The from and to entries in the mvIMPACT::Shuffle objects may range from 0 to 15 (the
/// maximum number of bitplanes in a 16 bit image).<br>
/// The size and datatype of the resulting mvIMPACT::Palette is calculated from the values in this
/// mvIMPACT::Shuffle vector. If any \c from value in the vector is at least 8 or higher, a palette with
/// 65536 entries (16 bit in) will be used, otherwise a palette with 256 entries (8 bit in) will be
/// used. If any \c to value in the vector is at least 8 or higher, a palette with \c bdUShort
/// datatype (16 bit out) will be used, otherwise a palette with \c bdUChar datatype will be
/// used.<br>
/// Values in the \c from part of the vector may be duplicated, to copy the same source bitplane to
/// several destination bitplanes. Values in the \c to part of the array must be unique. (How would
/// you copy different bitplanes to the same resulting bitplane?)<br>
/// The palette contents are calculated in a way that the first threshold is coded in the
/// least-significant bitplane of the resulting image, the next threshold is coded in the next higher
/// bitplane, and so on.<br>
/// A 16 bit in palette may be used to copy bitplanes from two images into one resulting image with
/// the mvIMPACT::mapLut function. The following drawing illustrates this:
/// \image html images/mvi_base/GenerateShufflePalette3.png
/// \see mvIMPACT::Shuffle
/// \see mvIMPACT::Palette
/// \see mvIMPACT::generateRampPalette
/// \see mvIMPACT::generatePalette
/// \see mvIMPACT::generateThresholdPalette
//-----------------------------------------------------------------------------
Palette generateShufflePalette(
	/// Up to 16 mvIMPACT::Shuffle objects.
	const std::vector<Shuffle>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR,shuffle)
	);




/// \brief Generate a palette for bitplane shuffling.

/// This function calculates a palette that can be applied to images with the mapLut()
/// function for the purpose of shuffling bitplanes around.<br>
/// A drawing should explain this further:
/// \image html images/mvi_base/GenerateShufflePalette1.png
/// In this example, the bitplanes 0 and 1 of the source image are copied to bitplanes 6 and 7 of
/// the destination image. The function calculates and presets the shuffle palette in a way that this
/// transformation can be executed.<br>
/// The \a shuffle parameter specifies how bitplanes are moved around. The table should
/// illustrate this:
/// \image html images/mvi_base/GenerateShufflePalette2.png
/// This table specifies that bitplane 0 of the source is moved to bitplane 6 of the destination.
/// Likewise, bitplane 1 of the source is moved to bitplane 7 of the destination. The \a shuffle
/// parameter is a std::vector of mvIMPACT::Shuffle objects with at least one and at most 16 entries.
/// The from and to entries in the mvIMPACT::Shuffle objects may range from 0 to 15 (the
/// maximum number of bitplanes in a 16 bit image).<br>
/// The size and datatype of the resulting mvIMPACT::Palette is calculated from the values in this
/// mvIMPACT::Shuffle vector. If any \c from value in the vector is at least 8 or higher, a palette with
/// 65536 entries (16 bit in) will be used, otherwise a palette with 256 entries (8 bit in) will be
/// used. If any \c to value in the vector is at least 8 or higher, a palette with \c bdUShort
/// datatype (16 bit out) will be used, otherwise a palette with \c bdUChar datatype will be
/// used.<br>
/// Values in the \c from part of the vector may be duplicated, to copy the same source bitplane to
/// several destination bitplanes. Values in the \c to part of the array must be unique. (How would
/// you copy different bitplanes to the same resulting bitplane?)<br>
/// The palette contents are calculated in a way that the first threshold is coded in the
/// least-significant bitplane of the resulting image, the next threshold is coded in the next higher
/// bitplane, and so on.<br>
/// A 16 bit in palette may be used to copy bitplanes from two images into one resulting image with
/// the mvIMPACT::mapLut function. The following drawing illustrates this:
/// \image html images/mvi_base/GenerateShufflePalette3.png
/// \see mvIMPACT::Shuffle
/// \see mvIMPACT::Palette
/// \see mvIMPACT::generateRampPalette
/// \see mvIMPACT::generatePalette
/// \see mvIMPACT::generateThresholdPalette
//-----------------------------------------------------------------------------
void generateShufflePalette(
	/// The destination palette.
	Palette& D,
	/// Up to 16 mvIMPACT::Shuffle objects.
	const std::vector<Shuffle>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR,shuffle)
	);









/// \brief Calculates a palette suitable for thresholding at multiple thresholds simultaneously.

/// The palette can be applied to images with the mvIMPACT::mapLut function for the purpose of
/// thresholding.
/// The palette is calculated in a way that the first threshold is coded in the
/// least-significant bitplane of the resulting image, the next threshold is coded in the next higher
/// bitplane, and so on.
/// The count of thresholds determines if the resulting image is of datatype \c bdUChar (1 to
/// 8 thresholds) or \c bdUShort (9 to 16 thresholds).
/// The datatype parameter determines if the palette will be applied to 8 bit images
/// (\c bdUChar, \c bdChar) or to 16 bit images (\c bdUShort, \c bdShort).
/// \see mvIMPACT::Threshold
/// \see #BufferDatatype
/// \see mvIMPACT::generatePalette
/// \see mvIMPACT::generateRampPalette
/// \see mvIMPACT::generateShufflePalette
//-----------------------------------------------------------------------------
Palette generateThresholdPalette(
	/// From 1 to 16 thresholds.
	const std::vector<Threshold>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR,thresholds),
	/// Datatype of the image(s) the created palette will be applied on.
	BufferDatatype datatype=bdChar
	);
// no default value for datatype here, because otherwise, the Python wrapper can't
// distinguish between this overloaded variant and the variant accepting
// a vector of Shuffle objects




/// \brief Calculates a palette suitable for thresholding at multiple thresholds simultaneously.

/// The palette can be applied to images with the mvIMPACT::mapLut function for the purpose of
/// thresholding.
/// The palette is calculated in a way that the first threshold is coded in the
/// least-significant bitplane of the resulting image, the next threshold is coded in the next higher
/// bitplane, and so on.
/// The count of thresholds determines if the resulting image is of datatype \c bdUChar (1 to
/// 8 thresholds) or \c bdUShort (9 to 16 thresholds).
/// The datatype parameter determines if the palette will be applied to 8 bit images
/// (\c bdUChar, \c bdChar) or to 16 bit images (\c bdUShort, \c bdShort).
/// The calculated palette will be stored in the destination buffer \a dest.
/// \see mvIMPACT::Threshold
/// \see #BufferDatatype
/// \see mvIMPACT::generatePalette
/// \see mvIMPACT::generateRampPalette
/// \see mvIMPACT::generateShufflePalette
//-----------------------------------------------------------------------------
 void generateThresholdPalette
(
	/// The destination palette.
	Palette& D,
	/// From 1 to 16 thresholds.
	const std::vector<Threshold>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR,thresholds),
	/// Datatype of the image(s) the created palette will be applied on.
	BufferDatatype datatype=bdChar
	);
// no default value for datatype here, because otherwise, the Python wrapper can't
 // distinguish between this overloaded variant and the variant accepting
 // a vector of Shuffle objects







/// \brief Take absolute pixel values of an image.

/// The function performed is: \a dest = Abs(\a source1).<br>
/// where \a dest is a placeholder for the resulting image.
//-----------------------------------------------------------------------------
Image absolute(
	  /// The source image.
	  const Image& source1);



/// \brief Take absolute pixel values of an image.

/// The function performed is: \a dest = Abs(\a source1).<br>
/// The destination image \a dest must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype than the source image \a source1.
//-----------------------------------------------------------------------------
void absolute(
	 /// The destination image.
	 Image& dest,
	 /// The source image.
	 const Image& source1);




/// \brief Add a constant value to an image.

/// The function performed is: \a dest = \a source  + \a value.<br>
/// where \a dest is a placeholder for the resulting image.
/// \see mvIMPACT::subtract
//-----------------------------------------------------------------------------
Image add(
		/// The source image.
		const Image& source,
		/// The operand value.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int value);



/// \brief Add two images.

/// The function performed is: \a dest = \a source1 + \a source2.<br>
/// where \a dest is a placeholder for the resulting image.
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \image html images/mvi_base/ImageAddition.png
/// \see mvIMPACT::subtract
//-----------------------------------------------------------------------------
Image add(
	  /// The first source image.
	  const Image& source1,
	  /// The second source image.
	  const Image& source2);




/// \brief Add a constant value to an image.

/// The function performed is: \a dest = \a source  + \a value.<br>
/// The destination image \a dest must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype than the source image \a source1.
/// \see mvIMPACT::subtract
//-----------------------------------------------------------------------------
void add(
		/// The destination image.
		Image& dest,
		/// The source image.
		const Image& source,
		/// The operand value.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int value);




/// \brief Add two images.

/// The function performed is: \a dest = \a source1 + \a source2.<br>
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \image html images/mvi_base/ImageAddition.png
/// \see mvIMPACT::subtract
//-----------------------------------------------------------------------------
void add(
	 /// The destination image.
	 Image& dest,
	 /// The first source image.
	 const Image& source1,
	 /// The second source image.
	 const Image& source2);






/// \brief Logically AND an image with a constant value.

/// The function performed is: \a dest = \a source  AND \a value <br>
/// where \a dest is a placeholder for the resulting image.
/// \see mvIMPACT::orImage
//-----------------------------------------------------------------------------
Image andImage(
			/// The source image.
			const Image& source,
			/// The operand value.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
			/// </mvParamRange>
			/// 	\endxmlonly
			int value);


/// \brief Logically AND two images.

/// The function performed is: \a dest = \a source1 AND \a source2 <br>
/// where \a dest is a placeholder for the resulting image.
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \image html images/mvi_base/ImageAND.png
/// \see mvIMPACT::orImage
//-----------------------------------------------------------------------------
Image andImage(
	       /// The source image.
	       const Image& source1,
	       /// The source image.
	       const Image& source2);







/// \brief Logically AND an image with a constant value.

/// The function performed is: \a dest = \a source  AND \a value <br>
/// The destination image \a dest must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype than the source image \a source.
/// \see mvIMPACT::orImage
//-----------------------------------------------------------------------------
void andImage(
			/// The destination image.
			Image& dest,
			/// The source image.
			const Image& source,
			/// The operand value.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int value);




/// \brief Logically AND two images.

/// The function performed is: \a dest = \a source1 AND \a source2 <br>
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \image html images/mvi_base/ImageAND.png
/// \see mvIMPACT::orImage
//-----------------------------------------------------------------------------
void andImage(
	      /// The destination image.
	      Image& dest,
	      /// The source image.
	      const Image& source1,
	      /// The source image.
	      const Image& source2);





/// \brief Clip an image.

/// The function performed is: \a dest = Clip(\a source1)<br>
/// where \a dest is a placeholder for the resulting image.
//-----------------------------------------------------------------------------
Image clip(
	   /// The source image.
	   const Image& source1);


/// \brief Clip an image.

/// The function performed is: \a dest = Clip(\a source1)<br>
/// The destination image \a dest must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype than the source image \a source1.
//-----------------------------------------------------------------------------
void clip(
	  /// The destination image.
	  Image& dest,
	  /// The source image.
	  const Image& source1);






/// \brief Compare an image with a constant value (equality).

/// The function performed is:
/// - \a dest = MAX, if \a source  == \a value,
/// - \a dest = MIN, else 
///
/// where \a dest is a placeholder for the resulting image.
/// MAX and MIN are the maximum and minimum values which can be represented with the datatype of the source image \a source.
/// \see mvIMPACT::compareGreater
/// \see mvIMPACT::compareGreaterOrEqual
/// \see mvIMPACT::compareLess
/// \see mvIMPACT::compareLessOrEqual
/// \see mvIMPACT::compareNotEqual
//-----------------------------------------------------------------------------
Image compareEqual(
	/// The source image.
	const Image& source,
	/// The operand value.
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
	/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
	/// </mvParamRange>
	/// \endxmlonly
	int value);




/// \brief Compare two images (equality).

/// The function performed is:
/// - \a dest = MAX, if \a source1 == \a source2,
/// - \a dest = MIN , else
///
/// where \a dest is a placeholder for the resulting image.
/// MAX and MIN are the maximum and minimum values which can be represented with the datatype of the source images \a source1 and \a source2.
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \see mvIMPACT::compareGreater
/// \see mvIMPACT::compareGreaterOrEqual
/// \see mvIMPACT::compareLess
/// \see mvIMPACT::compareLessOrEqual
/// \see mvIMPACT::compareNotEqual
//-----------------------------------------------------------------------------
Image compareEqual(
		   /// The source image.
		   const Image& source1,
		   /// The source image.
		   const Image& source2);




/// \brief Compare an image with a constant value (equality).

/// The function performed is:
/// - \a dest = MAX, if \a source  == \a value,
/// - \a dest = MIN, else <br>
///
/// MAX and MIN are the maximum and minimum values which can be represented with the datatype of the destination image \a dest.
/// The destination image \a dest must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype than the source image \a source.
/// \see mvIMPACT::compareGreater
/// \see mvIMPACT::compareGreaterOrEqual
/// \see mvIMPACT::compareLess
/// \see mvIMPACT::compareLessOrEqual
/// \see mvIMPACT::compareNotEqual
//-----------------------------------------------------------------------------
void compareEqual(
		/// The destination image.
		Image& dest,
		/// The source image.
		const Image& source,
		/// The operand value.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int value);






/// \brief Compare two images (equality).

/// The function performed is:
/// - \a dest = MAX, if \a source1 == \a source2,
/// - \a dest = MIN , else
///
/// MAX and MIN are the maximum and minimum values which can be represented with the datatype of the destination image \a dest.
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \see mvIMPACT::compareGreater
/// \see mvIMPACT::compareGreaterOrEqual
/// \see mvIMPACT::compareLess
/// \see mvIMPACT::compareLessOrEqual
/// \see mvIMPACT::compareNotEqual
//-----------------------------------------------------------------------------
void compareEqual(
		  /// The destination image.
		  Image& dest,
		  /// The source image.
		  const Image& source1,
		  /// The source image.
		  const Image& source2);




/// \brief Compare an image with a constant value (greater)

/// The function performed is:
/// - \a dest = MAX, if \a source  > \a value
/// - \a dest = MIN, else
///
/// where \a dest is a placeholder for the resulting image.
/// MAX and MIN are the maximum and minimum values which can be represented with the datatype of the source image \a source.
/// \see mvIMPACT::compareEqual
/// \see mvIMPACT::compareGreaterOrEqual
/// \see mvIMPACT::compareLess
/// \see mvIMPACT::compareLessOrEqual
/// \see mvIMPACT::compareNotEqual
//-----------------------------------------------------------------------------
Image compareGreater(
		    /// The source image.
		    const Image& source,
		    /// The operand value.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int value);



/// \brief Compare two images (greater)

/// The function performed is:
/// - \a dest = MAX, if \a source1 > \a source2
/// - \a dest = MIN, else
///
/// where \a dest is a placeholder for the resulting image.
/// MAX and MIN are the maximum and minimum values which can be represented with the datatype of the source images \a source1 and \a source2.
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \see mvIMPACT::compareEqual
/// \see mvIMPACT::compareGreaterOrEqual
/// \see mvIMPACT::compareLess
/// \see mvIMPACT::compareLessOrEqual
/// \see mvIMPACT::compareNotEqual
//-----------------------------------------------------------------------------
Image compareGreater(
		     /// The source image.
		     const Image& source1,
		     /// The source image.
		     const Image& source2);




/// \brief Compare an image with a constant value (greater)

/// The function performed is:
/// - \a dest = MAX, if \a source  > \a value
/// - \a dest = MIN, else
///
/// MAX and MIN are the maximum and minimum values which can be represented with the datatype of the destination image \a dest.
/// The destination image \a dest must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype than the source image \a source.
/// \see mvIMPACT::compareEqual
/// \see mvIMPACT::compareGreaterOrEqual
/// \see mvIMPACT::compareLess
/// \see mvIMPACT::compareLessOrEqual
/// \see mvIMPACT::compareNotEqual
//-----------------------------------------------------------------------------
void compareGreater(
		    /// The destination image.
		    Image& dest,
		    /// The source image.
		    const Image& source,
		    /// The operand value.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int value);









/// \brief Compare two images (greater)

/// The function performed is:
/// - \a dest = MAX, if \a source1 > \a source2
/// - \a dest = MIN, else
///
/// MAX and MIN are the maximum and minimum values which can be represented with the datatype of the destination image \a dest.
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \see mvIMPACT::compareEqual
/// \see mvIMPACT::compareGreaterOrEqual
/// \see mvIMPACT::compareLess
/// \see mvIMPACT::compareLessOrEqual
/// \see mvIMPACT::compareNotEqual
//-----------------------------------------------------------------------------
void compareGreater(
		    /// The destination image.
		    Image& dest,
		    /// The source image.
		    const Image& source1,
		    /// The source image.
		    const Image& source2);






/// \brief Compare an image with a constant value (greater or equal)

/// The function performed is:
/// - \a dest = MAX, if \a source  >= \a value
/// - \a dest = MIN, else
///
/// where \a dest is a placeholder for the resulting image.
/// MAX and MIN are the maximum and minimum values which can be represented with the datatype of the source image \a source.
/// \see mvIMPACT::compareEqual
/// \see mvIMPACT::compareGreater
/// \see mvIMPACT::compareLess
/// \see mvIMPACT::compareLessOrEqual
/// \see mvIMPACT::compareNotEqual
//-----------------------------------------------------------------------------
Image compareGreaterOrEqual(
			    /// The source image.
			    const Image& source,
			    /// The operand value.
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
				/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
				/// </mvParamRange>
				/// 	\endxmlonly
				int value);







/// \brief Compare two images (greater or equal)

/// The function performed is:
/// - \a dest = MAX, if \a source1 >= \a source2
/// - \a dest = MIN, else
///
/// where \a dest is a placeholder for the resulting image.
/// MAX and MIN are the maximum and minimum values which can be represented with the datatype of the source images \a source1 and \a source2.
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \see mvIMPACT::compareEqual
/// \see mvIMPACT::compareGreater
/// \see mvIMPACT::compareLess
/// \see mvIMPACT::compareLessOrEqual
/// \see mvIMPACT::compareNotEqual
//-----------------------------------------------------------------------------
Image compareGreaterOrEqual(
			    /// The source image.
			    const Image& source1,
			    /// The source image.
			    const Image& source2);




/// \brief Compare an image with a constant value (greater or equal)

/// The function performed is:
/// - \a dest = MAX, if \a source  >= \a value
/// - \a dest = MIN, else
///
/// MAX and MIN are the maximum and minimum values which can be represented with the datatype of the destination image \a dest.
/// The destination image \a dest must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype than the source image \a source.
/// \see mvIMPACT::compareEqual
/// \see mvIMPACT::compareGreater
/// \see mvIMPACT::compareLess
/// \see mvIMPACT::compareLessOrEqual
/// \see mvIMPACT::compareNotEqual
//-----------------------------------------------------------------------------
void compareGreaterOrEqual(
			    /// The destination image.
			    Image& dest,
			    /// The source image.
			    const Image& source,
			    /// The operand value.
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
				/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
				/// </mvParamRange>
				/// \endxmlonly
				int value);




/// \brief Compare two images (greater or equal)

/// The function performed is:
/// - \a dest = MAX, if \a source1 >= \a source2
/// - \a dest = MIN, else
///
/// MAX and MIN are the maximum and minimum values which can be represented with the datatype of the destination image \a dest.
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \see mvIMPACT::compareEqual
/// \see mvIMPACT::compareGreater
/// \see mvIMPACT::compareLess
/// \see mvIMPACT::compareLessOrEqual
/// \see mvIMPACT::compareNotEqual
//-----------------------------------------------------------------------------
void compareGreaterOrEqual(
			   /// The destination image.
			   Image& dest,
			   /// The source image.
			   const Image& source1,
			   /// The source image.
			   const Image& source2);



/// \brief Compare an image with a constant value (less)

/// The function performed is:
/// - \a dest = MAX, if \a source  < \a value
/// - \a dest = MIN, else
///
/// where \a dest is a placeholder for the resulting image.
/// MAX and MIN are the maximum and minimum values which can be represented with the datatype of the source image \a source.
/// \see mvIMPACT::compareEqual
/// \see mvIMPACT::compareGreater
/// \see mvIMPACT::compareGreaterOrEqual
/// \see mvIMPACT::compareLessOrEqual
/// \see mvIMPACT::compareNotEqual
//-----------------------------------------------------------------------------
Image compareLess(
		/// The source image.
		const Image& source,
		/// The operand value.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int value);


/// \brief Compare two images (less)

/// The function performed is:
/// - \a dest = MAX, if \a source1 < \a source2
/// - \a dest = MIN, else
///
/// where \a dest is a placeholder for the resulting image.
/// MAX and MIN are the maximum and minimum values which can be represented with the datatype of the source images \a source1 and \a source2.
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \see mvIMPACT::compareEqual
/// \see mvIMPACT::compareGreater
/// \see mvIMPACT::compareGreaterOrEqual
/// \see mvIMPACT::compareLessOrEqual
/// \see mvIMPACT::compareNotEqual
//-----------------------------------------------------------------------------
Image compareLess(
		  /// The source image.
		  const Image& source1,
		  /// The source image.
		  const Image& source2);


/// \brief Compare an image with a constant value (less)

/// The function performed is:
/// - \a dest = MAX, if \a source  < \a value
/// - \a dest = MIN, else
///
/// MAX and MIN are the maximum and minimum values which can be represented with the datatype of the destination image \a dest.
/// The destination image \a dest must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype than the source image \a source.
/// \see mvIMPACT::compareEqual
/// \see mvIMPACT::compareGreater
/// \see mvIMPACT::compareGreaterOrEqual
/// \see mvIMPACT::compareLessOrEqual
/// \see mvIMPACT::compareNotEqual
//-----------------------------------------------------------------------------
void compareLess(
		/// The destination image.
		Image& dest,
		/// The source image.
		const Image& source,
		/// The operand value.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int value);




/// \brief Compare two images (less)

/// The function performed is:
/// - \a dest = MAX, if \a source1 < \a source2
/// - \a dest = MIN, else
///
/// MAX and MIN are the maximum and minimum values which can be represented with the datatype of the destination image \a dest.
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \see mvIMPACT::compareEqual
/// \see mvIMPACT::compareGreater
/// \see mvIMPACT::compareGreaterOrEqual
/// \see mvIMPACT::compareLessOrEqual
/// \see mvIMPACT::compareNotEqual
//-----------------------------------------------------------------------------
void compareLess(
		 /// The destination image.
		 Image& dest,
		 /// The source image.
		 const Image& source1,
		 /// The source image.
		 const Image& source2);








/// \brief Compare an image with a constant value (less or equal)

/// The function performed is:
/// - \a dest = MAX, if \a source <= \a value
/// - \a dest = MIN, else
///
/// where \a dest is a placeholder for the resulting image.
/// MAX and MIN are the maximum and minimum values which can be represented with the datatype of the source image \a source.
/// \see mvIMPACT::compareEqual
/// \see mvIMPACT::compareGreater
/// \see mvIMPACT::compareGreaterOrEqual
/// \see mvIMPACT::compareLess
/// \see mvIMPACT::compareNotEqual
//-----------------------------------------------------------------------------
Image compareLessOrEqual(
			/// The source image.
			const Image& source,
			/// The operand value.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int value);






/// \brief Compare two images (less or equal)

/// The function performed is:
/// - \a dest = MAX, if \a source1 <= \a source2
/// - \a dest = MIN, else
///
/// where \a dest is a placeholder for the resulting image.
/// MAX and MIN are the maximum and minimum values which can be represented with the datatype of the source images \a source1 and \a source2.
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \see mvIMPACT::compareEqual
/// \see mvIMPACT::compareGreater
/// \see mvIMPACT::compareGreaterOrEqual
/// \see mvIMPACT::compareLess
/// \see mvIMPACT::compareNotEqual
//-----------------------------------------------------------------------------
Image compareLessOrEqual(
			 /// The source image.
			 const Image& source1,
			 /// The source image.
			 const Image& source2);






/// \brief Compare an image with a constant value (less or equal)

/// The function performed is:
/// - \a dest = MAX, if \a source <= \a value
/// - \a dest = MIN, else
///
/// MAX and MIN are the maximum and minimum values which can be represented with the datatype of the destination image \a dest.
/// The destination image \a dest must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype than the source image \a source.
/// \see mvIMPACT::compareEqual
/// \see mvIMPACT::compareGreater
/// \see mvIMPACT::compareGreaterOrEqual
/// \see mvIMPACT::compareLess
/// \see mvIMPACT::compareNotEqual
//-----------------------------------------------------------------------------
void compareLessOrEqual(
			/// The destination image.
			Image& dest,
			/// The source image.
			const Image& source,
			/// The operand value.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int value);



/// \brief Compare two images (less or equal)

/// The function performed is:
/// - \a dest = MAX, if \a source1 <= \a source2
/// - \a dest = MIN, else
///
/// MAX and MIN are the maximum and minimum values which can be represented with the datatype of the destination image \a dest.
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \see mvIMPACT::compareEqual
/// \see mvIMPACT::compareGreater
/// \see mvIMPACT::compareGreaterOrEqual
/// \see mvIMPACT::compareLess
/// \see mvIMPACT::compareNotEqual
//-----------------------------------------------------------------------------
void compareLessOrEqual(
			/// The destination image.
			Image& dest,
			/// The source image.
			const Image& source1,
			/// The source image.
			const Image& source2);






/// \brief Compare an image with a constant value (not equal)

/// The function performed is:
/// - \a dest = MAX, if \a source != \a value
/// - \a dest = MIN, else
///
/// where \a dest is a placeholder for the resulting image.
/// MAX and MIN are the maximum and minimum values which can be represented with the datatype of the source image \a source.
/// \see mvIMPACT::compareEqual
/// \see mvIMPACT::compareGreater
/// \see mvIMPACT::compareGreaterOrEqual
/// \see mvIMPACT::compareLess
/// \see mvIMPACT::compareLessOrEqual
//-----------------------------------------------------------------------------
Image compareNotEqual(
		    /// The source image.
		    const Image& source,
		    /// The operand value.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
			/// </mvParamRange>
			/// 	\endxmlonly
			int value);





/// \brief Compare two images (not equal)

/// The function performed is:
/// - \a dest = MAX, if \a source1 != \a source2
/// - \a dest = MIN, else
///
/// where \a dest is a placeholder for the resulting image.
/// MAX and MIN are the maximum and minimum values which can be represented with the datatype of the source images \a source1 and \a source2.
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \see mvIMPACT::compareEqual
/// \see mvIMPACT::compareGreater
/// \see mvIMPACT::compareGreaterOrEqual
/// \see mvIMPACT::compareLess
/// \see mvIMPACT::compareLessOrEqual
//-----------------------------------------------------------------------------
Image compareNotEqual(
		      /// The source image.
		      const Image& source1,
		      /// The source image.
		      const Image& source2);



/// \brief Compare an image with a constant value (not equal)

/// The function performed is:
/// - \a dest = MAX, if \a source != \a value
/// - \a dest = MIN, else
///
/// MAX and MIN are the maximum and minimum values which can be represented with the datatype of the destination image \a dest.
/// The destination image \a dest must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype than the source image \a source.
/// \see mvIMPACT::compareEqual
/// \see mvIMPACT::compareGreater
/// \see mvIMPACT::compareGreaterOrEqual
/// \see mvIMPACT::compareLess
/// \see mvIMPACT::compareLessOrEqual
//-----------------------------------------------------------------------------
void compareNotEqual(
		    /// The destination image.
		    Image& dest,
		    /// The source image.
		    const Image& source,
		    /// The operand value.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int value);






/// \brief Compare two images (not equal)

/// The function performed is:
/// - \a dest = MAX, if \a source1 != \a source2
/// - \a dest = MIN, else
///
/// MAX and MIN are the maximum and minimum values which can be represented with the datatype of the destination image \a dest.
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \see mvIMPACT::compareEqual
/// \see mvIMPACT::compareGreater
/// \see mvIMPACT::compareGreaterOrEqual
/// \see mvIMPACT::compareLess
/// \see mvIMPACT::compareLessOrEqual
//-----------------------------------------------------------------------------
void compareNotEqual(
		     /// The destination image.
		     Image& dest,
		     /// The source image.
		     const Image& source1,
		     /// The source image.
		     const Image& source2);







/// \brief Divide an image through a constant value.

/// The function performed is: \a dest = \a source / \a value.<br>
/// where \a dest is a placeholder for the resulting image.
/// \see mvIMPACT::multiply
//-----------------------------------------------------------------------------
Image divide(
			/// The source image.
			const Image& source,
			/// The operand value.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int value);



/// \brief Divide a constant value through an image.

/// The function performed is: \a dest = \a value / \a source.<br>
/// where \a dest is a placeholder for the resulting image.
/// \see mvIMPACT::multiply
//-----------------------------------------------------------------------------
Image divide(
			/// The operand value.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int value,
			/// The source image.
			const Image& source);



/// \brief Divide an image through an image.

/// The function performed is: \a dest = \a source1 / \a source2.<br>
/// where \a dest is a placeholder for the resulting image.
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \image html images/mvi_base/ImageDivision.png
/// \see mvIMPACT::multiply
//-----------------------------------------------------------------------------
Image divide(
	     /// The first source image.
	     const Image& source1,
	     /// The second source image.
	     const Image& source2);





/// \brief Divide an image through a constant value.

/// The function performed is: \a dest = \a source / \a value.<br>
/// The destination image \a dest must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype than the source image \a source.
/// \see mvIMPACT::multiply
//-----------------------------------------------------------------------------
void divide(
			/// The destination image.
			Image& dest,
			/// The source image.
			const Image& source,
			/// The operand value.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int value);



/// \brief Divide a constant value through an image.

/// The function performed is: \a dest = \a value / \a source.<br>
/// The destination image \a dest must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype than the source image \a source.
/// \see mvIMPACT::multiply
//-----------------------------------------------------------------------------
void divide(
			/// The destination image.
			Image& dest,
			/// The operand value.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int value,
			/// The source image.
			const Image& source);



/// \brief Divide an image through an image.

/// The function performed is: \a dest = \a source1 / \a source2.<br>
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \image html images/mvi_base/ImageDivision.png
/// \see mvIMPACT::multiply
//-----------------------------------------------------------------------------
void divide(
	    /// The destination image.
	    Image& dest,
	    /// The first source image.
	    const Image& source1,
	    /// The second source image.
	    const Image& source2);






/// \brief Performs a point to point palette mapping operation.

/// The function performed is: \a dest = \a palette[(\a source1 << 8) OR \a source2]<br>
/// where \a dest is a placeholder for the resulting image.
/// That means:
/// - the pixel values from \a source1 make up the upper 8 bits of the index of the palette entry
/// - the pixel values from \a source2 make up the lower 8 bits of the index of the palette entry
/// Thus the palette specified with parameter \a palette must be of datatype "bdUShort" and the datatypes of
/// the images must be "bdUChar"
/// The image properties of \a source1 and \a source2 must match concerning the number of bands, z-slices and time-slices.
/// The palette buffer can have the following properties:
/// -  The palette has the same properties concerning the number of bands, z-slices and
/// time-slices as the source images. In this case, there is a 1:1 relationship in
/// the mapping process (ie. source images and mapping palette constist of 3 bands, the
/// first band of the source images will be mapped through the first band of the palette,
/// the mapping result is written into the first band of the resulting image).
/// -  The palette has only one band, z-slice and time-slice. In this case, every band,
/// z-slice or time-slice of the source images will be mapped using the same location of the
/// palette.
/// \note You can combine only two 8 bit images!
/// \see mvIMPACT::mapLut
/// \see mvIMPACT::Image
/// \see mvIMPACT::Palette
//-----------------------------------------------------------------------------
Image map2 (
	    /// The first source image. The data will be treated as unsigned.
	    const Image& source1,
	    /// The second source image.The data will be treated as unsigned.
	    const Image& source2,
	    /// The palette to be used. The datatype must be set to "bdUShort".
	    /// The palette data will always be treated as unsigned.
	    const Palette& palette
	    );






/// \brief Performs a point to point palette mapping operation.

/// The function performed is: \a dest = \a palette[(\a source1 << 8) OR \a source2]<br>
/// That means:
/// - the pixel values from \a source1 make up the upper 8 bits of the index of the palette entry
/// - the pixel values from \a source2 make up the lower 8 bits of the index of the palette entry
/// Thus the palette specified with parameter \a palette must be of datatype "bdUShort" and the datatypes of
/// the images must be "bdUChar"
/// The image properties of \a source1, \a source2 and \a dest must match concerning the number of bands, z-slices and time-slices.
/// The palette buffer can have the following properties:
/// -  The palette has the same properties concerning the number of bands, z-slices and
/// time-slices as the source images. In this case, there is a 1:1 relationship in
/// the mapping process (ie. source images and mapping palette constist of 3 bands, the
/// first band of the source images will be mapped through the first band of the palette,
/// the mapping result is written into the first band of the resulting image).
/// -  The palette has only one band, z-slice and time-slice. In this case, every band,
/// z-slice or time-slice of the source images will be mapped using the same location of the
/// palette.
/// \note You can combine only two 8 bit images!
/// \note The source and destination images cannot partially overlap. Inplace processing is supported.
/// \see mvIMPACT::mapLut
/// \see mvIMPACT::Image
/// \see mvIMPACT::Palette
//-----------------------------------------------------------------------------
void map2(
	  /// The destination image.
	  Image& dest,
	  /// The first source image. The data will be treated as unsigned.
	  const Image& source1,
	  /// The second source image.The data will be treated as unsigned.
	  const Image& source2,
	  /// The palette to be used. The datatype must be set to "bdUShort".
	  /// The palette data will always be treated as unsigned.
	  const Palette& palette);








/// \brief Performs a point to point palette mapping operation.

/// This function performs a point to point palette mapping operation using the specified source
/// image, mapping the data through the specified palette buffer and returns the resulting image.
/// The palette buffer can have the following properties:
/// -  The palette has the same properties concerning the number of bands, z-slices and
/// time-slices as the source image. In this case, there is a 1:1 relationship in
/// the mapping process (i.e. source image and mapping palette constist of 3 bands, the
/// first band of the source image will be mapped through the first band of the palette,
/// the mapping result is written into the first band of the resulting image).
/// -  The palette has only one band, z-slice and time-slice. In this case, every band,
/// z-slice or time-slice of the source image will be mapped using the same location of the
/// palette.
/// \see mvIMPACT::map2
/// \see mvIMPACT::Image
/// \see mvIMPACT::Palette
//-----------------------------------------------------------------------------
Image mapLut(
	     /// The source image
	     const Image& source,
	     /// The mapping palette
	     const Palette& P
	     );



/// \brief Performs a point to point palette mapping operation.

/// This function performs a point to point palette mapping operation using the specified source
/// image, mapping the data through the specified palette buffer and writes the resulting image into the destination image \a dest.
/// The image properties of \a source, \a dest must match
/// concerning the number of bands, z-slices and time-slices.
/// The palette buffer can have the following properties:
/// -  The palette has the same properties concerning the number of bands, z-slices and
/// time-slices as the source image. In this case, there is a 1:1 relationship in
/// the mapping process (i.e. source image and mapping palette constist of 3 bands, the
/// first band of the source image will be mapped through the first band of the palette,
/// the mapping result is written into the first band of the resulting image).
/// -  The palette has only one band, z-slice and time-slice. In this case, every band,
/// z-slice or time-slice of the source image will be mapped using the same location of the
/// palette.
/// \see mvIMPACT::map2
/// \see mvIMPACT::Image
/// \see mvIMPACT::Palette
/// \note The source and destination images cannot partially overlap. Inplace processing is supported.
//-----------------------------------------------------------------------------
void mapLut(
	    /// The destination image
	    Image& dest,
	    /// The source image
	    const Image& source,
	    /// The mapping palette
	    const Palette& P
	    );






/// \brief Multiply an image with a constant value.

/// The function performed is: \a dest = \a source * \a value.<br>
/// where \a dest is a placeholder for the resulting image.
/// \see mvIMPACT::divide
//-----------------------------------------------------------------------------
Image multiply(
			/// The source image.
			const Image& source,
			/// The operand value.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int value);



/// \brief Multiply two images.

/// The function performed is: \a dest = \a source1 * \a source2.<br>
/// where \a dest is a placeholder for the resulting image.
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \image html images/mvi_base/ImageMultiply.png
/// \see mvIMPACT::divide
//-----------------------------------------------------------------------------
Image multiply(
	       /// The first source image.
	       const Image& source1,
	       /// The second source image.
	       const Image& source2);





/// \brief Multiply an image with a constant value.

/// The function performed is: \a dest = \a source * \a value.<br>
/// The destination image \a dest must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype than the source image \a source.
/// \see mvIMPACT::divide
//-----------------------------------------------------------------------------
void multiply(
			/// The destination image.
			Image& dest,
			/// The source image.
			const Image& source,
			/// The operand value.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int value);



/// \brief Multiply two images.

/// The function performed is: \a dest = \a source1 * \a source2.<br>
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \image html images/mvi_base/ImageMultiply.png
/// \see mvIMPACT::divide
//-----------------------------------------------------------------------------
void multiply(
	      /// The destination image.
	      Image& dest,
	      /// The first source image.
	      const Image& source1,
	      /// The second source image.
	      const Image& source2);






/// \brief Logically NAND an image with a constant value.

/// The function performed is: \a dest = \a source NAND \a value <br>
/// where \a dest is a placeholder for the resulting image.
/// \see mvIMPACT::and
//-----------------------------------------------------------------------------
Image nand(
		/// The source image.
		const Image& source,
		/// The operand value.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int value);



/// \brief Logically NAND two images.

/// The function performed is: \a dest = \a source1 NAND \a source2 <br>
/// where \a dest is a placeholder for the resulting image.
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \image html images/mvi_base/ImageNAND.png
/// \see mvIMPACT::and
//-----------------------------------------------------------------------------
Image nand(
	   /// The source image.
	   const Image& source1,
	   /// The source image.
	   const Image& source2);



/// \brief Logically NAND an image with a constant value.

/// The function performed is: \a dest = \a source NAND \a value <br>
/// The destination image \a dest must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype than the source image \a source.
/// \see mvIMPACT::and
//-----------------------------------------------------------------------------
void nand(
		/// The destination image.
		Image& dest,
		/// The source image.
		const Image& source,
		/// The operand value.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int value);



/// \brief Logically NAND two images.

/// The function performed is: \a dest = \a source1 NAND \a source2 <br>
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \image html images/mvi_base/ImageNAND.png
/// \see mvIMPACT::and
//-----------------------------------------------------------------------------
void nand(
	  /// The destination image.
	  Image& dest,
	  /// The source image.
	  const Image& source1,
	  /// The source image.
	  const Image& source2);


/// \brief Negate an image (2-complement)

/// The function performed is: \a dest = Neg(\a source1), 2-complement.<br>
/// where \a dest is a placeholder for the resulting image.
/// \see mvIMPACT::notImage
//-----------------------------------------------------------------------------
Image neg(
	  /// The source image.
	  const Image& source1);



/// \brief Negate an image (2-complement)

/// The function performed is: \a dest = Neg(\a source1), 2-complement.<br>
/// The destination image \a dest must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype than the source image \a source1.
/// \see mvIMPACT::notImage
//-----------------------------------------------------------------------------
void neg(
	 /// The destination image.
	 Image& dest,
	 /// The source image.
	 const Image& source1);


/// \brief Logically NOR an image with a constant value.

/// The function performed is: \a dest = \a source NOR \a value <br>
/// where \a dest is a placeholder for the resulting image.
/// \see mvIMPACT::orImage
//-----------------------------------------------------------------------------
Image nor(
		/// The source image.
		const Image& source,
		/// The operand value.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int value);



/// \brief Logically NOR two images.

/// The function performed is: \a dest = \a source1 NOR \a source2 <br>
/// where \a dest is a placeholder for the resulting image.
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \image html images/mvi_base/ImageNOR.png
/// \see mvIMPACT::orImage
//-----------------------------------------------------------------------------
Image nor(
	  /// The source image.
	  const Image& source1,
	  /// The source image.
	  const Image& source2);



/// \brief Logically NOR an image with a constant value.

/// The function performed is: \a dest = \a source NOR \a value <br>
/// The destination image \a dest must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype than the source image \a source.
/// \see mvIMPACT::orImage
//-----------------------------------------------------------------------------
void nor(
		/// The destination image.
		Image& dest,
		/// The source image.
		const Image& source,
		/// The operand value.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int value);





/// \brief Logically NOR two images.

/// The function performed is: \a dest = \a source1 NOR \a source2 <br>
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \image html images/mvi_base/ImageNOR.png
/// \see mvIMPACT::orImage
//-----------------------------------------------------------------------------
void nor(
	 /// The destination image.
	 Image& dest,
	 /// The source image.
	 const Image& source1,
	 /// The source image.
	 const Image& source2);


/// \brief Negate an image (1-complement)

/// The function performed is: \a dest = ~\a source1, 1-complement.<br>
/// where \a dest is a placeholder for the resulting image.
/// \see mvIMPACT::neg
//-----------------------------------------------------------------------------
Image notImage(
	       /// The source image.
	       const Image& source1);



/// \brief Negate an image (1-complement)

/// The function performed is: \a dest = ~\a source1, 1-complement.<br>
/// The destination image \a dest must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype than the source image \a source1.
/// \see mvIMPACT::neg
//-----------------------------------------------------------------------------
void notImage(
	      /// The destination image.
	      Image& dest,
	      /// The source image.
	      const Image& source1);



/// \brief Logically OR an image with a constant value.

/// The function performed is: \a dest = \a source OR \a value <br>
/// where \a dest is a placeholder for the resulting image.
/// \see mvIMPACT::nor
//-----------------------------------------------------------------------------
Image orImage(
			/// The source image.
			const Image& source,
			/// The operand value.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int value);


/// \brief Logically OR two images.

/// The function performed is: \a dest = \a source1 OR \a source2 <br>
/// where \a dest is a placeholder for the resulting image.
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \image html images/mvi_base/ImageOR.png
/// \see mvIMPACT::nor
//-----------------------------------------------------------------------------
Image orImage(
	      /// The source image.
	      const Image& source1,
	      /// The source image.
	      const Image& source2);






/// \brief Logically OR an image with a constant value.

/// The function performed is: \a dest = \a source OR \a value <br>
/// The destination image \a dest must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype than the source image \a source.
/// \see mvIMPACT::nor
//-----------------------------------------------------------------------------
void orImage(
			/// The destination image.
			Image& dest,
			/// The source image.
			const Image& source,
			/// The operand value.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int value);



/// \brief Logically OR two images.

/// The function performed is: \a dest = \a source1 OR \a source2 <br>
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \image html images/mvi_base/ImageOR.png
/// \see mvIMPACT::nor
//-----------------------------------------------------------------------------
void orImage(
	     /// The destination image.
	     Image& dest,
	     /// The source image.
	     const Image& source1,
	     /// The source image.
	     const Image& source2);





/// \brief Overlay several images

/// This function allows you to overlay two or more images on top of each other. The first image
/// specified will be the bottom most. The next is overlaid onto the previous one, etc.
/// The overlay mechanism is based on a simple keying index value. If the image to be overlaid
/// has a black pixel (index 0), then the pixel of the underlying image will be written into the
/// destination image else the pixel of the overlay image will be written into the destination
/// image.
///
/// \note The number of mvIMPACT::Image objects in vector \a Images must be at least 2.
/// \note The number of mvIMPACT::Palette objects specified in vector \a mappingPalettes and in
/// \note vector \a displayPalettes must be 0 or equal to the number of mvIMPACT::Image object in vector \a sources.
//-----------------------------------------------------------------------------
Image overlay
(
	/// The width, height, number of z-slices and number of time slices of
	/// each image must be identical.
	const std::vector<Image>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, sources),
	/// 	This optional parameter allows you to specify mapping LUTs for every
	/// image in \a sources. The output of a each mapping LUT must be of data
	/// type 8-bit.
	const std::vector<Palette>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, mappingPalettes),
	/// This optional parameter allows you to specify display LUTs. A display LUT
	/// must consist of three bands and each band must be of data type 8-bit.
	const std::vector<Palette>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, displayPalettes)
	);

/// \brief Set a Buffer to a constant value.
///
/// This function sets image \a dest to value \a value.
void setConstant(
		/// The destination image.
		BufferBase& dest,
		/// The operator value.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="%(dest)s.datatypeMinValue"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(dest)s.datatypeMaxValue"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int value);


/// \brief Performs a shading correction.

/// This function performs a shading correction using the specified source,
/// white reference and black reference images and returns the resulting image.
/// You can select two different methods
/// how to perform a shading correction:
/// \image html images/mvi_base/ShadingCorrection_Modes.png
/// The images specified with \a whiteReference and \a blackReference can have
/// the same properties and dimensions as the source image.
/// Alternatively the reference images can have one band,slice and frame
/// (the width and height must be equal). This allows you, for example, to
/// subtract a white- and black-reference image from an image sequence. All
/// values below 0 will be clipped to 0 and values greater than the maximum value,
/// will be set to the maximum of the destination buffer.
/// \note In the case
/// \note of a multiplicative shading correction, a value of 0 in the white reference
/// \note image would cause a 'division by zero error'. This can be avoided by setting
/// \note each pixel value to 1.
/// \see #ShadingMode
/// \see mvIMPACT::Image
//-----------------------------------------------------------------------------
Image shadingCorrection(
			/// The source image.
			const Image& source,
			/// The white reference image.
			const Image& whiteReference,
			/// The black reference image.
			const Image& blackReference,
			/// Additive or multiplicative shading correction.
			ShadingMode      mode
			);






/// \brief Performs a shading correction.

/// This function performs a shading correction using the specified source,
/// white reference and black reference images and writes the result into
/// the specified destination image \a dest. You can select two different methods
/// how to perform a shading correction:
/// \image html images/mvi_base/ShadingCorrection_Modes.png
/// The images specified with \a whiteReference and \a blackReference can have
/// the same properties and dimensions as the source image.
/// Alternatively the reference images can have one band,slice and frame
/// (the width and height must be equal). This allows you, for example, to
/// subtract a white- and black-reference image from an image sequence. All
/// values below 0 will be clipped to 0 and values greater than the maximum value,
/// will be set to the maximum of the destination buffer.
/// The source image \a source and the destination image \a dest must have the same properties
/// and dimensions.
/// \note In the case
/// \note of a multiplicative shading correction, a value of 0 in the white reference
/// \note image would cause a 'division by zero error'. This can be avoided by setting
/// \note each pixel value to 1.
/// \see #ShadingMode
/// \see mvIMPACT::Image
//-----------------------------------------------------------------------------
void shadingCorrection (
			/// The destination image.
			Image&       D,
			/// The source image.
			const Image& source,
			/// The white reference image.
			const Image& whiteReference,
			/// The black reference image.
			const Image& blackReference,
			/// Additive or multiplicative shading correction.
			ShadingMode      mode
			);



/// \brief Performs a shading correction.

/// This function performs a shading correction using the specified source image \a source,
/// the white reference image \a whiteReference and the mean gray value of the black reference image \a blackMeanGrayValue.
/// The result will be returned as an mvIMPACT::Image.
/// You can select two different methods
/// how to perform a shading correction:
/// \image html images/mvi_base/ShadingCorrection_Modes.png
/// The image specified with \a whiteReference  can have
/// the same properties and dimensions as the source image.
/// Alternatively the reference image can have one band,slice and frame
/// (the width and height must be equal). This allows you, for example, to
/// subtract a white reference image from an image sequence. All
/// values below 0 will be clipped to 0 and values greater than the maximum value,
/// will be set to the maximum of the destination buffer.
/// In this function the mean gray value of the black reference image is used instead of the black reference image itself.
/// \note In the case
/// \note of a multiplicative shading correction, a value of 0 in the white reference
/// \note image would cause a 'division by zero error'. This can be avoided by setting
/// \note each pixel value to 1.
/// \see #ShadingMode
/// \see mvIMPACT::Image
//-----------------------------------------------------------------------------
Image shadingCorrection (
			/// The source image.
			const Image& source,
			/// The white reference image.
			const Image& whiteReference,
			/// Instead of an image a mean gray value is given.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int             blackMeanGrayValue,
			/// Additive or multiplicative shading correction.
			ShadingMode      mode
			);





/// \brief Performs a shading correction.

/// This function performs a shading correction using the specified source image \a source,
/// the white reference image \a whiteReference and the mean gray value of the black reference image \a blackMeanGrayValue.
/// The result will be written into the destination image \a dest.
/// You can select two different methods
/// how to perform a shading correction:
/// \image html images/mvi_base/ShadingCorrection_Modes.png
/// The image specified with \a whiteReference  can have
/// the same properties and dimensions as the source image.
/// Alternatively the reference image can have one band,slice and frame
/// (the width and height must be equal). This allows you, for example, to
/// subtract a white reference image from an image sequence. All
/// values below 0 will be clipped to 0 and values greater than the maximum value,
/// will be set to the maximum of the destination buffer.
/// In this function the mean gray value of the black reference image is used instead of the black reference image itself.
/// The source image \a source and the destination image \a dest must have the same properties
/// and dimensions.
/// \note In the case
/// \note of a multiplicative shading correction, a value of 0 in the white reference
/// \note image would cause a 'division by zero error'. This can be avoided by setting
/// \note each pixel value to 1.
/// \see #ShadingMode
/// \see mvIMPACT::Image
//-----------------------------------------------------------------------------
void shadingCorrection (
			/// The destination image.
			Image& dest,
			/// The source image.
			const Image& source,
			/// The white reference image.
			const Image& whiteReference,
			/// Instead of an image a mean gray value is given.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int             blackMeanGrayValue,
			/// Additive or multiplicative shading correction.
			ShadingMode      mode
			);





/// \brief Subtract a constant value from an image.

/// The function performed is: \a dest = \a source - \a value <br>
/// where \a dest is a placeholder for the resulting image.
/// \see mvIMPACT::add
/// \see mvIMPACT::subtractAbsolute
/// \see mvIMPACT::subtractClipped
//-----------------------------------------------------------------------------
Image subtract(
			/// The source image.
			const Image& source,
			/// The operand value.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int value);



/// \brief Subtract an image from a constant value.
///
/// The function performed is: \a dest = \a value - \a source<br>
/// where \a dest is a placeholder for the resulting image.
/// \see mvIMPACT::add
/// \see mvIMPACT::subtractAbsolute
/// \see mvIMPACT::subtractClipped
//-----------------------------------------------------------------------------
Image subtract(
			/// The operand value.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int value,
			/// The source image.
			const Image& source);



/// \brief Subtract an image from an image.
///
/// The function performed is: \a dest = \a source1 - \a source2 <br>
/// where \a dest is a placeholder for the resulting image.
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \image html images/mvi_base/ImageSubtraction.png
/// \see mvIMPACT::add
/// \see mvIMPACT::subtractAbsolute
/// \see mvIMPACT::subtractClipped
//-----------------------------------------------------------------------------
Image subtract(
	       /// The first source image.
	       const Image& source1,
	       /// The second source image.
	       const Image& source2);


/// \brief Subtract a constant value from an image.
///
/// The function performed is: \a dest = \a source - \a value <br>
/// The destination image \a dest must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype than the source image \a source.
/// \see mvIMPACT::add
/// \see mvIMPACT::subtractAbsolute
/// \see mvIMPACT::subtractClipped
//-----------------------------------------------------------------------------
void subtract(
			/// The destination image.
			Image& dest,
			/// The source image.
			const Image& source,
			/// The operand value.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int value);



/// \brief Subtract an image from a constant value.
///
/// The function performed is: \a dest = \a value - \a source<br>
/// The destination image \a dest must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype than the source image \a source.
/// \see mvIMPACT::add
/// \see mvIMPACT::subtractAbsolute
/// \see mvIMPACT::subtractClipped
//-----------------------------------------------------------------------------
void subtract(
			/// The destination image.
			Image& dest,
			/// The operand value.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int value,
			/// The source image.
			const Image& source);



/// \brief Subtract an image from an image.
///
/// The function performed is: \a dest = \a source1 - \a source2 <br>
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \image html images/mvi_base/ImageSubtraction.png
/// \see mvIMPACT::add
/// \see mvIMPACT::subtractAbsolute
/// \see mvIMPACT::subtractClipped
//-----------------------------------------------------------------------------
void subtract(
	      /// The destination image.
	      Image& dest,
	      /// The first source image.
	      const Image& source1,
	      /// The second source image.
	      const Image& source2);



/// \brief Subtract a constant value from an Image and take the absolute.
///
/// The function performed is: \a dest = Abs(\a source - \a value) <br>
/// where \a dest is a placeholder for the resulting image.
/// \see mvIMPACT::add
/// \see mvIMPACT::subtract
/// \see mvIMPACT::subtractClipped
//-----------------------------------------------------------------------------
Image subtractAbsolute(
				/// The source image.
				const Image& source,
				/// The operand value.
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
				/// </mvParamRange>
				/// \endxmlonly
				int value);


/// \brief Subtract an image from an image and take the absolute.
///
/// The function performed is: \a dest = Abs(\a source1 - \a source2) <br>
/// where \a dest is a placeholder for the resulting image.
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \see mvIMPACT::add
/// \see mvIMPACT::subtract
/// \see mvIMPACT::subtractClipped
//-----------------------------------------------------------------------------
Image subtractAbsolute(
		       /// The first source image.
		       const Image& source1,
		       /// The second source image.
		       const Image& source2);




/// \brief Subtract a constant value from an image and take the absolute
///
/// The function performed is: \a dest = Abs(\a source - \a value) <br>
/// The destination image \a dest must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype than the source image \a source.
/// \see mvIMPACT::add
/// \see mvIMPACT::subtract
/// \see mvIMPACT::subtractClipped
//-----------------------------------------------------------------------------
void subtractAbsolute(
				/// The destination image.
				Image& dest,
				/// The source image.
				const Image& source,
				/// The operand value.
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
				/// </mvParamRange>
				/// \endxmlonly
				int value);



/// \brief Subtract an image from an image and take the absolute.
///
/// The function performed is: \a dest = Abs(\a source1 - \a source2) <br>
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \see mvIMPACT::add
/// \see mvIMPACT::subtract
/// \see mvIMPACT::subtractClipped
//-----------------------------------------------------------------------------
void subtractAbsolute(
		      /// The destination image.
		      Image& dest,
		      /// The source image.
		      const Image& source1,
		      /// The source image.
		      const Image& source2);



/// \brief Subtract a constant value from an image and clip the result.
///
/// The function performed is: \a dest = Clip(\a source - \a value) <br>
/// where \a dest is a placeholder for the resulting image.
/// \see mvIMPACT::add
/// \see mvIMPACT::subtract
/// \see mvIMPACT::subtractAbsolute
//-----------------------------------------------------------------------------
Image subtractClipped(
				/// The source image.
				const Image& source,
				/// The operand value.
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
				/// </mvParamRange>
				/// \endxmlonly
				int value);



/// \brief Subtract an image from an image and clip the result.
///
/// The function performed is: \a dest = Clip(\a source1 - \a source2) <br>
/// where \a dest is a placeholder for the resulting image.
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \see mvIMPACT::add
/// \see mvIMPACT::subtract
/// \see mvIMPACT::subtractAbsolute
//-----------------------------------------------------------------------------
Image subtractClipped(
		      /// The source image.
		      const Image& source1,
		      /// The source image.
		      const Image& source2);



/// \brief Subtract a constant value from an image and clip the result.
///
/// The function performed is: \a dest = Clip(\a source - \a value) <br>
/// The destination image \a dest must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype than the source image \a source.
/// \see mvIMPACT::add
/// \see mvIMPACT::subtract
/// \see mvIMPACT::subtractAbsolute
//-----------------------------------------------------------------------------
void subtractClipped(
				/// The destination image.
				Image& dest,
				/// The source image.
				const Image& source,
				/// The operand value.
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
				/// </mvParamRange>
				/// \endxmlonly
				int value);


/// \brief Subtract an image from an image and clip the result.

/// The function performed is: \a dest = Clip(\a source1 - \a source2) <br>
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \see mvIMPACT::add
/// \see mvIMPACT::subtract
/// \see mvIMPACT::subtractAbsolute
//-----------------------------------------------------------------------------
void subtractClipped(
		     /// The destination image.
		     Image& dest,
		     /// The source image.
		     const Image& source1,
		     /// The source image.
		     const Image& source2);



/// \brief Performs a weighted point to point add operation based on a third image.

/// This function performs a weighted a point to point add operation based on a third image. The
/// point to point operation can be performed on two images, whereas the third image determines
/// how to mix the two source images.
/// The operation performed is as follows:
/// \a dest = \a source1* \a source3 + \a source2*(1-\a Weight)<br>
/// where \a dest is a placeholder for the resulting image.
/// The buffers specified with \a source1, \a source2, and \a Weight must have the same properties
/// concerning the number of bands, z-slices and time-slices.
/// \see mvIMPACT::Image
/// \see mvIMPACT::add
Image weightedAdd(
		  /// The first source image.
		  const Image& source1,
		  /// The second source image.
		  const Image& source2,
		  /// The image which holds the weights multiplied with 255.
		  /// The data type of this image must be "bdUChar"
		  const Image& weight
		  );





/// \brief Performs a weighted point to point add operation based on a third image.

/// This function performs a weighted a point to point add operation based on a third image. The
/// point to point operation can be performed on two images, whereas the third image determines
/// how to mix the two source images.
/// The operation performed is as follows:
/// \a dest = \a source1* \a source3 + \a source2*(1-\a Weight)<br>
/// The buffers specified with \a source1, \a source2,\a Weight and \a dest must have the same properties
/// concerning the number of bands, z-slices and time-slices.
/// The source and destination buffers cannot partially overlap. This situation could have exist, if
/// child buffers are used. However, in place processing is supported, when source is equal to
/// destination.
/// \see mvIMPACT::Image
/// \see mvIMPACT::add
void weightedAdd(
		 /// The destination image
		 Image& dest,
		 /// The first source image.
		 const Image& source1,
		 /// The second source image.
		 const Image& source2,
		 /// The image which holds the weights multiplied with 255.
		 /// The data type of this image must be "bdUChar"
		 const Image& weight
		 );




/// \brief Performs a weighted point to point add operation based on a third image.

/// This function performs a weighted a point to point add operation based on a third image. The
/// point to point operation can be performed on two images, whereas the third image determines
/// how to mix the two source images.
/// The operation performed is as follows:
/// \a dest = \a source1 * \a weight + \a source2 * (1 - \a weight)
/// where \a dest is a placeholder for the resulting image.
/// The buffers specified with \a source1, \a source2 and \a dest must have the same properties
/// concerning the number of bands, z-slices and time-slices.
/// \see mvIMPACT::Image
/// \see mvIMPACT::add
Image weightedAdd(
			/// The first source image.
			const Image& source1,
			/// The second source image.
			const Image& source2,
			/// The weight multiplied with 255.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamConst value="255"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int weight
			);



/// \brief Performs a weighted point to point add operation based on a third image.

/// This function performs a weighted a point to point add operation based on a third image. The
/// point to point operation can be performed on two images, whereas the third image determines
/// how to mix the two source images.
/// The operation performed is as follows:
/// \a dest = \a source1 * \a weight + \a source2 * (1 - \a weight)
/// The buffers specified with \a source1, \a source2 and \a dest must have the same properties
/// concerning the number of bands, z-slices and time-slices.
/// The source and destination buffers cannot partially overlap. This situation could have exist, if
/// child buffers are used. However, in place processing is supported, when source is equal to
/// destination.
/// \see mvIMPACT::Image
/// \see mvIMPACT::add
void weightedAdd(
			/// The destination image
			Image& dest,
			/// The first source image.
			const Image& source1,
			/// The second source image.
			const Image& source2,
			/// The weight multiplied with 255.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamConst value="255"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int weight
			);



/// \brief Logically XNOR/NXOR an image with a constant value.

/// The function performed is: \a dest = ~(\a source ^ \a value). <br>
/// where \a dest is a placeholder for the resulting image.
/// \see mvIMPACT::xorImage
/// \see mvIMPACT::notImage
//-----------------------------------------------------------------------------
Image xnor(
		/// The source image.
		const Image& source,
		/// The operand value.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int value);



/// \brief Logically XNOR/NXOR two images.

/// The function performed is: \a dest = ~(\a source1 ^ \a source2).<br>
/// where \a dest is a placeholder for the resulting image.
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \image html images/mvi_base/ImageNXOR.png
/// \see mvIMPACT::xorImage
/// \see mvIMPACT::notImage
//-----------------------------------------------------------------------------
Image xnor(
	   /// The source image.
	   const Image& source1,
	   /// The source image.
	   const Image& source2);




/// \brief Logically XNOR/NXOR an image with a constant value.

/// The function performed is: \a dest = ~(\a source ^ \a value). <br>
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \see mvIMPACT::xorImage
/// \see mvIMPACT::notImage
//-----------------------------------------------------------------------------
void xnor(
		/// The destination image.
		Image& dest,
		/// The source image.
		const Image& source,
		/// The operand value.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int value);



/// \brief Logically XNOR/NXOR two images.

/// The function performed is: \a dest = ~(\a source1 ^ \a source2).<br>
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \image html images/mvi_base/ImageNXOR.png
/// \see mvIMPACT::xorImage
/// \see mvIMPACT::notImage
//-----------------------------------------------------------------------------
void xnor(
	  /// The destination image.
	  Image& dest,
	  /// The source image.
	  const Image& source1,
	  /// The source image.
	  const Image& source2);


/// \brief Logically XOR an image with a constant value.

/// The function performed is: \a dest = \a source ^ \a value. <br>
/// where \a dest is a placeholder for the resulting image.
/// \see mvIMPACT::xnor
/// \see mvIMPACT::orImage
//-----------------------------------------------------------------------------
Image xorImage(
			/// The source image.
			const Image& source,
			/// The operand value.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int value);


/// \brief Logically XOR two images.

/// The function performed is: \a dest = \a source1 ^ \a source2.<br>
/// where \a dest is a placeholder for the resulting image.
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \image html images/mvi_base/ImageXOR.png
/// \see mvIMPACT::xnor
/// \see mvIMPACT::orImage
//-----------------------------------------------------------------------------
Image xorImage(
	       /// The source image.
	       const Image& source1,
	       /// The source image.
	       const Image& source2);



/// \brief Logically XOR an image with a constant value.

/// The function performed is: \a dest = \a source ^ \a value. <br>
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \see mvIMPACT::xnor
/// \see mvIMPACT::orImage
//-----------------------------------------------------------------------------
void xorImage(
			/// The destination image.
			Image& dest,
			/// The source image.
			const Image& source,
			/// The operator value.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int value);



/// \brief Logically XOR two images.

/// The function performed is: \a dest = \a source1 ^ \a source2.<br>
/// All mvIMPACT::Image objects passed as parameters must have the same dimensions (x, y, bands, z-slices, time-slices) and datatype in general.
/// One sole exception exists: the dimensions of \a source1 or \a source2 may
/// consist of one band, one z-slice and one time-slice (x- and y must be equal).
/// \image html images/mvi_base/ImageXOR.png
/// \see mvIMPACT::xnor
/// \see mvIMPACT::orImage
//-----------------------------------------------------------------------------
void xorImage(
	      /// The destination image.
	      Image& dest,
	      /// The source image.
	      const Image& source1,
	      /// The source image.
	      const Image& source2);






/// \brief The function uses Otsu's method to calculate an optimal threshold for an image.

/// This threshold can be used to binarize images automatically, based on the image
/// contents. The histogram does not need to be bimodal, Otsu's method works by setting the
/// threshold in a way that the total variance is minimized.
/// The returned threshold value \c threshold can be used to binarize an image. The binarization should be
/// carried out in the following way:
/// - background pixel: pixel value < \c threshold
/// - foreground pixel: pixel value >= \c threshold
/// Suitable functions for binarization of images are mvIMPACT::compareGreaterOrEqual (passing \c threshold as parameter \a value)
/// or mvIMPACT::generateThresholdPalette.
/// If a multidimensional image is passed to the function, only the data of the first
/// plane is used to calculate the threshold. If you want to calculate the threshold for a different
/// plane in a multidimensional image, you can use the mvIMPACT::Image to create a
/// proper child image for the desired plane.
/// Supported Datatypes: Image: "dbChar" , "bdUChar" "bdShort" , "bdUShort"
/// \see #BufferDatatype
/// \see mvIMPACT::Image
/// \see mvIMPACT::compareGreaterOrEqual
/// \see mvIMPACT::generateThresholdPalette
//-----------------------------------------------------------------------------
int bestThreshold(/// the image for whose threshold value should be calculated
		  const Image& source);




/// \brief Find the first single local minimum in a given histogram.

/// This function tries to find the first local minimum in the given intensity histogram \a source and returns
/// the result.

/// \note Before trying to find minima, it is strongly recommended to
/// \note smooth the histogram data. The results are as good as the image quality. This means that it's
/// \note possible, that no minima can be found or if minima are found, their values are
/// \note meaningless. So, your image should be enhanced properly before trying to find minima.
/// \see mvIMPACT::getLocalMinima
/// \see mvIMPACT::Histogram
/// \see mvIMPACT::smooth
//-----------------------------------------------------------------------------
int getSingleLocalMinimum(/// the histogram
			  const Histogram& source);




/// \brief Find all local minima in a given histogram.

/// This function determines the local minima of the histogram.The results are returned in a vector.
/// The first and last histogram entry will always be treated as a minimum. Therefore, the number
/// of minima found will be at least set to 2. Parameter \a range1 specifies a minimum tracking range of
/// subsequent histogram entries, that represent the falling edge of the histogram. Parameter \a range2
/// specifies a minimum tracking range of subsequent histogram entries, which represent the
/// rising edge of the histogram.
/// \image html images/mvi_base/Histogram_LocalMinima.png
/// The algorithm selects only these minima that satisfy the following rule:
/// - the gradient on the left side of the assumed minimum is negative for at least "range1" entries
/// - the gradient on the right side of the assumed minimum is positive for at least "range2" entries
/// \note Before trying to find minima, it is strongly recommended to
/// \note smooth the histogram data. The results are as good as the image quality. This means that it's
/// \note possible, that no minima can be found or if minima are found, their values are
/// \note meaningless. So, your image should be enhanced properly before trying to find minima.
/// \see mvIMPACT::getSingleLocalMinimum
/// \see mvIMPACT::Histogram
/// \see mvIMPACT::smooth
//-----------------------------------------------------------------------------
inline std::vector<int> getLocalMinima (
	/// the histogram
	const Histogram& source,
	/// width of the area that should be considered the falling edge of a minimum (left side)
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="0.01"/></mvParamMin>
	/// <mvParamStep>0.01</mvParamStep>
	/// </mvParamRange>
	/// \endxmlonly
	double range1,
	/// width of the area that should be considered the rising edge of a minimum (right side)
	/// \xmlonly
	/// <mvParamRange>
	/// <mvParamMin><mvParamConst value="0.01"/></mvParamMin>
	/// <mvParamStep>0.01</mvParamStep>
	/// </mvParamRange>
	/// \endxmlonly
	double range2
	);





/// \brief Calculates an intensity histogram of an image.

/// A frequency histogram is a mere count of pixels having all possible gray-level values. It fully
/// characterizes the distribution of the pixel intensities, regardless their positions.
/// A single, narrow histogram peak corresponds to an area of uniform content. Two-peaked
/// histograms, also called bimodal, are commonplace and correspond to foreground features of a
/// given color over a contrasted background. Large peaks correspond to poorly defined shades of
/// gray such as given by textured surfaces, noisy imaging conditions or uneven illumination.
/// The number of entries in the histogram depends on the datatype of the source
/// buffer (256 entries for a 8 bit buffer, 65536 entries for a 16 bit buffer)
/// \image html images/mvi_base/Histogram_Histogram.png
/// \see mvIMPACT::Image
/// \see mvIMPACT::Histogram
//-----------------------------------------------------------------------------
Histogram calcHistogram(
			/// the image whose histogram should be calculated
			const Image& source);





/// \brief Calculates an intensity histogram of an image.

/// A frequency histogram is a mere count of pixels having all possible gray-level values. It fully
/// characterizes the distribution of the pixel intensities, regardless their positions.
/// A single, narrow histogram peak corresponds to an area of uniform content. Two-peaked
/// histograms, also called bimodal, are commonplace and correspond to foreground features of a
/// given color over a contrasted background. Large peaks correspond to poorly defined shades of
/// gray such as given by textured surfaces, noisy imaging conditions or uneven illumination.
/// \image html images/mvi_base/Histogram_Histogram.png
/// \note The datatype of the destination histogram \a dest must be set to "bdULong". The
/// \note histogram size must be large enough to keep all possible intensity values (256 entries
/// \note for a 8 bit image, 65536 for a 16 bit image).
/// \see mvIMPACT::Image
/// \see mvIMPACT::Histogram
//-----------------------------------------------------------------------------
void calcHistogram(
		   /// the destination histogram
		   Histogram& dest,
		   /// the image which histogram should be calculated
		   const Image& source);





/// \brief Generates a X- or Y profile of a buffer.

/// This function performs a x- or y-profile operation using the specified source image \a source returns the resulting profile.
/// When calculating a x-profile, the intensities of each column in the image will be accumulated.
/// When calculating a y-profile, the intensities of each row in the image will be accumulated.
/// If the source image \a source is a multidimensional image, the resulting mvIMPACT::Profile object will have the same
/// properties concerning the dimensions of the buffer (bands, z-slices, time-slices)
/// Nevertheless the y-size will be 1!
/// \see #ProfileMode
/// \see mvIMPACT::Image
/// \see mvIMPACT::Profile
//-----------------------------------------------------------------------------
Profile calcLineProfile(/// the image which profile will be calculated
		    const Image& source,
		    /// Specifies whether to calculate an X- or an Y- profile
		    ProfileMode mode=pmXProfile);




/// \brief Generates a X- or Y profile of a buffer.

/// This function performs a x- or y-profile operation using the specified source image \a source writes the results into
/// the destination profile \a dest.
/// When calculating a x-profile, the intensities of each column in the image will be accumulated.
/// When calculating a y-profile, the intensities of each row in the image will be accumulated.
/// If the source image \a source is a multidimensional image, the destination profile must have the same
/// properties concerning the dimensions of the buffer (bands, z-slices, time-slices)
/// Nevertheless the y-size must be 1!
/// \note The function accumulates the values in the destination profile with
/// \note each call. If this is not desired, you should either reset the profiles's values to 0.0 or create
/// \note a new mvIMPACT::Profile object!
/// \see #ProfileMode
/// \see mvIMPACT::Image
/// \see mvIMPACT::Profile
//-----------------------------------------------------------------------------
void calcLineProfile(/// the destination profile
		 Profile& dest,
		 /// the image which profile will be calculated
		 const Image& source,
		 /// Specifies whether to calculate an X- or an Y- profile
		 ProfileMode mode=pmXProfile);



/// \brief Generates a line profile of an image.

/// This function performs a line profile operation using the specified source image \a source and returns the
/// resulting profile. It uses an algorithm with bilinear interpolation to read
/// the intensity values along a line.
/// If the source image is a multidimensional buffer, the profile will have the same
/// properties concerning the number of bands, z-slices and time-slices.
/// All points of the desired line must be set with respect to the image origin (top left corner).
/// The given start and end points are included.
/// \image html images/mvi_base/Profile_Profile.png
/// \see mvIMPACT::Line
/// \see mvIMPACT::Image
/// \see mvIMPACT::Profile
//-----------------------------------------------------------------------------
Profile calcLineProfile(/// The source image. The data will be treated as unsigned.
		    const Image& source,
		    /// The line. Start and end point are included.
		    const Line& line);





/// \brief Generates a line profile of an image.

/// This function performs a line profile operation using the specified source image \a source and writes the results into the
/// destination profile \a dest. It uses an algorithm with bilinear interpolation to read
/// the intensity values along a line.
/// If the source image is a multidimensional buffer, the destination profile must have the same
/// properties concerning the number of bands, z-slices and time-slices.Furthermore the datatype of the
/// destination profile must be equal to the dataytpe of the source image.
/// The required width of the destination profile can be determined by calling calcLineProfileLength().
/// All points of the desired line must be set with respect to the image origin (top left corner).
/// The given start and end points are included.
/// \image html images/mvi_base/Profile_Profile.png
/// \see mvIMPACT::Line
/// \see mvIMPACT::Image
/// \see mvIMPACT::Profile
//-----------------------------------------------------------------------------
void calcLineProfile(/// The destination profile
		Profile& dest,
		/// The source image
		const Image& source,
		/// The line. Start and end point are included.
	    const Line& line);


/// \brief Generates a profile of an image along a polygon.

/// This function performs a profile operation using the specified source image \a source and returns the
/// resulting profile. It uses an algorithm with bilinear interpolation to read
/// the intensity values along the lines of a polygon given as a vector of points in \a polygonPoints.
/// If the source image is a multidimensional buffer, the profile will have the same
/// properties concerning the number of bands, z-slices and time-slices.
/// All points of the desired line must be set with respect to the image origin (top left corner).
/// The given start and end points are included.
/// \image html images/mvi_base/Profile_Profile.png
/// \see mvIMPACT::Point
/// \see mvIMPACT::Image
/// \see mvIMPACT::Profile
//-----------------------------------------------------------------------------
Profile calcPolygonProfile(/// The source image. The data will be treated as unsigned.
	const Image& source,
	/// The points of the polygon
	const std::vector<Point>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, polygonPoints));



/// \brief creates an image based on multiple adjacent line profiles
///
/// A profile of the line defined by \a fromPoint and \a toPoint in the source image
/// \a source is calculated. Then profiles of \code(size-1)/2\endcode adjacent lines
/// on the left and right side (in the direction given by the vector to-from)
/// of this line are calculated and added above and below of
/// the original profile line in the destination image.
///
Image calcProfileImage(/// The source image
				const Image& source,
				/// The start point of the line. This point is included.
				const Point& fromPoint,
				/// The end point of the line. This point is included.
				const Point& toPoint,
				/// The width of the resulting line profile image,
				/// this must be an odd number
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
				/// </mvParamRange>
				/// \endxmlonly
				int size,
				/// Specifies the operation mode used for pixel interpolation.
				GeometricInterpolation mode = giBilinear
				);


/// \brief creates an image based on multiple adjacent line profiles
///
/// A profile of the line defined by \a fromPoint and \a toPoint in the source image
/// \a source is calculated. Then profiles of \code(size-1)/2\endcode adjacent lines
/// on the left and right side (in the direction given by the vector to-from)
/// of this line are calculated and added above and below of
/// the original profile line in the destination image.
///
void calcProfileImage(
				/// The destination profile
                Image& dest,
                /// The source image
				const Image& source,
                /// The start point of the line. This point is included.
                const Point& fromPoint,
                /// The end point of the line. This point is included.
                const Point& toPoint,
				/// The width of the resulting line profile image,
				/// this must be an odd number
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
				/// </mvParamRange>
				/// \endxmlonly
				int size,
				/// Specifies the operation mode used for pixel interpolation.
				GeometricInterpolation mode = giBilinear
		       );



/// \brief Performs a convolution operation with a custom kernel.

/// This function performs a general convolution operation using a custom kernel kernel and returns the resulting image.
/// By using the member
/// functions from mvIMPACT::Kernel you can control the behavior of the convolution operation.
/// \see mvIMPACT::Kernel
/// \see mvIMPACT::Image
//-----------------------------------------------------------------------------
Image convolve(
	       /// The source image buffer.
	       const Image& source,
	       /// The convolution kernel buffer.
	       const Kernel& kernel);


/// \brief Performs a convolution operation with a custom kernel.

/// This function performs a general convolution operation using a custom kernel \a kernel and writes the result into
/// the destination image \a dest.
/// By using the member
/// functions from mvIMPACT::Kernel you can control the behavior of the convolution operation.
/// \see mvIMPACT::Kernel
/// \see mvIMPACT::Image
//-----------------------------------------------------------------------------
void convolve(
	      /// The destination image buffer.
	      Image& dest,
	      /// The source image buffer.
	      const Image& source,
	      /// The convolution kernel buffer.
	      const Kernel& kernel);





/// \brief Performs a convolution operation with a predefined kernel.

/// This function performs a general convolution operation using a predefined kernel \a kernel and returns the resulting image.
/// Generally, the predefined filters can be divided into the
/// following categories:
/// -  Smoothing filters
/// These filters smooth images (removal of high frequency information). For the human
/// eye smoothed images look unsharp. Example: "skSmooth1"
/// -  Edge detection filters
/// These filters emphasize edges in images. After the filter process, edges appear bright in
/// the image, whereas regions with no edges appear dark. Example: "skSobel"
/// -  Sharpening filters
/// These filters sharpen images (emphasize high frequency information). Example: "skSharpen1"
/// \note Smoothing filter are sometimes used to remove noise from images. Another
/// \note filter type, which is often used to remove 'salt and pepper' noise is called a Median filter.
/// \note Please see mvIMPACT::rankFilter function for further information.
/// \see #StockKernel
/// \see mvIMPACT::Image
/// \see mvIMPACT::rankFilter
//-----------------------------------------------------------------------------
Image convolve(
	       /// The source image buffer
	       const Image& source,
	       /// The predefined kernel.
	       StockKernel kernel);



/// \brief Performs a convolution operation with a predefined kernel.

/// This function performs a general convolution operation using a predefined kernel \a kernel and writes the
/// result into destination image \a dest.
/// Generally, the predefined filters can be divided into the
/// following categories:
/// -  Smoothing filters
/// These filters smooth images (removal of high frequency information). For the human
/// eye smoothed images look unsharp. Example: "skSmooth1"
/// -  Edge detection filters
/// These filters emphasize edges in images. After the filter process, edges appear bright in
/// the image, whereas regions with no edges appear dark. Example: "skSobel"
/// -  Sharpening filters
/// These filters sharpen images (emphasize high frequency information). Example: "skSharpen1"
/// \note Smoothing filter are sometimes used to remove noise from images. Another
/// \note filter type, which is often used to remove 'salt and pepper' noise is called a Median filter.
/// \note Please see mvIMPACT::rankFilter function for further information.
/// \see #StockKernel
/// \see mvIMPACT::Image
/// \see mvIMPACT::rankFilter
//-----------------------------------------------------------------------------
void convolve(
	      /// The destination image buffer.
	      Image& dest,
	      /// The source image buffer.
	      const Image& source,
	      /// The predefined kernel.
	      StockKernel kernel);


/// \brief Calculates a normalized difference between two images.
///
/// This function calculates a normalized difference between two images. The difference is
/// calculated according to the formula:
/// \image html images/mvi_base/Difference_Formula.png
/// where: <br>
/// - dx is the width of the images,
/// - dy is the height of the images,
/// - db is the number of bands of the images,
/// - dz is the number of slices of the images,
/// - dt is the number of frames of the images,
/// - x is a value between 0 and dx-1,
/// - y is a value between 0 and dy-1,
/// - b is a value between 0 and db-1,
/// - z is a value between 0 and dz-1,
/// - t is a value between 0 and dt-1,
/// - v is the grayvalue of a single pixel (at location x, y, b, z, t).
//-----------------------------------------------------------------------------
double difference(/// the first image
		  const Image& source1,
		  /// the second image
		  const Image& source2);


/// \brief Return the number of differences between the two source images.
///
/// Count number of pixels of image \a source1 not equal to \a source2.
/// The datatype of the images must be "bdULong".
/// \see mvIMPACT::Image
//-----------------------------------------------------------------------------
int compare(/// the first image
	    const Image& source1,
	    /// the second image
	    const Image& source2);


/// \brief Calculate the number of pixels a line profile given with \a line would consist of
///
/// This is useful if you want to call mvIMPACT::calcLineProfile
/// \see mvIMPACT::calcLineProfile
/// \see mvIMPACT::Line
int calcLineProfileLength(/// the line whose length should be calculated
			  const Line& line);


/// \brief Average different frames of the same image
Image averageFrames(
		    /// the source image consisting of multiple frames
		    const Image& source
		    );


/// \brief Average different frames of the same image
void averageFrames(
                   /// the destination image
		   Image& dest,
		   /// the source image consisting of multiple frames
		   const Image& source
		   );


/// \brief Performs a dynamic threshold operation.
///
/// This function performs a dynamic threshold operation using the specified source image and
/// returns the resulting binary image.
/// One of two methods can be selected to perform the threshold operation:<br>
/// - The first method "amRegion" divides the image into multiple rectangular regions. For every region, a
/// threshold value will be computed using the formula given below. This method is faster than
/// the second method and should be applied, if speed matters and if the illumination variation in
/// the source image is not too strong.
/// - The second method "amNeighborhood" includes the neighborhood of a center pixel. It is done for every pixel in
/// the image. This method is much more time consuming than the first method but it sometimes
/// leads to better results.
/// The threshold value will be calculated as follows:
/// Threshold = \a contrast + (1- \a contrast/D) * Mean;
/// where: <br>
/// - Mean is the mean gray value of a region or a neighborhood (depends on selected method specified with \a mode)
/// - D is a constant, which is internally set to half of the dynamic range (i.e. 8 bit image has a
/// dynamic range of 0..255, so D is set to 128).
/// - Contrast is the \a contrast parameter.
/// If the pixel value of the source image is greater than the threshold value, the pixel value in the
/// destination image will be set to the maximum which can be represented (i.e. in a 8 bit buffer
/// 0xFF), otherwise it will be set to 0.
/// \see #AdaptiveMode
//-----------------------------------------------------------------------------
Image dynamicThreshold(/// The source image
				const Image& source,
				/// Specifies the width of the region or neighborhood depending on the \a mode
				/// parameter.
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
				/// <mvParamMax><mvParamComplex Python="%(source)s.width-1"/></mvParamMax>
				/// </mvParamRange>
				/// \endxmlonly
				int width=10,
				/// Specifies the height of the height or neighborhood depending on the \a mode
				/// parameter.
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
				/// <mvParamMax><mvParamComplex Python="%(source)s.height-1"/></mvParamMax>
				/// </mvParamRange>
				/// \endxmlonly
				int height=10,
				/// Specifies a contrast value. This value must be set with respect to the number of bits
				/// per sample (dynamic range) of the input image.
				/// Examples:<br>
				/// - bits per sample is 8, contrast range [0..255]
				/// - bits per sample is 12, contrast range [0..4096]
				/// - bits per sample is 16, contrast range [0..65535]
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
				/// </mvParamRange>
				/// \endxmlonly
				int contrast=100,
				/// Specifies the adaptive operation mode.
				AdaptiveMode mode=amRegion);




/// \brief Performs a dynamic threshold operation.
///
/// This function performs a dynamic threshold operation using the specified source image \a source and
/// stores the results in the desination image \a dest.
/// One of two methods can be selected to perform the threshold operation:<br>
/// - The first method "amRegion" divides the image into multiple rectangular regions. For every region, a
/// threshold value will be computed using the formula given below. This method is faster than
/// the second method and should be applied, if speed matters and if the illumination variation in
/// the source image is not too strong.
/// - The second method "amNeighborhood" includes the neighborhood of a center pixel. It is done for every pixel in
/// the image. This method is much more time consuming than the first method but it sometimes
/// leads to better results.
/// The threshold value will be calculated as follows:
/// Threshold = \a contrast + (1- \a contrast/D) * Mean;
/// where: <br>
/// - Mean is the mean gray value of a region or a neighborhood (depends on selected method specified with \a mode)
/// - D is a constant, which is internally set to half of the dynamic range (i.e. 8 bit image has a
/// dynamic range of 0..255, so D is set to 128).
/// - Contrast is the \a contrast parameter.
/// If the pixel value of the source image is greater than the threshold value, the pixel value in the
/// destination image will be set to the maximum which can be represented (i.e. in a 8 bit buffer
/// 0xFF), otherwise it will be set to 0.
/// \note If the source image is a multidimensional buffer, the destination image must have the same
/// \note properties concerning the number of bands, z-slices and time-slices.
/// \see #AdaptiveMode
//-----------------------------------------------------------------------------
void dynamicThreshold(/// The destination image
				Image& dest,
				/// The source image.
				const Image& source,
				/// Specifies the width of the region or neighborhood depending on the \a mode
				/// parameter.
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
				/// <mvParamMax><mvParamComplex Python="%(source)s.width-1"/></mvParamMax>
				/// </mvParamRange>
				/// \endxmlonly
				int width=10,
				/// Specifies the height of the height or neighborhood depending on the \a mode
				/// parameter.
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
				/// <mvParamMax><mvParamComplex Python="%(source)s.height-1"/></mvParamMax>
				/// </mvParamRange>
				/// \endxmlonly
				int height=10,
				/// Specifies a contrast value. This value must be set with respect to the number of bits
				/// per sample (dynamic range) of the input image.
				/// Examples:<br>
				/// - bits per sample is 8, contrast range [0..255]
				/// - bits per sample is 12, contrast range [0..4096]
				/// - bits per sample is 16, contrast range [0..65535]
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
				/// </mvParamRange>
				/// \endxmlonly
				int contrast=20,
				/// Specifies the adaptive operation mode.
				AdaptiveMode mode=amRegion);


/// \brief Thresholds an image dynamically with a line-based algorithm
///
/// "Line-based" means that only horizontal neighbourhood is used. The width of the neighbourhood operator
/// can be given in the parameter \c OperatorWidth.
///
/// Supported Datatypes:
/// Image: bdChar, bdUChar, bdShort, bdUShort, bdLong, bdULong
///
/// \return Returns the thresholded image
Image dynamicLineThreshold(
		      /// The source image.
				const Image &S,
				/// \c pmWhiteOnBlack: bright object, dark background.
				/// \c pmBlackOnWhite: dark object, bright background
				/// Note that \c pmAuto is not supported here.
				PolarityMode polarityMode,
				/// The width of the neighbourhood operator. The operator width needs to be set
				/// at least to the size of the greatest object from the image which should
				/// remain after the thresholding.
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
				/// </mvParamRange>
				/// \endxmlonly
				int operatorWidth,
				/// Minimum distance between estimates for background and foreground
				/// values within the \c OperatorWidth. Every time the distance gets smaller,
				/// the foreground estimate is corrected so that the minimum distance is adhered.
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
				/// </mvParamRange>
				/// \endxmlonly
				int minDistance);


/// \brief Thresholds an image dynamically with a line-based algorithm
///
/// "Line-based" means that only horizontal neighbourhood is used. The width of the neighbourhood operator
/// can be given in the parameter \c OperatorWidth.
///
/// Supported Datatypes:
/// Image: bdChar, bdUChar, bdShort, bdUShort, bdLong, bdULong
///
/// \return Returns the thresholded image
void dynamicLineThreshold(
				/// The destination image
				Image& dest,
				/// The source image.
				const Image& source,
				/// \c pmWhiteOnBlack: bright object, dark background.
				/// \c pmBlackOnWhite: dark object, bright background
				/// Note that \c pmAuto is not supported here.
				PolarityMode polarityMode,
				/// The width of the neighbourhood operator. The operator width needs to be set
				/// at least to the size of the greatest object from the image which should
				/// remain after the thresholding.
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
				/// </mvParamRange>
				/// \endxmlonly
				int operatorWidth,
				/// Minimum distance between estimates for background and foreground
				/// values within the \c OperatorWidth. Every time the distance gets smaller,
				/// the foreground estimate is corrected so that the minimum distance is adhered.
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
				/// </mvParamRange>
				/// \endxmlonly
				int minDistance);






/// \brief Performs a histogram equalization.

/// This function performs a histogram equalization of the specified source histogram \a source and returns the
/// resulting mvIMPACT::Palette object.
/// The transformation functions are as follows:
/// image html images/mvi_base/HistogramEqualization_Formula.png
/// If you want to make the results visible in your image, you must use a palette mapping function like mvIMPACT::mapLut
/// \see #EqualizeMode
/// \see mvIMPACT::Palette
/// \see mvIMPACT::Histogram
/// \see mvIMPACT::mapLut
//-----------------------------------------------------------------------------
Palette equalize(/// The source histogram
		 const Histogram& source,
		 /// Defines, which type of equalization to perform.
		 EqualizeMode mode=emUniform);




/// \brief Performs a histogram equalization.
///
/// This function performs a histogram equalization of the specified source histogram \a source and stores the
/// result in the destination palette \a dest.
/// The transformation functions are as follows:
/// image html images/mvi_base/HistogramEqualization_Formula.png
/// If you want to make the results visible in your image, you must use a palette mapping function like mvIMPACT::mapLut
/// \see #EqualizeMode
/// \see mvIMPACT::Palette
/// \see mvIMPACT::Histogram
/// \see mvIMPACT::mapLut
//-----------------------------------------------------------------------------
void equalize(/// The destination palette
	      Palette& dest,
	      /// The source histogram
	      const Histogram& source,
	      /// Defines, which type of equalization to perform.
	      EqualizeMode mode=emUniform);



/// \brief Preset an image with a checker pattern.
///
/// This function presets image \a source   with a checker pattern.
/// The pattern is defined within a unit square and is geometrically transformed before it
/// fills the image space. Furthermore the pattern is defined within a value range of 0.0 to 1.0 and is transformed by a
/// value transformation into actual gray values before being applied to the image.
/// The geometric transformation is specified with a mvIMPACT::PresetTransformation object
/// that is passed with the \a presetTransformation parameter.
/// The value transformation is expressed in an object of mvIMPACT::PresetColors and is passed with parameter \a presetColors.
/// \image html images/mvi_base/CheckerPattern.png
/// \see mvIMPACT::PresetColors
/// \see mvIMPACT::PresetTransformation
/// \see mvIMPACT::Image
/// \see mvIMPACT::presetConstantImage
/// \see mvIMPACT::presetNoiseImage
/// \see mvIMPACT::presetRingImage
/// \see mvIMPACT::presetWedgeImage
//-----------------------------------------------------------------------------
void presetCheckerImage (/// the image where the pattern is written to
			 Image&                  source,
			 /// defines the value transformation of the pattern
			 const PresetColors&         presetColors,
			 /// defines the geometric transformation of the pattern
			 const PresetTransformation& presetTransformation
			 );






/// \brief Preset an image with a uniform color.

/// This function presets image \a source   with a constant value \a value.
/// \see mvIMPACT::Image
/// \see mvIMPACT::presetCheckerImage
/// \see mvIMPACT::presetNoiseImage
/// \see mvIMPACT::presetRingImage
/// \see mvIMPACT::presetWedgeImage
//-----------------------------------------------------------------------------
void presetConstantImage(/// the image that will be filled with value \a value
			Image& source,
			/// the value that is used to fill image \a source
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamComplex Python="int(%(source)s.datatypeMinValue)"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="int(%(source)s.datatypeMaxValue)"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int value);



/// \brief Preset an image with a noise pattern.

/// This function presets image \a source   with a noise pattern.
/// The pattern is defined within a value range of 0.0 to 1.0 and is transformed by a
/// value transformation into actual gray values before being applied to the image.
/// The value transformation is expressed in an object of mvIMPACT::PresetColors and is passed with parameter \a presetColors.
/// Parameter \a presetCurveType is used to specify the type of curve that is used to calculate the colors between \c colors.black and \c colors.white.
/// \image html images/mvi_base/NoisePattern.png
/// \see #PresetCurveType
/// \see mvIMPACT::PresetColors
/// \see mvIMPACT::PresetTransformation
/// \see mvIMPACT::Image
/// \see mvIMPACT::presetConstantImage
/// \see mvIMPACT::presetCheckerImage
/// \see mvIMPACT::presetRingImage
/// \see mvIMPACT::presetWedgeImage
//-----------------------------------------------------------------------------
void presetNoiseImage (/// The image where the pattern is written to
				Image&          source,
				/// Defines the value transformation for the pattern
				const PresetColors& presetColors,
				/// Seed value for the random noise generator.
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
				/// <mvParamMax><mvParamConst value="2147483647"/></mvParamMax>
				/// </mvParamRange>
				/// \endxmlonly
				int                seed = 0,
				/// Specifies the curve type to use for calculating the colors
				PresetCurveType     presetCurveType = pctPresetLinear
				);



/// \brief Preset an image with a ring pattern.

/// This function presets image \a source   with a ring pattern.
/// The pattern is defined within a unit square and is geometrically transformed before it
/// fills the image space. Furthermore the pattern is defined within a value range of 0.0 to 1.0 and is transformed by a
/// value transformation into actual gray values before being applied to the image.
/// The geometric transformation is specified with a mvIMPACT::PresetTransformation object
/// that is passed with the \a presetTransformation parameter.
/// The value transformation is expressed in an object of mvIMPACT::PresetColors and is passed with parameter \a presetColors.
/// Parameter \a presetType is used to specify the type of curve that is used to calculate the colors between \c colors.black and \c colors.white.
/// \image html images/mvi_base/RingPattern.png
/// \see #PresetCurveType
/// \see mvIMPACT::PresetColors
/// \see mvIMPACT::PresetTransformation
/// \see mvIMPACT::Image
/// \see mvIMPACT::presetConstantImage
/// \see mvIMPACT::presetNoiseImage
/// \see mvIMPACT::presetCheckerImage
/// \see mvIMPACT::presetWedgeImage
//-----------------------------------------------------------------------------
void presetRingImage (/// The image where the pattern is written to
		      Image& source,
		      /// Defines the value transformation for the pattern
		      const PresetColors&         presetColors,
		      /// Defines the geometric transformation of the pattern
		      const PresetTransformation& presetTransformation,
		      /// Specifies the curve type to use for calculating the colors
		      PresetCurveType             presetCurveType = pctPresetLinear
		      );



/// \brief Preset an image with a wedge pattern.
///
/// This function presets image \a source   with a wedge pattern.
/// The pattern is defined within a unit square and is geometrically transformed before it
/// fills the image space. Furthermore the pattern is defined within a value range of 0.0 to 1.0 and is transformed by a
/// value transformation into actual gray values before being applied to the image.
/// The geometric transformation is specified with a mvIMPACT::PresetTransformation object
/// that is passed with the \a presetTransformation parameter.
/// The value transformation is expressed in an object of mvIMPACT::PresetColors and is passed with parameter \a presetColors.
/// Parameter \a presetType is used to specify the type of curve that is used to calculate the colors between \c colors.black and \c colors.white.
/// \image html images/mvi_base/WedgePattern.png
/// \see #PresetCurveType
/// \see mvIMPACT::PresetColors
/// \see mvIMPACT::PresetTransformation
/// \see mvIMPACT::Image
/// \see mvIMPACT::presetConstantImage
/// \see mvIMPACT::presetNoiseImage
/// \see mvIMPACT::presetRingImage
/// \see mvIMPACT::presetCheckerImage
//-----------------------------------------------------------------------------
void presetWedgeImage (/// The image where the pattern is written to
		       Image& source,
		       /// Defines the value transformation for the pattern
		       const PresetColors&         presetColors,
		       /// Defines the geometric transformation of the pattern
		       const PresetTransformation& presetTransformation,
		       /// Specifies the curve type to use for calculating the colors
		       PresetCurveType             presetCurveType = pctPresetLinear
		       );




/// Preset a palette with a predefined pattern.
///
/// This function presets palette \a source   with a specific predefined data.
/// \note Parameter \a gamma is only used if parameter \a palettePresetType is either set to "pptGrayGamma" or "pptGrayInverseGamma".
/// \note In all other cases parameter \a gamma is ignored!
/// \see mvIMPACT::Palette
/// \see #PalettePresetType
inline void presetPalette (
				/// The palette.
				Palette& source,
				/// The pattern type.
				PalettePresetType palettePresetType,
				/// The gamma value (only used with pptGrayGamma and pptGrayInverseGamma).
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="0.0"/></mvParamMin>
				/// <mvParamStep>0.1</mvParamStep>
				/// </mvParamRange>
				/// \endxmlonly
				double gamma=2.2
				);





/// \brief Quantizes a true-color image down to a palettized image.

/// This function reduces the number of color in a true-color image and returns
/// a suitable palettized image and the corresponding palette.<br>
/// Together with the function scale() this can be used to create thumbnail images
/// (smaller, reduced color depth), that take less space but nevertheless look pleasing.
/// \see #DitherMode
/// \see mvIMPACT::Image
/// \see mvIMPACT::Palette
//-----------------------------------------------------------------------------
std::pair<Image,Palette> quantize  (
				    /// The source image. Must be a true-color image, ie. with 3 bands.
				    /// Only single images are supported (ie. slices and frames must equal 1).
				    const Image& source,
				    /// A value between 2 and 256 that specifies the maximum number of colors that the
				    /// resulting palettized image should have.
					/// \xmlonly
					/// <mvParamRange>
					/// <mvParamMin><mvParamConst value="2"/></mvParamMin>
					/// <mvParamMax><mvParamConst value="256"/></mvParamMax>
					/// </mvParamRange>
					/// \endxmlonly
					int             colors,
				    /// Specifies dithering settings for the quantization algorithm.
				    DitherMode       mode
				    );



/// \brief Quantizes a true-color image down to a palettized image.

/// This function reduces the number of color in a true-color image and returns
/// the palettized image. The corresponding palette will be stored in the destination palette \a palette.
/// Together with the function scale() this can be used to create thumbnail images
/// (smaller, reduced color depth), that take less space but nevertheless look pleasing.
/// \see #DitherMode
/// \see mvIMPACT::Image
/// \see mvIMPACT::Palette
//-----------------------------------------------------------------------------
Image quantize  (
			/// The source image. Must be a true-color image, ie. with 3 bands.
			/// Only single images are supported (ie. slices and frames must equal 1).
			const Image&   source,
			/// The palette used to palettize the image. The palette must
			/// have 256 entries and 3 bands.
			Palette& palette,
			/// A value between 2 and 256 that specifies the maximum number of colors that the
			/// resulting palettized image should have.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="2"/></mvParamMin>
			/// <mvParamMax><mvParamConst value="256"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int               colors,
			/// Specifies dithering settings for the quantization algorithm.
			DitherMode         mode
			);



/// \brief Quantizes a true-color image down to a palettized image.

/// This function reduces the number of color in a true-color image and returns
/// the resulting palette. The corresponding image will be stored in the destination image \a dest.
/// The destination
/// image must be of the same size than the source image, but with one band only.
/// Together with the function scale() this can be used to create thumbnail images
/// (smaller, reduced color depth), that take less space but nevertheless look pleasing.
/// \see #DitherMode
/// \see mvIMPACT::Image
/// \see mvIMPACT::Palette
//-----------------------------------------------------------------------------
 Palette quantize  (
		    /// The destination image.
		    Image&         dest,
		    /// The source image. Must be a true-color image, ie. with 3 bands.
		    /// Only single images are supported (ie. slices and frames must equal 1).
		    const Image&   source,
		    /// A value between 2 and 256 that specifies the maximum number of colors that the
		    /// resulting palettized image should have.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="2"/></mvParamMin>
			/// <mvParamMax><mvParamConst value="256"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int               colors,
		    /// Specifies dithering settings for the quantization algorithm.
		    DitherMode         mode
		    );



/// \brief Quantizes a true-color image down to a palettized image.

/// This function reduces the number of color in a true-color image.
/// The resulting palette will be stored in the destination palette \a palette.
/// The corresponding image will be stored in the destination image \a dest.
/// The destination
/// image must be of the same size than the source image, but with one band only.
/// Together with the function scale() this can be used to create thumbnail images
/// (smaller, reduced color depth), that take less space but nevertheless look pleasing.
/// \see #DitherMode
/// \see mvIMPACT::Image
/// \see mvIMPACT::Palette
//-----------------------------------------------------------------------------
 void quantize  (
			/// The destination image.
			Image&         dest,
			/// The source image. Must be a true-color image, ie. with 3 bands.
			/// Only single images are supported (ie. slices and frames must equal 1).
			const Image&   source,
			/// The palette used to palettize the image. The palette must
			/// have 256 entries and 3 bands.
			Palette& palette,
			/// A value between 2 and 256 that specifies the maximum number of colors that the
			/// resulting palettized image should have.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="2"/></mvParamMin>
			/// <mvParamMax><mvParamConst value="256"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int               colors,
			/// Specifies dithering settings for the quantization algorithm.
			DitherMode         mode
			);


/// \brief Smoothes an intensity histogram.

/// This function smoothes the data of an intensity histogram using the specified source
/// histogram buffer and returns the resulting destination histogram buffer. You
/// can use a smoothed histogram for example to find one or multiple thresholds in an image.
/// A 3x1 kernel will be used for the smoothing operation.
/// \see mvIMPACT::Histogram
/// \see mvIMPACT::getLocalMinima
/// \see mvIMPACT::getSingleLocalMinimum
//-----------------------------------------------------------------------------
Histogram smooth(/// The histogram to be smoothed.The histogram data will always be treated as unsigned.
			const Histogram& source,
			/// Specifies the number of times to perform the smoothing operation.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
		 int iterations=1);


/// \brief Smoothes an intensity histogram.

/// This function smoothes the data of an intensity histogram using the specified source
/// histogram buffer \a source and writes the resulting destination histogram to \a dest.
/// The buffer properties of the source
/// and destination histogram buffer must be identical.
//You
/// can use a smoothed histogram for example to find one or multiple thresholds in an image.
/// A 3x1 kernel will be used for the smoothing operation.
/// \see mvIMPACT::Histogram
/// \see mvIMPACT::getLocalMinima
/// \see mvIMPACT::getSingleLocalMinimum
//-----------------------------------------------------------------------------
void smooth(/// The destination histogram
			Histogram& dest,
			/// The histogram to be smoothed.The histogram data will always be treated as unsigned.
			const Histogram& source,
			/// Specifies the number of times to perform the smoothing operation.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int iterations=1);



/// \brief Flip an image.
///
/// This function flips the source image using the specified operation mode and
/// returns the result.
/// Parameter \a mode specifies if the image is flipped horizontally, vertically, or both or by 90 degree.
/// \see #FlipMode
/// \see mvIMPACT::Image
//-----------------------------------------------------------------------------
Image flip (
	    /// The source image.
	    const Image& source,
	    /// Horizontal or vertical flipping.
	    FlipMode mode=fmHorizontal
	    );



/// \brief Flip an image.


/// This function flips the source image using the specified operation mode and
/// stores the result in the destination image \a dest.
/// If the source image is a multidimensional buffer, the destination
/// image must have the same properties concerning the number of bands, z-slices and
/// time-slices.
/// Parameter \a mode specifies if the image is flipped horizontally, vertically or both or by 90 degree.
/// \see #FlipMode
/// \see mvIMPACT::Image
//-----------------------------------------------------------------------------
void flip (
	   /// The destination image.
	   /// 	If the source buffer is a multidimensional buffer, the destination
	   /// buffer must also have the same properties concerning the
	   /// number of bands, slices and frames.
	   Image& dest,
	   /// The source image.
	   const Image& source,
	   /// Horizontal or vertical flipping.
	   FlipMode mode=fmHorizontal
	   );


/// \brief Convert a gray image to a run-length encoded image.
///
/// This function converts the data from a gray image to a run-length encoded
/// image and returns the RLE image.
///
/// \return The RLE encoded image.
/// \see mvIMPACT::Image
/// \see #PolarityMode
//-----------------------------------------------------------------------------
Image convertToRle (
			/// The source image. This must be a gray image with one band.
			const Image& source,
			/// Threshold value. If the value is -1 an automatic threshold will be computed.
			int threshold=-1,
			/// The image polarity which can be pmWhiteOnBlack or pmBlackOnWhite.
			/// Note that pmAuto is not supported here.
			PolarityMode polarityMode=pmWhiteOnBlack,
			/// For some image processing algorithms it is necessary to delete the border pixel.
			/// Delete or encode border pixel.
			bool deleteBorderPixel=false);



/// \brief Convert a gray image to a run-length encoded image.
///
/// This function converts the data from a gray image to a run-length encoded
/// image.
///
/// \see mvIMPACT::Image
/// \see #PolarityMode
//-----------------------------------------------------------------------------
void convertToRle (
		   /// The destination image.
		   Image& dest,
		   /// The source image. This must be a gray image with one band.
		   const Image& source,
		   /// Threshold value. If the value is -1 an automatic threshold will be computed.
		   int threshold=-1,
		   /// The image polarity which can be pmWhiteOnBlack or pmBlackOnWhite.
		   /// Note that pmAuto is not supported here.
		   PolarityMode polarityMode=pmWhiteOnBlack,
		   /// For some image processing algorithms it is necessary to delete the border pixel.
		   /// Delete or encode border pixel.
		   bool deleteBorderPixel=false);



/// \brief Calculates the matrix elements of a 3x3 matrix used for pass point method.

/// This function calculates the elements of a 3x3 matrix used for the pass point
/// method. Six elements (m11..m23) of a 3x3 matrix of the form:
/// <pre>
/// m11 m12 m13
/// m21 m22 m23
/// 0   0   1
/// </pre>
/// are calculated. The elements m31, m32 and m33 are set as shown above.
/// To compute the geometric transformation of the image, you can use the function
/// matrix() which takes a 3x3 matrix as an input parameter.<br>
/// The maximum number of pass points is restricted to 20, whereas the minimum number of
/// pass points to be supplied is 3.
/// This function in conjunction with mvIMPACT::matrix can be used to rotate a distorted image to the position of a reference image.
/// To do this pass the points of the reference image with parameter \a referencePoints and the corresponding points of the distorted image
/// with \a distortedPoints. Then use the resulting matrix in mvIMPACT::matrix.
/// \see mvIMPACT::MatrixDouble
/// \see mvIMPACT::PointDouble
/// \see mvIMPACT::matrix
//-----------------------------------------------------------------------------
MatrixDouble getMatrixPassPoint (
	/// Reference points.
	const std::vector<PointDouble>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR,referencePoints),
	/// Distorted points.
	const std::vector<PointDouble>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR,distortedPoints)
	);



/// \brief Transforms an image using a 3x3 matrix.

/// This function performs a geometric transformation based on a 3x3 matrix. The elements of
/// the matrix must be set properly in order to get the desired results.
/// The complete operation can be expressed as follows:<br>
/// <pre>
/// m11 m12 m13
/// m21 m22 m23 (matrix elements)
/// m31 m32 m33
///
/// x' = m11*x + m12*y + m13
/// y' = m21*x + m22*y + m23
/// </pre>
/// The transformation matrix can also be determined by calling mvIMPACT::getMatrixPassPoint.
/// \see #GeometricInterpolation
/// \see mvIMPACT::Image
/// \see mvIMPACT::MatrixDouble
/// \see mvIMPACT::getMatrixPassPoint
//-----------------------------------------------------------------------------
 Image matrix (
	       /// The source image.
	       Image& source,
	       /// The transformation matrix (3x3)
	       const MatrixDouble& transformation,
	       /// Specifies the operation mode used for pixel interpolation.
	       GeometricInterpolation mode = giBilinear
	       );




/// \brief Transforms an image using a 3x3 matrix.

/// This function performs a geometric transformation based on a 3x3 matrix. The resulting image is
/// stored in the destination image \a dest.
/// If the source image \a source is a multidimensional buffer, the destination image \a dest must have the same
/// properties concerning the number of bands, z-slices and time-slices.
/// The elements of
/// the matrix must be set properly in order to get the desired results.
/// The complete operation can be expressed as follows:<br>
/// <pre>
/// m11 m12 m13
/// m21 m22 m23 (matrix elements)
/// m31 m32 m33
///
/// x' = m11*x + m12*y + m13
/// y' = m21*x + m22*y + m23
/// </pre>
/// The transformation matrix can also be determined by calling mvIMPACT::getMatrixPassPoint.
/// \see #GeometricInterpolation
/// \see mvIMPACT::Image
/// \see mvIMPACT::MatrixDouble
/// \see mvIMPACT::getMatrixPassPoint
//-----------------------------------------------------------------------------
 void matrix
(
	/// The destination image.
	Image& dest,
	/// The source image.
	const Image& source,
	/// The transformation matrix (3x3)
	const MatrixDouble& transformation,
	/// Specifies the operation mode used for pixel interpolation.
	GeometricInterpolation mode = giBilinear
	);






/// \brief Rotate an image.

/// This function rotates the source image \a source about the specified source center and rotation angle
/// and returns the rotated image buffer translated to the specified destination center. That means the center point of the
/// source image is translated (after the rotation) to the center point of the destination image.
/// The destination image will have the same properties and dimensions than the source image.
/// If
/// the rotated image does not fit in the destination buffer, all data outside the destination buffer
/// boundary will be clipped.
/// The center of rotation in the source image is given with parameters \a sourceCenterX and \a sourceCenterY.
/// The  center point of the destination image is given with parameters \a destCenterX and \a destCenterY.
/// The rotation angle is given in degrees. Positive values rotate in clockwise direction
/// whereas negative values rotate in counter-clockwise direction.
/// \see mvIMPACT::Image
/// \see #GeometricInterpolation
//-----------------------------------------------------------------------------
 Image rotate(
			/// The source image.
			const Image&             source,
			/// Specifies the x-coordinate of the source center of rotation.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0.0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="float(%(source)s.width-1)"/></mvParamMax>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double                 sourceCenterX,
			/// Specifies the y-coordinate of the source center of rotation.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0.0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="float(%(source)s.height-1)"/></mvParamMax>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double                 sourceCenterY,
			/// Specifies the x-coordinate of the destination center.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0.0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="float(%(source)s.width-1)"/></mvParamMax>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double                 destCenterX,
			/// Specifies the y-coordinate of the destination center.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0.0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="float(%(source)s.height-1)"/></mvParamMax>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double                 destCenterY,
			/// Specifies the rotation angle in degrees.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="-360.0"/></mvParamMin>
			/// <mvParamMax><mvParamConst value="360.0"/></mvParamMax>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double                 angle,
			/// Specifies the operation mode used for pixel interpolation.
			GeometricInterpolation mode = giBilinear
			);


/// \brief Rotate an image and fit it to destination.

/// This function rotates the source image \a source about the source center and rotation angle
/// and fits the rotated image buffer to the returned destination image. 
/// The destination image will have the same number of bands, slices and time frames as the source image.
/// However, the width and height is different from the source image depending on the rotation angle.
///
/// The rotation angle is given in degrees. Positive values rotate in clockwise direction
/// whereas negative values rotate in counter-clockwise direction.
/// \see mvIMPACT::Image
/// \see #GeometricInterpolation
//-----------------------------------------------------------------------------
 Image rotatefit(
			/// The source image.
			const Image&             source,
			/// Specifies the x-coordinate of the source center of rotation.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0.0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="float(%(source)s.width-1)"/></mvParamMax>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			/// Specifies the rotation angle in degrees.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="-360.0"/></mvParamMin>
			/// <mvParamMax><mvParamConst value="360.0"/></mvParamMax>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double                 angle,
			/// Specifies the operation mode used for pixel interpolation.
			GeometricInterpolation mode = giBilinear
			);



/// \brief Rotate an image.

/// This function rotates the source image \a source about the specified source center and rotation angle
/// and stores the rotated image buffer in the destination image translated to the specified destination center.
/// That means the center point of the
/// source image is translated (after the rotation) to the center point of the destination image.
/// If the source buffer is a multidimensional buffer, the destination buffer must also have the
/// same properties concerning the number of bands, z-slices and time-slices.
/// If
/// the rotated image does not fit in the destination buffer, all data outside the destination buffer
/// boundary will be clipped.
/// The center of rotation in the source image is given with parameters \a sourceCenterX and \a sourceCenterY.
/// The  center point of the destination image is given with parameters \a destCenterX and \a destCenterY.
/// The rotation angle is given in degrees. Positive values rotate in clockwise direction
/// whereas negative values rotate in counter-clockwise direction.
/// \see mvIMPACT::Image
/// \see #GeometricInterpolation
//-----------------------------------------------------------------------------
 void rotate (
			/// The destination image.
			Image&             dest,
			/// The source image.
			const Image&       source,
			/// Specifies the x-coordinate of the source center of rotation.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0.0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="float(%(source)s.width-1)"/></mvParamMax>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double                 sourceCenterX,
			/// Specifies the y-coordinate of the source center of rotation.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0.0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="float(%(source)s.height-1)"/></mvParamMax>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double                 sourceCenterY,
			/// Specifies the x-coordinate of the destination center.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0.0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="float(%(source)s.width-1)"/></mvParamMax>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double                 destCenterX,
			/// Specifies the y-coordinate of the destination center.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0.0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="float(%(source)s.height-1)"/></mvParamMax>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double                 destCenterY,
			/// Specified the rotation angle in degrees.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="-360.0"/></mvParamMin>
			/// <mvParamMax><mvParamConst value="360.0"/></mvParamMax>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double                 angle,
			/// Specifies the operation mode used for pixel interpolation.
			GeometricInterpolation mode = giBilinear
			);




/// \brief Scale an image.

/// This function scales the source image \a source with a specified scaling factor (\a scaleX and \a scaleY) and returns
/// the resulting image starting at location 0,0 (top left corner). Scaling factors less than 1.0
/// reduce the source image, while scaling factors greater than 1.0 enlarge the source image.
/// Only the content of the image is scaled not its canvas. This means the scaled
/// image has the width and heigth as the original image.
/// If the scaled image does not fit in the destination buffer, all data outside the destination buffer
/// boundary will be clipped.
/// \see #GeometricInterpolation
/// \see mvIMPACT::Image
//-----------------------------------------------------------------------------
Image scale (
			/// The source image.
			Image&             source,
			/// Specifies the scale factor in x-direction.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0.01"/></mvParamMin>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double                 scaleX,
			/// Specifies the scale factor in y-direction.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0.01"/></mvParamMin>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double                 scaleY,
			/// Specifies the operation mode used for pixel interpolation.
			GeometricInterpolation mode = giBilinear
			);





/// \brief Scale an image.

/// This function scales the source image \a source with a specified scaling factor (\a scaleX and \a scaleY) and stores
/// the resulting image in the destination buffer \a dest starting at location 0,0 (top left corner). Scaling factors less than 1.0
/// reduce the source image, while scaling factors greater than 1.0 enlarge the source image.
/// If the scaled image does not fit in the destination buffer, all data outside the destination buffer
/// boundary will be clipped.
/// If the source buffer is a multidimensional buffer, the destination buffer must also have the
/// same properties concerning the number of bands, z-slices and time-slices.
/// \see #GeometricInterpolation
/// \see mvIMPACT::Image
//-----------------------------------------------------------------------------
 void scale (
			/// The destination image.
			Image& dest,
			/// The source image.
			const Image& source,
			/// Specifies the scale factor in x-direction.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0.01"/></mvParamMin>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double                 scaleX,
			/// Specifies the scale factor in y-direction.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0.01"/></mvParamMin>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double                 scaleY,
			/// Specifies the operation mode used for pixel interpolation.
			GeometricInterpolation mode = giBilinear
			);



/// \brief Translates an image.

/// This function translates the source image by the specified distances and returns the resulting image.
/// The returned image has the same dimensions than the source image.
/// Thus, if the translated image does not fit into the
/// destination buffer, all data outside of the destination buffer boundary will be clipped.
/// \see #GeometricInterpolation
/// \see mvIMPACT::Image
//-----------------------------------------------------------------------------
 Image translate (
			/// The source image.
			const Image& source,
			/// Specifies the distance to translate in x-direction. Positive values shift the image to
			/// the right, while negative values shift the image to the left.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamComplex Python="float(-%(source)s.width)"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="float(%(source)s.width)"/></mvParamMax>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double dX,
			/// Specifies the distance to translate in y-direction. Positive values shift the image
			/// down, while negative values shift the image up.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamComplex Python="float(-%(source)s.height)"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="float(%(source)s.height)"/></mvParamMax>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double dY,
			/// Specifies the operation mode used for pixel interpolation.
			GeometricInterpolation mode = giBilinear
			);


/// \brief Translates an image.

/// This function translates the source image by the specified distances and writes the resulting image
/// into the destination buffer specified with \a dest.
/// If the source image is a multidimensional buffer, the destination image must
/// have the same properties concerning the number of bands, slices and frames.
/// If the translated image does not fit into the
/// destination buffer, all data outside of the destination buffer boundary will be clipped.
/// \see #GeometricInterpolation
/// \see mvIMPACT::Image
//-----------------------------------------------------------------------------
 void translate (
			/// The destination image.
			/// If the source buffer is a multidimensional buffer, the destination buffer must
			/// have the same properties concerning the number of bands, slices and frames.
			Image& dest,
			/// The source image.
			const Image& source,
			/// Specifies the distance to translate in x-direction. Positive values shift the image to
			/// the right, while negative values shift the image to the left.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamComplex Python="float(-%(source)s.width)"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="float(%(source)s.width)"/></mvParamMax>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double dX,
			/// Specifies the distance to translate in y-direction. Positive values shift the image
			/// down, while negative values shift the image up.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamComplex Python="float(-%(source)s.height)"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="float(%(source)s.height)"/></mvParamMax>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double dY,
			/// Specifies the operation mode used for pixel interpolation.
			GeometricInterpolation mode = giBilinear
			);



/// \brief Unwinds an image (polar transformation).

/// This function unwinds a section in the source image \a source using the specified coordinates and
/// returns the unwinded image. The function allows you to unwind circles
/// and circular arcs as well as ellipses and elliptical arcs. Additionally, when using
/// elliptical objects, you can unwind them even if they are placed in oblique direction
/// (please see \c rotationAngle parameter). The destination image will always be of rectanglar
/// shape where the width and height will be determined by the \a angleStep and
/// \a fromSize/ \a toSize parameters.<br>
/// The following image explains the various parameters of the function:
/// \image html images/mvi_base/Unwind_Explanation.png
/// \note An elliptical unwind operation may introduce distortions at the left and
/// \note right side of the destination image.
/// \see mvIMPACT::Image
//-----------------------------------------------------------------------------
 Image unwind (
			/// The source image.
			const Image& source,
			/// Specifies the x-extent of the area to be transformed. It is relative to the position
			/// of \a xCenter.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int xExtend,
			/// Specifies the y-extent of the area to be transformed. It is relative to the position
			/// of \a yCenter.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int yExtend,
			/// Specifies the x-coordinate of the center of the polar transformation with respect to
			/// the origin (top left corner) of the source image
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0.0"/></mvParamMin>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double xCenter,
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0.0"/></mvParamMin>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			/// Specifies the y-coordinate of the center of the polar transformation with respect to
			/// the origin (top left corner) of the source image
			double yCenter,
			/// Specifies the start angle in degrees. If \a fromAngle is greater than \a toAngle, the image will be
			/// transformed in clockwise direction. If \a fromAngle is smaller than \a toAngle, the
			/// image will be transformed in counter-clockwise direction.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0.0"/></mvParamMin>
			/// <mvParamMax><mvParamConst value="360.0"/></mvParamMax>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double fromAngle,
			/// Specifies the angle in degrees where the transformation is stopped.
			/// The image data found at this angle is included in the destination image.
			/// If \a fromAngle is greater than \a toAngle, the image will be
			/// transformed in clockwise direction. If \a fromAngle is smaller than \a toAngle, the
			/// image will be transformed in counter-clockwise direction.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0.0"/></mvParamMin>
			/// <mvParamMax><mvParamConst value="360.0"/></mvParamMax>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double toAngle,
			/// Specifies the start position (in pixel) from where to start unwinding. The results of
			/// the polar transformation starting at FromSize will be projected into the destination
			/// buffer to the first row. The results of the next position will be projected into the next
			/// row of the destination buffer aso..
			/// In case of a circular unwind operation, it should
			/// be a number between 0..extent/2 (\a xExtend and \a yExtent are the same for a circular unwind
			/// operation). In case of an elliptical unwind operation, it should be a number between
			/// 0..minimum(\a xExtend, \a yExtend)/2.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="min(%(xExtend)s,%(yExtend)s)/2"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int fromSize,
			/// Specifies the (inclusive) end position where to stop unwinding. In case of a circular
			/// unwind operation, it should be a number between 0..extent/2 (\a xExtend and \a yExtend are
			/// the same for a circular unwind operation). In case of an elliptical unwind operation,
			/// it should be a number between 0..minimum(\a xExtend, \a yExtend)/2.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="min(%(xExtend)s,%(yExtend)s)/2"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int toSize,
			/// Specifies the angle step width (in degrees) used during the transformation. The
			/// smaller the step width the bigger the width of the resulting image.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0.01"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="abs(%(fromAngle)s-%(toAngle)s)"/></mvParamMax>
			/// <mvParamStep>0.01</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double angleStep,
			/// Specifies the rotation angle of the operation. The rotation angle is most useful, if
			/// you want to process oblique elliptical objects. In all other cases it should be set to 0.
			/// If you process circular objects, the rotation angle can be seen as an offset that is
			/// added to the \a fromAngle parameter.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0.0"/></mvParamMin>
			/// <mvParamMax><mvParamConst value="360.0"/></mvParamMax>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double rotationAngle = 0.0f,
			/// Specifies the operation mode used for pixel interpolation.
			GeometricInterpolation mode = giBilinear
			);



/// \brief Unwinds an image (polar transformation).

/// This function unwinds a section in the source image \a source using the specified coordinates and
/// stores the unwinded image in the destination buffer specified with \a dest. The function allows you to unwind circles
/// and circular arcs as well as ellipses and elliptical arcs. Additionally, when using
/// elliptical objects, you can unwind them even if they are placed in oblique direction
/// (please see \c rotationAngle parameter). The destination image will always be of rectanglar
/// shape where the width and height will be determined by the \a angleStep and
/// \a fromSize/ \a toSize parameters.<br>
/// The following image explains the various parameters of the function:
/// \image html images/mvi_base/Unwind_Explanation.png
/// \note An elliptical unwind operation may introduce distortions at the left and
/// \note right side of the destination image.
/// \see mvIMPACT::Image
//-----------------------------------------------------------------------------
 void unwind (
			/// The destination image.
			Image& dest,
			/// The source image.
			const Image& source,
			/// Specifies the x-extent of the area to be transformed. It is relative to the position
			/// of xCenter.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int xExtend,
			/// Specifies the y-extent of the area to be transformed. It is relative to the position
			/// of yCenter.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int yExtend,
			/// Specifies the y-coordinate of the center of the polar transformation with respect to
			/// the origin (top left corner) of the source image
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0.0"/></mvParamMin>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double xCenter,
			/// Specifies the y-coordinate of the center of the polar transformation with respect to
			/// the origin (top left corner) of the source image
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0.0"/></mvParamMin>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double yCenter,
			/// Specifies the start angle in degrees. If \a fromAngle is greater than \a toAngle, the image will be
			/// transformed in clockwise direction. If \a fromAngle is smaller than \a toAngle, the
			/// image will be transformed in counter-clockwise direction.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0.0"/></mvParamMin>
			/// <mvParamMax><mvParamConst value="360.0"/></mvParamMax>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double fromAngle,
			/// Specifies the angle in degrees where the transformation is stopped.
			/// The image data found at this angle is included in the destination image.
			/// If \a fromAngle is greater than \a toAngle, the image will be
			/// transformed in clockwise direction. If \a fromAngle is smaller than \a toAngle, the
			/// image will be transformed in counter-clockwise direction.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0.0"/></mvParamMin>
			/// <mvParamMax><mvParamConst value="360.0"/></mvParamMax>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double toAngle,
			/// Specifies the start position (in pixel) from where to start unwinding. The results of
			/// the polar transformation starting at FromSize will be projected into the destination
			/// buffer to the first row. The results of the next position will be projected into the next
			/// row of the destination buffer aso..
			/// In case of a circular unwind operation, it should
			/// be a number between 0..extent/2 (\a xExtend and \a yExtent are the same for a circular unwind
			/// operation). In case of an elliptical unwind operation, it should be a number between
			/// 0..minimum(\a xExtend, \a yExtend)/2.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="min(%(xExtend)s,%(yExtend)s)/2"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int fromSize,
			/// Specifies the (inclusive) end position where to stop unwinding. In case of a circular
			/// unwind operation, it should be a number between 0..extent/2 (\a xExtend and \a yExtend are
			/// the same for a circular unwind operation). In case of an elliptical unwind operation,
			/// it should be a number between 0..minimum(\a xExtend, \a yExtend)/2.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="min(%(xExtend)s,%(yExtend)s)/2"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int toSize,
			/// Specifies the angle step width (in degrees) used during the transformation. The
			/// smaller the step width the bigger the width of the resulting image.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0.01"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="abs(%(fromAngle)s-%(toAngle)s)"/></mvParamMax>
			/// <mvParamStep>0.01</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double angleStep,
			/// Specifies the rotation angle of the operation. The rotation angle is most useful, if
			/// you want to process oblique elliptical objects. In all other cases it should be set to 0.
			/// If you process circular objects, the rotation angle can be seen as an offset that is
			/// added to the \a fromAngle parameter.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0.0"/></mvParamMin>
			/// <mvParamMax><mvParamConst value="360.0"/></mvParamMax>
			/// <mvParamStep>0.1</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double rotationAngle = 0.0f,
			/// Specifies the operation mode used for pixel interpolation.
			GeometricInterpolation mode = giBilinear
			);



 /////////////////////////////////////////////////////////////////
 // vl_file functions



/// \brief The file format specifier.

/// Specifies a file format. This enumeration contains built-in file formats.
/// You can also have extended file formats that are specified in the file.fmt
/// configuration file. To use one of the extended file formats, you need to
/// cast its id value to #FileFormat.
enum FileFormat
{
	/// Any file format.
	ffAny=mvIMPACT_C::FL_DONT_CARE,
	/// The windows bmp file format.
	ffBmp=mvIMPACT_C::IPL_BMP,
	/// The tiff file format.
	ffTiff=mvIMPACT_C::IPL_TIFF,
	/// The rle file format.
	ffRle=mvIMPACT_C::IPL_RLE,
};


/// \brief The file datatype.

/// Specifies the datatype of the pixels in the file. Supports 8 bit and 16 bit.
/// For 16 bit data, you can specify Little Endian (Intel) and
/// Big Endian (Motorola) modes.
enum FileDatatype
{
	/// 8 bit.
	fdUChar=mvIMPACT_C::FL_DTUCHAR,
	/// 16 bit nonswapped (Intel, Little Endian).
	fdUShort=mvIMPACT_C::FL_DTUSHORT,
	/// 16 bit swapped (Motorola, Big Endian).
	fdUShortSwapped=mvIMPACT_C::FL_DTUSHORT | mvIMPACT_C::IPL_SWAPBYTES,
};


/// \brief Pixel color arrangement flags.

/// For color images, pixels can be arranged in a planar format (i.e. first
/// all pixels of the read plane, then the green plane, then the blue plane) or
/// in a packed format (i.e. RGBRGB...).
enum FileOrganization
{
	/// Planar: RRR...RGGG...GBBB...B
	foPlanar=mvIMPACT_C::IPL_PLANAR,
	/// Interleaved: RGBRGBRGB...RGB
	foInterleaved=mvIMPACT_C::FL_RGB,
};



/// \brief Load an image from a file.

/// This function imports data from a specified file format into an image.
/// - Loading a BMP type file:
/// You can load 1, 4, 8 and 24 bit uncompressed BMP files. If the number
/// of bits per sample is 1 or 4, the function casts them to 8, because
/// only 8 bit buffers can be processed.
/// - Loading a TIFF type file:
/// You can import uncompressed 8, 16- and 24-bit (true color RGB) TIFF-files.
/// The baselines TIFF spec Rev. 5.0 for grayscale and RGB images are supported.
/// The function supports byte swapping (if necessary) when reading a 16-bit
/// monochrome image.
/// - Loading from an extended file format:
/// The type of image supported is entirely defined by the file format filter.
/// File format filters should be written to support at least one-band and
/// three-band images as well as the 8-bit and 16-bit data types.
///
/// \note Palette data is not read, even if it would be available in the file.
/// \see #FileFormat
/// \see mvIMPACT::Image
/// \see mvIMPACT::saveImage
/// \see mvIMPACT::loadImageWithPalette
/// \see mvIMPACT::loadRawImage
/// \see mvIMPACT::loadImageSequence
//-----------------------------------------------------------------------------
Image loadImage(
		/// Specifies the file to be opened for reading. You can use a filename
		/// only or a complete path with pathname and filename. If you specify a
		/// filename only, the function first looks in the current directory, then
		/// in the directory specified with the VL_FILE_DIR environment variable.
		const std::string& fileName,
		/// Specifies the file type. It can be set to one of the following constants:
		/// - ::ffBmp : a BMP type file.
		/// - ::ffTiff : a TIFF type file.
		/// - any id value supported through dynamically loaded file format filters
		/// as specified in the file.fmt file.
		/// - ::ffAny : The #FileFormat parameter will be ignored. The function
		/// tries to distinguish the file format using the file extension. Valid file
		/// extensions are:
		/// 		- "tif" for a TIFF format file.
		/// 		- "bmp" for a BMP format file.
		/// 		- or any file extensions that are supported through dynamically
		///       loaded file format filters. File format filter extensions are
		///       matched before the built-in extensions are matched. Thus, if you
		///       have a file format filter that matches "tif", this filter will
		///       always be used if you specify ::ffAny. If you absolutely
		///       want to use the intrinsic TIFF format, you have to specify
		///       ::ffTiff directly.
		FileFormat fileFormat=ffAny);


/// \brief Load an image from a file.

/// This function imports data from a specified file format into an image.
/// - Loading a BMP type file:
/// You can load 1, 4, 8 and 24 bit uncompressed BMP files. If the number
/// of bits per sample is 1 or 4, the function casts them to 8, because
/// only 8 bit buffers can be processed.
/// - Loading a TIFF type file:
/// You can import uncompressed 8, 16- and 24-bit (true color RGB) TIFF-files.
/// The baselines TIFF spec Rev. 5.0 for grayscale and RGB images are supported.
/// The function supports byte swapping (if necessary) when reading a 16-bit
/// monochrome image.
/// - Loading from an extended file format:
/// The type of image supported is entirely defined by the file format filter.
/// File format filters should be written to support at least one-band and
/// three-band images as well as the 8-bit and 16-bit data types.
///
/// \note Palette data is not read, even if it would be available in the file.
/// \see #FileFormat
/// \see mvIMPACT::Image
/// \see mvIMPACT::saveImage
/// \see mvIMPACT::loadImageWithPalette
/// \see mvIMPACT::loadRawImage
/// \see mvIMPACT::loadImageSequence
//-----------------------------------------------------------------------------
void loadImage (
		/// A reference to an mvIMPACT::Image that will receive the data of the file loaded.
		/// The properties of this image must be set properly concerning the
		/// following parameters:
		/// - Datatype: ::bdUChar or ::bdUShort (for a 16-bit TIFF file)
		/// - Number of bands: 1 for a monochrome image, 3 for a color image.
		/// - Number of slices: must be set to 1.
		/// - Number of frames: must be set to 1.
		Image& dest,
		/// Specifies the file to be opened for reading. You can use a filename
		/// only or a complete path with pathname and filename. If you specify a
		/// filename only, the function first looks in the current directory, then
		/// in the directory specified with the VL_FILE_DIR environment variable.
		const std::string& fileName,
		/// Specifies the file type. It can be set to one of the following constants:
		/// - ::ffBmp : a BMP type file.
		/// - ::ffTiff : a TIFF type file.
		/// - any id value supported through dynamically loaded file format filters
		/// as specified in the file.fmt file.
		/// - ::ffAny : The FileFormat parameter will be ignored. The function
		/// tries to distinguish the file format using the file extension. Valid file
		/// extensions are:
		/// 		- "tif" for a TIFF format file.
		/// 		- "bmp" for a BMP format file.
		/// 		- or any file extensions that are supported through dynamically
		///       loaded file format filters. File format filter extensions are
		///       matched before the built-in extensions are matched. Thus, if you
		///       have a file format filter that matches "tif", this filter will
		///       always be used if you specify ::ffAny. If you absolutely
		///       want to use the intrinsic TIFF format, you have to specify
		///       ::ffTiff directly.
		FileFormat fileFormat=ffAny
		);


/// \brief Load an image and a palette from a file.

/// This function imports data from a specified file format into an image.
/// It returns the new mvIMPACT::Image object as well as the corresponding mvIMPACT::Palette object.
/// - Loading a BMP type file:
/// You can load 1, 4, 8 and 24 bit uncompressed BMP files. If the number
/// of bits per sample is 1 or 4, the function casts them to 8, because
/// only 8 bit buffers can be processed.
/// - Loading a TIFF type file:
/// You can import uncompressed 8, 16- and 24-bit (true color RGB) TIFF-files.
/// The baselines TIFF spec Rev. 5.0 for grayscale and RGB images are supported.
/// The function supports byte swapping (if necessary) when reading a 16-bit
/// monochrome image.
/// - Loading from an extended file format:
/// The type of image supported is entirely defined by the file format filter.
/// File format filters should be written to support at least one-band and
/// three-band images as well as the 8-bit and 16-bit data types.
///
/// \see #FileFormat
/// \see mvIMPACT::Palette
/// \see mvIMPACT::Image
/// \see mvIMPACT::loadImage
/// \see mvIMPACT::saveImage
/// \see mvIMPACT::loadRawImage
/// \see mvIMPACT::loadImageSequence
//-----------------------------------------------------------------------------
std::pair<Image, Palette> loadImageWithPalette (
						/// Specifies the file to be opened for reading. You can use a filename
						/// only or a complete path with pathname and filename. If you specify a
						/// filename only, the function first looks in the current directory, then
						/// in the directory specified with the VL_FILE_DIR environment variable.
						const std::string& fileName,
						/// Specifies the file type. It can be set to one of the following constants:
						/// - ::ffBmp : a BMP type file.
						/// - ::ffTiff : a TIFF type file.
						/// - any id value supported through dynamically loaded file format filters
						/// as specified in the file.fmt file.
						/// - ::ffAny : The FileFormat parameter will be ignored. The function
						/// tries to distinguish the file format using the file extension. Valid file
						/// extensions are:
						/// 		- "tif" for a TIFF format file.
						/// 		- "bmp" for a BMP format file.
						/// 		- or any file extensions that are supported through dynamically
						///       loaded file format filters. File format filter extensions are
						///       matched before the built-in extensions are matched. Thus, if you
						///       have a file format filter that matches "tif", this filter will
						///       always be used if you specify ::ffAny. If you absolutely
						///       want to use the intrinsic TIFF format, you have to specify
						///       ::ffTiff directly.
						FileFormat         fileFormat=ffAny
						);







/// \brief Load an image and a palette from a file.

/// This function imports data from a specified file format into an image.
/// It returns the new mvIMPACT::Image object as well as the corresponding mvIMPACT::Palette object.
/// - Loading a BMP type file:
/// You can load 1, 4, 8 and 24 bit uncompressed BMP files. If the number
/// of bits per sample is 1 or 4, the function casts them to 8, because
/// only 8 bit buffers can be processed.
/// - Loading a TIFF type file:
/// You can import uncompressed 8, 16- and 24-bit (true color RGB) TIFF-files.
/// The baselines TIFF spec Rev. 5.0 for grayscale and RGB images are supported.
/// The function supports byte swapping (if necessary) when reading a 16-bit
/// monochrome image.
/// - Loading from an extended file format:
/// The type of image supported is entirely defined by the file format filter.
/// File format filters should be written to support at least one-band and
/// three-band images as well as the 8-bit and 16-bit data types.
///
/// \see #FileFormat
/// \see mvIMPACT::Palette
/// \see mvIMPACT::Image
/// \see mvIMPACT::loadImage
/// \see mvIMPACT::saveImage
/// \see mvIMPACT::loadRawImage
/// \see mvIMPACT::loadImageSequence
//-----------------------------------------------------------------------------
void loadImageWithPalette (
			   /// A reference to an mvIMPACT::Image that will receive the data of the file loaded.
			   /// The properties of this image must be set properly concerning the
			   /// following parameters:
			   /// - Datatype: ::bdUChar or ::bdUShort (for a 16-bit TIFF file)
			   /// - Number of bands: 1 for a monochrome image, 3 for a color image.
			   /// - Number of slices: must be set to 1.
			   /// - Number of frames: must be set to 1.
			   Image& destImage,
			   /// A reference to a mvIMPACT::Palette that will receive the palette data of the file
			   /// loaded.
			   /// The properties of this palette must be set properly concerning the
			   /// following parameters:
			   /// - Datatype: ::bdUChar.
			   /// - Number of bands: 3.
			   /// - Number of slices: must be set to 1.
			   /// - Number of frames: must be set to 1.
			   Palette& destPalette,
			   /// Specifies the file to be opened for reading. You can use a filename
			   /// only or a complete path with pathname and filename. If you specify a
			   /// filename only, the function first looks in the current directory, then
			   /// in the directory specified with the VL_FILE_DIR environment variable.
			   const std::string& fileName,
			   /// Specifies the file type. It can be set to one of the following constants:
			   /// - ::ffBmp : a BMP type file.
			   /// - ::ffTiff : a TIFF type file.
			   /// - any id value supported through dynamically loaded file format filters
			   /// as specified in the file.fmt file.
			   /// - ::ffAny : The FileFormat parameter will be ignored. The function
			   /// tries to distinguish the file format using the file extension. Valid file
			   /// extensions are:
			   /// 		- "tif" for a TIFF format file.
			   /// 		- "bmp" for a BMP format file.
			   /// 		- or any file extensions that are supported through dynamically
			   ///       loaded file format filters. File format filter extensions are
			   ///       matched before the built-in extensions are matched. Thus, if you
			   ///       have a file format filter that matches "tif", this filter will
			   ///       always be used if you specify ::ffAny. If you absolutely
			   ///       want to use the intrinsic TIFF format, you have to specify
			   ///       ::ffTiff directly.
			   FileFormat fileFormat=ffAny
			   );




/// \brief Load an image from a file, using a raw file format.

/// This function imports data from a raw file into an image and returns the result.
/// \note Palette data is not read, even if it would be available in the file.
/// \see #FileDatatype
/// \see #FileOrganization
/// \see mvIMPACT::Image
/// \see mvIMPACT::loadImage
/// \see mvIMPACT::saveImage
/// \see mvIMPACT::loadImageWithPalette
/// \see mvIMPACT::loadImageSequence
//-----------------------------------------------------------------------------
Image loadRawImage (
		    /// Specifies the file to be opened for reading. You can use a filename
		    /// only or a complete path with pathname and filename. If you specify a
		    /// filename only, the function first looks in the current directory, then
		    /// in the directory specified with the VL_FILE_DIR environment variable.
		    const std::string& fileName,
		    /// Specifies the width of the file bitmap in pixel.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int width,
		    /// Specifies the height of the file bitmap in pixel.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int height,
		    /// Specifies the number of bands of the file bitmap.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int bands,
		    /// Specifies the data type of the file bitmap data. It can be set to one of
		    /// the following constants:
		    /// - ::fdUChar : the file data will be interpreted as 8 bit (per pixel).
		    /// - ::fdUShort : the file data will be interpreted as 16 bit little endian
		    /// (per pixel).
		    /// - ::fdUShortSwapped : the file data will be interpreted as 16 bit big
		    /// endian (per pixel).
		    FileDatatype fileDatatype,
		    /// Specifies how the sample values are stored in the file. It can be set to
		    /// any value of the ::FileOrganization enumeration.
		    FileOrganization fileOrganization,
		    /// Specifies the pixel pitch (distance between pixels to be read) in count
		    /// items (not in bytes).Thus this parameter does not depend on the datatype of the bitmap
		    /// specified with \a fileDatatype. The default value is 1. If you have for example a
		    /// RGB image, where the data is stored as RGB, RGB, ..., you can specify a
		    /// pixel pitch of 3 to get the data of a single plane (if you get the red,
		    /// green or blue component, depending on the \a offset parameter).
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int pitch,
		    /// Specifies the file offset in bytes from the beginning of the file to the
		    /// first data byte of the bitmap data where to start reading. Use this to skip the file header.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int offset=0
		    );




/// \brief Load an image from a file, using a raw file format.

/// This function imports data from a raw file into an image.
/// The contents are written to the mvIMPACT::Image object specified with \a dest.
/// \note Palette data is not read, even if it would be available in the file.
/// \see #FileDatatype
/// \see #FileOrganization
/// \see mvIMPACT::Image
/// \see mvIMPACT::loadImage
/// \see mvIMPACT::saveImage
/// \see mvIMPACT::loadImageWithPalette
/// \see mvIMPACT::loadImageSequence
//-----------------------------------------------------------------------------
void loadRawImage (
			/// A reference to a mvIMPACT::Image that will receive the data of the file loaded.
			/// The properties of this image must be set properly concerning the
			/// following parameters:
			/// - Datatype: ::bdUChar or ::bdUShort (for a 16-bit TIFF file)
			/// - Number of bands: 1 for a monochrome image, 3 for a color image.
			/// - Number of slices: must be set to 1.
			/// - Number of frames: must be set to the number of consecutive frames loaded.
			Image& dest,
			/// Specifies the file to be opened for reading. You can use a filename
			/// only or a complete path with pathname and filename. If you specify a
			/// filename only, the function first looks in the current directory, then
			/// in the directory specified with the VL_FILE_DIR environment variable.
			const std::string& fileName,
			/// Specifies the width of the file bitmap in pixel.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int width,
			/// Specifies the height of the file bitmap in pixel.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int height,
			/// Specifies the number of bands of the file bitmap.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int bands,
			/// Specifies the data type of the file bitmap data. It can be set to one of
			/// the following constants:
			/// - ::fdUChar : the file data will be interpreted as 8 bit (per pixel).
			/// - ::fdUShort : the file data will be interpreted as 16 bit little endian
			/// (per pixel).
			/// - ::fdUShortSwapped : the file data will be interpreted as 16 bit big
			/// endian (per pixel).
			FileDatatype fileDatatype,
			/// Specifies how the sample values are stored in the file. It can be set to
			/// any value of the ::FileOrganization enumeration.
			FileOrganization fileOrganization,
			/// Specifies the pixel pitch (distance between pixels to be read) in count
			/// items (not in bytes). Thus this parameter does not depend on the datatype of the bitmap
			/// specified with \a fileDatatype. The default value is 1. If you have for example a
			/// RGB image, where the data is stored as RGB, RGB, ..., you can specify a
			/// pixel pitch of 3 to get the data of a single plane (if you get the red,
			/// green or blue component, depending on the \a offset parameter).
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int pitch,
			/// Specifies the file offset in bytes from the beginning of the file to the
			/// first data byte of the bitmap data where to start reading. Use this to skip the file header.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// </mvParamRange>
			/// \endxmlonly
			int offset=0
			);




/// \brief Load an image sequence from a set of subsequently numbered files.

/// This function loads sequentially numbered files, until the sequence is exhausted and returns the resulting mvIMPACT::Image.
/// The sequence is loaded as a frame-sequence.
/// File names of the subsequent images are built either by appending a
/// 1 and monotonically increasing it or by monotonically increasing an
/// already existing number at the end of the given file name.
/// -  Loading a BMP type file:
/// You can load 1, 4, 8 and 24 bit uncompressed BMP files. If
/// the number of bits per sample is 1 or 4, the function casts them to 8, because only 8 bit
/// buffers can be processed.
/// -  Loading a TIFF type file:
/// You can import uncompressed 8, 16- and 24-bit (true color
/// RGB) TIFF-files. The baselines TIFF spec Rev. 5.0 for grayscale and RGB images are
/// supported. .
/// The function supports byte swapping (if necessary) when reading a 16-bit
/// monochrome image.
/// -  Loading from an extended file format: The type of image and palette supported is
/// entirely defined by the file format filter. File format filters should be written to support
/// at least one-band and three-band images as well as the 8-bit and 16-bit data types.
/// \note Palette data is not read, even if it would be available in the file.
/// \see #FileFormat
/// \see mvIMPACT::Image
/// \see mvIMPACT::loadImageSequenceWithPalette
/// \see mvIMPACT::loadImage
/// \see mvIMPACT::saveImage
/// \see mvIMPACT::loadImageWithPalette
/// \see mvIMPACT::loadRawImage
//-----------------------------------------------------------------------------
Image loadImageSequence (
			 /// Specifies the file to be opened for reading. You can use a filename
			 /// only or a complete path with pathname and filename. If you specify a
			 /// filename only, the function first looks in the current directory, then
			 /// in the directory specified with the VL_FILE_DIR environment variable.
			 /// This filename is treated as the base filename for all further images
			 /// of the sequence.
			 const std::string& fileName,
			 /// Specifies the file type. It can be set to one of the following constants:
			 /// - ::ffBmp : a BMP type file.
			 /// - ::ffTiff : a TIFF type file.
			 /// - any id value supported through dynamically loaded file format filters
			 /// as specified in the file.fmt file.
			 /// - ::ffAny : The #FileFormat parameter will be ignored. The function
			 /// tries to distinguish the file format using the file extension. Valid file
			 /// extensions are:
			 /// 		- "tif" for a TIFF format file.
			 /// 		- "bmp" for a BMP format file.
			 /// 		- or any file extensions that are supported through dynamically
			 ///       loaded file format filters. File format filter extensions are
			 ///       matched before the built-in extensions are matched. Thus, if you
			 ///       have a file format filter that matches "tif", this filter will
			 ///       always be used if you specify ::ffAny. If you absolutely
			 ///       want to use the intrinsic TIFF format, you have to specify
			 ///       ::ffTiff directly.
			 FileFormat fileFormat=ffAny
			 );



/// \brief Load an image sequence from a set of subsequently numbered files.
///
/// This function loads sequentially numbered files, until the sequence is exhausted and stores the result in the mvIMPACT::Image object
/// given with \a dest. The sequence is loaded as a frame-sequence.
/// File names of the subsequent images are built either by appending a
/// 1 and monotonically increasing it or by monotonically increasing an
/// already existing number at the end of the given file name.
/// -  Loading a BMP type file:
/// You can load 1, 4, 8 and 24 bit uncompressed BMP files. If
/// the number of bits per sample is 1 or 4, the function casts them to 8, because only 8 bit
/// buffers can be processed.
/// -  Loading a TIFF type file:
/// You can import uncompressed 8, 16- and 24-bit (true color
/// RGB) TIFF-files. The baselines TIFF spec Rev. 5.0 for grayscale and RGB images are
/// supported. .
/// The function supports byte swapping (if necessary) when reading a 16-bit
/// monochrome image.
/// -  Loading from an extended file format: The type of image and palette supported is
/// entirely defined by the file format filter. File format filters should be written to support
/// at least one-band and three-band images as well as the 8-bit and 16-bit data types.
/// \note Palette data is not read, even if it would be available in the file.
/// \see #FileFormat
/// \see mvIMPACT::Image
/// \see mvIMPACT::loadImageSequenceWithPalette
/// \see mvIMPACT::loadImage
/// \see mvIMPACT::saveImage
/// \see mvIMPACT::loadImageWithPalette
/// \see mvIMPACT::loadRawImage
//-----------------------------------------------------------------------------
void loadImageSequence (
			/// A reference to a mvIMPACT::Image that will receive the data of the file loaded.
			/// The properties of this image must be set properly concerning the
			/// following parameters:
			/// - Datatype: ::bdUChar or ::bdUShort (for a 16-bit TIFF file)
			/// - Number of bands: 1 for a monochrome image, 3 for a color image.
			/// - Number of slices: must be set to 1.
			/// - Number of frames: must be set to the number of consecutive frames loaded.
			Image& dest,
			/// Specifies the file to be opened for reading. You can use a filename
			/// only or a complete path with pathname and filename. If you specify a
			/// filename only, the function first looks in the current directory, then
			/// in the directory specified with the VL_FILE_DIR environment variable.
			/// This filename is treated as the base filename for all further images
			/// of the sequence.
			const std::string& fileName,
			/// Specifies the file type. It can be set to one of the following constants:
			/// - ::ffBmp : a BMP type file.
			/// - ::ffTiff : a TIFF type file.
			/// - any id value supported through dynamically loaded file format filters
			/// as specified in the file.fmt file.
			/// - ::ffAny : The FileFormat parameter will be ignored. The function
			/// tries to distinguish the file format using the file extension. Valid file
			/// extensions are:
			/// 		- "tif" for a TIFF format file.
			/// 		- "bmp" for a BMP format file.
			/// 		- or any file extensions that are supported through dynamically
			///       loaded file format filters. File format filter extensions are
			///       matched before the built-in extensions are matched. Thus, if you
			///       have a file format filter that matches "tif", this filter will
			///       always be used if you specify ::ffAny. If you absolutely
			///       want to use the intrinsic TIFF format, you have to specify
			///       ::ffTiff directly.
			FileFormat fileFormat=ffAny
			);






/// \brief Load an image sequence and a palette from a set of subsequently numbered files.

/// This function loads sequentially numbered files, until the sequence is exhausted and returns the resulting mvIMPACT::Image and
/// the corresponding mvIMPACT::Palette object.
/// The sequence is loaded as a frame-sequence.
/// File names of the subsequent images are built either by appending a
/// 1 and monotonically increasing it or by monotonically increasing an
/// already existing number at the end of the given file name.
/// -  Loading a BMP type file:
/// You can load 1, 4, 8 and 24 bit uncompressed BMP files. If
/// the number of bits per sample is 1 or 4, the function casts them to 8, because only 8 bit
/// buffers can be processed.
/// -  Loading a TIFF type file:
/// You can import uncompressed 8, 16- and 24-bit (true color
/// RGB) TIFF-files. The baselines TIFF spec Rev. 5.0 for grayscale and RGB images are
/// supported. .
/// The function supports byte swapping (if necessary) when reading a 16-bit
/// monochrome image.
/// -  Loading from an extended file format: The type of image and palette supported is
/// entirely defined by the file format filter. File format filters should be written to support
/// at least one-band and three-band images as well as the 8-bit and 16-bit data types.
/// \see #FileFormat
/// \see mvIMPACT::Palette
/// \see mvIMPACT::Image
/// \see mvIMPACT::loadImageSequence
/// \see mvIMPACT::loadImage
/// \see mvIMPACT::saveImage
/// \see mvIMPACT::loadImageWithPalette
/// \see mvIMPACT::loadRawImage
//-----------------------------------------------------------------------------
std::pair<Image, Palette> loadImageSequenceWithPalette (
							/// Specifies the file to be opened for reading. You can use a filename
							/// only or a complete path with pathname and filename. If you specify a
							/// filename only, the function first looks in the current directory, then
							/// in the directory specified with the VL_FILE_DIR environment variable.
							/// This filename is treated as the base filename for all further images
							/// of the sequence.
							const std::string& fileName,
							/// Specifies the file type. It can be set to one of the following constants:
							/// - ::ffBmp : a BMP type file.
							/// - ::ffTiff : a TIFF type file.
							/// - any id value supported through dynamically loaded file format filters
							/// as specified in the file.fmt file.
							/// - ::ffAny : The FileFormat parameter will be ignored. The function
							/// tries to distinguish the file format using the file extension. Valid file
							/// extensions are:
							/// 		- "tif" for a TIFF format file.
							/// 		- "bmp" for a BMP format file.
							/// 		- or any file extensions that are supported through dynamically
							///       loaded file format filters. File format filter extensions are
							///       matched before the built-in extensions are matched. Thus, if you
							///       have a file format filter that matches "tif", this filter will
							///       always be used if you specify ::ffAny. If you absolutely
							///       want to use the intrinsic TIFF format, you have to specify
							///       ::ffTiff directly.
							FileFormat fileFormat=ffAny
							);






/// \brief Load an image sequence and a palette from a set of subsequently numbered files.

/// This function loads sequentially numbered files, until the sequence is exhausted. The image sequence is
/// stored in the mvIMPACT::Image object given with parameter \a destImage. The corresponding palette
/// is stored in the mvIMPACT::Palette object given with parameter \a destPalette.
/// The sequence is loaded as a frame-sequence.
/// File names of the subsequent images are built either by appending a
/// 1 and monotonically increasing it or by monotonically increasing an
/// already existing number at the end of the given file name.
/// -  Loading a BMP type file:
/// You can load 1, 4, 8 and 24 bit uncompressed BMP files. If
/// the number of bits per sample is 1 or 4, the function casts them to 8, because only 8 bit
/// buffers can be processed.
/// -  Loading a TIFF type file:
/// You can import uncompressed 8, 16- and 24-bit (true color
/// RGB) TIFF-files. The baselines TIFF spec Rev. 5.0 for grayscale and RGB images are
/// supported. .
/// The function supports byte swapping (if necessary) when reading a 16-bit
/// monochrome image.
/// -  Loading from an extended file format: The type of image and palette supported is
/// entirely defined by the file format filter. File format filters should be written to support
/// at least one-band and three-band images as well as the 8-bit and 16-bit data types.
/// \see #FileFormat
/// \see mvIMPACT::Palette
/// \see mvIMPACT::Image
/// \see mvIMPACT::loadImageSequence
/// \see mvIMPACT::loadImage
/// \see mvIMPACT::saveImage
/// \see mvIMPACT::loadImageWithPalette
/// \see mvIMPACT::loadRawImage
//-----------------------------------------------------------------------------
void loadImageSequenceWithPalette (
				   /// A reference to a mvIMPACT::Image that will receive the data of the file loaded.
				   /// The properties of this image must be set properly concerning the
				   /// following parameters:
				   /// - Datatype: ::bdUChar or ::bdUShort (for a 16-bit TIFF file)
				   /// - Number of bands: 1 for a monochrome image, 3 for a color image.
				   /// - Number of slices: must be set to 1.
				   /// - Number of frames: must be set to the number of consecutive frames loaded.
				   Image& destImage,
				   /// A reference to a mvIMPACT::Palette that will receive the palette data of the file
				   /// loaded.
				   /// The properties of this palette must be set properly concerning the
				   /// following parameters:
				   /// - Datatype: ::bdUChar.
				   /// - Number of bands: 3.
				   /// - Number of slices: must be set to 1.
				   /// - Number of frames: must be set to 1.
				   Palette& destPalette,
				   /// Specifies the file to be opened for reading. You can use a filename
				   /// only or a complete path with pathname and filename. If you specify a
				   /// filename only, the function first looks in the current directory, then
				   /// in the directory specified with the VL_FILE_DIR environment variable.
				   /// This filename is treated as the base filename for all further images
				   /// of the sequence.
				   const std::string& fileName,
				   /// Specifies the file type. It can be set to one of the following constants:
				   /// - ::ffBmp : a BMP type file.
				   /// - ::ffTiff : a TIFF type file.
				   /// - any id value supported through dynamically loaded file format filters
				   /// as specified in the file.fmt file.
				   /// - ::ffAny : The FileFormat parameter will be ignored. The function
				   /// tries to distinguish the file format using the file extension. Valid file
				   /// extensions are:
				   /// 		- "tif" for a TIFF format file.
				   /// 		- "bmp" for a BMP format file.
				   /// 		- or any file extensions that are supported through dynamically
				   ///       loaded file format filters. File format filter extensions are
				   ///       matched before the built-in extensions are matched. Thus, if you
				   ///       have a file format filter that matches "tif", this filter will
				   ///       always be used if you specify ::ffAny. If you absolutely
				   ///       want to use the intrinsic TIFF format, you have to specify
				   ///       ::ffTiff directly.
				   FileFormat format=ffAny
				   );






/// \brief Save an image and an optional palette to a file.

/// This function exports an mvIMPACT::Image to a file of the specified format.
/// - Exporting to a BMP type file:
///   You can save an mvIMPACT::Image as a 8 (one band) or 24 bit (three bands)
///   uncompressed BMP file. Palette data are exported only, if the mvIMPACT::Image consists
///   of one band (monochrome).
/// - Exporting to a TIFF type file:
///   You can save an mvIMPACT::Image as a 8 bit (one band, monochrome), 16 bit
///   (one band, monochrome) and 24 bit (three bands, color) TIFF-file. Right now,
///   only INTEL type byte ordering is supported.
///
///   In the case of 8 or 16 bit grayscale images, the function supports the tags
///   recommended by the TIFF specs Rev 5.0 for a Tiff grayscale image (class G).
///   The data will be written into a single strip.
///
///   In the case of 24 bit true color images, the function supports the tags
///   recommended by the TIFF specs Rev 5.0 for a TIFF true color image (class R).
///   The values for R, G and B will be written into a single bit plane (RGB,
///   RGB, etc.).
///
///   Palette data can only be exported to a TIFF file, if the buffer consists of
///   one band (monochrome) .
/// - Exporting to an extended file format:
///   The type of image and palette supported is entirely defined by the
///   file format filter. File format filters should be written to support
///   at least one-band and three-band images as well as the 8-bit and 16-bit
///   data types.
/// \see #FileFormat
/// \see mvIMPACT::Image
/// \see mvIMPACT::Palette
/// \see mvIMPACT::loadImage
/// \see mvIMPACT::loadImageWithPalette
/// \see mvIMPACT::saveImageSequence
//-----------------------------------------------------------------------------
void saveImage (
		/// Specifies the image to save.
		const Image& src,
		/// Specifies the file to be opened for writing. You can use a filename
		/// only or a complete path with pathname and filename. If you specify a
		/// filename only, the function first looks in the current directory, then
		/// in the directory specified with the VL_FILE_DIR environment variable.
		/// An existing file with the same name will be overwritten.
		const std::string& fileName,
		/// Specifies the file type. It can be set to one of the following constants:
		/// - ::ffBmp : a BMP type file.
		/// - ::ffTiff : a TIFF type file.
		/// - any id value supported through dynamically loaded file format filters
		/// as specified in the file.fmt file.
		/// - ::ffAny : The FileFormat parameter will be ignored. The function
		/// tries to distinguish the file format using the file extension. Valid file
		/// extensions are:
		/// 		- "tif" for a TIFF format file.
		/// 		- "bmp" for a BMP format file.
		/// 		- or any file extensions that are supported through dynamically
		///       loaded file format filters. File format filter extensions are
		///       matched before the built-in extensions are matched. Thus, if you
		///       have a file format filter that matches "tif", this filter will
		///       always be used if you specify ::ffAny. If you absolutely
		///       want to use the intrinsic TIFF format, you have to specify
		///       ::ffTiff directly.
		FileFormat fileFormat=ffAny,
		/// Specifies an optional palette.
		Palette* pal=0
		);





/// \brief Save an image sequence and an optional palette to a set of subsequently numbered files.

/// This function exports an mvIMPACT::Image sequence to a set of files of the specified format.
/// - Exporting to a BMP type file:
///   You can save an mvIMPACT::Image as a 8 (one band) or 24 bit (three bands)
///   uncompressed BMP file. Palette data are exported only, if the mvIMPACT::Image consists
///   of one band (monochrome).
/// - Exporting to a TIFF type file:
///   You can save an mvIMPACT::Image as a 8 bit (one band, monochrome), 16 bit
///   (one band, monochrome) and 24 bit (three bands, color) TIFF-file. Right now,
///   only INTEL type byte ordering is supported.
///
///   In the case of 8 or 16 bit grayscale images, the function supports the tags
///   recommended by the TIFF specs Rev 5.0 for a Tiff grayscale image (class G).
///   The data will be written into a single strip.
///
///   In the case of 24 bit true color images, the function supports the tags
///   recommended by the TIFF specs Rev 5.0 for a TIFF true color image (class R).
///   The values for R, G and B will be written into a single bit plane (RGB,
///   RGB, etc.).
///
///   Palette data can only be exported to a TIFF file, if the buffer consists of
///   one band (monochrome) .
/// - Exporting to an extended file format:
///   The type of image and palette supported is entirely defined by the
///   file format filter. File format filters should be written to support
///   at least one-band and three-band images as well as the 8-bit and 16-bit
///   data types.
///
/// File names of the subsequent images are built either by appending a 1 and
/// monotonically increasing it or by monotonically increasing an already
/// existing number at the end.
/// \see #FileFormat
/// \see mvIMPACT::Image
/// \see mvIMPACT::Palette
/// \see mvIMPACT::loadImage
/// \see mvIMPACT::loadImageWithPalette
/// \see mvIMPACT::saveImage
//-----------------------------------------------------------------------------
void saveImageSequence (
			/// Specifies the image to save.
			/// The image must have multiple frames in order to get more that one file on the disk!
			const Image& src,
			/// Specifies the name of the first file to be opened for writing.
			/// You can use a filename only or a complete path with pathname and
			/// filename. If you specify a filename only, the function saves
			/// in the directory specified with the VL_FILE_DIR environment variable.
			/// An existing file with the same name will be overwritten.
			const std::string& fileName,
			/// Specifies the file type. It can be set to one of the following constants:
			/// - ::ffBmp : a BMP type file.
			/// - ::ffTiff : a TIFF type file.
			/// - any id value supported through dynamically loaded file format filters
			/// as specified in the file.fmt file.
			/// - ::ffAny : The FileFormat parameter will be ignored. The function
			/// tries to distinguish the file format using the file extension. Valid file
			/// extensions are:
			/// 		- "tif" for a TIFF format file.
			/// 		- "bmp" for a BMP format file.
			/// 		- or any file extensions that are supported through dynamically
			///       loaded file format filters. File format filter extensions are
			///       matched before the built-in extensions are matched. Thus, if you
			///       have a file format filter that matches "tif", this filter will
			///       always be used if you specify ::ffAny. If you absolutely
			///       want to use the intrinsic TIFF format, you have to specify
			///       ::ffTiff directly.
			FileFormat fileFormat=ffAny,
			/// Specifies an optional palette.
			Palette* palette=0
			);



/// \brief An mvIMPACT::ImageInfo object allows you to inquire information about a file containing
/// \brief  an image.
///
/// An ImageInfo object is used to retrieve information about an
/// mvIMPACT::Image file without loading it into memory.
/// The information that can be retrieved includes the following:
/// - Width
/// - Height
/// - Samples per pixel
/// - Bits per sample
/// - Compression
/// - Palette
/// - Sequence length
/// \see mvIMPACT::Image
//-----------------------------------------------------------------------------
class ImageInfo
//-----------------------------------------------------------------------------
{
public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
	/// standard constructor only exists for DOTNET wrapper to work
	ImageInfo();
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS


  /// \brief Construct an ImageInfo object.

  /// Loads the information from the specified file.
  /// \see #FileFormat
  /// \see mvIMPACT::Image
  ImageInfo(
	    /// Specifies the file to be opened for reading. You can use a filename
	    /// only or a complete path with pathname and filename. If you specify a
	    /// filename only, the function first looks in the current directory, then
	    /// in the directory specified with the VL_FILE_DIR environment variable.
	    const std::string& fileName,
	    /// Specifies the file type. It can be set to one of the following constants:
	    /// - ::ffBmp : a BMP type file.
	    /// - ::ffTiff : a TIFF type file.
	    /// - any id value supported through dynamically loaded file format filters
	    /// as specified in the file.fmt file.
	    /// - ::ffAny : The FileFormat parameter will be ignored. The function
	    /// tries to distinguish the file format using the file extension. Valid file
	    /// extensions are:
	    /// 		- "tif" for a TIFF format file.
	    /// 		- "bmp" for a BMP format file.
	    /// 		- or any file extensions that are supported through dynamically
	    ///       loaded file format filters. File format filter extensions are
	    ///       matched before the built-in extensions are matched. Thus, if you
	    ///       have a file format filter that matches "tif", this filter will
	    ///       always be used if you specify ::ffAny. If you absolutely
	    ///       want to use the intrinsic TIFF format, you have to specify
	    ///       ::ffTiff directly.
	    FileFormat fileFormat=ffAny);


  /// \brief Inquire the width of an image in a file.
  ///
  /// \see mvIMPACT::Image::getWidth
  int getWidth() const;


  /// \brief Inquire the height of an image in a file.
  ///
  /// \see mvIMPACT::Image::getHeight
  int getHeight() const;


  /// \brief Inquire the samples per pixel of an image in a file.
  ///
  /// This is 1 for monochrome images and 3 for color images.
  /// \see mvIMPACT::Image::getBands
  int getSamplesPerPixel() const;


  /// \brief Inquire the bits per sample of an image in a file.
  ///
  /// This depends on the datatype of the image (8 or 16 bit)
  /// \see mvIMPACT::Image::getDatatypeSize
  int getBitsPerSample() const;


  /// \brief Inquire the compression status of an image in a file.
  ///
  /// Returns \c true if the image is compressed within the file,
  /// or \c false otherwise.
  bool getIsCompressed() const;


  /// \brief Inquire if an image in a file contains a palette.
  ///
  /// Return \c true if the file contains a palette,
  /// or \c false if not.
  bool getHasPalette() const;


  /// \brief Inquire the sequence length of an image sequence made up from a set of
  /// subsequently numbered files.
  ///
  /// \see mvIMPACT::Image::getFrames
  int getSequenceLength() const;


 private:
  std::string fileName_;
  FileFormat fileFormat_;
};

 /////////////////////////////////////////////////////////////////
 // vl_slice functions




/// \brief Specifies the orthogonal projection direction.

/// Used to get orthogonal slices of a multidimensional buffer.
enum OrthogonalProjection
{

	/// \brief A horizontal cut, top to bottom.

	/// The following projection will be performed:<br>
	/// x-dimension source --> x-dimension destination <BR>
	/// depth-dimension (band,z,time) source --> y-dimension destination top to bottom
	opXTopToBottom=mvIMPACT_C::SL_XCUT | mvIMPACT_C::SL_TOP_PRJ,

	/// \brief A horizontal cut, bottom to top.

	/// The following projection will be performed: <BR>
	/// x-dimension source --> x-dimension destination <BR>
	/// depth-dimension (band,z,time) source --> y-dimension destination bottom to top
	opXBottomToTop=mvIMPACT_C::SL_XCUT | mvIMPACT_C::SL_BOTTOM_PRJ,


	/// \brief A vertical cut, left to right.

	/// The following projection will be performed: <BR>
	/// depth-dimension (band,z,time) source --> x-dimension destination left to right
	/// y-dimension source --> y-dimension in destination
	opYLeftToRight=mvIMPACT_C::SL_YCUT | mvIMPACT_C::SL_LEFT_PRJ,

	/// \brief A vertical cut, right to left.

	/// The following projection will be performed: <BR>
	/// depth-dimension (band,z,time) source --> x-dimension destination right to left
	/// y-dimension source --> y-dimension in destination
	opYRightToLeft=mvIMPACT_C::SL_YCUT | mvIMPACT_C::SL_RIGHT_PRJ,
};


/// \brief Specifies the oblique projection direction.

/// Used to get oblique slices of a multidimensional buffer.
enum ObliqueProjection
{
	/// An xy cut, left to right.
	opXYLeftToRight=mvIMPACT_C::SL_XY | mvIMPACT_C::SL_LEFT_PRJ,
	/// An xy cut, right to left.
	opXYRightToLeft=mvIMPACT_C::SL_XY | mvIMPACT_C::SL_RIGHT_PRJ,
	/// A zy cut, top to bottom.
	opZYTopToBottom=mvIMPACT_C::SL_ZY | mvIMPACT_C::SL_TOP_PRJ,
	/// A zy cut, bottom to top.
	opZYBottomToTop=mvIMPACT_C::SL_ZY | mvIMPACT_C::SL_BOTTOM_PRJ,
	/// An xz cut, left to right.
	opXZLeftToRight=mvIMPACT_C::SL_XZ | mvIMPACT_C::SL_LEFT_PRJ,
	/// An xz cut, right to left.
	opXZRightToLeft=mvIMPACT_C::SL_XZ | mvIMPACT_C::SL_RIGHT_PRJ,
};


/// \brief Generates a 3D line profile.
//!
//! This function performs a 3D-line profile operation using the specified
//! source buffer and returns the results in a profile buffer.
//! Although the function lets you specify coordinates of five dimensions,
//! you can use only three of them depending on the dimensions the source
//! buffer consists of.
//! The x- and y-position of the start- and end points must be set in any case.
//! The third dimension that can be used depends on the number of bands, z-slices
//! and time-slices of the source buffer.
//!
//! Example: If you have a buffer that consists of 2 z-slices and each z-slice
//! consists of 3 bands, the band coordinate of the start and end point must be
//! set to equal values ranging from 0..2. In this case, the band coordinate
//! specifies from which band to get the data when accessing subsequent z-slices.
//! The time coordinates T0 and T1 must be set to 0.
//!
//! If \a startCoord and \a endCoord differ in more than 1 of the dimensions band, slice and frame,
//! an exception is thrown.
//!
//! All x/y coordinates must be set with respect to the buffer origin (top left
//! corner). The start and end points are included.
//! \return The destination Profile.
//-----------------------------------------------------------------------------
 Profile lineProfile3d(
	/// The source Image buffer. Normally, the source buffer consists of multiple
	/// dimensions (i.e. multiple z-slices that could represent a data volume set).
	const Image& source,
	/// coordinates of start point
	const Coord &startCoord,
	/// coordinates of end point
	const Coord &endCoord
);


/// \brief Generates a 3D line profile.
//!
//! This function performs a 3D-line profile operation using the specified
//! source buffer and writes the results into the specified profile buffer.
//! Although the function lets you specify coordinates of five dimensions,
//! you can use only three of them depending on the dimensions the source
//! buffer consists of.
//! The x- and y-position of the start- and end points must be set in any case.
//! The third dimension that can be used depends on the number of bands, z-slices
//! and time-slices of the source buffer.
//!
//! Example: If you have a buffer that consists of 2 z-slices and each z-slice
//! consists of 3 bands, the band coordinate of the start and end point must be
//! set to equal values ranging from 0..2. In this case, the band coordinate
//! specifies from which band to get the data when accessing subsequent z-slices.
//! The time coordinates T0 and T1 must be set to 0.
//!
//! If \a startCoord and \a endCoord differ in more than 1 of the dimensions band, slice and frame,
//! an exception is thrown.
//!
//! All x/y coordinates must be set with respect to the buffer origin (top left
//! corner). The start and end points are included.
//-----------------------------------------------------------------------------
 void lineProfile3d(
	/// The destination Profile buffer. The datatype of this buffer must match
	/// the datatype of the source Image buffer.
	Profile& dest,
	/// The source Image buffer. Normally, the source buffer consists of multiple
	/// dimensions (i.e. multiple z-slices that could represent a data volume set).
	const Image& source,
	/// coordinates of start point.
	const Coord &startCoord,
	/// coordinates of end point.
	const Coord &endCoord
);


/// \brief Gets an orthogonal slice out of a data volume (multidimensional imag)
///
/// This function allows you to get orthogonal slices out of a multidimensional
/// source data buffer. Each slice will be projected to a two dimensional
/// destination image which is passed as parameter \a dest.
/// The destination image \a dest must be a two
/// dimensional (x,y) buffer and must have the same datatype as the source image \a source.
/// The following figure shows the functionality when \a orthogonalProjection is set to
/// ::opXBottomToTop :
/// \image html images/mvi_base/OrthogonalSlice_XBottomToTop.png
/// The following figure shows the functionality when Mode is set to
/// ::opYRightToLeft :
/// \image html images/mvi_base/OrthogonalSlice_YRightToLeft.png
/// \see #OrthogonalProjection
/// \see mvIMPACT::Image
/// \see mvIMPACT::obliqueSlice
//-----------------------------------------------------------------------------
 void orthogonalSlice(
				/// Specifies the destination image. The destination image must be a
				/// two dimensional (x,y) buffer and must have the same datatype as the source
				/// image \a source.
				Image& dest,
				/// Specifies the source image. Normally, the source buffer consists
				/// of multiple dimensions (i.e. multiple z-slices that could represent a
				/// data volume set).
				const Image& source,
				/// Specifies the orthogonal projection direction.
				OrthogonalProjection orthogonalProjection,
				/// Position of cut with respect to projection (defines the X- or Y-position
				/// depending on the setting of \a orthogonalProjection)
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
				/// <mvParamMax><mvParamComplex Python="(((%(source)s.width-1,%(source)s.width-1),(%(source)s.height-1,None)),((%(source)s.height-1,None),(None,None)))[%(orthogonalProjection)s==opXTopToBottom][%(orthogonalProjection)s==opXBottomToTop][%(orthogonalProjection)s==opYLeftToRight]"/></mvParamMax>
				/// </mvParamRange>
				/// \endxmlonly
				int cut,
				/// Specifies the zero-based band offset from which to get data. If you have
				/// a buffer, for example, that consists of multiple z-slices and each z-slice
				/// consists of multiple bands, you can specify from which band to get the data.
				/// Otherwise set to 0.
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
				/// <mvParamMax><mvParamComplex Python="%(source)s.bands-1"/></mvParamMax>
				/// </mvParamRange>
				/// \endxmlonly
				int band=0,
				/// Specifies the zero-based z-slice offset from which to get data. If you
				/// have a buffer, for example, that consists of multiple time-slices and each
				/// time-slice consists of multiple z-sclices, you can specify from which
				/// z-slice to get the data. Otherwise 0.
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
				/// <mvParamMax><mvParamComplex Python="%(source)s.slices-1"/></mvParamMax>
				/// </mvParamRange>
				/// \endxmlonly
				int slice=0,
				/// Specifies the zero-based time-slice offset from which to get data.
				/// Normally set to 0.
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
				/// <mvParamMax><mvParamComplex Python="%(source)s.frames-1"/></mvParamMax>
				/// </mvParamRange>
				/// \endxmlonly
				int frame=0);



/// \brief Gets an orthogonal slice out of a data volume (multidimensional imag)
///
/// This function returns an orthogonal slice out of a multidimensional
/// source data buffer.
/// The following figure shows the functionality when \a orthogonalProjection is set to
/// ::opXBottomToTop :
/// \image html images/mvi_base/OrthogonalSlice_XBottomToTop.png
/// The following figure shows the functionality when Mode is set to
/// ::opYRightToLeft :
/// \image html images/mvi_base/OrthogonalSlice_YRightToLeft.png
/// \see #OrthogonalProjection
/// \see mvIMPACT::Image
/// \see mvIMPACT::obliqueSlice
//-----------------------------------------------------------------------------
Image orthogonalSlice(
				/// Specifies the source image. Normally, the source buffer consists
				/// of multiple dimensions (i.e. multiple z-slices that could represent a
				/// data volume set).
				const Image& source,
				/// Specifies the orthogonal projection direction.
				OrthogonalProjection orthogonalProjection,
				/// Position of cut with respect to projection (defines the X- or Y-position
				/// depending on the setting of \a orthogonalProjection)
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
				/// <mvParamMax><mvParamComplex Python="(((%(source)s.width-1,%(source)s.width-1),(%(source)s.height-1,None)),((%(source)s.height-1,None),(None,None)))[%(orthogonalProjection)s==opXTopToBottom][%(orthogonalProjection)s==opXBottomToTop][%(orthogonalProjection)s==opYLeftToRight]"/></mvParamMax>
				/// </mvParamRange>
				/// \endxmlonly
				int cut,
				/// Specifies the zero-based band offset from which to get data. If you have
				/// a buffer, for example, that consists of multiple z-slices and each z-slice
				/// consists of multiple bands, you can specify from which band to get the data.
				/// Otherwise set to 0.
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
				/// <mvParamMax><mvParamComplex Python="%(source)s.bands-1"/></mvParamMax>
				/// </mvParamRange>
				/// \endxmlonly
				int band=0,
				/// Specifies the zero-based z-slice offset from which to get data. If you
				/// have a buffer, for example, that consists of multiple time-slices and each
				/// time-slice consists of multiple z-sclices, you can specify from which
				/// z-slice to get the data. Otherwise 0.
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
				/// <mvParamMax><mvParamComplex Python="%(source)s.slices-1"/></mvParamMax>
				/// </mvParamRange>
				/// \endxmlonly
				int slice=0,
				/// Specifies the zero-based time-slice offset from which to get data.
				/// Normally set to 0.
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
				/// <mvParamMax><mvParamComplex Python="%(source)s.frames-1"/></mvParamMax>
				/// </mvParamRange>
				/// \endxmlonly
				int frame=0);



/// \brief Gets a slice in oblique direction from a multidimensional source buffer.
///
/// This function returns an  oblique slices out of a multidimensional
/// source image. Each slice will be projected to a two dimensional
/// destination buffer.
/// The following figure shows the functionality when \c projection is set to
/// ::opXYRightToLeft :
/// \image html images/mvi_base/ObliqueSlice_XYRightToLeft.png
/// \see mvIMPACT::Image
/// \see mvIMPACT::orthogonalSlice
//-----------------------------------------------------------------------------
Image obliqueSlice(
			/// Specifies the source buffer handle. Normally, the source buffer consists
			/// of multiple dimensions (i.e. multiple z-slices that could represent a
			/// data volume set).
			const Image& source,
			/// Specifies the oblique projection direction. It can be set to one of the
			/// following constants:
			/// - ::opXYLeftToRight <BR>
			/// 		The following projection will be performed: <BR>
			/// 		depth-dimension (band,z,time)source --> x-dimension destination left to right<BR>
			/// 	x,y dimension source --> y-dimension destination
			/// - ::opXYRightToLeft <BR>
			/// 		The following projection will be performed: <BR>
			/// 		depth-dimension (band,z,time)source --> x-dimension destination right to left<BR>
			/// 	x,y dimension source --> y-dimension destination
			/// - ::ZYTopToBottom <BR>
			/// 		The following projection will be performed: <BR>
			/// 	x-dimension source --> x-dimension destination <BR>
			/// 	z,y dimension source --> y-dimension destination top to bottom
			/// - ::ZYBottomToTop <BR>
			/// 		The following projection will be performed: <BR>
			/// 	x-dimension source --> x-dimension destination <BR>
			/// 	z,y dimension source --> y-dimension destination bottom to top
			/// - ::XZLeftToRight <BR>
			/// 		The following projection will be performed: <BR>
			/// 	x,z-dimension source --> x-dimension destination left to right<BR>
			/// 	y-dimension source --> y-dimension destination
			/// - ::XZRightToLeft <BR>
			/// 		The following projection will be performed: <BR>
			/// 	x,z-dimension source --> x-dimension destination right to left<BR>
			/// 	y-dimension source --> y-dimension destination
			ObliqueProjection projection,
			/// First point's coordinates.
			const Point& fromPoint,
			/// Second point's coordinates.
			const Point& toPoint,
			/// Specifies the zero-based band offset from which to get data. If you have
			/// a buffer for example, that consists of multiple z-slices and each z-slice
			/// consists of multiple bands, you can specify from which band to get the
			/// data. Otherwise set to 0.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(source)s.bands-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int band=0,
			/// Specifies the zero-based z-slice offset from which to get data. If you have
			/// a buffer for example, that consists of multiple time-slices and each
			/// time-slice consists of multiple z-sclices, you can specify from which
			/// z-slice to get the data. Otherwise set to 0.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(source)s.slices-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int slice=0,
			/// Specifies the zero-based time-slice offset from which to get data. Normally
			/// set to 0.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(source)s.frames-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int frame=0);


/// \brief Gets a slice in oblique direction from a multidimensional source buffer.

/// This function returns an  oblique slices out of a multidimensional
/// source image. Each slice will be projected to a two dimensional
/// destination buffer.
/// The following figure shows the functionality when \c projection is set to
/// ::opXYRightToLeft :
/// \image html images/mvi_base/ObliqueSlice_XYRightToLeft.png
/// \see mvIMPACT::Image
/// \see mvIMPACT::orthogonalSlice
//-----------------------------------------------------------------------------
void obliqueSlice(
			/// Specifies the destination buffer handle. The destination buffer must be a
			/// two dimensional (x,y) buffer and must have the same datatype as the source
			/// buffer.
			Image& dest,
			/// Specifies the source buffer handle. Normally, the source buffer consists
			/// of multiple dimensions (i.e. multiple z-slices that could represent a
			/// data volume set).
			const Image& source,
			/// Specifies the oblique projection direction. It can be set to one of the
			/// following constants:
			/// - ::opXYLeftToRight <BR>
			/// 		The following projection will be performed: <BR>
			/// 		depth-dimension (band,z,time)source --> x-dimension destination left to right<BR>
			/// 	x,y dimension source --> y-dimension destination
			/// - ::opXYRightToLeft <BR>
			/// 		The following projection will be performed: <BR>
			/// 		depth-dimension (band,z,time)source --> x-dimension destination right to left<BR>
			/// 	x,y dimension source --> y-dimension destination
			/// - ::ZYTopToBottom <BR>
			/// 		The following projection will be performed: <BR>
			/// 	x-dimension source --> x-dimension destination <BR>
			/// 	z,y dimension source --> y-dimension destination top to bottom
			/// - ::ZYBottomToTop <BR>
			/// 		The following projection will be performed: <BR>
			/// 	x-dimension source --> x-dimension destination <BR>
			/// 	z,y dimension source --> y-dimension destination bottom to top
			/// - ::XZLeftToRight <BR>
			/// 		The following projection will be performed: <BR>
			/// 	x,z-dimension source --> x-dimension destination left to right<BR>
			/// 	y-dimension source --> y-dimension destination
			/// - ::XZRightToLeft <BR>
			/// 		The following projection will be performed: <BR>
			/// 	x,z-dimension source --> x-dimension destination right to left<BR>
			/// 	y-dimension source --> y-dimension destination
			ObliqueProjection projection,
			/// First point's coordinates.
			const Point& fromPoint,
			/// Second point's coordinates.
			const Point& toPoint,
			/// Specifies the zero-based band offset from which to get data. If you have
			/// a buffer for example, that consists of multiple z-slices and each z-slice
			/// consists of multiple bands, you can specify from which band to get the
			/// data. Otherwise set to 0.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(source)s.bands-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int band=0,
			/// Specifies the zero-based z-slice offset from which to get data. If you have
			/// a buffer for example, that consists of multiple time-slices and each
			/// time-slice consists of multiple z-sclices, you can specify from which
			/// z-slice to get the data. Otherwise set to 0.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(source)s.slices-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int slice=0,
			/// Specifies the zero-based time-slice offset from which to get data. Normally
			/// set to 0.
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(source)s.frames-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int frame=0);


#ifndef I386_LINUX
/// \brief The type of the object of interest.
enum OoiType
{
	/// Unspecified type.
	otNone=-1,

	/// Point, PointOfInterest
	otPoi=0,

	/// Line, LineOfInterest
	otLoi,

	/// Area, AreaOfInterest
	otAoi,

	/// Ellipse, EllipseOfInterest
	otEoi,

	/// Polyline, PolylineOfInterest
	otPloi,

	/// Polygon, PolygonOfInterest
	otPgoi,

	/// Array of lines, LineArrayOfInterest
	otAloi,

	/// Barcode visualizer, BarcodeVisualizer
	otCr1d,

	/// Datamatrix visualizer, DatamatrixVisualizer
	otCr2dDm,
};



/// \brief The profile drawing direction.
///
/// These constants determine the drawing direction of a profile.
/// \see mvIMPACT::Window::setProfileDrawingDir
enum ProfileDirection
{
	/// Displays a profile horizontally.
	pdHorizontal=mvIMPACT_C::DISP_PROFILE_HORIZONTAL,
	/// Displays a profile vertically.
	pdVertical=mvIMPACT_C::DISP_PROFILE_VERTICAL
};



/// \brief The histogram drawing mode.
///
/// These constants determine the histogram drawing mode.
/// \see mvIMPACT::Window::setHistogramDrawingMode
enum HistogramMode
{
	/// Displays a histogram normally.
	hmNormal=mvIMPACT_C::DISP_HISTOGRAM_NORMAL,
	/// Displays a histogram accumulated.
	hmAccumulated=mvIMPACT_C::DISP_HISTOGRAM_ACCUMULATED
};



/// \brief The image drawing mode.
///
/// These constants determine the image drawing mode.
/// \see mvIMPACT::Window::setImageDrawingMode
enum ImageMode
{
	/// Displays an image graphically.
	imGraphic=mvIMPACT_C::DISP_IMAGE_GRAPHIC,
	/// Displays an image numerically.
	imNumeric=mvIMPACT_C::DISP_IMAGE_NUMERIC
};


/// \brief The copy clipboard mode.
///
/// These constants determine how a window is copied to the clipboard.
/// \see mvIMPACT::Window::setClipboardMode
enum CopyClipboardMode
{
	/// Copy the client area only.
	ccmClient=mvIMPACT_C::DISP_COPYCLIENT,
	/// Copy the whole window with title bar and frame.
	ccmWindow=mvIMPACT_C::DISP_COPYWHOLE
};


/// \brief The zoom mode.
///
/// These constants determine how window contents are zoomed.
/// \see mvIMPACT::Window::setZoomMode
enum ZoomingMode
{
	/// Zoom to fit into client area.
	zmFit=mvIMPACT_C::DISP_ZOOM_FIT,
	/// Zoom by factors.
	zmFactors=mvIMPACT_C::DISP_ZOOM_FACTORS,
	/// Zoom fit preserving aspect ratio.
	zmFitAspect=mvIMPACT_C::DISP_ZOOM_FIT_ASPECT
};


/// \brief The scrollbar mode
///
/// This enumeration lists possible scrollbar modes.
/// \see mvIMPACT::Window::setScrollbarMode
enum ScrollingMode
{
	/// Disable scrollbars if not needed.
	smDisable=mvIMPACT_C::DISP_SCROLLBAR_DISABLE,
	/// Hide scrollbars if not needed.
	smHide=mvIMPACT_C::DISP_SCROLLBAR_HIDE,
	/// Never show scrollbars.
	smNever=mvIMPACT_C::DISP_SCROLLBAR_NEVER
};

/// Refelects the states of the mouse buttons
///
/// Several functions make use of mouse buttons. This
/// enumeration lists the possible mouse button ids. The values of this enumeration
/// may be ORed to specify several buttons at once.
enum MouseButton
{
	/// No mouse button.
	mbNone          = mvIMPACT_C::DISP_NOBUTTON,
	/// Left mouse button.
	mbLButton       = mvIMPACT_C::DISP_LBUTTON,
	/// Middle mouse button.
	mbMButton       = mvIMPACT_C::DISP_MBUTTON,
	/// Right mouse button.
	mbRButton       = mvIMPACT_C::DISP_RBUTTON,
	/// Extended mouse button 1.
	mbXButton1      = mvIMPACT_C::DISP_XBUTTON1,
	/// Extended mouse button 2.
	mbXButton2      = mvIMPACT_C::DISP_XBUTTON2,
	/// Keyboard shift key.
	mbShiftButton   = mvIMPACT_C::DISP_SHIFT_BUTTON,
	/// Keyboard control key.
	mbControlButton = mvIMPACT_C::DISP_CONTROL_BUTTON
};



/// \brief This class represents a device context to draw on.
///
/// This class provides several functions to draw overlays (lines,circles histograms etc.) during a callback.
/// The callback methods are provided by class mvIMPACT::Window and class mvIMPACT::display3d::Window3D .
/// Drawing onto the device context does not affect the underlying buffer, i.e. the image data will not be modified.
/// Please use the drawing functions of class mvIMPACT::Image if you want to modify the actual image data.
/// \note Use of this class is only valid inside the callback methods that deliver an instance of DeviceContext.
/// \note Do not try to use such an object outside the callback methods, since the underlying OS device context is released as soon as
/// \note the callback method ends.
/// \see mvIMPACT::Window
/// \see mvIMPACT::display3d::Window3D
/// \see mvIMPACT::Image::drawEllipse
/// \see mvIMPACT::Image::drawPolygon
/// \see mvIMPACT::Image::drawRectangle
/// \see mvIMPACT::Image::drawLine
/// \see mvIMPACT::Image::drawPoint


class DeviceContext
{
private:
	mvIMPACT_C::IPL_HDC m_dc;

public:

#ifndef DOXYGEN_SHOULD_SKIP_THIS
	/// Constructor needed by the DOTNET wrapper, initializes
	/// m_dc to NULL.
	DeviceContext();
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

	/// Construct a DeviceContext object from an integer.
	DeviceContext(int handle);

#ifndef WRAP_ANY
	/// Construct a DeviceContext object from a portable IPL_HDC handle.
	DeviceContext(mvIMPACT_C::IPL_HDC hdc);

	/// Convert to a portable handle.
	operator mvIMPACT_C::IPL_HDC() const;

	/// Convert to an integer.
	operator int() const;

	/// Convert to a portable handle.
	mvIMPACT_C::IPL_HDC ConvertToDeviceContextHandle() const;

	// 64bit support makes sense for 64bit capable compilers only
#ifdef _M_X64
	/// Convert to an integer (64 bit).
	long long ConvertToInteger64() const;
#endif // #ifdef _M_X64

#endif // #ifndef WRAP_ANY

	/// Convert to an integer.
	int ConvertToInteger() const;


  /// \brief Draws a buffer graphically.

  /// This function draws images, palettes, profiles and histograms onto
  /// a drawing canvas.
  ///
  /// \note Actual drawing is affected by various settings that can be selected using
  /// \note the methods of class mvIMPACT::Window. As a side-effect, the function
  /// \note may change settings in the passed device context. If this is undesirable,
  /// \note you should bracket calls with SaveDC/RestoreDC.
  /// \note Do not use outside a callback method!
  /// \see mvIMPACT::Rectangle
  /// \see mvIMPACT::BufferBase
  void draw(
	    /// Buffer to draw. You can pass images, palettes, profiles and histograms
	    /// to this function.
	    const BufferBase& src,
	    /// Specifies a portion of the buffer that is to be drawn. The rectangle
	    /// must be normalized.
	    const Rectangle& sourceRect,
	    /// Specifies a portion of the drawing canvas to draw into. The
	    /// portion specified with source is zoomed to fit into the portion of the
	    /// drawing canvas specified with dest.
	    const Rectangle& destRect);


  /// \brief Draws a buffer graphically.

  /// This function draws images, palettes, profiles and histograms onto
  /// a drawing canvas.
  ///
  /// \note Actual drawing is affected by various settings that can be selected using
  /// \note the methods of class mvIMPACT::Window. As a side-effect, the function
  /// \note may change settings in the passed device context. If this is undesirable,
  /// \note you should bracket calls with SaveDC/RestoreDC.
  /// \note Do not use outside a callback method!
  /// \see mvIMPACT::Rectangle
  /// \see mvIMPACT::BufferBase
  void draw(
	    /// Buffer to draw. You can pass images, palettes, profiles and histograms
	    /// to this function.
	    const BufferBase& source,
	    /// Specifies both a portion of the buffer that is to be drawn and a portion of
	    /// the drawing canvas to draw into. The rectangle must be normalized.
	    const Rectangle& sourceRect);



  /// \brief Draws a buffer graphically.

  /// This function draws images, palettes, profiles and histograms onto
  /// a drawing canvas.
  ///
  /// \note Actual drawing is affected by various settings that can be selected using
  /// \note the methods of class mvIMPACT::Window. As a side-effect, the function
  /// \note may change settings in the passed device context. If this is undesirable,
  /// \note you should bracket calls with SaveDC/RestoreDC.
  /// \note Do not use outside a callback method!
  /// \see mvIMPACT::BufferBase
  void draw(
	    /// Buffer to draw. You can pass images, palettes, profiles and histograms
	    /// to this function.
	    const BufferBase& source
	    );



  /// \brief Draws an elliptical arc segment.

  /// The \c rect parameter specifies the bounding rectangle. An ellipse formed
  /// by the bounding rectangle defines the curve of the arc. The arc extends
  /// in the drawing direction (clockwise or counter-clockwise) from the point
  /// where it intersects the radial from the center of the bounding rectangle
  /// to the start point. The arc ends where it intersects the radial from the
  /// center of the bounding rectangle to the end point. If the start point
  /// and end points are the same, a full ellipse is drawn.
  /// \note Do not use outside a callback method!
  /// \see mvIMPACT::RGBColor
  /// \see mvIMPACT::Rectangle
  /// \see mvIMPACT::Point
  void drawArc (
		/// A bounding rectangle.
		const Rectangle& rect,
		/// Start angle location.
		const Point& startPoint,
		/// End angle location.
		const Point& endPoint,
		/// \c true means clockwise, whereas \c false means counter-clockwise.
		bool  directionClockwise,
		/// Color of the arc.
		const RGBColor& color
		);



  /// \brief Draws an ellipse.

  /// The \c rect parameter specifies the bounding rectangle.
  /// \note Do not use outside a callback method!
  /// \see mvIMPACT::Rectangle
  /// \see mvIMPACT::RGBColor
  void drawEllipse
    (
     /// A bounding rectangle.
     const Rectangle& rect,
     /// Color of the ellipse.
     const RGBColor& color
     );



  /// \brief This function draws a histogram onto a drawing canvas.

  /// \note Actual drawing is affected by various settings that can be selected using
  /// \note the methods of class mvIMPACT::Window. As a side-effect, the function
  /// \note may change settings in the passed device context. If this is undesirable,
  /// \note you should bracket calls with SaveDC/RestoreDC.
  /// \note Do not use outside a callback method!
  /// \see mvIMPACT::Histogram
  /// \see mvIMPACT::Window::setHistogramDrawingMode
  void drawHistogram (
		      /// The histogram to draw.
		      const Histogram& source
		      );



  /// \brief Draw a histogram onto a destination area of the drawing canvas.

  /// \note Actual drawing is affected by various settings that can be selected using
  /// \note the methods of class mvIMPACT::Window. As a side-effect, the function
  /// \note may change settings in the passed device context. If this is undesirable,
  /// \note you should bracket calls with SaveDC/RestoreDC.
  /// \note Do not use outside a callback method!
  /// \see mvIMPACT::Histogram
  /// \see mvIMPACT::Rectangle
  /// \see mvIMPACT::Window::setHistogramDrawingMode
  void drawHistogram (
		      /// The histogram to draw.
		      const Histogram& source,
		      /// Destination where the histogram is drawn.
		      const Rectangle& destRect
		      );


  /// \brief Draw a part of a histogram onto a destination area of the drawing canvas.

  /// \note Actual drawing is affected by various settings that can be selected using
  /// \note the methods of class mvIMPACT::Window. As a side-effect, the function
  /// \note may change settings in the passed device context. If this is undesirable,
  /// \note you should bracket calls with SaveDC/RestoreDC.
  /// \note Do not use outside a callback method!
  /// \see mvIMPACT::Histogram
  /// \see mvIMPACT::Rectangle
  /// \see mvIMPACT::Window::setHistogramDrawingMode
  void drawHistogram (
		      /// The histogram to draw.
		      const Histogram& source,
		      /// The source rectangle specifies the part of the histogram that
		      /// is drawn.
		      const Rectangle& sourceRect,
		      /// Destination where the histogram is drawn.
		      const Rectangle& destRect
		      );






  /// \brief Draw an image on a canvas.

  /// This function draws images onto a drawing canvas.
  /// Images can be drawn
  /// graphically and/or numerically.
  /// \note Actual drawing is affected by various settings that can be selected using
  /// \note the methods of class mvIMPACT::Window. As a side-effect, the function
  /// \note may change settings in the passed device context. If this is undesirable,
  /// \note you should bracket calls with SaveDC/RestoreDC.
  /// \note Do not use outside a callback method!
  /// \see mvIMPACT::Image
  /// \see mvIMPACT::Window::setImageDrawingMode
  void drawImage(
		 /// The image to draw.
		 const Image& source
		 );



  /// \brief Draw an image onto a destination area of the drawing canvas.

  /// Images can be drawn
  /// graphically and/or numerically.
  /// \note Actual drawing is affected by various settings that can be selected using
  /// \note the methods of class mvIMPACT::Window. As a side-effect, the function
  /// \note may change settings in the passed device context. If this is undesirable,
  /// \note you should bracket calls with SaveDC/RestoreDC.
  /// \note Do not use outside a callback method!
  /// \see mvIMPACT::Image
  /// \see mvIMPACT::Rectangle
  /// \see mvIMPACT::Window::setImageDrawingMode
  void drawImage  (
		   /// The image to draw.
		   const Image& source,
		   /// Destination where the image is drawn.
		   const Rectangle& destRect
		   );

  /// \brief Draw a part of an image onto a destination area of the drawing canvas.

  /// Images can be drawn
  /// graphically and/or numerically.
  /// \note Actual drawing is affected by various settings that can be selected using
  /// \note the methods of class mvIMPACT::Window. As a side-effect, the function
  /// \note may change settings in the passed device context. If this is undesirable,
  /// \note you should bracket calls with SaveDC/RestoreDC.
  /// \note Do not use outside a callback method!
  /// \see mvIMPACT::Image
  /// \see mvIMPACT::Rectangle
  /// \see mvIMPACT::Window::setImageDrawingMode
  void drawImage (
		  /// The image to draw.
		  const Image& source,
		  /// The source rectangle specifies the part of the image that
		  /// is drawn.
		  const Rectangle& sourceRect,
		  /// Destination where the image is drawn.
		  const Rectangle& destRect
		  );




  /// \brief Draw a line onto the drawing canvas.

  /// Draws a line from \c startPoint to \c endPoint using color \c color .
  /// \note Do not use outside a callback method!
  /// \see mvIMPACT::Point
  /// \see mvIMPACT::RGBColor
  void drawLine (
		 /// Start point of the line.
	       const Point& startPoint,
	       /// End point of the line.
	       const Point& endPoint,
	       /// Color of the line.
	       const RGBColor& color
	       );


  /// Draw a line onto the drawing canvas.

  /// Draws a line from \c startPoint to \c endPoint using color \c color .
  /// \note Do not use outside a callback method!
  /// \see mvIMPACT::Line
  /// \see mvIMPACT::RGBColor
  void drawLine (
		 /// The line to draw
		 const Line& line,
		 /// Color of the line.
		 const RGBColor& color
		 );



  /// \brief This function draws palettes onto a drawing canvas.

  /// \note Actual drawing is affected by various settings that can be selected using
  /// \note the methods of class mvIMPACT::Window. As a side-effect, the function
  /// \note may change settings in the passed device context. If this is undesirable,
  /// \note you should bracket calls with SaveDC/RestoreDC.
  /// \note Do not use outside a callback method!
  /// \see mvIMPACT::Palette
  void drawPalette (
		    /// The palette to draw.
		    const Palette& source
		    );



  /// \brief Draw a palette onto a destination area of the drawing canvas.

  /// \note Actual drawing is affected by various settings that can be selected using
  /// \note the methods of class mvIMPACT::Window. As a side-effect, the function
  /// \note may change settings in the passed device context. If this is undesirable,
  /// \note you should bracket calls with SaveDC/RestoreDC.
  /// \note Do not use outside a callback method!
  /// \see mvIMPACT::Palette
  /// \see mvIMPACT::Rectangle
  void drawPalette (
		    /// The palette to draw.
		    const Palette& source,
		    /// Destination where the palette is drawn.
		    const Rectangle& destRect
		    );




  /// \brief Draw a part of a palette onto a destination area of the drawing canvas.

  /// \note Actual drawing is affected by various settings that can be selected using
  /// \note the methods of class mvIMPACT::Window. As a side-effect, the function
  /// \note may change settings in the passed device context. If this is undesirable,
  /// \note you should bracket calls with SaveDC/RestoreDC.
  /// \note Do not use outside a callback method!
  /// \see mvIMPACT::Palette
  /// \see mvIMPACT::Rectangle
  void drawPalette (
		    /// The palette to draw.
		    const Palette& source,
		    /// The source rectangle specifies the part of the palette that
		    /// is drawn.
		    const Rectangle& sourceRect,
		    /// Destination where the palette is drawn.
		    const Rectangle& destRect
		    );





  /// \brief Draw a point onto the drawing canvas.

  ///
  /// \note Do not use outside a callback method!
  /// \see mvIMPACT::Point
  /// \see mvIMPACT::RGBColor
  void drawPoint (
		  /// Coordinate of the point.
		  const Point& point,
		  /// Color of the point.
		  const RGBColor& color
		  );



  /// \brief This function draws profiles onto a drawing canvas.

  /// \note Actual drawing is affected by various settings that can be selected using
  /// \note the methods of class mvIMPACT::Window. As a side-effect, the function
  /// \note may change settings in the passed device context. If this is undesirable,
  /// \note you should bracket calls with SaveDC/RestoreDC.
  /// \note Do not use outside a callback method!
  /// \see mvIMPACT::Profile
  /// \see mvIMPACT::Window::setProfileDrawingDir
  void drawProfile (
		    /// The profile to draw.
		    const Profile& source
		    );


  /// \brief Draw a profile onto a destination area of the drawing canvas.

  /// \note Actual drawing is affected by various settings that can be selected using
  /// \note the methods of class mvIMPACT::Window. As a side-effect, the function
  /// \note may change settings in the passed device context. If this is undesirable,
  /// \note you should bracket calls with SaveDC/RestoreDC.
  /// \note Do not use outside a callback method!
  /// \see mvIMPACT::Profile
  /// \see mvIMPACT::Rectangle
  /// \see mvIMPACT::Window::setProfileDrawingDir
  void drawProfile (
		    /// The profile to draw.
		    const Profile& source,
		    /// Destination where the profile is drawn.
		    const Rectangle& destRect
		    );


  /// \brief Draw a part of a profile onto a destination area of the drawing canvas.

  /// \note Actual drawing is affected by various settings that can be selected using
  /// \note the methods of class mvIMPACT::Window. As a side-effect, the function
  /// \note may change settings in the passed device context. If this is undesirable,
  /// \note you should bracket calls with SaveDC/RestoreDC.
  /// \note Do not use outside a callback method!
  /// \see mvIMPACT::Profile
  /// \see mvIMPACT::Rectangle
  /// \see mvIMPACT::Window::setProfileDrawingDir
void drawProfile (
		  /// The profile to draw.
		  const Profile& source,
		  /// The source rectangle specifies the part of the profile that
		  /// is drawn.
		  const Rectangle& sourceRect,
		  /// Destination where the profile is drawn.
		  const Rectangle& destRect
		  );

};

class Window;

/// \brief This class represents an object of interest.
///
/// An object of interest, or ooi, is a visual object that can live within the
/// context of a window and provide visual display and/or interaction.
/// 
/// Several types of oois are implemented to visualize different aspects of data.
///
/// For example there is a point of interest to visualize point data. The user can
/// manipulate this point of interest with the mouse or with keyboard keys, so
/// that the point of interest can also be used to input point data.
/// 
/// Many more ooi types are implemented, such as lines, rectangles, ellipses, etc.,
/// to provide a rich set of visual interaction tools.
/// 
/// As class ObjectOfInterest is an abstract class, it cannot be instantiated. Instead,
/// its subclasses can. If we talk about instances of ObjectOfInterest in the
/// following, instances of its subclasses are meant.
///
/// An ooi can only live within the context that a Window provides.
/// An object of interest which is not assigned to a Window is thus empty.
/// If a Window is destroyed, all instances of ObjectOfInterest, which belonged to it, become empty.
///
/// \note This is an abstract class!
///
/// \see mvIMPACT::ObjectOfInterest
/// \see mvIMPACT::PointOfInterest
/// \see mvIMPACT::LineOfInterest
/// \see mvIMPACT::AreaOfInterest
/// \see mvIMPACT::EllipseOfInterest
/// \see mvIMPACT::PolylineOfInterest
/// \see mvIMPACT::PolygonOfInterest
/// \see mvIMPACT::LineArrayOfInterest
/// \see mvIMPACT::BarcodeVisualizer
/// \see mvIMPACT::DatamatrixVisualizer
//-----------------------------------------------------------------------------
class ObjectOfInterest
//-----------------------------------------------------------------------------
{
private:
	friend class Window;
	friend class PointOfInterest;
	friend class LineOfInterest;
	friend class AreaOfInterest;
	friend class EllipseOfInterest;
	friend class PolylineOfInterest;
	friend class PolygonOfInterest;
	friend class LineArrayOfInterest;
	friend class BarcodeVisualizer;
	friend class DatamatrixVisualizer;

	/// Unassigned buffer constant.
	enum { unassigned = -1 };

	/// Pointer to the reference counter.
	int * counter_;

	/// Pointer to the ooi handle.
	mvIMPACT_C::DISP_OOIHANDLE * handle_;

	/// Pointer to window or NULL if ooi is empty.
	Window * window_;

	/// Dispose an ooi. This is the outsourced destructor.
	void dispose();

	/// \brief Construct an empty ooi.
	///
	/// An empty ooi does not have a real ooi allocated in the C layer. It is
	/// just the empty C++ shell.
	///
	/// However, empty oois can be made non-empty by assigning other non-empty
	/// oois to them.
	/// 
	/// Only subclasses have access to this constructor, in order to avoid
	/// 'untyped' objects of interest.
	ObjectOfInterest();

	/// \brief Construct an allocated ooi from a handle.
	/// 
	/// An allocated ooi wraps a real ooi allocated in the C layer.
	/// 
	/// Allocated oois can be made empty by assigning another empty ooi to them.
	/// 
	/// Only subclasses have access to this constructor, in order to avoid
	/// 'untyped' objects of interest.
	ObjectOfInterest(
		/// The window which hosts the ooi.
		const Window & window,
		/// The ooi handle.
		mvIMPACT_C::DISP_OOIHANDLE h);

	/// \brief Construct an allocated ooi.
	/// 
	/// An allocated ooi wraps a real ooi allocated in the C layer.
	/// 
	/// Allocated oois can be made empty by assigning another empty ooi to them.
	/// 
	/// Only subclasses have access to this constructor, in order to avoid
	/// 'untyped' objects of interest.
	ObjectOfInterest(
		/// The window which hosts the ooi.
		const Window & window);

	/// \brief Copy construct an ooi (share ownership, shallow copy).
	ObjectOfInterest(
		/// The ooi to copy from.
		const ObjectOfInterest & r);

#ifndef WRAP_ANY
	/// \brief Overwrite current object with \a src.
	virtual ObjectOfInterest & operator=(
		/// The ooi to assign from.
		const ObjectOfInterest & src);
#endif // #ifndef WRAP_ANY


	PROXY_CLASS_SIMPLE_DECL(Visible, bool, ObjectOfInterest)
	PROXY_CLASS_SIMPLE_DECL(LinesVisible, bool, ObjectOfInterest)
	PROXY_CLASS_SIMPLE_DECL(LinesSolid, bool, ObjectOfInterest)
	PROXY_CLASS_RGBCOLOR_DECL(LineColor, RGBColor, ObjectOfInterest)
	PROXY_CLASS_SIMPLE_DECL(HandleSize, int, ObjectOfInterest)
	PROXY_CLASS_RGBCOLOR_DECL(HandleLineColor, RGBColor, ObjectOfInterest)
	PROXY_CLASS_RGBCOLOR_DECL(HandleFillColor, RGBColor, ObjectOfInterest)
	PROXY_CLASS_SIMPLE_DECL(HandlesVisible, bool, ObjectOfInterest)
	PROXY_CLASS_SIMPLE_DECL(HandleDrawingStyle, unsigned int, ObjectOfInterest)
	PROXY_CLASS_SIMPLE_DECL(Active, bool, ObjectOfInterest)
	PROXY_CLASS_SIMPLE_DECL(UIActive, bool, ObjectOfInterest)
	PROXY_CLASS_SIMPLE_DECL(Selected, bool, ObjectOfInterest)
	PROXY_CLASS_SIMPLE_DECL(FillVisible, bool, ObjectOfInterest)
	PROXY_CLASS_SIMPLE_DECL(FillTransparent, bool, ObjectOfInterest)
	PROXY_CLASS_RGBCOLOR_DECL(FillColor, RGBColor, ObjectOfInterest)
	PROXY_CLASS_SIMPLE_DECL(Text, std::string, ObjectOfInterest)
	PROXY_CLASS_RGBCOLOR_DECL(TextColor, RGBColor, ObjectOfInterest)
	PROXY_CLASS_SIMPLE_DECL(TextVisible, bool, ObjectOfInterest)
	PROXY_CLASS_SIMPLE_DECL(Angle, double, ObjectOfInterest)
	PROXY_CLASS_SIMPLE_DECL(Width, int, ObjectOfInterest)


public:

	/// \brief Destruct an ooi.
	virtual ~ObjectOfInterest() = 0;

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
	static int getObjectType(const Window& window, mvIMPACT_C::DISP_OOIHANDLE h);
	static ObjectOfInterest * constructOoi(const Window & window, mvIMPACT_C::DISP_OOIHANDLE h);
#endif // #ifndef WRAP_ANY
#endif

	/// Returns the type identifier ot this Ooi.
	int getObjectType() const;

#ifndef WRAP_ANY
	/// Returns a pointer to the window associated with this Ooi.
	Window * getWindow() const;
#endif // #ifndef WRAP_ANY

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
	mvIMPACT_C::DISP_OOIHANDLE getHandle() const;
	int getUseCount() const;
	bool getIsUnique() const;
#endif // #ifndef WRAP_ANY
#endif

#ifndef WRAP_PYTHON
	/// \brief Make a copy on the heap
	virtual ObjectOfInterest* makeShallowCopy() const = 0;
#endif

	/// \brief Get the Ooi visible property.
	/// This property can be used to make an Ooi completely
	/// visible or invisible. This allows you to temporarily show and hide an Ooi
	/// without removing and adding it from the set.
	virtual bool getVisible() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi visible property.
	/// This property can be used to make an Ooi completely
	/// visible or invisible. This allows you to temporarily show and hide an Ooi
	/// without removing and adding it from the set.
	virtual ObjectOfInterest::VisibleProxy getVisible();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi visible property.
	/// This property can be used to make an Ooi completely
	/// visible or invisible. This allows you to temporarily show and hide an Ooi
	/// without removing and adding it from the set.
	virtual ObjectOfInterest& setVisible(
		/// Set to \c true to make the Ooi visible;
		/// set to \c false to make it invisible
		bool visible);


	/// \brief Get the Ooi line visible property.
	/// Returns \c true if the lines of the Ooi are visible or \c false  if not.
	virtual bool getLinesVisible() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi line visible property.
	/// Returns \c true if the lines of the Ooi are visible or \c false  if not.
	virtual ObjectOfInterest::LinesVisibleProxy getLinesVisible();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi line visible property.
	/// This property can be used to make an Ooi which
	/// draws with visible or invisible lines.
	virtual ObjectOfInterest& setLinesVisible(
		/// The state of the line visibility.
		bool linesVisible);


	/// \brief Get the Ooi lines solid property.
	/// Lines can be drawn solid or dashed.
	/// Returns \c true if the lines of the Ooi are drawn solid or \c false if they are drawn dashed.
	virtual bool getLinesSolid() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi lines solid property.
	/// Lines can be drawn solid or dashed.
	/// Returns \c true if the lines of the Ooi are drawn solid or \c false if they are drawn dashed.
	virtual ObjectOfInterest::LinesSolidProxy getLinesSolid();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi lines solid property.
	/// Lines can be drawn solid or dashed.
	virtual ObjectOfInterest& setLinesSolid(
		/// Set to true to draw lines solid, set to false to draw lines dashed..
		bool linesSolid);


	/// \brief Get the Ooi line color property.
	/// This gets the Ooi line color.
	/// \see mvIMPACT::RGBColor
	virtual RGBColor getLineColor() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi line color property.
	/// This gets the Ooi line color.
	/// \see mvIMPACT::RGBColor
	virtual ObjectOfInterest::LineColorProxy getLineColor();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi line color property.
	/// This sets the Ooi lines to some color.
	/// \see mvIMPACT::RGBColor
	virtual ObjectOfInterest& setLineColor(
		/// The new color of the ooi lines.
		const RGBColor& color);


	// retained for compatibility only
	virtual RGBColor getColor() const;
#ifndef WRAP_ANY
	virtual ObjectOfInterest::LineColorProxy getColor();
#endif // #ifndef WRAP_ANY
	virtual ObjectOfInterest& setColor(
		const RGBColor& color);


	/// \brief Get the Ooi handle size property.
	/// Retrieves the size of the dragging handles of the Ooi.
	virtual int getHandleSize() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi handle size property.
	/// Retrieves the size of the dragging handles of the Ooi.
	virtual ObjectOfInterest::HandleSizeProxy getHandleSize();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi handle size property.
	/// Allows you to specify the size of the dragging handles of the Ooi.
	virtual ObjectOfInterest& setHandleSize(
		/// The new size.
		/// \xmlonly
		/// <mvParamRange>
		/// 	<mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int size);


	/// \brief Get the Ooi handle line color property.
	/// A handle is drawn as a filled
	/// square where the border and the inside are drawn in different
	/// colors. When the window is inactive, the handle line color
	/// and the handle fill color are interchanged.
	/// \see mvIMPACT::RGBColor
	/// \see mvIMPACT::ObjectOfInterest::setHandleFillColor
	virtual RGBColor getHandleLineColor() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi handle line color property.
	/// A handle is drawn as a filled
	/// square where the border and the inside are drawn in different
	/// colors. When the window is inactive, the handle line color
	/// and the handle fill color are interchanged.
	/// \see mvIMPACT::RGBColor
	/// \see mvIMPACT::ObjectOfInterest::setHandleFillColor
	virtual HandleLineColorProxy getHandleLineColor();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi handle line color property.
	/// A handle is drawn as a filled
	/// square where the border and the inside are drawn in different
	/// colors. When the window is inactive, the handle line color
	/// and the handle fill color are interchanged.
	/// \see mvIMPACT::RGBColor
	/// \see mvIMPACT::ObjectOfInterest::setHandleFillColor
	virtual ObjectOfInterest& setHandleLineColor(
		/// The line color.
		const RGBColor& color);


	/// \brief Get the Ooi handle fill color property.
	/// A handle is drawn as a filled
	/// square where the border and the inside are drawn in different
	/// colors. When the window is inactive, the handle line color
	/// and the handle fill color are interchanged.
	/// \see mvIMPACT::RGBColor
	/// \see mvIMPACT::ObjectOfInterest::setHandleLineColor
	virtual RGBColor getHandleFillColor() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi handle fill color property.
	/// A handle is drawn as a filled
	/// square where the border and the inside are drawn in different
	/// colors. When the window is inactive, the handle line color
	/// and the handle fill color are interchanged.
	/// \see mvIMPACT::RGBColor
	/// \see mvIMPACT::ObjectOfInterest::setHandleLineColor
	virtual HandleFillColorProxy getHandleFillColor();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi handle fill color property.
	/// A handle is drawn as a filled
	/// square where the border and the inside are drawn in different
	/// colors. When the window is inactive, the handle line color
	/// and the handle fill color are interchanged.
	/// \see mvIMPACT::RGBColor
	/// \see mvIMPACT::ObjectOfInterest::setHandleLineColor
	virtual ObjectOfInterest& setHandleFillColor(
		/// The fill color.
		const RGBColor& color);


	/// \brief Get the Ooi handle visible property.
	/// Returns \c true if the handles are visible or \c false if they are invisible.
	virtual bool getHandlesVisible() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi handle visible property.
	/// Returns \c true if the handles are visible or \c false if they are invisible.
	virtual HandlesVisibleProxy getHandlesVisible();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi handle visible property.
	/// This property can be used to make an Ooi which
	/// draws with the handles invisible.
	virtual ObjectOfInterest& setHandlesVisible(
		/// Visibility state of the ooi handles.
		bool handlesVisible);


	/// This gets the drawing style for the first 16 dragging handles.
	/// Two bits (starting with the low bit) encode the drawing style for the
	/// respective dragging handle.
	virtual unsigned int getHandleDrawingStyle() const;

#ifndef WRAP_ANY
	/// This gets the drawing style for the first 16 dragging handles.
	/// Two bits (starting with the low bit) encode the drawing style for the
	/// respective dragging handle.
	virtual HandleDrawingStyleProxy getHandleDrawingStyle();
#endif // #ifndef WRAP_ANY

	/// This sets the drawing style for the first 16 dragging handles.
	/// Two bits (starting with the low bit) encode the drawing style for the
	/// respective dragging handle.
	virtual ObjectOfInterest& setHandleDrawingStyle(
		/// The new handle drawing style.
		unsigned int Style);


	/// \brief Get the Ooi active property.
	/// This property is usually set for active windows
	/// (foreground windows) and cleared for inactive windows (background windows).
	/// Internally it's used to reverse the handle fill and handle line colors.
	/// This way you can distinguish between selected OOIs in foreground and
	/// background windows.
	virtual bool getActive() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi active property.
	/// This property is usually set for active windows
	/// (foreground windows) and cleared for inactive windows (background windows).
	/// Internally it's used to reverse the handle fill and handle line colors.
	/// This way you can distinguish between selected OOIs in foreground and
	/// background windows.
	virtual ActiveProxy getActive();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi active property.
	/// This property is usually set for active windows
	/// (foreground windows) and cleared for inactive windows (background windows).
	/// Internally it's used to reverse the handle fill and handle line colors.
	/// This way you can distinguish between selected OOIs in foreground and
	/// background windows.
	virtual ObjectOfInterest& setActive(
		/// The state of the active flag.
		bool active);


	/// \brief Get the Ooi user-interface active property.
	/// If this property is set
	/// the Ooi functions with the normal user-interface handling, i.e. it can
	/// be selected/de-selected, moved, sized and cleared. If this property is
	/// cleared, the Ooi does not respond to user-interface handling,
	/// i.e. it is kind of fixed.
	virtual bool getUIActive() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi user-interface active property.
	/// If this property is set
	/// the Ooi functions with the normal user-interface handling, i.e. it can
	/// be selected/de-selected, moved, sized and cleared. If this property is
	/// cleared, the Ooi does not respond to user-interface handling,
	/// i.e. it is kind of fixed.
	virtual UIActiveProxy getUIActive();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi user-interface active property.
	/// If this property is set
	/// the Ooi functions with the normal user-interface handling, i.e. it can
	/// be selected/de-selected, moved, sized and cleared. If this property is
	/// cleared, the Ooi does not respond to user-interface handling,
	/// i.e. it is kind of fixed.
	virtual ObjectOfInterest& setUIActive(
		/// The state of the oois user interface.
		bool uIActive);


	/// \brief Get the Ooi selected property.
	/// Returns \c true if the Ooi is selected or \c false if not.
	/// When an Ooi is selected it is drawn with handles, when
	/// it is de-selected it is drawn without handles.
	virtual bool getSelected() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi selected property.
	/// Returns \c true if the Ooi is selected or \c false if not.
	/// When an Ooi is selected it is drawn with handles, when
	/// it is de-selected it is drawn without handles.
	virtual SelectedProxy getSelected();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi selected property.
	/// Allows you select or de-select an Ooi
	/// programmatically. When an Ooi is selected it is drawn with handles, when
	/// it is de-selected it is drawn without handles.
	virtual ObjectOfInterest& setSelected(
		/// set to \c true to select the ooi, \c false to de-select
		bool selected);


protected:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
	/// \brief Get the Ooi fill visible property.
	/// Returns \c true if the Ooi is drawn filled or \c false if not.
	virtual bool getFillVisible() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi fill visible property.
	/// Returns \c true if the Ooi is drawn filled or \c false if not.
	virtual FillVisibleProxy getFillVisible();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi fill visible property.
	/// This property can be used to make an Ooi which
	/// draws with or without fill.
	virtual ObjectOfInterest& setFillVisible(
		/// The state of the fill visibility.
		bool fillVisible);


	/// \brief Get the Ooi fill transparent property.
	/// A fill can be solid or semi-transparent.
	/// Returns \c true if the Ooi is filled semi-transparent \c false if it filled solid.
	virtual bool getFillTransparent() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi fill transparent property.
	/// A fill can be solid or semi-transparent.
	/// Returns \c true if the Ooi is filled semi-transparent \c false if it filled solid.
	virtual FillTransparentProxy getFillTransparent();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi fill transparent property.
	/// A fill can be solid or semi-transparent.
	virtual ObjectOfInterest& setFillTransparent(
		/// Set to true to fill semi-transparent, false to fill solid.
		bool fillTransparent);


	/// \brief Get the Ooi fill color property.
	/// This gets the Ooi fill color.
	/// \see mvIMPACT::RGBColor
	virtual RGBColor getFillColor() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi fill color property.
	/// This gets the Ooi fill color.
	/// \see mvIMPACT::RGBColor
	virtual FillColorProxy getFillColor();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi fill color property.
	/// This sets the Ooi interior to some color.
	/// \see mvIMPACT::RGBColor
	virtual ObjectOfInterest& setFillColor(
		/// The new color of the ooi interior.
		const RGBColor& color);


	/// \brief Get the Ooi text property.
	/// Returns the text that is displayed as the Ooi description.
	virtual std::string getText() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi text property.
	/// Returns the text that is displayed as the Ooi description.
	virtual TextProxy getText();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi text property.
	/// This sets the text that is displayed as the Ooi description
	virtual ObjectOfInterest& setText(
		/// The text.
		const std::string& text);


	/// \brief Get the Ooi text color property.
	/// Retrieve the text color of the Ooi.
	/// \see mvIMPACT::RGBColor
	virtual RGBColor getTextColor() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi text color property.
	/// Retrieve the text color of the Ooi.
	/// \see mvIMPACT::RGBColor
	virtual TextColorProxy getTextColor();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi text color property.
	/// The text of the Ooi will be displayed in the specified color.
	/// \see mvIMPACT::RGBColor
	virtual ObjectOfInterest& setTextColor(
		/// The text color of the Ooi.
		const RGBColor& color);


	/// \brief Get the Ooi text visible property.
	/// Returns \c true if the text of the Ooi is visible or \c false if not.
	virtual bool getTextVisible() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi text visible property.
	/// Returns \c true if the text of the Ooi is visible or \c false if not.
	virtual TextVisibleProxy getTextVisible();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi text visible property.
	/// This property can be used to make an Ooi which
	/// draws with the text invisible.
	virtual ObjectOfInterest& setTextVisible(
		/// The visibility state of the ooi text.
		bool textVisible);


	virtual double getAngle() const;

#ifndef WRAP_ANY
	virtual AngleProxy getAngle();
#endif // #ifndef WRAP_ANY

	virtual ObjectOfInterest& setAngle(
		double Angle);

	virtual int getWidth() const;

#ifndef WRAP_ANY
	virtual WidthProxy getWidth();
#endif // #ifndef WRAP_ANY

	virtual ObjectOfInterest& setWidth(
		int Width);

	int getPos(int index) const;

	ObjectOfInterest& setPos(int index, const int& pos);

	std::vector<Point> getPoints() const;

	ObjectOfInterest& setPoints(const std::vector<Point>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, points));

#endif
};


PYTHON_ONLY(%feature("director") Window);
/**
 \brief This is the base class for windows.

 A mvIMPACT controlled window can be used to display images, histograms, profiles and so on.
 It provides callbacks for various events, such as mouse or keyboard events.
 \note Objects of class mvIMPACT::Window cannot display 3D content as used by mvIMPACT 3D Display.
 \note To do this you have to create an object of mvIMPACT::display3d::Window3D.

 \xmlonly
 <mvWrapperDoc>
 <htmlinclude ref="cs_doc_start.html"/>
 \note C#: The window is closed as soon as the mvIMPACT::Window object is destroyed. Since C# has a garbage collector this is non-deterministic and
 \note does NOT necessarly happen when the window object goes out of scope! To destroy the object in a deterministic way call mvIMPACT::Window:Dispose()
 \note See also \ref cs_notes_cleanup

 <htmlinclude ref="specific_doc_end.html"/>
 <htmlinclude ref="vb_net_doc_start.html"/>
 \note VB.NET: The window is closed as soon as the mvIMPACT::Window object is destroyed. Since VB.NET has a garbage collector
 \note this is non-deterministic and does NOT necessarly happen when the window object goes out of scope! To destroy the object
 \note in a deterministic way call mvIMPACT::Window:Dispose()
 \note See also \ref vbnet_notes_cleanup

 <htmlinclude ref="specific_doc_end.html"/>
 </mvWrapperDoc>
 \endxmlonly
 \see mvIMPACT::display3d::Window3D
*/
//-----------------------------------------------------------------------------
class Window
//-----------------------------------------------------------------------------
{
private:
	friend class ObjectOfInterest;
	friend class PointOfInterest;
	friend class LineOfInterest;
	friend class AreaOfInterest;
	friend class EllipseOfInterest;
	friend class PolylineOfInterest;
	friend class PolygonOfInterest;
	friend class LineArrayOfInterest;
	friend class BarcodeVisualizer;
	friend class DatamatrixVisualizer;

public:
#ifndef WRAP_DOTNET
	/// \brief Construct an non-allocated window.
	Window();

	/// \brief Construct or subclass a window with an associated buffer.

	/// The buffer given with parameter \a source will be displayed in the window.
	/// If parameter \a cleanup is set to \c true the mvIMPACT::Window object will be destroyed automatically if the variable
	/// goes out of scope.
	/// \see mvIMPACT::BufferBase
	Window(
        /// A buffer.
		const BufferBase& source,
		/// A window handle. If create is true, then this parameter specifies the parent window or NULL. In the
		/// former case a child window is created, in the latter case a toplevel window is created. If create is
		/// false, this cannot be NULL and must specify a window to be subclassed.
		const WindowHandle* handle=0,
		/// Distinguish between creation of a window (set to true) and subclassing a window (set to false).
		bool create=true,
		/// Set to \c true if the window should be destroyed if variable goes out of scope,
		/// set to \c false if the window should not be destroyed if variable goes out of scope.
		/// Usually, for windows that have been created this should be set to true, for windows that have been subclassed
		/// this should be set to false.
		bool cleanup=true);

	/// \brief Copy construct a Window (share ownership, shallow copy)
	Window(
	       /// The Window to copy from.
	       const Window & src);
#endif // #ifndef WRAP_DOTNET

#ifndef WRAP_ANY
	/// \brief Overwrite current object with \a src.
	Window& operator=(
		/// The Window to assign from.
		const Window & src);
#endif // #ifndef WRAP_ANY

	/// \brief Destruct a Window.

	/// The destruction is different whether the window was originally created or subclassed. If the window was originally
	/// created, this destructor destroys the window. If the window was originally subclassed, this destructor unsubclasses
	/// the window, but leaves it existent. This is done because we assume that subclassed windows are owned by some other
	/// instance; the instance that created the window originally is responsible to also cleanup and destroy it later. This
	/// behaviour fits nicely with window handling frameworks.
	virtual ~Window();

#ifndef WRAP_ANY
	/// Make a copy of the window.
	virtual Window* makeShallowCopy() const;
#endif // #ifndef WRAP_ANY

#ifndef WRAP_DOTNET

	/// \brief This function is called whenever a new Ooi is created.
	/// Implement this method to execute commands directly after creation of the Ooi.
	/// \see mvIMPACT::ObjectOfInterest
	/// \see mvIMPACT::PointOfInterest
	/// \see mvIMPACT::LineOfInterest
	/// \see mvIMPACT::AreaOfInterest
	/// \see mvIMPACT::EllipseOfInterest
	/// \see mvIMPACT::PolylineOfInterest
	/// \see mvIMPACT::PolygonOfInterest
	/// \see mvIMPACT::LineArrayOfInterest
	/// \see mvIMPACT::BarcodeVisualizer
	/// \see mvIMPACT::DatamatrixVisualizer
	virtual void onOoiCreate (
		/// Points to the Ooi.
		const ObjectOfInterest* ooi);

	/// \brief This function is called when an Ooi is about to be destroyed.
	/// Implement this method to execute commands before destruction of the Ooi.
	/// \see mvIMPACT::ObjectOfInterest
	/// \see mvIMPACT::PointOfInterest
	/// \see mvIMPACT::LineOfInterest
	/// \see mvIMPACT::AreaOfInterest
	/// \see mvIMPACT::EllipseOfInterest
	/// \see mvIMPACT::PolylineOfInterest
	/// \see mvIMPACT::PolygonOfInterest
	/// \see mvIMPACT::LineArrayOfInterest
	/// \see mvIMPACT::BarcodeVisualizer
	/// \see mvIMPACT::DatamatrixVisualizer
	/// \see mvIMPACT::Window::onOoiCreate
	virtual void onOoiDestroy (
		/// Points to the Ooi.
		const ObjectOfInterest* ooi);

	/// \brief This function is called when an Ooi is selected or deselected.
	/// Implement this method to execute commands whenever an Ooi is selected or deselected.
	/// If \a false is returned you cancel out standard handling of the event, i.e.
	/// selecting or deselecting the corresponding Ooi.
	/// \see mvIMPACT::ObjectOfInterest
	/// \see mvIMPACT::PointOfInterest
	/// \see mvIMPACT::LineOfInterest
	/// \see mvIMPACT::AreaOfInterest
	/// \see mvIMPACT::EllipseOfInterest
	/// \see mvIMPACT::PolylineOfInterest
	/// \see mvIMPACT::PolygonOfInterest
	/// \see mvIMPACT::LineArrayOfInterest
	/// \see mvIMPACT::BarcodeVisualizer
	/// \see mvIMPACT::DatamatrixVisualizer
	virtual bool onOoiSelect (
		/// The Ooi.
		const ObjectOfInterest* ooi,
		/// \c true is the Ooi is selected. \c false if it is deselected.
		bool selected);

	/// \brief This function is called when the user starts to modify an ooi.
	/// Implement this method to execute commands whenever the Ooi is modified.
	/// If \c false is returned the modification will be cancelled.
	/// Parameter \a handle is the number of the handle that was clicked to initiate the event.
	/// E.g. a Area of interest has 8 handles:
	/// \code
	/// 0----1----2
	/// |         |
	/// 7         3
	/// |         |
	/// 6----5----4
	/// \endcode
	/// If the Ooi itself was clicked (e.g. inside the Aoi) a value
	/// of -1 is used for the handle.
	/// \see mvIMPACT::ObjectOfInterest
	/// \see mvIMPACT::PointOfInterest
	/// \see mvIMPACT::LineOfInterest
	/// \see mvIMPACT::AreaOfInterest
	/// \see mvIMPACT::EllipseOfInterest
	/// \see mvIMPACT::PolylineOfInterest
	/// \see mvIMPACT::PolygonOfInterest
	/// \see mvIMPACT::LineArrayOfInterest
	/// \see mvIMPACT::BarcodeVisualizer
	/// \see mvIMPACT::DatamatrixVisualizer
	virtual bool onOoiStartTrack (
		/// The Ooi.
		const ObjectOfInterest * ooi,
		/// Handle of the ooi.
		int handle);

	/// \brief This function is called when the user stops to modify an ooi.
	/// Implement this method to execute commands whenever a moodification of the Ooi occurred.
	/// \see mvIMPACT::ObjectOfInterest
	/// \see mvIMPACT::PointOfInterest
	/// \see mvIMPACT::LineOfInterest
	/// \see mvIMPACT::AreaOfInterest
	/// \see mvIMPACT::EllipseOfInterest
	/// \see mvIMPACT::PolylineOfInterest
	/// \see mvIMPACT::PolygonOfInterest
	/// \see mvIMPACT::LineArrayOfInterest
	/// \see mvIMPACT::BarcodeVisualizer
	/// \see mvIMPACT::DatamatrixVisualizer
	virtual void onOoiStopTrack (
		/// The Ooi.
		const ObjectOfInterest * ooi);

	/// \brief This function is called when the user moves an ooi to another location.
	/// This function is called _before_ the ooi is moved! If you return \c false
	/// here you can cancel the movement.
	/// Parameter \a handle is the number of the handle that was clicked to initiate the event.
	/// E.g. a Area of interest has 8 handles:
	/// \code
	/// 0----1----2
	/// |         |
	/// 7         3
	/// |         |
	/// 6----5----4
	/// \endcode
	/// If the Ooi itself was clicked (e.g. inside the Aoi) a value
	/// of -1 is used for the handle.
	/// \see mvIMPACT::ObjectOfInterest
	/// \see mvIMPACT::PointOfInterest
	/// \see mvIMPACT::LineOfInterest
	/// \see mvIMPACT::AreaOfInterest
	/// \see mvIMPACT::EllipseOfInterest
	/// \see mvIMPACT::PolylineOfInterest
	/// \see mvIMPACT::PolygonOfInterest
	/// \see mvIMPACT::LineArrayOfInterest
	/// \see mvIMPACT::BarcodeVisualizer
	/// \see mvIMPACT::DatamatrixVisualizer
	virtual bool onOoiTrackTo (
		/// The Ooi.
		const ObjectOfInterest * ooi,
		/// Handle of the ooi.
		int handle,
		/// Location where the handle is dragged to.
		const Point* point);

	/// \brief This function is called when the user moved an ooi to another location.
	/// Implement this method to execute commands whenever a movement of the Ooi occurred.
	/// It is called after the movement has happened.
	/// \see mvIMPACT::ObjectOfInterest
	/// \see mvIMPACT::PointOfInterest
	/// \see mvIMPACT::LineOfInterest
	/// \see mvIMPACT::AreaOfInterest
	/// \see mvIMPACT::EllipseOfInterest
	/// \see mvIMPACT::PolylineOfInterest
	/// \see mvIMPACT::PolygonOfInterest
	/// \see mvIMPACT::LineArrayOfInterest
	/// \see mvIMPACT::BarcodeVisualizer
	/// \see mvIMPACT::DatamatrixVisualizer
	virtual void onOoiTracked (
		/// The Ooi.
		const ObjectOfInterest * ooi);

  /// \brief This function is called whenever the window requires painting.

  /// When this function is called the actual painting of the mvIMPACT::BufferBase is
  /// already done. This means that you can use this function to draw overlays.
  /// \see mvIMPACT::BufferBase
  /// \see mvIMPACT::DeviceContext
  /// \see mvIMPACT::Rectangle
  /// \see mvIMPACT::Window::onBeforeDraw
  virtual void onDraw(
		    /// Context that is painted in.
		    DeviceContext *deviceContext,
		    /// The rectangle in the buffer that specifies the portion that was drawn.
		    const Rectangle* sourceRect,
		    /// The rectangle in the drawing canvas where the drawing occurred.
		    /// Drawing outside this rectangle may be clipped.
		    const Rectangle* destRect
		    );


  /// \brief This function is called whenever the window requires painting.

  /// It is called before the actual painting of the mvIMPACT::BufferBase is done.
  /// Return \c false in your implementation to cancel the window update.
  /// Returning \c true to continue the update of the window.
  /// \see mvIMPACT::Window::onDraw
  /// \see mvIMPACT::DeviceContext
  /// \see mvIMPACT::BufferBase
  /// \see mvIMPACT::Rectangle
  virtual bool onBeforeDraw (
			   /// Context that is painted in.
			   DeviceContext* deviceContext,
			   /// The rectangle in the buffer that specifies the portion that will be drawn.
			   const Rectangle* sourceRect,
			   /// The rectangle in the drawing canvas where the drawing will occur.
			   /// Drawing outside this rectangle may be clipped.
			   const Rectangle* destRect
			   );


  /// \brief This function is called whenever the user presses a mouse button.

  /// Implement this method to execute commands whenever a mouse button was pressed.
  /// If \a false is returned you cancel out standard handling of the event.
  /// \note The mouse x and y coordinates are window coordinates and
  /// \note not buffer coordinates.
  /// \see #MouseButton
  /// \see mvIMPACT::Point
  /// \see mvIMPACT::Window::onMouseButtonDown
  /// \see mvIMPACT::Window::onMouseButtonUpWindow
  virtual bool onMouseButtonDownWindow (
			   /// The depressed mouse button.
			   MouseButton mouseButton,
			   /// The window coordinate where the event occurred.
			   const Point* point
			   );

  /// \brief This function is called whenever the user releases a mouse button.

  /// Implement this method to execute commands whenever a mouse button was released.
  /// If \a false is returned you cancel out standard handling of the corresponding message.
  /// \note The mouse x and y coordinates are window coordinates and
  /// \note not buffer coordinates.
  /// \see #MouseButton
  /// \see mvIMPACT::Point
  /// \see mvIMPACT::Window::onMouseButtonDown
  /// \see mvIMPACT::Window::onMouseButtonUpWindow
  virtual bool onMouseButtonUpWindow (
			 /// The released mouse button.
			 MouseButton mouseButton,
			 /// The window coordinate where the event occurred.
			 const Point* point
			 );


  /// \brief This function is called whenever the user double clicks a mouse button.

  /// Implement this method to execute commands whenever a a double click occurred
  /// If \a false is returned you cancel out standard handling of the corresponding message.
  /// \note The mouse x and y coordinates are window coordinates and
  /// \note not buffer coordinates.
  /// \see mvIMPACT::Window
  /// \see #MouseButton
  /// \see mvIMPACT::Point
  /// \see mvIMPACT::Window::onMouseButtonDownWindow
  /// \see mvIMPACT::Window::onMouseButtonUpWindow
  /// \see mvIMPACT::Window::onMouseDoubleClick
  virtual bool onMouseDoubleClickWindow (
			    /// The double clicked mouse button.
			    MouseButton mouseButton,
			    /// The window coordinate where the event occurred.
			    const Point* point
			    );


  /// \brief Implement this method to execute commands whenever the mouse is moved.
  /// If \a false is returned you cancel out standard handling of the event.
  /// \note The mouse x and y coordinates are window coordinates and
  /// \note not buffer coordinates.
  /// \see mvIMPACT::Window::onMouseMove
  /// \see #MouseButton
  /// \see mvIMPACT::Point
  virtual bool onMouseMoveWindow (
		     /// The mouse button that is pressed during the move.
		     MouseButton mouseButton,
		     /// The window coordinate of the mouse.
		     const Point* point
		     );


  /// \brief  This function is called whenever the user depresses a mouse button.

  /// Implement this method to execute commands whenever a mouse button was pressed.
  /// If \a false is returned you cancel out standard handling of the event.
  /// \note The mouse x and y coordinates are buffer coordinates and
  /// \note not window coordinates.
  /// \see mvIMPACT::Window::onMouseButtonUp
  /// \see #MouseButton
  /// \see mvIMPACT::PointDouble
  /// \see mvIMPACT::Window::onMouseButtonDownWindow
  virtual bool onMouseButtonDown (
			   /// The depressed mouse button.
			   MouseButton mouseButton,
			   /// The buffer coordinate where the event occurred.
			   const PointDouble* point
			   );


  /// \brief This function is called whenever the user releases a mouse button.

  /// Implement this method to execute commands whenever a mouse button was released.
  /// If \a false is returned you cancel out standard handling of the event.
  /// \note The mouse x and y coordinates are buffer coordinates and
  /// \note not window coordinates.
  /// \see #MouseButton
  /// \see mvIMPACT::PointDouble
  /// \see mvIMPACT::Window::onMouseButtonDown
  /// \see mvIMPACT::Window::onMouseButtonUpWindow
  virtual bool onMouseButtonUp (
			 /// The released mouse button.
			 MouseButton mouseButton,
			 /// The buffer coordinate where the event occurred.
			 const PointDouble* point
			 );

  /// \brief This function is called whenever the user double clicks a mouse button.

  /// Implement this method to execute commands whenever double click occurred.
  /// If \a false is returned you cancel out standard handling of the event.
  /// \note The mouse x and y coordinates are buffer coordinates and
  /// \note not window coordinates.
  /// \see #MouseButton
  /// \see mvIMPACT::PointDouble
  /// \see mvIMPACT::Window::onMouseButtonDown
  /// \see mvIMPACT::Window::onMouseButtonUp
  virtual bool onMouseDoubleClick (
			    /// The double clicked mouse button.
			    MouseButton mouseButton,
			    /// The buffer coordinate where the event occurred.
			    const PointDouble* point
			    );


  /// \brief This function is called whenever the user moves the mouse.

  /// Implement this method to execute commands whenever the mouse is moved.
  /// If \a false is returned you cancel out standard handling of the event.
  /// \note The mouse x and y coordinates are buffer coordinates and
  /// \note not window coordinates.
  /// \see mvIMPACT::Window::onMouseMoveWindow
  /// \see #MouseButton
  /// \see mvIMPACT::PointDouble
  virtual bool onMouseMove (
		     /// The mouse button that is pressed during the move.
		     MouseButton mouseButton,
		     /// The buffer coordinate of the mouse.
		     const PointDouble* point
		     );


  /// \brief This function is called whenever the user pressed a key.

  /// Return \c false in your implementation to cancel the further processing of
  /// this key event. E.g.: This disallows the user to delete an ooi by pressing 'del'.
  /// Returning \c true continues to processing of the key.
  virtual bool onKeyDown (
		    /// The ascii code of the character.
		    int character
		    );

  /// \brief This function is called whenever the user scrolls the contents of a window.

  /// Implement this method to execute commands whenever the the slider of the scrollbar is moved.
  virtual void onScrollPosChange(
		      /// The new x coordinate of the horizontal scroll bar.
		      int scrollPosX,
		      /// The new y coordinate of the vertical scroll bar.
		      int scrollPosY
		      );

  /// \brief This function is called whenever the x or y zoom is changed.

  /// Implement this method to execute commands whenever the the zoom factor of the mvIMPACT::Window object changed.
  /// \see mvIMPACT::Window::setZoomX
  /// \see mvIMPACT::Window::setZoomY
  virtual void onZoomFactorsChange (
		     /// The new x zoom.
		     double zoomX,
		     /// The new y zoom.
		     double zoomY
		     );

#endif // #ifndef WRAP_DOTNET

	/// \brief Access the window handle.
	/// Returns a constant reference to the window handle.
	WindowHandle getHandle() const;

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
	/// \brief Get the Ooiset handle.
	mvIMPACT_C::DISP_OOISETHANDLE getOoiSetHandle() const;

	/// \brief This is the contents of the shared reference counter.
	int getUseCount() const;
#endif // #ifndef WRAP_ANY
#endif

	/// \brief Retrieve the cleanup flag.

	/// If this flag is set to \c true the window will be destroyed when the object variable goes out of scope.
	/// If the flag is set to \c false the window will not be destroyed.

	/// The cleanup flag is shared between multiple copies of the same window.

	/// \see mvIMPACT::Window::setCleanup
	bool getMustCleanup() const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the cleanup flag.

	/// If this flag is set to \c true the window will be destroyed when the object variable goes out of scope.
	/// If the flag is set to \c false the window will not be destroyed.

	/// The cleanup flag is shared between multiple copies of the same window.

	/// \see mvIMPACT::Window::mustCleanup
	Window& setMustCleanup(/// set to \c true to force cleanup if variable goes out of scope; set to \c false if not
			   bool cleanup);



	/// \brief Convert to an operating system window.
#ifndef WRAP_ANY
	operator WindowHandle() const;
#endif


	/// \brief Invalidate the window content.

	/// The window will be repainted later.
	/// \see mvIMPACT::Window::redraw
	void update() const;


	/// \brief Redraw the window immediately.

	/// This will force an immediate update of the window contents.
	/// \see mvIMPACT::Window::update
	void redraw() const;


	/// \brief Copy Window contents to the clipboard.

	/// The clipboard mode determines, whether the
	/// whole Window or the client area only is copied.
	/// \see #CopyClipboardMode
	/// \see mvIMPACT::Window::setClipboardMode
	void copyToClipboard() const;


	/// \brief Get the window's content.

	/// Returns a reference to a mvIMPACT::BufferBase object that represents the windows content.
	/// \see mvIMPACT::BufferBase
	BufferBase& getBuffer() const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the window content

	/// Sets the mvIMPACT::BufferBase object that represents the windows content.
	/// \see mvIMPACT::BufferBase
	Window& setBuffer(
			  /// The buffer to display.
			  const BufferBase& buffer);


	/// \brief Get the Profile drawing direction.

	/// Returns the Profile drawing direction of this Window.
	/// \see #ProfileDirection
	/// \see mvIMPACT::Window::setProfileDrawingDir
	/// \see mvIMPACT::Profile
	ProfileDirection getProfileDrawingDir() const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the Profile drawing direction.

	///
	/// \see #ProfileDirection
	/// \see mvIMPACT::Window::getProfileDrawingDir
	/// \see mvIMPACT::Profile
	Window& setProfileDrawingDir(
				     /// The new Profile drawing direction of this Window.
				     ProfileDirection profileDrawingDir);


	/// \brief Get the Histogram drawing mode.

	/// Return The Histogram drawing mode of this Window.
	/// \see #HistogramMode
	/// \see mvIMPACT::Window::setHistogramDrawingMode
	/// \see mvIMPACT::Histogram
	HistogramMode getHistogramDrawingMode() const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the Histogram drawing mode.

	///
	/// \see #HistogramMode
	/// \see mvIMPACT::Window::getHistogramDrawingMode
	/// \see mvIMPACT::Histogram
	Window& setHistogramDrawingMode(
					/// The new Histogram drawing mode of this Window.
					HistogramMode histogramDrawingMode);


	/// \brief Get the Image drawing mode.

	/// Returns the Image drawing mode of this Window.
	/// Use this to determine if your images are displayed numerically or graphically.
	/// \see #ImageMode
	/// \see mvIMPACT::Window::setImageDrawingMode
	ImageMode getImageDrawingMode() const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the Image drawing mode.

	/// Use this to specify whether your images are displayed numerically or graphically.
	/// \see #ImageMode
	/// \see mvIMPACT::Window::getImageDrawingMode
	Window& setImageDrawingMode(
				    /// The new Image drawing mode of this Window.
				    ImageMode imageDrawingMode);


	/// \brief Get the numeric base.

	/// The numeric base is used when drawing a buffer
	/// numerically.
	/// \see mvIMPACT::Window::getImageDrawingMode
	int getNumericBase() const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the numeric base.

	/// The numeric base is used when drawing a buffer
	/// numerically.
	/// \see mvIMPACT::Window::setImageDrawingMode
	Window& setNumericBase(
					/// The new numeric base of this window. This is a value from 2 to 36.
					/// \xmlonly
					/// <mvParamRange>
					/// <mvParamMin><mvParamConst value="2"/></mvParamMin>
					/// <mvParamMax><mvParamConst value="36"/></mvParamMax>
					/// </mvParamRange>
					/// \endxmlonly
				   int numericBase);


	/// \brief Get the color palette.

	/// One band images will be colored with this palette.
	/// \see mvIMPACT::Palette
	/// \see mvIMPACT::Window::setColorPalette
	Palette getColorPalette() const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the color palette.

	/// One band images will be colored with this palette.
	/// \see mvIMPACT::Palette
	/// \see mvIMPACT::Window::getColorPalette
	Window& setColorPalette(
				/// The new color Palette of this Window.
				const Palette& colorPalette);


	/// \brief Get the text spacing.

	/// The text spacing is used when drawing a buffer
	/// numerically.
	/// \see mvIMPACT::Window::setTextSpacing
	/// \see mvIMPACT::Window::setImageDrawingMode
	int getTextSpacing() const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the spacing around text.

	/// The text spacing is used when drawing a buffer
	/// numerically.
	/// \see mvIMPACT::Window::getTextSpacing
	/// \see mvIMPACT::Window::setImageDrawingMode
	Window& setTextSpacing(
			    /// The new text spacing of this Window.
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
				/// </mvParamRange>
				/// \endxmlonly
				int textSpacing);


	/// \brief Get the text height.

	/// The text height is used when drawing a buffer
	/// numerically.
	/// \see mvIMPACT::Window::setTextHeight
	/// \see mvIMPACT::Window::setImageDrawingMode
	int getTextHeight() const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the text height.

	/// The text height is used when drawing a buffer
	/// numerically.
	/// \see mvIMPACT::Window::getTextHeight
	/// \see mvIMPACT::Window::setImageDrawingMode
	Window& setTextHeight(
					/// The new text height of this window.
					/// \xmlonly
					/// <mvParamRange>
					/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
					/// </mvParamRange>
					/// \endxmlonly
					int textHeight);


	/// \brief Get the text weight.

	/// The text weight is used when drawing a buffer
	/// numerically.
	/// The weight ranges from 1 to 1000 where
	/// 1 means very thin and 1000 means very thick.
	/// \see mvIMPACT::Window::setTextWeight
	/// \see mvIMPACT::Window::setImageDrawingMode
	int getTextWeight() const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the text weight.

	/// The text weight is used when drawing a buffer
	/// numerically.
	/// The weight ranges from 1 to 1000 where
	/// 1 means very thin and 1000 means very thick.
	/// \see mvIMPACT::Window::getTextWeight
	/// \see mvIMPACT::Window::setImageDrawingMode
	Window& setTextWeight(
					/// The new text weight of this window. The weight ranges from 1 to 1000 where
					/// 1 means very thin and 1000 means very thick.
					/// \xmlonly
					/// <mvParamRange>
					/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
					/// <mvParamMax><mvParamConst value="1000"/></mvParamMax>
					/// </mvParamRange>
					/// \endxmlonly
					int textWeight);


	/// \brief Get the text color.

	/// The text color is used when drawing a buffer
	/// numerically.
	/// \see mvIMPACT::Window::setTextColor
	/// \see mvIMPACT::Window::setImageDrawingMode
	/// \see mvIMPACT::RGBColor
	RGBColor getTextColor() const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the text color.

	/// The text color is used when drawing a buffer
	/// numerically.
	/// \see mvIMPACT::Window::getTextColor
	/// \see mvIMPACT::Window::setImageDrawingMode
	/// \see mvIMPACT::RGBColor
	Window& setTextColor(
			     /// The new text color of this Window.
			     const RGBColor textColor);


	/// \brief Get the draw color.

	/// This is the color that is used to draw Profiles etc.
	/// \see mvIMPACT::RGBColor
	/// \see mvIMPACT::Window::setDrawColor
	RGBColor getDrawColor() const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the draw color.
	/// This is the color that is used to draw Profiles etc.
	/// \see mvIMPACT::RGBColor
	/// \see mvIMPACT::Window::getDrawColor
	Window& setDrawColor(
			     /// The new draw color of this Window.
			     const RGBColor& drawColor);


	/// \brief Get the fill color.

	/// This is the color that is used to fill the outline if a histogram is displayed
	/// \see mvIMPACT::RGBColor
	/// \see mvIMPACT::Window::setFillColor
	RGBColor getFillColor() const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the fill color.
	/// This is the color that is used to fill the outline if a histogram is displayed
	/// \see mvIMPACT::RGBColor
	/// \see mvIMPACT::Window::setFillColor
	Window& setFillColor(
			     /// The new fill color of this Window.
			     const RGBColor& fillColor);


	/// \brief  Get the normalization value.

	/// Histogram values are scaled
	/// with this value or scaled to the
	/// histogram's maximum
	/// (different maxima are used for
	/// normal or accumulated
	/// drawing).
	/// \see mvIMPACT::Window::setNormalize
	int getNormalize() const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the normalization value.

	/// Histogram values are scaled
	/// with this value or scaled to the
	/// histogram's maximum
	/// (different maxima are used for
	/// normal or accumulated
	/// drawing).
	/// \see mvIMPACT::Window::getNormalize
	Window& setNormalize(
					/// The new normalization value of this Window.
					/// \xmlonly
					/// <mvParamRange>
					/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
					/// </mvParamRange>
					/// \endxmlonly
					int normalize);


#ifdef PLATFORM_MVBL
	/// \brief  Get the display green gain value.

	/// Only for mvBlueLYNX available.
	/// Used to adjust the bayer mosaic display.
	double getDisplayGreenGain() const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief  Set the display green gain value.

	/// Only for mvBlueLYNX available.
	/// Used to adjust the bayer mosaic display.
	Window& setDisplayGreenGain( double v );
#endif	// PLATFORM_MVBL


	/// \brief Get the clipboard mode.

	/// The clipboard mode defines which parts of the window are copied to the clipboard
	/// when calling mvIMPACT::Window::copyToClipBoard
	/// \see mvIMPACT::Window::copyToClipboard
	/// \see #CopyClipboardMode
	/// \see mvIMPACT::Window::setClipboardMode
	CopyClipboardMode getClipboardMode() const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the clipboard mode.

	/// The clipboard mode defines which parts of the window are copied to the clipboard
	/// when calling mvIMPACT::Window::copyToClipBoard
	/// \see mvIMPACT::Window::copyToClipboard
	/// \see #CopyClipboardMode
	/// \see mvIMPACT::Window::getClipboardMode
	Window& setClipboardMode(
				 /// The new clipboard copy mode of this Window.
				 CopyClipboardMode clipboardMode);


	/// \brief Get the horizontal zoom value.

	///
	/// \see mvIMPACT::Window::setZoomX
	/// \see mvIMPACT::Window::getZoomY
	double getZoomX() const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the horizontal zoom value.

	///
	/// \see mvIMPACT::Window::getZoomX
	/// \see mvIMPACT::Window::setZoomY
	/// \see mvIMPACT::Window::setZoom
	Window& setZoomX(
					/// The new horizontal zoom value of this Window.
					/// \xmlonly
					/// <mvParamRange>
					/// <mvParamMin><mvParamConst value="0.01"/></mvParamMin>
					/// <mvParamStep>0.1</mvParamStep>
					/// </mvParamRange>
					/// \endxmlonly
					double zoomX);


	/// \brief Get the vertical zoom value.

	///
	/// \see mvIMPACT::Window::setZoomY
	/// \see mvIMPACT::Window::getZoomX
	double getZoomY() const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the vertical zoom value.

	///
	/// \see mvIMPACT::Window::getZoomY
	/// \see mvIMPACT::Window::setZoomX
	/// \see mvIMPACT::Window::setZoom
	Window& setZoomY(
					/// The new vertical zoom value of this Window.
					/// \xmlonly
					/// <mvParamRange>
					/// <mvParamMin><mvParamConst value="0.01"/></mvParamMin>
					/// <mvParamStep>0.1</mvParamStep>
					/// </mvParamRange>
					/// \endxmlonly
					double zoomY);


	/// \brief Set the horizontal and vertical zoom value.

	/// Sets the vertical and the horizontal zoom factor to the same value.
	Window& setZoom(
					/// The new horizontal and vertical zoom value of this Window.
					/// \xmlonly
					/// <mvParamRange>
					/// <mvParamMin><mvParamConst value="0.01"/></mvParamMin>
					/// <mvParamStep>0.1</mvParamStep>
					/// </mvParamRange>
					/// \endxmlonly
					double zoom);


	/// \brief Get the zoom mode.

	/// Determine if the window is zoomed, such that the content exactly fits, or if
	/// it is zoomed using the zoom factors.
	/// \see #ZoomingMode
	/// \see mvIMPACT::Window::setZoomMode
	ZoomingMode getZoomMode() const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the zoom mode.

	/// Specify if the window is zoomed, such that the content exactly fits, or if
	/// it is zoomed using the zoom factors.
	/// \see #ZoomingMode
	/// \see mvIMPACT::Window::getZoomMode
	Window& setZoomMode(
			    /// The new zoom mode of this Window.
			    ZoomingMode zoomMode);


	/// \brief Get the horizontal scroll position
	///
	/// The horizontal scroll position
	/// specifies how many pixels to the left of the shown area are not shown in the
	/// section which is currently displayed in the window. The position is measured
	/// in "window pixels", i.e. if the window is zoomed by factor 2, the image width
	/// is 640 pixels and 300 pixels of the image to the
	/// the left of the current section are not shown, the horizontal
	/// scroll position is 600.
	///
	/// \see mvIMPACT::Window::setScrollPos
	/// \see mvIMPACT::Window::getScrollPos
	/// \see mvIMPACT::Window::setScrollPosX
	/// \see mvIMPACT::Window::setScrollPosY
	/// \see mvIMPACT::Window::getScrollPosY
	int getScrollPosX() const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the horizontal scroll position
	///
	/// The horizontal scroll position
	/// specifies how many pixels to the left of the shown area are not shown in the
	/// section which is currently displayed in the window. The position is measured
	/// in "window pixels", i.e. if the window is zoomed by factor 2, the image width
	/// is 640 pixels and 300 pixels of the image to the
	/// the left of the current section are not shown, the horizontal
	/// scroll position is 600.
	///
	/// \see mvIMPACT::Window::setScrollPos
	/// \see mvIMPACT::Window::getScrollPos
	/// \see mvIMPACT::Window::getScrollPosX
	/// \see mvIMPACT::Window::setScrollPosY
	/// \see mvIMPACT::Window::getScrollPosY
	Window& setScrollPosX(
					/// The new scroll position.
					/// \xmlonly
					/// <mvParamRange>
					/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
					/// </mvParamRange>
					/// \endxmlonly
					int position);


	/// \brief Get the vertical scroll position
	///
	/// The vertical scroll position
	/// specifies how many pixels above the shown area are not shown in the
	/// section which is currently displayed in the window. The position is measured
	/// in "window pixels", i.e. if the window is zoomed by factor 2 and the image
	/// height is 480 pixels  and 200 pixels of the image above
	/// the current section are not shown, the vertical scroll position is 400.
	///
	/// \see mvIMPACT::Window::setScrollPos
	/// \see mvIMPACT::Window::getScrollPos
	/// \see mvIMPACT::Window::setScrollPosX
	/// \see mvIMPACT::Window::getScrollPosX
	/// \see mvIMPACT::Window::setScrollPosY
	int getScrollPosY() const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the horizontal scroll position
	///
	/// The horizontal scroll position
	/// specifies how many pixels to the left of the shown area are not shown in the
	/// section which is currently displayed in the window. The position is measured
	/// in "window pixels", i.e. if the window is zoomed by factor 2, the image width
	/// is 640 pixels and 300 pixels of the image to the
	/// the left of the current section are not shown, the horizontal
	/// scroll position is 600.
	///
	/// \see mvIMPACT::Window::setScrollPos
	/// \see mvIMPACT::Window::getScrollPos
	/// \see mvIMPACT::Window::setScrollPosX
	/// \see mvIMPACT::Window::getScrollPosX
	/// \see mvIMPACT::Window::getScrollPosY
	Window& setScrollPosY(
					/// The new scroll position.
					/// \xmlonly
					/// <mvParamRange>
					/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
					/// </mvParamRange>
					/// \endxmlonly
					int position);


	/// \brief Get the scroll position
	///
	/// The scroll position (in both horizontal and vertical directions)
	/// specifies how many pixels above the shown area are not shown in the
	/// section which is currently displayed in the window. The position is measured
	/// in "window pixels", i.e. if the window is zoomed by factor 2 and the image
	/// height is 480 pixels  and 200 pixels of the image above
	/// the current section are not shown, the vertical scroll position is 400.
	///
	/// \see mvIMPACT::Window::setScrollPos
	/// \see mvIMPACT::Window::setScrollPosX
	/// \see mvIMPACT::Window::getScrollPosX
	/// \see mvIMPACT::Window::setScrollPosY
	/// \see mvIMPACT::Window::getScrollPosY
	Point getScrollPos() const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the scroll position
	///
	/// The scroll position (in both horizontal and vertical directions)
	/// specifies how many pixels to the left of the shown area are not shown in the
	/// section which is currently displayed in the window. The position is measured
	/// in "window pixels", i.e. if the window is zoomed by factor 2, the image width
	/// is 640 pixels and 300 pixels of the image to the
	/// the left of the current section are not shown, the horizontal
	/// scroll position is 600.
	///
	/// \see mvIMPACT::Window::getScrollPos
	/// \see mvIMPACT::Window::setScrollPosX
	/// \see mvIMPACT::Window::getScrollPosX
	/// \see mvIMPACT::Window::setScrollPosY
	/// \see mvIMPACT::Window::getScrollPosY
	Window& setScrollPos(
					/// The new scroll position.
					Point position);


	/// \brief Get the window size
	///
	/// The window size specifies the size of the window (including potential
	/// window borders) measured in pixels.
	///
	/// \see mvIMPACT::Window::setWindowSize
	Point getWindowSize() const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the window size.
	///
	/// The window size specifies the size of the window (including potential
	/// window borders) measured in pixels.
	///
	/// \see mvIMPACT::Window::getWindowSize
	Window& setWindowSize(
		/// The new window size.
		Point size);


	/// \brief Get the mapping palette.

	/// The image data is mapped over the
	/// mapping palette before
	/// drawing.
	/// \see mvIMPACT::Palette
	/// \see mvIMPACT::Window::setMappingPalette
	Palette getMappingPalette() const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the mapping palette.

	/// When a mapping palette is specified the image data is mapped
	/// using this palette before displaying it.
	/// \see mvIMPACT::Palette
	/// \see mvIMPACT::Window::getMappingPalette
	Window& setMappingPalette(
				  /// The new mapping palette of this window.
				  const Palette& mappingPalette);


	/// \brief Query the number of bits the data is shifted before it is displayed.

	/// E.g.: Shift 16 bit data before drawing.
	/// 0 displays the low
	/// byte, 8 displays the high byte.
	/// \see mvIMPACT::Window::setShift
	int getShift() const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the number of bits the data is shifted before it is displayed.

	/// E.g.: Shift 16 bit data before drawing. 0 displays the low byte,
	/// 8 displays the high byte.
	/// \see mvIMPACT::Window::getShift
	Window& setShift(
					/// the number of bits to shift
					/// \xmlonly
					/// <mvParamRange>
					/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
					/// <mvParamMax><mvParamConst value="15"/></mvParamMax>
					/// </mvParamRange>
					/// \endxmlonly
					int shift);


	/// \brief Get the scrollbar mode.

	/// The scrollbar mode defines when the scrollbars are shown.
	/// \see #ScrollingMode
	/// \see mvIMPACT::Window::setScrollbarMode
	ScrollingMode getScrollbarMode() const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief  Set the scrollbar mode.

	/// The scrollbar mode defines when the scrollbars are shown.
	/// \see #ScrollingMode
	/// \see mvIMPACT::Window::getScrollbarMode
	Window& setScrollbarMode(
				 /// The new scrollbar mode of this window.
				 ScrollingMode scrollbarMode);


	/// \brief Return the background color.

	/// Retrieve the background color of the window.
	/// \see mvIMPACT::RGBColor
	/// \see mvIMPACT::Window::setBackgroundColor
	RGBColor getBackgroundColor () const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the background color for all windows.

	/// \see mvIMPACT::RGBColor
	/// \see mvIMPACT::Window::getBackgroundColor
	Window& setBackgroundColor (/// the color to be set
				    const RGBColor& backgroundColor);

	/// \brief Get the window title text.

	/// \see mvIMPACT::Window::setTitle
	std::string getTitle() const;

#ifndef WRAP_ANY
	//PROP
#endif // #ifndef WRAP_ANY

	/// \brief Set the window title text.

	/// \see mvIMPACT::Window::getTitle
	void setTitle(
		/// The new title text.
		const std::string & title);

private:

	/// Pointer to the reference counter.
	int * counter_;

	/// The window handle.
	WindowHandle * handle_;

	/// Do we need to destroy this window, when we go out of scope?
	bool * must_cleanup_;

	/// The Ooiset handle.
	mvIMPACT_C::DISP_OOISETHANDLE * ooiset_;

	/// Stored pointer to the BufferBase.
	/// The BufferBase object can change. BufferBase is a shared class, so
	/// changes are shared between copies.
	/// The BufferBase object can be replaced by another one with setBuffer().
	/// Thus it must be shared among copies of a Window and thus it is saved as
	/// a pointer here.
	BufferBase * buffer_;

	// Pointer to the list of windows
	std::list<Window *> * windows_;

	// Add a window to the list
	void addWindow(Window * window);

	// Remove a window from the list
	void removeWindow(Window * window);

	class callbacks
	{
		callbacks();								// no default constructor
		callbacks(const callbacks&);				// no copy constructor
		callbacks& operator=(const callbacks&);		// no copy assignment

		std::list<Window *> * windows_;

	public:
		callbacks(std::list<Window *> * windows);

		static mvIMPACT_C::IPL_FRESULT IPL_C_CALLTYPE  DISP_OnOoiCreated(
			mvIMPACT_C::DISP_OOISETHANDLE set,
			mvIMPACT_C::DISP_OOIHANDLE    hOoi,
			mvIMPACT_C::IPL_CONST_VOID_PTR userPtr);

		static mvIMPACT_C::IPL_FRESULT IPL_C_CALLTYPE  DISP_OnOoiDestroyed(
			mvIMPACT_C::DISP_OOISETHANDLE set,
			mvIMPACT_C::DISP_OOIHANDLE    hOoi,
			mvIMPACT_C::IPL_CONST_VOID_PTR userPtr);

		static mvIMPACT_C::IPL_FRESULT IPL_C_CALLTYPE DISP_OnAddOoi(
			mvIMPACT_C::IPL_HWND         window,
			const mvIMPACT_C::IPL_CHAR*  type,
			mvIMPACT_C::IPL_POINT*       points,
			mvIMPACT_C::IPL_ULONG        count,
			mvIMPACT_C::IPL_CONST_VOID_PTR* OoiUserPtr,
			mvIMPACT_C::IPL_CONST_VOID_PTR  UserPtr);

		static mvIMPACT_C::IPL_FRESULT IPL_C_CALLTYPE DISP_OnOoiSelect(
			mvIMPACT_C::DISP_OOISETHANDLE set,
			mvIMPACT_C::DISP_OOIHANDLE    hOoi,
			mvIMPACT_C::IPL_BOOL          select,
			mvIMPACT_C::IPL_BOOL*         cancel,
			mvIMPACT_C::IPL_CONST_VOID_PTR userPtr);

		static mvIMPACT_C::IPL_FRESULT IPL_C_CALLTYPE DISP_OnOoiStartTracking(
			mvIMPACT_C::DISP_OOISETHANDLE set,
			mvIMPACT_C::DISP_OOIHANDLE    hOoi,
			mvIMPACT_C::IPL_LONG          handle,
			mvIMPACT_C::IPL_BOOL*         cancel,
			mvIMPACT_C::IPL_CONST_VOID_PTR userPtr);

		static mvIMPACT_C::IPL_FRESULT IPL_C_CALLTYPE DISP_OnOoiEndTracking(
			mvIMPACT_C::DISP_OOISETHANDLE set,
			mvIMPACT_C::DISP_OOIHANDLE    hOoi,
			mvIMPACT_C::IPL_CONST_VOID_PTR userPtr);

		static mvIMPACT_C::IPL_FRESULT IPL_C_CALLTYPE DISP_OnOoiTrackTo(
			mvIMPACT_C::DISP_OOISETHANDLE set,
			mvIMPACT_C::DISP_OOIHANDLE    hOoi,
			mvIMPACT_C::IPL_LONG          handle,
			const mvIMPACT_C::IPL_POINT*  point,
			mvIMPACT_C::IPL_BOOL*         cancel,
			mvIMPACT_C::IPL_CONST_VOID_PTR userPtr);

		static mvIMPACT_C::IPL_FRESULT IPL_C_CALLTYPE DISP_OnOoiTracked(
			mvIMPACT_C::DISP_OOISETHANDLE set,
			mvIMPACT_C::DISP_OOIHANDLE    hOoi,
			mvIMPACT_C::IPL_CONST_VOID_PTR userPtr);

		static mvIMPACT_C::IPL_FRESULT IPL_C_CALLTYPE DISP_OnBeforeDraw(
			mvIMPACT_C::IPL_HWND window,
			mvIMPACT_C::IPL_BUFHANDLE    buffer,
			mvIMPACT_C::IPL_HDC          hdc,
			const mvIMPACT_C::IPL_RECT*  source,
			const mvIMPACT_C::IPL_RECT*  dest,
			mvIMPACT_C::IPL_BOOL*        cancel,
			mvIMPACT_C::IPL_CONST_VOID_PTR userPtr);

		static mvIMPACT_C::IPL_FRESULT IPL_C_CALLTYPE DISP_OnDraw(
			mvIMPACT_C::IPL_HWND window,
			mvIMPACT_C::IPL_BUFHANDLE    buffer,
			mvIMPACT_C::IPL_HDC          hdc,
			const mvIMPACT_C::IPL_RECT * source,
			const mvIMPACT_C::IPL_RECT * dest ,
			mvIMPACT_C::IPL_CONST_VOID_PTR userPtr);

		static mvIMPACT_C::IPL_FRESULT IPL_C_CALLTYPE DISP_OnWindowButtonDown(
			mvIMPACT_C::IPL_HWND window,
			const mvIMPACT_C::IPL_POINT* point,
			mvIMPACT_C::DISP_MOUSEBUTTON button,
			mvIMPACT_C::IPL_BOOL*        cancel,
			mvIMPACT_C::IPL_CONST_VOID_PTR userPtr);

		static mvIMPACT_C::IPL_FRESULT IPL_C_CALLTYPE DISP_OnWindowButtonUp(
			mvIMPACT_C::IPL_HWND window,
			const mvIMPACT_C::IPL_POINT* point,
			mvIMPACT_C::DISP_MOUSEBUTTON button,
			mvIMPACT_C::IPL_BOOL*        cancel,
			mvIMPACT_C::IPL_CONST_VOID_PTR userPtr);

		static mvIMPACT_C::IPL_FRESULT IPL_C_CALLTYPE DISP_OnWindowDblClk(
			mvIMPACT_C::IPL_HWND window,
			const mvIMPACT_C::IPL_POINT* point,
			mvIMPACT_C::DISP_MOUSEBUTTON button,
			mvIMPACT_C::IPL_BOOL*        cancel,
			mvIMPACT_C::IPL_CONST_VOID_PTR userPtr);

		static mvIMPACT_C::IPL_FRESULT IPL_C_CALLTYPE DISP_OnWindowMouseMove(
			mvIMPACT_C::IPL_HWND window,
			const mvIMPACT_C::IPL_POINT* point,
			mvIMPACT_C::DISP_MOUSEBUTTON button,
			mvIMPACT_C::IPL_BOOL*        cancel,
			mvIMPACT_C::IPL_CONST_VOID_PTR userPtr);

		static mvIMPACT_C::IPL_FRESULT IPL_C_CALLTYPE DISP_OnButtonDown(
			mvIMPACT_C::IPL_HWND window,
			const mvIMPACT_C::IPL_POINT_DOUBLE* point,
			mvIMPACT_C::DISP_MOUSEBUTTON        button,
			mvIMPACT_C::IPL_BOOL*               cancel,
			mvIMPACT_C::IPL_CONST_VOID_PTR      userPtr);

		static mvIMPACT_C::IPL_FRESULT IPL_C_CALLTYPE DISP_OnButtonUp(
			mvIMPACT_C::IPL_HWND window,
			const mvIMPACT_C::IPL_POINT_DOUBLE* point,
			mvIMPACT_C::DISP_MOUSEBUTTON        button,
			mvIMPACT_C::IPL_BOOL*               cancel,
			mvIMPACT_C::IPL_CONST_VOID_PTR      userPtr);

		static mvIMPACT_C::IPL_FRESULT IPL_C_CALLTYPE DISP_OnDblClk(
			mvIMPACT_C::IPL_HWND window,
			const mvIMPACT_C::IPL_POINT_DOUBLE* point,
			mvIMPACT_C::DISP_MOUSEBUTTON        button,
			mvIMPACT_C::IPL_BOOL*               cancel,
			mvIMPACT_C::IPL_CONST_VOID_PTR      userPtr);

		static mvIMPACT_C::IPL_FRESULT IPL_C_CALLTYPE DISP_OnMouseMove(
			mvIMPACT_C::IPL_HWND window,
			const mvIMPACT_C::IPL_POINT_DOUBLE* point,
			mvIMPACT_C::DISP_MOUSEBUTTON        button,
			mvIMPACT_C::IPL_BOOL*               cancel,
			mvIMPACT_C::IPL_CONST_VOID_PTR      userPtr);

		static mvIMPACT_C::IPL_FRESULT IPL_C_CALLTYPE DISP_OnKeyDown(
			mvIMPACT_C::IPL_HWND window,
			mvIMPACT_C::IPL_ULONG       character,
			mvIMPACT_C::IPL_BOOL*       cancel,
			mvIMPACT_C::IPL_CONST_VOID_PTR userPtr);

		static mvIMPACT_C::IPL_FRESULT IPL_C_CALLTYPE DISP_OnScrollPosChange(
			mvIMPACT_C::IPL_HWND window,
			mvIMPACT_C::IPL_ULONG       x,
			mvIMPACT_C::IPL_ULONG       y,
			mvIMPACT_C::IPL_CONST_VOID_PTR userPtr);

		static mvIMPACT_C::IPL_FRESULT IPL_C_CALLTYPE DISP_OnZoomFactorsChange(
			mvIMPACT_C::IPL_HWND window,
			mvIMPACT_C::IPL_DOUBLE      x,
			mvIMPACT_C::IPL_DOUBLE      y,
			mvIMPACT_C::IPL_CONST_VOID_PTR userPtr);

		/// Convenience function to set a single callback
		void setCallback(mvIMPACT_C::DISP_CONTROLTYPE item, void * pCallback);

		/// Convenience function to set all callbacks
		void setCallbacks();
	};

	// Pointer to the callbacks
	callbacks * callbacks_;

	/// Convenience function to set all callbacks
	void setCallbacks();

	// Pointer to the list of oois
	std::list<ObjectOfInterest *> * oois_;

	// Add an ooi to the list
	void addOoi(ObjectOfInterest * ooi);

	// Remove an ooi from the list
	void removeOoi(ObjectOfInterest * ooi);

	/// Dispose a Window.
	void dispose();
};

/// \brief This class represents a point of interest.
///
/// A point of interest is used to visualize a point in a window. The point can
/// be displayed with various properties, such as location and color. The user can also
/// interactively manipulate the line, and these interactive manipulations are
/// reported back to the code via virtual functions of the Window class.
/// 
/// A point of interest can be used to both visualize and/or edit point
/// data overlaid on top of a visual image or other visual object.
///
/// This class is derived from mvIMPACT::ObjectOfInterest.
///
/// \see mvIMPACT::ObjectOfInterest
/// \see mvIMPACT::PointOfInterest
/// \see mvIMPACT::LineOfInterest
/// \see mvIMPACT::AreaOfInterest
/// \see mvIMPACT::EllipseOfInterest
/// \see mvIMPACT::PolylineOfInterest
/// \see mvIMPACT::PolygonOfInterest
/// \see mvIMPACT::LineArrayOfInterest
/// \see mvIMPACT::BarcodeVisualizer
/// \see mvIMPACT::DatamatrixVisualizer
//-----------------------------------------------------------------------------
class PointOfInterest : public ObjectOfInterest
//-----------------------------------------------------------------------------
{
	PROXY_CLASS_SIMPLE_DECL(PoiStyle, PointDrawingStyle, PointOfInterest)
	PROXY_CLASS_SIMPLE_DECL(X, int, PointOfInterest)
	PROXY_CLASS_SIMPLE_DECL(Y, int, PointOfInterest)
	PROXY_CLASS_POINT_DECL(Point, Point, PointOfInterest)

public:

	/// \brief Construct an empty point of interest.
	///
	/// An empty point of interest does not have a real ooi allocated in the C layer. It is
	/// just the empty C++ shell.
	///
	/// However, empty points of interest can be made non-empty by assigning other non-empty
	/// points of interest to them.
	PointOfInterest();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
	/// \brief Construct an allocated point of interest from a handle.
	/// 
	/// An allocated point of interest wraps a real ooi allocated in the C layer.
	/// 
	/// Allocated points of interest can be made empty by assigning another empty point of interest to them.
	PointOfInterest(
		/// The window that holds the point of interest.
		const Window & window,
		/// The ooi handle.
		mvIMPACT_C::DISP_OOIHANDLE h);
#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

	/// \brief Construct an allocated point of interest.
	///
	/// The point of interest is attached to the mvIMPACT::Wndow given
	/// with parameter \a window.
	///
	/// \see mvIMPACT::Window
	/// \see mvIMPACT::Point
	PointOfInterest(
		/// The window that holds the point of interest.
		const Window & window,
		/// The point that defines the point of interest.
		const Point & point);

	/// Copy construct a PointOfInterest object.
	PointOfInterest(const PointOfInterest &src);

	/// Destruct a PointOfInterest object.
	virtual ~PointOfInterest();

#ifndef WRAP_ANY
	/// \brief Cast a mvIMPACT::ObjectOfInterest to a mvIMPACT::PointOfInterest
	/// This function exists for overcoming the problem that in event handlers
	/// (eg OnOoiTrack.tracked()) one gets an object of type ObjectOfInterest but need
	/// information from the subclass.
	/// \see mvIMPACT::PointOfInterest::isPointOfInterest
	// \internal
	// There are two reasons, because of which this function was defined:
	// 1. You can solve this problem by using dynamic type casting. But then, RTTI is
	// required. At the moment, the code must compile on a compiler without rtti support,
	// so a class member is used for this purpose.
	// 2. If you would use RTTI, you get problems when creating wrappers for script languages
	// with SWIG (like Python, for example), because there is no possibility to wrap rtti (at
	// time of this writing).
	static const PointOfInterest* castFromObjectOfInterest (
		/// the Ooi to cast from
		const ObjectOfInterest* ooi);
#endif // #ifndef WRAP_ANY

	/// \brief Cast a mvIMPACT::ObjectOfInterest to a mvIMPACT::PointOfInterest
	/// This function exists for overcoming the problem that in event handlers
	/// (eg OnOoiTrack.tracked()) one gets an object of type ObjectOfInterest but need
	/// information from the subclass.
	/// \see mvIMPACT::PointOfInterest::isPointOfInterest
	// \internal
	// There are two reasons, because of which this function was defined:
	// 1. You can solve this problem by using dynamic type casting. But then, RTTI is
	// required. At the moment, the code must compile on a compiler without rtti support,
	// so a class member is used for this purpose.
	// 2. If you would use RTTI, you get problems when creating wrappers for script languages
	// with SWIG (like Python, for example), because there is no possibility to wrap rtti (at
	// time of this writing).
	static PointOfInterest* castFromObjectOfInterest (
		/// the Ooi to cast from
		ObjectOfInterest* ooi);

#ifndef WRAP_PYTHON
	virtual ObjectOfInterest* makeShallowCopy() const;
#endif // WRAP_PYTHON


	/// \brief Get the Ooi text property.
	/// Returns the text that is displayed as the Ooi description.
	virtual std::string getText() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi text property.
	/// Returns the text that is displayed as the Ooi description.
	virtual ObjectOfInterest::TextProxy getText();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi text property.
	/// This sets the text that is displayed as the Ooi description
	virtual PointOfInterest& setText(
		/// The text.
		const std::string& text);


	/// \brief Get the Ooi text color property.
	/// Retrieve the text color of the Ooi.
	/// \see mvIMPACT::RGBColor
	virtual RGBColor getTextColor() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi text color property.
	/// Retrieve the text color of the Ooi.
	/// \see mvIMPACT::RGBColor
	virtual ObjectOfInterest::TextColorProxy getTextColor();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi text color property.
	/// The text of the Ooi will be displayed in the specified color.
	/// \see mvIMPACT::RGBColor
	virtual PointOfInterest& setTextColor(
		/// The text color of the Ooi.
		const RGBColor& color);


	/// \brief Get the Ooi text visible property.
	/// Returns \c true if the text of the Ooi is visible or \c false if not.
	virtual bool getTextVisible() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi text visible property.
	/// Returns \c true if the text of the Ooi is visible or \c false if not.
	virtual ObjectOfInterest::TextVisibleProxy getTextVisible();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi text visible property.
	/// This property can be used to make an Ooi which
	/// draws with the text invisible.
	virtual PointOfInterest& setTextVisible(
		/// The visibility state of the ooi text.
		bool textVisible);


	/// Get the angle of the point.
	virtual double getAngle() const;

#ifndef WRAP_ANY
	/// Get the angle of the point.
	virtual ObjectOfInterest::AngleProxy getAngle();
#endif // #ifndef WRAP_ANY

	/// Set the angle of the point.
	virtual PointOfInterest& setAngle(
		/// The new angle.
		double Angle);


	/// Get the width of the point.
	virtual int getWidth() const;

#ifndef WRAP_ANY
	/// Get the width of the point.
	virtual ObjectOfInterest::WidthProxy getWidth();
#endif // #ifndef WRAP_ANY

	/// Set the width of the point.
	virtual PointOfInterest& setWidth(
		/// The new width.
		int Width);


	/// Get the drawing style of the point.
	virtual PointDrawingStyle getPoiStyle() const;

#ifndef WRAP_ANY
	/// Get the drawing style of the point.
	virtual PointOfInterest::PoiStyleProxy getPoiStyle();
#endif // #ifndef WRAP_ANY

	/// Set the drawing style of the point.
	virtual PointOfInterest& setPoiStyle(
		/// The new style.
		PointDrawingStyle Style);


	/// Get the horizontal position of the point.
	virtual int getX() const;

#ifndef WRAP_ANY
	/// Get the horizontal position of the point.
	virtual PointOfInterest::XProxy getX();
#endif // #ifndef WRAP_ANY

	/// Set the horizontal position of the point.
	virtual PointOfInterest& setX(
		/// The new position.
		int x0);


	/// Get the vertical position of the point.
	virtual int getY() const;

#ifndef WRAP_ANY
	/// Get the vertical position of the point.
	virtual PointOfInterest::YProxy getY();
#endif // #ifndef WRAP_ANY

	/// Set the vertical position of the point.
	virtual PointOfInterest& setY(
		/// The new position.
		int y0);

	/// \brief Get the coordinate of the point of interest
	/// Return a mvIMPACT::Point object corresponding to the PointOfInterest object
	/// \see mvIMPACT::Point
	/// \see mvIMPACT::PointOfInterest::setPoint
	virtual Point getPoint() const;

#ifndef WRAP_ANY
	/// \brief Get the coordinate of the point of interest
	/// Return a mvIMPACT::Point object corresponding to the PointOfInterest object
	/// \see mvIMPACT::Point
	/// \see mvIMPACT::PointOfInterest::setPoint
	virtual PointOfInterest::PointProxy getPoint();
#endif // #ifndef WRAP_ANY

	/// \brief Set the coordinate of the point of interest
	/// Set the coordinates of the PointOfInterest object to those given by a Point object
	/// Return a mvIMPACT::Point object corresponding to the PointOfInterest object
	/// \see mvIMPACT::Point
	/// \see mvIMPACT::PointOfInterest::getPoint
	virtual PointOfInterest& setPoint(
		/// the point that represents the Poi
		const Point & point);
};

/// \brief This class represents a line of interest.
///
/// A line of interest is used to visualize a line in a window. The line can be
/// displayed with various properties, such as location and color. The user can also
/// interactively manipulate the line, and these interactive manipulations are 
/// reported back to the code via virtual functions of the Window class.
/// 
/// A line of interest can be used to both visualize and/or edit line
/// data overlaid on top of a visual image or other visual object.
///
/// This class is derived from mvIMPACT::ObjectOfInterest.
///
/// \see mvIMPACT::ObjectOfInterest
/// \see mvIMPACT::PointOfInterest
/// \see mvIMPACT::LineOfInterest
/// \see mvIMPACT::AreaOfInterest
/// \see mvIMPACT::EllipseOfInterest
/// \see mvIMPACT::PolylineOfInterest
/// \see mvIMPACT::PolygonOfInterest
/// \see mvIMPACT::LineArrayOfInterest
/// \see mvIMPACT::BarcodeVisualizer
/// \see mvIMPACT::DatamatrixVisualizer
//-----------------------------------------------------------------------------
class LineOfInterest : public ObjectOfInterest
//-----------------------------------------------------------------------------
{
	PROXY_CLASS_SIMPLE_DECL(ShowArrow, bool, LineOfInterest)
	PROXY_CLASS_SIMPLE_DECL(DragWidth, bool, LineOfInterest)
	PROXY_CLASS_SIMPLE_DECL(X0, int, LineOfInterest)
	PROXY_CLASS_SIMPLE_DECL(Y0, int, LineOfInterest)
	PROXY_CLASS_SIMPLE_DECL(X1, int, LineOfInterest)
	PROXY_CLASS_SIMPLE_DECL(Y1, int, LineOfInterest)
	PROXY_CLASS_LINE_DECL(Line, Line, LineOfInterest)

public:

	/// \brief Construct an empty line of interest.
	///
	/// An empty line of interest does not have a real ooi allocated in the C layer. It is
	/// just the empty C++ shell.
	///
	/// However, empty lines of interest can be made non-empty by assigning other non-empty
	/// lines of interest to them.
	LineOfInterest();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
	/// \brief Construct an allocated line of interest from a handle.
	/// 
	/// An allocated line of interest wraps a real ooi allocated in the C layer.
	/// 
	/// Allocated lines of interest can be made empty by assigning another empty line of interest to them.
	LineOfInterest(
		/// The window that holds the line of interest.
		const Window & window,
		/// The ooi handle.
		mvIMPACT_C::DISP_OOIHANDLE h);
#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

	/// \brief Construct an allocated line of interest.
	///
	/// The line of interest is attached to the mvIMPACT::Window given
	/// with parameter \a window.
	///
	/// \see mvIMPACT::Window
	/// \see mvIMPACT::Line
	LineOfInterest(
		/// The window that holds the line of interest.
		const Window & window,
		/// The line that defines the line of interest.
		const Line & line);

	/// Copy construct a LineOfInterest object
	LineOfInterest(const LineOfInterest &s);

	/// Destruct a LineOfInterest object.
	virtual ~LineOfInterest();

#ifndef WRAP_ANY
	/// \brief Cast a mvIMPACT::ObjectOfInterest to a mvIMPACT::LineOfInterest
	/// This function exists for overcoming the problem that in event handlers
	/// (eg OnOoiTrack.tracked()) one gets an object of type ObjectOfInterest but need
	/// information from the subclass.
	///
	/// \see mvIMPACT::LineOfInterest::isLineOfInterest
	// \internal
	// There are two reasons, because of which this function was defined:
	// 1. You can solve this problem by using dynamic type casting. But then, RTTI is
	// required. At the moment, the code must compile on a compiler without rtti support,
	// so a class member is used for this purpose.
	// 2. If you would use RTTI, you get problems when creating wrappers for script languages
	// with SWIG (like Python, for example), because there is no possibility to wrap rtti (at
	// time of this writing).
	static const LineOfInterest* castFromObjectOfInterest (
		/// the Ooi to cast from
		const ObjectOfInterest* ooi);
#endif // #ifndef WRAP_ANY

	/// \brief Cast a mvIMPACT::ObjectOfInterest to a mvIMPACT::LineOfInterest
	/// This function exists for overcoming the problem that in event handlers
	/// (eg OnOoiTrack.tracked()) one gets an object of type ObjectOfInterest but need
	/// information from the subclass.
	///
	/// \see mvIMPACT::LineOfInterest::isLineOfInterest
	// \internal
	// There are two reasons, because of which this function was defined:
	// 1. You can solve this problem by using dynamic type casting. But then, RTTI is
	// required. At the moment, the code must compile on a compiler without rtti support,
	// so a class member is used for this purpose.
	// 2. If you would use RTTI, you get problems when creating wrappers for script languages
	// with SWIG (like Python, for example), because there is no possibility to wrap rtti (at
	// time of this writing).
	static LineOfInterest* castFromObjectOfInterest (
		/// the Ooi to cast from
		ObjectOfInterest* ooi);

#ifndef WRAP_PYTHON
	virtual ObjectOfInterest* makeShallowCopy() const;
#endif // WRAP_PYTHON

	/// \brief Get the Ooi fill visible property.
	/// Returns \c true if the Ooi is drawn filled or \c false if not.
	virtual bool getFillVisible() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi fill visible property.
	/// Returns \c true if the Ooi is drawn filled or \c false if not.
	virtual ObjectOfInterest::FillVisibleProxy getFillVisible();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi fill visible property.
	/// This property can be used to make an Ooi which
	/// draws with or without fill.
	virtual LineOfInterest& setFillVisible(
		/// The state of the fill visibility.
		bool fillVisible);


	/// \brief Get the Ooi fill transparent property.
	/// A fill can be solid or semi-transparent.
	/// Returns \c true if the Ooi is filled semi-transparent \c false if it filled solid.
	virtual bool getFillTransparent() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi fill transparent property.
	/// A fill can be solid or semi-transparent.
	/// Returns \c true if the Ooi is filled semi-transparent \c false if it filled solid.
	virtual ObjectOfInterest::FillTransparentProxy getFillTransparent();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi fill transparent property.
	/// A fill can be solid or semi-transparent.
	virtual LineOfInterest& setFillTransparent(
		/// Set to true to fill semi-transparent, false to fill solid.
		bool fillTransparent);


	/// \brief Get the Ooi fill color property.
	/// This gets the Ooi fill color.
	/// \see mvIMPACT::RGBColor
	virtual RGBColor getFillColor() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi fill color property.
	/// This gets the Ooi fill color.
	/// \see mvIMPACT::RGBColor
	virtual ObjectOfInterest::FillColorProxy getFillColor();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi fill color property.
	/// This sets the Ooi interior to some color.
	/// \see mvIMPACT::RGBColor
	virtual LineOfInterest& setFillColor(
		/// The new color of the ooi interior.
		const RGBColor& color);


	/// \brief Get the Ooi text property.
	/// Returns the text that is displayed as the Ooi description.
	virtual std::string getText() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi text property.
	/// Returns the text that is displayed as the Ooi description.
	virtual ObjectOfInterest::TextProxy getText();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi text property.
	/// This sets the text that is displayed as the Ooi description
	virtual LineOfInterest& setText(
		/// The text.
		const std::string& text);


	/// \brief Get the Ooi text color property.
	/// Retrieve the text color of the Ooi.
	/// \see mvIMPACT::RGBColor
	virtual RGBColor getTextColor() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi text color property.
	/// Retrieve the text color of the Ooi.
	/// \see mvIMPACT::RGBColor
	virtual ObjectOfInterest::TextColorProxy getTextColor();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi text color property.
	/// The text of the Ooi will be displayed in the specified color.
	/// \see mvIMPACT::RGBColor
	virtual LineOfInterest& setTextColor(
		/// The text color of the Ooi.
		const RGBColor& color);


	/// \brief Get the Ooi text visible property.
	/// Returns \c true if the text of the Ooi is visible or \c false if not.
	virtual bool getTextVisible() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi text visible property.
	/// Returns \c true if the text of the Ooi is visible or \c false if not.
	virtual ObjectOfInterest::TextVisibleProxy getTextVisible();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi text visible property.
	/// This property can be used to make an Ooi which
	/// draws with the text invisible.
	virtual LineOfInterest& setTextVisible(
		/// The visibility state of the ooi text.
		bool textVisible);


	/// \brief Get the angle of the line of interest.
	/// The angle of the line of interest is calculated based on the position of its endpoints.
	virtual double getAngle() const;


	/// \brief Get the width of the line of interest.
	///
	/// The width returned here is the width on both sides of the line! So the entire line width is 
	/// LineOfInterest::getWidth()*2+1
	virtual int getWidth() const;

#ifndef WRAP_ANY
	/// \brief Get the width of the line of interest.
	///
	/// The width returned here is the width on both sides of the line! So the entire line width is 
	/// LineOfInterest::getWidth()*2+1
	virtual ObjectOfInterest::WidthProxy getWidth();
#endif // #ifndef WRAP_ANY

	/// \brief Set the width of the line of interest.
	///
	/// The width passed here is taken on both sides of the line! So the entire line width is 
	/// \c Width*2+1
	virtual LineOfInterest& setWidth(
		/// The new width.
		int Width);


	/// \brief Get the flag to show an arrow indicating the direction of the line of interest.
	virtual bool getShowArrow() const;

#ifndef WRAP_ANY
	/// \brief Get the flag to show an arrow indicating the direction of the line of interest.
	virtual LineOfInterest::ShowArrowProxy getShowArrow();
#endif // #ifndef WRAP_ANY

	/// \brief Set the flag to show an arrow indicating the direction of the line of interest.
	virtual LineOfInterest& setShowArrow(
		/// The new arrow flag.
		bool ShowArrow);


	/// \brief Get the flag that allows draging the line width.
	virtual bool getDragWidth() const;

#ifndef WRAP_ANY
	/// \brief Get the flag that allows draging the line width.
	virtual LineOfInterest::DragWidthProxy getDragWidth();
#endif // #ifndef WRAP_ANY

	/// \brief Set the flag that allows draging the line width.
	virtual LineOfInterest& setDragWidth(
		/// The new flag.
		bool DragWidth);


	/// Get the horizontal position of the first point.
	virtual int getX0() const;

#ifndef WRAP_ANY
	/// Get the horizontal position of the first point.
	virtual LineOfInterest::X0Proxy getX0();
#endif // #ifndef WRAP_ANY

	/// Set the horizontal position of the first point.
	LineOfInterest& setX0(
		/// The new position.
		int x0);


	/// Get the vertical position of the first point.
	virtual int getY0() const;

#ifndef WRAP_ANY
	/// Get the vertical position of the first point.
	virtual LineOfInterest::Y0Proxy getY0();
#endif // #ifndef WRAP_ANY

	/// Set the vertical position of the first point.
	virtual LineOfInterest& setY0(
		/// The new position.
		int y0);


	/// Get the horizontal position of the second point.
	virtual int getX1() const;

#ifndef WRAP_ANY
	/// Get the horizontal position of the second point.
	virtual LineOfInterest::X1Proxy getX1();
#endif // #ifndef WRAP_ANY

	/// Set the horizontal position of the second point.
	virtual LineOfInterest& setX1(
		/// The new position.
		int x1);


	/// Get the vertical position of the second point.
	virtual int getY1() const;

#ifndef WRAP_ANY
	/// Get the vertical position of the second point.
	virtual LineOfInterest::Y1Proxy getY1();
#endif // #ifndef WRAP_ANY

	/// Set the vertical position of the second point.
	virtual LineOfInterest& setY1(
		/// The new position.
		int y1);

	/// Get the horizontal center position.
	virtual int getCenterX() const;

	/// Get the vertical center position.
	virtual int getCenterY() const;

	/// \brief Get the line that is defined by the Loi.
	/// Returns a mvIMPACT::Line object corresponding to the mvIMPACT::LineOfInterest.
	/// \see mvIMPACT::Line
	/// \see mvIMPACT::LineOfInterest::setLine
	virtual Line getLine() const;

#ifndef WRAP_ANY
	/// \brief Get the line that is defined by the Loi.
	/// Returns a mvIMPACT::Line object corresponding to the mvIMPACT::LineOfInterest.
	/// \see mvIMPACT::Line
	/// \see mvIMPACT::LineOfInterest::setLine
	virtual LineOfInterest::LineProxy getLine();
#endif // #ifndef WRAP_ANY

	/// \brief Set the coordinates of the Loi.
	/// Sets the coordinates of the LineOfInterest object to those given by a Line object
	/// \see mvIMPACT::LineOfInterest::getLine
	/// \see mvIMPACT::Line
	virtual LineOfInterest& setLine(
		/// The line that defines the Loi.
		Line line);
};

/// \brief This class represents an area of interest.
///
/// An area of interest is used to visualize a rectangular area 
/// in a window. The area can be displayed with various properties, such as location
/// and color. The user can also interactively manipulate the area, and these
/// interactive manipulations are reported back to the code via virtual functions
/// of the Window class.
/// 
/// An area of interest can be used to both visualize and/or edit rectangle
/// data overlaid on top of a visual image or other visual object.
///
/// This class is derived from mvIMPACT::ObjectOfInterest.
///
/// \see mvIMPACT::ObjectOfInterest
/// \see mvIMPACT::PointOfInterest
/// \see mvIMPACT::LineOfInterest
/// \see mvIMPACT::AreaOfInterest
/// \see mvIMPACT::EllipseOfInterest
/// \see mvIMPACT::PolylineOfInterest
/// \see mvIMPACT::PolygonOfInterest
/// \see mvIMPACT::LineArrayOfInterest
/// \see mvIMPACT::BarcodeVisualizer
/// \see mvIMPACT::DatamatrixVisualizer
class AreaOfInterest : public ObjectOfInterest
{
	PROXY_CLASS_SIMPLE_DECL(ConstrainSquare, bool, AreaOfInterest)
	PROXY_CLASS_SIMPLE_DECL(Left, int, AreaOfInterest)
	PROXY_CLASS_SIMPLE_DECL(Top, int, AreaOfInterest)
	PROXY_CLASS_SIMPLE_DECL(Right, int, AreaOfInterest)
	PROXY_CLASS_SIMPLE_DECL(Bottom, int, AreaOfInterest)
	PROXY_CLASS_RECTANGLE_DECL(Rectangle, Rectangle, AreaOfInterest)

public:

	/// \brief Construct an empty area of interest.
	///
	/// An empty area of interest does not have a real ooi allocated in the C layer. It is
	/// just the empty C++ shell.
	///
	/// However, empty areas of interest can be made non-empty by assigning other non-empty
	/// areas of interest to them.
	AreaOfInterest();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
	/// \brief Construct an allocated area of interest from a handle.
	/// 
	/// An allocated area of interest wraps a real ooi allocated in the C layer.
	/// 
	/// Allocated areas of interest can be made empty by assigning another empty area of interest to them.
	AreaOfInterest(
		/// The window that holds the area of interest.
		const Window & window,
		/// The ooi handle.
		mvIMPACT_C::DISP_OOIHANDLE h);
#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

	/// \brief Construct an allocated area of interest.
	///
	/// The area of interest is attached to the mvIMPACT::Window given
	/// with parameter \a window.
	/// 
	/// \see mvIMPACT::Window
	/// \see mvIMPACT::Rectangle
	AreaOfInterest(
		/// The window that holds the area of interest.
		const Window & window,
		/// The rectangle that defines the area of interest.
		const Rectangle &rect);

	/// Copy construct an AreaOfInterest object
	AreaOfInterest(const AreaOfInterest & src);

	/// Destruct an AreaOfInterest object.
	virtual ~AreaOfInterest();

#ifndef WRAP_ANY
	/// \brief Cast a mvIMPACT::ObjectOfInterest to mvIMPACT::AreaOfInterest
	/// This function exists for overcoming the problem that in event handlers
	/// (eg OnOoiTrack.tracked()) one gets an object of type ObjectOfInterest but need
	/// information from the subclass.
	/// \see mvIMPACT::AreaOfInterest::isAreaOfInterest
	// \internal
	// There are two reasons, because of which this function was defined:
	// 1. You can solve this problem by using dynamic type casting. But then, RTTI is
	// required. At the moment, the code must compile on a compiler without rtti support,
	// so a class member is used for this purpose.
	// 2. If you would use RTTI, you get problems when creating wrappers for script languages
	// with SWIG (like Python, for example), because there is no possibility to wrap rtti (at
	// time of this writing).
	static const AreaOfInterest* castFromObjectOfInterest(
		/// the object of interest to cast from
		const ObjectOfInterest *ooi);
#endif // #ifndef WRAP_ANY

	/// \brief Cast a mvIMPACT::ObjectOfInterest to mvIMPACT::AreaOfInterest
	/// This function exists for overcoming the problem that in event handlers
	/// (eg OnOoiTrack.tracked()) one gets an object of type ObjectOfInterest but need
	/// information from the subclass.
	/// \see mvIMPACT::AreaOfInterest::isAreaOfInterest
	// \internal
	// There are two reasons, because of which this function was defined:
	// 1. You can solve this problem by using dynamic type casting. But then, RTTI is
	// required. At the moment, the code must compile on a compiler without rtti support,
	// so a class member is used for this purpose.
	// 2. If you would use RTTI, you get problems when creating wrappers for script languages
	// with SWIG (like Python, for example), because there is no possibility to wrap rtti (at
	// time of this writing).
	static AreaOfInterest* castFromObjectOfInterest(
		/// the object of interest to cast from
		ObjectOfInterest *ooi);

#ifndef WRAP_PYTHON
	virtual ObjectOfInterest* makeShallowCopy() const;
#endif // WRAP_PYTHON

	/// \brief Get the Ooi fill visible property.
	/// Returns \c true if the Ooi is drawn filled or \c false if not.
	virtual bool getFillVisible() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi fill visible property.
	/// Returns \c true if the Ooi is drawn filled or \c false if not.
	virtual ObjectOfInterest::FillVisibleProxy getFillVisible();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi fill visible property.
	/// This property can be used to make an Ooi which
	/// draws with or without fill.
	virtual AreaOfInterest& setFillVisible(
		/// The state of the fill visibility.
		bool fillVisible);


	/// \brief Get the Ooi fill transparent property.
	/// A fill can be solid or semi-transparent.
	/// Returns \c true if the Ooi is filled semi-transparent \c false if it filled solid.
	virtual bool getFillTransparent() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi fill transparent property.
	/// A fill can be solid or semi-transparent.
	/// Returns \c true if the Ooi is filled semi-transparent \c false if it filled solid.
	virtual ObjectOfInterest::FillTransparentProxy getFillTransparent();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi fill transparent property.
	/// A fill can be solid or semi-transparent.
	virtual AreaOfInterest& setFillTransparent(
		/// Set to true to fill semi-transparent, false to fill solid.
		bool fillTransparent);


	/// \brief Get the Ooi fill color property.
	/// This gets the Ooi fill color.
	/// \see mvIMPACT::RGBColor
	virtual RGBColor getFillColor() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi fill color property.
	/// This gets the Ooi fill color.
	/// \see mvIMPACT::RGBColor
	virtual ObjectOfInterest::FillColorProxy getFillColor();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi fill color property.
	/// This sets the Ooi interior to some color.
	/// \see mvIMPACT::RGBColor
	virtual AreaOfInterest& setFillColor(
		/// The new color of the ooi interior.
		const RGBColor& color);


	/// \brief Get the Ooi text property.
	/// Returns the text that is displayed as the Ooi description.
	virtual std::string getText() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi text property.
	/// Returns the text that is displayed as the Ooi description.
	virtual ObjectOfInterest::TextProxy getText();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi text property.
	/// This sets the text that is displayed as the Ooi description
	virtual AreaOfInterest& setText(
		/// The text.
		const std::string& text);


	/// \brief Get the Ooi text color property.
	/// Retrieve the text color of the Ooi.
	/// \see mvIMPACT::RGBColor
	virtual RGBColor getTextColor() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi text color property.
	/// Retrieve the text color of the Ooi.
	/// \see mvIMPACT::RGBColor
	virtual ObjectOfInterest::TextColorProxy getTextColor();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi text color property.
	/// The text of the Ooi will be displayed in the specified color.
	/// \see mvIMPACT::RGBColor
	virtual AreaOfInterest& setTextColor(
		/// The text color of the Ooi.
		const RGBColor& color);


	/// \brief Get the Ooi text visible property.
	/// Returns \c true if the text of the Ooi is visible or \c false if not.
	virtual bool getTextVisible() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi text visible property.
	/// Returns \c true if the text of the Ooi is visible or \c false if not.
	virtual ObjectOfInterest::TextVisibleProxy getTextVisible();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi text visible property.
	/// This property can be used to make an Ooi which
	/// draws with the text invisible.
	virtual AreaOfInterest& setTextVisible(
		/// The visibility state of the ooi text.
		bool textVisible);


	/// Get the constrain flag.
	virtual bool getConstrainSquare() const;

#ifndef WRAP_ANY
	/// Get the constrain flag.
	virtual AreaOfInterest::ConstrainSquareProxy getConstrainSquare();
#endif // #ifndef WRAP_ANY

	/// Set the constrain flag.
	virtual AreaOfInterest& setConstrainSquare(
		/// The new setting.
		bool Constrain);


	/// Get the left position.
	virtual int getLeft() const;

#ifndef WRAP_ANY
	/// Get the left position.
	virtual AreaOfInterest::LeftProxy getLeft();
#endif // #ifndef WRAP_ANY

	/// Set the left position.
	virtual AreaOfInterest& setLeft(
		/// The new position.
		int left);


	/// Get the top position.
	virtual int getTop() const;

#ifndef WRAP_ANY
	/// Get the top position.
	virtual AreaOfInterest::TopProxy getTop();
#endif // #ifndef WRAP_ANY

	/// Set the top position.
	virtual AreaOfInterest& setTop(
		/// The new position.
		int top);


	/// Get the right position.
	virtual int getRight() const;

#ifndef WRAP_ANY
	/// Get the right position.
	virtual AreaOfInterest::RightProxy getRight();
#endif // #ifndef WRAP_ANY

	/// Set the right position.
	virtual AreaOfInterest& setRight(
		/// The new position.
		int right);


	/// Get the bottom position.
	virtual int getBottom() const;

#ifndef WRAP_ANY
	/// Get the bottom position.
	virtual AreaOfInterest::BottomProxy getBottom();
#endif // #ifndef WRAP_ANY

	/// Set the bottom position.
	virtual AreaOfInterest& setBottom(
		/// The new position.
		int bottom);

	/// Get the horizontal center position.
	int getCenterX() const;

	/// Get the vertical center position.
	int getCenterY() const;

	/// \brief Retrieve the bounds of the Aoi.
	/// Returns a Rectangle object corresponding to the AreaOfInterest object.
	/// \see mvIMPACT::Rectangle
	/// \see mvIMPACT::setRectangle
	virtual Rectangle getRectangle() const;

#ifndef WRAP_ANY
	/// \brief Retrieve the bounds of the Aoi.
	/// Returns a Rectangle object corresponding to the AreaOfInterest object.
	/// \see mvIMPACT::Rectangle
	/// \see mvIMPACT::setRectangle
	virtual AreaOfInterest::RectangleProxy getRectangle();
#endif // #ifndef WRAP_ANY

	/// \brief Set the bounds of the Aoi
	/// Sets the coordinates of the AreaOfInterest object to those given by a Rectangle object.
	/// \see mvIMPACT::Rectangle
	/// \see mvIMPACT::getRectangle
	virtual AreaOfInterest& setRectangle(
		/// The rectangle that defines the new bounds of the Aoi.
		Rectangle rectangle);
};

/// \brief This class represents an ellipse of interest.
///
/// An ellipse of interest is used to visualize an elliptical area 
/// in a window. The area can be displayed with various properties, such as location
/// and color. The user can also interactively manipulate the area, and these
/// interactive manipulations are reported back to the code via virtual functions
/// of the Window class.
/// 
/// An ellipse of interest can be used to both visualize and/or edit ellipse
/// data overlaid on top of a visual image or other visual object.
///
/// This class is derived from mvIMPACT::ObjectOfInterest.
///
/// \see mvIMPACT::ObjectOfInterest
/// \see mvIMPACT::PointOfInterest
/// \see mvIMPACT::LineOfInterest
/// \see mvIMPACT::AreaOfInterest
/// \see mvIMPACT::EllipseOfInterest
/// \see mvIMPACT::PolylineOfInterest
/// \see mvIMPACT::PolygonOfInterest
/// \see mvIMPACT::LineArrayOfInterest
/// \see mvIMPACT::BarcodeVisualizer
/// \see mvIMPACT::DatamatrixVisualizer
class EllipseOfInterest : public ObjectOfInterest
{
	PROXY_CLASS_SIMPLE_DECL(ConstrainCircle, bool, EllipseOfInterest)
	PROXY_CLASS_SIMPLE_DECL(Left, int, EllipseOfInterest)
	PROXY_CLASS_SIMPLE_DECL(Top, int, EllipseOfInterest)
	PROXY_CLASS_SIMPLE_DECL(Right, int, EllipseOfInterest)
	PROXY_CLASS_SIMPLE_DECL(Bottom, int, EllipseOfInterest)
	PROXY_CLASS_RECTANGLE_DECL(Rectangle, Rectangle, EllipseOfInterest)

public:

	/// \brief Construct an empty ellipse of interest.
	///
	/// An empty ellipse of interest does not have a real ooi allocated in the C layer. It is
	/// just the empty C++ shell.
	///
	/// However, empty ellipses of interest can be made non-empty by assigning other non-empty
	/// ellipses of interest to them.
	EllipseOfInterest();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
	/// \brief Construct an allocated ellipse of interest from a handle.
	/// 
	/// An allocated ellipse of interest wraps a real ooi allocated in the C layer.
	/// 
	/// Allocated ellipses of interest can be made empty by assigning another empty ellipse of interest to them.
	EllipseOfInterest(
		/// The window that holds the ellipse of interest.
		const Window & window,
		/// The ooi handle.
		mvIMPACT_C::DISP_OOIHANDLE h);
#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

	/// \brief Construct an allocated ellipse of interest.
	///
	/// The ellipse of interest is attached to the mvIMPACT::Window given
	/// with parameter \a window.
	/// 
	/// \see mvIMPACT::Window
	/// \see mvIMPACT::Rectangle
	EllipseOfInterest(
		/// The window that holds the ellipse of interest.
		const Window & window,
		/// The rectangle that defines the bounds of the ellipse of interest.
		const Rectangle & rect);

	/// Copy construct an EllipseOfInterest object
	EllipseOfInterest(const EllipseOfInterest & src);

	/// Destruct an EllipseOfInterest object.
	virtual ~EllipseOfInterest();

#ifndef WRAP_ANY
	/// \brief Cast a mvIMPACT::ObjectOfInterest to mvIMPACT::EllipseOfInterest
	/// This function exists for overcoming the problem that in event handlers
	/// (eg OnOoiTrack.tracked()) one gets an object of type ObjectOfInterest but need
	/// information from the subclass.
	/// \see mvIMPACT::EllipseOfInterest::isEllipseOfInterest
	// \internal
	// There are two reasons, because of which this function was defined:
	// 1. You can solve this problem by using dynamic type casting. But then, RTTI is
	// required. At the moment, the code must compile on a compiler without rtti support,
	// so a class member is used for this purpose.
	// 2. If you would use RTTI, you get problems when creating wrappers for script languages
	// with SWIG (like Python, for example), because there is no possibility to wrap rtti (at
	// time of this writing).
	static const EllipseOfInterest* castFromObjectOfInterest(
		/// the object of interest to cast from
		const ObjectOfInterest *ooi);
#endif // #ifndef WRAP_ANY

	/// \brief Cast a mvIMPACT::ObjectOfInterest to mvIMPACT::EllipseOfInterest
	/// This function exists for overcoming the problem that in event handlers
	/// (eg OnOoiTrack.tracked()) one gets an object of type ObjectOfInterest but need
	/// information from the subclass.
	/// \see mvIMPACT::EllipseOfInterest::isEllipseOfInterest
	// \internal
	// There are two reasons, because of which this function was defined:
	// 1. You can solve this problem by using dynamic type casting. But then, RTTI is
	// required. At the moment, the code must compile on a compiler without rtti support,
	// so a class member is used for this purpose.
	// 2. If you would use RTTI, you get problems when creating wrappers for script languages
	// with SWIG (like Python, for example), because there is no possibility to wrap rtti (at
	// time of this writing).
	static EllipseOfInterest* castFromObjectOfInterest(
		/// the object of interest to cast from
		ObjectOfInterest *ooi);

#ifndef WRAP_PYTHON
	virtual ObjectOfInterest* makeShallowCopy() const;
#endif // WRAP_PYTHON

	/// \brief Get the Ooi fill visible property.
	/// Returns \c true if the Ooi is drawn filled or \c false if not.
	virtual bool getFillVisible() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi fill visible property.
	/// Returns \c true if the Ooi is drawn filled or \c false if not.
	virtual ObjectOfInterest::FillVisibleProxy getFillVisible();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi fill visible property.
	/// This property can be used to make an Ooi which
	/// draws with or without fill.
	virtual EllipseOfInterest& setFillVisible(
		/// The state of the fill visibility.
		bool fillVisible);


	/// \brief Get the Ooi fill transparent property.
	/// A fill can be solid or semi-transparent.
	/// Returns \c true if the Ooi is filled semi-transparent \c false if it filled solid.
	virtual bool getFillTransparent() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi fill transparent property.
	/// A fill can be solid or semi-transparent.
	/// Returns \c true if the Ooi is filled semi-transparent \c false if it filled solid.
	virtual ObjectOfInterest::FillTransparentProxy getFillTransparent();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi fill transparent property.
	/// A fill can be solid or semi-transparent.
	virtual EllipseOfInterest& setFillTransparent(
		/// Set to true to fill semi-transparent, false to fill solid.
		bool fillTransparent);


	/// \brief Get the Ooi fill color property.
	/// This gets the Ooi fill color.
	/// \see mvIMPACT::RGBColor
	virtual RGBColor getFillColor() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi fill color property.
	/// This gets the Ooi fill color.
	/// \see mvIMPACT::RGBColor
	virtual ObjectOfInterest::FillColorProxy getFillColor();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi fill color property.
	/// This sets the Ooi interior to some color.
	/// \see mvIMPACT::RGBColor
	virtual EllipseOfInterest& setFillColor(
		/// The new color of the ooi interior.
		const RGBColor& color);


	/// \brief Get the Ooi text property.
	/// Returns the text that is displayed as the Ooi description.
	virtual std::string getText() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi text property.
	/// Returns the text that is displayed as the Ooi description.
	virtual ObjectOfInterest::TextProxy getText();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi text property.
	/// This sets the text that is displayed as the Ooi description
	virtual EllipseOfInterest& setText(
		/// The text.
		const std::string& text);


	/// \brief Get the Ooi text color property.
	/// Retrieve the text color of the Ooi.
	/// \see mvIMPACT::RGBColor
	virtual RGBColor getTextColor() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi text color property.
	/// Retrieve the text color of the Ooi.
	/// \see mvIMPACT::RGBColor
	virtual ObjectOfInterest::TextColorProxy getTextColor();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi text color property.
	/// The text of the Ooi will be displayed in the specified color.
	/// \see mvIMPACT::RGBColor
	virtual EllipseOfInterest& setTextColor(
		/// The text color of the Ooi.
		const RGBColor& color);


	/// \brief Get the Ooi text visible property.
	/// Returns \c true if the text of the Ooi is visible or \c false if not.
	virtual bool getTextVisible() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi text visible property.
	/// Returns \c true if the text of the Ooi is visible or \c false if not.
	virtual ObjectOfInterest::TextVisibleProxy getTextVisible();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi text visible property.
	/// This property can be used to make an Ooi which
	/// draws with the text invisible.
	virtual EllipseOfInterest& setTextVisible(
		/// The visibility state of the ooi text.
		bool textVisible);


	/// Get the constrain flag.
	virtual bool getConstrainCircle() const;

#ifndef WRAP_ANY
	/// Get the constrain flag.
	virtual EllipseOfInterest::ConstrainCircleProxy getConstrainCircle();
#endif // #ifndef WRAP_ANY

	/// Set the constrain flag.
	virtual EllipseOfInterest& setConstrainCircle(
		/// The new setting.
		bool Constrain);


	/// Get the left position.
	virtual int getLeft() const;

#ifndef WRAP_ANY
	/// Get the left position.
	virtual EllipseOfInterest::LeftProxy getLeft();
#endif // #ifndef WRAP_ANY

	/// Set the left position.
	virtual EllipseOfInterest& setLeft(
		/// The new position.
		int left);


	/// Get the top position.
	virtual int getTop() const;

#ifndef WRAP_ANY
	/// Get the top position.
	virtual EllipseOfInterest::TopProxy getTop();
#endif // #ifndef WRAP_ANY

	/// Set the top position.
	virtual EllipseOfInterest& setTop(
		/// The new position.
		int top);


	/// Get the right position.
	virtual int getRight() const;

#ifndef WRAP_ANY
	/// Get the right position.
	virtual EllipseOfInterest::RightProxy getRight();
#endif // #ifndef WRAP_ANY

	/// Set the right position.
	virtual EllipseOfInterest& setRight(
		/// The new position.
		int right);


	/// Get the bottom position.
	virtual int getBottom() const;

#ifndef WRAP_ANY
	/// Get the bottom position.
	virtual EllipseOfInterest::BottomProxy getBottom();
#endif // #ifndef WRAP_ANY

	/// Set the bottom position.
	virtual EllipseOfInterest& setBottom(
		/// The new position.
		int bottom);

	/// Get the horizontal center position.
	int getCenterX() const;

	/// Get the vertical center position.
	int getCenterY() const;

	/// \brief Retrieve the bounds of the ellipse.
	/// Returns a Rectangle object corresponding to the EllipseOfInterest object
	/// \see mvIMPACT::Rectangle
	/// \see mvIMPACT::setRectangle
	virtual Rectangle getRectangle() const;

#ifndef WRAP_ANY
	/// \brief Retrieve the bounds of the ellipse.
	/// Returns a Rectangle object corresponding to the EllipseOfInterest object
	/// \see mvIMPACT::Rectangle
	/// \see mvIMPACT::setRectangle
	virtual EllipseOfInterest::RectangleProxy getRectangle();
#endif // #ifndef WRAP_ANY

	/// \brief Set the bounds of the ellipse.
	/// Sets the coordinates of the EllipseOfInterest object to those given by a Rectangle object
	/// \see mvIMPACT::Rectangle
	/// \see mvIMPACT::getRectangle
	virtual EllipseOfInterest& setRectangle(
		/// the rectangle that defines the new bounds of the ellipse.
		Rectangle rectangle);
};

/// \brief This class represents a polyline of interest.
///
/// A polyline of interest is used to visualize a polyline  
/// in a window. The polyline can be displayed with various properties, such as location
/// and color. The user can also interactively manipulate the polyline, and these
/// interactive manipulations are reported back to the code via virtual functions
/// of the Window class.
/// 
/// A polyline of interest can be used to both visualize and/or edit polyline
/// data overlaid on top of a visual image or other visual object.
///
/// This class is derived from mvIMPACT::ObjectOfInterest.
///
/// \see mvIMPACT::ObjectOfInterest
/// \see mvIMPACT::PointOfInterest
/// \see mvIMPACT::LineOfInterest
/// \see mvIMPACT::AreaOfInterest
/// \see mvIMPACT::EllipseOfInterest
/// \see mvIMPACT::PolylineOfInterest
/// \see mvIMPACT::PolygonOfInterest
/// \see mvIMPACT::LineArrayOfInterest
/// \see mvIMPACT::BarcodeVisualizer
/// \see mvIMPACT::DatamatrixVisualizer
class PolylineOfInterest : public ObjectOfInterest
{
public:

	/// \brief Construct an empty polyline of interest.
	///
	/// An empty polyline of interest does not have a real ooi allocated in the C layer. It is
	/// just the empty C++ shell.
	///
	/// However, empty polylines of interest can be made non-empty by assigning other non-empty
	/// polylines of interest to them.
	PolylineOfInterest();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
	/// \brief Construct an allocated polyline of interest from a handle.
	/// 
	/// An allocated polyline of interest wraps a real ooi allocated in the C layer.
	/// 
	/// Allocated polylines of interest can be made empty by assigning another empty polylines of interest to them.
	PolylineOfInterest(
		/// The window that holds the polyline of interest.
		const Window & window,
		/// The ooi handle.
		mvIMPACT_C::DISP_OOIHANDLE h);
#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

	/// \brief Construct an allocated polyline of interest.
	///
	/// The polyline of interest is attached to the mvIMPACT::Window given
	/// with parameter \a window.
	/// 
	/// \see mvIMPACT::Window
	/// \see mvIMPACT::Rectangle
	PolylineOfInterest(
		/// The window that holds the polyline of interest.
		const Window & window,
		/// The array of points that define the polyline.
		const std::vector<Point>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, points));

	/// Copy construct a PolylineOfInterest object
	PolylineOfInterest(const PolylineOfInterest & src);

	/// Destruct a PolylineOfInterest object.
	virtual ~PolylineOfInterest();

#ifndef WRAP_ANY
	/// \brief Cast a mvIMPACT::ObjectOfInterest to mvIMPACT::PolylineOfInterest
	/// This function exists for overcoming the problem that in event handlers
	/// (eg OnOoiTrack.tracked()) one gets an object of type ObjectOfInterest but need
	/// information from the subclass.
	/// \see mvIMPACT::PolylineOfInterest::isPolylineOfInterest
	// \internal
	// There are two reasons, because of which this function was defined:
	// 1. You can solve this problem by using dynamic type casting. But then, RTTI is
	// required. At the moment, the code must compile on a compiler without rtti support,
	// so a class member is used for this purpose.
	// 2. If you would use RTTI, you get problems when creating wrappers for script languages
	// with SWIG (like Python, for example), because there is no possibility to wrap rtti (at
	// time of this writing).
	static const PolylineOfInterest* castFromObjectOfInterest(
		/// the object of interest to cast from
		const ObjectOfInterest *ooi);

#endif // #ifndef WRAP_ANY

	/// \brief Cast a mvIMPACT::ObjectOfInterest to mvIMPACT::PolylineOfInterest
	/// This function exists for overcoming the problem that in event handlers
	/// (eg OnOoiTrack.tracked()) one gets an object of type ObjectOfInterest but need
	/// information from the subclass.
	/// \see mvIMPACT::PolylineOfInterest::isPolylineOfInterest
	// \internal
	// There are two reasons, because of which this function was defined:
	// 1. You can solve this problem by using dynamic type casting. But then, RTTI is
	// required. At the moment, the code must compile on a compiler without rtti support,
	// so a class member is used for this purpose.
	// 2. If you would use RTTI, you get problems when creating wrappers for script languages
	// with SWIG (like Python, for example), because there is no possibility to wrap rtti (at
	// time of this writing).
	static PolylineOfInterest* castFromObjectOfInterest(
		/// the object of interest to cast from
		ObjectOfInterest *ooi);

#ifndef WRAP_PYTHON
	virtual ObjectOfInterest* makeShallowCopy() const;
#endif // WRAP_PYTHON

	/// \brief Get the Ooi text property.
	/// Returns the text that is displayed as the Ooi description.
	virtual std::string getText() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi text property.
	/// Returns the text that is displayed as the Ooi description.
	virtual ObjectOfInterest::TextProxy getText();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi text property.
	/// This sets the text that is displayed as the Ooi description
	virtual PolylineOfInterest& setText(
		/// The text.
		const std::string& text);


	/// \brief Get the Ooi text color property.
	/// Retrieve the text color of the Ooi.
	/// \see mvIMPACT::RGBColor
	virtual RGBColor getTextColor() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi text color property.
	/// Retrieve the text color of the Ooi.
	/// \see mvIMPACT::RGBColor
	virtual ObjectOfInterest::TextColorProxy getTextColor();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi text color property.
	/// The text of the Ooi will be displayed in the specified color.
	/// \see mvIMPACT::RGBColor
	virtual PolylineOfInterest& setTextColor(
		/// The text color of the Ooi.
		const RGBColor& color);


	/// \brief Get the Ooi text visible property.
	/// Returns \c true if the text of the Ooi is visible or \c false if not.
	virtual bool getTextVisible() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi text visible property.
	/// Returns \c true if the text of the Ooi is visible or \c false if not.
	virtual ObjectOfInterest::TextVisibleProxy getTextVisible();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi text visible property.
	/// This property can be used to make an Ooi which
	/// draws with the text invisible.
	virtual PolylineOfInterest& setTextVisible(
		/// The visibility state of the ooi text.
		bool textVisible);


	/// Get the horizontal position.
	int getX(
		/// The index of the point
		int i) const;

	/// Set the horizontal position.
	PolylineOfInterest& setX(
		/// The index of the point.
		int i,
		/// The new position.
		int x);


	/// Get the vertical position.
	int getY(
		/// The index of the point
		int i) const;

	/// Set the vertical position.
	PolylineOfInterest& setY(
		/// The index of the point.
		int i,
		/// The new position.
		int y);


	/// Get the points of the polyline.
	std::vector<Point> getPoints() const;

	/// Set the points of the polyline.
	PolylineOfInterest& setPoints(
		/// The points of the polyline.
		const std::vector<Point>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, points));
};

/// \brief This class represents a polygon of interest.
///
/// A polygon of interest is used to visualize a polygon  
/// in a window. The polygon can be displayed with various properties, such as location
/// and color. The user can also interactively manipulate the polygon, and these
/// interactive manipulations are reported back to the code via virtual functions
/// of the Window class.
/// 
/// A polygon of interest can be used to both visualize and/or edit polygon
/// data overlaid on top of a visual image or other visual object.
///
/// This class is derived from mvIMPACT::ObjectOfInterest.
///
/// \see mvIMPACT::ObjectOfInterest
/// \see mvIMPACT::PointOfInterest
/// \see mvIMPACT::LineOfInterest
/// \see mvIMPACT::AreaOfInterest
/// \see mvIMPACT::EllipseOfInterest
/// \see mvIMPACT::PolylineOfInterest
/// \see mvIMPACT::PolygonOfInterest
/// \see mvIMPACT::LineArrayOfInterest
/// \see mvIMPACT::BarcodeVisualizer
/// \see mvIMPACT::DatamatrixVisualizer
class PolygonOfInterest : public ObjectOfInterest
{
public:

	/// \brief Construct an empty polygon of interest.
	///
	/// An empty polygon of interest does not have a real ooi allocated in the C layer. It is
	/// just the empty C++ shell.
	///
	/// However, empty polygon of interest can be made non-empty by assigning other non-empty
	/// polygon of interest to them.
	PolygonOfInterest();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
	/// \brief Construct an allocated polygon of interest from a handle.
	/// 
	/// An allocated polygon of interest wraps a real ooi allocated in the C layer.
	/// 
	/// Allocated polygons of interest can be made empty by assigning another empty polygons of interest to them.
	PolygonOfInterest(
		/// The window that holds the polygon of interest.
		const Window & window,
		/// The ooi handle.
		mvIMPACT_C::DISP_OOIHANDLE h);
#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

	/// \brief Construct an allocated polygon of interest.
	///
	/// The polygon of interest is attached to the mvIMPACT::Window given
	/// with parameter \a window.
	/// 
	/// \see mvIMPACT::Window
	/// \see mvIMPACT::Rectangle
	PolygonOfInterest(
		/// The window that holds the polygon of interest.
		const Window & window,
		/// The array of points that define the polygon.
		const std::vector<Point>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, points));

	/// Copy construct a PolygonOfInterest object
	PolygonOfInterest(const PolygonOfInterest & src);

	/// Destruct a PolygonOfInterest object.
	virtual ~PolygonOfInterest();

#ifndef WRAP_ANY
	/// \brief Cast a mvIMPACT::ObjectOfInterest to mvIMPACT::PolygonOfInterest
	/// This function exists for overcoming the problem that in event handlers
	/// (eg OnOoiTrack.tracked()) one gets an object of type ObjectOfInterest but need
	/// information from the subclass.
	/// \see mvIMPACT::PolygonOfInterest::isPolygonOfInterest
	// \internal
	// There are two reasons, because of which this function was defined:
	// 1. You can solve this problem by using dynamic type casting. But then, RTTI is
	// required. At the moment, the code must compile on a compiler without rtti support,
	// so a class member is used for this purpose.
	// 2. If you would use RTTI, you get problems when creating wrappers for script languages
	// with SWIG (like Python, for example), because there is no possibility to wrap rtti (at
	// time of this writing).
	static const PolygonOfInterest* castFromObjectOfInterest(
		/// the object of interest to cast from
		const ObjectOfInterest *ooi);

#endif // #ifndef WRAP_ANY

	/// \brief Cast a mvIMPACT::ObjectOfInterest to mvIMPACT::PolygonOfInterest
	/// This function exists for overcoming the problem that in event handlers
	/// (eg OnOoiTrack.tracked()) one gets an object of type ObjectOfInterest but need
	/// information from the subclass.
	/// \see mvIMPACT::PolygonOfInterest::isPolygonOfInterest
	// \internal
	// There are two reasons, because of which this function was defined:
	// 1. You can solve this problem by using dynamic type casting. But then, RTTI is
	// required. At the moment, the code must compile on a compiler without rtti support,
	// so a class member is used for this purpose.
	// 2. If you would use RTTI, you get problems when creating wrappers for script languages
	// with SWIG (like Python, for example), because there is no possibility to wrap rtti (at
	// time of this writing).
	static PolygonOfInterest* castFromObjectOfInterest(
		/// the object of interest to cast from
		ObjectOfInterest *ooi);

#ifndef WRAP_PYTHON
	virtual ObjectOfInterest* makeShallowCopy() const;
#endif // WRAP_PYTHON

	/// \brief Get the Ooi fill visible property.
	/// Returns \c true if the Ooi is drawn filled or \c false if not.
	virtual bool getFillVisible() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi fill visible property.
	/// Returns \c true if the Ooi is drawn filled or \c false if not.
	virtual ObjectOfInterest::FillVisibleProxy getFillVisible();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi fill visible property.
	/// This property can be used to make an Ooi which
	/// draws with or without fill.
	virtual PolygonOfInterest& setFillVisible(
		/// The state of the fill visibility.
		bool fillVisible);


	/// \brief Get the Ooi fill transparent property.
	/// A fill can be solid or semi-transparent.
	/// Returns \c true if the Ooi is filled semi-transparent \c false if it filled solid.
	virtual bool getFillTransparent() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi fill transparent property.
	/// A fill can be solid or semi-transparent.
	/// Returns \c true if the Ooi is filled semi-transparent \c false if it filled solid.
	virtual ObjectOfInterest::FillTransparentProxy getFillTransparent();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi fill transparent property.
	/// A fill can be solid or semi-transparent.
	virtual PolygonOfInterest& setFillTransparent(
		/// Set to true to fill semi-transparent, false to fill solid.
		bool fillTransparent);


	/// \brief Get the Ooi fill color property.
	/// This gets the Ooi fill color.
	/// \see mvIMPACT::RGBColor
	virtual RGBColor getFillColor() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi fill color property.
	/// This gets the Ooi fill color.
	/// \see mvIMPACT::RGBColor
	virtual ObjectOfInterest::FillColorProxy getFillColor();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi fill color property.
	/// This sets the Ooi interior to some color.
	/// \see mvIMPACT::RGBColor
	virtual PolygonOfInterest& setFillColor(
		/// The new color of the ooi interior.
		const RGBColor& color);


	/// \brief Get the Ooi text property.
	/// Returns the text that is displayed as the Ooi description.
	virtual std::string getText() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi text property.
	/// Returns the text that is displayed as the Ooi description.
	virtual ObjectOfInterest::TextProxy getText();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi text property.
	/// This sets the text that is displayed as the Ooi description
	virtual PolygonOfInterest& setText(
		/// The text.
		const std::string& text);


	/// \brief Get the Ooi text color property.
	/// Retrieve the text color of the Ooi.
	/// \see mvIMPACT::RGBColor
	virtual RGBColor getTextColor() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi text color property.
	/// Retrieve the text color of the Ooi.
	/// \see mvIMPACT::RGBColor
	virtual ObjectOfInterest::TextColorProxy getTextColor();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi text color property.
	/// The text of the Ooi will be displayed in the specified color.
	/// \see mvIMPACT::RGBColor
	virtual PolygonOfInterest& setTextColor(
		/// The text color of the Ooi.
		const RGBColor& color);


	/// \brief Get the Ooi text visible property.
	/// Returns \c true if the text of the Ooi is visible or \c false if not.
	virtual bool getTextVisible() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi text visible property.
	/// Returns \c true if the text of the Ooi is visible or \c false if not.
	virtual ObjectOfInterest::TextVisibleProxy getTextVisible();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi text visible property.
	/// This property can be used to make an Ooi which
	/// draws with the text invisible.
	virtual PolygonOfInterest& setTextVisible(
		/// The visibility state of the ooi text.
		bool textVisible);


	/// Get the horizontal position.
	int getX(
		/// The index of the point
		int i) const;

	/// Set the horizontal position.
	PolygonOfInterest& setX(
		/// The index of the point.
		int i,
		/// The new position.
		int x);


	/// Get the vertical position.
	int getY(
		/// The index of the point
		int i) const;

	/// Set the vertical position.
	PolygonOfInterest& setY(
		/// The index of the point.
		int i,
		/// The new position.
		int y);


	/// Get the points of the polygon.
	std::vector<Point> getPoints() const;

	/// Set the points of the polygon.
	PolygonOfInterest& setPoints(
		/// The points of the polygon.
		const std::vector<Point>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, points));
};

/// \brief This class represents an array of lines.
///
/// An array of lines is used to visualize many lines  
/// in a window. The lines can be displayed with various properties, such as location
/// and color. The user can also interactively manipulate the lines, and these
/// interactive manipulations are reported back to the code via virtual functions
/// of the Window class.
/// 
/// An array of lines can be used to both visualize and/or edit 
/// data of many lines overlaid on top of a visual image or other visual object.
///
/// This class is derived from mvIMPACT::ObjectOfInterest.
///
/// \see mvIMPACT::ObjectOfInterest
/// \see mvIMPACT::PointOfInterest
/// \see mvIMPACT::LineOfInterest
/// \see mvIMPACT::AreaOfInterest
/// \see mvIMPACT::EllipseOfInterest
/// \see mvIMPACT::PolylineOfInterest
/// \see mvIMPACT::PolygonOfInterest
/// \see mvIMPACT::LineArrayOfInterest
/// \see mvIMPACT::BarcodeVisualizer
/// \see mvIMPACT::DatamatrixVisualizer
class LineArrayOfInterest : public ObjectOfInterest
{
public:

	/// \brief Construct an empty array of lines.
	///
	/// An empty array of lines does not have a real ooi allocated in the C layer. It is
	/// just the empty C++ shell.
	///
	/// However, empty arrays of lines can be made non-empty by assigning other non-empty
	/// arrays of lines to them.
	LineArrayOfInterest();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
	/// \brief Construct an allocated array of lines from a handle.
	/// 
	/// An allocated array of lines wraps a real ooi allocated in the C layer.
	/// 
	/// Allocated arrays of lines can be made empty by assigning other empty arrays of lines to them.
	LineArrayOfInterest(
		/// The window that holds the array of lines.
		const Window & window,
		/// The ooi handle.
		mvIMPACT_C::DISP_OOIHANDLE h);
#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

	/// \brief Construct an allocated array of lines.
	///
	/// The array of lines is attached to the mvIMPACT::Window given
	/// with parameter \a window.
	/// 
	/// \see mvIMPACT::Window
	/// \see mvIMPACT::Rectangle
	LineArrayOfInterest(
		/// The window that holds the array of lines.
		const Window & window,
		/// The array of points that define the line array.
		const std::vector<Point>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, points));

	/// Copy construct a LineArrayOfInterest object
	LineArrayOfInterest(const LineArrayOfInterest & src);

	/// Destruct a LineArrayOfInterest object.
	virtual ~LineArrayOfInterest();

#ifndef WRAP_ANY
	/// \brief Cast a mvIMPACT::ObjectOfInterest to mvIMPACT::LineArrayOfInterest
	/// This function exists for overcoming the problem that in event handlers
	/// (eg OnOoiTrack.tracked()) one gets an object of type ObjectOfInterest but need
	/// information from the subclass.
	/// \see mvIMPACT::LineArrayOfInterest::isLineArrayOfInterest
	// \internal
	// There are two reasons, because of which this function was defined:
	// 1. You can solve this problem by using dynamic type casting. But then, RTTI is
	// required. At the moment, the code must compile on a compiler without rtti support,
	// so a class member is used for this purpose.
	// 2. If you would use RTTI, you get problems when creating wrappers for script languages
	// with SWIG (like Python, for example), because there is no possibility to wrap rtti (at
	// time of this writing).
	static const LineArrayOfInterest* castFromObjectOfInterest(
		/// the object of interest to cast from
		const ObjectOfInterest *ooi);

#endif // #ifndef WRAP_ANY

	/// \brief Cast a mvIMPACT::ObjectOfInterest to mvIMPACT::LineArrayOfInterest
	/// This function exists for overcoming the problem that in event handlers
	/// (eg OnOoiTrack.tracked()) one gets an object of type ObjectOfInterest but need
	/// information from the subclass.
	/// \see mvIMPACT::LineArrayOfInterest::isLineArrayOfInterest
	// \internal
	// There are two reasons, because of which this function was defined:
	// 1. You can solve this problem by using dynamic type casting. But then, RTTI is
	// required. At the moment, the code must compile on a compiler without rtti support,
	// so a class member is used for this purpose.
	// 2. If you would use RTTI, you get problems when creating wrappers for script languages
	// with SWIG (like Python, for example), because there is no possibility to wrap rtti (at
	// time of this writing).
	static LineArrayOfInterest* castFromObjectOfInterest(
		/// the object of interest to cast from
		ObjectOfInterest *ooi);

#ifndef WRAP_PYTHON
	virtual ObjectOfInterest* makeShallowCopy() const;
#endif // WRAP_PYTHON

	/// Get the horizontal position.
	int getX(
		/// The index of the point
		int i) const;

	/// Set the horizontal position.
	LineArrayOfInterest& setX(
		/// The index of the point.
		int i,
		/// The new position.
		int x);


	/// Get the vertical position.
	int getY(
		/// The index of the point
		int i) const;

	/// Set the vertical position.
	LineArrayOfInterest& setY(
		/// The index of the point.
		int i,
		/// The new position.
		int y);

	/// Get the lines of the line array.
	std::vector<Line> getLines() const;

	/// Set the points of the polyline.
	LineArrayOfInterest& setLines(
		/// The lines of the line array.
		const std::vector<Line>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, lines));
};

/// \brief This class represents a barcode visualizer.
///
/// A barcode visualizer is used to visualize barcode outlines 
/// in a window. The barcode outline can be displayed with various properties, such as location
/// and color. The user can also interactively manipulate the barcode outline, and these
/// interactive manipulations are reported back to the code via virtual functions
/// of the Window class.
/// 
/// A barcode visualizer can be used to both visualize and/or edit barcode outline
/// data overlaid on top of a visual image or other visual object.
///
/// This class is derived from mvIMPACT::ObjectOfInterest.
///
/// \see mvIMPACT::ObjectOfInterest
/// \see mvIMPACT::PointOfInterest
/// \see mvIMPACT::LineOfInterest
/// \see mvIMPACT::AreaOfInterest
/// \see mvIMPACT::EllipseOfInterest
/// \see mvIMPACT::PolylineOfInterest
/// \see mvIMPACT::PolygonOfInterest
/// \see mvIMPACT::LineArrayOfInterest
/// \see mvIMPACT::BarcodeVisualizer
/// \see mvIMPACT::DatamatrixVisualizer
class BarcodeVisualizer : public ObjectOfInterest
{
	PROXY_CLASS_SIMPLE_DECL(ShowDetails, bool, BarcodeVisualizer)

public:

	/// \brief Construct an empty barcode visualizer.
	///
	/// An empty barcode visualizer does not have a real ooi allocated in the C layer. It is
	/// just the empty C++ shell.
	///
	/// However, empty barcode visualizers can be made non-empty by assigning other non-empty
	/// barcode visualizers to them.
	BarcodeVisualizer();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
	/// \brief Construct an allocated barcode visualizer from a handle.
	/// 
	/// An allocated barcode visualizer wraps a real ooi allocated in the C layer.
	/// 
	/// Allocated barcode visualizers can be made empty by assigning other empty barcode visualizers of lines to them.
	BarcodeVisualizer(
		/// The window that holds the barcode visualizer.
		const Window & window,
		/// The ooi handle.
		mvIMPACT_C::DISP_OOIHANDLE h);
#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

	/// \brief Construct an allocated barcode visualizer.
	///
	/// The barcode visualizer is attached to the mvIMPACT::Window given
	/// with parameter \a window.
	/// 
	/// \see mvIMPACT::Window
	/// \see mvIMPACT::Rectangle
	BarcodeVisualizer(
		/// The window that holds the barcode visualizer.
		const Window & window,
		/// The array of points that define the barcode visualizer.
		const std::vector<Point>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, points));

	/// Copy construct a BarcodeVisualizer object
	BarcodeVisualizer(const BarcodeVisualizer & src);

	/// Destruct a BarcodeVisualizer object.
	virtual ~BarcodeVisualizer();

#ifndef WRAP_ANY
	/// \brief Cast a mvIMPACT::ObjectOfInterest to mvIMPACT::BarcodeVisualizer
	/// This function exists for overcoming the problem that in event handlers
	/// (eg OnOoiTrack.tracked()) one gets an object of type ObjectOfInterest but need
	/// information from the subclass.
	/// \see mvIMPACT::BarcodeVisualizer::isBarcodeVisualizer
	// \internal
	// There are two reasons, because of which this function was defined:
	// 1. You can solve this problem by using dynamic type casting. But then, RTTI is
	// required. At the moment, the code must compile on a compiler without rtti support,
	// so a class member is used for this purpose.
	// 2. If you would use RTTI, you get problems when creating wrappers for script languages
	// with SWIG (like Python, for example), because there is no possibility to wrap rtti (at
	// time of this writing).
	static const BarcodeVisualizer* castFromObjectOfInterest(
		/// the object of interest to cast from
		const ObjectOfInterest *ooi);

#endif // #ifndef WRAP_ANY

	/// \brief Cast a mvIMPACT::ObjectOfInterest to mvIMPACT::BarcodeVisualizer
	/// This function exists for overcoming the problem that in event handlers
	/// (eg OnOoiTrack.tracked()) one gets an object of type ObjectOfInterest but need
	/// information from the subclass.
	/// \see mvIMPACT::BarcodeVisualizer::isBarcodeVisualizer
	// \internal
	// There are two reasons, because of which this function was defined:
	// 1. You can solve this problem by using dynamic type casting. But then, RTTI is
	// required. At the moment, the code must compile on a compiler without rtti support,
	// so a class member is used for this purpose.
	// 2. If you would use RTTI, you get problems when creating wrappers for script languages
	// with SWIG (like Python, for example), because there is no possibility to wrap rtti (at
	// time of this writing).
	static BarcodeVisualizer* castFromObjectOfInterest(
		/// the object of interest to cast from
		ObjectOfInterest *ooi);

#ifndef WRAP_PYTHON
	virtual ObjectOfInterest* makeShallowCopy() const;
#endif // WRAP_PYTHON

	/// \brief Get the Ooi fill visible property.
	/// Returns \c true if the Ooi is drawn filled or \c false if not.
	virtual bool getFillVisible() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi fill visible property.
	/// Returns \c true if the Ooi is drawn filled or \c false if not.
	virtual ObjectOfInterest::FillVisibleProxy getFillVisible();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi fill visible property.
	/// This property can be used to make an Ooi which
	/// draws with or without fill.
	virtual BarcodeVisualizer& setFillVisible(
		/// The state of the fill visibility.
		bool fillVisible);


	/// \brief Get the Ooi fill transparent property.
	/// A fill can be solid or semi-transparent.
	/// Returns \c true if the Ooi is filled semi-transparent \c false if it filled solid.
	virtual bool getFillTransparent() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi fill transparent property.
	/// A fill can be solid or semi-transparent.
	/// Returns \c true if the Ooi is filled semi-transparent \c false if it filled solid.
	virtual ObjectOfInterest::FillTransparentProxy getFillTransparent();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi fill transparent property.
	/// A fill can be solid or semi-transparent.
	virtual BarcodeVisualizer& setFillTransparent(
		/// Set to true to fill semi-transparent, false to fill solid.
		bool fillTransparent);


	/// \brief Get the Ooi fill color property.
	/// This gets the Ooi fill color.
	/// \see mvIMPACT::RGBColor
	virtual RGBColor getFillColor() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi fill color property.
	/// This gets the Ooi fill color.
	/// \see mvIMPACT::RGBColor
	virtual ObjectOfInterest::FillColorProxy getFillColor();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi fill color property.
	/// This sets the Ooi interior to some color.
	/// \see mvIMPACT::RGBColor
	virtual BarcodeVisualizer& setFillColor(
		/// The new color of the ooi interior.
		const RGBColor& color);


	/// \brief Get the Ooi text property.
	/// Returns the text that is displayed as the Ooi description.
	virtual std::string getText() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi text property.
	/// Returns the text that is displayed as the Ooi description.
	virtual ObjectOfInterest::TextProxy getText();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi text property.
	/// This sets the text that is displayed as the Ooi description
	virtual BarcodeVisualizer& setText(
		/// The text.
		const std::string& text);


	/// \brief Get the Ooi text color property.
	/// Retrieve the text color of the Ooi.
	/// \see mvIMPACT::RGBColor
	virtual RGBColor getTextColor() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi text color property.
	/// Retrieve the text color of the Ooi.
	/// \see mvIMPACT::RGBColor
	virtual ObjectOfInterest::TextColorProxy getTextColor();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi text color property.
	/// The text of the Ooi will be displayed in the specified color.
	/// \see mvIMPACT::RGBColor
	virtual BarcodeVisualizer& setTextColor(
		/// The text color of the Ooi.
		const RGBColor& color);


	/// \brief Get the Ooi text visible property.
	/// Returns \c true if the text of the Ooi is visible or \c false if not.
	virtual bool getTextVisible() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi text visible property.
	/// Returns \c true if the text of the Ooi is visible or \c false if not.
	virtual ObjectOfInterest::TextVisibleProxy getTextVisible();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi text visible property.
	/// This property can be used to make an Ooi which
	/// draws with the text invisible.
	virtual BarcodeVisualizer& setTextVisible(
		/// The visibility state of the ooi text.
		bool textVisible);


	/// If true, visualize the direction of the barcode; if false,
	/// only visualize the outline.
	virtual bool getShowDetails() const;

#ifndef WRAP_ANY
	/// If true, visualize the direction of the barcode; if false,
	/// only visualize the outline.
	virtual BarcodeVisualizer::ShowDetailsProxy getShowDetails();
#endif // #ifndef WRAP_ANY

	/// Set to true to visualize the direction of the barcode, set to false to
	/// only visualize the outline.
	virtual BarcodeVisualizer& setShowDetails(
		/// The new setting.
		bool ShowDetails);


	/// Get the horizontal position.
	int getX(
		/// The index of the point
		int i) const;

	/// Set the horizontal position.
	BarcodeVisualizer& setX(
		/// The index of the point.
		int i,
		/// The new position.
		int x);


	/// Get the vertical position.
	int getY(
		/// The index of the point
		int i) const;

	/// Set the vertical position.
	BarcodeVisualizer& setY(
		/// The index of the point.
		int i,
		/// The new position.
		int y);


	/// Get the points of the barcode visualizer.
	std::vector<Point> getPoints() const;

	/// Set the points of the barcode visualizer.
	BarcodeVisualizer& setPoints(
		/// The points of the barcode visualizer.
		const std::vector<Point>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, points));
};

/// \brief This class represents a datamatrix visualizer.
///
/// A datamatrix visualizer is used to visualize datamatrix outlines 
/// in a window. The datamatrix outline can be displayed with various properties, such as location
/// and color. The user can also interactively manipulate the datamatrix outline, and these
/// interactive manipulations are reported back to the code via virtual functions
/// of the Window class.
/// 
/// A datamatrix visualizer can be used to both visualize and/or edit datamatrix outline
/// data overlaid on top of a visual image or other visual object.
///
/// This class is derived from mvIMPACT::ObjectOfInterest.
///
/// \see mvIMPACT::ObjectOfInterest
/// \see mvIMPACT::PointOfInterest
/// \see mvIMPACT::LineOfInterest
/// \see mvIMPACT::AreaOfInterest
/// \see mvIMPACT::EllipseOfInterest
/// \see mvIMPACT::PolylineOfInterest
/// \see mvIMPACT::PolygonOfInterest
/// \see mvIMPACT::LineArrayOfInterest
/// \see mvIMPACT::BarcodeVisualizer
/// \see mvIMPACT::DatamatrixVisualizer
class DatamatrixVisualizer : public ObjectOfInterest
{
	PROXY_CLASS_SIMPLE_DECL(ShowDetails, bool, DatamatrixVisualizer)
	PROXY_CLASS_SIMPLE_DECL(Rows, int, DatamatrixVisualizer)
	PROXY_CLASS_SIMPLE_DECL(Columns, int, DatamatrixVisualizer)

public:

	/// \brief Construct an empty datamatrix visualizer.
	///
	/// An empty datamatrix visualizer does not have a real ooi allocated in the C layer. It is
	/// just the empty C++ shell.
	///
	/// However, empty datamatrix visualizers can be made non-empty by assigning other non-empty
	/// datamatrix visualizers to them.
	DatamatrixVisualizer();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
	/// \brief Construct an allocated datamatrix visualizer from a handle.
	/// 
	/// An allocated datamatrix visualizer wraps a real ooi allocated in the C layer.
	/// 
	/// Allocated datamatrix visualizers can be made empty by assigning other empty datamatrix visualizers of lines to them.
	DatamatrixVisualizer(
		/// The window that holds the datamatrix visualizer.
		const Window & window,
		/// The ooi handle.
		mvIMPACT_C::DISP_OOIHANDLE h);
#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

	/// \brief Construct an allocated datamatrix visualizer.
	///
	/// The datamatrix visualizer is attached to the mvIMPACT::Window given
	/// with parameter \a window.
	/// 
	/// \see mvIMPACT::Window
	/// \see mvIMPACT::Rectangle
	DatamatrixVisualizer(
		/// The window that holds the datamatrix visualizer.
		const Window & window,
		/// The array of points that define the datamatrix visualizer.
		const std::vector<Point>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, points));

	/// Copy construct a DatamatrixVisualizer object
	DatamatrixVisualizer(const DatamatrixVisualizer & src);

	/// Destruct a DatamatrixVisualizer object.
	virtual ~DatamatrixVisualizer();

#ifndef WRAP_ANY
	/// \brief Cast a mvIMPACT::ObjectOfInterest to mvIMPACT::DatamatrixVisualizer
	/// This function exists for overcoming the problem that in event handlers
	/// (eg OnOoiTrack.tracked()) one gets an object of type ObjectOfInterest but need
	/// information from the subclass.
	/// \see mvIMPACT::DatamatrixVisualizer::isDatamatrixVisualizer
	// \internal
	// There are two reasons, because of which this function was defined:
	// 1. You can solve this problem by using dynamic type casting. But then, RTTI is
	// required. At the moment, the code must compile on a compiler without rtti support,
	// so a class member is used for this purpose.
	// 2. If you would use RTTI, you get problems when creating wrappers for script languages
	// with SWIG (like Python, for example), because there is no possibility to wrap rtti (at
	// time of this writing).
	static const DatamatrixVisualizer* castFromObjectOfInterest(
		/// the object of interest to cast from
		const ObjectOfInterest *ooi);

#endif // #ifndef WRAP_ANY

	/// \brief Cast a mvIMPACT::ObjectOfInterest to mvIMPACT::DatamatrixVisualizer
	/// This function exists for overcoming the problem that in event handlers
	/// (eg OnOoiTrack.tracked()) one gets an object of type ObjectOfInterest but need
	/// information from the subclass.
	/// \see mvIMPACT::DatamatrixVisualizer::isDatamatrixVisualizer
	// \internal
	// There are two reasons, because of which this function was defined:
	// 1. You can solve this problem by using dynamic type casting. But then, RTTI is
	// required. At the moment, the code must compile on a compiler without rtti support,
	// so a class member is used for this purpose.
	// 2. If you would use RTTI, you get problems when creating wrappers for script languages
	// with SWIG (like Python, for example), because there is no possibility to wrap rtti (at
	// time of this writing).
	static DatamatrixVisualizer* castFromObjectOfInterest(
		/// the object of interest to cast from
		ObjectOfInterest *ooi);

#ifndef WRAP_PYTHON
	virtual ObjectOfInterest* makeShallowCopy() const;
#endif // WRAP_PYTHON

	/// \brief Get the Ooi fill visible property.
	/// Returns \c true if the Ooi is drawn filled or \c false if not.
	virtual bool getFillVisible() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi fill visible property.
	/// Returns \c true if the Ooi is drawn filled or \c false if not.
	virtual ObjectOfInterest::FillVisibleProxy getFillVisible();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi fill visible property.
	/// This property can be used to make an Ooi which
	/// draws with or without fill.
	virtual DatamatrixVisualizer& setFillVisible(
		/// The state of the fill visibility.
		bool fillVisible);


	/// \brief Get the Ooi fill transparent property.
	/// A fill can be solid or semi-transparent.
	/// Returns \c true if the Ooi is filled semi-transparent \c false if it filled solid.
	virtual bool getFillTransparent() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi fill transparent property.
	/// A fill can be solid or semi-transparent.
	/// Returns \c true if the Ooi is filled semi-transparent \c false if it filled solid.
	virtual ObjectOfInterest::FillTransparentProxy getFillTransparent();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi fill transparent property.
	/// A fill can be solid or semi-transparent.
	virtual DatamatrixVisualizer& setFillTransparent(
		/// Set to true to fill semi-transparent, false to fill solid.
		bool fillTransparent);


	/// \brief Get the Ooi fill color property.
	/// This gets the Ooi fill color.
	/// \see mvIMPACT::RGBColor
	virtual RGBColor getFillColor() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi fill color property.
	/// This gets the Ooi fill color.
	/// \see mvIMPACT::RGBColor
	virtual ObjectOfInterest::FillColorProxy getFillColor();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi fill color property.
	/// This sets the Ooi interior to some color.
	/// \see mvIMPACT::RGBColor
	virtual DatamatrixVisualizer& setFillColor(
		/// The new color of the ooi interior.
		const RGBColor& color);


	/// \brief Get the Ooi text property.
	/// Returns the text that is displayed as the Ooi description.
	virtual std::string getText() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi text property.
	/// Returns the text that is displayed as the Ooi description.
	virtual ObjectOfInterest::TextProxy getText();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi text property.
	/// This sets the text that is displayed as the Ooi description
	virtual DatamatrixVisualizer& setText(
		/// The text.
		const std::string& text);


	/// \brief Get the Ooi text color property.
	/// Retrieve the text color of the Ooi.
	/// \see mvIMPACT::RGBColor
	virtual RGBColor getTextColor() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi text color property.
	/// Retrieve the text color of the Ooi.
	/// \see mvIMPACT::RGBColor
	virtual ObjectOfInterest::TextColorProxy getTextColor();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi text color property.
	/// The text of the Ooi will be displayed in the specified color.
	/// \see mvIMPACT::RGBColor
	virtual DatamatrixVisualizer& setTextColor(
		/// The text color of the Ooi.
		const RGBColor& color);


	/// \brief Get the Ooi text visible property.
	/// Returns \c true if the text of the Ooi is visible or \c false if not.
	virtual bool getTextVisible() const;

#ifndef WRAP_ANY
	/// \brief Get the Ooi text visible property.
	/// Returns \c true if the text of the Ooi is visible or \c false if not.
	virtual ObjectOfInterest::TextVisibleProxy getTextVisible();
#endif // #ifndef WRAP_ANY

	/// \brief Set the Ooi text visible property.
	/// This property can be used to make an Ooi which
	/// draws with the text invisible.
	virtual DatamatrixVisualizer& setTextVisible(
		/// The visibility state of the ooi text.
		bool textVisible);


	/// If true, visualize the finder pattern; if false, only
	/// visualize the outline.
	virtual bool getShowDetails() const;

#ifndef WRAP_ANY
	/// If true, visualize the finder pattern; if false, only
	/// visualize the outline.
	virtual DatamatrixVisualizer::ShowDetailsProxy getShowDetails();
#endif // #ifndef WRAP_ANY

	/// Set to true to visualize the finder pattern, set to false to only
	/// visualize the outline.
	virtual DatamatrixVisualizer& setShowDetails(
		/// The new setting.
		bool ShowDetails);


	/// Get the number of columns of the datamatrix.
	virtual int getColumns() const;

#ifndef WRAP_ANY
	/// Get the number of columns of the datamatrix.
	virtual DatamatrixVisualizer::ColumnsProxy getColumns();
#endif // #ifndef WRAP_ANY

	/// Set the number of columns of the datamatrix.
	virtual DatamatrixVisualizer& setColumns(
		/// The new setting.
		int Columns);


	/// Get the number of rows of the datamatrix.
	virtual int getRows() const;

#ifndef WRAP_ANY
	/// Get the number of rows of the datamatrix.
	virtual DatamatrixVisualizer::RowsProxy getRows();
#endif // #ifndef WRAP_ANY

	/// Set the number of rows of the datamatrix.
	virtual DatamatrixVisualizer& setRows(
		/// The new setting.
		int Columns);


	/// Get the horizontal position.
	int getX(
		/// The index of the point
		int i) const;

	/// Set the horizontal position.
	DatamatrixVisualizer& setX(
		/// The index of the point.
		int i,
		/// The new position.
		int x);


	/// Get the vertical position.
	int getY(
		/// The index of the point
		int i) const;

	/// Set the vertical position.
	DatamatrixVisualizer& setY(
		/// The index of the point.
		int i,
		/// The new position.
		int y);


	/// Get the points of the datamatrix visualizer.
	std::vector<Point> getPoints() const;

	/// Set the points of the datamatrix visualizer.
	DatamatrixVisualizer& setPoints(
		/// The points of the datamatrix visualizer.
		const std::vector<Point>& PYTHON_CPP_SWITCH(SEQUENCE_TO_VECTOR, points));
};

// don't wrap runMessageLoop for Python since it is a blocking function which may cause a deadlock. See base.i for the replacement.
#if defined(PLATFORM_MVBL) || !defined(WRAP_PYTHON)

/// \brief Run a message loop to make windows functional.

/// The message loop
/// will be terminated when the space button is pressed.
/// \note This function must be called from the thread that opened the windows!
//-----------------------------------------------------------------------------
void runMessageLoop(
		    /// Message to be displayed on console window.
		    const std::string& message="Press <space> to continue\n");

#endif // WRAP_PYTHON

/// \brief Dispatch all messages currently in the message queue.

/// After that the
/// function returns.
/// \note This function must be called from the thread that opened the windows!
//-----------------------------------------------------------------------------
void dispatchMessages();



/// \brief Get the default profile drawing direction.

/// All windows created will inherit this setting.
/// \see #ProfileDirection
/// \see mvIMPACT::Window::getProfileDrawingDir
//-----------------------------------------------------------------------------
ProfileDirection getDefaultProfileDrawingDir();




/// \brief Set the default profile drawing direction.

/// All windows created after an invocation of this
/// function will inherit this setting.
/// \see #ProfileDirection
/// \see mvIMPACT::Window::setProfileDrawingDir
//-----------------------------------------------------------------------------
void setDefaultProfileDrawingDir(
				 /// The new default Profile drawing direction.
				 ProfileDirection profileDrawingDir);





/// \brief Get the default histogram drawing mode.

/// All windows created will inherit this setting.
/// \see #HistogramMode
/// \see mvIMPACT::Window::getHistogramDrawingMode
//-----------------------------------------------------------------------------
HistogramMode getDefaultHistogramDrawingMode();



/// \brief Set the default histogram drawing mode.

/// All windows created after an invocation of this
/// function will inherit this setting.
/// \see #HistogramMode
/// \see mvIMPACT::Window::setHistogramDrawingMode
//-----------------------------------------------------------------------------
void setDefaultHistogramDrawingMode(
				    /// The new default Histogram drawing mode.
				    HistogramMode histogramDrawingMode);




/// \brief Get the default image drawing mode.

/// All windows created will inherit this setting.
/// \see #ImageMode
/// \see mvIMPACT::Window::getImageDrawingMode
//-----------------------------------------------------------------------------
ImageMode getDefaultImageDrawingMode();






/// \brief Set the default image drawing mode.

/// All windows created after an invocation of this
/// function will inherit this setting.
/// \see #ImageMode
/// \see mvIMPACT::Window::setImageDrawingMode
//-----------------------------------------------------------------------------
void setDefaultImageDrawingMode(
				/// The new default Image drawing mode.
				ImageMode imageDrawingMode);



/// \brief Get the default numeric base.

/// The numeric base is used when drawing buffers
/// numerically.
/// All windows created will inherit this setting.
/// \see mvIMPACT::Window::getNumericBase
//-----------------------------------------------------------------------------
int getDefaultNumericBase();


/// \brief Set the default numeric base.

/// All windows created after an invocation of this
/// function will inherit this setting. The numeric base is used when drawing buffers
/// numerically.
/// \see mvIMPACT::Window::setNumericBase
//-----------------------------------------------------------------------------
void setDefaultNumericBase(
					/// The new default numeric base. This is value from 2 to 36.
					/// \xmlonly
					/// <mvParamRange>
					/// <mvParamMin><mvParamConst value="2"/></mvParamMin>
					/// <mvParamMax><mvParamConst value="36"/></mvParamMax>
					/// </mvParamRange>
					/// \endxmlonly
					int numericBase);


/// \brief Get the default color palette.

/// One band images will be colored with this palette.
/// All windows created will inherit this setting.
/// \see mvIMPACT::Window::getColorPalette
/// \see mvIMPACT::Palette
//-----------------------------------------------------------------------------
Palette getDefaultColorPalette();




/// \brief Set the default color palette.

/// All windows created after an invocation of this
/// function will inherit this setting.
/// One band images will be colored with this palette.
/// \see mvIMPACT::Window::setColorPalette
/// \see mvIMPACT::Palette
//-----------------------------------------------------------------------------
void setDefaultColorPalette(
			    /// The new default color palette.
			    const Palette& colorPalette);



/// \brief Get the default text spacing.

/// The text spacing is used when drawing buffers
/// numerically.
/// All windows created will inherit this setting.
/// \see mvIMPACT::Window::getTextSpacing
//-----------------------------------------------------------------------------
int getDefaultTextSpacing();



/// \brief Set the default text spacing.

/// All windows created after an invocation of this
/// function will inherit this setting. The text spacing is used when drawing buffers
/// numerically.
/// \see mvIMPACT::Window::setTextSpacing
//-----------------------------------------------------------------------------
void setDefaultTextSpacing(
					/// The new default text spacing.
					/// \xmlonly
					/// <mvParamRange>
					/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
					/// </mvParamRange>
					/// \endxmlonly
					int textSpacing);



/// \brief Get the default text height.

/// The text height is used when drawing buffers
/// numerically.
/// All windows created will inherit this setting.
/// \see mvIMPACT::Window::getTextHeight
//-----------------------------------------------------------------------------
int getDefaultTextHeight();



/// \brief Set the default text height.

/// All windows created after an invocation of this
/// function will inherit this setting. The text height is used when drawing buffers
/// numerically.
/// \see mvIMPACT::Window::setTextHeight
//-----------------------------------------------------------------------------
void setDefaultTextHeight(
					/// The new default text height.
					/// \xmlonly
					/// <mvParamRange>
					/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
					/// </mvParamRange>
					/// \endxmlonly
					int textHeight);



/// \brief Get the default text weight.

/// The text weight is used when drawing buffers
/// numerically.
/// All windows created will inherit this setting.
/// \see mvIMPACT::Window::getTextWeight
//-----------------------------------------------------------------------------
int getDefaultTextWeight();



/// \brief Set the default text weight.

/// All windows created after an invocation of this
/// function will inherit this setting. The text weight is used when drawing buffers
/// numerically.
/// \see mvIMPACT::Window::setTextHeight
//-----------------------------------------------------------------------------
void setDefaultTextWeight(
					/// The new default text weight. The weight ranges from 1 to 1000 where
					/// 1 means very thin and 1000 means very thick.
					/// \xmlonly
					/// <mvParamRange>
					/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
					/// <mvParamMax><mvParamConst value="1000"/></mvParamMax>
					/// </mvParamRange>
					/// \endxmlonly
					int textWeight);



/// \brief Get the default text color.
///
/// The text color is used when drawing buffers
/// numerically.
/// All windows created will inherit this setting.
/// \see mvIMPACT::Window::getTextColor
/// \see mvIMPACT::RGBColor
//-----------------------------------------------------------------------------
RGBColor getDefaultTextColor();



/// \brief Set the default text color.
///
/// All windows created after an invocation of this
/// function will inherit this setting. The text color is used when drawing buffers
/// numerically.
/// \see mvIMPACT::Window::setTextColor
/// \see mvIMPACT::RGBColor
//-----------------------------------------------------------------------------
void setDefaultTextColor(
			 /// The new default text color.
			 const RGBColor& textColor);



/// \brief Get the default draw color.
///
/// The draw color is used to draw profiles etc.
/// All windows created will inherit this setting.
/// \see mvIMPACT::Window::getDrawColor
/// \see mvIMPACT::RGBColor
//-----------------------------------------------------------------------------
RGBColor getDefaultDrawColor();


/// \brief Set the default draw color.
///
/// The draw color is used to draw profiles etc.
/// All windows created after an invocation of this
/// function will inherit this setting.
/// \see mvIMPACT::Window::setDrawColor
/// \see mvIMPACT::RGBColor
//-----------------------------------------------------------------------------
void setDefaultDrawColor(
			 /// The new default draw color.
			 const RGBColor& drawColor);


/// \brief Get the default fill color.
///
/// The fill color is used to fill histograms etc.
/// All windows created will inherit this setting.
/// \see mvIMPACT::Window::getFillColor
/// \see mvIMPACT::RGBColor
//-----------------------------------------------------------------------------
RGBColor getDefaultFillColor();



/// \brief Set the default fill color.
///
/// The fill color is used to fill histograms etc.
/// All windows created after an invocation of this
/// function will inherit this setting.
/// \see mvIMPACT::Window::setFillColor
/// \see mvIMPACT::RGBColor
//-----------------------------------------------------------------------------
void setDefaultFillColor(
			 /// The new default fill color.
			 const RGBColor& fillColor);


/// \brief Get the default normalization value.
///
/// Histogram values are scaled
/// with this value or scaled to the
/// histogram's maximum
/// (different maxima are used for
/// normal or accumulated
/// drawing).
/// All windows created will inherit this setting.
/// \see mvIMPACT::Window::getNormalize
//-----------------------------------------------------------------------------
int getDefaultNormalize();




/// \brief Set the default normalization value.
///
/// Histogram values are scaled
/// with this value or scaled to the
/// histogram's maximum
/// (different maxima are used for
/// normal or accumulated
/// drawing).
/// All windows created after an invocation of this
/// function will inherit this setting.
/// All windows created will inherit this setting.
/// \see mvIMPACT::Window::setNormalize
//-----------------------------------------------------------------------------
void setDefaultNormalize(
					/// The new default normalization value.
					/// \xmlonly
					/// <mvParamRange>
					/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
					/// </mvParamRange>
					/// \endxmlonly
					int normalize);


/// \brief Get the default copy clipboard mode.
///
/// Defines whether the whole window or only the client area will be copie to the clipboard when calling mvIMPACT::copyToClipboard.
/// All windows created will inherit this setting.
/// \see mvIMPACT::Window::getClipboardMode
/// \see #CopyClipboardMode
//-----------------------------------------------------------------------------
CopyClipboardMode getDefaultClipboardMode();


/// \brief Set the default copy clipboard mode.
///
/// Defines whether the whole window or only the client area will be copie to the clipboard when calling mvIMPACT::copyToClipboard.
/// All windows created after an invocation of this
/// function will inherit this setting.
/// \see mvIMPACT::Window::setClipboardMode
/// \see #CopyClipboardMode
//-----------------------------------------------------------------------------
void setDefaultClipboardMode(
			     /// The new default clipboard copy mode.
			     CopyClipboardMode clipboardMode);


/// \brief Get the default horizontal zoom value.
///
/// All windows created will inherit this setting.
/// \see mvIMPACT::Window::getZoomX
//-----------------------------------------------------------------------------
double getDefaultZoomX();


/// \brief Set the default horizontal zoom value.
///
/// All windows created after an invocation of this
/// function will inherit this setting.
/// \see mvIMPACT::Window::setZoomX
//-----------------------------------------------------------------------------
void setDefaultZoomX(
					/// The new default horizontal zoom value.
					/// \xmlonly
					/// <mvParamRange>
					/// <mvParamMin><mvParamConst value="0.01"/></mvParamMin>
					/// <mvParamStep>0.1</mvParamStep>
					/// </mvParamRange>
					/// \endxmlonly
					double zoomX);


/// \brief  Get the default vertical zoom value.
///
/// All windows created will inherit this setting.
/// \see mvIMPACT::Window::getZoomY
//-----------------------------------------------------------------------------
double getDefaultZoomY();


/// \brief Set the default vertical zoom value.
///
/// All windows created after an invocation of this
/// function will inherit this setting.
/// \see mvIMPACT::Window::setZoomY
//-----------------------------------------------------------------------------
 void setDefaultZoomY(
					/// The new default vertical zoom value.
					/// \xmlonly
					/// <mvParamRange>
					/// <mvParamMin><mvParamConst value="0.01"/></mvParamMin>
					/// <mvParamStep>0.1</mvParamStep>
					/// </mvParamRange>
					/// \endxmlonly
					double zoomY);



/// \brief Set the default horizontal and vertical zoom value.
///
/// All windows created after an invocation of this
/// function will inherit this setting.
/// \see mvIMPACT::Window::setZoomY
/// \see mvIMPACT::Window::setZoomX
/// \see mvIMPACT::Window::setZoom
//-----------------------------------------------------------------------------
void setDefaultZoom(
					/// The new default horizontal and vertical zoom value.
					/// \xmlonly
					/// <mvParamRange>
					/// <mvParamMin><mvParamConst value="0.01"/></mvParamMin>
					/// <mvParamStep>0.1</mvParamStep>
					/// </mvParamRange>
					/// \endxmlonly
					double zoom);





/// \brief Get the default zoom mode.

/// The zoom mode sepciifes whether the window is zoomed such that its contents fit exactly
/// or if the zoom factors will be used.
/// All windows created will inherit this setting.
/// \see mvIMPACT::Window::getZoomMode
/// \see #ZoomingMode
//-----------------------------------------------------------------------------
ZoomingMode getDefaultZoomMode();





/// \brief Set the default zoom mode.

/// The zoom mode sepciifes whether the window is zoomed such that its contents fit exactly
/// or if the zoom factors will be used.
/// All windows created after an invocation of this
/// function will inherit this setting.
/// \see mvIMPACT::Window::setZoomMode
/// \see #ZoomingMode
//-----------------------------------------------------------------------------
void setDefaultZoomMode(
			/// The new default zoom mode.
			ZoomingMode zoomMode);






/// \brief Get the default mapping palette.

/// The image data is mapped over this palette before drawing.
/// All windows created will inherit this setting.
/// \see mvIMPACT::Window::getMappingPalette
/// \see mvIMPACT::Palette
//-----------------------------------------------------------------------------
Palette getDefaultMappingPalette();


/// \brief Set the default mapping palette.

/// All windows created after an invocation of this
/// function will inherit this setting. When a mapping palette is specified the
/// image data is mapped using this palette before displaying it.
/// \see mvIMPACT::Window::getMappingPalette
/// \see mvIMPACT::Palette
//-----------------------------------------------------------------------------
void setDefaultMappingPalette(
			      /// The new default mapping Palette.
			      const Palette& mappingPalette);






/// \brief Query the default bit shift property for 16bit images.

/// 0 displays the low
/// byte, 8 displays the high byte.
/// All windows created will inherit this setting.
/// \see mvIMPACT::Window::getShift
//-----------------------------------------------------------------------------
int getDefaultShift();


/// \brief Set number of bits to shift for 16bit images.

/// 0 displays the low
/// byte, 8 displays the high byte.
/// All windows created after an invocation of this
/// function will inherit this setting.
/// \see mvIMPACT::Window::setShift
//-----------------------------------------------------------------------------
void setDefaultShift(
					/// number of bits to shift
					/// \xmlonly
					/// <mvParamRange>
					/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
					/// <mvParamMax><mvParamConst value="15"/></mvParamMax>
					/// </mvParamRange>
					/// \endxmlonly
					int shift);


/// \brief Get the default scrollbar mode.

/// The scrollbar mode defines when to show scrollbars.
/// All windows created will inherit this setting.
/// \see mvIMPACT::Window::getScrollbarMode
/// \see #ScrollingMode
//-----------------------------------------------------------------------------
ScrollingMode getDefaultScrollbarMode();



/// \brief Set the default scrollbar mode.

/// The scrollbar mode defines when to show scrollbars.
/// All windows created after an invocation of this
/// function will inherit this setting.
/// \see mvIMPACT::Window::setScrollbarMode
/// \see #ScrollingMode
//-----------------------------------------------------------------------------
void setDefaultScrollbarMode(
			     /// The new default scrollbar mode.
			     ScrollingMode scrollbarMode);








/// \brief Return the default background color.

/// All windows created will inherit this setting.
/// \see mvIMPACT::Window::getBackgroundColor
/// \see mvIMPACT::RGBColor
//-----------------------------------------------------------------------------
RGBColor getDefaultBackgroundColor ();



/// \brief Set the default background color for all windows.

/// All windows created after an invocation of this
/// function will inherit this setting.
/// \see mvIMPACT::Window::setScrollbarMode
/// \see mvIMPACT::RGBColor
//-----------------------------------------------------------------------------
void setDefaultBackgroundColor (/// the color to set as standard background color
				const RGBColor& backgroundColor );



/// \brief Get the default window width used for empty windows.

/// Empty windows are
/// those that are created without a valid buffer at creation time. This
/// setting defines the default width of those windows. When the window is
/// created, the necessary space for window adornments (caption, frames) is
/// automatically added.
/// \see mvIMPACT::setDefaultEmptyWindowWidth
int getDefaultEmptyWindowWidth();



/// \brief Set the default window width used for empty windows.

/// Empty windows are
/// those that are created without a valid buffer at creation time. This
/// setting defines the default width of those windows. When the window is
/// created, the necessary space for window adornments (caption, frames) is
/// automatically added.
/// \see mvIMPACT::getDefaultEmptyWindowWidth
void setDefaultEmptyWindowWidth(
					/// The default window width used for empty windows.
					/// \xmlonly
					/// <mvParamRange>
					/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
					/// </mvParamRange>
					/// \endxmlonly
					int emptyWindowWidth);





/// \brief Get the default window height used for empty windows.

/// Empty windows are
/// those that are created without a valid buffer at creation time. This
/// setting defines the default height of those windows. When the window is
/// created, the necessary space for window adornments (caption, frames) is
/// automatically added.
/// \see mvIMPACT::setDefaultEmptyWindowHeight
int getDefaultEmptyWindowHeight();






/// \brief Set the default window height used for empty windows.

/// Empty windows are
/// those that are created without a valid buffer at creation time. This
/// setting defines the default height of those windows. When the window is
/// created, the necessary space for window adornments (caption, frames) is
/// automatically added.
/// \see mvIMPACT::getDefaultEmptyWindowHeight
void setDefaultEmptyWindowHeight(
					/// The default window height used for empty windows.
					/// \xmlonly
					/// <mvParamRange>
					/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
					/// </mvParamRange>
					/// \endxmlonly
					int emptyWindowHeight);





#endif

/////////////////////////////////////////////////////////////////
// vl_autotrace functions

/// \brief Start direction of the tracer. The tracer will try to start tracing in the
/// \brief given direction.

/// This is used by mvIMPACT::Tracer::setStartDirection
/// \see mvIMPACT::Tracer::setStartDirection
enum StartDirection
{
	/// Trace north.
	sdNorth     = ATR_DIR_N,
	/// Trace north west.
	sdNorthWest = ATR_DIR_NW,
	/// Trace west.
	sdWest      = ATR_DIR_W,
	/// Trace south west.
	sdSouthWest = ATR_DIR_SW,
	/// Trace south.
	sdSouth     = ATR_DIR_S,
	/// Trace south east.
	sdSouthEast = ATR_DIR_SE,
	/// Trace east.
	sdEast      = ATR_DIR_E,
	/// Trace north east.
	sdNorthEast = ATR_DIR_NE
};



/// \brief Specifies one of the possible events the tracer generates.

/// This is used by mvIMPACT::Tracer::configureEvent
/// \see mvIMPACT::Traxcer::EnableEvent
enum EventType
{
	/// Generated, if the tracer module has performed a successful operation.
	etDone             = mvIMPACT_C::ATR_EVENT_DONE,
	/// Generated, if the gradient falls below a threshold.
	etMinimumThreshold = mvIMPACT_C::ATR_EVENT_MIN_THRES,
	/// Generated, if the gradient exceeds a threshold.
	etMaximumThreshold = mvIMPACT_C::ATR_EVENT_MAX_THRES,
	/// Generated, if a point exists twice in the point list. Additionaly to this event
	/// you have to switch on \c etSafeMode in order to receive this event.
	etPointTwice       = mvIMPACT_C::ATR_EVENT_POINT_TWICE,
	/// Generated, if the tracer module hits a border pixel.
	etBorder           = mvIMPACT_C::ATR_EVENT_BORDER,
	/// The safe mode event. If this mode switched on the tracer checks after every
	/// step if there are duplicate pixels in the list.
	etSafeMode         = mvIMPACT_C::ATR_EVENT_SAFE_MODE
};



/// \brief Status associated with an event or with the TraceResult.

/// This is used to signal the state of the tracer.
/// \see mvIMPACT::Tracer::onEvent.
/// \see mvIMPACT::TraceResult::getStatus
enum TraceStatus
{
	/// Operation done.
	tsDone = ATR_STS_DONE,
	/// An image border was hit.
	tsBorder = ATR_STS_BORDER,
	/// A point is found twice in the contour list.
	tsPointTwice = ATR_STS_POINT_TWICE,
	/// The lower gradient threshold has been reached.
	tsMinimumThreshold = ATR_STS_MIN_THRES,
	/// The upper gradient threshold has been reached.
	tsMaximumThreshold = ATR_STS_MAX_THRES,

	/// Successful operation. Status of the TraceResult. Use TraceResult::getStatus()
	/// to query the status.
	tsOk = ATR_STS_OK,
	/// The number of maximum points is reached. Status of the TraceResult.
	/// Use TraceResult::getStatus() to query the status.
	tsMaximumPoints = ATR_STS_MAX_POINTS,
	/// Operation canceled. Not used yet.
	tsCanceled = ATR_STS_CANCELED

};

/// \brief Kernel used by the tracer internally to detect edges.

/// When processing noisy images or if the object to be traced has some small gaps in
/// its contour, it is recommended to use larger kernels. The smaller the kernel size,
/// the faster the trace will be.
/// \see mvIMPACT::Tracer::setFilterSize
enum TracingKernel
{
  /// 2x2 kernel.
  tk2x2 = ATR_2x2,
  /// 3x3 kernel.
  tk3x3 = ATR_3x3,
  /// 5x5 kernel.
  tk5x5 = ATR_5x5,
  /// 7x7 kernel.
  tk7x7 = ATR_7x7,
  /// 9x9 kernel.
  tk9x9 = ATR_9x9
};


/// \brief Contains all contour points found by the tracer so far

/// This class is used by the Tracer class to inform the user about
/// the contour pixels found so far. You never instantiate an object
/// of this class manually. Instances of this class are only
/// valid in the body of the overloaded mvIMPACT::Tracer::onEvent function!
/// \see mvIMPACT::Tracer::onEvent
//-----------------------------------------------------------------------------
class ContourList
//-----------------------------------------------------------------------------
{
public:

#ifndef DOXYGEN_SHOULD_SKIP_THIS
	/// \brief Construct an unallocated ContourList object.
	///
	/// This generates just a dummy object.
	ContourList();
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

	/// \brief Copy construct ContourList object (flat copy).
	///
	/// Note that, however, all the copies
	/// of this object get invalid when the event handler
	/// mvIMPACT::Tracer::onEvent is left.
	ContourList            (const ContourList& src);


#ifndef WRAP_ANY
	/// \brief Assign a ContourList object (flat copy).
	///
	/// Note that, however, all the copies
	/// of this object get invalid when the event handler
	/// mvIMPACT::Tracer::onEvent is left.
	ContourList& operator= (const ContourList& src);
#endif // #ifndef WRAP_ANY

	/// \brief Access a point from the list of contour pixels.

	///
	/// \see mvIMPACT::PointDouble
	PointDouble getPoint
	(
		/// Index of the point to retrieve.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.numberOfPoints-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int index
	) const;


#ifndef WRAP_ANY
	/// \brief Access a point from the list of contour pixels.

	///
	/// \see mvIMPACT::ContourList::getPoint
	PointDouble operator[]
	(
		/// Index of the point to retrieve.
		int index
	) const;
#endif // #ifndef WRAP_ANY



	/// \brief Set a point in the list at a specific index.

	/// This function modifies a contour point that was found by the tracer
	/// \see mvIMPACT::PointDouble
	ContourList& setPoint(
					/// the index of the point to be modified
					/// \xmlonly
					/// <mvParamRange>
					/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
					/// <mvParamMax><mvParamComplex Python="%(instance)s.numberOfPoints-1"/></mvParamMax>
					/// </mvParamRange>
					/// \endxmlonly
					int index,
					/// the new data of the contour point
					PointDouble point);


	/// \brief Retrieve the number of contour pixels found so far.
	int getNumberOfPoints () const;


	/// \brief Retrieve the search radius of the tracer.
	///
	/// If the tracer stops tracing an edge (i.e. if it finds a point twice), the
	/// user has the possibility, to set the tracer to a point from where to
	/// continue. Since the point from where to continue is in most cases not
	/// exactly placed on the edge the user can define a radius where the
	/// trace module searches for edge pixel candidates. This radius will be retrieved
	/// with that function.
	int getSearchRadius () const;


	/// \brief Continue tracing

	/// With this function you specify two points. The tracer connects these two points
	/// with a straight line and continues tracing at the second point.
	/// If you call this function tracing continues. If you don't call this function
	/// tracing is canceled.
	void continueTracing
	(
		/// First point. It is one of the points in the contour list.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.numberOfPoints-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int fromIndex,
		/// Second point. A user defined point that specifies where tracing
		/// should continue.
		PointDouble toPoint
	);

	/// \brief Destruct a ContourList object
	///
	/// Note that this does work as expected, because the underlying
	/// C-API object exists only in the mvIMPACT::Tracer::onEvent object.
	~ContourList();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
	ContourList (mvIMPACT_C::ATR_LIST* pList);
	bool doContinue() const;
#endif // #ifndef WRAP_ANY
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
	mvIMPACT_C::ATR_LIST* m_pList;
	bool                  m_bContinue;
};


/// \brief Class that holds the results of the tracer

/// The result of a trace is a number of contour pixels. This class allows you
/// to access these pixels.
//-----------------------------------------------------------------------------
class TraceResult
//-----------------------------------------------------------------------------
{
  friend class Tracer;

 public:


  /// \brief Construct an unassigned TraceResult.
  TraceResult ();

  /// \brief Destruct a TraceResult object.
  ~TraceResult ();

  /// \brief Return the trace status.

  /// This indicates why the tracer stopped his normal operation.
  /// After a successful trace this function will
  /// return \c tsOk.
  /// \see #TraceStatus
  TraceStatus getStatus () const;


  /// \brief Access a single contour pixel.

  /// This returns the contour pixel with the index \a index from the list.
  /// \see mvIMPACT::PointDouble
  /// \see mvIMPACT::TraceResult::getNumberOfPoints
  PointDouble getPoint
    (
		/// Index of the pixel. Can be 0 to getNumberOfPoints()-1.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(instance)s.numberOfPoints-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int index
		) const;


#ifndef WRAP_ANY

  /// \brief Access a single contour pixel.

  /// This returns the contour pixel with the index \a index from the list.
  /// \see mvIMPACT::PointDouble
  /// \see mvIMPACT::TraceResult::getNumberOfPoints
  PointDouble operator[]
    (
     /// Index of the pixel. Can be 0 to getNumberOfPoints()-1.
     int index
     ) const;
#endif // #ifndef WRAP_ANY



  /// \brief Modify a specific contour point in the result set

  /// This function modifies a contour point that was found by the tracer
  /// \see mvIMPACT::PointDouble
  TraceResult& setPoint(
			/// index of the contour point to be modified
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
			/// <mvParamMax><mvParamComplex Python="%(instance)s.numberOfPoints-1"/></mvParamMax>
			/// </mvParamRange>
			/// \endxmlonly
			int index,
			/// the new data for the contour point
			PointDouble point);



  /// \brief Retrieve the number of contour pixels found by the tracer.
  int getNumberOfPoints () const;



  /// \brief Construct a mvIMPACT::TraceResult object from \a src.
  TraceResult (/// the other object
	       const TraceResult& src);


#ifndef WRAP_ANY
  /// \brief Overwrite current object with \a src.
  TraceResult& operator= (/// the other object
			  const TraceResult& src);
#endif // #ifndef WRAP_ANY


 protected:
  /// \brief Allocates a TraceResult object from a handle.
  TraceResult (mvIMPACT_C::IPL_BUFHANDLE handle);


#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_ANY
  int getUseCount() const;
  bool getIsUnique   () const;
  mvIMPACT_C::IPL_BUFHANDLE getHandle  () const;
  mvIMPACT_C::IPL_BUFHANDLE getPolygonBuffer() const;
#endif // #ifndef WRAP_ANY
#endif

 protected:
  /// The buffer handle.
  mvIMPACT_C::IPL_BUFHANDLE  m_handle;

  /// Unassigned buffer constant.
  enum { unassigned = -1 };

 private:
  /// Pointer to the reference counter.
  int* m_counter;

  /// Number of points.
  int m_numberOfPoints;
  /// Pointer to point buffer
  mvIMPACT_C::ATR_POINT* m_Points;
  /// Tracing status.
  TraceStatus m_status;

  /// Buffer holding the outline of the trace
  mvIMPACT_C::IPL_BUFHANDLE m_PolygonBuffer;

  /// Dispose the buffer. If the reference count drops to zero
  /// and the buffer was allocated it is freed.
  void dispose();

  void copy(const TraceResult& src);
};




PYTHON_ONLY(%feature("director") Tracer);
/// \brief Main class for tracing grayscale contours.

/// It helps you to run along edges
/// in grayscale images. The function to start tracing is trace().
///
/// Derive from this class and overwrite mvIMPACT::Tracer::onEvent to react on tracer events.
///
/// Do not forget to call the constructor mvIMPACT::Tracer in the constructor
/// of your derived class.
///
/// \note The tracer only works in one plane!
//-----------------------------------------------------------------------------
class Tracer
//-----------------------------------------------------------------------------
{
 public:

	/// \brief Construct a Tracer object with default values
	///
	/// The following default values are used:
	/// m_maxPoints = 819;
	/// m_filterSize = tk5x5;
	/// m_numberOfTestPoints = 10;
	/// m_startDirection = sdEast;
	/// m_minThreshold = 0;
	/// m_maxThreshold = 1;
	/// m_neighborhoodMode = nm8Connected;
	///
	/// If you inherit from this class, you _must_ call this constructor
	/// in the constructor of your derived class !
	Tracer();

	/// destruct a Tracer object
	virtual ~Tracer();

  /// \brief Event handler

  /// Override this function in a subclass and the tracer will call it for
  /// every contour pixel found.
  /// The default implementation just returns \c true.
  /// Return \c true to continue tracing or \c false to abort tracing.
  virtual bool onContourPixel (/// the x-position of the contour pixel that was found
		      int x,
		      /// the y-position of the contour pixel that was found
		      int y);


  /// \brief Event handler

  /// Override this function in a subclass and the tracer will call it for
  /// every event type that you have subscribed to. You can subscribe to an event
  /// by calling Tracer::configureEvent().
  /// If you want the tracing to continue after this event you have to call
  /// ContourList::continueTracing().
  /// The default implementation does nothing, i.e. stops tracing.
  ///
  /// It is not "allowed" though possible to assign a different object to \a contourList.
  ///
  /// \see #TraceStatus
  /// \see mvIMPACT::ContourList
  /// \see mvIMPACT::ContourList::continueTracing
  virtual void onEvent
    (
     /// Indicates the event that occurred
     TraceStatus traceStatus,
     /// List of contour pixels found so far. Call ContourList::continueTracing()
     /// to point the tracer to the location to continue from.
     ContourList& contourList
     );




  /// \brief Start the tracing

  /// The tracer starts to search for an initial contour pixel along a search
  /// line. This line should be perpendicular to the edge that you want to trace.
  /// Once it finds a start pixel the tracer starts to run along the edge by looking
  /// at neighboring pixels. You can influence the direction that it runs by calling
  /// setStartDirection(). The tracing stops, when the contour is closed, or when
  /// the tracer got caught in an endless loop.
  ///
  /// If you don't want to use the maximum gradient method to find a starting point, you can use properties to define
  /// the behaviour for finding a starting point.
  /// Example:
  /// setStartPolarity(1);
  /// setStartIndex(0);
  ///
  /// In the above example, the function tries to find the starting point on an edge with positive polarity 
  /// (transition from dark to bright). If there are multiple transitions of the same type, it uses the first
  /// transition. The function throws an exception if you specify an index which is out of range.
  /// You can enable the maximum gradient method again by making the following call:
  /// setStartIndex(-1);
  /// The following image shows how to place a search line:
  /// \image html TracerLine.png
  /// \see mvIMPACT::Image
  /// \see mvIMPACT::Line
  /// \see mvIMPACT::TraceResult
  /// \see mvIMPACT::Tracer::setStartDirection
  TraceResult trace
    (
		/// The source image.
		const Image& source,
		/// The search line. See function description.
		const Line& line,
		/// Specifies the band where the trace takes place.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(source)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int  bandOffset  =0,
		/// Specifies the slice where the trace takes place.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(source)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int  sliceOffset =0,
		/// Specifies the frame where the trace takes place.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(source)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int  frameOffset =0
		);

  /// \brief Start the tracing between two lines.

  /// The tracer starts to search for an initial contour pixel along a start search
  /// line. This line should be perpendicular to the edge that you want to trace.
  /// Once it finds a start pixel the tracer starts to run along the edge by looking
  /// at neighboring pixels. You can influence the direction that it runs by calling
  /// setStartDirection(). The tracing stops, when the contour crosses the ending line,
  /// or when the contour is closed, or when the tracer got caught in an endless loop.
  ///
  /// If you don't want to use the maximum gradient method to find a starting point, you can use properties to define
  /// the behaviour for finding a starting point.
  /// Example:
  /// setStartPolarity(1);
  /// setStartIndex(0);
  ///
  /// In the above example, the function tries to find the starting point on an edge with positive polarity 
  /// (transition from dark to bright). If there are multiple transitions of the same type, it uses the first
  /// transition. The function throws an exception if you specify an index which is out of range.
  /// You can enable the maximum gradient method again by making the following call:
  /// setStartIndex(-1);
  /// The following image shows how to place the search lines:
  /// \image html images/mvi_base/TracerLineToLine.png
  /// \see mvIMPACT::Image
  /// \see mvIMPACT::Line
  /// \see mvIMPACT::TraceResult
  /// \see mvIMPACT::Tracer::setStartDirection
  TraceResult trace
    (
		/// The source image.
		const Image& source,
		/// The start search line. See function description.
		const Line& lineStart,
		/// The end search line. See function description.
		const Line& lineEnd,
		/// Specifies the band where the trace takes place.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(source)s.bands-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int  bandOffset  =0,
		/// Specifies the slice where the trace takes place.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(source)s.slices-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int  sliceOffset =0,
		/// Specifies the frame where the trace takes place.
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="0"/></mvParamMin>
		/// <mvParamMax><mvParamComplex Python="%(source)s.frames-1"/></mvParamMax>
		/// </mvParamRange>
		/// \endxmlonly
		int  frameOffset =0
		);




  /// \brief Specify if tracer events should be enabled or disabled.

  /// This function allows you to enable or disable different events. An event can be
  /// specified with one of the EventType enumeration types. To receive events you must
  /// subclass mvIMPACT::Tracer and override the onEvent() function.
  /// \see #EventType
  void configureEvent
    (
     /// Type of events to enable or disable.
     EventType type,
     /// set to \c true to enable an event, set to \c false to disable it.
     bool enable=true
     );

  //Properties


  /// \brief Retrieve the maximum number of points to extract.

  /// The tracer stops
  /// if it reaches this limit.
  /// \see mvIMPACT::Tracer::setMaxPoints
  int getMaxPoints () const;

#ifndef WRAP_ANY
  //PROP
#endif // #ifndef WRAP_ANY

  /// \brief Set the maximum number of point to extract from a contour.

  /// The tracer stops
  /// if it reaches this limit.
  /// \see mvIMPACT::Tracer::getMaxPoints
  Tracer& setMaxPoints (
		/// the maximum number of points to extract
		/// \xmlonly
		/// <mvParamRange>
		/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
		/// </mvParamRange>
		/// \endxmlonly
		int maxPoints);


  /// \brief Retrieve the current kernel used to trace contours.

  /// The smaller
  /// the kernel size, the faster the trace will be.
  /// \see #TracingKernel
  /// \see mvIMPACT::Tracer::setFilterSize
  TracingKernel getFilterSize () const;

  /// \brief Set the kernel size used for tracing

  /// The kernel size should be set depending on the image quality (noise).
  /// When processing noisy images or if the object to be traced has some small
  /// gaps in its contour, it is recommended to use larger kernels. The smaller
  /// the kernel size, the faster the trace will be.
  /// \see #TracingKernel
  /// \see mvIMPACT::Tracer::getFilterSize
  Tracer& setFilterSize (/// the new kernel size
			 TracingKernel filterSize);


  /// \brief Retrieve the number of points to trace, to detect the proper direction
  /// \brief set with setStartDirection().
  ///
  /// \see mvIMPACT::Tracer::setNumberOfTestPoints
  /// \see mvIMPACT::Tracer::setStartDirection
  int getNumberOfTestPoints () const;

#ifndef WRAP_ANY
  //PROP
#endif // #ifndef WRAP_ANY

  /// \brief Set the number of points to trace, to detect the proper direction
  /// \brief specified with setStartDirection().

  ///
  /// \see mvIMPACT::Tracer::getNumberOfTestPoints
  /// \see mvIMPACT::Tracer::setStartDirection
  Tracer& setNumberOfTestPoints (
				/// then number of points to test
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="1"/></mvParamMin>
				/// </mvParamRange>
				/// \endxmlonly
				int numberOfTestPoints);


  /// \brief Retrieve the current start direction of the tracer.
  ///
  /// \see #StartDirection
  /// \see mvIMPACT::Tracer::getNumberOfTestPoints
  /// \see mvIMPACT::Tracer::setStartDirection
  StartDirection getStartDirection () const;

#ifndef WRAP_ANY
  //PROP
#endif // #ifndef WRAP_ANY

  /// \brief Set the preferred start direction that the tracer uses to run along an edge.
  ///
  /// \see #StartDirection
  /// \see mvIMPACT::Tracer::setNumberOfTestPoints
  /// \see mvIMPACT::Tracer::getStartDirection
  Tracer& setStartDirection (/// the preferred start direction
			     StartDirection startDirection );


  /// \brief Retrieve the minimum gradient to be reached before generating
  /// \brief an event.
  ///
  /// This value is in the range [0.0 - 1.0].
  /// \see mvIMPACT::Tracer::setMinThreshold
  /// \see #TraceStatus
  double getMinThreshold () const;

#ifndef WRAP_ANY
  //PROP
#endif // #ifndef WRAP_ANY

  /// \brief Set the minimum gradient to be reached before generating
  /// \brief an event.
  ///
  /// This value is in the range [0.0 - 1.0].
  /// This is a normalized value representing the gradient magnitude. 
  /// By default, the minimum threshold is 0.
  /// Internally the tracer follows an edge by using the maximum gradient which is calculated using a ?Sobel? like kernel.
  /// Normally, there is no need to change these values. However, if you do that, you can set a working range of normalized 
  /// gradient magnitude values for the tracer.
  /// If the minimum threshold is set to 0.2 for example and the maximum gradient magnitude found by the tracer is below that value, 
  /// an event can be triggered (if enabled), which allows the user to do further processing. 
  /// This mechnism allows the user to provide his ?own points? to the tracer where it should continue tracing. 
  /// \see mvIMPACT::Tracer::getMinThreshold
  /// \see mvIMPACT::Tracer::configureEvent
  /// \see #TraceStatus
  Tracer& setMinThreshold (
			/// the new minimum gradient
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0.0"/></mvParamMin>
			/// <mvParamMax><mvParamConst value="1.0"/></mvParamMax>
			/// <mvParamStep>0.01</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double minThreshold);


  /// \brief Retrieve the maximum gradient to be reached before generating
  /// \brief an event.
  ///
  /// This value is in the range [0.0 - 1.0].
  /// \see mvIMPACT::Tracer::setMaxThreshold
  /// \see #TraceStatus
  double getMaxThreshold () const;

#ifndef WRAP_ANY
  //PROP
#endif // #ifndef WRAP_ANY

  /// \brief Set the maximum gradient to be reached before generating
  /// \brief an event.
  ///
  /// This value is in the range [0.0 - 1.0].
  /// This is a normalized value representing the gradient magnitude. 
  /// By default, the maximum threshold is 1.
  /// Internally the tracer follows an edge by using the maximum gradient which is calculated using a ?Sobel? like kernel.
  /// Normally, there is no need to change these values. However, if you do that, you can set a working range of normalized 
  /// gradient magnitude values for the tracer.
  /// If the maximum threshold is set to 0.5 for example and the maximum gradient magnitude found by the tracer exceeds that value, 
  /// an event can be triggered (if enabled), which allows the user to do further processing. 
  /// This mechnism allows the user to provide his ?own points? to the tracer where it should continue tracing. 
  /// \see mvIMPACT::Tracer::getMaxThreshold
  /// \see mvIMPACT::Tracer::configureEvent
  /// \see #TraceStatus
  Tracer& setMaxThreshold (
			/// the new maximum gradient
			/// \xmlonly
			/// <mvParamRange>
			/// <mvParamMin><mvParamConst value="0.0"/></mvParamMin>
			/// <mvParamMax><mvParamConst value="1.0"/></mvParamMax>
			/// <mvParamStep>0.01</mvParamStep>
			/// </mvParamRange>
			/// \endxmlonly
			double maxThreshold);


  /// \brief Retreive the neighborhood mode used to search for adjacent contour pixels.
  ///
  /// \see mvIMPACT::Tracer::setNeighborhoodMode
  /// \see #NeighborhoodMode
  NeighborhoodMode getNeighborhoodMode () const;

#ifndef WRAP_ANY
  //PROP
#endif // #ifndef WRAP_ANY

  /// \brief Set the neighborhood mode used to search for adjacent contour pixels.
  ///
  ///
  /// \see mvIMPACT::Tracer::getNeighborhoodMode
  /// \see #NeighborhoodMode
  Tracer& setNeighborhoodMode (/// the neighborhood mode to be set
			  NeighborhoodMode neighborhoodMode);


  /// \brief Retrieve the edge polarity.
  ///
  /// Returns the polarity of an edge which is used to find a start pixel.
  /// A value of 1 defines a transition from dark to bright whereas -1
  /// defines a transition from bright to dark.
  /// \see mvIMPACT::Tracer::setStartPolarity
  int getStartPolarity () const;

#ifndef WRAP_ANY
  //PROP
#endif // #ifndef WRAP_ANY

  /// \brief Set the edge polarity.
  ///
  /// Defines the polarity of an edge which is used to find a start pixel.	
  /// A value of 1 defines a transition from dark to bright whereas -1
  /// defines a transition from bright to dark.
  /// \see mvIMPACT::Tracer::getStartPolarity
  Tracer& setStartPolarity (
				/// the edge polarity
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="-1"/></mvParamMin>
				/// <mvParamMax><mvParamConst value="1"/></mvParamMax>
				/// </mvParamRange>
				/// \endxmlonly
				int polarity);


  /// \brief Retrieve the edge start index.
  ///
  /// Specifies an index for an edge transition the tracer should start from. For example, a value of 0 specifies the first transition,
  /// 1 the second transition aso...
  /// \see mvIMPACT::Tracer::setStartIndex
  int getStartIndex () const;

#ifndef WRAP_ANY
  //PROP
#endif // #ifndef WRAP_ANY

  /// \brief Set the edge start index.
  ///
  /// Specifies an index for an edge transition the tracer should start from. For example, a value of 0 specifies the first transition,
  /// 1 the second transition aso...
  /// Passing a value of -1 instructs the tracer to use the maximum gradient method.
  /// \see mvIMPACT::Tracer::getStartIndex
  Tracer& setStartIndex (
				/// the start index
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="-1"/></mvParamMin>
				/// </mvParamRange>
				/// \endxmlonly
				int index);

  /// \brief Retrieve the gradient threshold used to find starting points.
  ///
  /// Returns the gradient threshold which is used to find edge pixel candidates. The range is [0..1].
  /// \see mvIMPACT::Tracer::setStartThreshold
  double getStartThreshold () const;

#ifndef WRAP_ANY
  //PROP
#endif // #ifndef WRAP_ANY

  /// \brief Set the gradient threshold used to find starting points.
  ///
  /// Defines the gradient threshold which is used to find edge pixel candidates. The range is [0..1].
  /// The gradient is the difference between two pixel values. If, for example, the difference is
  /// 40, then the normalized gradient for an 8-bit image is 40/255 = 0.156.
  /// It is not recommended to use very small values, because edge pixel candidates generated by noise might
  /// be used.
  /// \see mvIMPACT::Tracer::getStartThreshold
  Tracer& setStartThreshold (
				/// the start threshold
				/// \xmlonly
				/// <mvParamRange>
				/// <mvParamMin><mvParamConst value="0.0"/></mvParamMin>
				/// <mvParamMax><mvParamConst value="1.0"/></mvParamMax>
				/// <mvParamStep>0.01</mvParamStep>
				/// </mvParamRange>
				/// \endxmlonly
				double threshold);


 private:

#ifndef WRAP_ANY
  /// C-callback function called by Impact.
  static mvIMPACT_C::IPL_LONG IPL_C_CALLTYPE onEventPixel
    (
     mvIMPACT_C::IPL_LONG  xPos,
     mvIMPACT_C::IPL_LONG  yPos,
     mvIMPACT_C::IPL_VOID_PTR pUser
     );

  /// C-callback function called by Impact.
  static mvIMPACT_C::IPL_LONG IPL_C_CALLTYPE onEventTracer
    (
     mvIMPACT_C::IPL_LONG  status,
     mvIMPACT_C::ATR_LIST* pListPtr,
     mvIMPACT_C::IPL_VOID_PTR pUser
     );

  void transferConfiguration() const;

	void setCallbacks();
	void removeCallbacks();

private:
	int m_maxPoints;
	TracingKernel m_filterSize;
	int m_numberOfTestPoints;
	StartDirection m_startDirection;
	double m_minThreshold;
	double m_maxThreshold;
	NeighborhoodMode m_neighborhoodMode;
	int m_startPolarity;
	int m_startIndex;
	double m_startThreshold;

	bool m_isEtDoneEnabled;
	bool m_isEtMinimumThresholdEnabled;
	bool m_isEtMaximumThresholdEnabled;
	bool m_isEtPointTwiceEnabled;
	bool m_isEtBorderEnabled;
	bool m_isEtSafeModeEnabled;

#endif // #ifndef WRAP_ANY
};

} // namespace mvIMPACT

#include "mvIMPACT_impl.h"

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef WRAP_PYTHON

#ifndef MVIMPACT_USE_NAMESPACES
using namespace mvIMPACT;
#endif // #ifndef MVIMPACT_USE_NAMESPACES

#endif // #ifndef WRAP_PYTHON
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

#ifdef _WIN32
#	ifdef __BORLANDC__
#		pragma option pop
#	endif
#endif // _WIN32
#ifdef _MSC_VER	// is Microsoft compiler?
#	if _MSC_VER < 1300	// is 'old' VC 6 compiler?
#       pragma warning( pop )	// restore old warning level
#	endif // _MSC_VER < 1300
#endif // _MSC_VER

#endif // MVIMPACT_H_
